-- Xilinx Vhdl produced by program ngd2vhdl D.27
-- Command: -w kcpsm.ngd kcpsm_sim.vhd 
-- Options: -w -ti UUT 
-- Date: Fri Sep 07 16:50:07 2001 
-- Input file: kcpsm.ngd
-- Output file: kcpsm_sim.vhd
-- Tmp file: c:/DOCUME~1/hwf1/LOCALS~1/Temp/xil_8
-- Design name: kcpsm
-- Xilinx: C:/Xilinx
-- # of Entities: 1
-- Device: xcv1000e-7-fg680

-- The output of ngd2vhdl is a simulation model. This file cannot be synthesized,
-- or used in any other manner other than simulation. This netlist uses simulation
-- primitives which may not represent the true implementation of the device, however
-- the netlist is functionally correct. Do not modify this file.

-- Model for  ROC (Reset-On-Configuration) Cell
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.VITAL_Timing.all;
entity ROC is
  generic (InstancePath: STRING := "*";
           WIDTH : Time := 100 ns);
  port(O : out std_ulogic := '1') ;
  attribute VITAL_LEVEL0 of ROC : entity is TRUE;
end ROC;

architecture ROC_V of ROC is
attribute VITAL_LEVEL0 of ROC_V : architecture is TRUE;
begin
  ONE_SHOT : process
  begin
    if (WIDTH <= 0 ns) then
       assert FALSE report
       "*** Error: a positive value of WIDTH must be specified ***"
       severity failure;
    else
       wait for WIDTH;
       O <= '0';
    end if;
    wait;
  end process ONE_SHOT;
end ROC_V;

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library SIMPRIM;
use SIMPRIM.VCOMPONENTS.ALL;
use SIMPRIM.VPACKAGE.ALL;
entity KCPSM is
  port (
    WRITE_STROBE : out STD_LOGIC; 
    READ_STROBE : out STD_LOGIC; 
    INTERRUPT : in STD_LOGIC := 'X'; 
    CLK : in STD_LOGIC := 'X'; 
    PORT_ID : out STD_LOGIC_VECTOR ( 7 downto 0 ); 
    OUTPUT : out STD_LOGIC_VECTOR ( 7 downto 0 ); 
    INPUT : in STD_LOGIC_VECTOR ( 7 downto 0 ); 
    I : in STD_LOGIC_VECTOR ( 15 downto 0 ); 
    ADDR : out STD_LOGIC_VECTOR ( 7 downto 0 ) 
  );
end KCPSM;

architecture STRUCTURE of KCPSM is
  component ROC
    generic (InstancePath: STRING := "*";
             WIDTH : Time := 100 ns);
    port (O : out STD_ULOGIC := '1');
  end component;
  signal CNT_ADDR7 : STD_LOGIC; 
  signal CNT_CY0 : STD_LOGIC; 
  signal CNT_CY6 : STD_LOGIC; 
  signal NEW_ADDR7 : STD_LOGIC; 
  signal NGD2VHDL_OI44 : STD_LOGIC; 
  signal CNT_STACK3 : STD_LOGIC; 
  signal CNT_ADDR1 : STD_LOGIC; 
  signal CNT_ADDR0 : STD_LOGIC; 
  signal Q_NET00010_Q : STD_LOGIC; 
  signal NEW_ADDR6 : STD_LOGIC; 
  signal NGD2VHDL_OI45 : STD_LOGIC; 
  signal CNT_CY5 : STD_LOGIC; 
  signal CNT_ADDR2 : STD_LOGIC; 
  signal CNT_CY2 : STD_LOGIC; 
  signal CNT_ADDR6 : STD_LOGIC; 
  signal Q_NET00015_Q : STD_LOGIC; 
  signal NEW_ADDR5 : STD_LOGIC; 
  signal NGD2VHDL_OI46 : STD_LOGIC; 
  signal NEW_STACK3 : STD_LOGIC; 
  signal CNT_ADDR4 : STD_LOGIC; 
  signal Q_NET00033_Q : STD_LOGIC; 
  signal ADDR_VECTOR0 : STD_LOGIC; 
  signal Q_NET00019_Q : STD_LOGIC; 
  signal NEW_ADDR4 : STD_LOGIC; 
  signal NGD2VHDL_OI47 : STD_LOGIC; 
  signal Q_NET00106_Q : STD_LOGIC; 
  signal NEW_ADDR0 : STD_LOGIC; 
  signal CNT_ADDR3 : STD_LOGIC; 
  signal CNT_ADDR5 : STD_LOGIC; 
  signal CNT_CY4 : STD_LOGIC; 
  signal CNT_CY3 : STD_LOGIC; 
  signal Q_NET00023_Q : STD_LOGIC; 
  signal NEW_ADDR3 : STD_LOGIC; 
  signal NGD2VHDL_OI48 : STD_LOGIC; 
  signal READ : STD_LOGIC; 
  signal INC_ADDR : STD_LOGIC; 
  signal SELECT_VECTOR : STD_LOGIC; 
  signal Q_NET00027_Q : STD_LOGIC; 
  signal NEW_ADDR2 : STD_LOGIC; 
  signal NGD2VHDL_OI49 : STD_LOGIC; 
  signal NOT_READ : STD_LOGIC; 
  signal CNT_CY1 : STD_LOGIC; 
  signal Q_NET00030_Q : STD_LOGIC; 
  signal NEW_ADDR1 : STD_LOGIC; 
  signal NGD2VHDL_OI50 : STD_LOGIC; 
  signal FORCE_FF : STD_LOGIC; 
  signal ADDR_VECTOR1 : STD_LOGIC; 
  signal ADDR_VECTOR2 : STD_LOGIC; 
  signal ADDR_VECTOR3 : STD_LOGIC; 
  signal ADDR_VECTOR4 : STD_LOGIC; 
  signal ADDR_VECTOR5 : STD_LOGIC; 
  signal ADDR_VECTOR6 : STD_LOGIC; 
  signal ADDR_VECTOR7 : STD_LOGIC; 
  signal NGD2VHDL_OI51 : STD_LOGIC; 
  signal STACK_RAM0 : STD_LOGIC; 
  signal MOVE_BASE_GROUP : STD_LOGIC; 
  signal VALID_TO_MOVE : STD_LOGIC; 
  signal STACK_RAM7 : STD_LOGIC; 
  signal Q_NET00004_Q : STD_LOGIC; 
  signal STACK_RAM6 : STD_LOGIC; 
  signal STACK_RAM5 : STD_LOGIC; 
  signal STACK_RAM4 : STD_LOGIC; 
  signal STACK_RAM3 : STD_LOGIC; 
  signal STACK_RAM2 : STD_LOGIC; 
  signal STACK_RAM1 : STD_LOGIC; 
  signal STACK_LSB : STD_LOGIC; 
  signal NEW_STACK0 : STD_LOGIC; 
  signal STACK_CIN : STD_LOGIC; 
  signal CNT_STACK0 : STD_LOGIC; 
  signal NEW_STACK1 : STD_LOGIC; 
  signal CNT_STACK_CY0 : STD_LOGIC; 
  signal CNT_STACK1 : STD_LOGIC; 
  signal NEW_STACK2 : STD_LOGIC; 
  signal CNT_STACK_CY1 : STD_LOGIC; 
  signal CNT_STACK_CY2 : STD_LOGIC; 
  signal CNT_STACK2 : STD_LOGIC; 
  signal HOLD_CLEAR_INT : STD_LOGIC; 
  signal INT_SET : STD_LOGIC; 
  signal CARRY : STD_LOGIC; 
  signal ZERO : STD_LOGIC; 
  signal CONDITION_MET : STD_LOGIC; 
  signal RD_STRB : STD_LOGIC; 
  signal WR_STRB : STD_LOGIC; 
  signal INTERRUPT_CAPTURE : STD_LOGIC; 
  signal PRESERVE_ZERO : STD_LOGIC; 
  signal INTERRUPT_TYPE : STD_LOGIC; 
  signal FOR_INT_EN : STD_LOGIC; 
  signal INT_ENABLE : STD_LOGIC; 
  signal PRESERVE_CARRY : STD_LOGIC; 
  signal MOVE_COMMAND : STD_LOGIC; 
  signal ALU_CODE1 : STD_LOGIC; 
  signal ALU_CODE0 : STD_LOGIC; 
  signal NGD2VHDL_OI10 : STD_LOGIC; 
  signal NGD2VHDL_OI2 : STD_LOGIC; 
  signal LOGIC7 : STD_LOGIC; 
  signal NGD2VHDL_OI11 : STD_LOGIC; 
  signal NGD2VHDL_OI3 : STD_LOGIC; 
  signal LOGIC6 : STD_LOGIC; 
  signal NGD2VHDL_OI12 : STD_LOGIC; 
  signal NGD2VHDL_OI4 : STD_LOGIC; 
  signal LOGIC5 : STD_LOGIC; 
  signal NGD2VHDL_OI13 : STD_LOGIC; 
  signal NGD2VHDL_OI5 : STD_LOGIC; 
  signal LOGIC4 : STD_LOGIC; 
  signal NGD2VHDL_OI14 : STD_LOGIC; 
  signal NGD2VHDL_OI6 : STD_LOGIC; 
  signal LOGIC3 : STD_LOGIC; 
  signal NGD2VHDL_OI15 : STD_LOGIC; 
  signal NGD2VHDL_OI7 : STD_LOGIC; 
  signal LOGIC2 : STD_LOGIC; 
  signal NGD2VHDL_OI16 : STD_LOGIC; 
  signal NGD2VHDL_OI8 : STD_LOGIC; 
  signal LOGIC1 : STD_LOGIC; 
  signal NGD2VHDL_OI17 : STD_LOGIC; 
  signal NGD2VHDL_OI9 : STD_LOGIC; 
  signal LOGIC0 : STD_LOGIC; 
  signal ADD_SUB0 : STD_LOGIC; 
  signal LOGICAL4 : STD_LOGIC; 
  signal LOGICAL6 : STD_LOGIC; 
  signal ARITH0 : STD_LOGIC; 
  signal LOGICAL0 : STD_LOGIC; 
  signal LOGICAL7 : STD_LOGIC; 
  signal LOGICAL5 : STD_LOGIC; 
  signal LOGICAL3 : STD_LOGIC; 
  signal LOGICAL1 : STD_LOGIC; 
  signal ARITH_CIN : STD_LOGIC; 
  signal ALU_ADSU0 : STD_LOGIC; 
  signal ARITH_CY0 : STD_LOGIC; 
  signal LOGICAL2 : STD_LOGIC; 
  signal ALU_ADSU6 : STD_LOGIC; 
  signal ADD_SUB1 : STD_LOGIC; 
  signal ARITH1 : STD_LOGIC; 
  signal ALU_ADSU1 : STD_LOGIC; 
  signal ARITH_CY1 : STD_LOGIC; 
  signal ADD_SUB2 : STD_LOGIC; 
  signal ARITH2 : STD_LOGIC; 
  signal ADD_SUB3 : STD_LOGIC; 
  signal ARITH3 : STD_LOGIC; 
  signal ARITH_CY3 : STD_LOGIC; 
  signal ALU_ADSU2 : STD_LOGIC; 
  signal ARITH_CY2 : STD_LOGIC; 
  signal ALU_ADSU3 : STD_LOGIC; 
  signal ADD_SUB4 : STD_LOGIC; 
  signal ARITH4 : STD_LOGIC; 
  signal ALU_ADSU : STD_LOGIC; 
  signal ARITH_CY5 : STD_LOGIC; 
  signal ADD_SUB5 : STD_LOGIC; 
  signal ARITH5 : STD_LOGIC; 
  signal ALU_ADSU5 : STD_LOGIC; 
  signal ADD_SUB6 : STD_LOGIC; 
  signal ARITH6 : STD_LOGIC; 
  signal ADD_SUB7 : STD_LOGIC; 
  signal ARITH7 : STD_LOGIC; 
  signal ARITH_CY7 : STD_LOGIC; 
  signal ARITH_CY6 : STD_LOGIC; 
  signal ALU_ADSU4 : STD_LOGIC; 
  signal ARITH_CY4 : STD_LOGIC; 
  signal ADD_SUB_CARRY : STD_LOGIC; 
  signal ARITH_CARRY : STD_LOGIC; 
  signal FOR_CODE2 : STD_LOGIC; 
  signal LOGICAL_ADD_SUB0 : STD_LOGIC; 
  signal ALU_CODE2 : STD_LOGIC; 
  signal LOGICAL_ADD_SUB1 : STD_LOGIC; 
  signal LOGICAL_ADD_SUB2 : STD_LOGIC; 
  signal LOGICAL_ADD_SUB3 : STD_LOGIC; 
  signal LOGICAL_ADD_SUB4 : STD_LOGIC; 
  signal LOGICAL_ADD_SUB5 : STD_LOGIC; 
  signal LOGICAL_ADD_SUB6 : STD_LOGIC; 
  signal LOGICAL_ADD_SUB7 : STD_LOGIC; 
  signal NEW_REG_DATA7 : STD_LOGIC; 
  signal READ_REG7 : STD_LOGIC; 
  signal NEW_REG_DATA6 : STD_LOGIC; 
  signal READ_REG6 : STD_LOGIC; 
  signal NEW_REG_DATA5 : STD_LOGIC; 
  signal READ_REG5 : STD_LOGIC; 
  signal CONSTANT_SY : STD_LOGIC; 
  signal NEW_REG_DATA4 : STD_LOGIC; 
  signal READ_REG4 : STD_LOGIC; 
  signal NEW_REG_DATA3 : STD_LOGIC; 
  signal READ_REG3 : STD_LOGIC; 
  signal NEW_REG_DATA2 : STD_LOGIC; 
  signal READ_REG2 : STD_LOGIC; 
  signal NEW_REG_DATA1 : STD_LOGIC; 
  signal READ_REG1 : STD_LOGIC; 
  signal WRITE_REG : STD_LOGIC; 
  signal NEW_REG_DATA0 : STD_LOGIC; 
  signal READ_REG0 : STD_LOGIC; 
  signal FOR_CARRY : STD_LOGIC; 
  signal FOR_ZERO : STD_LOGIC; 
  signal FLAG_EN_TYPE : STD_LOGIC; 
  signal RETURNI_DECODE : STD_LOGIC; 
  signal REG_WRITE_TYPE : STD_LOGIC; 
  signal SHIFT_INPUT0 : STD_LOGIC; 
  signal SHIFT0 : STD_LOGIC; 
  signal SHIFT_INPUT1 : STD_LOGIC; 
  signal SHIFT1 : STD_LOGIC; 
  signal SHIFT_INPUT2 : STD_LOGIC; 
  signal SHIFT2 : STD_LOGIC; 
  signal SHIFT_INPUT3 : STD_LOGIC; 
  signal SHIFT3 : STD_LOGIC; 
  signal SHIFT_INPUT4 : STD_LOGIC; 
  signal SHIFT4 : STD_LOGIC; 
  signal SHIFT_INPUT5 : STD_LOGIC; 
  signal SHIFT5 : STD_LOGIC; 
  signal SHIFT_INPUT6 : STD_LOGIC; 
  signal SHIFT6 : STD_LOGIC; 
  signal SHIFT_INPUT7 : STD_LOGIC; 
  signal SHIFT7 : STD_LOGIC; 
  signal SHIFT_INPUT_SEL : STD_LOGIC; 
  signal REG_DATA_SEL : STD_LOGIC; 
  signal FLAG_EN2 : STD_LOGIC; 
  signal Q_NET00001_Q : STD_LOGIC; 
  signal Q_NET00002_Q : STD_LOGIC; 
  signal SHIFT_BIT : STD_LOGIC; 
  signal SR0 : STD_LOGIC; 
  signal SR5 : STD_LOGIC; 
  signal SR1 : STD_LOGIC; 
  signal SR2 : STD_LOGIC; 
  signal SR7 : STD_LOGIC; 
  signal SR3 : STD_LOGIC; 
  signal SR6 : STD_LOGIC; 
  signal SR4 : STD_LOGIC; 
  signal SHIFT_CARRY : STD_LOGIC; 
  signal SRCY : STD_LOGIC; 
  signal NEW_ZERO : STD_LOGIC; 
  signal NEW_CARRY : STD_LOGIC; 
  signal FLAG_EN : STD_LOGIC; 
  signal FLAG_EN1 : STD_LOGIC; 
  signal FLAG_EN3 : STD_LOGIC; 
  signal LOW_ZERO : STD_LOGIC; 
  signal HIGH_ZERO : STD_LOGIC; 
  signal Q_NET00014_Q : STD_LOGIC; 
  signal Q_NET00016_Q : STD_LOGIC; 
  signal Q_NET00017_Q : STD_LOGIC; 
  signal LOW_ZERO_CY : STD_LOGIC; 
  signal ARITH_DECODE : STD_LOGIC; 
  signal SHIFT_DECODE : STD_LOGIC; 
  signal ALU_CODE3 : STD_LOGIC; 
  signal FLAG_EN_COMMAND : STD_LOGIC; 
  signal RETURNI_COMMAND : STD_LOGIC; 
  signal SEL_ARITH_CY : STD_LOGIC; 
  signal SEL_SHIFT_CY : STD_LOGIC; 
  signal EN_WRITE_REG : STD_LOGIC; 
  signal Q_I11_O : STD_LOGIC; 
  signal Q_I129_O : STD_LOGIC; 
  signal Q_I13_O : STD_LOGIC; 
  signal Q_I138_O : STD_LOGIC; 
  signal Q_I143_O : STD_LOGIC; 
  signal Q_I147_O : STD_LOGIC; 
  signal Q_I15_O : STD_LOGIC; 
  signal Q_I151_O : STD_LOGIC; 
  signal Q_I153_O : STD_LOGIC; 
  signal Q_I156_O : STD_LOGIC; 
  signal Q_I161_O : STD_LOGIC; 
  signal Q_I237_O : STD_LOGIC; 
  signal Q_I25_O : STD_LOGIC; 
  signal Q_I30_O : STD_LOGIC; 
  signal Q_I33_O : STD_LOGIC; 
  signal Q_I75_O : STD_LOGIC; 
  signal Q_I76_O : STD_LOGIC; 
  signal Q_I8_O : STD_LOGIC; 
  signal Q_I83_O : STD_LOGIC; 
  signal GSR : STD_LOGIC; 
  signal GND : STD_LOGIC; 
  signal VCC : STD_LOGIC; 
  signal RETURN_VECTOR : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal STACK : STD_LOGIC_VECTOR ( 3 downto 0 ); 
begin
  PORT_ID(7) <= NGD2VHDL_OI2;
  PORT_ID(6) <= NGD2VHDL_OI3;
  PORT_ID(5) <= NGD2VHDL_OI4;
  PORT_ID(4) <= NGD2VHDL_OI5;
  PORT_ID(3) <= NGD2VHDL_OI6;
  PORT_ID(2) <= NGD2VHDL_OI7;
  PORT_ID(1) <= NGD2VHDL_OI8;
  PORT_ID(0) <= NGD2VHDL_OI9;
  OUTPUT(7) <= NGD2VHDL_OI10;
  OUTPUT(6) <= NGD2VHDL_OI11;
  OUTPUT(5) <= NGD2VHDL_OI12;
  OUTPUT(4) <= NGD2VHDL_OI13;
  OUTPUT(3) <= NGD2VHDL_OI14;
  OUTPUT(2) <= NGD2VHDL_OI15;
  OUTPUT(1) <= NGD2VHDL_OI16;
  OUTPUT(0) <= NGD2VHDL_OI17;
  ADDR(7) <= NGD2VHDL_OI44;
  ADDR(6) <= NGD2VHDL_OI45;
  ADDR(5) <= NGD2VHDL_OI46;
  ADDR(4) <= NGD2VHDL_OI47;
  ADDR(3) <= NGD2VHDL_OI48;
  ADDR(2) <= NGD2VHDL_OI49;
  ADDR(1) <= NGD2VHDL_OI50;
  ADDR(0) <= NGD2VHDL_OI51;
  Q_I1 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SELECT_VECTOR,
      ADR1 => ADDR_VECTOR7,
      ADR2 => NGD2VHDL_OI44,
      O => CNT_ADDR7
    );
  Q_I10 : X_ZERO
    port map (
      O => Q_NET00010_Q
    );
  Q_I102 : X_FF
    port map (
      I => INTERRUPT,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => INTERRUPT_CAPTURE
    );
  Q_I103 : X_LUT3
    generic map (
      INIT => X"80"
    )
    port map (
      ADR0 => INTERRUPT_CAPTURE,
      ADR1 => READ,
      ADR2 => INT_ENABLE,
      O => FORCE_FF
    );
  Q_I104 : X_MUX2
    port map (
      IA => HOLD_CLEAR_INT,
      IB => INT_SET,
      SEL => INTERRUPT_TYPE,
      O => FOR_INT_EN
    );
  Q_I105 : X_FF
    port map (
      I => FOR_INT_EN,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => INT_ENABLE
    );
  Q_I106 : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => I(4),
      ADR1 => I(8),
      ADR2 => MOVE_BASE_GROUP,
      O => INTERRUPT_TYPE
    );
  Q_I107 : X_FF
    port map (
      I => ZERO,
      CLK => CLK,
      CE => FORCE_FF,
      SET => GND,
      RST => GSR,
      O => PRESERVE_ZERO
    );
  Q_I108 : X_FF
    port map (
      I => CARRY,
      CLK => CLK,
      CE => FORCE_FF,
      SET => GND,
      RST => GSR,
      O => PRESERVE_CARRY
    );
  Q_I109 : X_MUX2
    port map (
      IA => MOVE_COMMAND,
      IB => CONDITION_MET,
      SEL => I(12),
      O => VALID_TO_MOVE
    );
  Q_I11 : X_MUX2
    port map (
      IA => Q_NET00033_Q,
      IB => INC_ADDR,
      SEL => CNT_ADDR0,
      O => Q_I11_O
    );
  Q_I11_MUXCY_L_BUF : X_BUF
    port map (
      I => Q_I11_O,
      O => CNT_CY0
    );
  Q_I110 : X_LUT2
    generic map (
      INIT => X"E"
    )
    port map (
      ADR0 => I(7),
      ADR1 => I(8),
      O => MOVE_COMMAND
    );
  Q_I111 : X_LUT4
    generic map (
      INIT => X"8000"
    )
    port map (
      ADR0 => I(9),
      ADR1 => VALID_TO_MOVE,
      ADR2 => MOVE_BASE_GROUP,
      ADR3 => READ,
      O => STACK_CIN
    );
  Q_I112 : X_INV
    port map (
      I => FORCE_FF,
      O => Q_NET00004_Q
    );
  Q_I115 : X_LUT4
    generic map (
      INIT => X"6E8A"
    )
    port map (
      ADR0 => NGD2VHDL_OI2,
      ADR1 => NGD2VHDL_OI10,
      ADR2 => ALU_CODE0,
      ADR3 => ALU_CODE1,
      O => LOGIC7
    );
  Q_I116 : X_FF
    port map (
      I => LOGIC5,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => LOGICAL5
    );
  Q_I117 : X_LUT4
    generic map (
      INIT => X"6E8A"
    )
    port map (
      ADR0 => NGD2VHDL_OI3,
      ADR1 => NGD2VHDL_OI11,
      ADR2 => ALU_CODE0,
      ADR3 => ALU_CODE1,
      O => LOGIC6
    );
  Q_I118 : X_LUT4
    generic map (
      INIT => X"6E8A"
    )
    port map (
      ADR0 => NGD2VHDL_OI4,
      ADR1 => NGD2VHDL_OI12,
      ADR2 => ALU_CODE0,
      ADR3 => ALU_CODE1,
      O => LOGIC5
    );
  Q_I119 : X_FF
    port map (
      I => LOGIC6,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => LOGICAL6
    );
  Q_I12 : X_XOR2
    port map (
      I0 => CNT_ADDR6,
      I1 => CNT_CY5,
      O => NEW_ADDR6
    );
  Q_I120 : X_LUT4
    generic map (
      INIT => X"6E8A"
    )
    port map (
      ADR0 => NGD2VHDL_OI5,
      ADR1 => NGD2VHDL_OI13,
      ADR2 => ALU_CODE0,
      ADR3 => ALU_CODE1,
      O => LOGIC4
    );
  Q_I121 : X_LUT4
    generic map (
      INIT => X"6E8A"
    )
    port map (
      ADR0 => NGD2VHDL_OI6,
      ADR1 => NGD2VHDL_OI14,
      ADR2 => ALU_CODE0,
      ADR3 => ALU_CODE1,
      O => LOGIC3
    );
  Q_I122 : X_FF
    port map (
      I => LOGIC7,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => LOGICAL7
    );
  Q_I123 : X_LUT4
    generic map (
      INIT => X"6E8A"
    )
    port map (
      ADR0 => NGD2VHDL_OI7,
      ADR1 => NGD2VHDL_OI15,
      ADR2 => ALU_CODE0,
      ADR3 => ALU_CODE1,
      O => LOGIC2
    );
  Q_I124 : X_LUT4
    generic map (
      INIT => X"6E8A"
    )
    port map (
      ADR0 => NGD2VHDL_OI8,
      ADR1 => NGD2VHDL_OI16,
      ADR2 => ALU_CODE0,
      ADR3 => ALU_CODE1,
      O => LOGIC1
    );
  Q_I125 : X_LUT4
    generic map (
      INIT => X"6E8A"
    )
    port map (
      ADR0 => NGD2VHDL_OI9,
      ADR1 => NGD2VHDL_OI17,
      ADR2 => ALU_CODE0,
      ADR3 => ALU_CODE1,
      O => LOGIC0
    );
  Q_I126 : X_FF
    port map (
      I => LOGIC2,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => LOGICAL2
    );
  Q_I127 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => NGD2VHDL_OI17,
      ADR1 => NGD2VHDL_OI9,
      ADR2 => ALU_CODE1,
      O => ALU_ADSU0
    );
  Q_I128 : X_XOR2
    port map (
      I0 => ALU_ADSU0,
      I1 => ARITH_CIN,
      O => ARITH0
    );
  Q_I129 : X_MUX2
    port map (
      IA => NGD2VHDL_OI17,
      IB => ARITH_CIN,
      SEL => ALU_ADSU0,
      O => Q_I129_O
    );
  Q_I129_MUXCY_L_BUF : X_BUF
    port map (
      I => Q_I129_O,
      O => ARITH_CY0
    );
  Q_I13 : X_MUX2
    port map (
      IA => Q_NET00030_Q,
      IB => CNT_CY0,
      SEL => CNT_ADDR1,
      O => Q_I13_O
    );
  Q_I13_MUXCY_L_BUF : X_BUF
    port map (
      I => Q_I13_O,
      O => CNT_CY1
    );
  Q_I130 : X_FF
    port map (
      I => LOGIC4,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => LOGICAL4
    );
  Q_I131 : X_FF
    port map (
      I => ARITH0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => ADD_SUB0
    );
  Q_I132 : X_LUT3
    generic map (
      INIT => X"78"
    )
    port map (
      ADR0 => CARRY,
      ADR1 => ALU_CODE0,
      ADR2 => ALU_CODE1,
      O => ARITH_CIN
    );
  Q_I133 : X_FF
    port map (
      I => LOGIC3,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => LOGICAL3
    );
  Q_I134 : X_FF
    port map (
      I => LOGIC0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => LOGICAL0
    );
  Q_I135 : X_FF
    port map (
      I => LOGIC1,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => LOGICAL1
    );
  Q_I136 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => NGD2VHDL_OI16,
      ADR1 => NGD2VHDL_OI8,
      ADR2 => ALU_CODE1,
      O => ALU_ADSU1
    );
  Q_I137 : X_XOR2
    port map (
      I0 => ALU_ADSU1,
      I1 => ARITH_CY0,
      O => ARITH1
    );
  Q_I138 : X_MUX2
    port map (
      IA => NGD2VHDL_OI16,
      IB => ARITH_CY0,
      SEL => ALU_ADSU1,
      O => Q_I138_O
    );
  Q_I138_MUXCY_L_BUF : X_BUF
    port map (
      I => Q_I138_O,
      O => ARITH_CY1
    );
  Q_I139 : X_FF
    port map (
      I => ARITH1,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => ADD_SUB1
    );
  Q_I14 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SELECT_VECTOR,
      ADR1 => ADDR_VECTOR2,
      ADR2 => NGD2VHDL_OI49,
      O => CNT_ADDR2
    );
  Q_I140 : X_FF
    port map (
      I => ARITH7,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => ADD_SUB7
    );
  Q_I141 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => NGD2VHDL_OI15,
      ADR1 => NGD2VHDL_OI7,
      ADR2 => ALU_CODE1,
      O => ALU_ADSU2
    );
  Q_I142 : X_XOR2
    port map (
      I0 => ALU_ADSU2,
      I1 => ARITH_CY1,
      O => ARITH2
    );
  Q_I143 : X_MUX2
    port map (
      IA => NGD2VHDL_OI15,
      IB => ARITH_CY1,
      SEL => ALU_ADSU2,
      O => Q_I143_O
    );
  Q_I143_MUXCY_L_BUF : X_BUF
    port map (
      I => Q_I143_O,
      O => ARITH_CY2
    );
  Q_I144 : X_FF
    port map (
      I => ARITH2,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => ADD_SUB2
    );
  Q_I145 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => NGD2VHDL_OI14,
      ADR1 => NGD2VHDL_OI6,
      ADR2 => ALU_CODE1,
      O => ALU_ADSU3
    );
  Q_I146 : X_XOR2
    port map (
      I0 => ALU_ADSU3,
      I1 => ARITH_CY2,
      O => ARITH3
    );
  Q_I147 : X_MUX2
    port map (
      IA => NGD2VHDL_OI14,
      IB => ARITH_CY2,
      SEL => ALU_ADSU3,
      O => Q_I147_O
    );
  Q_I147_MUXCY_L_BUF : X_BUF
    port map (
      I => Q_I147_O,
      O => ARITH_CY3
    );
  Q_I148 : X_FF
    port map (
      I => ARITH3,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => ADD_SUB3
    );
  Q_I149 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => NGD2VHDL_OI13,
      ADR1 => NGD2VHDL_OI5,
      ADR2 => ALU_CODE1,
      O => ALU_ADSU4
    );
  Q_I15 : X_MUX2
    port map (
      IA => Q_NET00015_Q,
      IB => CNT_CY4,
      SEL => CNT_ADDR5,
      O => Q_I15_O
    );
  Q_I15_MUXCY_L_BUF : X_BUF
    port map (
      I => Q_I15_O,
      O => CNT_CY5
    );
  Q_I150 : X_XOR2
    port map (
      I0 => ALU_ADSU4,
      I1 => ARITH_CY3,
      O => ARITH4
    );
  Q_I151 : X_MUX2
    port map (
      IA => NGD2VHDL_OI13,
      IB => ARITH_CY3,
      SEL => ALU_ADSU4,
      O => Q_I151_O
    );
  Q_I151_MUXCY_L_BUF : X_BUF
    port map (
      I => Q_I151_O,
      O => ARITH_CY4
    );
  Q_I152 : X_FF
    port map (
      I => ARITH4,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => ADD_SUB4
    );
  Q_I153 : X_MUX2
    port map (
      IA => NGD2VHDL_OI10,
      IB => ARITH_CY6,
      SEL => ALU_ADSU,
      O => Q_I153_O
    );
  Q_I153_MUXCY_L_BUF : X_BUF
    port map (
      I => Q_I153_O,
      O => ARITH_CY7
    );
  Q_I154 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => NGD2VHDL_OI12,
      ADR1 => NGD2VHDL_OI4,
      ADR2 => ALU_CODE1,
      O => ALU_ADSU5
    );
  Q_I155 : X_XOR2
    port map (
      I0 => ALU_ADSU5,
      I1 => ARITH_CY4,
      O => ARITH5
    );
  Q_I156 : X_MUX2
    port map (
      IA => NGD2VHDL_OI12,
      IB => ARITH_CY4,
      SEL => ALU_ADSU5,
      O => Q_I156_O
    );
  Q_I156_MUXCY_L_BUF : X_BUF
    port map (
      I => Q_I156_O,
      O => ARITH_CY5
    );
  Q_I157 : X_FF
    port map (
      I => ARITH5,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => ADD_SUB5
    );
  Q_I158 : X_XOR2
    port map (
      I0 => ALU_ADSU,
      I1 => ARITH_CY6,
      O => ARITH7
    );
  Q_I159 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => NGD2VHDL_OI11,
      ADR1 => NGD2VHDL_OI3,
      ADR2 => ALU_CODE1,
      O => ALU_ADSU6
    );
  Q_I16 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SELECT_VECTOR,
      ADR1 => ADDR_VECTOR5,
      ADR2 => NGD2VHDL_OI46,
      O => CNT_ADDR5
    );
  Q_I160 : X_XOR2
    port map (
      I0 => ALU_ADSU6,
      I1 => ARITH_CY5,
      O => ARITH6
    );
  Q_I161 : X_MUX2
    port map (
      IA => NGD2VHDL_OI11,
      IB => ARITH_CY5,
      SEL => ALU_ADSU6,
      O => Q_I161_O
    );
  Q_I161_MUXCY_L_BUF : X_BUF
    port map (
      I => Q_I161_O,
      O => ARITH_CY6
    );
  Q_I162 : X_FF
    port map (
      I => ARITH6,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => ADD_SUB6
    );
  Q_I163 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => NGD2VHDL_OI10,
      ADR1 => NGD2VHDL_OI2,
      ADR2 => ALU_CODE1,
      O => ALU_ADSU
    );
  Q_I164 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => ARITH_CY7,
      ADR1 => ALU_CODE1,
      O => ARITH_CARRY
    );
  Q_I165 : X_FF
    port map (
      I => ARITH_CARRY,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => ADD_SUB_CARRY
    );
  Q_I166 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => I(0),
      ADR1 => I(12),
      ADR2 => I(15),
      O => ALU_CODE0
    );
  Q_I167 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => I(1),
      ADR1 => I(13),
      ADR2 => I(15),
      O => ALU_CODE1
    );
  Q_I168 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => I(2),
      ADR1 => I(14),
      ADR2 => I(15),
      O => FOR_CODE2
    );
  Q_I169 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => ADD_SUB0,
      ADR1 => LOGICAL0,
      ADR2 => ALU_CODE2,
      O => LOGICAL_ADD_SUB0
    );
  Q_I17 : X_ZERO
    port map (
      O => Q_NET00015_Q
    );
  Q_I170 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => ADD_SUB1,
      ADR1 => LOGICAL1,
      ADR2 => ALU_CODE2,
      O => LOGICAL_ADD_SUB1
    );
  Q_I171 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => ADD_SUB2,
      ADR1 => LOGICAL2,
      ADR2 => ALU_CODE2,
      O => LOGICAL_ADD_SUB2
    );
  Q_I172 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => ADD_SUB3,
      ADR1 => LOGICAL3,
      ADR2 => ALU_CODE2,
      O => LOGICAL_ADD_SUB3
    );
  Q_I173 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => ADD_SUB4,
      ADR1 => LOGICAL4,
      ADR2 => ALU_CODE2,
      O => LOGICAL_ADD_SUB4
    );
  Q_I174 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => ADD_SUB5,
      ADR1 => LOGICAL5,
      ADR2 => ALU_CODE2,
      O => LOGICAL_ADD_SUB5
    );
  Q_I175 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => ADD_SUB6,
      ADR1 => LOGICAL6,
      ADR2 => ALU_CODE2,
      O => LOGICAL_ADD_SUB6
    );
  Q_I176 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => ADD_SUB7,
      ADR1 => LOGICAL7,
      ADR2 => ALU_CODE2,
      O => LOGICAL_ADD_SUB7
    );
  Q_I177 : X_FF
    port map (
      I => FOR_CODE2,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => ALU_CODE2
    );
  Q_I179 : X_MUX2
    port map (
      IA => Q_NET00014_Q,
      IB => LOW_ZERO_CY,
      SEL => HIGH_ZERO,
      O => FOR_ZERO
    );
  Q_I18 : X_ZERO
    port map (
      O => Q_NET00027_Q
    );
  Q_I180 : X_LUT4
    generic map (
      INIT => X"3CFF"
    )
    port map (
      ADR0 => I(12),
      ADR1 => I(13),
      ADR2 => I(14),
      ADR3 => I(15),
      O => REG_WRITE_TYPE
    );
  Q_I182 : X_LUT4
    generic map (
      INIT => X"F222"
    )
    port map (
      ADR0 => I(14),
      ADR1 => I(15),
      ADR2 => I(2),
      ADR3 => FLAG_EN2,
      O => ARITH_DECODE
    );
  Q_I184 : X_LUT4
    generic map (
      INIT => X"2000"
    )
    port map (
      ADR0 => I(12),
      ADR1 => I(13),
      ADR2 => I(14),
      ADR3 => I(15),
      O => SHIFT_DECODE
    );
  Q_I19 : X_XOR2
    port map (
      I0 => CNT_ADDR5,
      I1 => CNT_CY4,
      O => NEW_ADDR5
    );
  Q_I191 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => READ_REG7,
      ADR1 => I(7),
      ADR2 => CONSTANT_SY,
      O => NGD2VHDL_OI2
    );
  Q_I193 : X_LUT4
    generic map (
      INIT => X"9800"
    )
    port map (
      ADR0 => I(12),
      ADR1 => I(13),
      ADR2 => I(14),
      ADR3 => I(15),
      O => CONSTANT_SY
    );
  Q_I194 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => READ_REG0,
      ADR1 => I(0),
      ADR2 => CONSTANT_SY,
      O => NGD2VHDL_OI9
    );
  Q_I195 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => READ_REG1,
      ADR1 => I(1),
      ADR2 => CONSTANT_SY,
      O => NGD2VHDL_OI8
    );
  Q_I196 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => READ_REG2,
      ADR1 => I(2),
      ADR2 => CONSTANT_SY,
      O => NGD2VHDL_OI7
    );
  Q_I197 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => READ_REG3,
      ADR1 => I(3),
      ADR2 => CONSTANT_SY,
      O => NGD2VHDL_OI6
    );
  Q_I198 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => READ_REG4,
      ADR1 => I(4),
      ADR2 => CONSTANT_SY,
      O => NGD2VHDL_OI5
    );
  Q_I199 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => READ_REG5,
      ADR1 => I(5),
      ADR2 => CONSTANT_SY,
      O => NGD2VHDL_OI4
    );
  Q_I2 : X_XOR2
    port map (
      I0 => CNT_ADDR7,
      I1 => CNT_CY6,
      O => NEW_ADDR7
    );
  Q_I20 : X_SFF
    port map (
      I => NEW_ADDR6,
      CLK => CLK,
      CE => READ,
      SET => GSR,
      RST => GND,
      SSET => FORCE_FF,
      SRST => GND,
      O => NGD2VHDL_OI45
    );
  Q_I200 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => READ_REG6,
      ADR1 => I(6),
      ADR2 => CONSTANT_SY,
      O => NGD2VHDL_OI3
    );
  Q_I202 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => INPUT(0),
      ADR1 => SHIFT0,
      ADR2 => SHIFT_INPUT_SEL,
      O => SHIFT_INPUT0
    );
  Q_I203 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => INPUT(1),
      ADR1 => SHIFT1,
      ADR2 => SHIFT_INPUT_SEL,
      O => SHIFT_INPUT1
    );
  Q_I205 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => INPUT(2),
      ADR1 => SHIFT2,
      ADR2 => SHIFT_INPUT_SEL,
      O => SHIFT_INPUT2
    );
  Q_I206 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => INPUT(3),
      ADR1 => SHIFT3,
      ADR2 => SHIFT_INPUT_SEL,
      O => SHIFT_INPUT3
    );
  Q_I207 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => INPUT(7),
      ADR1 => SHIFT7,
      ADR2 => SHIFT_INPUT_SEL,
      O => SHIFT_INPUT7
    );
  Q_I208 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => INPUT(4),
      ADR1 => SHIFT4,
      ADR2 => SHIFT_INPUT_SEL,
      O => SHIFT_INPUT4
    );
  Q_I209 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => INPUT(5),
      ADR1 => SHIFT5,
      ADR2 => SHIFT_INPUT_SEL,
      O => SHIFT_INPUT5
    );
  Q_I21 : X_FF
    port map (
      I => NOT_READ,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      O => READ
    );
  Q_I211 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => INPUT(6),
      ADR1 => SHIFT6,
      ADR2 => SHIFT_INPUT_SEL,
      O => SHIFT_INPUT6
    );
  Q_I212 : X_MUX2
    port map (
      IA => SHIFT_INPUT0,
      IB => LOGICAL_ADD_SUB0,
      SEL => REG_DATA_SEL,
      O => NEW_REG_DATA0
    );
  Q_I213 : X_MUX2
    port map (
      IA => SHIFT_INPUT7,
      IB => LOGICAL_ADD_SUB7,
      SEL => REG_DATA_SEL,
      O => NEW_REG_DATA7
    );
  Q_I214 : X_MUX2
    port map (
      IA => SHIFT_INPUT2,
      IB => LOGICAL_ADD_SUB2,
      SEL => REG_DATA_SEL,
      O => NEW_REG_DATA2
    );
  Q_I215 : X_MUX2
    port map (
      IA => SHIFT_INPUT4,
      IB => LOGICAL_ADD_SUB4,
      SEL => REG_DATA_SEL,
      O => NEW_REG_DATA4
    );
  Q_I216 : X_MUX2
    port map (
      IA => SHIFT_INPUT1,
      IB => LOGICAL_ADD_SUB1,
      SEL => REG_DATA_SEL,
      O => NEW_REG_DATA1
    );
  Q_I217 : X_MUX2
    port map (
      IA => SHIFT_INPUT5,
      IB => LOGICAL_ADD_SUB5,
      SEL => REG_DATA_SEL,
      O => NEW_REG_DATA5
    );
  Q_I218 : X_MUX2
    port map (
      IA => SHIFT_INPUT3,
      IB => LOGICAL_ADD_SUB3,
      SEL => REG_DATA_SEL,
      O => NEW_REG_DATA3
    );
  Q_I219 : X_MUX2
    port map (
      IA => SHIFT_INPUT6,
      IB => LOGICAL_ADD_SUB6,
      SEL => REG_DATA_SEL,
      O => NEW_REG_DATA6
    );
  Q_I22 : X_XOR2
    port map (
      I0 => CNT_ADDR2,
      I1 => CNT_CY1,
      O => NEW_ADDR2
    );
  Q_I220 : X_LUT3
    generic map (
      INIT => X"1F"
    )
    port map (
      ADR0 => I(12),
      ADR1 => I(13),
      ADR2 => I(15),
      O => ALU_CODE3
    );
  Q_I222 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => SHIFT_BIT,
      ADR1 => NGD2VHDL_OI11,
      ADR2 => I(3),
      O => SR7
    );
  Q_I223 : X_MUX2
    port map (
      IA => Q_NET00001_Q,
      IB => Q_NET00002_Q,
      SEL => I(2),
      O => SHIFT_BIT
    );
  Q_I224 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => NGD2VHDL_OI16,
      ADR1 => SHIFT_BIT,
      ADR2 => I(3),
      O => SR0
    );
  Q_I225 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => NGD2VHDL_OI15,
      ADR1 => NGD2VHDL_OI17,
      ADR2 => I(3),
      O => SR1
    );
  Q_I226 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => NGD2VHDL_OI14,
      ADR1 => NGD2VHDL_OI16,
      ADR2 => I(3),
      O => SR2
    );
  Q_I227 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => NGD2VHDL_OI13,
      ADR1 => NGD2VHDL_OI15,
      ADR2 => I(3),
      O => SR3
    );
  Q_I228 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => NGD2VHDL_OI12,
      ADR1 => NGD2VHDL_OI14,
      ADR2 => I(3),
      O => SR4
    );
  Q_I229 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => NGD2VHDL_OI11,
      ADR1 => NGD2VHDL_OI13,
      ADR2 => I(3),
      O => SR5
    );
  Q_I23 : X_ZERO
    port map (
      O => Q_NET00030_Q
    );
  Q_I230 : X_FF
    port map (
      I => SR5,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SHIFT5
    );
  Q_I231 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => NGD2VHDL_OI10,
      ADR1 => NGD2VHDL_OI12,
      ADR2 => I(3),
      O => SR6
    );
  Q_I232 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => NGD2VHDL_OI10,
      ADR1 => CARRY,
      ADR2 => I(1),
      O => Q_NET00001_Q
    );
  Q_I233 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => I(0),
      ADR1 => NGD2VHDL_OI17,
      ADR2 => I(1),
      O => Q_NET00002_Q
    );
  Q_I235 : X_ZERO
    port map (
      O => Q_NET00014_Q
    );
  Q_I236 : X_ONE
    port map (
      O => Q_NET00017_Q
    );
  Q_I237 : X_MUX2
    port map (
      IA => Q_NET00016_Q,
      IB => Q_NET00017_Q,
      SEL => LOW_ZERO,
      O => Q_I237_O
    );
  Q_I237_MUXCY_L_BUF : X_BUF
    port map (
      I => Q_I237_O,
      O => LOW_ZERO_CY
    );
  Q_I238 : X_FF
    port map (
      I => SR0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SHIFT0
    );
  Q_I239 : X_FF
    port map (
      I => SR1,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SHIFT1
    );
  Q_I24 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SELECT_VECTOR,
      ADR1 => ADDR_VECTOR1,
      ADR2 => NGD2VHDL_OI50,
      O => CNT_ADDR1
    );
  Q_I240 : X_FF
    port map (
      I => SR6,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SHIFT6
    );
  Q_I241 : X_FF
    port map (
      I => SR7,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SHIFT7
    );
  Q_I242 : X_FF
    port map (
      I => SR2,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SHIFT2
    );
  Q_I243 : X_FF
    port map (
      I => SR4,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SHIFT4
    );
  Q_I244 : X_FF
    port map (
      I => SR3,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SHIFT3
    );
  Q_I245 : X_LUT3
    generic map (
      INIT => X"AC"
    )
    port map (
      ADR0 => NGD2VHDL_OI17,
      ADR1 => NGD2VHDL_OI10,
      ADR2 => I(3),
      O => SRCY
    );
  Q_I246 : X_FF
    port map (
      I => SRCY,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SHIFT_CARRY
    );
  Q_I247 : X_FF
    port map (
      I => NEW_ZERO,
      CLK => CLK,
      CE => FLAG_EN,
      SET => GND,
      RST => GSR,
      O => ZERO
    );
  Q_I248 : X_ZERO
    port map (
      O => Q_NET00016_Q
    );
  Q_I249 : X_FF
    port map (
      I => NEW_CARRY,
      CLK => CLK,
      CE => FLAG_EN,
      SET => GND,
      RST => GSR,
      O => CARRY
    );
  Q_I25 : X_MUX2
    port map (
      IA => Q_NET00019_Q,
      IB => CNT_CY3,
      SEL => CNT_ADDR4,
      O => Q_I25_O
    );
  Q_I25_MUXCY_L_BUF : X_BUF
    port map (
      I => Q_I25_O,
      O => CNT_CY4
    );
  Q_I250 : X_LUT4
    generic map (
      INIT => X"3808"
    )
    port map (
      ADR0 => SHIFT_CARRY,
      ADR1 => SEL_SHIFT_CY,
      ADR2 => SEL_ARITH_CY,
      ADR3 => ADD_SUB_CARRY,
      O => FOR_CARRY
    );
  Q_I251 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => FLAG_EN1,
      ADR1 => FLAG_EN2,
      ADR2 => FLAG_EN3,
      O => FLAG_EN_TYPE
    );
  Q_I252 : X_LUT4
    generic map (
      INIT => X"20FE"
    )
    port map (
      ADR0 => I(12),
      ADR1 => I(13),
      ADR2 => I(14),
      ADR3 => I(15),
      O => FLAG_EN1
    );
  Q_I253 : X_LUT4
    generic map (
      INIT => X"1000"
    )
    port map (
      ADR0 => I(12),
      ADR1 => I(13),
      ADR2 => I(14),
      ADR3 => I(15),
      O => FLAG_EN2
    );
  Q_I254 : X_LUT3
    generic map (
      INIT => X"FE"
    )
    port map (
      ADR0 => I(0),
      ADR1 => I(1),
      ADR2 => I(2),
      O => FLAG_EN3
    );
  Q_I255 : X_LUT4
    generic map (
      INIT => X"0001"
    )
    port map (
      ADR0 => NEW_REG_DATA4,
      ADR1 => NEW_REG_DATA5,
      ADR2 => NEW_REG_DATA6,
      ADR3 => NEW_REG_DATA7,
      O => HIGH_ZERO
    );
  Q_I256 : X_LUT4
    generic map (
      INIT => X"0001"
    )
    port map (
      ADR0 => NEW_REG_DATA0,
      ADR1 => NEW_REG_DATA1,
      ADR2 => NEW_REG_DATA2,
      ADR3 => NEW_REG_DATA3,
      O => LOW_ZERO
    );
  Q_I257 : X_LUT4
    generic map (
      INIT => X"0800"
    )
    port map (
      ADR0 => I(4),
      ADR1 => I(7),
      ADR2 => I(8),
      ADR3 => MOVE_BASE_GROUP,
      O => RETURNI_DECODE
    );
  Q_I258 : X_LUT3
    generic map (
      INIT => X"0E"
    )
    port map (
      ADR0 => FLAG_EN_COMMAND,
      ADR1 => RETURNI_COMMAND,
      ADR2 => READ,
      O => FLAG_EN
    );
  Q_I259 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => FOR_ZERO,
      ADR1 => PRESERVE_ZERO,
      ADR2 => RETURNI_COMMAND,
      O => NEW_ZERO
    );
  Q_I26 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SELECT_VECTOR,
      ADR1 => ADDR_VECTOR4,
      ADR2 => NGD2VHDL_OI47,
      O => CNT_ADDR4
    );
  Q_I260 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => FOR_CARRY,
      ADR1 => PRESERVE_CARRY,
      ADR2 => RETURNI_COMMAND,
      O => NEW_CARRY
    );
  Q_I261 : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => REG_WRITE_TYPE,
      ADR1 => READ,
      ADR2 => FORCE_FF,
      O => EN_WRITE_REG
    );
  Q_I264 : X_FF
    port map (
      I => I(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SHIFT_INPUT_SEL
    );
  Q_I266 : X_FF
    port map (
      I => ALU_CODE3,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => REG_DATA_SEL
    );
  Q_I268 : X_FF
    port map (
      I => FLAG_EN_TYPE,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => FLAG_EN_COMMAND
    );
  Q_I27 : X_ZERO
    port map (
      O => Q_NET00019_Q
    );
  Q_I270 : X_FF
    port map (
      I => RETURNI_DECODE,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => RETURNI_COMMAND
    );
  Q_I272 : X_FF
    port map (
      I => SHIFT_DECODE,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEL_SHIFT_CY
    );
  Q_I274 : X_FF
    port map (
      I => ARITH_DECODE,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEL_ARITH_CY
    );
  Q_I277 : X_FF
    port map (
      I => EN_WRITE_REG,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => WRITE_REG
    );
  Q_I279 : X_INV
    port map (
      I => READ,
      O => NOT_READ
    );
  Q_I28 : X_XOR2
    port map (
      I0 => CNT_ADDR4,
      I1 => CNT_CY3,
      O => NEW_ADDR4
    );
  Q_I280 : X_SFF
    port map (
      I => RD_STRB,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => FORCE_FF,
      O => READ_STROBE
    );
  Q_I281 : X_SFF
    port map (
      I => WR_STRB,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => FORCE_FF,
      O => WRITE_STROBE
    );
  Q_I29 : X_SFF
    port map (
      I => NEW_ADDR5,
      CLK => CLK,
      CE => READ,
      SET => GSR,
      RST => GND,
      SSET => FORCE_FF,
      SRST => GND,
      O => NGD2VHDL_OI46
    );
  Q_I3 : X_SFF
    port map (
      I => NEW_ADDR7,
      CLK => CLK,
      CE => READ,
      SET => GSR,
      RST => GND,
      SSET => FORCE_FF,
      SRST => GND,
      O => NGD2VHDL_OI44
    );
  Q_I30 : X_MUX2
    port map (
      IA => Q_NET00023_Q,
      IB => CNT_CY2,
      SEL => CNT_ADDR3,
      O => Q_I30_O
    );
  Q_I30_MUXCY_L_BUF : X_BUF
    port map (
      I => Q_I30_O,
      O => CNT_CY3
    );
  Q_I31 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SELECT_VECTOR,
      ADR1 => ADDR_VECTOR3,
      ADR2 => NGD2VHDL_OI48,
      O => CNT_ADDR3
    );
  Q_I32 : X_ZERO
    port map (
      O => Q_NET00023_Q
    );
  Q_I33 : X_MUX2
    port map (
      IA => Q_NET00027_Q,
      IB => CNT_CY1,
      SEL => CNT_ADDR2,
      O => Q_I33_O
    );
  Q_I33_MUXCY_L_BUF : X_BUF
    port map (
      I => Q_I33_O,
      O => CNT_CY2
    );
  Q_I34 : X_XOR2
    port map (
      I0 => CNT_ADDR3,
      I1 => CNT_CY2,
      O => NEW_ADDR3
    );
  Q_I35 : X_SFF
    port map (
      I => NEW_ADDR4,
      CLK => CLK,
      CE => READ,
      SET => GSR,
      RST => GND,
      SSET => FORCE_FF,
      SRST => GND,
      O => NGD2VHDL_OI47
    );
  Q_I36 : X_FF
    port map (
      I => STACK_RAM3,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => RETURN_VECTOR(3)
    );
  Q_I37 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => I(8),
      ADR1 => I(3),
      ADR2 => RETURN_VECTOR(3),
      O => ADDR_VECTOR3
    );
  Q_I38 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => I(8),
      ADR1 => I(4),
      ADR2 => RETURN_VECTOR(4),
      O => ADDR_VECTOR4
    );
  Q_I39 : X_SFF
    port map (
      I => NEW_ADDR0,
      CLK => CLK,
      CE => READ,
      SET => GSR,
      RST => GND,
      SSET => FORCE_FF,
      SRST => GND,
      O => NGD2VHDL_OI51
    );
  Q_I4 : X_ZERO
    port map (
      O => Q_NET00033_Q
    );
  Q_I40 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => STACK(2),
      ADR1 => READ,
      O => CNT_STACK2
    );
  Q_I41 : X_FF
    port map (
      I => NEW_STACK3,
      CLK => CLK,
      CE => Q_NET00004_Q,
      SET => GND,
      RST => GSR,
      O => STACK(3)
    );
  Q_I42 : X_SFF
    port map (
      I => NEW_ADDR3,
      CLK => CLK,
      CE => READ,
      SET => GSR,
      RST => GND,
      SSET => FORCE_FF,
      SRST => GND,
      O => NGD2VHDL_OI48
    );
  Q_I43 : X_SFF
    port map (
      I => NEW_ADDR2,
      CLK => CLK,
      CE => READ,
      SET => GSR,
      RST => GND,
      SSET => FORCE_FF,
      SRST => GND,
      O => NGD2VHDL_OI49
    );
  Q_I45 : X_ZERO
    port map (
      O => Q_NET00106_Q
    );
  Q_I46 : X_SFF
    port map (
      I => NEW_ADDR1,
      CLK => CLK,
      CE => READ,
      SET => GSR,
      RST => GND,
      SSET => FORCE_FF,
      SRST => GND,
      O => NGD2VHDL_OI50
    );
  Q_I47 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => I(8),
      ADR1 => I(7),
      ADR2 => RETURN_VECTOR(7),
      O => ADDR_VECTOR7
    );
  Q_I48 : X_FF
    port map (
      I => STACK_RAM1,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => RETURN_VECTOR(1)
    );
  Q_I49 : X_FF
    port map (
      I => STACK_RAM0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => RETURN_VECTOR(0)
    );
  Q_I5 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SELECT_VECTOR,
      ADR1 => ADDR_VECTOR0,
      ADR2 => NGD2VHDL_OI51,
      O => CNT_ADDR0
    );
  Q_I50 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => I(8),
      ADR1 => I(0),
      ADR2 => RETURN_VECTOR(0),
      O => ADDR_VECTOR0
    );
  Q_I51 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => I(8),
      ADR1 => I(6),
      ADR2 => RETURN_VECTOR(6),
      O => ADDR_VECTOR6
    );
  Q_I52 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => I(8),
      ADR1 => I(2),
      ADR2 => RETURN_VECTOR(2),
      O => ADDR_VECTOR2
    );
  Q_I53 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => I(8),
      ADR1 => I(5),
      ADR2 => RETURN_VECTOR(5),
      O => ADDR_VECTOR5
    );
  Q_I54 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => I(8),
      ADR1 => I(1),
      ADR2 => RETURN_VECTOR(1),
      O => ADDR_VECTOR1
    );
  Q_I55 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => STACK(0),
      ADR1 => STACK(1),
      ADR2 => STACK(2),
      ADR3 => STACK(3),
      I => NGD2VHDL_OI49,
      CLK => CLK,
      WE => READ,
      O => STACK_RAM2
    );
  Q_I56 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => STACK(0),
      ADR1 => STACK(1),
      ADR2 => STACK(2),
      ADR3 => STACK(3),
      I => NGD2VHDL_OI48,
      CLK => CLK,
      WE => READ,
      O => STACK_RAM3
    );
  Q_I58 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => STACK(0),
      ADR1 => STACK(1),
      ADR2 => STACK(2),
      ADR3 => STACK(3),
      I => NGD2VHDL_OI44,
      CLK => CLK,
      WE => READ,
      O => STACK_RAM7
    );
  Q_I6 : X_XOR2
    port map (
      I0 => CNT_ADDR0,
      I1 => INC_ADDR,
      O => NEW_ADDR0
    );
  Q_I60 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => STACK(0),
      ADR1 => STACK(1),
      ADR2 => STACK(2),
      ADR3 => STACK(3),
      I => NGD2VHDL_OI51,
      CLK => CLK,
      WE => READ,
      O => STACK_RAM0
    );
  Q_I61 : X_FF
    port map (
      I => STACK_RAM4,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => RETURN_VECTOR(4)
    );
  Q_I62 : X_FF
    port map (
      I => STACK_RAM7,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => RETURN_VECTOR(7)
    );
  Q_I63 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => STACK(0),
      ADR1 => STACK(1),
      ADR2 => STACK(2),
      ADR3 => STACK(3),
      I => NGD2VHDL_OI47,
      CLK => CLK,
      WE => READ,
      O => STACK_RAM4
    );
  Q_I65 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => STACK(0),
      ADR1 => STACK(1),
      ADR2 => STACK(2),
      ADR3 => STACK(3),
      I => NGD2VHDL_OI45,
      CLK => CLK,
      WE => READ,
      O => STACK_RAM6
    );
  Q_I66 : X_FF
    port map (
      I => STACK_RAM6,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => RETURN_VECTOR(6)
    );
  Q_I67 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => STACK(0),
      ADR1 => STACK(1),
      ADR2 => STACK(2),
      ADR3 => STACK(3),
      I => NGD2VHDL_OI50,
      CLK => CLK,
      WE => READ,
      O => STACK_RAM1
    );
  Q_I68 : X_FF
    port map (
      I => STACK_RAM5,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => RETURN_VECTOR(5)
    );
  Q_I69 : X_FF
    port map (
      I => STACK_RAM2,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => RETURN_VECTOR(2)
    );
  Q_I7 : X_XOR2
    port map (
      I0 => CNT_ADDR1,
      I1 => CNT_CY0,
      O => NEW_ADDR1
    );
  Q_I70 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => STACK(0),
      ADR1 => STACK(1),
      ADR2 => STACK(2),
      ADR3 => STACK(3),
      I => NGD2VHDL_OI46,
      CLK => CLK,
      WE => READ,
      O => STACK_RAM5
    );
  Q_I71 : X_XOR2
    port map (
      I0 => CNT_STACK3,
      I1 => CNT_STACK_CY2,
      O => NEW_STACK3
    );
  Q_I72 : X_XOR2
    port map (
      I0 => CNT_STACK2,
      I1 => CNT_STACK_CY1,
      O => NEW_STACK2
    );
  Q_I73 : X_LUT4
    generic map (
      INIT => X"5A96"
    )
    port map (
      ADR0 => STACK(0),
      ADR1 => STACK_LSB,
      ADR2 => READ,
      ADR3 => FORCE_FF,
      O => CNT_STACK0
    );
  Q_I74 : X_XOR2
    port map (
      I0 => CNT_STACK0,
      I1 => STACK_CIN,
      O => NEW_STACK0
    );
  Q_I75 : X_MUX2
    port map (
      IA => STACK(0),
      IB => STACK_CIN,
      SEL => CNT_STACK0,
      O => Q_I75_O
    );
  Q_I75_MUXCY_L_BUF : X_BUF
    port map (
      I => Q_I75_O,
      O => CNT_STACK_CY0
    );
  Q_I76 : X_MUX2
    port map (
      IA => STACK(2),
      IB => CNT_STACK_CY1,
      SEL => CNT_STACK2,
      O => Q_I76_O
    );
  Q_I76_MUXCY_L_BUF : X_BUF
    port map (
      I => Q_I76_O,
      O => CNT_STACK_CY2
    );
  Q_I77 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => STACK(1),
      ADR1 => READ,
      O => CNT_STACK1
    );
  Q_I78 : X_FF
    port map (
      I => NEW_STACK0,
      CLK => CLK,
      CE => Q_NET00004_Q,
      SET => GND,
      RST => GSR,
      O => STACK(0)
    );
  Q_I79 : X_FF
    port map (
      I => NEW_STACK2,
      CLK => CLK,
      CE => Q_NET00004_Q,
      SET => GND,
      RST => GSR,
      O => STACK(2)
    );
  Q_I8 : X_MUX2
    port map (
      IA => Q_NET00010_Q,
      IB => CNT_CY5,
      SEL => CNT_ADDR6,
      O => Q_I8_O
    );
  Q_I8_MUXCY_L_BUF : X_BUF
    port map (
      I => Q_I8_O,
      O => CNT_CY6
    );
  Q_I80 : X_FF
    port map (
      I => NEW_STACK1,
      CLK => CLK,
      CE => Q_NET00004_Q,
      SET => GND,
      RST => GSR,
      O => STACK(1)
    );
  Q_I81 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => STACK(3),
      ADR1 => READ,
      O => CNT_STACK3
    );
  Q_I82 : X_XOR2
    port map (
      I0 => CNT_STACK1,
      I1 => CNT_STACK_CY0,
      O => NEW_STACK1
    );
  Q_I83 : X_MUX2
    port map (
      IA => STACK(1),
      IB => CNT_STACK_CY0,
      SEL => CNT_STACK1,
      O => Q_I83_O
    );
  Q_I83_MUXCY_L_BUF : X_BUF
    port map (
      I => Q_I83_O,
      O => CNT_STACK_CY1
    );
  Q_I84 : X_LUT2
    generic map (
      INIT => X"2"
    )
    port map (
      ADR0 => I(5),
      ADR1 => FORCE_FF,
      O => INT_SET
    );
  Q_I85 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => VALID_TO_MOVE,
      ADR1 => MOVE_BASE_GROUP,
      O => SELECT_VECTOR
    );
  Q_I86 : X_LUT4
    generic map (
      INIT => X"1FFF"
    )
    port map (
      ADR0 => I(6),
      ADR1 => I(8),
      ADR2 => VALID_TO_MOVE,
      ADR3 => MOVE_BASE_GROUP,
      O => INC_ADDR
    );
  Q_I87 : X_LUT2
    generic map (
      INIT => X"2"
    )
    port map (
      ADR0 => INT_ENABLE,
      ADR1 => FORCE_FF,
      O => HOLD_CLEAR_INT
    );
  Q_I9 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SELECT_VECTOR,
      ADR1 => ADDR_VECTOR6,
      ADR2 => NGD2VHDL_OI45,
      O => CNT_ADDR6
    );
  Q_I91 : X_LUT4
    generic map (
      INIT => X"40FF"
    )
    port map (
      ADR0 => I(8),
      ADR1 => VALID_TO_MOVE,
      ADR2 => MOVE_BASE_GROUP,
      ADR3 => READ,
      O => STACK_LSB
    );
  Q_I92 : X_LUT3
    generic map (
      INIT => X"10"
    )
    port map (
      ADR0 => I(13),
      ADR1 => I(14),
      ADR2 => I(15),
      O => MOVE_BASE_GROUP
    );
  Q_I93 : X_LUT4
    generic map (
      INIT => X"5A3C"
    )
    port map (
      ADR0 => CARRY,
      ADR1 => ZERO,
      ADR2 => I(10),
      ADR3 => I(11),
      O => CONDITION_MET
    );
  Q_I94 : X_LUT4
    generic map (
      INIT => X"0800"
    )
    port map (
      ADR0 => READ,
      ADR1 => I(13),
      ADR2 => I(14),
      ADR3 => I(15),
      O => RD_STRB
    );
  Q_I98 : X_LUT4
    generic map (
      INIT => X"8000"
    )
    port map (
      ADR0 => READ,
      ADR1 => I(13),
      ADR2 => I(14),
      ADR3 => I(15),
      O => WR_STRB
    );
  Q_I178_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => I(8),
      ADR1 => I(9),
      ADR2 => I(10),
      ADR3 => I(11),
      I => NEW_REG_DATA7,
      CLK => CLK,
      WE => WRITE_REG,
      O => NGD2VHDL_OI10
    );
  Q_I178_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => I(4),
      RADR1 => I(5),
      RADR2 => I(6),
      RADR3 => I(7),
      WADR0 => I(8),
      WADR1 => I(9),
      WADR2 => I(10),
      WADR3 => I(11),
      I => NEW_REG_DATA7,
      CLK => CLK,
      WE => WRITE_REG,
      O => READ_REG7
    );
  Q_I181_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => I(8),
      ADR1 => I(9),
      ADR2 => I(10),
      ADR3 => I(11),
      I => NEW_REG_DATA6,
      CLK => CLK,
      WE => WRITE_REG,
      O => NGD2VHDL_OI11
    );
  Q_I181_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => I(4),
      RADR1 => I(5),
      RADR2 => I(6),
      RADR3 => I(7),
      WADR0 => I(8),
      WADR1 => I(9),
      WADR2 => I(10),
      WADR3 => I(11),
      I => NEW_REG_DATA6,
      CLK => CLK,
      WE => WRITE_REG,
      O => READ_REG6
    );
  Q_I183_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => I(8),
      ADR1 => I(9),
      ADR2 => I(10),
      ADR3 => I(11),
      I => NEW_REG_DATA5,
      CLK => CLK,
      WE => WRITE_REG,
      O => NGD2VHDL_OI12
    );
  Q_I183_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => I(4),
      RADR1 => I(5),
      RADR2 => I(6),
      RADR3 => I(7),
      WADR0 => I(8),
      WADR1 => I(9),
      WADR2 => I(10),
      WADR3 => I(11),
      I => NEW_REG_DATA5,
      CLK => CLK,
      WE => WRITE_REG,
      O => READ_REG5
    );
  Q_I185_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => I(8),
      ADR1 => I(9),
      ADR2 => I(10),
      ADR3 => I(11),
      I => NEW_REG_DATA4,
      CLK => CLK,
      WE => WRITE_REG,
      O => NGD2VHDL_OI13
    );
  Q_I185_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => I(4),
      RADR1 => I(5),
      RADR2 => I(6),
      RADR3 => I(7),
      WADR0 => I(8),
      WADR1 => I(9),
      WADR2 => I(10),
      WADR3 => I(11),
      I => NEW_REG_DATA4,
      CLK => CLK,
      WE => WRITE_REG,
      O => READ_REG4
    );
  Q_I186_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => I(8),
      ADR1 => I(9),
      ADR2 => I(10),
      ADR3 => I(11),
      I => NEW_REG_DATA3,
      CLK => CLK,
      WE => WRITE_REG,
      O => NGD2VHDL_OI14
    );
  Q_I186_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => I(4),
      RADR1 => I(5),
      RADR2 => I(6),
      RADR3 => I(7),
      WADR0 => I(8),
      WADR1 => I(9),
      WADR2 => I(10),
      WADR3 => I(11),
      I => NEW_REG_DATA3,
      CLK => CLK,
      WE => WRITE_REG,
      O => READ_REG3
    );
  Q_I187_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => I(8),
      ADR1 => I(9),
      ADR2 => I(10),
      ADR3 => I(11),
      I => NEW_REG_DATA2,
      CLK => CLK,
      WE => WRITE_REG,
      O => NGD2VHDL_OI15
    );
  Q_I187_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => I(4),
      RADR1 => I(5),
      RADR2 => I(6),
      RADR3 => I(7),
      WADR0 => I(8),
      WADR1 => I(9),
      WADR2 => I(10),
      WADR3 => I(11),
      I => NEW_REG_DATA2,
      CLK => CLK,
      WE => WRITE_REG,
      O => READ_REG2
    );
  Q_I189_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => I(8),
      ADR1 => I(9),
      ADR2 => I(10),
      ADR3 => I(11),
      I => NEW_REG_DATA1,
      CLK => CLK,
      WE => WRITE_REG,
      O => NGD2VHDL_OI16
    );
  Q_I189_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => I(4),
      RADR1 => I(5),
      RADR2 => I(6),
      RADR3 => I(7),
      WADR0 => I(8),
      WADR1 => I(9),
      WADR2 => I(10),
      WADR3 => I(11),
      I => NEW_REG_DATA1,
      CLK => CLK,
      WE => WRITE_REG,
      O => READ_REG1
    );
  Q_I192_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => I(8),
      ADR1 => I(9),
      ADR2 => I(10),
      ADR3 => I(11),
      I => NEW_REG_DATA0,
      CLK => CLK,
      WE => WRITE_REG,
      O => NGD2VHDL_OI17
    );
  Q_I192_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => I(4),
      RADR1 => I(5),
      RADR2 => I(6),
      RADR3 => I(7),
      WADR0 => I(8),
      WADR1 => I(9),
      WADR2 => I(10),
      WADR3 => I(11),
      I => NEW_REG_DATA0,
      CLK => CLK,
      WE => WRITE_REG,
      O => READ_REG0
    );
  VCC_0 : X_ONE
    port map (
      O => VCC
    );
  GND_1 : X_ZERO
    port map (
      O => GND
    );
  ROC_NGD2VHDL : ROC port map (O => GSR);
end STRUCTURE;

