-- Applied Research Laboratory
-- Washington University in St. Louis
--
-- File:  ccp.vhd
-- Created by:  David E. Taylor
-- Created on:  1/20/00
-- Last Modified: 1/20/00, 1:30pm
--
-- The following code creates a simulation model
-- of a 100MHz clock.
--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
--
entity clock is
port(
	clk : out std_logic
);
end clock;
--
architecture behavioral of clock is
--
signal i : std_logic := '1';            -- loop variable
--
begin
clock_gen: process
        constant Tclk: time := 5 ns;
begin
	  clk <= '0';
          wait for Tclk;
          while i='1' loop
            clk <= '0';
            wait for Tclk;
            clk <= '1';
            wait for Tclk;
          end loop;
end process clock_gen;
--
end behavioral;
