/* $Id: cc_crc.c,v 1.1 2001/04/06 21:59:58 florian Exp $
 *
 * (c) 2001, Applied Research Lab, Washington University, St. Louis
 *
 * IP testbench tools
 * generate testpatterns for FPX modules
 *
 * cc_crc.c: calculate CRC for control cells, original code by Todd
 */

#include "testbench.h"

static int* queue_buffer[12];
static int* Payload[12];
static int crc_compute(int, int);

/* wrapper functions to crc_compute() */
void set_cc_crc (DataBlock* data)
{
  int i;
  /* copy data to Payload */
  for (i=0; i<12; i++)
    Payload[i] = (int*)data->data[i];
  crc_compute(0, 0);
  /* set crc */
  data->data[11] = (int)Payload[11];
}

int check_cc_crc (DataBlock* data)
{
}

/* Todd's CRC code */
static int crc_compute(int check_crc,int temp_data)
{

  int t=0;
  int data[16];
  int crc[16];
  int din[16];
  int old[16];
  int temp_Payload[16];
  int y,k,j,z,temp,stuff,temp2;
  int tempcrc=0;
  int hexcrc=0;
  int i;

  for (k=15; k>=0; k--)
    {
      data[k]=0;
      crc[k]=0;
      old[k]=0;
    }

  if(temp_data)
    {
      z=2;
      for(i=0;i<12;i++)
	{

	  temp_Payload[i]=(int)queue_buffer[z];
	  z++;
	}

    }
  else
    {
      for(i=0;i<12;i++)
	{
	  temp_Payload[i]=(int)Payload[i];
	}
    }

  for(i=0;i<12;i++)
    {
      for(y=0;y<2;y++)
	{
	  if(i==11)
	    y=2;

	  temp=(int)temp_Payload[i];
	  temp=temp >> 16;

	  for(t=0;t<16;t++)
	    {
	      din[t]=temp & 0x0001;
	      temp=temp >> 1;
	    }

	  data[0]  = din[15] ^ din[11] ^ din[7]  ^ din[4] ^  din[3];
	  data[1]  = din[14] ^ din[10] ^ din[6]  ^ din[3] ^  din[2];
	  data[2]  = din[13] ^ din[9]  ^ din[5]  ^ din[2] ^  din[1];
	  data[3]  = din[12] ^ din[8]  ^ din[4]  ^ din[1] ^  din[0];
	  data[4]  = din[11] ^ din[7]  ^ din[3]  ^ din[0];
	  data[5]  = din[15] ^ din[11] ^ din[10] ^ din[7] ^
	    din[6] ^ din[4] ^ din[3] ^ din[2];
	  data[6]  = din[14] ^ din[10] ^ din[9]  ^ din[6] ^
	    din[5] ^ din[3] ^ din[2] ^ din[1];
	  data[7]  = din[13] ^ din[9]  ^ din[8]  ^ din[5] ^
	    din[4] ^ din[2] ^ din[1] ^ din[0];
	  data[8]  = din[12] ^ din[8]  ^ din[7]  ^ din[4] ^
	    din[3] ^ din[1] ^ din[0];
	  data[9]  = din[11] ^ din[7]  ^ din[6]  ^ din[3] ^
	    din[2] ^ din[0];
	  data[10] = din[10] ^ din[6]  ^ din[5]  ^ din[2] ^
	    din[1];
	  data[11] = din[9]  ^ din[5]  ^ din[4]  ^ din[1] ^
	    din[0];
	  data[12] = din[15] ^ din[11] ^ din[8]  ^ din[7] ^
	    din[0];
	  data[13] = din[14] ^ din[10] ^ din[7]  ^ din[6];
	  data[14] = din[13] ^ din[9]  ^ din[6]  ^ din[5];
	  data[15] = din[12] ^ din[8]  ^ din[5]  ^ din[4];


	  for (k=15; k>=0; k--)
	    {
	      crc[k] = data[k] ^ old[k];
	      old[k] = crc[k];
	    }
	  temp=(int)temp_Payload[i];
	  temp=temp << 16;
	  temp_Payload[i]=temp;
	}
    }
  for (k=15; k>=0; k--)
    {
      tempcrc=crc[k];
      tempcrc=tempcrc << k;
      hexcrc=tempcrc | hexcrc;
    }

  if(!check_crc)
    {
      if(!temp_data)
	tempcrc=(int)Payload[11];
      else
	tempcrc=(int)queue_buffer[13];

      tempcrc=tempcrc & 0xFFFF0000;
      tempcrc=hexcrc | tempcrc;
      if(temp_data)
	queue_buffer[13]=(int*)tempcrc;
      else
	Payload[11]=(int*)tempcrc;
    }
  if(check_crc)
    {
      if(!temp_data)
	tempcrc=(int)Payload[11];
      else
	tempcrc=(int)queue_buffer[13];

      tempcrc=tempcrc & 0x0000FFFF;

      if(hexcrc==tempcrc)
	{
	  if(!temp_data)
	    tempcrc=(int)Payload[11];
	  else
	    tempcrc=(int)queue_buffer[13];

	  tempcrc=tempcrc & 0xFFFF0000;
	  tempcrc=hexcrc | tempcrc;
	  if(temp_data)
	    queue_buffer[13]=(int*)tempcrc;
	  else
	    Payload[11]=(int*)tempcrc;
	  return 1;
	}
      else
	{
	  printf("\n BAD CRC \n");
	  return 0;
	}
    }
  return 0;
}
