/* $Id: dumptb.c,v 1.2 2001/04/27 02:00:01 florian Exp $
 *
 * (c) 2001, Applied Research Lab, Washington University, St. Louis
 *
 * IP testbench tools
 * generate testpatterns for FPX modules
 *
 * dumptb.c: output description file
 */

#include "testbench.h"
#include <stdio.h>

void DumpTB (char *outfile, StreamBlock *sblock)
{
  FILE *file;
  unsigned count;

  /* open file */
  file = fopen (outfile, "w");
  if (!file) {
    printf ("Error! cannot open file %s\n", outfile);
    return;
  }

  /* header */
  fprintf (file, "# generated file\n");
  fprintf (file, "# do not edit!\n");
  fprintf (file, "#\n");

  /* dump every block */
  while (sblock) {
    if (sblock->btype != NONE) {
      /* print type */
      switch (sblock->btype)
	{
	case RAW:   fprintf (file, "!RAW"); break;
	case ERROR: fprintf (file, "!ERROR"); break;
	case PAD:   fprintf (file, "!PAD"); break;
	case CTRLCELL: fprintf (file, "!CTRLCELL"); break;
	case CELL:  fprintf (file, "!CELL"); break;
	case FRAME: fprintf (file, "!FRAME"); break;
	case IPv4:  fprintf (file, "!IPv4"); break;
	case IPv6:  fprintf (file, "!IPv6"); break;
	case UDP:   fprintf (file, "!UDP"); break;
	default:    fprintf (file, "!UNKNOWN"); break;
	}
      /* print options */
      if (sblock->options)
	fprintf (file, " %s\n", sblock->options);
      else 
	fprintf (file, "\n");
      /* dump data */
      for (count=0; count<sblock->data->entries; count++)
	fprintf (file, "%08X\n", sblock->data->data[count]);
    } /* it's a real block */

    /* get next block */
    sblock = sblock->next;
  }


  /* close file */
  fclose (file);
}
