/* $Id: racells.c,v 1.2 2001/04/06 18:25:41 florian Exp $
 *
 * (c) 2001, Applied Research Lab, Washington University, St. Louis
 *
 * IP testbench tools
 * generate testpatterns for FPX modules
 *
 * racells.c: reassemble cells from raw
 */

#include "testbench.h"
#include <stdlib.h>
#include <string.h>

extern unsigned char calc_hec (unsigned long header);

StreamBlock *RACellFilter (StreamBlock *block)
{
  unsigned header;
  unsigned vci, islast;
  unsigned char hec;
  unsigned entries, count;
  DataBlock *data;
  char strbuf[32];

  /* we only handle raw blocks */
  if (block->btype != RAW)
    return block;

  /* get channel */
  header = block->data->data[0];
  vci = (header>> 4) & 0xFFFF;
  /* get last bit */
  islast = (header& 0x02) != 0;

  /* check hec! */
  hec = calc_hec (header);
  if (hec != (block->data->data[1] >> 24)) {
    block->btype = ERROR;
    if (block->options)
      free (block->options);
    block->options = strdup ("invalid HEC");
  }
  else { 
    /* copy data */
    data = NewDataBlock ();
    entries = block->data->entries;
    if (entries > 14)
      entries = 14;
    for (count=2; count<entries; count++)
      AddToDataBlock (data, block->data->data[count]);

    DeleteDataBlock (block->data);
    block->data = data;

    /* set options (vci and islast) */
    if (block->options)
      free (block->options);
    sprintf (strbuf, "%d %d", vci, islast);
    block->options = strdup (strbuf);

    block->btype = CELL;
  }
  return block;
}
