/* $Id: testbench.c,v 1.1.1.1 2001/03/21 20:11:36 florian Exp $
 *
 * (c) 2001, Applied Research Lab, Washington University, St. Louis
 *
 * IP testbench tools
 * generate testpatterns for FPX modules
 *
 * testbench.c: basic functions to organize structures
 */

#include "testbench.h"
#include <stdlib.h>
#include <string.h>

/* create new data block */
DataBlock *NewDataBlock()
{
  DataBlock *block = (DataBlock*) malloc (sizeof(DataBlock));
  block->size = 14;		/* initial block size */
  block->entries = 0;		/* no entries */
  block->data = (unsigned long*) malloc (sizeof(unsigned long) * block->size);

  return block;
}

/* add a word to data block */
void AddToDataBlock (DataBlock *block, unsigned word)
{
  /* enough space? */
  if (block->entries >= block->size) {
    /* resize first */
    block->size += 14;
    block->data = (unsigned long*) realloc (block->data, 
				       sizeof(unsigned long) * block->size);
  }

  /* add word */
  block->data[block->entries++] = word;
}

/* delete a data block */
void DeleteDataBlock (DataBlock *block)
{
  free (block->data);
  free (block);
}

/* create new stream block */
StreamBlock *NewStreamBlock (BlockType btype)
{
  StreamBlock *block = (StreamBlock*) malloc (sizeof(StreamBlock));
  block->btype = btype;
  block->data = NewDataBlock();
  block->options = NULL;
  block->next = NULL;
  
  return block;
}

/* delete a stream block */
void DeleteStreamBlock (StreamBlock *block)
{
  DeleteDataBlock (block->data);
  if (block->options)
    free (block->options);
  free (block);
}


StreamBlock *ErrorBlock (char *errorstr)
{
  StreamBlock *errblock = NewStreamBlock (ERROR);
  errblock -> options = strdup (errorstr);
  
  return errblock;
}
