/* $Id: udp.c,v 1.1.1.1 2001/03/21 20:11:36 florian Exp $
 *
 * (c) 2001, Applied Research Lab, Washington University, St. Louis
 *
 * IP testbench tools
 * generate testpatterns for FPX modules
 * 
 * udp.c: converts UDP datagrams to IP packets
 */


#include "testbench.h"
#include <stdlib.h>
#include <string.h>

StreamBlock *UDPFilter (StreamBlock *block)
{
  DataBlock *data = NewDataBlock ();
  char strbuf[33];
  unsigned count;
  unsigned addr[4] = { 127, 0, 0, 1};
  unsigned srcport = 64000;
  unsigned dstport = 7;
  
  /* we only handle UDP blocks */
  if (block->btype != UDP)
    return block;

  /* check options */
  if (block->options) {
    sscanf (block->options, "%d.%d.%d.%d %d %d", 
	    addr, addr+1, addr+2, addr+3, &dstport, &srcport);
    free (block->options);
  }

  /* set options */
  sprintf (strbuf, "%d.%d.%d.%d 17", addr[0], addr[1], addr[2], addr[3]);
  block->options = strdup (strbuf);

  /* create UDP header */
  /* src port / dest port */
  AddToDataBlock (data, (srcport << 16) | (dstport & 0xFFFF) );
  /* length / checksum */
  AddToDataBlock (data, (8 + block->data->entries*4) << 16);

  /* calc checksum */

  /* copy payload */
  for (count=0; count<block->data->entries; count++)
    AddToDataBlock (data, block->data->data[count]);

  /* delete old block */
  DeleteDataBlock (block->data);
  
  /* update stream block */
  block->btype = IPv4;
  block->data = data;

  return block;
}
