-- Xilinx Vhdl produced by program ngd2vhdl D.27
-- Command: -w cellproc.ngd cellproc_sim.vhd 
-- Options: -w -ti UUT 
-- Date: Wed Aug 15 18:26:44 2001 
-- Input file: cellproc.ngd
-- Output file: cellproc_sim.vhd
-- Tmp file: c:/DOCUME~1/hwf1/LOCALS~1/Temp/xil_42
-- Design name: CellProc
-- Xilinx: C:/Xilinx
-- # of Entities: 1
-- Device: xcv1000e-7-fg680

-- The output of ngd2vhdl is a simulation model. This file cannot be synthesized,
-- or used in any other manner other than simulation. This netlist uses simulation
-- primitives which may not represent the true implementation of the device, however
-- the netlist is functionally correct. Do not modify this file.

-- Model for  ROC (Reset-On-Configuration) Cell
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.VITAL_Timing.all;
entity ROC is
  generic (InstancePath: STRING := "*";
           WIDTH : Time := 100 ns);
  port(O : out std_ulogic := '1') ;
  attribute VITAL_LEVEL0 of ROC : entity is TRUE;
end ROC;

architecture ROC_V of ROC is
attribute VITAL_LEVEL0 of ROC_V : architecture is TRUE;
begin
  ONE_SHOT : process
  begin
    if (WIDTH <= 0 ns) then
       assert FALSE report
       "*** Error: a positive value of WIDTH must be specified ***"
       severity failure;
    else
       wait for WIDTH;
       O <= '0';
    end if;
    wait;
  end process ONE_SHOT;
end ROC_V;

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library SIMPRIM;
use SIMPRIM.VCOMPONENTS.ALL;
use SIMPRIM.VPACKAGE.ALL;
entity CELLPROC is
  port (
    TCA_OUT_MOD : in STD_LOGIC := 'X'; 
    TCA_OUT_APPL : in STD_LOGIC := 'X'; 
    TCA_MOD_IN : out STD_LOGIC; 
    TCA_APPL_IN : out STD_LOGIC; 
    SOC_OUT_MOD : out STD_LOGIC; 
    SOC_OUT_APPL : out STD_LOGIC; 
    SOC_MOD_IN : in STD_LOGIC := 'X'; 
    SOC_APPL_IN : in STD_LOGIC := 'X'; 
    RESET_L : in STD_LOGIC := 'X'; 
    READY_L : out STD_LOGIC; 
    ENABLE_L : in STD_LOGIC := 'X'; 
    CLK : in STD_LOGIC := 'X'; 
    D_OUT_MOD : out STD_LOGIC_VECTOR ( 31 downto 0 ); 
    D_OUT_APPL : out STD_LOGIC_VECTOR ( 31 downto 0 ); 
    D_MOD_IN : in STD_LOGIC_VECTOR ( 31 downto 0 ); 
    D_APPL_IN : in STD_LOGIC_VECTOR ( 31 downto 0 ) 
  );
end CELLPROC;

architecture STRUCTURE of CELLPROC is
  component ROC
    generic (InstancePath: STRING := "*";
             WIDTH : Time := 100 ns);
    port (O : out STD_ULOGIC := '1');
  end component;
  signal NGD2VHDL_OI69 : STD_LOGIC; 
  signal I_11 : STD_LOGIC; 
  signal NGD2VHDL_OI70 : STD_LOGIC; 
  signal UN10_IS_CONTROL_CELL_0_N_59 : STD_LOGIC; 
  signal N_3554 : STD_LOGIC; 
  signal G_3658 : STD_LOGIC; 
  signal UN10_IS_CONTROL_CELL_0_N_51 : STD_LOGIC; 
  signal NGD2VHDL_OI67 : STD_LOGIC; 
  signal NGD2VHDL_OI68 : STD_LOGIC; 
  signal UN10_IS_CONTROL_CELL_0_N_35 : STD_LOGIC; 
  signal NGD2VHDL_OI65 : STD_LOGIC; 
  signal NGD2VHDL_OI66 : STD_LOGIC; 
  signal N_3408 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_2_0_S_21_Q : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_21_Q : STD_LOGIC; 
  signal G_2535_S : STD_LOGIC; 
  signal NGD2VHDL_OI63 : STD_LOGIC; 
  signal UN10_IS_CONTROL_CELL_0_N_19 : STD_LOGIC; 
  signal NGD2VHDL_OI64 : STD_LOGIC; 
  signal NGD2VHDL_OI62 : STD_LOGIC; 
  signal UN10_IS_CONTROL_CELL_0_N_3 : STD_LOGIC; 
  signal NGD2VHDL_OI61 : STD_LOGIC; 
  signal DISPATCH_UN8_SOC : STD_LOGIC; 
  signal DISPATCH_UN9_SOC : STD_LOGIC; 
  signal DISPATCH_UN8_SOC_0_N_59 : STD_LOGIC; 
  signal N_3469_REP1 : STD_LOGIC; 
  signal N_3055 : STD_LOGIC; 
  signal G_3592 : STD_LOGIC; 
  signal G_3582 : STD_LOGIC; 
  signal G_3579 : STD_LOGIC; 
  signal VALID_02 : STD_LOGIC; 
  signal G_3580 : STD_LOGIC; 
  signal N_4113 : STD_LOGIC; 
  signal G_1072_SX : STD_LOGIC; 
  signal G_20 : STD_LOGIC; 
  signal G_3570 : STD_LOGIC; 
  signal G_3617 : STD_LOGIC; 
  signal G_3619 : STD_LOGIC; 
  signal G_23 : STD_LOGIC; 
  signal NGD2VHDL_OI59 : STD_LOGIC; 
  signal NGD2VHDL_OI60 : STD_LOGIC; 
  signal UN10_IS_CONTROL_CELL_0_N_43 : STD_LOGIC; 
  signal DISPATCH_UN8_SOC_0_N_51 : STD_LOGIC; 
  signal G_3667 : STD_LOGIC; 
  signal NGD2VHDL_OI57 : STD_LOGIC; 
  signal NGD2VHDL_OI58 : STD_LOGIC; 
  signal UN10_IS_CONTROL_CELL_0_N_27 : STD_LOGIC; 
  signal DISPATCH_UN8_SOC_0_N_35 : STD_LOGIC; 
  signal G_3253 : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X0_5_Q : STD_LOGIC; 
  signal G_3250 : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X0_16_Q : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X0_28_Q : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X0_20_Q : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X0_17_Q : STD_LOGIC; 
  signal N_3300 : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X0_25_Q : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X0_27_Q : STD_LOGIC; 
  signal G_3614 : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X0_21_Q : STD_LOGIC; 
  signal G_3602 : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X0_29_Q : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X0_26_Q : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X0_4_Q : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X0_22_Q : STD_LOGIC; 
  signal N_3469 : STD_LOGIC; 
  signal G_3_0_X0 : STD_LOGIC; 
  signal G_3_X0_0 : STD_LOGIC; 
  signal N_3469_REP2 : STD_LOGIC; 
  signal N_3469_REP1_0 : STD_LOGIC; 
  signal G_3_X0 : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X0_23_Q : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X1_23_Q : STD_LOGIC; 
  signal G_3_X1 : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X1_21_Q : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X1_5_Q : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X1_22_Q : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X1_25_Q : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X1_28_Q : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X1_17_Q : STD_LOGIC; 
  signal G_3_X1_0 : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X1_29_Q : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X1_16_Q : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X1_27_Q : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X1_26_Q : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X1_4_Q : STD_LOGIC; 
  signal G_3_0_X1 : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_X1_20_Q : STD_LOGIC; 
  signal G_3583 : STD_LOGIC; 
  signal G_3563 : STD_LOGIC; 
  signal G_3581 : STD_LOGIC; 
  signal NGD2VHDL_OI55 : STD_LOGIC; 
  signal NGD2VHDL_OI56 : STD_LOGIC; 
  signal UN10_IS_CONTROL_CELL_0_N_11 : STD_LOGIC; 
  signal DISPATCH_UN8_SOC_0_N_19 : STD_LOGIC; 
  signal GENCOUNT_FAST_0_2_Q : STD_LOGIC; 
  signal GENCOUNT_FAST_0_0_Q : STD_LOGIC; 
  signal DISPATCH_UN8_SOC_0_N_3 : STD_LOGIC; 
  signal DATA_STORE_4_1_Q : STD_LOGIC; 
  signal G_3552 : STD_LOGIC; 
  signal DATA_STORE_0_1_Q : STD_LOGIC; 
  signal G_4_FAST : STD_LOGIC; 
  signal G_3550 : STD_LOGIC; 
  signal SEL_REGVPIVCI_REGNR_02_1_IV_0_0_1_G_3561_SX : STD_LOGIC; 
  signal G_3562 : STD_LOGIC; 
  signal DATA_STORE_4_6_Q : STD_LOGIC; 
  signal G_3561 : STD_LOGIC; 
  signal G_3549 : STD_LOGIC; 
  signal G_3551 : STD_LOGIC; 
  signal SEL_REGVPIVCI_REGNR_02_1_IV_0_0_0_G_3551_SX : STD_LOGIC; 
  signal SEL_REGVPIVCI_REGNR_02_1_IV_0_0_2_G_3549_SX : STD_LOGIC; 
  signal DATA_STORE_4_2_Q : STD_LOGIC; 
  signal G_2834_FAST : STD_LOGIC; 
  signal DATA_STORE_0_0_Q : STD_LOGIC; 
  signal DATA_STORE_4_0_Q : STD_LOGIC; 
  signal G_2539_S : STD_LOGIC; 
  signal SEL_REGVPIVCI_REGNR_02_1_IV_0_0_6_G_3557_SX : STD_LOGIC; 
  signal DATA_STORE_0_6_Q : STD_LOGIC; 
  signal G_3557 : STD_LOGIC; 
  signal DATA_STORE_0_2_Q : STD_LOGIC; 
  signal G_3558 : STD_LOGIC; 
  signal VALID_04 : STD_LOGIC; 
  signal DISPATCH_UN8_SOC_0_N_43 : STD_LOGIC; 
  signal G_3_FAST : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_9_Q : STD_LOGIC; 
  signal G_3258 : STD_LOGIC; 
  signal G_1072_X : STD_LOGIC; 
  signal N_3285 : STD_LOGIC; 
  signal N_2848 : STD_LOGIC; 
  signal G_3639_S : STD_LOGIC; 
  signal N_3834 : STD_LOGIC; 
  signal N_3550 : STD_LOGIC; 
  signal N_3465 : STD_LOGIC; 
  signal N_3844 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_I_I_30_Q : STD_LOGIC; 
  signal DISPATCH_UN8_SOC_0_N_27 : STD_LOGIC; 
  signal N_894_1 : STD_LOGIC; 
  signal N_3850 : STD_LOGIC; 
  signal N_3362 : STD_LOGIC; 
  signal G_35 : STD_LOGIC; 
  signal G_36 : STD_LOGIC; 
  signal G_3601 : STD_LOGIC; 
  signal G_2835_X : STD_LOGIC; 
  signal G_3613 : STD_LOGIC; 
  signal G_3608 : STD_LOGIC; 
  signal N_3378 : STD_LOGIC; 
  signal G_3611 : STD_LOGIC; 
  signal DISPATCH_UN8_SOC_0_N_11 : STD_LOGIC; 
  signal G_3335 : STD_LOGIC; 
  signal G_3334 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_16_Q : STD_LOGIC; 
  signal G_2626_Q_G_24_SX : STD_LOGIC; 
  signal NGD2VHDL_OI44 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_18_Q : STD_LOGIC; 
  signal NGD2VHDL_OI45 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_26_Q : STD_LOGIC; 
  signal N_3842_REP2 : STD_LOGIC; 
  signal NGD2VHDL_OI46 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_2_0_12_G_3637_SX : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_11_Q : STD_LOGIC; 
  signal G_3650 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_20_Q : STD_LOGIC; 
  signal N_3724 : STD_LOGIC; 
  signal N_3013 : STD_LOGIC; 
  signal G_3336 : STD_LOGIC; 
  signal G_3637 : STD_LOGIC; 
  signal NGD2VHDL_OI43 : STD_LOGIC; 
  signal N_3911 : STD_LOGIC; 
  signal N_3820 : STD_LOGIC; 
  signal G_3338 : STD_LOGIC; 
  signal G_3553 : STD_LOGIC; 
  signal N_3817 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_2_0_SX_20_Q : STD_LOGIC; 
  signal NGD2VHDL_OI51 : STD_LOGIC; 
  signal NGD2VHDL_OI47 : STD_LOGIC; 
  signal NGD2VHDL_OI48 : STD_LOGIC; 
  signal G_2621_X : STD_LOGIC; 
  signal N_2939 : STD_LOGIC; 
  signal G_3559 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_10_Q : STD_LOGIC; 
  signal NGD2VHDL_OI50 : STD_LOGIC; 
  signal NGD2VHDL_OI52 : STD_LOGIC; 
  signal N_3552 : STD_LOGIC; 
  signal G_3337 : STD_LOGIC; 
  signal G_3649 : STD_LOGIC; 
  signal G_3339 : STD_LOGIC; 
  signal N_3842_REP1 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_2_0_S_26_Q : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_12_Q : STD_LOGIC; 
  signal G_3555 : STD_LOGIC; 
  signal G_3644_S : STD_LOGIC; 
  signal N_2990 : STD_LOGIC; 
  signal SEL_REGVPIVCI_VALID_02_1 : STD_LOGIC; 
  signal G_3547 : STD_LOGIC; 
  signal NGD2VHDL_OI49 : STD_LOGIC; 
  signal G_3545 : STD_LOGIC; 
  signal N_3464 : STD_LOGIC; 
  signal G_3652_S : STD_LOGIC; 
  signal N_3412 : STD_LOGIC; 
  signal NGD2VHDL_OI54 : STD_LOGIC; 
  signal N_3804 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_24_Q : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_1_Q : STD_LOGIC; 
  signal NGD2VHDL_OI53 : STD_LOGIC; 
  signal G_3599_S : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_I_I_17_Q : STD_LOGIC; 
  signal G_3343 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_2_0_S_6_Q : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_2_Q : STD_LOGIC; 
  signal G_3599 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_4_Q : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_6_Q : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_2_0_S_5_Q : STD_LOGIC; 
  signal N_3418 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_5_Q : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_8_Q : STD_LOGIC; 
  signal UN4_IS_CONTROL_CELL_NE : STD_LOGIC; 
  signal N_3674_REP2 : STD_LOGIC; 
  signal G_3616 : STD_LOGIC; 
  signal N_3836 : STD_LOGIC; 
  signal G_17 : STD_LOGIC; 
  signal N_3683 : STD_LOGIC; 
  signal N_2998 : STD_LOGIC; 
  signal N_2997 : STD_LOGIC; 
  signal G_3333 : STD_LOGIC; 
  signal G_2647 : STD_LOGIC; 
  signal G_3326 : STD_LOGIC; 
  signal G_3328 : STD_LOGIC; 
  signal G_3325 : STD_LOGIC; 
  signal G_3324 : STD_LOGIC; 
  signal G_3332 : STD_LOGIC; 
  signal G_3327 : STD_LOGIC; 
  signal G_3590 : STD_LOGIC; 
  signal G_3588 : STD_LOGIC; 
  signal G_3577 : STD_LOGIC; 
  signal G_3586 : STD_LOGIC; 
  signal G_3584 : STD_LOGIC; 
  signal G_3573 : STD_LOGIC; 
  signal G_15_0 : STD_LOGIC; 
  signal G_3566 : STD_LOGIC; 
  signal N_3835 : STD_LOGIC; 
  signal G_3595 : STD_LOGIC; 
  signal G_3571 : STD_LOGIC; 
  signal G_15 : STD_LOGIC; 
  signal G_3568 : STD_LOGIC; 
  signal N_3684 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_28_Q : STD_LOGIC; 
  signal N_3784 : STD_LOGIC; 
  signal G_3522 : STD_LOGIC; 
  signal G_3532 : STD_LOGIC; 
  signal G_3448 : STD_LOGIC; 
  signal N_3689 : STD_LOGIC; 
  signal G_3556 : STD_LOGIC; 
  signal G_3355 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_13_Q : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_25_Q : STD_LOGIC; 
  signal G_3447 : STD_LOGIC; 
  signal N_3294_I : STD_LOGIC; 
  signal G_3536 : STD_LOGIC; 
  signal CHECK_CRC_CALC_8_Q : STD_LOGIC; 
  signal G_3645 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_14_Q : STD_LOGIC; 
  signal DATA_STORE_6_4_Q : STD_LOGIC; 
  signal CHECK_CRC_CALC_12_Q : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_2_0_SX_25_Q : STD_LOGIC; 
  signal N_3299 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_19_Q : STD_LOGIC; 
  signal N_3455 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_0_Q : STD_LOGIC; 
  signal N_3009 : STD_LOGIC; 
  signal N_3833 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_I_I_27_Q : STD_LOGIC; 
  signal SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_0_S_4_Q : STD_LOGIC; 
  signal SOC : STD_LOGIC; 
  signal N_3009_1 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_3_Q : STD_LOGIC; 
  signal N_3417 : STD_LOGIC; 
  signal G_3654_S : STD_LOGIC; 
  signal N_1892_I : STD_LOGIC; 
  signal CHECK_CRC_CALC_6_Q : STD_LOGIC; 
  signal MATCH_MODID : STD_LOGIC; 
  signal N_3435 : STD_LOGIC; 
  signal CHECK_CRC_CALC_15_Q : STD_LOGIC; 
  signal G_3276 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_22_Q : STD_LOGIC; 
  signal N_3405 : STD_LOGIC; 
  signal N_3404 : STD_LOGIC; 
  signal N_4755_2 : STD_LOGIC; 
  signal N_3118 : STD_LOGIC; 
  signal N_4755_I : STD_LOGIC; 
  signal N_3152 : STD_LOGIC; 
  signal DATA_STORE_6_2_Q : STD_LOGIC; 
  signal DATA_STORE_6_1_Q : STD_LOGIC; 
  signal DATA_STORE_6_0_Q : STD_LOGIC; 
  signal DATA_STORE_6_6_Q : STD_LOGIC; 
  signal G_2944 : STD_LOGIC; 
  signal G_2962 : STD_LOGIC; 
  signal N_3674_REP1 : STD_LOGIC; 
  signal G_2959 : STD_LOGIC; 
  signal G_2949 : STD_LOGIC; 
  signal G_2960 : STD_LOGIC; 
  signal G_2956 : STD_LOGIC; 
  signal G_2958 : STD_LOGIC; 
  signal G_2964 : STD_LOGIC; 
  signal G_2963 : STD_LOGIC; 
  signal G_2946 : STD_LOGIC; 
  signal G_2943 : STD_LOGIC; 
  signal G_2957 : STD_LOGIC; 
  signal G_2951 : STD_LOGIC; 
  signal G_2948 : STD_LOGIC; 
  signal G_2961 : STD_LOGIC; 
  signal G_2947 : STD_LOGIC; 
  signal N_3674 : STD_LOGIC; 
  signal G_2955 : STD_LOGIC; 
  signal G_2952 : STD_LOGIC; 
  signal G_2940 : STD_LOGIC; 
  signal G_2945 : STD_LOGIC; 
  signal G_2942 : STD_LOGIC; 
  signal G_2966 : STD_LOGIC; 
  signal G_2953 : STD_LOGIC; 
  signal G_2965 : STD_LOGIC; 
  signal G_2950 : STD_LOGIC; 
  signal G_2939 : STD_LOGIC; 
  signal G_2941 : STD_LOGIC; 
  signal G_2954 : STD_LOGIC; 
  signal UN1_STATE_1_0_AND2 : STD_LOGIC; 
  signal N_2575 : STD_LOGIC; 
  signal UN1_STATE_6_0_AND2 : STD_LOGIC; 
  signal UN1_STATE_7_0_AND2 : STD_LOGIC; 
  signal UN1_STATE_2_0_AND2 : STD_LOGIC; 
  signal UN1_STATE_3_1_AND2 : STD_LOGIC; 
  signal N_2580 : STD_LOGIC; 
  signal UN1_STATE_0_AND2 : STD_LOGIC; 
  signal N_3154 : STD_LOGIC; 
  signal UN1_STATE_4_0_AND2 : STD_LOGIC; 
  signal UN1_STATE_5_0_AND2 : STD_LOGIC; 
  signal N_882_1 : STD_LOGIC; 
  signal N_3431 : STD_LOGIC; 
  signal RESET_L_I : STD_LOGIC; 
  signal G_2952_AM : STD_LOGIC; 
  signal G_2942_AM : STD_LOGIC; 
  signal G_2957_AM : STD_LOGIC; 
  signal G_2953_AM : STD_LOGIC; 
  signal G_2940_AM : STD_LOGIC; 
  signal G_2956_AM : STD_LOGIC; 
  signal G_2958_AM : STD_LOGIC; 
  signal G_2944_AM : STD_LOGIC; 
  signal G_2965_AM : STD_LOGIC; 
  signal G_2955_AM : STD_LOGIC; 
  signal G_2954_AM : STD_LOGIC; 
  signal G_2943_AM : STD_LOGIC; 
  signal G_2966_AM : STD_LOGIC; 
  signal G_2951_AM : STD_LOGIC; 
  signal G_2939_AM : STD_LOGIC; 
  signal G_2945_AM : STD_LOGIC; 
  signal G_2963_AM : STD_LOGIC; 
  signal G_2947_AM : STD_LOGIC; 
  signal G_2946_AM : STD_LOGIC; 
  signal G_2960_AM : STD_LOGIC; 
  signal G_2959_AM : STD_LOGIC; 
  signal G_2961_AM : STD_LOGIC; 
  signal G_2941_AM : STD_LOGIC; 
  signal G_2964_AM : STD_LOGIC; 
  signal G_2948_AM : STD_LOGIC; 
  signal G_2949_AM : STD_LOGIC; 
  signal G_2962_AM : STD_LOGIC; 
  signal G_2950_AM : STD_LOGIC; 
  signal G_2956_BM : STD_LOGIC; 
  signal G_2957_BM : STD_LOGIC; 
  signal G_2942_BM : STD_LOGIC; 
  signal G_2965_BM : STD_LOGIC; 
  signal G_2941_BM : STD_LOGIC; 
  signal G_2953_BM : STD_LOGIC; 
  signal G_2958_BM : STD_LOGIC; 
  signal G_2943_BM : STD_LOGIC; 
  signal G_2955_BM : STD_LOGIC; 
  signal G_2951_BM : STD_LOGIC; 
  signal G_2945_BM : STD_LOGIC; 
  signal G_2966_BM : STD_LOGIC; 
  signal G_2950_BM : STD_LOGIC; 
  signal G_2961_BM : STD_LOGIC; 
  signal G_2952_BM : STD_LOGIC; 
  signal G_2954_BM : STD_LOGIC; 
  signal G_2962_BM : STD_LOGIC; 
  signal G_2960_BM : STD_LOGIC; 
  signal G_2946_BM : STD_LOGIC; 
  signal G_2963_BM : STD_LOGIC; 
  signal G_2940_BM : STD_LOGIC; 
  signal G_2944_BM : STD_LOGIC; 
  signal G_2949_BM : STD_LOGIC; 
  signal G_2939_BM : STD_LOGIC; 
  signal G_2959_BM : STD_LOGIC; 
  signal G_2948_BM : STD_LOGIC; 
  signal G_2964_BM : STD_LOGIC; 
  signal G_2947_BM : STD_LOGIC; 
  signal N_2914 : STD_LOGIC; 
  signal SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_0_S_3_Q : STD_LOGIC; 
  signal SEL_REGVPIVCI_VALID_02_1_IV_0_0_AND2_0_S : STD_LOGIC; 
  signal DATA_STORE_2_5_Q : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_23_Q : STD_LOGIC; 
  signal N_3793 : STD_LOGIC; 
  signal CHECK_CRC_CALC_2_Q : STD_LOGIC; 
  signal DATA_STORE_6_5_Q : STD_LOGIC; 
  signal DATA_STORE_6_3_Q : STD_LOGIC; 
  signal N_3821 : STD_LOGIC; 
  signal DATA_STORE_2_4_Q : STD_LOGIC; 
  signal N_2994 : STD_LOGIC; 
  signal N_2991 : STD_LOGIC; 
  signal G_1 : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_31_Q : STD_LOGIC; 
  signal G_3620 : STD_LOGIC; 
  signal DATA_STORE_4_31_Q : STD_LOGIC; 
  signal CHECK_CRC_CALC_10_Q : STD_LOGIC; 
  signal DATA_STORE_4_7_Q : STD_LOGIC; 
  signal N_3812 : STD_LOGIC; 
  signal N_3728 : STD_LOGIC; 
  signal DATA_STORE_2_3_Q : STD_LOGIC; 
  signal N_3823 : STD_LOGIC; 
  signal DATA_STORE_2_31_Q : STD_LOGIC; 
  signal SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_2_S_3_Q : STD_LOGIC; 
  signal SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_2_S_4_Q : STD_LOGIC; 
  signal CHECK_CRC_CALC_1_Q : STD_LOGIC; 
  signal DATA_STORE_2_7_Q : STD_LOGIC; 
  signal N_3815 : STD_LOGIC; 
  signal N_2855 : STD_LOGIC; 
  signal G_3622 : STD_LOGIC; 
  signal CHECK_CRC_CALC_9_Q : STD_LOGIC; 
  signal CHECK_CRC_CALC_7_Q : STD_LOGIC; 
  signal CRC_OK : STD_LOGIC; 
  signal CHECK_CRC_CALC_11_Q : STD_LOGIC; 
  signal N_3802 : STD_LOGIC; 
  signal G_3530 : STD_LOGIC; 
  signal SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_2_S_5_Q : STD_LOGIC; 
  signal SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_0_S_7_Q : STD_LOGIC; 
  signal SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_0_S_5_Q : STD_LOGIC; 
  signal N_3343 : STD_LOGIC; 
  signal DATA_STORE_4_5_Q : STD_LOGIC; 
  signal DATA_STORE_6_31_Q : STD_LOGIC; 
  signal DATA_STORE_4_3_Q : STD_LOGIC; 
  signal G_3640 : STD_LOGIC; 
  signal G_3593 : STD_LOGIC; 
  signal G_3666 : STD_LOGIC; 
  signal N_3805 : STD_LOGIC; 
  signal SEL_REGVPIVCI_VALID_02_1_IV_0_0_AND2_2_S : STD_LOGIC; 
  signal G_3533 : STD_LOGIC; 
  signal SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_2_S_7_Q : STD_LOGIC; 
  signal N_3409 : STD_LOGIC; 
  signal DATA_STORE_6_7_Q : STD_LOGIC; 
  signal N_2584 : STD_LOGIC; 
  signal DATA_STORE_4_4_Q : STD_LOGIC; 
  signal G_3597 : STD_LOGIC; 
  signal DATA_STORE_0_4_Q : STD_LOGIC; 
  signal DATA_STORE_0_5_Q : STD_LOGIC; 
  signal N_3796 : STD_LOGIC; 
  signal G_3537 : STD_LOGIC; 
  signal CHECK_CRC_CALC_5_Q : STD_LOGIC; 
  signal DATA_STORE_0_31_Q : STD_LOGIC; 
  signal G_3543 : STD_LOGIC; 
  signal N_3428 : STD_LOGIC; 
  signal DATA_STORE_0_7_Q : STD_LOGIC; 
  signal DATA_STORE_0_3_Q : STD_LOGIC; 
  signal N_4764_4 : STD_LOGIC; 
  signal CHECK_CRC_CALC_4_Q : STD_LOGIC; 
  signal CHECK_CRC_CALC_3_Q : STD_LOGIC; 
  signal CHECK_CRC_CALC_0_Q : STD_LOGIC; 
  signal CHECK_CRC_CALC_14_Q : STD_LOGIC; 
  signal G_3661 : STD_LOGIC; 
  signal G_3660 : STD_LOGIC; 
  signal G_3668 : STD_LOGIC; 
  signal G_3662 : STD_LOGIC; 
  signal N_4766_11 : STD_LOGIC; 
  signal G_3659 : STD_LOGIC; 
  signal N_4766_10 : STD_LOGIC; 
  signal N_4766_8 : STD_LOGIC; 
  signal N_4766_9 : STD_LOGIC; 
  signal N_4760_1 : STD_LOGIC; 
  signal NGD2VHDL_OI71 : STD_LOGIC; 
  signal NGD2VHDL_OI4 : STD_LOGIC; 
  signal DATA_STORE_2_6_Q : STD_LOGIC; 
  signal N_2551_I : STD_LOGIC; 
  signal N_2550_I : STD_LOGIC; 
  signal G_3665 : STD_LOGIC; 
  signal DATA_STORE_2_0_Q : STD_LOGIC; 
  signal N_2552_I : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_I_I_15_Q : STD_LOGIC; 
  signal DATA_STORE_2_2_Q : STD_LOGIC; 
  signal DATA_STORE_2_1_Q : STD_LOGIC; 
  signal DATA00_OUT_DATA_00_2_I_I_7_Q : STD_LOGIC; 
  signal N_3691 : STD_LOGIC; 
  signal G_3663 : STD_LOGIC; 
  signal N_4762_I : STD_LOGIC; 
  signal N_3693 : STD_LOGIC; 
  signal N_4754_I : STD_LOGIC; 
  signal CC_SEL_CRC_DELAY : STD_LOGIC; 
  signal SOC_CC : STD_LOGIC; 
  signal SOC_CC_M : STD_LOGIC; 
  signal ENABLE_IN : STD_LOGIC; 
  signal NGD2VHDL_OI74 : STD_LOGIC; 
  signal SOC_IN : STD_LOGIC; 
  signal NGD2VHDL_OI73 : STD_LOGIC; 
  signal NGD2VHDL_OI72 : STD_LOGIC; 
  signal SOC_M : STD_LOGIC; 
  signal CC_SEL_CRC : STD_LOGIC; 
  signal CMUX_FULL_BYPASS : STD_LOGIC; 
  signal GND_INT : STD_LOGIC; 
  signal VCC_INT : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_11_G_3582_O : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_12_G_3570_O : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_13_G_3580_O : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_14_G_3592_O : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_15_G_3579_O : STD_LOGIC; 
  signal DATA04_OUT_DATA_04_2_0_IV_0_0_30_G_3619_O : STD_LOGIC; 
  signal DISPATCH_UN8_SOC_0_I_2_O : STD_LOGIC; 
  signal DISPATCH_UN8_SOC_0_I_11_O : STD_LOGIC; 
  signal DISPATCH_UN8_SOC_0_I_20_O : STD_LOGIC; 
  signal DISPATCH_UN8_SOC_0_I_29_O : STD_LOGIC; 
  signal DISPATCH_UN8_SOC_0_I_38_O : STD_LOGIC; 
  signal DISPATCH_UN8_SOC_0_I_47_O : STD_LOGIC; 
  signal DISPATCH_UN8_SOC_0_I_56_O : STD_LOGIC; 
  signal DISPATCH_UN8_SOC_0_I_65_O : STD_LOGIC; 
  signal SEL_REGVPIVCI_REGNR_02_1_IV_0_0_0_G_3552_O : STD_LOGIC; 
  signal SEL_REGVPIVCI_REGNR_02_1_IV_0_0_1_G_3562_O : STD_LOGIC; 
  signal SEL_REGVPIVCI_REGNR_02_1_IV_0_0_2_G_3550_O : STD_LOGIC; 
  signal SEL_REGVPIVCI_REGNR_02_1_IV_0_0_6_G_3558_O : STD_LOGIC; 
  signal UN10_IS_CONTROL_CELL_0_I_2_O : STD_LOGIC; 
  signal UN10_IS_CONTROL_CELL_0_I_11_O : STD_LOGIC; 
  signal UN10_IS_CONTROL_CELL_0_I_20_O : STD_LOGIC; 
  signal UN10_IS_CONTROL_CELL_0_I_29_O : STD_LOGIC; 
  signal UN10_IS_CONTROL_CELL_0_I_38_O : STD_LOGIC; 
  signal UN10_IS_CONTROL_CELL_0_I_47_O : STD_LOGIC; 
  signal UN10_IS_CONTROL_CELL_0_I_56_O : STD_LOGIC; 
  signal UN10_IS_CONTROL_CELL_0_I_65_O : STD_LOGIC; 
  signal GSR : STD_LOGIC; 
  signal CHECK_HEC_PROC_V_HEC_1_I_0_Q : STD_LOGIC; 
  signal CHECK_G_3305 : STD_LOGIC; 
  signal CHECK_N_56 : STD_LOGIC; 
  signal CHECK_N_69 : STD_LOGIC; 
  signal CHECK_G_3316 : STD_LOGIC; 
  signal CHECK_N_59 : STD_LOGIC; 
  signal CHECK_G_3422 : STD_LOGIC; 
  signal CHECK_G_3400 : STD_LOGIC; 
  signal CHECK_N_54 : STD_LOGIC; 
  signal CHECK_HEC_CALC_5_Q : STD_LOGIC; 
  signal CHECK_HEC_PROC_V_HEC_1_I_6_Q : STD_LOGIC; 
  signal CHECK_G_3308 : STD_LOGIC; 
  signal CHECK_N_67 : STD_LOGIC; 
  signal CHECK_HEC_PROC_V_HEC_1_I_4_Q : STD_LOGIC; 
  signal CHECK_G_3395 : STD_LOGIC; 
  signal CHECK_N_62 : STD_LOGIC; 
  signal CHECK_HEC_CALC_3_Q : STD_LOGIC; 
  signal CHECK_HEC_PROC_V_HEC_1_I_2_Q : STD_LOGIC; 
  signal CHECK_N_63 : STD_LOGIC; 
  signal CHECK_N_70 : STD_LOGIC; 
  signal CHECK_HEC_CALC_1_Q : STD_LOGIC; 
  signal CHECK_HEC_CALC_7_Q : STD_LOGIC; 
  signal CHECK_N_58 : STD_LOGIC; 
  signal CHECK_N_65 : STD_LOGIC; 
  signal CHECK_G_3278 : STD_LOGIC; 
  signal CHECK_OUT_PROC_UN6_SOC_OUT_NE : STD_LOGIC; 
  signal CHECK_G_3280 : STD_LOGIC; 
  signal CHECK_G_3279 : STD_LOGIC; 
  signal CHECK_G_3277 : STD_LOGIC; 
  signal CHECK_G_3312 : STD_LOGIC; 
  signal CHECK_N_71 : STD_LOGIC; 
  signal CHECK_G_3404 : STD_LOGIC; 
  signal CHECK_N_72 : STD_LOGIC; 
  signal CHECK_N_64 : STD_LOGIC; 
  signal CHECK_G_3416 : STD_LOGIC; 
  signal CHECK_N_66 : STD_LOGIC; 
  signal CHECK_N_68 : STD_LOGIC; 
  signal CHECK_G_3410 : STD_LOGIC; 
  signal CHECK_G_3306 : STD_LOGIC; 
  signal CHECK_G_3411 : STD_LOGIC; 
  signal CHECK_G_3405 : STD_LOGIC; 
  signal CHECK_G_3417 : STD_LOGIC; 
  signal CHECK_SOC_OUT_I : STD_LOGIC; 
  signal CHECK_SOC_OUT : STD_LOGIC; 
  signal CHECK_SOC_IN : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_137 : STD_LOGIC; 
  signal CHECK_CRC_GEN_CRC_L_6_Q : STD_LOGIC; 
  signal CHECK_CRC_GEN_CRC_L_1_Q : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_155_0 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_171_0 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_139_0 : STD_LOGIC; 
  signal CHECK_CRC_GEN_CRC_L_M_4_Q : STD_LOGIC; 
  signal CHECK_CRC_GEN_CRC_L_M_14_Q : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_151_0 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_158 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3445 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3467 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3469 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3479 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3480 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3496 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_162 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_140_0 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3513 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3515 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_134_0 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3518 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3520 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3528 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_156 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3529 : STD_LOGIC; 
  signal CHECK_CRC_GEN_N_4_1 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_141_0 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3273 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3498 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3505 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3345 : STD_LOGIC; 
  signal CHECK_CRC_GEN_N_52 : STD_LOGIC; 
  signal CHECK_CRC_GEN_N_53 : STD_LOGIC; 
  signal CHECK_CRC_GEN_CRC16_OUT_1_0_AND2_I_7_Q : STD_LOGIC; 
  signal CHECK_CRC_GEN_N_48 : STD_LOGIC; 
  signal CHECK_CRC_GEN_N_46 : STD_LOGIC; 
  signal CHECK_CRC_GEN_CRC_L_12_Q : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3356 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_143 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3516 : STD_LOGIC; 
  signal CHECK_CRC_GEN_N_54 : STD_LOGIC; 
  signal CHECK_CRC_GEN_CRC_L_10_Q : STD_LOGIC; 
  signal CHECK_CRC_GEN_N_51 : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3486 : STD_LOGIC; 
  signal CHECK_CRC_GEN_CRC16_OUT_1_0_AND2_I_15_Q : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_135 : STD_LOGIC; 
  signal CHECK_CRC_GEN_CRC_L_13_Q : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_3500 : STD_LOGIC; 
  signal CHECK_CRC_GEN_N_87_I : STD_LOGIC; 
  signal CHECK_CRC_GEN_N_86_I : STD_LOGIC; 
  signal CHECK_CRC_GEN_G_150_0 : STD_LOGIC; 
  signal CHECK_CRC_GEN_GEN_CRC_L_G_3262 : STD_LOGIC; 
  signal CMUX_OUTPUT_UN4_STATE : STD_LOGIC; 
  signal CMUX_OUTPUT_UN5_STATE : STD_LOGIC; 
  signal CMUX_N_133_1 : STD_LOGIC; 
  signal CMUX_SOC_OUT : STD_LOGIC; 
  signal CMUX_UN1_UN1_UN5_STATE_I : STD_LOGIC; 
  signal CMUX_OUTPUT_UN24_TMP_STATE : STD_LOGIC; 
  signal CMUX_OUTPUT_UN22_TMP_STATE : STD_LOGIC; 
  signal CMUX_OUTPUT_UN20_TMP_STATE : STD_LOGIC; 
  signal CMUX_NX_STATE_SS0 : STD_LOGIC; 
  signal CMUX_N_57_1 : STD_LOGIC; 
  signal CMUX_N_85 : STD_LOGIC; 
  signal CMUX_N_77 : STD_LOGIC; 
  signal CMUX_N_83 : STD_LOGIC; 
  signal CMUX_N_73 : STD_LOGIC; 
  signal CMUX_N_74 : STD_LOGIC; 
  signal CMUX_N_87 : STD_LOGIC; 
  signal CMUX_N_86 : STD_LOGIC; 
  signal CMUX_N_72 : STD_LOGIC; 
  signal CMUX_N_71 : STD_LOGIC; 
  signal CMUX_N_90 : STD_LOGIC; 
  signal CMUX_N_69 : STD_LOGIC; 
  signal CMUX_N_97 : STD_LOGIC; 
  signal CMUX_N_78 : STD_LOGIC; 
  signal CMUX_N_95 : STD_LOGIC; 
  signal CMUX_N_70 : STD_LOGIC; 
  signal CMUX_N_75 : STD_LOGIC; 
  signal CMUX_N_92 : STD_LOGIC; 
  signal CMUX_N_89 : STD_LOGIC; 
  signal CMUX_N_88 : STD_LOGIC; 
  signal CMUX_N_84 : STD_LOGIC; 
  signal CMUX_N_82 : STD_LOGIC; 
  signal CMUX_N_80 : STD_LOGIC; 
  signal CMUX_N_79 : STD_LOGIC; 
  signal CMUX_N_76 : STD_LOGIC; 
  signal CMUX_N_94 : STD_LOGIC; 
  signal CMUX_N_68 : STD_LOGIC; 
  signal CMUX_N_96 : STD_LOGIC; 
  signal CMUX_N_66 : STD_LOGIC; 
  signal CMUX_N_93 : STD_LOGIC; 
  signal CMUX_N_91 : STD_LOGIC; 
  signal CMUX_N_81 : STD_LOGIC; 
  signal CMUX_N_67 : STD_LOGIC; 
  signal CMUX_SOC_APPL_IN : STD_LOGIC; 
  signal CMUX_SOC_CTRL_IN : STD_LOGIC; 
  signal CMUX_SOC_BP_IN : STD_LOGIC; 
  signal CMUX_N_131 : STD_LOGIC; 
  signal CMUX_N_133 : STD_LOGIC; 
  signal CMUX_N_132 : STD_LOGIC; 
  signal CMUX_N_31_I_0 : STD_LOGIC; 
  signal CMUX_N_31_I : STD_LOGIC; 
  signal CMUX_N_31_I_1 : STD_LOGIC; 
  signal CMUX_EMPTY_BYPASS : STD_LOGIC; 
  signal CMUX_UN1_UN1_EMPTY_APPL : STD_LOGIC; 
  signal CMUX_EMPTY_CTRL : STD_LOGIC; 
  signal CMUX_EMPTY_APPL : STD_LOGIC; 
  signal CMUX_FIFO_RES : STD_LOGIC; 
  signal CMUX_FULL_APPL : STD_LOGIC; 
  signal CMUX_APPL_IN_N_13 : STD_LOGIC; 
  signal CMUX_APPL_IN_G_3212 : STD_LOGIC; 
  signal CMUX_APPL_IN_N_20_1 : STD_LOGIC; 
  signal CMUX_APPL_IN_N_37_I : STD_LOGIC; 
  signal CMUX_APPL_IN_N_38_I : STD_LOGIC; 
  signal CMUX_APPL_IN_N_39_I : STD_LOGIC; 
  signal CMUX_BYPASS_IN_N_13 : STD_LOGIC; 
  signal CMUX_BYPASS_IN_G_3209 : STD_LOGIC; 
  signal CMUX_BYPASS_IN_N_20_1 : STD_LOGIC; 
  signal CMUX_BYPASS_IN_N_37_I : STD_LOGIC; 
  signal CMUX_BYPASS_IN_N_38_I : STD_LOGIC; 
  signal CMUX_BYPASS_IN_N_39_I : STD_LOGIC; 
  signal CMUX_CTRLCELL_IN_N_13 : STD_LOGIC; 
  signal CMUX_CTRLCELL_IN_G_3214 : STD_LOGIC; 
  signal CMUX_CTRLCELL_IN_N_20_1 : STD_LOGIC; 
  signal CMUX_CTRLCELL_IN_N_37_I : STD_LOGIC; 
  signal CMUX_CTRLCELL_IN_N_38_I : STD_LOGIC; 
  signal CMUX_CTRLCELL_IN_N_39_I : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2818 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4027 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3589 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3573 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3559 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2742 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3951 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3543 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3529 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2304 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3513 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2288 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3499 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2147483644 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2274 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2147483641 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3483 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2666 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2258 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1844 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N216 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1843 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1842 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N214 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3469 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1841 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3875 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1840 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3061 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N212 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1839 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N211 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3059 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1838 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N210 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N209 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2244 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3057 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N208 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N207 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N206 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3054 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3053 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N204 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3052 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N203 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3051 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N202 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3050 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N201 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3049 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1828 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N200 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3048 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1827 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N199 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1826 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N198 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3453 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1825 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3046 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1824 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3045 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1823 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3044 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1822 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3043 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3042 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2228 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3041 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3040 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4255 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3439 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2214 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3423 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2198 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1788 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1787 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1786 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1785 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1784 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1783 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1782 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3409 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1780 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1779 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3407 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1778 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3406 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1777 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3405 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2184 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1776 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3404 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2590 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1775 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3403 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1774 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3402 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3401 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N3799 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1764 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1763 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1762 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1761 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2168 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1760 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1759 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1758 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2970 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2154 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4179 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2138 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2124 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2122 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1714 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2121 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2120 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2119 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2118 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N1710 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2117 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2116 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2514 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N2894 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4103 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4504 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4502 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4500 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4497 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4496 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4495 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4494 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4493 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4492 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4491 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4489 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4488 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4487 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4486 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4485 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4484 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_N4483 : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU46_S : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU46_LO : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU46_O : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU49_LO : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU49_O : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU70_O : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU125_S : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU125_LO : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU125_O : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU128_LO : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU128_O : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU149_O : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU7_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU11_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU15_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU19_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU23_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU27_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU30_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU32_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU34_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU36_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU38_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU40_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU42_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU44_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU47_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU50_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU56_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU59_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU62_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU65_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU68_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU73_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU79_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU83_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU87_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU91_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU95_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU99_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU102_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU104_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU106_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU108_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU110_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU112_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU114_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU116_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU117_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU118_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU119_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU120_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU121_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU122_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU123_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU126_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU129_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU135_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU138_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU141_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU144_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU147_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_APPL_BU152_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2818 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4027 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3589 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3573 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3559 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2742 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3951 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3543 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3529 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2304 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3513 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2288 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3499 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2147483644 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2274 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2147483641 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3483 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2666 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2258 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1844 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N216 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1843 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1842 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N214 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3469 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1841 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3875 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1840 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3061 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N212 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1839 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N211 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3059 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1838 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N210 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N209 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2244 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3057 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N208 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N207 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N206 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3054 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3053 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N204 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3052 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N203 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3051 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N202 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3050 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N201 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3049 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1828 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N200 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3048 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1827 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N199 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1826 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N198 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3453 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1825 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3046 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1824 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3045 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1823 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3044 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1822 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3043 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3042 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2228 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3041 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3040 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4255 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3439 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2214 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3423 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2198 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1788 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1787 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1786 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1785 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1784 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1783 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1782 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3409 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1780 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1779 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3407 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1778 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3406 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1777 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3405 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2184 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1776 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3404 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2590 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1775 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3403 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1774 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3402 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3401 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N3799 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1764 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1763 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1762 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1761 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2168 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1760 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1759 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1758 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2970 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2154 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4179 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2138 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2124 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2122 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1714 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2121 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2120 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2119 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2118 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N1710 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2117 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2116 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2514 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N2894 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4103 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4504 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4502 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4500 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4497 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4496 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4495 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4494 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4493 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4492 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4491 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4489 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4488 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4487 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4486 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4485 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4484 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_N4483 : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU46_S : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU46_LO : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU46_O : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU49_LO : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU49_O : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU70_O : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU125_S : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU125_LO : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU125_O : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU128_LO : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU128_O : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU149_O : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU7_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU11_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU15_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU19_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU23_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU27_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU30_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU32_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU34_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU36_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU38_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU40_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU42_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU44_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU47_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU50_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU56_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU59_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU62_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU65_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU68_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU73_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU79_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU83_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU87_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU91_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU95_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU99_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU102_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU104_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU106_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU108_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU110_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU112_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU114_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU116_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU117_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU118_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU119_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU120_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU121_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU122_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU123_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU126_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU129_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU135_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU138_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU141_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU144_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU147_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_BYPASS_BU152_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2032 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2031 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2030 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2029 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2827 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2825 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2823 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2007 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2006 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2820 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2005 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2819 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2004 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2818 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2817 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2002 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2001 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2815 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2000 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2814 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1999 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2813 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2812 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1992 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1991 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1990 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1989 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3184 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3583 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1951 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2355 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3168 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1947 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2754 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3154 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2339 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2325 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3138 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3124 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2309 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2295 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3108 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3507 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3094 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2279 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3092 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3091 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3090 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3089 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2147483644 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2147483641 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2678 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2265 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2263 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2262 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2261 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2260 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1024 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N210 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1023 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1022 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N208 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1021 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1020 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N206 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1019 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N205 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1018 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N204 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1017 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N203 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1016 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1015 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N201 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1014 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N200 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1013 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N199 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N198 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1012 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1011 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1010 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1009 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1008 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1007 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1006 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1005 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1004 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1003 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1002 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1001 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N1000 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N999 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N998 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N997 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N996 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N995 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N994 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N993 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N991 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N990 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_FULL : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3431 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N989 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N988 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N987 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N986 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N985 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N984 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N983 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N982 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N981 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N980 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N979 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N978 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N977 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N976 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N975 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2602 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N974 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N973 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N972 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N971 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N970 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N969 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N968 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N967 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N966 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N965 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N964 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N963 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N962 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N961 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N960 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3355 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3754 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3752 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3750 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3747 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2526 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3746 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3745 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3744 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3742 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3741 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3740 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N3739 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2042 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2041 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2040 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_N2039 : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU122_S : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU122_LO : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU122_O : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU125_LO : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU125_O : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU137_O : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU171_S : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU171_LO : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU171_O : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU174_LO : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU174_O : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU186_O : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU101_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU105_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU109_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU112_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU114_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU116_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU118_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU120_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU123_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU126_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU132_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU135_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU140_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU146_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU150_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU154_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU157_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU159_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU161_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU163_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU165_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU166_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU167_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU168_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU169_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU172_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU175_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU181_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU184_GSR_OR : STD_LOGIC; 
  signal CMUX_FIFO_CTRLCELL_BU189_GSR_OR : STD_LOGIC; 
  signal CRC_GEN_CRC_H_0_Q : STD_LOGIC; 
  signal CRC_GEN_G_151 : STD_LOGIC; 
  signal CRC_GEN_CRC16_OUT_1_0_AND2_I_7_Q : STD_LOGIC; 
  signal CRC_GEN_G_3435 : STD_LOGIC; 
  signal CRC_GEN_G_139 : STD_LOGIC; 
  signal CRC_GEN_CRC_L_0_Q : STD_LOGIC; 
  signal CRC_GEN_CRC_L_1_Q : STD_LOGIC; 
  signal CRC_GEN_CRC_L_6_Q : STD_LOGIC; 
  signal CRC_GEN_G_3510 : STD_LOGIC; 
  signal CRC_GEN_G_3462 : STD_LOGIC; 
  signal CRC_GEN_G_3490 : STD_LOGIC; 
  signal CRC_GEN_G_155 : STD_LOGIC; 
  signal CRC_GEN_G_3484 : STD_LOGIC; 
  signal CRC_GEN_G_3526 : STD_LOGIC; 
  signal CRC_GEN_G_3494 : STD_LOGIC; 
  signal CRC_GEN_G_141 : STD_LOGIC; 
  signal CRC_GEN_G_3431 : STD_LOGIC; 
  signal CRC_GEN_G_3453 : STD_LOGIC; 
  signal CRC_GEN_G_3482 : STD_LOGIC; 
  signal CRC_GEN_G_3439 : STD_LOGIC; 
  signal CRC_GEN_G_3465 : STD_LOGIC; 
  signal CRC_GEN_CRC_L_12_Q : STD_LOGIC; 
  signal CRC_GEN_G_3472 : STD_LOGIC; 
  signal CRC_GEN_CRC_L_2_Q : STD_LOGIC; 
  signal CRC_GEN_CRC_H_4_Q : STD_LOGIC; 
  signal CRC_GEN_G_3495 : STD_LOGIC; 
  signal CRC_GEN_G_3525 : STD_LOGIC; 
  signal CRC_GEN_CRC_L_10_Q : STD_LOGIC; 
  signal CRC_GEN_CRC_L_11_Q : STD_LOGIC; 
  signal CRC_GEN_G_171 : STD_LOGIC; 
  signal CRC_GEN_G_169 : STD_LOGIC; 
  signal CRC_GEN_N_54 : STD_LOGIC; 
  signal CRC_GEN_G_134 : STD_LOGIC; 
  signal CRC_GEN_N_52 : STD_LOGIC; 
  signal CRC_GEN_N_50 : STD_LOGIC; 
  signal CRC_GEN_G_3474 : STD_LOGIC; 
  signal CRC_GEN_G_3475 : STD_LOGIC; 
  signal CRC_GEN_G_140 : STD_LOGIC; 
  signal CRC_GEN_N_4_1 : STD_LOGIC; 
  signal CRC_GEN_N_53 : STD_LOGIC; 
  signal CRC_GEN_G_152 : STD_LOGIC; 
  signal CRC_GEN_CRC16_OUT_1_0_AND2_I_15_Q : STD_LOGIC; 
  signal CRC_GEN_CRC_L_13_Q : STD_LOGIC; 
  signal CRC_GEN_G_3507 : STD_LOGIC; 
  signal CRC_GEN_N_86_I : STD_LOGIC; 
  signal CRC_GEN_N_87_I : STD_LOGIC; 
  signal CRC_GEN_G_150 : STD_LOGIC; 
  signal CRC_GEN_GEN_CRC_H_N_51 : STD_LOGIC; 
  signal CRC_GEN_GEN_CRC_L_G_3351 : STD_LOGIC; 
  signal CRC_GEN_GEN_CRC_L_G_3317 : STD_LOGIC; 
  signal CRC_GEN_GEN_CRC_L_G_3318 : STD_LOGIC; 
  signal CRC_GEN_GEN_CRC_L_G_3234 : STD_LOGIC; 
  signal CRC_GEN_GEN_CRC_L_G_3320 : STD_LOGIC; 
  signal HEC_SET_G_3298 : STD_LOGIC; 
  signal HEC_SET_G_3300 : STD_LOGIC; 
  signal HEC_SET_G_3360 : STD_LOGIC; 
  signal HEC_SET_G_3362 : STD_LOGIC; 
  signal HEC_SET_G_116 : STD_LOGIC; 
  signal HEC_SET_HEC_CALC_5_Q : STD_LOGIC; 
  signal HEC_SET_HEC_CALC_1_Q : STD_LOGIC; 
  signal HEC_SET_G_113 : STD_LOGIC; 
  signal HEC_SET_G_3384 : STD_LOGIC; 
  signal HEC_SET_HEC_PROC_V_HEC_1_I_4_Q : STD_LOGIC; 
  signal HEC_SET_G_107 : STD_LOGIC; 
  signal HEC_SET_G_3291 : STD_LOGIC; 
  signal HEC_SET_N_47 : STD_LOGIC; 
  signal HEC_SET_G_3288 : STD_LOGIC; 
  signal HEC_SET_N_46 : STD_LOGIC; 
  signal HEC_SET_HEC_CALC_3_Q : STD_LOGIC; 
  signal HEC_SET_HEC_CALC_7_Q : STD_LOGIC; 
  signal HEC_SET_HEC_PROC_V_HEC_1_I_2_Q : STD_LOGIC; 
  signal HEC_SET_G_108 : STD_LOGIC; 
  signal HEC_SET_HEC_PROC_V_HEC_1_I_0_Q : STD_LOGIC; 
  signal HEC_SET_G_118 : STD_LOGIC; 
  signal HEC_SET_N_43 : STD_LOGIC; 
  signal HEC_SET_G_3377 : STD_LOGIC; 
  signal HEC_SET_HEC_PROC_V_HEC_1_I_6_Q : STD_LOGIC; 
  signal HEC_SET_G_3388 : STD_LOGIC; 
  signal HEC_SET_G_3366 : STD_LOGIC; 
  signal HEC_SET_G_3367 : STD_LOGIC; 
  signal HEC_SET_G_3290 : STD_LOGIC; 
  signal HEC_SET_G_3372 : STD_LOGIC; 
  signal HEC_SET_G_3376 : STD_LOGIC; 
  signal HEC_SET_G_117 : STD_LOGIC; 
  signal HEC_SET_G_110 : STD_LOGIC; 
  signal HEC_SET_G_3296 : STD_LOGIC; 
  signal HEC_SET_G_3373 : STD_LOGIC; 
  signal HEC_SET_G_120 : STD_LOGIC; 
  signal HEC_SET_G_122 : STD_LOGIC; 
  signal HEC_SET_G_121 : STD_LOGIC; 
  signal HEC_SET_G_119 : STD_LOGIC; 
  signal HEC_SET_G_124 : STD_LOGIC; 
  signal HEC_SET_G_123 : STD_LOGIC; 
  signal HEC_SET_G_125 : STD_LOGIC; 
  signal HEC_SET_G_126 : STD_LOGIC; 
  signal HEC_SET_SOC_IN : STD_LOGIC; 
  signal STATE00_H_N_3006_I : STD_LOGIC; 
  signal STATE00_H_N_1816_I : STD_LOGIC; 
  signal STATE00_H_G_3392 : STD_LOGIC; 
  signal STATE02_H_N_2978 : STD_LOGIC; 
  signal STATE02_H_G_3456 : STD_LOGIC; 
  signal STATE02_H_G_3440 : STD_LOGIC; 
  signal STATE02_H_G_3442 : STD_LOGIC; 
  signal STATE02_H_N_1410_I : STD_LOGIC; 
  signal STATE02_H_G_3458 : STD_LOGIC; 
  signal STATE04_H_N_2981 : STD_LOGIC; 
  signal STATE04_H_N_2100_I : STD_LOGIC; 
  signal STATE04_H_G_3352 : STD_LOGIC; 
  signal STATE04_H_N_1223_I : STD_LOGIC; 
  signal STATE_H_N_3430_I : STD_LOGIC; 
  signal STATE_H_N_2547_I : STD_LOGIC; 
  signal VCC : STD_LOGIC; 
  signal GND : STD_LOGIC; 
  signal NGD2VHDL_X_1752_22 : STD_LOGIC; 
  signal NGD2VHDL_X_1752_23 : STD_LOGIC; 
  signal NGD2VHDL_X_1752_24 : STD_LOGIC; 
  signal NGD2VHDL_X_1752_25 : STD_LOGIC; 
  signal NGD2VHDL_X_1752_26 : STD_LOGIC; 
  signal NGD2VHDL_X_1752_27 : STD_LOGIC; 
  signal NGD2VHDL_X_1752_28 : STD_LOGIC; 
  signal NGD2VHDL_X_1752_29 : STD_LOGIC; 
  signal NGD2VHDL_X_1752_30 : STD_LOGIC; 
  signal NGD2VHDL_X_1752_31 : STD_LOGIC; 
  signal NGD2VHDL_X_1752_32 : STD_LOGIC; 
  signal NGD2VHDL_X_1752_33 : STD_LOGIC; 
  signal NGD2VHDL_X_1752_34 : STD_LOGIC; 
  signal NGD2VHDL_X_1752_35 : STD_LOGIC; 
  signal NGD2VHDL_X_1752_36 : STD_LOGIC; 
  signal NGD2VHDL_X_1752_37 : STD_LOGIC; 
  signal NGD2VHDL_X_1753_22 : STD_LOGIC; 
  signal NGD2VHDL_X_1753_23 : STD_LOGIC; 
  signal NGD2VHDL_X_1753_24 : STD_LOGIC; 
  signal NGD2VHDL_X_1753_25 : STD_LOGIC; 
  signal NGD2VHDL_X_1753_26 : STD_LOGIC; 
  signal NGD2VHDL_X_1753_27 : STD_LOGIC; 
  signal NGD2VHDL_X_1753_28 : STD_LOGIC; 
  signal NGD2VHDL_X_1753_29 : STD_LOGIC; 
  signal NGD2VHDL_X_1753_30 : STD_LOGIC; 
  signal NGD2VHDL_X_1753_31 : STD_LOGIC; 
  signal NGD2VHDL_X_1753_32 : STD_LOGIC; 
  signal NGD2VHDL_X_1753_33 : STD_LOGIC; 
  signal NGD2VHDL_X_1753_34 : STD_LOGIC; 
  signal NGD2VHDL_X_1753_35 : STD_LOGIC; 
  signal NGD2VHDL_X_1753_36 : STD_LOGIC; 
  signal NGD2VHDL_X_1753_37 : STD_LOGIC; 
  signal NGD2VHDL_X_1805_5 : STD_LOGIC; 
  signal NGD2VHDL_X_1823_4 : STD_LOGIC; 
  signal NGD2VHDL_X_1884_5 : STD_LOGIC; 
  signal NGD2VHDL_X_1902_4 : STD_LOGIC; 
  signal NGD2VHDL_X_1919_22 : STD_LOGIC; 
  signal NGD2VHDL_X_1919_23 : STD_LOGIC; 
  signal NGD2VHDL_X_1919_24 : STD_LOGIC; 
  signal NGD2VHDL_X_1919_25 : STD_LOGIC; 
  signal NGD2VHDL_X_1919_26 : STD_LOGIC; 
  signal NGD2VHDL_X_1919_27 : STD_LOGIC; 
  signal NGD2VHDL_X_1919_28 : STD_LOGIC; 
  signal NGD2VHDL_X_1919_29 : STD_LOGIC; 
  signal NGD2VHDL_X_1919_30 : STD_LOGIC; 
  signal NGD2VHDL_X_1919_31 : STD_LOGIC; 
  signal NGD2VHDL_X_1919_32 : STD_LOGIC; 
  signal NGD2VHDL_X_1919_33 : STD_LOGIC; 
  signal NGD2VHDL_X_1919_34 : STD_LOGIC; 
  signal NGD2VHDL_X_1919_35 : STD_LOGIC; 
  signal NGD2VHDL_X_1919_36 : STD_LOGIC; 
  signal NGD2VHDL_X_1919_37 : STD_LOGIC; 
  signal NGD2VHDL_X_1920_22 : STD_LOGIC; 
  signal NGD2VHDL_X_1920_23 : STD_LOGIC; 
  signal NGD2VHDL_X_1920_24 : STD_LOGIC; 
  signal NGD2VHDL_X_1920_25 : STD_LOGIC; 
  signal NGD2VHDL_X_1920_26 : STD_LOGIC; 
  signal NGD2VHDL_X_1920_27 : STD_LOGIC; 
  signal NGD2VHDL_X_1920_28 : STD_LOGIC; 
  signal NGD2VHDL_X_1920_29 : STD_LOGIC; 
  signal NGD2VHDL_X_1920_30 : STD_LOGIC; 
  signal NGD2VHDL_X_1920_31 : STD_LOGIC; 
  signal NGD2VHDL_X_1920_32 : STD_LOGIC; 
  signal NGD2VHDL_X_1920_33 : STD_LOGIC; 
  signal NGD2VHDL_X_1920_34 : STD_LOGIC; 
  signal NGD2VHDL_X_1920_35 : STD_LOGIC; 
  signal NGD2VHDL_X_1920_36 : STD_LOGIC; 
  signal NGD2VHDL_X_1920_37 : STD_LOGIC; 
  signal NGD2VHDL_X_1972_5 : STD_LOGIC; 
  signal NGD2VHDL_X_1990_4 : STD_LOGIC; 
  signal NGD2VHDL_X_2051_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2069_4 : STD_LOGIC; 
  signal NGD2VHDL_X_2087_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2090_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2093_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2096_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2099_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2102_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2105_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2108_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2111_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2114_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2117_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2120_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2123_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2126_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2129_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2132_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2135_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2138_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2141_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2144_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2147_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2150_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2153_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2156_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2159_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2162_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2165_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2168_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2171_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2174_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2177_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2180_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2215_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2224_4 : STD_LOGIC; 
  signal NGD2VHDL_X_2264_5 : STD_LOGIC; 
  signal NGD2VHDL_X_2273_4 : STD_LOGIC; 
  signal UN10_IS_CONTROL_CELL_0_DATA_TMP : STD_LOGIC_VECTOR ( 6 downto 0 ); 
  signal CTRLCELL_VCI : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal DATA00_OUT_DATA_00_2_2_0_AND2_X0 : STD_LOGIC_VECTOR ( 21 downto 21 ); 
  signal STATE00 : STD_LOGIC_VECTOR ( 5 downto 0 ); 
  signal APPL_VCI : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal DISPATCH_UN8_SOC_0_DATA_TMP : STD_LOGIC_VECTOR ( 6 downto 0 ); 
  signal REGNR_02 : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal DATA04_OUT_DATA_04_2 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal REGNR_04 : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal GENCOUNT_FAST : STD_LOGIC_VECTOR ( 3 downto 0 ); 
  signal STATE00_FAST : STD_LOGIC_VECTOR ( 1 downto 1 ); 
  signal DATA00_OUT_DATA_00_2_2_0_AND2_4_SX : STD_LOGIC_VECTOR ( 20 downto 20 ); 
  signal CCOPCODE : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal DATA04_OUT_DATA_04_2_0_IV_0_X0 : STD_LOGIC_VECTOR ( 24 downto 24 ); 
  signal DATA04_OUT_DATA_04_2_0_IV_0_X1 : STD_LOGIC_VECTOR ( 24 downto 24 ); 
  signal SEL_REGVPIVCI_REGNR_02_1 : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal STATE04 : STD_LOGIC_VECTOR ( 8 downto 0 ); 
  signal GENCOUNT : STD_LOGIC_VECTOR ( 2 downto 0 ); 
  signal DATA00_OUT_DATA_00_2_2_0_S_X0 : STD_LOGIC_VECTOR ( 21 downto 21 ); 
  signal SEQUENCENR : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal CMDATA_STORE : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA00_OUT_DATA_00_2_2_0_X0 : STD_LOGIC_VECTOR ( 9 downto 9 ); 
  signal CTRLCELL_VPI : STD_LOGIC_VECTOR ( 11 downto 0 ); 
  signal DATA_CC_M : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA00_OUT_DATA_00_2_2_0_AND2_SX : STD_LOGIC_VECTOR ( 20 downto 20 ); 
  signal DATA00_OUT_DATA_00_2_2_0_AND2_0_S : STD_LOGIC_VECTOR ( 12 downto 12 ); 
  signal STATE04_FAST : STD_LOGIC_VECTOR ( 5 downto 5 ); 
  signal APPL_VPI : STD_LOGIC_VECTOR ( 11 downto 0 ); 
  signal DATA_CC_MUX_TMP_DATA_4 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal STATE02_H_STATE02 : STD_LOGIC_VECTOR ( 1 downto 0 ); 
  signal OPCSEL_BUF : STD_LOGIC_VECTOR ( 1 downto 0 ); 
  signal OPCODE_SEL : STD_LOGIC_VECTOR ( 1 downto 0 ); 
  signal CRC_NEW : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal DATA00_OUT_DATA_00_2_2_0_S_SX : STD_LOGIC_VECTOR ( 25 downto 25 ); 
  signal SEL_STATE : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal PLCOUNT : STD_LOGIC_VECTOR ( 2 downto 0 ); 
  signal STATE : STD_LOGIC_VECTOR ( 3 downto 0 ); 
  signal DATA_STORE_3 : STD_LOGIC_VECTOR ( 31 downto 4 ); 
  signal DATA_STORE_7 : STD_LOGIC_VECTOR ( 31 downto 4 ); 
  signal DATA_STORE_1 : STD_LOGIC_VECTOR ( 31 downto 4 ); 
  signal DATA_STORE_5 : STD_LOGIC_VECTOR ( 31 downto 4 ); 
  signal DATA_IN : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_M : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_04 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_00 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal STATE_H_STATE : STD_LOGIC_VECTOR ( 5 downto 5 ); 
  signal DATA_CC_DELAY : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_CC_1 : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal PLCOUNT_I : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal GENCOUNT_I : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal VPI_02 : STD_LOGIC_VECTOR ( 11 downto 0 ); 
  signal VCI_02 : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal DATA00_OUT_DATA_00_2_2_0_TRUE : STD_LOGIC_VECTOR ( 9 downto 9 ); 
  signal DATA00_OUT_DATA_00_2_2_0_S_TRUE : STD_LOGIC_VECTOR ( 21 downto 21 ); 
  signal CHECK_DATA_IN : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal CHECK_HEC : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal CHECK_CRC_CALC_0 : STD_LOGIC_VECTOR ( 13 downto 13 ); 
  signal CHECK_DATA_OUT : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal CHECK_CRC_GEN_UN5_NX_CRC_0 : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal CHECK_CRC_GEN_COUNTER : STD_LOGIC_VECTOR ( 2 downto 0 ); 
  signal CMUX_COUNTER : STD_LOGIC_VECTOR ( 2 downto 0 ); 
  signal CMUX_NX_STATE_M3 : STD_LOGIC_VECTOR ( 1 downto 0 ); 
  signal CMUX_STATE : STD_LOGIC_VECTOR ( 1 downto 0 ); 
  signal CMUX_COUNTER_I : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal CMUX_DOUT_CTRL : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal CMUX_DOUT_APPL : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal CMUX_DATA_CTRL_IN : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal CMUX_DATA_BP_IN : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal CMUX_DATA_APPL_IN : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal CMUX_DOUT_BYPASS : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal CMUX_APPL_IN_COUNTER : STD_LOGIC_VECTOR ( 2 downto 0 ); 
  signal CMUX_APPL_IN_STATE : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal CMUX_APPL_IN_COUNTER_I : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal CMUX_BYPASS_IN_COUNTER : STD_LOGIC_VECTOR ( 2 downto 0 ); 
  signal CMUX_BYPASS_IN_STATE : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal CMUX_BYPASS_IN_COUNTER_I : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal CMUX_CTRLCELL_IN_COUNTER : STD_LOGIC_VECTOR ( 2 downto 0 ); 
  signal CMUX_CTRLCELL_IN_STATE : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal CMUX_CTRLCELL_IN_COUNTER_I : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal CRC_GEN_UN5_NX_CRC : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal CRC_GEN_CRC_L_M : STD_LOGIC_VECTOR ( 4 downto 4 ); 
  signal CRC_GEN_COUNTER : STD_LOGIC_VECTOR ( 2 downto 0 ); 
  signal CRC_GEN_COUNTER_I : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal HEC_SET_DATA_IN : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal HEC_SET_HEC : STD_LOGIC_VECTOR ( 7 downto 0 ); 
  signal STATE00_H_STATE00_NS : STD_LOGIC_VECTOR ( 1 downto 1 ); 
  signal STATE00_H_STATE00_0 : STD_LOGIC_VECTOR ( 6 downto 6 ); 
  signal STATE02_H_STATE02_NS : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal STATE04_H_STATE04_NS : STD_LOGIC_VECTOR ( 1 downto 1 ); 
  signal STATE_H_STATE_0 : STD_LOGIC_VECTOR ( 4 downto 4 ); 
begin
  SOC_OUT_MOD <= NGD2VHDL_OI4;
  D_OUT_APPL(31) <= NGD2VHDL_OI43;
  D_OUT_APPL(30) <= NGD2VHDL_OI44;
  D_OUT_APPL(29) <= NGD2VHDL_OI45;
  D_OUT_APPL(28) <= NGD2VHDL_OI46;
  D_OUT_APPL(27) <= NGD2VHDL_OI47;
  D_OUT_APPL(26) <= NGD2VHDL_OI48;
  D_OUT_APPL(25) <= NGD2VHDL_OI49;
  D_OUT_APPL(24) <= NGD2VHDL_OI50;
  D_OUT_APPL(23) <= NGD2VHDL_OI51;
  D_OUT_APPL(22) <= NGD2VHDL_OI52;
  D_OUT_APPL(21) <= NGD2VHDL_OI53;
  D_OUT_APPL(20) <= NGD2VHDL_OI54;
  D_OUT_APPL(19) <= NGD2VHDL_OI55;
  D_OUT_APPL(18) <= NGD2VHDL_OI56;
  D_OUT_APPL(17) <= NGD2VHDL_OI57;
  D_OUT_APPL(16) <= NGD2VHDL_OI58;
  D_OUT_APPL(15) <= NGD2VHDL_OI59;
  D_OUT_APPL(14) <= NGD2VHDL_OI60;
  D_OUT_APPL(13) <= NGD2VHDL_OI61;
  D_OUT_APPL(12) <= NGD2VHDL_OI62;
  D_OUT_APPL(11) <= NGD2VHDL_OI63;
  D_OUT_APPL(10) <= NGD2VHDL_OI64;
  D_OUT_APPL(9) <= NGD2VHDL_OI65;
  D_OUT_APPL(8) <= NGD2VHDL_OI66;
  D_OUT_APPL(7) <= NGD2VHDL_OI67;
  D_OUT_APPL(6) <= NGD2VHDL_OI68;
  D_OUT_APPL(5) <= NGD2VHDL_OI69;
  D_OUT_APPL(4) <= NGD2VHDL_OI70;
  D_OUT_APPL(3) <= NGD2VHDL_OI71;
  D_OUT_APPL(2) <= NGD2VHDL_OI72;
  D_OUT_APPL(1) <= NGD2VHDL_OI73;
  D_OUT_APPL(0) <= NGD2VHDL_OI74;
  GND_0 : X_ZERO
    port map (
      O => GND_INT
    );
  G_1035_0_AND2_G_3250 : X_LUT2
    generic map (
      INIT => X"1"
    )
    port map (
      ADR0 => CCOPCODE(3),
      ADR1 => CCOPCODE(5),
      O => G_3250
    );
  G_1035_0_AND2_G_3253 : X_LUT4
    generic map (
      INIT => X"0001"
    )
    port map (
      ADR0 => CCOPCODE(7),
      ADR1 => CCOPCODE(4),
      ADR2 => CCOPCODE(0),
      ADR3 => CCOPCODE(6),
      O => G_3253
    );
  G_1072 : X_LUT4
    generic map (
      INIT => X"0001"
    )
    port map (
      ADR0 => REGNR_04(7),
      ADR1 => REGNR_04(3),
      ADR2 => REGNR_04(5),
      ADR3 => G_1072_SX,
      O => N_4113
    );
  G_1072_G_3258 : X_LUT4
    generic map (
      INIT => X"0001"
    )
    port map (
      ADR0 => REGNR_04(6),
      ADR1 => REGNR_04(0),
      ADR2 => REGNR_04(2),
      ADR3 => REGNR_04(1),
      O => G_3258
    );
  G_1072_SX_1 : X_LUT4
    generic map (
      INIT => X"FFFE"
    )
    port map (
      ADR0 => REGNR_04(1),
      ADR1 => REGNR_04(2),
      ADR2 => REGNR_04(0),
      ADR3 => REGNR_04(6),
      O => G_1072_SX
    );
  G_1072_X_2 : X_LUT3
    generic map (
      INIT => X"01"
    )
    port map (
      ADR0 => REGNR_04(5),
      ADR1 => REGNR_04(3),
      ADR2 => REGNR_04(7),
      O => G_1072_X
    );
  G_1086_I : X_LUT4
    generic map (
      INIT => X"1B11"
    )
    port map (
      ADR0 => SEL_STATE(0),
      ADR1 => STATE00(4),
      ADR2 => OPCSEL_BUF(1),
      ADR3 => OPCSEL_BUF(0),
      O => N_3152
    );
  G_1438_0_OR2_0_XOR2 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => GENCOUNT(0),
      ADR1 => GENCOUNT(2),
      O => N_3683
    );
  G_1918 : X_LUT2
    generic map (
      INIT => X"2"
    )
    port map (
      ADR0 => STATE(2),
      ADR1 => N_882_1,
      O => N_2575
    );
  G_1927 : X_LUT2
    generic map (
      INIT => X"4"
    )
    port map (
      ADR0 => PLCOUNT(2),
      ADR1 => N_882_1,
      O => N_2584
    );
  G_2229_0_AND2 : X_LUT4
    generic map (
      INIT => X"8000"
    )
    port map (
      ADR0 => G_3253,
      ADR1 => G_3250,
      ADR2 => CRC_OK,
      ADR3 => STATE(0),
      O => N_3455
    );
  G_2234_G_5_0_AND6_G_5_G_4 : X_LUT4
    generic map (
      INIT => X"0008"
    )
    port map (
      ADR0 => G_23,
      ADR1 => G_20,
      ADR2 => REGNR_02(1),
      ADR3 => REGNR_02(2),
      O => N_3055
    );
  G_2234_G_5_0_AND6_G_5_G_4_G_20 : X_LUT2
    generic map (
      INIT => X"1"
    )
    port map (
      ADR0 => REGNR_02(3),
      ADR1 => REGNR_02(0),
      O => G_20
    );
  G_2234_G_5_0_AND6_G_5_G_4_G_23 : X_LUT4
    generic map (
      INIT => X"0002"
    )
    port map (
      ADR0 => VALID_02,
      ADR1 => REGNR_02(7),
      ADR2 => REGNR_02(6),
      ADR3 => REGNR_02(5),
      O => G_23
    );
  G_2234_G_5_0_AND6_G_5_G_4_FAST : X_LUT4
    generic map (
      INIT => X"0001"
    )
    port map (
      ADR0 => REGNR_02(3),
      ADR1 => REGNR_02(0),
      ADR2 => REGNR_02(1),
      ADR3 => REGNR_02(2),
      O => G_4_FAST
    );
  G_2298 : X_LUT2
    generic map (
      INIT => X"1"
    )
    port map (
      ADR0 => STATE04(1),
      ADR1 => STATE04(2),
      O => N_3118
    );
  G_2299_G_1_0_OR6_G_1_G_1 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => G_3258,
      ADR1 => G_1072_X,
      ADR2 => G_23,
      ADR3 => G_4_FAST,
      O => N_2848
    );
  G_2300_0_OR2_G_4_0_OR6_G_3_G_2_G_17 : X_LUT2
    generic map (
      INIT => X"4"
    )
    port map (
      ADR0 => REGNR_04(4),
      ADR1 => VALID_04,
      O => G_17
    );
  G_2300_0_OR2_G_4_0_OR6_G_3_G_3 : X_LUT4
    generic map (
      INIT => X"EAAA"
    )
    port map (
      ADR0 => STATE04(7),
      ADR1 => N_2848,
      ADR2 => G_17,
      ADR3 => STATE04(3),
      O => N_3285
    );
  G_2300_0_OR2_G_4_0_OR6_G_3_G_3_FAST : X_LUT4
    generic map (
      INIT => X"EAAA"
    )
    port map (
      ADR0 => STATE04(7),
      ADR1 => N_2848,
      ADR2 => G_17,
      ADR3 => STATE04(3),
      O => G_3_FAST
    );
  G_2306 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CCOPCODE(1),
      ADR1 => CCOPCODE(2),
      O => N_2855
    );
  G_2365 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CTRLCELL_VCI(3),
      ADR1 => APPL_VCI(3),
      ADR2 => REGNR_04(4),
      O => N_2914
    );
  G_2368_G_3355 : X_LUT3
    generic map (
      INIT => X"EF"
    )
    port map (
      ADR0 => GENCOUNT(0),
      ADR1 => N_894_1,
      ADR2 => GENCOUNT(1),
      O => G_3355
    );
  G_2534 : X_LUT3
    generic map (
      INIT => X"01"
    )
    port map (
      ADR0 => STATE00_FAST(1),
      ADR1 => STATE00(5),
      ADR2 => STATE00(0),
      O => N_3464
    );
  G_2535 : X_LUT4
    generic map (
      INIT => X"0100"
    )
    port map (
      ADR0 => STATE00_FAST(1),
      ADR1 => STATE00(5),
      ADR2 => STATE00(0),
      ADR3 => STATE00(2),
      O => N_3465
    );
  G_2535_S_3 : X_LUT2
    generic map (
      INIT => X"2"
    )
    port map (
      ADR0 => STATE00(2),
      ADR1 => STATE00(0),
      O => G_2535_S
    );
  G_2538_G_3380_G_1 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => STATE04(3),
      ADR1 => VALID_04,
      O => G_1
    );
  G_2539 : X_LUT4
    generic map (
      INIT => X"EA00"
    )
    port map (
      ADR0 => N_4113,
      ADR1 => G_4_FAST,
      ADR2 => G_23,
      ADR3 => G_2539_S,
      O => N_3469
    );
  G_2539_REP1 : X_LUT4
    generic map (
      INIT => X"EA00"
    )
    port map (
      ADR0 => N_4113,
      ADR1 => G_4_FAST,
      ADR2 => G_23,
      ADR3 => G_2539_S,
      O => N_3469_REP1
    );
  G_2539_REP1_0 : X_LUT4
    generic map (
      INIT => X"EA00"
    )
    port map (
      ADR0 => N_4113,
      ADR1 => G_4_FAST,
      ADR2 => G_23,
      ADR3 => G_2539_S,
      O => N_3469_REP1_0
    );
  G_2539_REP2 : X_LUT4
    generic map (
      INIT => X"EA00"
    )
    port map (
      ADR0 => N_4113,
      ADR1 => G_4_FAST,
      ADR2 => G_23,
      ADR3 => G_2539_S,
      O => N_3469_REP2
    );
  G_2539_S_4 : X_LUT3
    generic map (
      INIT => X"80"
    )
    port map (
      ADR0 => REGNR_04(4),
      ADR1 => STATE04(3),
      ADR2 => VALID_04,
      O => G_2539_S
    );
  G_2621 : X_LUT3
    generic map (
      INIT => X"01"
    )
    port map (
      ADR0 => GENCOUNT_FAST_0_2_Q,
      ADR1 => GENCOUNT(1),
      ADR2 => GENCOUNT_FAST_0_0_Q,
      O => N_3550
    );
  G_2621_X_5 : X_LUT2
    generic map (
      INIT => X"1"
    )
    port map (
      ADR0 => GENCOUNT(1),
      ADR1 => GENCOUNT_FAST_0_0_Q,
      O => G_2621_X
    );
  G_2624 : X_LUT3
    generic map (
      INIT => X"40"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => G_2621_X,
      ADR2 => N_3465,
      O => N_3552
    );
  G_2626_Q_G_24 : X_LUT3
    generic map (
      INIT => X"02"
    )
    port map (
      ADR0 => I_11,
      ADR1 => G_3343,
      ADR2 => G_2626_Q_G_24_SX,
      O => N_3554
    );
  G_2626_Q_G_24_SX_6 : X_LUT4
    generic map (
      INIT => X"FFF7"
    )
    port map (
      ADR0 => SOC,
      ADR1 => MATCH_MODID,
      ADR2 => G_3337,
      ADR3 => G_3339,
      O => G_2626_Q_G_24_SX
    );
  G_2636_I_AND2 : X_LUT2
    generic map (
      INIT => X"1"
    )
    port map (
      ADR0 => GENCOUNT(0),
      ADR1 => GENCOUNT(1),
      O => N_3294_I
    );
  G_2641 : X_LUT3
    generic map (
      INIT => X"BF"
    )
    port map (
      ADR0 => CCOPCODE(2),
      ADR1 => G_3253,
      ADR2 => G_3250,
      O => N_3299
    );
  G_2642 : X_LUT4
    generic map (
      INIT => X"BFFF"
    )
    port map (
      ADR0 => CCOPCODE(2),
      ADR1 => CCOPCODE(1),
      ADR2 => G_3253,
      ADR3 => G_3250,
      O => N_3300
    );
  G_2647_7 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => APPL_VPI(5),
      ADR1 => NGD2VHDL_OI49,
      O => G_2647
    );
  G_2685 : X_LUT3
    generic map (
      INIT => X"5D"
    )
    port map (
      ADR0 => SEL_STATE(0),
      ADR1 => OPCSEL_BUF(1),
      ADR2 => OPCSEL_BUF(0),
      O => N_3343
    );
  G_2834 : X_LUT3
    generic map (
      INIT => X"10"
    )
    port map (
      ADR0 => GENCOUNT_FAST(2),
      ADR1 => N_894_1,
      ADR2 => GENCOUNT_FAST(0),
      O => N_3833
    );
  G_2834_FAST_8 : X_LUT3
    generic map (
      INIT => X"10"
    )
    port map (
      ADR0 => GENCOUNT_FAST(2),
      ADR1 => GENCOUNT_FAST(3),
      ADR2 => GENCOUNT_FAST(0),
      O => G_2834_FAST
    );
  G_2835 : X_LUT4
    generic map (
      INIT => X"0100"
    )
    port map (
      ADR0 => STATE00_FAST(1),
      ADR1 => GENCOUNT_FAST(3),
      ADR2 => STATE00(5),
      ADR3 => G_2535_S,
      O => N_3834
    );
  G_2835_X_9 : X_LUT3
    generic map (
      INIT => X"01"
    )
    port map (
      ADR0 => STATE00(1),
      ADR1 => N_894_1,
      ADR2 => STATE00(5),
      O => G_2835_X
    );
  G_2836 : X_LUT2
    generic map (
      INIT => X"4"
    )
    port map (
      ADR0 => STATE00(1),
      ADR1 => STATE00(5),
      O => N_3835
    );
  G_2837 : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => N_894_1,
      ADR2 => GENCOUNT(0),
      O => N_3836
    );
  G_2844_REP1 : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => G_2834_FAST,
      ADR1 => STATE04(5),
      ADR2 => GENCOUNT(1),
      O => N_3842_REP1
    );
  G_2844_REP2 : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => G_2834_FAST,
      ADR1 => STATE04(5),
      ADR2 => GENCOUNT(1),
      O => N_3842_REP2
    );
  G_2846 : X_LUT3
    generic map (
      INIT => X"10"
    )
    port map (
      ADR0 => STATE00_FAST(1),
      ADR1 => STATE00(5),
      ADR2 => STATE00(0),
      O => N_3844
    );
  G_2852 : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => G_2535_S,
      ADR1 => G_2835_X,
      ADR2 => GENCOUNT(1),
      O => N_3850
    );
  G_2914 : X_LUT4
    generic map (
      INIT => X"2000"
    )
    port map (
      ADR0 => GENCOUNT(0),
      ADR1 => N_894_1,
      ADR2 => GENCOUNT(2),
      ADR3 => N_3465,
      O => N_3911
    );
  G_2918 : X_LUT2
    generic map (
      INIT => X"E"
    )
    port map (
      ADR0 => STATE04_FAST(5),
      ADR1 => GENCOUNT_FAST(1),
      O => N_3674
    );
  G_2918_REP1 : X_LUT2
    generic map (
      INIT => X"E"
    )
    port map (
      ADR0 => STATE04_FAST(5),
      ADR1 => GENCOUNT_FAST(1),
      O => N_3674_REP1
    );
  G_2918_REP2 : X_LUT2
    generic map (
      INIT => X"E"
    )
    port map (
      ADR0 => STATE04_FAST(5),
      ADR1 => GENCOUNT_FAST(1),
      O => N_3674_REP2
    );
  G_2928 : X_LUT2
    generic map (
      INIT => X"7"
    )
    port map (
      ADR0 => GENCOUNT_FAST_0_0_Q,
      ADR1 => GENCOUNT_FAST(1),
      O => N_3684
    );
  G_2933 : X_LUT2
    generic map (
      INIT => X"E"
    )
    port map (
      ADR0 => GENCOUNT_FAST_0_2_Q,
      ADR1 => GENCOUNT_FAST_0_0_Q,
      O => N_3689
    );
  G_2935 : X_LUT4
    generic map (
      INIT => X"6AAA"
    )
    port map (
      ADR0 => N_894_1,
      ADR1 => GENCOUNT(2),
      ADR2 => GENCOUNT(1),
      ADR3 => GENCOUNT(0),
      O => N_3691
    );
  G_2937 : X_LUT3
    generic map (
      INIT => X"6A"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => GENCOUNT(1),
      ADR2 => GENCOUNT(0),
      O => N_3693
    );
  G_2939_10 : X_MUX2
    port map (
      IA => G_2939_AM,
      IB => G_2939_BM,
      SEL => N_3674,
      O => G_2939
    );
  G_2939_AM_11 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(25),
      ADR2 => DATA_STORE_3(25),
      O => G_2939_AM
    );
  G_2939_BM_12 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(25),
      ADR2 => DATA_STORE_5(25),
      O => G_2939_BM
    );
  G_2940_13 : X_MUX2
    port map (
      IA => G_2940_AM,
      IB => G_2940_BM,
      SEL => N_3674,
      O => G_2940
    );
  G_2940_AM_14 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(24),
      ADR2 => DATA_STORE_3(24),
      O => G_2940_AM
    );
  G_2940_BM_15 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(24),
      ADR2 => DATA_STORE_5(24),
      O => G_2940_BM
    );
  G_2941_16 : X_MUX2
    port map (
      IA => G_2941_AM,
      IB => G_2941_BM,
      SEL => N_3674,
      O => G_2941
    );
  G_2941_AM_17 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(23),
      ADR2 => DATA_STORE_3(23),
      O => G_2941_AM
    );
  G_2941_BM_18 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(23),
      ADR2 => DATA_STORE_5(23),
      O => G_2941_BM
    );
  G_2942_19 : X_MUX2
    port map (
      IA => G_2942_AM,
      IB => G_2942_BM,
      SEL => N_3674,
      O => G_2942
    );
  G_2942_AM_20 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(22),
      ADR2 => DATA_STORE_3(22),
      O => G_2942_AM
    );
  G_2942_BM_21 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(22),
      ADR2 => DATA_STORE_5(22),
      O => G_2942_BM
    );
  G_2943_22 : X_MUX2
    port map (
      IA => G_2943_AM,
      IB => G_2943_BM,
      SEL => N_3674,
      O => G_2943
    );
  G_2943_AM_23 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(21),
      ADR2 => DATA_STORE_3(21),
      O => G_2943_AM
    );
  G_2943_BM_24 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(21),
      ADR2 => DATA_STORE_5(21),
      O => G_2943_BM
    );
  G_2944_25 : X_MUX2
    port map (
      IA => G_2944_AM,
      IB => G_2944_BM,
      SEL => N_3674,
      O => G_2944
    );
  G_2944_AM_26 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(20),
      ADR2 => DATA_STORE_3(20),
      O => G_2944_AM
    );
  G_2944_BM_27 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(20),
      ADR2 => DATA_STORE_5(20),
      O => G_2944_BM
    );
  G_2945_28 : X_MUX2
    port map (
      IA => G_2945_AM,
      IB => G_2945_BM,
      SEL => N_3674,
      O => G_2945
    );
  G_2945_AM_29 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(19),
      ADR2 => DATA_STORE_3(19),
      O => G_2945_AM
    );
  G_2945_BM_30 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(19),
      ADR2 => DATA_STORE_5(19),
      O => G_2945_BM
    );
  G_2946_31 : X_MUX2
    port map (
      IA => G_2946_AM,
      IB => G_2946_BM,
      SEL => N_3674,
      O => G_2946
    );
  G_2946_AM_32 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(18),
      ADR2 => DATA_STORE_3(18),
      O => G_2946_AM
    );
  G_2946_BM_33 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(18),
      ADR2 => DATA_STORE_5(18),
      O => G_2946_BM
    );
  G_2947_34 : X_MUX2
    port map (
      IA => G_2947_AM,
      IB => G_2947_BM,
      SEL => N_3674,
      O => G_2947
    );
  G_2947_AM_35 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(17),
      ADR2 => DATA_STORE_3(17),
      O => G_2947_AM
    );
  G_2947_BM_36 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(17),
      ADR2 => DATA_STORE_5(17),
      O => G_2947_BM
    );
  G_2948_37 : X_MUX2
    port map (
      IA => G_2948_AM,
      IB => G_2948_BM,
      SEL => N_3674,
      O => G_2948
    );
  G_2948_AM_38 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(16),
      ADR2 => DATA_STORE_3(16),
      O => G_2948_AM
    );
  G_2948_BM_39 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(16),
      ADR2 => DATA_STORE_5(16),
      O => G_2948_BM
    );
  G_2949_40 : X_MUX2
    port map (
      IA => G_2949_AM,
      IB => G_2949_BM,
      SEL => N_3674,
      O => G_2949
    );
  G_2949_AM_41 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(15),
      ADR2 => DATA_STORE_3(15),
      O => G_2949_AM
    );
  G_2949_BM_42 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(15),
      ADR2 => DATA_STORE_5(15),
      O => G_2949_BM
    );
  G_2950_43 : X_MUX2
    port map (
      IA => G_2950_AM,
      IB => G_2950_BM,
      SEL => N_3674,
      O => G_2950
    );
  G_2950_AM_44 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(14),
      ADR2 => DATA_STORE_3(14),
      O => G_2950_AM
    );
  G_2950_BM_45 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(14),
      ADR2 => DATA_STORE_5(14),
      O => G_2950_BM
    );
  G_2951_46 : X_MUX2
    port map (
      IA => G_2951_AM,
      IB => G_2951_BM,
      SEL => N_3674,
      O => G_2951
    );
  G_2951_AM_47 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(13),
      ADR2 => DATA_STORE_3(13),
      O => G_2951_AM
    );
  G_2951_BM_48 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(13),
      ADR2 => DATA_STORE_5(13),
      O => G_2951_BM
    );
  G_2952_49 : X_MUX2
    port map (
      IA => G_2952_AM,
      IB => G_2952_BM,
      SEL => N_3674,
      O => G_2952
    );
  G_2952_AM_50 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(12),
      ADR2 => DATA_STORE_3(12),
      O => G_2952_AM
    );
  G_2952_BM_51 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(12),
      ADR2 => DATA_STORE_5(12),
      O => G_2952_BM
    );
  G_2953_52 : X_MUX2
    port map (
      IA => G_2953_AM,
      IB => G_2953_BM,
      SEL => N_3674_REP1,
      O => G_2953
    );
  G_2953_AM_53 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(11),
      ADR2 => DATA_STORE_3(11),
      O => G_2953_AM
    );
  G_2953_BM_54 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(11),
      ADR2 => DATA_STORE_5(11),
      O => G_2953_BM
    );
  G_2954_55 : X_MUX2
    port map (
      IA => G_2954_AM,
      IB => G_2954_BM,
      SEL => N_3674_REP1,
      O => G_2954
    );
  G_2954_AM_56 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(10),
      ADR2 => DATA_STORE_3(10),
      O => G_2954_AM
    );
  G_2954_BM_57 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(10),
      ADR2 => DATA_STORE_5(10),
      O => G_2954_BM
    );
  G_2955_58 : X_MUX2
    port map (
      IA => G_2955_AM,
      IB => G_2955_BM,
      SEL => N_3674_REP1,
      O => G_2955
    );
  G_2955_AM_59 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(9),
      ADR2 => DATA_STORE_3(9),
      O => G_2955_AM
    );
  G_2955_BM_60 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(9),
      ADR2 => DATA_STORE_5(9),
      O => G_2955_BM
    );
  G_2956_61 : X_MUX2
    port map (
      IA => G_2956_AM,
      IB => G_2956_BM,
      SEL => N_3674_REP1,
      O => G_2956
    );
  G_2956_AM_62 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(8),
      ADR2 => DATA_STORE_3(8),
      O => G_2956_AM
    );
  G_2956_BM_63 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(8),
      ADR2 => DATA_STORE_5(8),
      O => G_2956_BM
    );
  G_2957_64 : X_MUX2
    port map (
      IA => G_2957_AM,
      IB => G_2957_BM,
      SEL => N_3674_REP1,
      O => G_2957
    );
  G_2957_AM_65 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(7),
      ADR2 => DATA_STORE_3(7),
      O => G_2957_AM
    );
  G_2957_BM_66 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(7),
      ADR2 => DATA_STORE_5(7),
      O => G_2957_BM
    );
  G_2958_67 : X_MUX2
    port map (
      IA => G_2958_AM,
      IB => G_2958_BM,
      SEL => N_3674_REP1,
      O => G_2958
    );
  G_2958_AM_68 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(6),
      ADR2 => DATA_STORE_3(6),
      O => G_2958_AM
    );
  G_2958_BM_69 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(6),
      ADR2 => DATA_STORE_5(6),
      O => G_2958_BM
    );
  G_2959_70 : X_MUX2
    port map (
      IA => G_2959_AM,
      IB => G_2959_BM,
      SEL => N_3674_REP1,
      O => G_2959
    );
  G_2959_AM_71 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(5),
      ADR2 => DATA_STORE_3(5),
      O => G_2959_AM
    );
  G_2959_BM_72 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(5),
      ADR2 => DATA_STORE_5(5),
      O => G_2959_BM
    );
  G_2960_73 : X_MUX2
    port map (
      IA => G_2960_AM,
      IB => G_2960_BM,
      SEL => N_3674_REP1,
      O => G_2960
    );
  G_2960_AM_74 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(4),
      ADR2 => DATA_STORE_3(4),
      O => G_2960_AM
    );
  G_2960_BM_75 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(4),
      ADR2 => DATA_STORE_5(4),
      O => G_2960_BM
    );
  G_2961_76 : X_MUX2
    port map (
      IA => G_2961_AM,
      IB => G_2961_BM,
      SEL => N_3674_REP1,
      O => G_2961
    );
  G_2961_AM_77 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(31),
      ADR2 => DATA_STORE_3(31),
      O => G_2961_AM
    );
  G_2961_BM_78 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(31),
      ADR2 => DATA_STORE_5(31),
      O => G_2961_BM
    );
  G_2962_79 : X_MUX2
    port map (
      IA => G_2962_AM,
      IB => G_2962_BM,
      SEL => N_3674_REP1,
      O => G_2962
    );
  G_2962_AM_80 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(30),
      ADR2 => DATA_STORE_3(30),
      O => G_2962_AM
    );
  G_2962_BM_81 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(30),
      ADR2 => DATA_STORE_5(30),
      O => G_2962_BM
    );
  G_2963_82 : X_MUX2
    port map (
      IA => G_2963_AM,
      IB => G_2963_BM,
      SEL => N_3674_REP1,
      O => G_2963
    );
  G_2963_AM_83 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(29),
      ADR2 => DATA_STORE_3(29),
      O => G_2963_AM
    );
  G_2963_BM_84 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(29),
      ADR2 => DATA_STORE_5(29),
      O => G_2963_BM
    );
  G_2964_85 : X_MUX2
    port map (
      IA => G_2964_AM,
      IB => G_2964_BM,
      SEL => N_3674_REP1,
      O => G_2964
    );
  G_2964_AM_86 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(28),
      ADR2 => DATA_STORE_3(28),
      O => G_2964_AM
    );
  G_2964_BM_87 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(28),
      ADR2 => DATA_STORE_5(28),
      O => G_2964_BM
    );
  G_2965_88 : X_MUX2
    port map (
      IA => G_2965_AM,
      IB => G_2965_BM,
      SEL => N_3674_REP1,
      O => G_2965
    );
  G_2965_AM_89 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(27),
      ADR2 => DATA_STORE_3(27),
      O => G_2965_AM
    );
  G_2965_BM_90 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(27),
      ADR2 => DATA_STORE_5(27),
      O => G_2965_BM
    );
  G_2966_91 : X_MUX2
    port map (
      IA => G_2966_AM,
      IB => G_2966_BM,
      SEL => N_3674_REP1,
      O => G_2966
    );
  G_2966_AM_92 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => DATA_STORE_7(26),
      ADR2 => DATA_STORE_3(26),
      O => G_2966_AM
    );
  G_2966_BM_93 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => DATA_STORE_1(26),
      ADR2 => DATA_STORE_5(26),
      O => G_2966_BM
    );
  G_2968 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => STATE00(3),
      ADR1 => SEQUENCENR(8),
      ADR2 => STATE00(0),
      O => N_3724
    );
  G_2972 : X_LUT3
    generic map (
      INIT => X"D9"
    )
    port map (
      ADR0 => GENCOUNT(0),
      ADR1 => GENCOUNT(1),
      ADR2 => GENCOUNT(2),
      O => N_3728
    );
  G_3657_2 : X_LUT4
    generic map (
      INIT => X"4F44"
    )
    port map (
      ADR0 => CTRLCELL_VPI(9),
      ADR1 => N_3835,
      ADR2 => SEQUENCENR(13),
      ADR3 => N_3844,
      O => N_4755_2
    );
  G_3658_94 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => N_3554,
      ADR1 => STATE_H_STATE(5),
      O => G_3658
    );
  G_3659_95 : X_LUT4
    generic map (
      INIT => X"0800"
    )
    port map (
      ADR0 => N_882_1,
      ADR1 => N_2580,
      ADR2 => PLCOUNT(2),
      ADR3 => STATE(2),
      O => G_3659
    );
  G_3659_1 : X_LUT2
    generic map (
      INIT => X"1"
    )
    port map (
      ADR0 => PLCOUNT(0),
      ADR1 => PLCOUNT(1),
      O => N_2580
    );
  G_3660_96 : X_LUT4
    generic map (
      INIT => X"4000"
    )
    port map (
      ADR0 => N_894_1,
      ADR1 => N_1892_I,
      ADR2 => GENCOUNT(1),
      ADR3 => STATE04(3),
      O => G_3660
    );
  G_3660_1 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => GENCOUNT(0),
      O => N_1892_I
    );
  G_3661_97 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => STATE04(6),
      ADR1 => N_3152,
      O => G_3661
    );
  G_3662_98 : X_LUT4
    generic map (
      INIT => X"0080"
    )
    port map (
      ADR0 => N_894_1,
      ADR1 => N_4760_1,
      ADR2 => STATE00(2),
      ADR3 => GENCOUNT(1),
      O => G_3662
    );
  G_3662_1 : X_LUT2
    generic map (
      INIT => X"1"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => GENCOUNT(0),
      O => N_4760_1
    );
  G_3663_99 : X_LUT4
    generic map (
      INIT => X"22A2"
    )
    port map (
      ADR0 => STATE00(4),
      ADR1 => SEL_STATE(0),
      ADR2 => OPCSEL_BUF(1),
      ADR3 => OPCSEL_BUF(0),
      O => G_3663
    );
  G_3665_100 : X_LUT3
    generic map (
      INIT => X"80"
    )
    port map (
      ADR0 => N_894_1,
      ADR1 => GENCOUNT(1),
      ADR2 => GENCOUNT(0),
      O => G_3665
    );
  G_3666_101 : X_LUT4
    generic map (
      INIT => X"0002"
    )
    port map (
      ADR0 => N_4764_4,
      ADR1 => DATA_IN(22),
      ADR2 => DATA_IN(23),
      ADR3 => DATA_IN(20),
      O => G_3666
    );
  G_3666_4 : X_LUT4
    generic map (
      INIT => X"0004"
    )
    port map (
      ADR0 => DATA_IN(19),
      ADR1 => DATA_IN(16),
      ADR2 => DATA_IN(21),
      ADR3 => DATA_IN(18),
      O => N_4764_4
    );
  G_3667_102 : X_LUT4
    generic map (
      INIT => X"AA2A"
    )
    port map (
      ADR0 => SOC,
      ADR1 => MATCH_MODID,
      ADR2 => I_11,
      ADR3 => UN4_IS_CONTROL_CELL_NE,
      O => G_3667
    );
  G_3668_103 : X_LUT4
    generic map (
      INIT => X"8000"
    )
    port map (
      ADR0 => N_4766_9,
      ADR1 => N_4766_8,
      ADR2 => N_4766_11,
      ADR3 => N_4766_10,
      O => G_3668
    );
  G_3668_8 : X_LUT4
    generic map (
      INIT => X"0001"
    )
    port map (
      ADR0 => CHECK_CRC_CALC_15_Q,
      ADR1 => CHECK_CRC_CALC_12_Q,
      ADR2 => CHECK_CRC_CALC_9_Q,
      ADR3 => CHECK_CRC_CALC_14_Q,
      O => N_4766_8
    );
  G_3668_9 : X_LUT4
    generic map (
      INIT => X"0001"
    )
    port map (
      ADR0 => CHECK_CRC_CALC_11_Q,
      ADR1 => CHECK_CRC_CALC_8_Q,
      ADR2 => CHECK_CRC_CALC_5_Q,
      ADR3 => CHECK_CRC_CALC_10_Q,
      O => N_4766_9
    );
  G_3668_10 : X_LUT4
    generic map (
      INIT => X"0001"
    )
    port map (
      ADR0 => CHECK_CRC_CALC_7_Q,
      ADR1 => CHECK_CRC_CALC_4_Q,
      ADR2 => CHECK_CRC_CALC_1_Q,
      ADR3 => CHECK_CRC_CALC_6_Q,
      O => N_4766_10
    );
  G_3668_11 : X_LUT3
    generic map (
      INIT => X"01"
    )
    port map (
      ADR0 => CHECK_CRC_CALC_2_Q,
      ADR1 => CHECK_CRC_CALC_3_Q,
      ADR2 => CHECK_CRC_CALC_0_Q,
      O => N_4766_11
    );
  I_22_0_AND2_0_AND2 : X_LUT4
    generic map (
      INIT => X"0200"
    )
    port map (
      ADR0 => N_3055,
      ADR1 => REGNR_02(4),
      ADR2 => STATE02_H_STATE02(0),
      ADR3 => STATE02_H_STATE02(1),
      O => N_2997
    );
  I_52_0_AND2_0_AND2 : X_LUT4
    generic map (
      INIT => X"0800"
    )
    port map (
      ADR0 => N_3055,
      ADR1 => REGNR_02(4),
      ADR2 => STATE02_H_STATE02(0),
      ADR3 => STATE02_H_STATE02(1),
      O => N_2998
    );
  N_2550_I_104 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => PLCOUNT(1),
      ADR1 => PLCOUNT(0),
      O => N_2550_I
    );
  N_2551_I_105 : X_LUT3
    generic map (
      INIT => X"6A"
    )
    port map (
      ADR0 => PLCOUNT(2),
      ADR1 => PLCOUNT(1),
      ADR2 => PLCOUNT(0),
      O => N_2551_I
    );
  N_2552_I_106 : X_LUT4
    generic map (
      INIT => X"6AAA"
    )
    port map (
      ADR0 => N_882_1,
      ADR1 => PLCOUNT(2),
      ADR2 => PLCOUNT(1),
      ADR3 => PLCOUNT(0),
      O => N_2552_I
    );
  N_3301_I : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => GENCOUNT(1),
      ADR1 => GENCOUNT(0),
      O => N_4754_I
    );
  N_3313_I : X_LUT3
    generic map (
      INIT => X"54"
    )
    port map (
      ADR0 => SEL_STATE(0),
      ADR1 => STATE04(6),
      ADR2 => STATE00(4),
      O => N_4762_I
    );
  N_4755_I_107 : X_LUT4
    generic map (
      INIT => X"1011"
    )
    port map (
      ADR0 => N_4755_2,
      ADR1 => N_3435,
      ADR2 => CMDATA_STORE(29),
      ADR3 => STATE00(1),
      O => N_4755_I
    );
  RESET_L_I_108 : X_INV
    port map (
      I => RESET_L,
      O => RESET_L_I
    );
  SOC_OUT_APPL_0_AND2_0_AND2 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => SOC,
      ADR1 => DISPATCH_UN9_SOC,
      O => SOC_OUT_APPL
    );
  TCA_MOD_IN_109 : X_LUT2
    generic map (
      INIT => X"2"
    )
    port map (
      ADR0 => TCA_OUT_APPL,
      ADR1 => CMUX_FULL_BYPASS,
      O => TCA_MOD_IN
    );
  VCC_110 : X_ONE
    port map (
      O => VCC_INT
    );
  APPL_VCI_0_Q : X_SFF
    port map (
      I => VCI_02(0),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VCI(0)
    );
  APPL_VCI_1_Q : X_SFF
    port map (
      I => VCI_02(1),
      CLK => CLK,
      CE => N_2998,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => APPL_VCI(1)
    );
  APPL_VCI_2_Q : X_SFF
    port map (
      I => VCI_02(2),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VCI(2)
    );
  APPL_VCI_3_Q : X_SFF
    port map (
      I => VCI_02(3),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VCI(3)
    );
  APPL_VCI_4_Q : X_SFF
    port map (
      I => VCI_02(4),
      CLK => CLK,
      CE => N_2998,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => APPL_VCI(4)
    );
  APPL_VCI_5_Q : X_SFF
    port map (
      I => VCI_02(5),
      CLK => CLK,
      CE => N_2998,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => APPL_VCI(5)
    );
  APPL_VCI_6_Q : X_SFF
    port map (
      I => VCI_02(6),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VCI(6)
    );
  APPL_VCI_7_Q : X_SFF
    port map (
      I => VCI_02(7),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VCI(7)
    );
  APPL_VCI_8_Q : X_SFF
    port map (
      I => VCI_02(8),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VCI(8)
    );
  APPL_VCI_9_Q : X_SFF
    port map (
      I => VCI_02(9),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VCI(9)
    );
  APPL_VCI_10_Q : X_SFF
    port map (
      I => VCI_02(10),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VCI(10)
    );
  APPL_VCI_11_Q : X_SFF
    port map (
      I => VCI_02(11),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VCI(11)
    );
  APPL_VCI_12_Q : X_SFF
    port map (
      I => VCI_02(12),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VCI(12)
    );
  APPL_VCI_13_Q : X_SFF
    port map (
      I => VCI_02(13),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VCI(13)
    );
  APPL_VCI_14_Q : X_SFF
    port map (
      I => VCI_02(14),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VCI(14)
    );
  APPL_VCI_15_Q : X_SFF
    port map (
      I => VCI_02(15),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VCI(15)
    );
  APPL_VPI_0_Q : X_SFF
    port map (
      I => VPI_02(0),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VPI(0)
    );
  APPL_VPI_1_Q : X_SFF
    port map (
      I => VPI_02(1),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VPI(1)
    );
  APPL_VPI_2_Q : X_SFF
    port map (
      I => VPI_02(2),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VPI(2)
    );
  APPL_VPI_3_Q : X_SFF
    port map (
      I => VPI_02(3),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VPI(3)
    );
  APPL_VPI_4_Q : X_SFF
    port map (
      I => VPI_02(4),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VPI(4)
    );
  APPL_VPI_5_Q : X_SFF
    port map (
      I => VPI_02(5),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VPI(5)
    );
  APPL_VPI_6_Q : X_SFF
    port map (
      I => VPI_02(6),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VPI(6)
    );
  APPL_VPI_7_Q : X_SFF
    port map (
      I => VPI_02(7),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VPI(7)
    );
  APPL_VPI_8_Q : X_SFF
    port map (
      I => VPI_02(8),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VPI(8)
    );
  APPL_VPI_9_Q : X_SFF
    port map (
      I => VPI_02(9),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VPI(9)
    );
  APPL_VPI_10_Q : X_SFF
    port map (
      I => VPI_02(10),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VPI(10)
    );
  APPL_VPI_11_Q : X_SFF
    port map (
      I => VPI_02(11),
      CLK => CLK,
      CE => N_2998,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => APPL_VPI(11)
    );
  CC_SEL_CRC_111 : X_SFF
    port map (
      I => G_3665,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => GENCOUNT(2),
      O => CC_SEL_CRC
    );
  CC_SEL_CRC_DELAY_112 : X_FF
    port map (
      I => CC_SEL_CRC,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CC_SEL_CRC_DELAY
    );
  CCOPCODE_0_Q : X_FF
    port map (
      I => NGD2VHDL_OI50,
      CLK => CLK,
      CE => STATE(3),
      SET => GND,
      RST => GSR,
      O => CCOPCODE(0)
    );
  CCOPCODE_1_Q : X_FF
    port map (
      I => NGD2VHDL_OI49,
      CLK => CLK,
      CE => STATE(3),
      SET => GND,
      RST => GSR,
      O => CCOPCODE(1)
    );
  CCOPCODE_2_Q : X_FF
    port map (
      I => NGD2VHDL_OI48,
      CLK => CLK,
      CE => STATE(3),
      SET => GND,
      RST => GSR,
      O => CCOPCODE(2)
    );
  CCOPCODE_3_Q : X_FF
    port map (
      I => NGD2VHDL_OI47,
      CLK => CLK,
      CE => STATE(3),
      SET => GND,
      RST => GSR,
      O => CCOPCODE(3)
    );
  CCOPCODE_4_Q : X_FF
    port map (
      I => NGD2VHDL_OI46,
      CLK => CLK,
      CE => STATE(3),
      SET => GND,
      RST => GSR,
      O => CCOPCODE(4)
    );
  CCOPCODE_5_Q : X_FF
    port map (
      I => NGD2VHDL_OI45,
      CLK => CLK,
      CE => STATE(3),
      SET => GND,
      RST => GSR,
      O => CCOPCODE(5)
    );
  CCOPCODE_6_Q : X_FF
    port map (
      I => NGD2VHDL_OI44,
      CLK => CLK,
      CE => STATE(3),
      SET => GND,
      RST => GSR,
      O => CCOPCODE(6)
    );
  CCOPCODE_7_Q : X_FF
    port map (
      I => NGD2VHDL_OI43,
      CLK => CLK,
      CE => STATE(3),
      SET => GND,
      RST => GSR,
      O => CCOPCODE(7)
    );
  CCSELECTION_UN5_GENCOUNT_I_AND2_I : X_LUT4
    generic map (
      INIT => X"555D"
    )
    port map (
      ADR0 => SEL_STATE(0),
      ADR1 => N_894_1,
      ADR2 => N_3684,
      ADR3 => GENCOUNT(2),
      O => N_3154
    );
  CMDATA_STORE_0_Q : X_FF
    port map (
      I => NGD2VHDL_OI74,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(0)
    );
  CMDATA_STORE_1_Q : X_FF
    port map (
      I => NGD2VHDL_OI73,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(1)
    );
  CMDATA_STORE_2_Q : X_FF
    port map (
      I => NGD2VHDL_OI72,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(2)
    );
  CMDATA_STORE_3_Q : X_FF
    port map (
      I => NGD2VHDL_OI71,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(3)
    );
  CMDATA_STORE_4_Q : X_FF
    port map (
      I => NGD2VHDL_OI70,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(4)
    );
  CMDATA_STORE_5_Q : X_FF
    port map (
      I => NGD2VHDL_OI69,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(5)
    );
  CMDATA_STORE_6_Q : X_FF
    port map (
      I => NGD2VHDL_OI68,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(6)
    );
  CMDATA_STORE_7_Q : X_FF
    port map (
      I => NGD2VHDL_OI67,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(7)
    );
  CMDATA_STORE_8_Q : X_FF
    port map (
      I => NGD2VHDL_OI66,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(8)
    );
  CMDATA_STORE_9_Q : X_FF
    port map (
      I => NGD2VHDL_OI65,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(9)
    );
  CMDATA_STORE_10_Q : X_FF
    port map (
      I => NGD2VHDL_OI64,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(10)
    );
  CMDATA_STORE_11_Q : X_FF
    port map (
      I => NGD2VHDL_OI63,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(11)
    );
  CMDATA_STORE_12_Q : X_FF
    port map (
      I => NGD2VHDL_OI62,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(12)
    );
  CMDATA_STORE_13_Q : X_FF
    port map (
      I => NGD2VHDL_OI61,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(13)
    );
  CMDATA_STORE_14_Q : X_FF
    port map (
      I => NGD2VHDL_OI60,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(14)
    );
  CMDATA_STORE_15_Q : X_FF
    port map (
      I => NGD2VHDL_OI59,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(15)
    );
  CMDATA_STORE_16_Q : X_FF
    port map (
      I => NGD2VHDL_OI58,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(16)
    );
  CMDATA_STORE_17_Q : X_FF
    port map (
      I => NGD2VHDL_OI57,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(17)
    );
  CMDATA_STORE_18_Q : X_FF
    port map (
      I => NGD2VHDL_OI56,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(18)
    );
  CMDATA_STORE_19_Q : X_FF
    port map (
      I => NGD2VHDL_OI55,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(19)
    );
  CMDATA_STORE_20_Q : X_FF
    port map (
      I => NGD2VHDL_OI54,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(20)
    );
  CMDATA_STORE_21_Q : X_FF
    port map (
      I => NGD2VHDL_OI53,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(21)
    );
  CMDATA_STORE_22_Q : X_FF
    port map (
      I => NGD2VHDL_OI52,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(22)
    );
  CMDATA_STORE_23_Q : X_FF
    port map (
      I => NGD2VHDL_OI51,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(23)
    );
  CMDATA_STORE_24_Q : X_FF
    port map (
      I => NGD2VHDL_OI50,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(24)
    );
  CMDATA_STORE_25_Q : X_FF
    port map (
      I => NGD2VHDL_OI49,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(25)
    );
  CMDATA_STORE_26_Q : X_FF
    port map (
      I => NGD2VHDL_OI48,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(26)
    );
  CMDATA_STORE_27_Q : X_FF
    port map (
      I => NGD2VHDL_OI47,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(27)
    );
  CMDATA_STORE_28_Q : X_FF
    port map (
      I => NGD2VHDL_OI46,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(28)
    );
  CMDATA_STORE_29_Q : X_FF
    port map (
      I => NGD2VHDL_OI45,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(29)
    );
  CMDATA_STORE_30_Q : X_FF
    port map (
      I => NGD2VHDL_OI44,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(30)
    );
  CMDATA_STORE_31_Q : X_FF
    port map (
      I => NGD2VHDL_OI43,
      CLK => CLK,
      CE => STATE(1),
      SET => GND,
      RST => GSR,
      O => CMDATA_STORE(31)
    );
  CTRLCELL_VCI_0_Q : X_SFF
    port map (
      I => VCI_02(0),
      CLK => CLK,
      CE => N_2997,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CTRLCELL_VCI(0)
    );
  CTRLCELL_VCI_1_Q : X_SFF
    port map (
      I => VCI_02(1),
      CLK => CLK,
      CE => N_2997,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CTRLCELL_VCI(1)
    );
  CTRLCELL_VCI_2_Q : X_SFF
    port map (
      I => VCI_02(2),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VCI(2)
    );
  CTRLCELL_VCI_3_Q : X_SFF
    port map (
      I => VCI_02(3),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VCI(3)
    );
  CTRLCELL_VCI_4_Q : X_SFF
    port map (
      I => VCI_02(4),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VCI(4)
    );
  CTRLCELL_VCI_5_Q : X_SFF
    port map (
      I => VCI_02(5),
      CLK => CLK,
      CE => N_2997,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CTRLCELL_VCI(5)
    );
  CTRLCELL_VCI_6_Q : X_SFF
    port map (
      I => VCI_02(6),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VCI(6)
    );
  CTRLCELL_VCI_7_Q : X_SFF
    port map (
      I => VCI_02(7),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VCI(7)
    );
  CTRLCELL_VCI_8_Q : X_SFF
    port map (
      I => VCI_02(8),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VCI(8)
    );
  CTRLCELL_VCI_9_Q : X_SFF
    port map (
      I => VCI_02(9),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VCI(9)
    );
  CTRLCELL_VCI_10_Q : X_SFF
    port map (
      I => VCI_02(10),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VCI(10)
    );
  CTRLCELL_VCI_11_Q : X_SFF
    port map (
      I => VCI_02(11),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VCI(11)
    );
  CTRLCELL_VCI_12_Q : X_SFF
    port map (
      I => VCI_02(12),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VCI(12)
    );
  CTRLCELL_VCI_13_Q : X_SFF
    port map (
      I => VCI_02(13),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VCI(13)
    );
  CTRLCELL_VCI_14_Q : X_SFF
    port map (
      I => VCI_02(14),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VCI(14)
    );
  CTRLCELL_VCI_15_Q : X_SFF
    port map (
      I => VCI_02(15),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VCI(15)
    );
  CTRLCELL_VPI_0_Q : X_SFF
    port map (
      I => VPI_02(0),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VPI(0)
    );
  CTRLCELL_VPI_1_Q : X_SFF
    port map (
      I => VPI_02(1),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VPI(1)
    );
  CTRLCELL_VPI_2_Q : X_SFF
    port map (
      I => VPI_02(2),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VPI(2)
    );
  CTRLCELL_VPI_3_Q : X_SFF
    port map (
      I => VPI_02(3),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VPI(3)
    );
  CTRLCELL_VPI_4_Q : X_SFF
    port map (
      I => VPI_02(4),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VPI(4)
    );
  CTRLCELL_VPI_5_Q : X_SFF
    port map (
      I => VPI_02(5),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VPI(5)
    );
  CTRLCELL_VPI_6_Q : X_SFF
    port map (
      I => VPI_02(6),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VPI(6)
    );
  CTRLCELL_VPI_7_Q : X_SFF
    port map (
      I => VPI_02(7),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VPI(7)
    );
  CTRLCELL_VPI_8_Q : X_SFF
    port map (
      I => VPI_02(8),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VPI(8)
    );
  CTRLCELL_VPI_9_Q : X_SFF
    port map (
      I => VPI_02(9),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VPI(9)
    );
  CTRLCELL_VPI_10_Q : X_SFF
    port map (
      I => VPI_02(10),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VPI(10)
    );
  CTRLCELL_VPI_11_Q : X_SFF
    port map (
      I => VPI_02(11),
      CLK => CLK,
      CE => N_2997,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CTRLCELL_VPI(11)
    );
  DATA00_OUT_DATA_00_2_1_0_10_Q : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_3804,
      ADR1 => N_3805,
      ADR2 => CTRLCELL_VCI(6),
      ADR3 => N_3835,
      O => DATA00_OUT_DATA_00_2_10_Q
    );
  DATA00_OUT_DATA_00_2_1_0_AND2_10_Q : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => STATE00(1),
      ADR1 => CMDATA_STORE(10),
      O => N_3805
    );
  DATA00_OUT_DATA_00_2_2_0_0_Q : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => N_3728,
      ADR1 => N_3834,
      ADR2 => CMDATA_STORE(0),
      ADR3 => STATE00(1),
      O => DATA00_OUT_DATA_00_2_0_Q
    );
  DATA00_OUT_DATA_00_2_2_0_1_Q : X_LUT3
    generic map (
      INIT => X"FE"
    )
    port map (
      ADR0 => N_3817,
      ADR1 => N_3417,
      ADR2 => N_3823,
      O => DATA00_OUT_DATA_00_2_1_Q
    );
  DATA00_OUT_DATA_00_2_2_0_2_Q : X_LUT4
    generic map (
      INIT => X"EEFE"
    )
    port map (
      ADR0 => N_3820,
      ADR1 => N_3821,
      ADR2 => N_3911,
      ADR3 => GENCOUNT(1),
      O => DATA00_OUT_DATA_00_2_2_Q
    );
  DATA00_OUT_DATA_00_2_2_0_3_Q : X_LUT4
    generic map (
      INIT => X"AEAA"
    )
    port map (
      ADR0 => N_2994,
      ADR1 => GENCOUNT(1),
      ADR2 => N_1892_I,
      ADR3 => N_3834,
      O => DATA00_OUT_DATA_00_2_3_Q
    );
  DATA00_OUT_DATA_00_2_2_0_4_Q : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_3817,
      ADR1 => G_3644_S,
      ADR2 => CTRLCELL_VCI(0),
      ADR3 => N_3835,
      O => DATA00_OUT_DATA_00_2_4_Q
    );
  DATA00_OUT_DATA_00_2_2_0_5_Q : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA00_OUT_DATA_00_2_2_0_S_5_Q,
      ADR1 => N_3815,
      ADR2 => CTRLCELL_VCI(1),
      ADR3 => N_3835,
      O => DATA00_OUT_DATA_00_2_5_Q
    );
  DATA00_OUT_DATA_00_2_2_0_6_Q : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA00_OUT_DATA_00_2_2_0_S_6_Q,
      ADR1 => N_3812,
      ADR2 => CTRLCELL_VCI(2),
      ADR3 => N_3835,
      O => DATA00_OUT_DATA_00_2_6_Q
    );
  DATA00_OUT_DATA_00_2_2_0_8_Q : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_2990,
      ADR1 => N_2991,
      ADR2 => CTRLCELL_VCI(4),
      ADR3 => N_3835,
      O => DATA00_OUT_DATA_00_2_8_Q
    );
  DATA00_OUT_DATA_00_2_2_0_9_Q : X_MUX2
    port map (
      IA => DATA00_OUT_DATA_00_2_2_0_X0(9),
      IB => DATA00_OUT_DATA_00_2_2_0_TRUE(9),
      SEL => G_3639_S,
      O => DATA00_OUT_DATA_00_2_9_Q
    );
  DATA00_OUT_DATA_00_2_2_0_11_Q : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_3804,
      ADR1 => N_3802,
      ADR2 => CTRLCELL_VCI(7),
      ADR3 => N_3835,
      O => DATA00_OUT_DATA_00_2_11_Q
    );
  DATA00_OUT_DATA_00_2_2_0_12_Q : X_LUT4
    generic map (
      INIT => X"AEAA"
    )
    port map (
      ADR0 => G_3637,
      ADR1 => GENCOUNT(2),
      ADR2 => GENCOUNT(0),
      ADR3 => N_3834,
      O => DATA00_OUT_DATA_00_2_12_Q
    );
  DATA00_OUT_DATA_00_2_2_0_13_Q : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_3834,
      ADR1 => N_3796,
      ADR2 => CTRLCELL_VCI(9),
      ADR3 => N_3835,
      O => DATA00_OUT_DATA_00_2_13_Q
    );
  DATA00_OUT_DATA_00_2_2_0_14_Q : X_LUT3
    generic map (
      INIT => X"BA"
    )
    port map (
      ADR0 => G_3622,
      ADR1 => N_1892_I,
      ADR2 => N_3834,
      O => DATA00_OUT_DATA_00_2_14_Q
    );
  DATA00_OUT_DATA_00_2_2_0_16_Q : X_LUT4
    generic map (
      INIT => X"FFF2"
    )
    port map (
      ADR0 => N_3850,
      ADR1 => N_1892_I,
      ADR2 => G_3652_S,
      ADR3 => G_3650,
      O => DATA00_OUT_DATA_00_2_16_Q
    );
  DATA00_OUT_DATA_00_2_2_0_18_Q : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => G_3597,
      ADR1 => N_3418,
      ADR2 => SEQUENCENR(2),
      ADR3 => N_3844,
      O => DATA00_OUT_DATA_00_2_18_Q
    );
  DATA00_OUT_DATA_00_2_2_0_19_Q : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => G_3536,
      ADR1 => N_3793,
      ADR2 => CTRLCELL_VCI(15),
      ADR3 => N_3835,
      O => DATA00_OUT_DATA_00_2_19_Q
    );
  DATA00_OUT_DATA_00_2_2_0_20_Q : X_LUT4
    generic map (
      INIT => X"FFF8"
    )
    port map (
      ADR0 => N_894_1,
      ADR1 => N_3552,
      ADR2 => N_3417,
      ADR3 => DATA00_OUT_DATA_00_2_2_0_SX_20_Q,
      O => DATA00_OUT_DATA_00_2_20_Q
    );
  DATA00_OUT_DATA_00_2_2_0_21_Q : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA00_OUT_DATA_00_2_2_0_S_21_Q,
      ADR1 => N_3409,
      ADR2 => CTRLCELL_VPI(1),
      ADR3 => N_3835,
      O => DATA00_OUT_DATA_00_2_21_Q
    );
  DATA00_OUT_DATA_00_2_2_0_22_Q : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_3834,
      ADR1 => G_3543,
      ADR2 => SEQUENCENR(6),
      ADR3 => N_3844,
      O => DATA00_OUT_DATA_00_2_22_Q
    );
  DATA00_OUT_DATA_00_2_2_0_23_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3530,
      ADR1 => SEQUENCENR(7),
      ADR2 => N_3844,
      O => DATA00_OUT_DATA_00_2_23_Q
    );
  DATA00_OUT_DATA_00_2_2_0_24_Q : X_LUT4
    generic map (
      INIT => X"EEAE"
    )
    port map (
      ADR0 => G_3599,
      ADR1 => N_3834,
      ADR2 => GENCOUNT(0),
      ADR3 => GENCOUNT(2),
      O => DATA00_OUT_DATA_00_2_24_Q
    );
  DATA00_OUT_DATA_00_2_2_0_25_Q : X_LUT3
    generic map (
      INIT => X"FE"
    )
    port map (
      ADR0 => DATA00_OUT_DATA_00_2_2_0_S_SX(25),
      ADR1 => DATA00_OUT_DATA_00_2_2_0_SX_25_Q,
      ADR2 => N_3404,
      O => DATA00_OUT_DATA_00_2_25_Q
    );
  DATA00_OUT_DATA_00_2_2_0_26_Q : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA00_OUT_DATA_00_2_2_0_S_26_Q,
      ADR1 => G_3654_S,
      ADR2 => CTRLCELL_VPI(6),
      ADR3 => N_3835,
      O => DATA00_OUT_DATA_00_2_26_Q
    );
  DATA00_OUT_DATA_00_2_2_0_28_Q : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => G_3537,
      ADR1 => N_3784,
      ADR2 => SEQUENCENR(12),
      ADR3 => N_3844,
      O => DATA00_OUT_DATA_00_2_28_Q
    );
  DATA00_OUT_DATA_00_2_2_0_31_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3533,
      ADR1 => SEQUENCENR(15),
      ADR2 => N_3844,
      O => DATA00_OUT_DATA_00_2_31_Q
    );
  DATA00_OUT_DATA_00_2_2_0_4_G_3644_S : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => N_3911,
      ADR1 => CMDATA_STORE(4),
      ADR2 => STATE00(1),
      O => G_3644_S
    );
  DATA00_OUT_DATA_00_2_2_0_9_G_3639_S : X_LUT4
    generic map (
      INIT => X"F444"
    )
    port map (
      ADR0 => N_3683,
      ADR1 => N_3834,
      ADR2 => CMDATA_STORE(9),
      ADR3 => STATE00(1),
      O => G_3639_S
    );
  DATA00_OUT_DATA_00_2_2_0_12_G_3637 : X_LUT4
    generic map (
      INIT => X"FF10"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => N_3684,
      ADR2 => N_3834,
      ADR3 => DATA00_OUT_DATA_00_2_2_0_12_G_3637_SX,
      O => G_3637
    );
  DATA00_OUT_DATA_00_2_2_0_12_G_3637_SX_113 : X_LUT3
    generic map (
      INIT => X"B8"
    )
    port map (
      ADR0 => CMDATA_STORE(12),
      ADR1 => STATE00(1),
      ADR2 => DATA00_OUT_DATA_00_2_2_0_AND2_0_S(12),
      O => DATA00_OUT_DATA_00_2_2_0_12_G_3637_SX
    );
  DATA00_OUT_DATA_00_2_2_0_14_G_3622 : X_LUT4
    generic map (
      INIT => X"B888"
    )
    port map (
      ADR0 => CMDATA_STORE(14),
      ADR1 => STATE00(1),
      ADR2 => CTRLCELL_VCI(10),
      ADR3 => STATE00(5),
      O => G_3622
    );
  DATA00_OUT_DATA_00_2_2_0_16_G_3649 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => CMDATA_STORE(16),
      ADR1 => STATE00(1),
      ADR2 => STATE00(3),
      ADR3 => N_3464,
      O => G_3649
    );
  DATA00_OUT_DATA_00_2_2_0_16_G_3650 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3649,
      ADR1 => CTRLCELL_VCI(12),
      ADR2 => N_3835,
      O => G_3650
    );
  DATA00_OUT_DATA_00_2_2_0_16_G_3652_S : X_LUT4
    generic map (
      INIT => X"F222"
    )
    port map (
      ADR0 => N_3834,
      ADR1 => N_3689,
      ADR2 => SEQUENCENR(0),
      ADR3 => N_3844,
      O => G_3652_S
    );
  DATA00_OUT_DATA_00_2_2_0_18_G_3597 : X_LUT4
    generic map (
      INIT => X"B888"
    )
    port map (
      ADR0 => CMDATA_STORE(18),
      ADR1 => STATE00(1),
      ADR2 => CTRLCELL_VCI(14),
      ADR3 => STATE00(5),
      O => G_3597
    );
  DATA00_OUT_DATA_00_2_2_0_19_G_3536 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEQUENCENR(3),
      ADR1 => N_3844,
      ADR2 => G_3522,
      ADR3 => N_3465,
      O => G_3536
    );
  DATA00_OUT_DATA_00_2_2_0_20_G_3645 : X_LUT4
    generic map (
      INIT => X"B888"
    )
    port map (
      ADR0 => CMDATA_STORE(20),
      ADR1 => STATE00(1),
      ADR2 => CTRLCELL_VPI(0),
      ADR3 => STATE00(5),
      O => G_3645
    );
  DATA00_OUT_DATA_00_2_2_0_22_G_3543 : X_LUT4
    generic map (
      INIT => X"B888"
    )
    port map (
      ADR0 => CMDATA_STORE(22),
      ADR1 => STATE00(1),
      ADR2 => STATE00(5),
      ADR3 => CTRLCELL_VPI(2),
      O => G_3543
    );
  DATA00_OUT_DATA_00_2_2_0_23_G_3530 : X_LUT4
    generic map (
      INIT => X"B888"
    )
    port map (
      ADR0 => CMDATA_STORE(23),
      ADR1 => STATE00(1),
      ADR2 => CTRLCELL_VPI(3),
      ADR3 => STATE00(5),
      O => G_3530
    );
  DATA00_OUT_DATA_00_2_2_0_24_G_3599 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3599_S,
      ADR1 => CTRLCELL_VPI(4),
      ADR2 => N_3835,
      O => G_3599
    );
  DATA00_OUT_DATA_00_2_2_0_24_G_3599_S : X_LUT4
    generic map (
      INIT => X"88B8"
    )
    port map (
      ADR0 => CMDATA_STORE(24),
      ADR1 => STATE00(1),
      ADR2 => N_3724,
      ADR3 => STATE00(5),
      O => G_3599_S
    );
  DATA00_OUT_DATA_00_2_2_0_26_G_3654_S : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEQUENCENR(10),
      ADR1 => N_3844,
      ADR2 => CMDATA_STORE(26),
      ADR3 => STATE00(1),
      O => G_3654_S
    );
  DATA00_OUT_DATA_00_2_2_0_28_G_3537 : X_LUT4
    generic map (
      INIT => X"B888"
    )
    port map (
      ADR0 => CMDATA_STORE(28),
      ADR1 => STATE00(1),
      ADR2 => CTRLCELL_VPI(8),
      ADR3 => STATE00(5),
      O => G_3537
    );
  DATA00_OUT_DATA_00_2_2_0_31_G_3533 : X_LUT4
    generic map (
      INIT => X"B888"
    )
    port map (
      ADR0 => CMDATA_STORE(31),
      ADR1 => STATE00(1),
      ADR2 => CTRLCELL_VPI(11),
      ADR3 => STATE00(5),
      O => G_3533
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_1_Q : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => STATE00(1),
      ADR1 => CMDATA_STORE(1),
      O => N_3823
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_2_Q : X_LUT4
    generic map (
      INIT => X"00B0"
    )
    port map (
      ADR0 => GENCOUNT(1),
      ADR1 => GENCOUNT(0),
      ADR2 => N_3834,
      ADR3 => GENCOUNT(2),
      O => N_3820
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_4_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => N_3834,
      ADR1 => GENCOUNT(1),
      ADR2 => GENCOUNT(2),
      O => N_3817
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_8_Q : X_LUT4
    generic map (
      INIT => X"0828"
    )
    port map (
      ADR0 => N_3834,
      ADR1 => GENCOUNT(2),
      ADR2 => GENCOUNT(0),
      ADR3 => GENCOUNT(1),
      O => N_2990
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_11_Q : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => STATE00(1),
      ADR1 => CMDATA_STORE(11),
      O => N_3802
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_13_Q : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => STATE00(1),
      ADR1 => CMDATA_STORE(13),
      O => N_3796
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_18_Q : X_LUT4
    generic map (
      INIT => X"820A"
    )
    port map (
      ADR0 => N_3834,
      ADR1 => GENCOUNT(2),
      ADR2 => GENCOUNT(0),
      ADR3 => GENCOUNT(1),
      O => N_3418
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_20_Q : X_LUT4
    generic map (
      INIT => X"0008"
    )
    port map (
      ADR0 => GENCOUNT(2),
      ADR1 => G_2535_S,
      ADR2 => STATE00(1),
      ADR3 => DATA00_OUT_DATA_00_2_2_0_AND2_SX(20),
      O => N_3412
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_21_Q : X_MUX2
    port map (
      IA => DATA00_OUT_DATA_00_2_2_0_AND2_X0(21),
      IB => GND_INT,
      SEL => DATA00_OUT_DATA_00_2_2_0_AND2_4_SX(20),
      O => N_3408
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_25_Q : X_LUT4
    generic map (
      INIT => X"2202"
    )
    port map (
      ADR0 => G_2535_S,
      ADR1 => DATA00_OUT_DATA_00_2_2_0_AND2_4_SX(20),
      ADR2 => GENCOUNT(1),
      ADR3 => N_3683,
      O => N_3404
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_0_2_Q : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => STATE00(1),
      ADR1 => CMDATA_STORE(2),
      O => N_3821
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_0_3_Q : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => STATE00(1),
      ADR1 => CMDATA_STORE(3),
      O => N_2994
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_0_5_Q : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => STATE00(1),
      ADR1 => CMDATA_STORE(5),
      O => N_3815
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_0_6_Q : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => STATE00(1),
      ADR1 => CMDATA_STORE(6),
      O => N_3812
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_0_8_Q : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => STATE00(1),
      ADR1 => CMDATA_STORE(8),
      O => N_2991
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_0_19_Q : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => STATE00(1),
      ADR1 => CMDATA_STORE(19),
      O => N_3793
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_0_21_Q : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => STATE00(1),
      ADR1 => CMDATA_STORE(21),
      O => N_3409
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_0_25_Q : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => STATE00(1),
      ADR1 => CMDATA_STORE(25),
      O => N_3405
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_0_S_12_Q : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => CTRLCELL_VCI(8),
      ADR1 => STATE00(5),
      O => DATA00_OUT_DATA_00_2_2_0_AND2_0_S(12)
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_1_11_Q : X_LUT2
    generic map (
      INIT => X"2"
    )
    port map (
      ADR0 => N_3834,
      ADR1 => N_3689,
      O => N_3804
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_2_28_Q : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => N_3465,
      ADR1 => N_3833,
      ADR2 => GENCOUNT(1),
      O => N_3784
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_4_20_Q : X_LUT4
    generic map (
      INIT => X"0002"
    )
    port map (
      ADR0 => G_2535_S,
      ADR1 => DATA00_OUT_DATA_00_2_2_0_AND2_4_SX(20),
      ADR2 => GENCOUNT(2),
      ADR3 => N_3684,
      O => N_3417
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_4_SX_20_Q : X_LUT3
    generic map (
      INIT => X"FE"
    )
    port map (
      ADR0 => STATE00(5),
      ADR1 => GENCOUNT_FAST(3),
      ADR2 => STATE00_FAST(1),
      O => DATA00_OUT_DATA_00_2_2_0_AND2_4_SX(20)
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_19_G_3522 : X_LUT4
    generic map (
      INIT => X"4004"
    )
    port map (
      ADR0 => N_894_1,
      ADR1 => GENCOUNT(0),
      ADR2 => GENCOUNT(2),
      ADR3 => GENCOUNT(1),
      O => G_3522
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_SX_20_Q : X_LUT4
    generic map (
      INIT => X"FFF9"
    )
    port map (
      ADR0 => GENCOUNT_FAST_0_0_Q,
      ADR1 => GENCOUNT(1),
      ADR2 => STATE00(5),
      ADR3 => N_894_1,
      O => DATA00_OUT_DATA_00_2_2_0_AND2_SX(20)
    );
  DATA00_OUT_DATA_00_2_2_0_AND2_X0_21_Q : X_LUT4
    generic map (
      INIT => X"F070"
    )
    port map (
      ADR0 => GENCOUNT_FAST_0_0_Q,
      ADR1 => GENCOUNT_FAST(1),
      ADR2 => G_2535_S,
      ADR3 => GENCOUNT_FAST_0_2_Q,
      O => DATA00_OUT_DATA_00_2_2_0_AND2_X0(21)
    );
  DATA00_OUT_DATA_00_2_2_0_S_5_Q_114 : X_LUT4
    generic map (
      INIT => X"A2AA"
    )
    port map (
      ADR0 => N_3834,
      ADR1 => GENCOUNT(2),
      ADR2 => GENCOUNT(1),
      ADR3 => GENCOUNT(0),
      O => DATA00_OUT_DATA_00_2_2_0_S_5_Q
    );
  DATA00_OUT_DATA_00_2_2_0_S_6_Q_115 : X_LUT4
    generic map (
      INIT => X"4CC4"
    )
    port map (
      ADR0 => GENCOUNT(0),
      ADR1 => N_3834,
      ADR2 => GENCOUNT(2),
      ADR3 => GENCOUNT(1),
      O => DATA00_OUT_DATA_00_2_2_0_S_6_Q
    );
  DATA00_OUT_DATA_00_2_2_0_S_21_Q_116 : X_MUX2
    port map (
      IA => DATA00_OUT_DATA_00_2_2_0_S_X0(21),
      IB => DATA00_OUT_DATA_00_2_2_0_S_TRUE(21),
      SEL => N_3408,
      O => DATA00_OUT_DATA_00_2_2_0_S_21_Q
    );
  DATA00_OUT_DATA_00_2_2_0_S_26_Q_117 : X_LUT4
    generic map (
      INIT => X"FF40"
    )
    port map (
      ADR0 => N_3294_I,
      ADR1 => GENCOUNT(2),
      ADR2 => N_3834,
      ADR3 => N_3552,
      O => DATA00_OUT_DATA_00_2_2_0_S_26_Q
    );
  DATA00_OUT_DATA_00_2_2_0_S_SX_25_Q : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => N_3844,
      ADR1 => SEQUENCENR(9),
      ADR2 => N_3550,
      ADR3 => N_3465,
      O => DATA00_OUT_DATA_00_2_2_0_S_SX(25)
    );
  DATA00_OUT_DATA_00_2_2_0_S_TRUE_21_Q : X_LUT2
    generic map (
      INIT => X"F"
    )
    port map (
      ADR0 => GND_INT,
      ADR1 => GND,
      O => DATA00_OUT_DATA_00_2_2_0_S_TRUE(21)
    );
  DATA00_OUT_DATA_00_2_2_0_S_X0_21_Q : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => N_3550,
      ADR1 => N_3465,
      ADR2 => N_3844,
      ADR3 => SEQUENCENR(5),
      O => DATA00_OUT_DATA_00_2_2_0_S_X0(21)
    );
  DATA00_OUT_DATA_00_2_2_0_SX_20_Q_118 : X_LUT4
    generic map (
      INIT => X"FFF8"
    )
    port map (
      ADR0 => N_3844,
      ADR1 => SEQUENCENR(4),
      ADR2 => G_3645,
      ADR3 => N_3412,
      O => DATA00_OUT_DATA_00_2_2_0_SX_20_Q
    );
  DATA00_OUT_DATA_00_2_2_0_SX_25_Q_119 : X_LUT4
    generic map (
      INIT => X"FF40"
    )
    port map (
      ADR0 => STATE00(1),
      ADR1 => STATE00(5),
      ADR2 => CTRLCELL_VPI(5),
      ADR3 => N_3405,
      O => DATA00_OUT_DATA_00_2_2_0_SX_25_Q
    );
  DATA00_OUT_DATA_00_2_2_0_TRUE_9_Q : X_LUT2
    generic map (
      INIT => X"F"
    )
    port map (
      ADR0 => GND_INT,
      ADR1 => GND,
      O => DATA00_OUT_DATA_00_2_2_0_TRUE(9)
    );
  DATA00_OUT_DATA_00_2_2_0_X0_9_Q : X_LUT4
    generic map (
      INIT => X"F222"
    )
    port map (
      ADR0 => N_3850,
      ADR1 => GENCOUNT(2),
      ADR2 => N_3835,
      ADR3 => CTRLCELL_VCI(5),
      O => DATA00_OUT_DATA_00_2_2_0_X0(9)
    );
  DATA00_OUT_DATA_00_2_I_0_AND2_29_Q : X_LUT2
    generic map (
      INIT => X"2"
    )
    port map (
      ADR0 => N_3464,
      ADR1 => N_3009_1,
      O => N_3431
    );
  DATA00_OUT_DATA_00_2_I_0_AND2_3_29_Q : X_LUT3
    generic map (
      INIT => X"02"
    )
    port map (
      ADR0 => N_3464,
      ADR1 => N_3689,
      ADR2 => N_894_1,
      O => N_3435
    );
  DATA00_OUT_DATA_00_2_I_I_7_Q_120 : X_LUT4
    generic map (
      INIT => X"CAC0"
    )
    port map (
      ADR0 => CTRLCELL_VCI(3),
      ADR1 => CMDATA_STORE(7),
      ADR2 => STATE00(1),
      ADR3 => STATE00(5),
      O => DATA00_OUT_DATA_00_2_I_I_7_Q
    );
  DATA00_OUT_DATA_00_2_I_I_15_Q_121 : X_LUT4
    generic map (
      INIT => X"CAC0"
    )
    port map (
      ADR0 => CTRLCELL_VCI(11),
      ADR1 => CMDATA_STORE(15),
      ADR2 => STATE00(1),
      ADR3 => STATE00(5),
      O => DATA00_OUT_DATA_00_2_I_I_15_Q
    );
  DATA00_OUT_DATA_00_2_I_I_17_Q_122 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_3013,
      ADR1 => G_3640,
      ADR2 => SEQUENCENR(1),
      ADR3 => N_3844,
      O => DATA00_OUT_DATA_00_2_I_I_17_Q
    );
  DATA00_OUT_DATA_00_2_I_I_27_Q_123 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => G_3532,
      ADR1 => N_3009,
      ADR2 => CMDATA_STORE(27),
      ADR3 => STATE00(1),
      O => DATA00_OUT_DATA_00_2_I_I_27_Q
    );
  DATA00_OUT_DATA_00_2_I_I_30_Q_124 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => N_3408,
      ADR1 => G_3620,
      ADR2 => SEQUENCENR(14),
      ADR3 => N_3844,
      O => DATA00_OUT_DATA_00_2_I_I_30_Q
    );
  DATA00_OUT_DATA_00_2_I_I_17_G_3640 : X_LUT4
    generic map (
      INIT => X"B888"
    )
    port map (
      ADR0 => CMDATA_STORE(17),
      ADR1 => STATE00(1),
      ADR2 => STATE00(5),
      ADR3 => CTRLCELL_VCI(13),
      O => G_3640
    );
  DATA00_OUT_DATA_00_2_I_I_27_G_3532 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => CTRLCELL_VPI(7),
      ADR1 => N_3835,
      ADR2 => SEQUENCENR(11),
      ADR3 => N_3844,
      O => G_3532
    );
  DATA00_OUT_DATA_00_2_I_I_30_G_3620 : X_LUT4
    generic map (
      INIT => X"B888"
    )
    port map (
      ADR0 => CMDATA_STORE(30),
      ADR1 => STATE00(1),
      ADR2 => STATE00(5),
      ADR3 => CTRLCELL_VPI(10),
      O => G_3620
    );
  DATA00_OUT_DATA_00_2_I_I_AND2_17_Q : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => N_3834,
      ADR1 => GENCOUNT(2),
      ADR2 => N_3294_I,
      O => N_3013
    );
  DATA00_OUT_DATA_00_2_I_I_AND2_27_Q : X_LUT4
    generic map (
      INIT => X"8880"
    )
    port map (
      ADR0 => N_3464,
      ADR1 => N_3009_1,
      ADR2 => N_1892_I,
      ADR3 => N_894_1,
      O => N_3009
    );
  DATA00_OUT_DATA_00_2_I_I_AND2_1_0_27_Q : X_LUT2
    generic map (
      INIT => X"1"
    )
    port map (
      ADR0 => STATE00(4),
      ADR1 => STATE00(3),
      O => N_3009_1
    );
  DATA04_OUT_DATA_04_2_0_IV_0_1_Q : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => CMDATA_STORE(1),
      ADR1 => STATE04(1),
      ADR2 => REGNR_02(1),
      ADR3 => STATE04(4),
      O => DATA04_OUT_DATA_04_2(1)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_3_Q : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => CMDATA_STORE(3),
      ADR1 => STATE04(1),
      ADR2 => REGNR_02(3),
      ADR3 => STATE04(4),
      O => DATA04_OUT_DATA_04_2(3)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_24_Q : X_MUX2
    port map (
      IA => DATA04_OUT_DATA_04_2_0_IV_0_X0(24),
      IB => DATA04_OUT_DATA_04_2_0_IV_0_X1(24),
      SEL => G_3_FAST,
      O => DATA04_OUT_DATA_04_2(24)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_0_Q : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => CMDATA_STORE(0),
      ADR1 => STATE04(1),
      ADR2 => REGNR_02(0),
      ADR3 => STATE04(4),
      O => DATA04_OUT_DATA_04_2(0)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_2_Q : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => CMDATA_STORE(2),
      ADR1 => STATE04(1),
      ADR2 => REGNR_02(2),
      ADR3 => STATE04(4),
      O => DATA04_OUT_DATA_04_2(2)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_4_Q : X_MUX2
    port map (
      IA => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_4_Q,
      IB => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_4_Q,
      SEL => N_3285,
      O => DATA04_OUT_DATA_04_2(4)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_5_Q : X_MUX2
    port map (
      IA => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_5_Q,
      IB => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_5_Q,
      SEL => N_3285,
      O => DATA04_OUT_DATA_04_2(5)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_6_Q : X_LUT4
    generic map (
      INIT => X"FFF8"
    )
    port map (
      ADR0 => CTRLCELL_VCI(2),
      ADR1 => N_3285,
      ADR2 => N_2939,
      ADR3 => G_3593,
      O => DATA04_OUT_DATA_04_2(6)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_7_Q : X_LUT4
    generic map (
      INIT => X"EAAA"
    )
    port map (
      ADR0 => G_3448,
      ADR1 => N_2914,
      ADR2 => G_1,
      ADR3 => N_2848,
      O => DATA04_OUT_DATA_04_2(7)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_8_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3583,
      ADR1 => CTRLCELL_VCI(4),
      ADR2 => N_3285,
      O => DATA04_OUT_DATA_04_2(8)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_9_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3581,
      ADR1 => CTRLCELL_VCI(5),
      ADR2 => N_3285,
      O => DATA04_OUT_DATA_04_2(9)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_10_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3563,
      ADR1 => CTRLCELL_VCI(6),
      ADR2 => N_3285,
      O => DATA04_OUT_DATA_04_2(10)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_11_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3582,
      ADR1 => CTRLCELL_VCI(7),
      ADR2 => N_3285,
      O => DATA04_OUT_DATA_04_2(11)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_12_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3570,
      ADR1 => CTRLCELL_VCI(8),
      ADR2 => N_3285,
      O => DATA04_OUT_DATA_04_2(12)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_13_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3580,
      ADR1 => CTRLCELL_VCI(9),
      ADR2 => N_3285,
      O => DATA04_OUT_DATA_04_2(13)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_14_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3592,
      ADR1 => CTRLCELL_VCI(10),
      ADR2 => N_3285,
      O => DATA04_OUT_DATA_04_2(14)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_15_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3579,
      ADR1 => CTRLCELL_VCI(11),
      ADR2 => N_3285,
      O => DATA04_OUT_DATA_04_2(15)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_16_Q : X_MUX2
    port map (
      IA => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_16_Q,
      IB => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_16_Q,
      SEL => G_3_FAST,
      O => DATA04_OUT_DATA_04_2(16)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_17_Q : X_MUX2
    port map (
      IA => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_17_Q,
      IB => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_17_Q,
      SEL => G_3_FAST,
      O => DATA04_OUT_DATA_04_2(17)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_20_Q : X_MUX2
    port map (
      IA => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_20_Q,
      IB => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_20_Q,
      SEL => N_3285,
      O => DATA04_OUT_DATA_04_2(20)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_21_Q : X_MUX2
    port map (
      IA => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_21_Q,
      IB => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_21_Q,
      SEL => G_3_FAST,
      O => DATA04_OUT_DATA_04_2(21)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_22_Q : X_MUX2
    port map (
      IA => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_22_Q,
      IB => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_22_Q,
      SEL => G_3_FAST,
      O => DATA04_OUT_DATA_04_2(22)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_23_Q : X_MUX2
    port map (
      IA => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_23_Q,
      IB => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_23_Q,
      SEL => G_3_FAST,
      O => DATA04_OUT_DATA_04_2(23)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_25_Q : X_MUX2
    port map (
      IA => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_25_Q,
      IB => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_25_Q,
      SEL => G_3_FAST,
      O => DATA04_OUT_DATA_04_2(25)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_26_Q : X_MUX2
    port map (
      IA => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_26_Q,
      IB => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_26_Q,
      SEL => G_3_FAST,
      O => DATA04_OUT_DATA_04_2(26)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_27_Q : X_MUX2
    port map (
      IA => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_27_Q,
      IB => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_27_Q,
      SEL => N_3285,
      O => DATA04_OUT_DATA_04_2(27)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_28_Q : X_MUX2
    port map (
      IA => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_28_Q,
      IB => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_28_Q,
      SEL => G_3_FAST,
      O => DATA04_OUT_DATA_04_2(28)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_29_Q : X_MUX2
    port map (
      IA => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_29_Q,
      IB => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_29_Q,
      SEL => G_3_FAST,
      O => DATA04_OUT_DATA_04_2(29)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_30_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3619,
      ADR1 => CTRLCELL_VPI(10),
      ADR2 => N_3285,
      O => DATA04_OUT_DATA_04_2(30)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_4_G_3590 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => REGNR_02(4),
      ADR1 => STATE04(4),
      ADR2 => CMDATA_STORE(4),
      ADR3 => STATE04(1),
      O => G_3590
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_5_G_3573 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => REGNR_02(5),
      ADR1 => STATE04(4),
      ADR2 => CMDATA_STORE(5),
      ADR3 => STATE04(1),
      O => G_3573
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_6_G_3593 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => REGNR_02(6),
      ADR1 => STATE04(4),
      ADR2 => CMDATA_STORE(6),
      ADR3 => STATE04(1),
      O => G_3593
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_7_G_3447 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => STATE04(7),
      ADR1 => CTRLCELL_VCI(3),
      ADR2 => REGNR_02(7),
      ADR3 => STATE04(4),
      O => G_3447
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_7_G_3448 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3447,
      ADR1 => CMDATA_STORE(7),
      ADR2 => STATE04(1),
      O => G_3448
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_8_G_3583 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => CMDATA_STORE(8),
      ADR1 => STATE04(1),
      ADR2 => APPL_VCI(4),
      ADR3 => N_3469,
      O => G_3583
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_9_G_3581 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => CMDATA_STORE(9),
      ADR1 => STATE04(1),
      ADR2 => APPL_VCI(5),
      ADR3 => N_3469,
      O => G_3581
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_10_G_3563 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => CMDATA_STORE(10),
      ADR1 => STATE04(1),
      ADR2 => APPL_VCI(6),
      ADR3 => N_3469,
      O => G_3563
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_11_G_3582 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => CMDATA_STORE(11),
      ADR1 => STATE04(1),
      ADR2 => APPL_VCI(7),
      ADR3 => N_3469_REP1,
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_11_G_3582_O
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_11_G_3582_LUT4_L_BUF : X_BUF
    port map (
      I => DATA04_OUT_DATA_04_2_0_IV_0_0_11_G_3582_O,
      O => G_3582
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_12_G_3570 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => CMDATA_STORE(12),
      ADR1 => STATE04(1),
      ADR2 => APPL_VCI(8),
      ADR3 => N_3469_REP1,
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_12_G_3570_O
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_12_G_3570_LUT4_L_BUF : X_BUF
    port map (
      I => DATA04_OUT_DATA_04_2_0_IV_0_0_12_G_3570_O,
      O => G_3570
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_13_G_3580 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => CMDATA_STORE(13),
      ADR1 => STATE04(1),
      ADR2 => APPL_VCI(9),
      ADR3 => N_3469_REP1,
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_13_G_3580_O
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_13_G_3580_LUT4_L_BUF : X_BUF
    port map (
      I => DATA04_OUT_DATA_04_2_0_IV_0_0_13_G_3580_O,
      O => G_3580
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_14_G_3592 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => CMDATA_STORE(14),
      ADR1 => STATE04(1),
      ADR2 => APPL_VCI(10),
      ADR3 => N_3469_REP1,
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_14_G_3592_O
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_14_G_3592_LUT4_L_BUF : X_BUF
    port map (
      I => DATA04_OUT_DATA_04_2_0_IV_0_0_14_G_3592_O,
      O => G_3592
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_15_G_3579 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => CMDATA_STORE(15),
      ADR1 => STATE04(1),
      ADR2 => APPL_VCI(11),
      ADR3 => N_3469_REP1,
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_15_G_3579_O
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_15_G_3579_LUT4_L_BUF : X_BUF
    port map (
      I => DATA04_OUT_DATA_04_2_0_IV_0_0_15_G_3579_O,
      O => G_3579
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_16_G_3611 : X_LUT4
    generic map (
      INIT => X"FFF8"
    )
    port map (
      ADR0 => CMDATA_STORE(16),
      ADR1 => STATE04(1),
      ADR2 => STATE04(5),
      ADR3 => N_3362,
      O => G_3611
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_17_G_3584 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEQUENCENR(1),
      ADR1 => STATE04(0),
      ADR2 => CMDATA_STORE(17),
      ADR3 => STATE04(1),
      O => G_3584
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_18_G_3 : X_MUX2
    port map (
      IA => G_3_X0_0,
      IB => G_3_X1_0,
      SEL => N_3285,
      O => DATA04_OUT_DATA_04_2(18)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_18_G_3_G_15 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEQUENCENR(2),
      ADR1 => STATE04(0),
      ADR2 => CMDATA_STORE(18),
      ADR3 => STATE04(1),
      O => G_15
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_18_G_3_X0 : X_LUT3
    generic map (
      INIT => X"F8"
    )
    port map (
      ADR0 => APPL_VCI(14),
      ADR1 => N_3469_REP1,
      ADR2 => G_15,
      O => G_3_X0_0
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_18_G_3_X1 : X_LUT4
    generic map (
      INIT => X"FFF8"
    )
    port map (
      ADR0 => APPL_VCI(14),
      ADR1 => N_3469_REP1,
      ADR2 => G_15,
      ADR3 => CTRLCELL_VCI(14),
      O => G_3_X1_0
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_19_G_3 : X_MUX2
    port map (
      IA => G_3_X0,
      IB => G_3_X1,
      SEL => N_3285,
      O => DATA04_OUT_DATA_04_2(19)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_19_G_3_G_15 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEQUENCENR(3),
      ADR1 => STATE04(0),
      ADR2 => CMDATA_STORE(19),
      ADR3 => STATE04(1),
      O => G_15_0
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_19_G_3_X0 : X_LUT3
    generic map (
      INIT => X"F8"
    )
    port map (
      ADR0 => APPL_VCI(15),
      ADR1 => N_3469_REP1,
      ADR2 => G_15_0,
      O => G_3_X0
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_19_G_3_X1 : X_LUT4
    generic map (
      INIT => X"FFF8"
    )
    port map (
      ADR0 => APPL_VCI(15),
      ADR1 => N_3469_REP1,
      ADR2 => G_15_0,
      ADR3 => CTRLCELL_VCI(15),
      O => G_3_X1
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_20_G_3577 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEQUENCENR(4),
      ADR1 => STATE04(0),
      ADR2 => CMDATA_STORE(20),
      ADR3 => STATE04(1),
      O => G_3577
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_21_G_3595 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEQUENCENR(5),
      ADR1 => STATE04(0),
      ADR2 => CMDATA_STORE(21),
      ADR3 => STATE04(1),
      O => G_3595
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_22_G_3586 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEQUENCENR(6),
      ADR1 => STATE04(0),
      ADR2 => CMDATA_STORE(22),
      ADR3 => STATE04(1),
      O => G_3586
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_23_G_3588 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEQUENCENR(7),
      ADR1 => STATE04(0),
      ADR2 => CMDATA_STORE(23),
      ADR3 => STATE04(1),
      O => G_3588
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_25_G_3613 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEQUENCENR(9),
      ADR1 => STATE04(0),
      ADR2 => CMDATA_STORE(25),
      ADR3 => STATE04(1),
      O => G_3613
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_25_G_3614 : X_LUT3
    generic map (
      INIT => X"BA"
    )
    port map (
      ADR0 => G_3613,
      ADR1 => N_3300,
      ADR2 => STATE04(5),
      O => G_3614
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_26_G_3601 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEQUENCENR(10),
      ADR1 => STATE04(0),
      ADR2 => CMDATA_STORE(26),
      ADR3 => STATE04(1),
      O => G_3601
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_26_G_3602 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3601,
      ADR1 => N_3300,
      ADR2 => STATE04(5),
      O => G_3602
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_27_G_3566 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEQUENCENR(11),
      ADR1 => STATE04(0),
      ADR2 => CMDATA_STORE(27),
      ADR3 => STATE04(1),
      O => G_3566
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_28_G_3571 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEQUENCENR(12),
      ADR1 => STATE04(0),
      ADR2 => CMDATA_STORE(28),
      ADR3 => STATE04(1),
      O => G_3571
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_29_G_3568 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEQUENCENR(13),
      ADR1 => STATE04(0),
      ADR2 => CMDATA_STORE(29),
      ADR3 => STATE04(1),
      O => G_3568
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_30_G_3616 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEQUENCENR(14),
      ADR1 => STATE04(0),
      ADR2 => CMDATA_STORE(30),
      ADR3 => STATE04(1),
      O => G_3616
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_30_G_3617 : X_LUT4
    generic map (
      INIT => X"E0C0"
    )
    port map (
      ADR0 => N_4113,
      ADR1 => N_3055,
      ADR2 => STATE04(4),
      ADR3 => VALID_04,
      O => G_3617
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_30_G_3619 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => G_3617,
      ADR1 => G_3616,
      ADR2 => APPL_VPI(10),
      ADR3 => N_3469_REP1,
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_30_G_3619_O
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_30_G_3619_LUT4_L_BUF : X_BUF
    port map (
      I => DATA04_OUT_DATA_04_2_0_IV_0_0_30_G_3619_O,
      O => G_3619
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_31_G_3_0 : X_MUX2
    port map (
      IA => G_3_0_X0,
      IB => G_3_0_X1,
      SEL => N_3285,
      O => DATA04_OUT_DATA_04_2(31)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_31_G_3_0_G_35 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => STATE04(4),
      ADR1 => VALID_02,
      ADR2 => SEQUENCENR(15),
      ADR3 => STATE04(0),
      O => G_35
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_31_G_3_0_G_36 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_35,
      ADR1 => CMDATA_STORE(31),
      ADR2 => STATE04(1),
      O => G_36
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_31_G_3_0_X0 : X_LUT3
    generic map (
      INIT => X"F8"
    )
    port map (
      ADR0 => APPL_VPI(11),
      ADR1 => N_3469_REP1,
      ADR2 => G_36,
      O => G_3_0_X0
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_31_G_3_0_X1 : X_LUT4
    generic map (
      INIT => X"FFF8"
    )
    port map (
      ADR0 => APPL_VPI(11),
      ADR1 => N_3469_REP1,
      ADR2 => G_36,
      ADR3 => CTRLCELL_VPI(11),
      O => G_3_0_X1
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_AND2_0_6_Q : X_LUT3
    generic map (
      INIT => X"80"
    )
    port map (
      ADR0 => N_2848,
      ADR1 => G_2539_S,
      ADR2 => APPL_VCI(2),
      O => N_2939
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_AND2_1_16_Q : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => STATE04(0),
      ADR1 => SEQUENCENR(0),
      O => N_3362
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X0_4_Q_125 : X_LUT3
    generic map (
      INIT => X"F8"
    )
    port map (
      ADR0 => APPL_VCI(0),
      ADR1 => N_3469_REP1,
      ADR2 => G_3590,
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_4_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X0_5_Q_126 : X_LUT3
    generic map (
      INIT => X"F8"
    )
    port map (
      ADR0 => APPL_VCI(1),
      ADR1 => N_3469_REP1,
      ADR2 => G_3573,
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_5_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X0_16_Q_127 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3611,
      ADR1 => APPL_VCI(12),
      ADR2 => N_3469,
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_16_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X0_17_Q_128 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3584,
      ADR1 => APPL_VCI(13),
      ADR2 => N_3469,
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_17_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X0_20_Q_129 : X_LUT3
    generic map (
      INIT => X"F8"
    )
    port map (
      ADR0 => APPL_VPI(0),
      ADR1 => N_3469_REP1,
      ADR2 => G_3577,
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_20_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X0_21_Q_130 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3595,
      ADR1 => APPL_VPI(1),
      ADR2 => N_3469,
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_21_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X0_22_Q_131 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3586,
      ADR1 => APPL_VPI(2),
      ADR2 => N_3469,
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_22_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X0_23_Q_132 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3588,
      ADR1 => APPL_VPI(3),
      ADR2 => N_3469,
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_23_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X0_25_Q_133 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3614,
      ADR1 => APPL_VPI(5),
      ADR2 => N_3469_REP1_0,
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_25_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X0_26_Q_134 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3602,
      ADR1 => APPL_VPI(6),
      ADR2 => N_3469_REP1_0,
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_26_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X0_27_Q_135 : X_LUT3
    generic map (
      INIT => X"F8"
    )
    port map (
      ADR0 => APPL_VPI(7),
      ADR1 => N_3469_REP1,
      ADR2 => G_3566,
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_27_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X0_28_Q_136 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3571,
      ADR1 => APPL_VPI(8),
      ADR2 => N_3469_REP1_0,
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_28_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X0_29_Q_137 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3568,
      ADR1 => APPL_VPI(9),
      ADR2 => N_3469_REP1_0,
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X0_29_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X1_4_Q_138 : X_LUT4
    generic map (
      INIT => X"FFF8"
    )
    port map (
      ADR0 => APPL_VCI(0),
      ADR1 => N_3469_REP1,
      ADR2 => G_3590,
      ADR3 => CTRLCELL_VCI(0),
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_4_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X1_5_Q_139 : X_LUT4
    generic map (
      INIT => X"FFF8"
    )
    port map (
      ADR0 => APPL_VCI(1),
      ADR1 => N_3469_REP1,
      ADR2 => G_3573,
      ADR3 => CTRLCELL_VCI(1),
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_5_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X1_16_Q_140 : X_LUT4
    generic map (
      INIT => X"FFEA"
    )
    port map (
      ADR0 => G_3611,
      ADR1 => APPL_VCI(12),
      ADR2 => N_3469_REP1_0,
      ADR3 => CTRLCELL_VCI(12),
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_16_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X1_17_Q_141 : X_LUT4
    generic map (
      INIT => X"FFEA"
    )
    port map (
      ADR0 => G_3584,
      ADR1 => APPL_VCI(13),
      ADR2 => N_3469_REP1_0,
      ADR3 => CTRLCELL_VCI(13),
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_17_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X1_20_Q_142 : X_LUT4
    generic map (
      INIT => X"FFF8"
    )
    port map (
      ADR0 => APPL_VPI(0),
      ADR1 => N_3469_REP1,
      ADR2 => G_3577,
      ADR3 => CTRLCELL_VPI(0),
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_20_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X1_21_Q_143 : X_LUT4
    generic map (
      INIT => X"FFEA"
    )
    port map (
      ADR0 => G_3595,
      ADR1 => APPL_VPI(1),
      ADR2 => N_3469_REP1_0,
      ADR3 => CTRLCELL_VPI(1),
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_21_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X1_22_Q_144 : X_LUT4
    generic map (
      INIT => X"FFEA"
    )
    port map (
      ADR0 => G_3586,
      ADR1 => APPL_VPI(2),
      ADR2 => N_3469_REP1_0,
      ADR3 => CTRLCELL_VPI(2),
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_22_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X1_23_Q_145 : X_LUT4
    generic map (
      INIT => X"FFEA"
    )
    port map (
      ADR0 => G_3588,
      ADR1 => APPL_VPI(3),
      ADR2 => N_3469_REP2,
      ADR3 => CTRLCELL_VPI(3),
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_23_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X1_25_Q_146 : X_LUT4
    generic map (
      INIT => X"FFEA"
    )
    port map (
      ADR0 => G_3614,
      ADR1 => APPL_VPI(5),
      ADR2 => N_3469_REP2,
      ADR3 => CTRLCELL_VPI(5),
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_25_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X1_26_Q_147 : X_LUT4
    generic map (
      INIT => X"FFEA"
    )
    port map (
      ADR0 => G_3602,
      ADR1 => APPL_VPI(6),
      ADR2 => N_3469_REP2,
      ADR3 => CTRLCELL_VPI(6),
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_26_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X1_27_Q_148 : X_LUT4
    generic map (
      INIT => X"FFF8"
    )
    port map (
      ADR0 => APPL_VPI(7),
      ADR1 => N_3469_REP1,
      ADR2 => G_3566,
      ADR3 => CTRLCELL_VPI(7),
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_27_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X1_28_Q_149 : X_LUT4
    generic map (
      INIT => X"FFEA"
    )
    port map (
      ADR0 => G_3571,
      ADR1 => APPL_VPI(8),
      ADR2 => N_3469_REP2,
      ADR3 => CTRLCELL_VPI(8),
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_28_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_0_X1_29_Q_150 : X_LUT4
    generic map (
      INIT => X"FFEA"
    )
    port map (
      ADR0 => G_3568,
      ADR1 => APPL_VPI(9),
      ADR2 => N_3469_REP2,
      ADR3 => CTRLCELL_VPI(9),
      O => DATA04_OUT_DATA_04_2_0_IV_0_0_X1_29_Q
    );
  DATA04_OUT_DATA_04_2_0_IV_0_24_G_3608 : X_LUT4
    generic map (
      INIT => X"FFF8"
    )
    port map (
      ADR0 => CMDATA_STORE(24),
      ADR1 => STATE04(1),
      ADR2 => STATE04(5),
      ADR3 => N_3378,
      O => G_3608
    );
  DATA04_OUT_DATA_04_2_0_IV_0_AND2_1_24_Q : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => STATE04(0),
      ADR1 => SEQUENCENR(8),
      O => N_3378
    );
  DATA04_OUT_DATA_04_2_0_IV_0_X0_24_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => G_3608,
      ADR1 => APPL_VPI(4),
      ADR2 => N_3469_REP2,
      O => DATA04_OUT_DATA_04_2_0_IV_0_X0(24)
    );
  DATA04_OUT_DATA_04_2_0_IV_0_X1_24_Q : X_LUT4
    generic map (
      INIT => X"FFEA"
    )
    port map (
      ADR0 => G_3608,
      ADR1 => APPL_VPI(4),
      ADR2 => N_3469_REP2,
      ADR3 => CTRLCELL_VPI(4),
      O => DATA04_OUT_DATA_04_2_0_IV_0_X1(24)
    );
  DATA_00_0_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_0_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(0)
    );
  DATA_00_1_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_1_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(1)
    );
  DATA_00_2_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_2_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(2)
    );
  DATA_00_3_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_3_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(3)
    );
  DATA_00_4_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_4_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(4)
    );
  DATA_00_5_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_5_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(5)
    );
  DATA_00_6_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_6_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(6)
    );
  DATA_00_7_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_I_I_7_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(7)
    );
  DATA_00_8_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_8_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(8)
    );
  DATA_00_9_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_9_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(9)
    );
  DATA_00_10_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_10_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(10)
    );
  DATA_00_11_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_11_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(11)
    );
  DATA_00_12_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_12_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(12)
    );
  DATA_00_13_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_13_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(13)
    );
  DATA_00_14_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_14_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(14)
    );
  DATA_00_15_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_I_I_15_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(15)
    );
  DATA_00_16_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_16_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(16)
    );
  DATA_00_17_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_I_I_17_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(17)
    );
  DATA_00_18_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_18_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(18)
    );
  DATA_00_19_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_19_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(19)
    );
  DATA_00_20_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_20_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(20)
    );
  DATA_00_21_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_21_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(21)
    );
  DATA_00_22_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_22_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(22)
    );
  DATA_00_23_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_23_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(23)
    );
  DATA_00_24_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_24_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(24)
    );
  DATA_00_25_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_25_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(25)
    );
  DATA_00_26_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_26_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(26)
    );
  DATA_00_27_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_I_I_27_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(27)
    );
  DATA_00_28_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_28_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(28)
    );
  DATA_00_29_Q : X_SFF
    port map (
      I => N_4755_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => N_3431,
      O => DATA_00(29)
    );
  DATA_00_30_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_I_I_30_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(30)
    );
  DATA_00_31_Q : X_FF
    port map (
      I => DATA00_OUT_DATA_00_2_31_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_00(31)
    );
  DATA_04_0_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(0)
    );
  DATA_04_1_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(1)
    );
  DATA_04_2_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(2)
    );
  DATA_04_3_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(3)
    );
  DATA_04_4_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(4)
    );
  DATA_04_5_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(5)
    );
  DATA_04_6_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(6)
    );
  DATA_04_7_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(7)
    );
  DATA_04_8_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(8)
    );
  DATA_04_9_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(9)
    );
  DATA_04_10_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(10)
    );
  DATA_04_11_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(11)
    );
  DATA_04_12_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(12)
    );
  DATA_04_13_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(13)
    );
  DATA_04_14_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(14),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(14)
    );
  DATA_04_15_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(15),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(15)
    );
  DATA_04_16_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(16),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(16)
    );
  DATA_04_17_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(17),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(17)
    );
  DATA_04_18_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(18),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(18)
    );
  DATA_04_19_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(19),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(19)
    );
  DATA_04_20_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(20),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(20)
    );
  DATA_04_21_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(21),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(21)
    );
  DATA_04_22_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(22),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(22)
    );
  DATA_04_23_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(23),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(23)
    );
  DATA_04_24_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(24),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(24)
    );
  DATA_04_25_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(25),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(25)
    );
  DATA_04_26_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(26),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(26)
    );
  DATA_04_27_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(27),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(27)
    );
  DATA_04_28_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(28),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(28)
    );
  DATA_04_29_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(29),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(29)
    );
  DATA_04_30_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(30),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(30)
    );
  DATA_04_31_Q : X_FF
    port map (
      I => DATA04_OUT_DATA_04_2(31),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_04(31)
    );
  DATA_CC_1_0_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_CC_DELAY(0),
      ADR1 => CRC_NEW(0),
      ADR2 => CC_SEL_CRC_DELAY,
      O => DATA_CC_1(0)
    );
  DATA_CC_1_1_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_CC_DELAY(1),
      ADR1 => CRC_NEW(1),
      ADR2 => CC_SEL_CRC_DELAY,
      O => DATA_CC_1(1)
    );
  DATA_CC_1_2_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_CC_DELAY(2),
      ADR1 => CRC_NEW(2),
      ADR2 => CC_SEL_CRC_DELAY,
      O => DATA_CC_1(2)
    );
  DATA_CC_1_3_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_CC_DELAY(3),
      ADR1 => CRC_NEW(3),
      ADR2 => CC_SEL_CRC_DELAY,
      O => DATA_CC_1(3)
    );
  DATA_CC_1_4_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_CC_DELAY(4),
      ADR1 => CRC_NEW(4),
      ADR2 => CC_SEL_CRC_DELAY,
      O => DATA_CC_1(4)
    );
  DATA_CC_1_5_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_CC_DELAY(5),
      ADR1 => CRC_NEW(5),
      ADR2 => CC_SEL_CRC_DELAY,
      O => DATA_CC_1(5)
    );
  DATA_CC_1_6_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_CC_DELAY(6),
      ADR1 => CRC_NEW(6),
      ADR2 => CC_SEL_CRC_DELAY,
      O => DATA_CC_1(6)
    );
  DATA_CC_1_7_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_CC_DELAY(7),
      ADR1 => CRC_NEW(7),
      ADR2 => CC_SEL_CRC_DELAY,
      O => DATA_CC_1(7)
    );
  DATA_CC_1_8_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_CC_DELAY(8),
      ADR1 => CRC_NEW(8),
      ADR2 => CC_SEL_CRC_DELAY,
      O => DATA_CC_1(8)
    );
  DATA_CC_1_9_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_CC_DELAY(9),
      ADR1 => CRC_NEW(9),
      ADR2 => CC_SEL_CRC_DELAY,
      O => DATA_CC_1(9)
    );
  DATA_CC_1_10_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_CC_DELAY(10),
      ADR1 => CRC_NEW(10),
      ADR2 => CC_SEL_CRC_DELAY,
      O => DATA_CC_1(10)
    );
  DATA_CC_1_11_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_CC_DELAY(11),
      ADR1 => CRC_NEW(11),
      ADR2 => CC_SEL_CRC_DELAY,
      O => DATA_CC_1(11)
    );
  DATA_CC_1_12_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_CC_DELAY(12),
      ADR1 => CRC_NEW(12),
      ADR2 => CC_SEL_CRC_DELAY,
      O => DATA_CC_1(12)
    );
  DATA_CC_1_13_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_CC_DELAY(13),
      ADR1 => CRC_NEW(13),
      ADR2 => CC_SEL_CRC_DELAY,
      O => DATA_CC_1(13)
    );
  DATA_CC_1_14_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_CC_DELAY(14),
      ADR1 => CRC_NEW(14),
      ADR2 => CC_SEL_CRC_DELAY,
      O => DATA_CC_1(14)
    );
  DATA_CC_1_15_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_CC_DELAY(15),
      ADR1 => CRC_NEW(15),
      ADR2 => CC_SEL_CRC_DELAY,
      O => DATA_CC_1(15)
    );
  DATA_CC_DELAY_0_Q : X_FF
    port map (
      I => DATA_CC_M(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(0)
    );
  DATA_CC_DELAY_1_Q : X_FF
    port map (
      I => DATA_CC_M(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(1)
    );
  DATA_CC_DELAY_2_Q : X_FF
    port map (
      I => DATA_CC_M(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(2)
    );
  DATA_CC_DELAY_3_Q : X_FF
    port map (
      I => DATA_CC_M(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(3)
    );
  DATA_CC_DELAY_4_Q : X_FF
    port map (
      I => DATA_CC_M(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(4)
    );
  DATA_CC_DELAY_5_Q : X_FF
    port map (
      I => DATA_CC_M(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(5)
    );
  DATA_CC_DELAY_6_Q : X_FF
    port map (
      I => DATA_CC_M(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(6)
    );
  DATA_CC_DELAY_7_Q : X_FF
    port map (
      I => DATA_CC_M(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(7)
    );
  DATA_CC_DELAY_8_Q : X_FF
    port map (
      I => DATA_CC_M(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(8)
    );
  DATA_CC_DELAY_9_Q : X_FF
    port map (
      I => DATA_CC_M(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(9)
    );
  DATA_CC_DELAY_10_Q : X_FF
    port map (
      I => DATA_CC_M(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(10)
    );
  DATA_CC_DELAY_11_Q : X_FF
    port map (
      I => DATA_CC_M(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(11)
    );
  DATA_CC_DELAY_12_Q : X_FF
    port map (
      I => DATA_CC_M(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(12)
    );
  DATA_CC_DELAY_13_Q : X_FF
    port map (
      I => DATA_CC_M(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(13)
    );
  DATA_CC_DELAY_14_Q : X_FF
    port map (
      I => DATA_CC_M(14),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(14)
    );
  DATA_CC_DELAY_15_Q : X_FF
    port map (
      I => DATA_CC_M(15),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(15)
    );
  DATA_CC_DELAY_16_Q : X_FF
    port map (
      I => DATA_CC_M(16),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(16)
    );
  DATA_CC_DELAY_17_Q : X_FF
    port map (
      I => DATA_CC_M(17),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(17)
    );
  DATA_CC_DELAY_18_Q : X_FF
    port map (
      I => DATA_CC_M(18),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(18)
    );
  DATA_CC_DELAY_19_Q : X_FF
    port map (
      I => DATA_CC_M(19),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(19)
    );
  DATA_CC_DELAY_20_Q : X_FF
    port map (
      I => DATA_CC_M(20),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(20)
    );
  DATA_CC_DELAY_21_Q : X_FF
    port map (
      I => DATA_CC_M(21),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(21)
    );
  DATA_CC_DELAY_22_Q : X_FF
    port map (
      I => DATA_CC_M(22),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(22)
    );
  DATA_CC_DELAY_23_Q : X_FF
    port map (
      I => DATA_CC_M(23),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(23)
    );
  DATA_CC_DELAY_24_Q : X_FF
    port map (
      I => DATA_CC_M(24),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(24)
    );
  DATA_CC_DELAY_25_Q : X_FF
    port map (
      I => DATA_CC_M(25),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(25)
    );
  DATA_CC_DELAY_26_Q : X_FF
    port map (
      I => DATA_CC_M(26),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(26)
    );
  DATA_CC_DELAY_27_Q : X_FF
    port map (
      I => DATA_CC_M(27),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(27)
    );
  DATA_CC_DELAY_28_Q : X_FF
    port map (
      I => DATA_CC_M(28),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(28)
    );
  DATA_CC_DELAY_29_Q : X_FF
    port map (
      I => DATA_CC_M(29),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(29)
    );
  DATA_CC_DELAY_30_Q : X_FF
    port map (
      I => DATA_CC_M(30),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(30)
    );
  DATA_CC_DELAY_31_Q : X_FF
    port map (
      I => DATA_CC_M(31),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_DELAY(31)
    );
  DATA_CC_M_0_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(0)
    );
  DATA_CC_M_1_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(1)
    );
  DATA_CC_M_2_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(2)
    );
  DATA_CC_M_3_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(3)
    );
  DATA_CC_M_4_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(4)
    );
  DATA_CC_M_5_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(5)
    );
  DATA_CC_M_6_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(6)
    );
  DATA_CC_M_7_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(7)
    );
  DATA_CC_M_8_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(8)
    );
  DATA_CC_M_9_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(9)
    );
  DATA_CC_M_10_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(10)
    );
  DATA_CC_M_11_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(11)
    );
  DATA_CC_M_12_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(12)
    );
  DATA_CC_M_13_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(13)
    );
  DATA_CC_M_14_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(14),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(14)
    );
  DATA_CC_M_15_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(15),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(15)
    );
  DATA_CC_M_16_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(16),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(16)
    );
  DATA_CC_M_17_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(17),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(17)
    );
  DATA_CC_M_18_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(18),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(18)
    );
  DATA_CC_M_19_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(19),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(19)
    );
  DATA_CC_M_20_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(20),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(20)
    );
  DATA_CC_M_21_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(21),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(21)
    );
  DATA_CC_M_22_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(22),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(22)
    );
  DATA_CC_M_23_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(23),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(23)
    );
  DATA_CC_M_24_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(24),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(24)
    );
  DATA_CC_M_25_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(25),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(25)
    );
  DATA_CC_M_26_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(26),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(26)
    );
  DATA_CC_M_27_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(27),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(27)
    );
  DATA_CC_M_28_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(28),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(28)
    );
  DATA_CC_M_29_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(29),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(29)
    );
  DATA_CC_M_30_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(30),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(30)
    );
  DATA_CC_M_31_Q : X_FF
    port map (
      I => DATA_CC_MUX_TMP_DATA_4(31),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_CC_M(31)
    );
  DATA_CC_MUX_TMP_DATA_4_0_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(0),
      ADR1 => DATA_04(0),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(0)
    );
  DATA_CC_MUX_TMP_DATA_4_1_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(1),
      ADR1 => DATA_04(1),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(1)
    );
  DATA_CC_MUX_TMP_DATA_4_2_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(2),
      ADR1 => DATA_04(2),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(2)
    );
  DATA_CC_MUX_TMP_DATA_4_3_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(3),
      ADR1 => DATA_04(3),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(3)
    );
  DATA_CC_MUX_TMP_DATA_4_4_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(4),
      ADR1 => DATA_04(4),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(4)
    );
  DATA_CC_MUX_TMP_DATA_4_5_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(5),
      ADR1 => DATA_04(5),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(5)
    );
  DATA_CC_MUX_TMP_DATA_4_6_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(6),
      ADR1 => DATA_04(6),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(6)
    );
  DATA_CC_MUX_TMP_DATA_4_7_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(7),
      ADR1 => DATA_04(7),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(7)
    );
  DATA_CC_MUX_TMP_DATA_4_8_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(8),
      ADR1 => DATA_04(8),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(8)
    );
  DATA_CC_MUX_TMP_DATA_4_9_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(9),
      ADR1 => DATA_04(9),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(9)
    );
  DATA_CC_MUX_TMP_DATA_4_10_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(10),
      ADR1 => DATA_04(10),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(10)
    );
  DATA_CC_MUX_TMP_DATA_4_11_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(11),
      ADR1 => DATA_04(11),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(11)
    );
  DATA_CC_MUX_TMP_DATA_4_12_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(12),
      ADR1 => DATA_04(12),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(12)
    );
  DATA_CC_MUX_TMP_DATA_4_13_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(13),
      ADR1 => DATA_04(13),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(13)
    );
  DATA_CC_MUX_TMP_DATA_4_14_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(14),
      ADR1 => DATA_04(14),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(14)
    );
  DATA_CC_MUX_TMP_DATA_4_15_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(15),
      ADR1 => DATA_04(15),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(15)
    );
  DATA_CC_MUX_TMP_DATA_4_16_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(16),
      ADR1 => DATA_04(16),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(16)
    );
  DATA_CC_MUX_TMP_DATA_4_17_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(17),
      ADR1 => DATA_04(17),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(17)
    );
  DATA_CC_MUX_TMP_DATA_4_18_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(18),
      ADR1 => DATA_04(18),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(18)
    );
  DATA_CC_MUX_TMP_DATA_4_19_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(19),
      ADR1 => DATA_04(19),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(19)
    );
  DATA_CC_MUX_TMP_DATA_4_20_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(20),
      ADR1 => DATA_04(20),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(20)
    );
  DATA_CC_MUX_TMP_DATA_4_21_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(21),
      ADR1 => DATA_04(21),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(21)
    );
  DATA_CC_MUX_TMP_DATA_4_22_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(22),
      ADR1 => DATA_04(22),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(22)
    );
  DATA_CC_MUX_TMP_DATA_4_23_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(23),
      ADR1 => DATA_04(23),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(23)
    );
  DATA_CC_MUX_TMP_DATA_4_24_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(24),
      ADR1 => DATA_04(24),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(24)
    );
  DATA_CC_MUX_TMP_DATA_4_25_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(25),
      ADR1 => DATA_04(25),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(25)
    );
  DATA_CC_MUX_TMP_DATA_4_26_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(26),
      ADR1 => DATA_04(26),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(26)
    );
  DATA_CC_MUX_TMP_DATA_4_27_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(27),
      ADR1 => DATA_04(27),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(27)
    );
  DATA_CC_MUX_TMP_DATA_4_28_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(28),
      ADR1 => DATA_04(28),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(28)
    );
  DATA_CC_MUX_TMP_DATA_4_29_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(29),
      ADR1 => DATA_04(29),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(29)
    );
  DATA_CC_MUX_TMP_DATA_4_30_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(30),
      ADR1 => DATA_04(30),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(30)
    );
  DATA_CC_MUX_TMP_DATA_4_31_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_00(31),
      ADR1 => DATA_04(31),
      ADR2 => OPCODE_SEL(0),
      O => DATA_CC_MUX_TMP_DATA_4(31)
    );
  DATA_IN_0_Q : X_FF
    port map (
      I => D_MOD_IN(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(0)
    );
  DATA_IN_1_Q : X_FF
    port map (
      I => D_MOD_IN(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(1)
    );
  DATA_IN_2_Q : X_FF
    port map (
      I => D_MOD_IN(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(2)
    );
  DATA_IN_3_Q : X_FF
    port map (
      I => D_MOD_IN(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(3)
    );
  DATA_IN_4_Q : X_FF
    port map (
      I => D_MOD_IN(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(4)
    );
  DATA_IN_5_Q : X_FF
    port map (
      I => D_MOD_IN(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(5)
    );
  DATA_IN_6_Q : X_FF
    port map (
      I => D_MOD_IN(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(6)
    );
  DATA_IN_7_Q : X_FF
    port map (
      I => D_MOD_IN(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(7)
    );
  DATA_IN_8_Q : X_FF
    port map (
      I => D_MOD_IN(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(8)
    );
  DATA_IN_9_Q : X_FF
    port map (
      I => D_MOD_IN(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(9)
    );
  DATA_IN_10_Q : X_FF
    port map (
      I => D_MOD_IN(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(10)
    );
  DATA_IN_11_Q : X_FF
    port map (
      I => D_MOD_IN(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(11)
    );
  DATA_IN_12_Q : X_FF
    port map (
      I => D_MOD_IN(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(12)
    );
  DATA_IN_13_Q : X_FF
    port map (
      I => D_MOD_IN(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(13)
    );
  DATA_IN_14_Q : X_FF
    port map (
      I => D_MOD_IN(14),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(14)
    );
  DATA_IN_15_Q : X_FF
    port map (
      I => D_MOD_IN(15),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(15)
    );
  DATA_IN_16_Q : X_FF
    port map (
      I => D_MOD_IN(16),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(16)
    );
  DATA_IN_17_Q : X_FF
    port map (
      I => D_MOD_IN(17),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(17)
    );
  DATA_IN_18_Q : X_FF
    port map (
      I => D_MOD_IN(18),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(18)
    );
  DATA_IN_19_Q : X_FF
    port map (
      I => D_MOD_IN(19),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(19)
    );
  DATA_IN_20_Q : X_FF
    port map (
      I => D_MOD_IN(20),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(20)
    );
  DATA_IN_21_Q : X_FF
    port map (
      I => D_MOD_IN(21),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(21)
    );
  DATA_IN_22_Q : X_FF
    port map (
      I => D_MOD_IN(22),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(22)
    );
  DATA_IN_23_Q : X_FF
    port map (
      I => D_MOD_IN(23),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(23)
    );
  DATA_IN_24_Q : X_FF
    port map (
      I => D_MOD_IN(24),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(24)
    );
  DATA_IN_25_Q : X_FF
    port map (
      I => D_MOD_IN(25),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(25)
    );
  DATA_IN_26_Q : X_FF
    port map (
      I => D_MOD_IN(26),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(26)
    );
  DATA_IN_27_Q : X_FF
    port map (
      I => D_MOD_IN(27),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(27)
    );
  DATA_IN_28_Q : X_FF
    port map (
      I => D_MOD_IN(28),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(28)
    );
  DATA_IN_29_Q : X_FF
    port map (
      I => D_MOD_IN(29),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(29)
    );
  DATA_IN_30_Q : X_FF
    port map (
      I => D_MOD_IN(30),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(30)
    );
  DATA_IN_31_Q : X_FF
    port map (
      I => D_MOD_IN(31),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_IN(31)
    );
  DATA_STORE_0_0_Q_151 : X_FF
    port map (
      I => NGD2VHDL_OI74,
      CLK => CLK,
      CE => UN1_STATE_1_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_0_0_Q
    );
  DATA_STORE_0_1_Q_152 : X_FF
    port map (
      I => NGD2VHDL_OI73,
      CLK => CLK,
      CE => UN1_STATE_1_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_0_1_Q
    );
  DATA_STORE_0_2_Q_153 : X_FF
    port map (
      I => NGD2VHDL_OI72,
      CLK => CLK,
      CE => UN1_STATE_1_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_0_2_Q
    );
  DATA_STORE_0_3_Q_154 : X_FF
    port map (
      I => NGD2VHDL_OI71,
      CLK => CLK,
      CE => UN1_STATE_1_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_0_3_Q
    );
  DATA_STORE_0_4_Q_155 : X_FF
    port map (
      I => NGD2VHDL_OI70,
      CLK => CLK,
      CE => UN1_STATE_1_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_0_4_Q
    );
  DATA_STORE_0_5_Q_156 : X_FF
    port map (
      I => NGD2VHDL_OI69,
      CLK => CLK,
      CE => UN1_STATE_1_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_0_5_Q
    );
  DATA_STORE_0_6_Q_157 : X_FF
    port map (
      I => NGD2VHDL_OI68,
      CLK => CLK,
      CE => UN1_STATE_1_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_0_6_Q
    );
  DATA_STORE_0_7_Q_158 : X_FF
    port map (
      I => NGD2VHDL_OI67,
      CLK => CLK,
      CE => UN1_STATE_1_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_0_7_Q
    );
  DATA_STORE_0_31_Q_159 : X_FF
    port map (
      I => NGD2VHDL_OI43,
      CLK => CLK,
      CE => UN1_STATE_1_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_0_31_Q
    );
  DATA_STORE_1_4_Q : X_FF
    port map (
      I => NGD2VHDL_OI70,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(4)
    );
  DATA_STORE_1_5_Q : X_FF
    port map (
      I => NGD2VHDL_OI69,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(5)
    );
  DATA_STORE_1_6_Q : X_FF
    port map (
      I => NGD2VHDL_OI68,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(6)
    );
  DATA_STORE_1_7_Q : X_FF
    port map (
      I => NGD2VHDL_OI67,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(7)
    );
  DATA_STORE_1_8_Q : X_FF
    port map (
      I => NGD2VHDL_OI66,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(8)
    );
  DATA_STORE_1_9_Q : X_FF
    port map (
      I => NGD2VHDL_OI65,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(9)
    );
  DATA_STORE_1_10_Q : X_FF
    port map (
      I => NGD2VHDL_OI64,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(10)
    );
  DATA_STORE_1_11_Q : X_FF
    port map (
      I => NGD2VHDL_OI63,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(11)
    );
  DATA_STORE_1_12_Q : X_FF
    port map (
      I => NGD2VHDL_OI62,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(12)
    );
  DATA_STORE_1_13_Q : X_FF
    port map (
      I => NGD2VHDL_OI61,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(13)
    );
  DATA_STORE_1_14_Q : X_FF
    port map (
      I => NGD2VHDL_OI60,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(14)
    );
  DATA_STORE_1_15_Q : X_FF
    port map (
      I => NGD2VHDL_OI59,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(15)
    );
  DATA_STORE_1_16_Q : X_FF
    port map (
      I => NGD2VHDL_OI58,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(16)
    );
  DATA_STORE_1_17_Q : X_FF
    port map (
      I => NGD2VHDL_OI57,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(17)
    );
  DATA_STORE_1_18_Q : X_FF
    port map (
      I => NGD2VHDL_OI56,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(18)
    );
  DATA_STORE_1_19_Q : X_FF
    port map (
      I => NGD2VHDL_OI55,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(19)
    );
  DATA_STORE_1_20_Q : X_FF
    port map (
      I => NGD2VHDL_OI54,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(20)
    );
  DATA_STORE_1_21_Q : X_FF
    port map (
      I => NGD2VHDL_OI53,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(21)
    );
  DATA_STORE_1_22_Q : X_FF
    port map (
      I => NGD2VHDL_OI52,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(22)
    );
  DATA_STORE_1_23_Q : X_FF
    port map (
      I => NGD2VHDL_OI51,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(23)
    );
  DATA_STORE_1_24_Q : X_FF
    port map (
      I => NGD2VHDL_OI50,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(24)
    );
  DATA_STORE_1_25_Q : X_FF
    port map (
      I => NGD2VHDL_OI49,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(25)
    );
  DATA_STORE_1_26_Q : X_FF
    port map (
      I => NGD2VHDL_OI48,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(26)
    );
  DATA_STORE_1_27_Q : X_FF
    port map (
      I => NGD2VHDL_OI47,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(27)
    );
  DATA_STORE_1_28_Q : X_FF
    port map (
      I => NGD2VHDL_OI46,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(28)
    );
  DATA_STORE_1_29_Q : X_FF
    port map (
      I => NGD2VHDL_OI45,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(29)
    );
  DATA_STORE_1_30_Q : X_FF
    port map (
      I => NGD2VHDL_OI44,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(30)
    );
  DATA_STORE_1_31_Q : X_FF
    port map (
      I => NGD2VHDL_OI43,
      CLK => CLK,
      CE => UN1_STATE_7_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_1(31)
    );
  DATA_STORE_2_0_Q_160 : X_FF
    port map (
      I => NGD2VHDL_OI74,
      CLK => CLK,
      CE => UN1_STATE_3_1_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_2_0_Q
    );
  DATA_STORE_2_1_Q_161 : X_FF
    port map (
      I => NGD2VHDL_OI73,
      CLK => CLK,
      CE => UN1_STATE_3_1_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_2_1_Q
    );
  DATA_STORE_2_2_Q_162 : X_FF
    port map (
      I => NGD2VHDL_OI72,
      CLK => CLK,
      CE => UN1_STATE_3_1_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_2_2_Q
    );
  DATA_STORE_2_3_Q_163 : X_FF
    port map (
      I => NGD2VHDL_OI71,
      CLK => CLK,
      CE => UN1_STATE_3_1_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_2_3_Q
    );
  DATA_STORE_2_4_Q_164 : X_FF
    port map (
      I => NGD2VHDL_OI70,
      CLK => CLK,
      CE => UN1_STATE_3_1_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_2_4_Q
    );
  DATA_STORE_2_5_Q_165 : X_FF
    port map (
      I => NGD2VHDL_OI69,
      CLK => CLK,
      CE => UN1_STATE_3_1_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_2_5_Q
    );
  DATA_STORE_2_6_Q_166 : X_FF
    port map (
      I => NGD2VHDL_OI68,
      CLK => CLK,
      CE => UN1_STATE_3_1_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_2_6_Q
    );
  DATA_STORE_2_7_Q_167 : X_FF
    port map (
      I => NGD2VHDL_OI67,
      CLK => CLK,
      CE => UN1_STATE_3_1_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_2_7_Q
    );
  DATA_STORE_2_31_Q_168 : X_FF
    port map (
      I => NGD2VHDL_OI43,
      CLK => CLK,
      CE => UN1_STATE_3_1_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_2_31_Q
    );
  DATA_STORE_3_4_Q : X_FF
    port map (
      I => NGD2VHDL_OI70,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(4)
    );
  DATA_STORE_3_5_Q : X_FF
    port map (
      I => NGD2VHDL_OI69,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(5)
    );
  DATA_STORE_3_6_Q : X_FF
    port map (
      I => NGD2VHDL_OI68,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(6)
    );
  DATA_STORE_3_7_Q : X_FF
    port map (
      I => NGD2VHDL_OI67,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(7)
    );
  DATA_STORE_3_8_Q : X_FF
    port map (
      I => NGD2VHDL_OI66,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(8)
    );
  DATA_STORE_3_9_Q : X_FF
    port map (
      I => NGD2VHDL_OI65,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(9)
    );
  DATA_STORE_3_10_Q : X_FF
    port map (
      I => NGD2VHDL_OI64,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(10)
    );
  DATA_STORE_3_11_Q : X_FF
    port map (
      I => NGD2VHDL_OI63,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(11)
    );
  DATA_STORE_3_12_Q : X_FF
    port map (
      I => NGD2VHDL_OI62,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(12)
    );
  DATA_STORE_3_13_Q : X_FF
    port map (
      I => NGD2VHDL_OI61,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(13)
    );
  DATA_STORE_3_14_Q : X_FF
    port map (
      I => NGD2VHDL_OI60,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(14)
    );
  DATA_STORE_3_15_Q : X_FF
    port map (
      I => NGD2VHDL_OI59,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(15)
    );
  DATA_STORE_3_16_Q : X_FF
    port map (
      I => NGD2VHDL_OI58,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(16)
    );
  DATA_STORE_3_17_Q : X_FF
    port map (
      I => NGD2VHDL_OI57,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(17)
    );
  DATA_STORE_3_18_Q : X_FF
    port map (
      I => NGD2VHDL_OI56,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(18)
    );
  DATA_STORE_3_19_Q : X_FF
    port map (
      I => NGD2VHDL_OI55,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(19)
    );
  DATA_STORE_3_20_Q : X_FF
    port map (
      I => NGD2VHDL_OI54,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(20)
    );
  DATA_STORE_3_21_Q : X_FF
    port map (
      I => NGD2VHDL_OI53,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(21)
    );
  DATA_STORE_3_22_Q : X_FF
    port map (
      I => NGD2VHDL_OI52,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(22)
    );
  DATA_STORE_3_23_Q : X_FF
    port map (
      I => NGD2VHDL_OI51,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(23)
    );
  DATA_STORE_3_24_Q : X_FF
    port map (
      I => NGD2VHDL_OI50,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(24)
    );
  DATA_STORE_3_25_Q : X_FF
    port map (
      I => NGD2VHDL_OI49,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(25)
    );
  DATA_STORE_3_26_Q : X_FF
    port map (
      I => NGD2VHDL_OI48,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(26)
    );
  DATA_STORE_3_27_Q : X_FF
    port map (
      I => NGD2VHDL_OI47,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(27)
    );
  DATA_STORE_3_28_Q : X_FF
    port map (
      I => NGD2VHDL_OI46,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(28)
    );
  DATA_STORE_3_29_Q : X_FF
    port map (
      I => NGD2VHDL_OI45,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(29)
    );
  DATA_STORE_3_30_Q : X_FF
    port map (
      I => NGD2VHDL_OI44,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(30)
    );
  DATA_STORE_3_31_Q : X_FF
    port map (
      I => NGD2VHDL_OI43,
      CLK => CLK,
      CE => UN1_STATE_2_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_3(31)
    );
  DATA_STORE_4_0_Q_169 : X_FF
    port map (
      I => NGD2VHDL_OI74,
      CLK => CLK,
      CE => UN1_STATE_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_4_0_Q
    );
  DATA_STORE_4_1_Q_170 : X_FF
    port map (
      I => NGD2VHDL_OI73,
      CLK => CLK,
      CE => UN1_STATE_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_4_1_Q
    );
  DATA_STORE_4_2_Q_171 : X_FF
    port map (
      I => NGD2VHDL_OI72,
      CLK => CLK,
      CE => UN1_STATE_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_4_2_Q
    );
  DATA_STORE_4_3_Q_172 : X_FF
    port map (
      I => NGD2VHDL_OI71,
      CLK => CLK,
      CE => UN1_STATE_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_4_3_Q
    );
  DATA_STORE_4_4_Q_173 : X_FF
    port map (
      I => NGD2VHDL_OI70,
      CLK => CLK,
      CE => UN1_STATE_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_4_4_Q
    );
  DATA_STORE_4_5_Q_174 : X_FF
    port map (
      I => NGD2VHDL_OI69,
      CLK => CLK,
      CE => UN1_STATE_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_4_5_Q
    );
  DATA_STORE_4_6_Q_175 : X_FF
    port map (
      I => NGD2VHDL_OI68,
      CLK => CLK,
      CE => UN1_STATE_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_4_6_Q
    );
  DATA_STORE_4_7_Q_176 : X_FF
    port map (
      I => NGD2VHDL_OI67,
      CLK => CLK,
      CE => UN1_STATE_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_4_7_Q
    );
  DATA_STORE_4_31_Q_177 : X_FF
    port map (
      I => NGD2VHDL_OI43,
      CLK => CLK,
      CE => UN1_STATE_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_4_31_Q
    );
  DATA_STORE_5_4_Q : X_FF
    port map (
      I => NGD2VHDL_OI70,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(4)
    );
  DATA_STORE_5_5_Q : X_FF
    port map (
      I => NGD2VHDL_OI69,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(5)
    );
  DATA_STORE_5_6_Q : X_FF
    port map (
      I => NGD2VHDL_OI68,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(6)
    );
  DATA_STORE_5_7_Q : X_FF
    port map (
      I => NGD2VHDL_OI67,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(7)
    );
  DATA_STORE_5_8_Q : X_FF
    port map (
      I => NGD2VHDL_OI66,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(8)
    );
  DATA_STORE_5_9_Q : X_FF
    port map (
      I => NGD2VHDL_OI65,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(9)
    );
  DATA_STORE_5_10_Q : X_FF
    port map (
      I => NGD2VHDL_OI64,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(10)
    );
  DATA_STORE_5_11_Q : X_FF
    port map (
      I => NGD2VHDL_OI63,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(11)
    );
  DATA_STORE_5_12_Q : X_FF
    port map (
      I => NGD2VHDL_OI62,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(12)
    );
  DATA_STORE_5_13_Q : X_FF
    port map (
      I => NGD2VHDL_OI61,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(13)
    );
  DATA_STORE_5_14_Q : X_FF
    port map (
      I => NGD2VHDL_OI60,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(14)
    );
  DATA_STORE_5_15_Q : X_FF
    port map (
      I => NGD2VHDL_OI59,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(15)
    );
  DATA_STORE_5_16_Q : X_FF
    port map (
      I => NGD2VHDL_OI58,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(16)
    );
  DATA_STORE_5_17_Q : X_FF
    port map (
      I => NGD2VHDL_OI57,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(17)
    );
  DATA_STORE_5_18_Q : X_FF
    port map (
      I => NGD2VHDL_OI56,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(18)
    );
  DATA_STORE_5_19_Q : X_FF
    port map (
      I => NGD2VHDL_OI55,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(19)
    );
  DATA_STORE_5_20_Q : X_FF
    port map (
      I => NGD2VHDL_OI54,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(20)
    );
  DATA_STORE_5_21_Q : X_FF
    port map (
      I => NGD2VHDL_OI53,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(21)
    );
  DATA_STORE_5_22_Q : X_FF
    port map (
      I => NGD2VHDL_OI52,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(22)
    );
  DATA_STORE_5_23_Q : X_FF
    port map (
      I => NGD2VHDL_OI51,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(23)
    );
  DATA_STORE_5_24_Q : X_FF
    port map (
      I => NGD2VHDL_OI50,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(24)
    );
  DATA_STORE_5_25_Q : X_FF
    port map (
      I => NGD2VHDL_OI49,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(25)
    );
  DATA_STORE_5_26_Q : X_FF
    port map (
      I => NGD2VHDL_OI48,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(26)
    );
  DATA_STORE_5_27_Q : X_FF
    port map (
      I => NGD2VHDL_OI47,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(27)
    );
  DATA_STORE_5_28_Q : X_FF
    port map (
      I => NGD2VHDL_OI46,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(28)
    );
  DATA_STORE_5_29_Q : X_FF
    port map (
      I => NGD2VHDL_OI45,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(29)
    );
  DATA_STORE_5_30_Q : X_FF
    port map (
      I => NGD2VHDL_OI44,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(30)
    );
  DATA_STORE_5_31_Q : X_FF
    port map (
      I => NGD2VHDL_OI43,
      CLK => CLK,
      CE => UN1_STATE_5_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_5(31)
    );
  DATA_STORE_6_0_Q_178 : X_FF
    port map (
      I => NGD2VHDL_OI74,
      CLK => CLK,
      CE => UN1_STATE_6_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_6_0_Q
    );
  DATA_STORE_6_1_Q_179 : X_FF
    port map (
      I => NGD2VHDL_OI73,
      CLK => CLK,
      CE => UN1_STATE_6_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_6_1_Q
    );
  DATA_STORE_6_2_Q_180 : X_FF
    port map (
      I => NGD2VHDL_OI72,
      CLK => CLK,
      CE => UN1_STATE_6_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_6_2_Q
    );
  DATA_STORE_6_3_Q_181 : X_FF
    port map (
      I => NGD2VHDL_OI71,
      CLK => CLK,
      CE => UN1_STATE_6_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_6_3_Q
    );
  DATA_STORE_6_4_Q_182 : X_FF
    port map (
      I => NGD2VHDL_OI70,
      CLK => CLK,
      CE => UN1_STATE_6_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_6_4_Q
    );
  DATA_STORE_6_5_Q_183 : X_FF
    port map (
      I => NGD2VHDL_OI69,
      CLK => CLK,
      CE => UN1_STATE_6_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_6_5_Q
    );
  DATA_STORE_6_6_Q_184 : X_FF
    port map (
      I => NGD2VHDL_OI68,
      CLK => CLK,
      CE => UN1_STATE_6_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_6_6_Q
    );
  DATA_STORE_6_7_Q_185 : X_FF
    port map (
      I => NGD2VHDL_OI67,
      CLK => CLK,
      CE => UN1_STATE_6_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_6_7_Q
    );
  DATA_STORE_6_31_Q_186 : X_FF
    port map (
      I => NGD2VHDL_OI43,
      CLK => CLK,
      CE => UN1_STATE_6_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_6_31_Q
    );
  DATA_STORE_7_4_Q : X_FF
    port map (
      I => NGD2VHDL_OI70,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(4)
    );
  DATA_STORE_7_5_Q : X_FF
    port map (
      I => NGD2VHDL_OI69,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(5)
    );
  DATA_STORE_7_6_Q : X_FF
    port map (
      I => NGD2VHDL_OI68,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(6)
    );
  DATA_STORE_7_7_Q : X_FF
    port map (
      I => NGD2VHDL_OI67,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(7)
    );
  DATA_STORE_7_8_Q : X_FF
    port map (
      I => NGD2VHDL_OI66,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(8)
    );
  DATA_STORE_7_9_Q : X_FF
    port map (
      I => NGD2VHDL_OI65,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(9)
    );
  DATA_STORE_7_10_Q : X_FF
    port map (
      I => NGD2VHDL_OI64,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(10)
    );
  DATA_STORE_7_11_Q : X_FF
    port map (
      I => NGD2VHDL_OI63,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(11)
    );
  DATA_STORE_7_12_Q : X_FF
    port map (
      I => NGD2VHDL_OI62,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(12)
    );
  DATA_STORE_7_13_Q : X_FF
    port map (
      I => NGD2VHDL_OI61,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(13)
    );
  DATA_STORE_7_14_Q : X_FF
    port map (
      I => NGD2VHDL_OI60,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(14)
    );
  DATA_STORE_7_15_Q : X_FF
    port map (
      I => NGD2VHDL_OI59,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(15)
    );
  DATA_STORE_7_16_Q : X_FF
    port map (
      I => NGD2VHDL_OI58,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(16)
    );
  DATA_STORE_7_17_Q : X_FF
    port map (
      I => NGD2VHDL_OI57,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(17)
    );
  DATA_STORE_7_18_Q : X_FF
    port map (
      I => NGD2VHDL_OI56,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(18)
    );
  DATA_STORE_7_19_Q : X_FF
    port map (
      I => NGD2VHDL_OI55,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(19)
    );
  DATA_STORE_7_20_Q : X_FF
    port map (
      I => NGD2VHDL_OI54,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(20)
    );
  DATA_STORE_7_21_Q : X_FF
    port map (
      I => NGD2VHDL_OI53,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(21)
    );
  DATA_STORE_7_22_Q : X_FF
    port map (
      I => NGD2VHDL_OI52,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(22)
    );
  DATA_STORE_7_23_Q : X_FF
    port map (
      I => NGD2VHDL_OI51,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(23)
    );
  DATA_STORE_7_24_Q : X_FF
    port map (
      I => NGD2VHDL_OI50,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(24)
    );
  DATA_STORE_7_25_Q : X_FF
    port map (
      I => NGD2VHDL_OI49,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(25)
    );
  DATA_STORE_7_26_Q : X_FF
    port map (
      I => NGD2VHDL_OI48,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(26)
    );
  DATA_STORE_7_27_Q : X_FF
    port map (
      I => NGD2VHDL_OI47,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(27)
    );
  DATA_STORE_7_28_Q : X_FF
    port map (
      I => NGD2VHDL_OI46,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(28)
    );
  DATA_STORE_7_29_Q : X_FF
    port map (
      I => NGD2VHDL_OI45,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(29)
    );
  DATA_STORE_7_30_Q : X_FF
    port map (
      I => NGD2VHDL_OI44,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(30)
    );
  DATA_STORE_7_31_Q : X_FF
    port map (
      I => NGD2VHDL_OI43,
      CLK => CLK,
      CE => UN1_STATE_4_0_AND2,
      SET => GND,
      RST => GSR,
      O => DATA_STORE_7(31)
    );
  DISPATCH_UN4_SOC_NE_G_3324 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => APPL_VPI(3),
      ADR1 => NGD2VHDL_OI51,
      ADR2 => APPL_VPI(2),
      ADR3 => NGD2VHDL_OI52,
      O => G_3324
    );
  DISPATCH_UN4_SOC_NE_G_3325 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => APPL_VPI(1),
      ADR1 => NGD2VHDL_OI53,
      ADR2 => APPL_VPI(0),
      ADR3 => NGD2VHDL_OI54,
      O => G_3325
    );
  DISPATCH_UN4_SOC_NE_G_3326 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => NGD2VHDL_OI46,
      ADR1 => APPL_VPI(8),
      ADR2 => NGD2VHDL_OI47,
      ADR3 => APPL_VPI(7),
      O => G_3326
    );
  DISPATCH_UN4_SOC_NE_G_3327 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => APPL_VPI(4),
      ADR1 => NGD2VHDL_OI50,
      ADR2 => APPL_VPI(10),
      ADR3 => NGD2VHDL_OI44,
      O => G_3327
    );
  DISPATCH_UN4_SOC_NE_G_3328 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => NGD2VHDL_OI45,
      ADR1 => APPL_VPI(9),
      ADR2 => NGD2VHDL_OI48,
      ADR3 => APPL_VPI(6),
      O => G_3328
    );
  DISPATCH_UN4_SOC_NE_G_3332 : X_LUT4
    generic map (
      INIT => X"BFFB"
    )
    port map (
      ADR0 => G_3327,
      ADR1 => G_2647,
      ADR2 => NGD2VHDL_OI43,
      ADR3 => APPL_VPI(11),
      O => G_3332
    );
  DISPATCH_UN4_SOC_NE_G_3333 : X_LUT4
    generic map (
      INIT => X"FFFE"
    )
    port map (
      ADR0 => G_3324,
      ADR1 => G_3325,
      ADR2 => G_3328,
      ADR3 => G_3326,
      O => G_3333
    );
  DISPATCH_UN8_SOC_0_I_2 : X_MUX2
    port map (
      IA => GND_INT,
      IB => DISPATCH_UN8_SOC_0_DATA_TMP(3),
      SEL => DISPATCH_UN8_SOC_0_N_3,
      O => DISPATCH_UN8_SOC_0_I_2_O
    );
  DISPATCH_UN8_SOC_0_I_2_MUXCY_L_BUF : X_BUF
    port map (
      I => DISPATCH_UN8_SOC_0_I_2_O,
      O => DISPATCH_UN8_SOC_0_DATA_TMP(4)
    );
  DISPATCH_UN8_SOC_0_I_10 : X_LUT4
    generic map (
      INIT => X"9009"
    )
    port map (
      ADR0 => APPL_VCI(9),
      ADR1 => NGD2VHDL_OI61,
      ADR2 => APPL_VCI(8),
      ADR3 => NGD2VHDL_OI62,
      O => DISPATCH_UN8_SOC_0_N_3
    );
  DISPATCH_UN8_SOC_0_I_11 : X_MUX2
    port map (
      IA => GND_INT,
      IB => DISPATCH_UN8_SOC_0_DATA_TMP(6),
      SEL => DISPATCH_UN8_SOC_0_N_11,
      O => DISPATCH_UN8_SOC_0_I_11_O
    );
  DISPATCH_UN8_SOC_0_I_11_MUXCY_L_BUF : X_BUF
    port map (
      I => DISPATCH_UN8_SOC_0_I_11_O,
      O => DISPATCH_UN8_SOC
    );
  DISPATCH_UN8_SOC_0_I_19 : X_LUT4
    generic map (
      INIT => X"9009"
    )
    port map (
      ADR0 => APPL_VCI(15),
      ADR1 => NGD2VHDL_OI55,
      ADR2 => APPL_VCI(14),
      ADR3 => NGD2VHDL_OI56,
      O => DISPATCH_UN8_SOC_0_N_11
    );
  DISPATCH_UN8_SOC_0_I_20 : X_MUX2
    port map (
      IA => GND_INT,
      IB => DISPATCH_UN8_SOC_0_DATA_TMP(2),
      SEL => DISPATCH_UN8_SOC_0_N_19,
      O => DISPATCH_UN8_SOC_0_I_20_O
    );
  DISPATCH_UN8_SOC_0_I_20_MUXCY_L_BUF : X_BUF
    port map (
      I => DISPATCH_UN8_SOC_0_I_20_O,
      O => DISPATCH_UN8_SOC_0_DATA_TMP(3)
    );
  DISPATCH_UN8_SOC_0_I_28 : X_LUT4
    generic map (
      INIT => X"9009"
    )
    port map (
      ADR0 => APPL_VCI(7),
      ADR1 => NGD2VHDL_OI63,
      ADR2 => APPL_VCI(6),
      ADR3 => NGD2VHDL_OI64,
      O => DISPATCH_UN8_SOC_0_N_19
    );
  DISPATCH_UN8_SOC_0_I_29 : X_MUX2
    port map (
      IA => GND_INT,
      IB => DISPATCH_UN8_SOC_0_DATA_TMP(5),
      SEL => DISPATCH_UN8_SOC_0_N_27,
      O => DISPATCH_UN8_SOC_0_I_29_O
    );
  DISPATCH_UN8_SOC_0_I_29_MUXCY_L_BUF : X_BUF
    port map (
      I => DISPATCH_UN8_SOC_0_I_29_O,
      O => DISPATCH_UN8_SOC_0_DATA_TMP(6)
    );
  DISPATCH_UN8_SOC_0_I_37 : X_LUT4
    generic map (
      INIT => X"9009"
    )
    port map (
      ADR0 => APPL_VCI(13),
      ADR1 => NGD2VHDL_OI57,
      ADR2 => APPL_VCI(12),
      ADR3 => NGD2VHDL_OI58,
      O => DISPATCH_UN8_SOC_0_N_27
    );
  DISPATCH_UN8_SOC_0_I_38 : X_MUX2
    port map (
      IA => GND_INT,
      IB => DISPATCH_UN8_SOC_0_DATA_TMP(1),
      SEL => DISPATCH_UN8_SOC_0_N_35,
      O => DISPATCH_UN8_SOC_0_I_38_O
    );
  DISPATCH_UN8_SOC_0_I_38_MUXCY_L_BUF : X_BUF
    port map (
      I => DISPATCH_UN8_SOC_0_I_38_O,
      O => DISPATCH_UN8_SOC_0_DATA_TMP(2)
    );
  DISPATCH_UN8_SOC_0_I_46 : X_LUT4
    generic map (
      INIT => X"9009"
    )
    port map (
      ADR0 => APPL_VCI(5),
      ADR1 => NGD2VHDL_OI65,
      ADR2 => APPL_VCI(4),
      ADR3 => NGD2VHDL_OI66,
      O => DISPATCH_UN8_SOC_0_N_35
    );
  DISPATCH_UN8_SOC_0_I_47 : X_MUX2
    port map (
      IA => GND_INT,
      IB => DISPATCH_UN8_SOC_0_DATA_TMP(4),
      SEL => DISPATCH_UN8_SOC_0_N_43,
      O => DISPATCH_UN8_SOC_0_I_47_O
    );
  DISPATCH_UN8_SOC_0_I_47_MUXCY_L_BUF : X_BUF
    port map (
      I => DISPATCH_UN8_SOC_0_I_47_O,
      O => DISPATCH_UN8_SOC_0_DATA_TMP(5)
    );
  DISPATCH_UN8_SOC_0_I_55 : X_LUT4
    generic map (
      INIT => X"9009"
    )
    port map (
      ADR0 => APPL_VCI(11),
      ADR1 => NGD2VHDL_OI59,
      ADR2 => APPL_VCI(10),
      ADR3 => NGD2VHDL_OI60,
      O => DISPATCH_UN8_SOC_0_N_43
    );
  DISPATCH_UN8_SOC_0_I_56 : X_MUX2
    port map (
      IA => GND_INT,
      IB => DISPATCH_UN8_SOC_0_DATA_TMP(0),
      SEL => DISPATCH_UN8_SOC_0_N_51,
      O => DISPATCH_UN8_SOC_0_I_56_O
    );
  DISPATCH_UN8_SOC_0_I_56_MUXCY_L_BUF : X_BUF
    port map (
      I => DISPATCH_UN8_SOC_0_I_56_O,
      O => DISPATCH_UN8_SOC_0_DATA_TMP(1)
    );
  DISPATCH_UN8_SOC_0_I_64 : X_LUT4
    generic map (
      INIT => X"9009"
    )
    port map (
      ADR0 => APPL_VCI(3),
      ADR1 => NGD2VHDL_OI67,
      ADR2 => APPL_VCI(2),
      ADR3 => NGD2VHDL_OI68,
      O => DISPATCH_UN8_SOC_0_N_51
    );
  DISPATCH_UN8_SOC_0_I_65 : X_MUX2
    port map (
      IA => GND_INT,
      IB => VCC_INT,
      SEL => DISPATCH_UN8_SOC_0_N_59,
      O => DISPATCH_UN8_SOC_0_I_65_O
    );
  DISPATCH_UN8_SOC_0_I_65_MUXCY_L_BUF : X_BUF
    port map (
      I => DISPATCH_UN8_SOC_0_I_65_O,
      O => DISPATCH_UN8_SOC_0_DATA_TMP(0)
    );
  DISPATCH_UN8_SOC_0_I_73 : X_LUT4
    generic map (
      INIT => X"9009"
    )
    port map (
      ADR0 => APPL_VCI(1),
      ADR1 => NGD2VHDL_OI69,
      ADR2 => APPL_VCI(0),
      ADR3 => NGD2VHDL_OI70,
      O => DISPATCH_UN8_SOC_0_N_59
    );
  DISPATCH_UN9_SOC_0_AND2 : X_LUT4
    generic map (
      INIT => X"0002"
    )
    port map (
      ADR0 => DISPATCH_UN8_SOC,
      ADR1 => NGD2VHDL_OI71,
      ADR2 => G_3333,
      ADR3 => G_3332,
      O => DISPATCH_UN9_SOC
    );
  ENABLE_IN_187 : X_FF
    port map (
      I => ENABLE_L,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => ENABLE_IN
    );
  ENABLE_IN_I : X_INV
    port map (
      I => ENABLE_IN,
      O => READY_L
    );
  GENCOUNT_0_Q : X_SFF
    port map (
      I => GENCOUNT_I(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC_M,
      O => GENCOUNT(0)
    );
  GENCOUNT_1_Q : X_SFF
    port map (
      I => N_4754_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC_M,
      O => GENCOUNT(1)
    );
  GENCOUNT_2_Q : X_SFF
    port map (
      I => N_3693,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC_M,
      O => GENCOUNT(2)
    );
  GENCOUNT_3_Q : X_SFF
    port map (
      I => N_3691,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC_M,
      O => N_894_1
    );
  GENCOUNT_FAST_0_Q : X_SFF
    port map (
      I => GENCOUNT_I(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC_M,
      O => GENCOUNT_FAST(0)
    );
  GENCOUNT_FAST_1_Q : X_SFF
    port map (
      I => N_4754_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC_M,
      O => GENCOUNT_FAST(1)
    );
  GENCOUNT_FAST_2_Q : X_SFF
    port map (
      I => N_3693,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC_M,
      O => GENCOUNT_FAST(2)
    );
  GENCOUNT_FAST_3_Q : X_SFF
    port map (
      I => N_3691,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC_M,
      O => GENCOUNT_FAST(3)
    );
  GENCOUNT_FAST_0_0_Q_188 : X_SFF
    port map (
      I => GENCOUNT_I(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC_M,
      O => GENCOUNT_FAST_0_0_Q
    );
  GENCOUNT_FAST_0_2_Q_189 : X_SFF
    port map (
      I => N_3693,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC_M,
      O => GENCOUNT_FAST_0_2_Q
    );
  GENCOUNT_I_0_Q : X_INV
    port map (
      I => GENCOUNT(0),
      O => GENCOUNT_I(0)
    );
  MATCH_MODID_190 : X_SFF
    port map (
      I => G_3666,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => DATA_IN(17),
      O => MATCH_MODID
    );
  OPCODE_SEL_1_0_AND2_0_AND2_0_G_3276 : X_LUT2
    generic map (
      INIT => X"2"
    )
    port map (
      ADR0 => STATE04(6),
      ADR1 => STATE00(4),
      O => G_3276
    );
  OPCODE_SEL_3_0_Q : X_LUT4
    generic map (
      INIT => X"E040"
    )
    port map (
      ADR0 => SEL_STATE(0),
      ADR1 => G_3276,
      ADR2 => RESET_L,
      ADR3 => OPCSEL_BUF(0),
      O => OPCODE_SEL(0)
    );
  OPCODE_SEL_3_1_Q : X_LUT4
    generic map (
      INIT => X"E040"
    )
    port map (
      ADR0 => SEL_STATE(0),
      ADR1 => STATE00(4),
      ADR2 => RESET_L,
      ADR3 => OPCSEL_BUF(1),
      O => OPCODE_SEL(1)
    );
  OPCSEL_BUF_0_Q : X_FF
    port map (
      I => OPCODE_SEL(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => OPCSEL_BUF(0)
    );
  OPCSEL_BUF_1_Q : X_FF
    port map (
      I => OPCODE_SEL(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => OPCSEL_BUF(1)
    );
  PLCOUNT_0_Q : X_SFF
    port map (
      I => PLCOUNT_I(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => STATE(3),
      O => PLCOUNT(0)
    );
  PLCOUNT_1_Q : X_SFF
    port map (
      I => N_2550_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => STATE(3),
      O => PLCOUNT(1)
    );
  PLCOUNT_2_Q : X_SFF
    port map (
      I => N_2551_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => STATE(3),
      O => PLCOUNT(2)
    );
  PLCOUNT_3_Q : X_SFF
    port map (
      I => N_2552_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => STATE(3),
      O => N_882_1
    );
  PLCOUNT_I_0_Q : X_INV
    port map (
      I => PLCOUNT(0),
      O => PLCOUNT_I(0)
    );
  REGNR_02_0_Q : X_FF
    port map (
      I => SEL_REGVPIVCI_REGNR_02_1(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => REGNR_02(0)
    );
  REGNR_02_1_Q : X_FF
    port map (
      I => SEL_REGVPIVCI_REGNR_02_1(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => REGNR_02(1)
    );
  REGNR_02_2_Q : X_FF
    port map (
      I => SEL_REGVPIVCI_REGNR_02_1(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => REGNR_02(2)
    );
  REGNR_02_3_Q : X_FF
    port map (
      I => SEL_REGVPIVCI_REGNR_02_1(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => REGNR_02(3)
    );
  REGNR_02_4_Q : X_FF
    port map (
      I => SEL_REGVPIVCI_REGNR_02_1(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => REGNR_02(4)
    );
  REGNR_02_5_Q : X_FF
    port map (
      I => SEL_REGVPIVCI_REGNR_02_1(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => REGNR_02(5)
    );
  REGNR_02_6_Q : X_FF
    port map (
      I => SEL_REGVPIVCI_REGNR_02_1(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => REGNR_02(6)
    );
  REGNR_02_7_Q : X_FF
    port map (
      I => SEL_REGVPIVCI_REGNR_02_1(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => REGNR_02(7)
    );
  REGNR_04_0_Q : X_FF
    port map (
      I => REGNR_02(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => REGNR_04(0)
    );
  REGNR_04_1_Q : X_FF
    port map (
      I => REGNR_02(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => REGNR_04(1)
    );
  REGNR_04_2_Q : X_FF
    port map (
      I => REGNR_02(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => REGNR_04(2)
    );
  REGNR_04_3_Q : X_FF
    port map (
      I => REGNR_02(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => REGNR_04(3)
    );
  REGNR_04_4_Q : X_FF
    port map (
      I => REGNR_02(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => REGNR_04(4)
    );
  REGNR_04_5_Q : X_FF
    port map (
      I => REGNR_02(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => REGNR_04(5)
    );
  REGNR_04_6_Q : X_FF
    port map (
      I => REGNR_02(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => REGNR_04(6)
    );
  REGNR_04_7_Q : X_FF
    port map (
      I => REGNR_02(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => REGNR_04(7)
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_0_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => G_3552,
      ADR1 => N_3674_REP2,
      ADR2 => N_3833,
      ADR3 => DATA_STORE_2_0_Q,
      O => SEL_REGVPIVCI_REGNR_02_1(0)
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_1_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => G_3562,
      ADR1 => N_3674_REP2,
      ADR2 => N_3833,
      ADR3 => DATA_STORE_2_1_Q,
      O => SEL_REGVPIVCI_REGNR_02_1(1)
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_2_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => G_3550,
      ADR1 => N_3674_REP2,
      ADR2 => N_3833,
      ADR3 => DATA_STORE_2_2_Q,
      O => SEL_REGVPIVCI_REGNR_02_1(2)
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_3_Q : X_LUT4
    generic map (
      INIT => X"F3F2"
    )
    port map (
      ADR0 => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_2_S_3_Q,
      ADR1 => N_3674_REP2,
      ADR2 => G_3545,
      ADR3 => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_0_S_3_Q,
      O => SEL_REGVPIVCI_REGNR_02_1(3)
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_4_Q : X_LUT4
    generic map (
      INIT => X"EEFE"
    )
    port map (
      ADR0 => G_3555,
      ADR1 => G_3556,
      ADR2 => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_2_S_4_Q,
      ADR3 => N_3674_REP2,
      O => SEL_REGVPIVCI_REGNR_02_1(4)
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_5_Q : X_LUT4
    generic map (
      INIT => X"F3F2"
    )
    port map (
      ADR0 => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_2_S_5_Q,
      ADR1 => N_3674_REP2,
      ADR2 => G_3547,
      ADR3 => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_0_S_5_Q,
      O => SEL_REGVPIVCI_REGNR_02_1(5)
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_6_Q : X_LUT4
    generic map (
      INIT => X"AAEA"
    )
    port map (
      ADR0 => G_3558,
      ADR1 => DATA_STORE_2_6_Q,
      ADR2 => N_3833,
      ADR3 => N_3674_REP2,
      O => SEL_REGVPIVCI_REGNR_02_1(6)
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_7_Q : X_LUT4
    generic map (
      INIT => X"F3F2"
    )
    port map (
      ADR0 => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_2_S_7_Q,
      ADR1 => N_3674_REP2,
      ADR2 => G_3553,
      ADR3 => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_0_S_7_Q,
      O => SEL_REGVPIVCI_REGNR_02_1(7)
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_0_G_3551 : X_LUT3
    generic map (
      INIT => X"0E"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => G_2834_FAST,
      ADR2 => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_0_G_3551_SX,
      O => G_3551
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_0_G_3551_SX_191 : X_LUT4
    generic map (
      INIT => X"1D3F"
    )
    port map (
      ADR0 => DATA_STORE_4_0_Q,
      ADR1 => STATE04(5),
      ADR2 => DATA_STORE_0_0_Q,
      ADR3 => GENCOUNT(1),
      O => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_0_G_3551_SX
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_0_G_3552 : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => G_3551,
      ADR1 => N_3674_REP2,
      ADR2 => N_3836,
      ADR3 => DATA_STORE_6_0_Q,
      O => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_0_G_3552_O
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_0_G_3552_LUT4_L_BUF : X_BUF
    port map (
      I => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_0_G_3552_O,
      O => G_3552
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_1_G_3561 : X_LUT3
    generic map (
      INIT => X"0E"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => G_2834_FAST,
      ADR2 => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_1_G_3561_SX,
      O => G_3561
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_1_G_3561_SX_192 : X_LUT4
    generic map (
      INIT => X"1D3F"
    )
    port map (
      ADR0 => DATA_STORE_4_1_Q,
      ADR1 => STATE04(5),
      ADR2 => DATA_STORE_0_1_Q,
      ADR3 => GENCOUNT(1),
      O => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_1_G_3561_SX
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_1_G_3562 : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => G_3561,
      ADR1 => N_3674_REP2,
      ADR2 => N_3836,
      ADR3 => DATA_STORE_6_1_Q,
      O => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_1_G_3562_O
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_1_G_3562_LUT4_L_BUF : X_BUF
    port map (
      I => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_1_G_3562_O,
      O => G_3562
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_2_G_3549 : X_LUT3
    generic map (
      INIT => X"0E"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => G_2834_FAST,
      ADR2 => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_2_G_3549_SX,
      O => G_3549
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_2_G_3549_SX_193 : X_LUT4
    generic map (
      INIT => X"1D3F"
    )
    port map (
      ADR0 => DATA_STORE_4_2_Q,
      ADR1 => STATE04(5),
      ADR2 => DATA_STORE_0_2_Q,
      ADR3 => GENCOUNT(1),
      O => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_2_G_3549_SX
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_2_G_3550 : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => G_3549,
      ADR1 => N_3674_REP2,
      ADR2 => N_3836,
      ADR3 => DATA_STORE_6_2_Q,
      O => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_2_G_3550_O
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_2_G_3550_LUT4_L_BUF : X_BUF
    port map (
      I => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_2_G_3550_O,
      O => G_3550
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_3_G_3545 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_STORE_0_3_Q,
      ADR1 => STATE04(5),
      ADR2 => DATA_STORE_4_3_Q,
      ADR3 => N_3842_REP1,
      O => G_3545
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_4_G_3555 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_STORE_0_4_Q,
      ADR1 => STATE04(5),
      ADR2 => DATA_STORE_4_4_Q,
      ADR3 => N_3842_REP1,
      O => G_3555
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_4_G_3556 : X_LUT2
    generic map (
      INIT => X"2"
    )
    port map (
      ADR0 => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_0_S_4_Q,
      ADR1 => N_3674_REP2,
      O => G_3556
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_5_G_3547 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_STORE_0_5_Q,
      ADR1 => STATE04(5),
      ADR2 => DATA_STORE_4_5_Q,
      ADR3 => N_3842_REP1,
      O => G_3547
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_6_G_3557 : X_LUT3
    generic map (
      INIT => X"0E"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => G_2834_FAST,
      ADR2 => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_6_G_3557_SX,
      O => G_3557
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_6_G_3557_SX_194 : X_LUT4
    generic map (
      INIT => X"1D3F"
    )
    port map (
      ADR0 => DATA_STORE_4_6_Q,
      ADR1 => STATE04(5),
      ADR2 => DATA_STORE_0_6_Q,
      ADR3 => GENCOUNT(1),
      O => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_6_G_3557_SX
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_6_G_3558 : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => G_3557,
      ADR1 => N_3674_REP2,
      ADR2 => N_3836,
      ADR3 => DATA_STORE_6_6_Q,
      O => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_6_G_3558_O
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_6_G_3558_LUT4_L_BUF : X_BUF
    port map (
      I => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_6_G_3558_O,
      O => G_3558
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_7_G_3553 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_STORE_0_7_Q,
      ADR1 => STATE04(5),
      ADR2 => DATA_STORE_4_7_Q,
      ADR3 => N_3842_REP2,
      O => G_3553
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_0_S_3_Q_195 : X_LUT4
    generic map (
      INIT => X"0800"
    )
    port map (
      ADR0 => DATA_STORE_6_3_Q,
      ADR1 => GENCOUNT(2),
      ADR2 => N_894_1,
      ADR3 => GENCOUNT(0),
      O => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_0_S_3_Q
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_0_S_4_Q_196 : X_LUT4
    generic map (
      INIT => X"0800"
    )
    port map (
      ADR0 => DATA_STORE_6_4_Q,
      ADR1 => GENCOUNT(2),
      ADR2 => N_894_1,
      ADR3 => GENCOUNT(0),
      O => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_0_S_4_Q
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_0_S_5_Q_197 : X_LUT4
    generic map (
      INIT => X"0800"
    )
    port map (
      ADR0 => DATA_STORE_6_5_Q,
      ADR1 => GENCOUNT(2),
      ADR2 => N_894_1,
      ADR3 => GENCOUNT(0),
      O => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_0_S_5_Q
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_0_S_7_Q_198 : X_LUT4
    generic map (
      INIT => X"0800"
    )
    port map (
      ADR0 => DATA_STORE_6_7_Q,
      ADR1 => GENCOUNT(2),
      ADR2 => N_894_1,
      ADR3 => GENCOUNT(0),
      O => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_0_S_7_Q
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_2_S_3_Q_199 : X_LUT4
    generic map (
      INIT => X"0200"
    )
    port map (
      ADR0 => DATA_STORE_2_3_Q,
      ADR1 => GENCOUNT(2),
      ADR2 => N_894_1,
      ADR3 => GENCOUNT(0),
      O => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_2_S_3_Q
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_2_S_4_Q_200 : X_LUT4
    generic map (
      INIT => X"0200"
    )
    port map (
      ADR0 => DATA_STORE_2_4_Q,
      ADR1 => GENCOUNT(2),
      ADR2 => N_894_1,
      ADR3 => GENCOUNT(0),
      O => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_2_S_4_Q
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_2_S_5_Q_201 : X_LUT4
    generic map (
      INIT => X"0200"
    )
    port map (
      ADR0 => DATA_STORE_2_5_Q,
      ADR1 => GENCOUNT(2),
      ADR2 => N_894_1,
      ADR3 => GENCOUNT(0),
      O => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_2_S_5_Q
    );
  SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_2_S_7_Q_202 : X_LUT4
    generic map (
      INIT => X"0200"
    )
    port map (
      ADR0 => DATA_STORE_2_7_Q,
      ADR1 => GENCOUNT(2),
      ADR2 => N_894_1,
      ADR3 => GENCOUNT(0),
      O => SEL_REGVPIVCI_REGNR_02_1_IV_0_0_AND2_2_S_7_Q
    );
  SEL_REGVPIVCI_VALID_02_1_IV_0_0 : X_LUT4
    generic map (
      INIT => X"F3F2"
    )
    port map (
      ADR0 => SEL_REGVPIVCI_VALID_02_1_IV_0_0_AND2_2_S,
      ADR1 => N_3674_REP2,
      ADR2 => G_3559,
      ADR3 => SEL_REGVPIVCI_VALID_02_1_IV_0_0_AND2_0_S,
      O => SEL_REGVPIVCI_VALID_02_1
    );
  SEL_REGVPIVCI_VALID_02_1_IV_0_0_G_3559 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_STORE_0_31_Q,
      ADR1 => STATE04(5),
      ADR2 => DATA_STORE_4_31_Q,
      ADR3 => N_3842_REP2,
      O => G_3559
    );
  SEL_REGVPIVCI_VALID_02_1_IV_0_0_AND2_0_S_203 : X_LUT4
    generic map (
      INIT => X"0800"
    )
    port map (
      ADR0 => DATA_STORE_6_31_Q,
      ADR1 => GENCOUNT(2),
      ADR2 => N_894_1,
      ADR3 => GENCOUNT(0),
      O => SEL_REGVPIVCI_VALID_02_1_IV_0_0_AND2_0_S
    );
  SEL_REGVPIVCI_VALID_02_1_IV_0_0_AND2_2_S_204 : X_LUT4
    generic map (
      INIT => X"0200"
    )
    port map (
      ADR0 => DATA_STORE_2_31_Q,
      ADR1 => GENCOUNT(2),
      ADR2 => N_894_1,
      ADR3 => GENCOUNT(0),
      O => SEL_REGVPIVCI_VALID_02_1_IV_0_0_AND2_2_S
    );
  SEL_STATE_0_Q : X_SFF
    port map (
      I => N_4762_I,
      CLK => CLK,
      CE => N_3154,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => SEL_STATE(0)
    );
  SEQUENCENR_0_Q : X_FF
    port map (
      I => NGD2VHDL_OI58,
      CLK => CLK,
      CE => STATE(0),
      SET => GND,
      RST => GSR,
      O => SEQUENCENR(0)
    );
  SEQUENCENR_1_Q : X_FF
    port map (
      I => NGD2VHDL_OI57,
      CLK => CLK,
      CE => STATE(0),
      SET => GND,
      RST => GSR,
      O => SEQUENCENR(1)
    );
  SEQUENCENR_2_Q : X_FF
    port map (
      I => NGD2VHDL_OI56,
      CLK => CLK,
      CE => STATE(0),
      SET => GND,
      RST => GSR,
      O => SEQUENCENR(2)
    );
  SEQUENCENR_3_Q : X_FF
    port map (
      I => NGD2VHDL_OI55,
      CLK => CLK,
      CE => STATE(0),
      SET => GND,
      RST => GSR,
      O => SEQUENCENR(3)
    );
  SEQUENCENR_4_Q : X_FF
    port map (
      I => NGD2VHDL_OI54,
      CLK => CLK,
      CE => STATE(0),
      SET => GND,
      RST => GSR,
      O => SEQUENCENR(4)
    );
  SEQUENCENR_5_Q : X_FF
    port map (
      I => NGD2VHDL_OI53,
      CLK => CLK,
      CE => STATE(0),
      SET => GND,
      RST => GSR,
      O => SEQUENCENR(5)
    );
  SEQUENCENR_6_Q : X_FF
    port map (
      I => NGD2VHDL_OI52,
      CLK => CLK,
      CE => STATE(0),
      SET => GND,
      RST => GSR,
      O => SEQUENCENR(6)
    );
  SEQUENCENR_7_Q : X_FF
    port map (
      I => NGD2VHDL_OI51,
      CLK => CLK,
      CE => STATE(0),
      SET => GND,
      RST => GSR,
      O => SEQUENCENR(7)
    );
  SEQUENCENR_8_Q : X_FF
    port map (
      I => NGD2VHDL_OI50,
      CLK => CLK,
      CE => STATE(0),
      SET => GND,
      RST => GSR,
      O => SEQUENCENR(8)
    );
  SEQUENCENR_9_Q : X_FF
    port map (
      I => NGD2VHDL_OI49,
      CLK => CLK,
      CE => STATE(0),
      SET => GND,
      RST => GSR,
      O => SEQUENCENR(9)
    );
  SEQUENCENR_10_Q : X_FF
    port map (
      I => NGD2VHDL_OI48,
      CLK => CLK,
      CE => STATE(0),
      SET => GND,
      RST => GSR,
      O => SEQUENCENR(10)
    );
  SEQUENCENR_11_Q : X_FF
    port map (
      I => NGD2VHDL_OI47,
      CLK => CLK,
      CE => STATE(0),
      SET => GND,
      RST => GSR,
      O => SEQUENCENR(11)
    );
  SEQUENCENR_12_Q : X_FF
    port map (
      I => NGD2VHDL_OI46,
      CLK => CLK,
      CE => STATE(0),
      SET => GND,
      RST => GSR,
      O => SEQUENCENR(12)
    );
  SEQUENCENR_13_Q : X_FF
    port map (
      I => NGD2VHDL_OI45,
      CLK => CLK,
      CE => STATE(0),
      SET => GND,
      RST => GSR,
      O => SEQUENCENR(13)
    );
  SEQUENCENR_14_Q : X_FF
    port map (
      I => NGD2VHDL_OI44,
      CLK => CLK,
      CE => STATE(0),
      SET => GND,
      RST => GSR,
      O => SEQUENCENR(14)
    );
  SEQUENCENR_15_Q : X_FF
    port map (
      I => NGD2VHDL_OI43,
      CLK => CLK,
      CE => STATE(0),
      SET => GND,
      RST => GSR,
      O => SEQUENCENR(15)
    );
  SOC_CC_205 : X_FF
    port map (
      I => SOC_CC_M,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SOC_CC
    );
  SOC_CC_M_206 : X_SFF
    port map (
      I => N_4762_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => SOC_CC_M
    );
  SOC_IN_207 : X_SFF
    port map (
      I => SOC_MOD_IN,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => SOC_IN
    );
  UN1_STATE_0_AND2_208 : X_LUT3
    generic map (
      INIT => X"80"
    )
    port map (
      ADR0 => N_2580,
      ADR1 => N_2575,
      ADR2 => PLCOUNT(2),
      O => UN1_STATE_0_AND2
    );
  UN1_STATE_1_0_AND2_209 : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => N_2580,
      ADR1 => N_2575,
      ADR2 => PLCOUNT(2),
      O => UN1_STATE_1_0_AND2
    );
  UN1_STATE_2_0_AND2_210 : X_LUT4
    generic map (
      INIT => X"0080"
    )
    port map (
      ADR0 => PLCOUNT(1),
      ADR1 => PLCOUNT(0),
      ADR2 => N_2575,
      ADR3 => PLCOUNT(2),
      O => UN1_STATE_2_0_AND2
    );
  UN1_STATE_3_1_AND2_211 : X_LUT4
    generic map (
      INIT => X"0020"
    )
    port map (
      ADR0 => N_2575,
      ADR1 => PLCOUNT(2),
      ADR2 => PLCOUNT(1),
      ADR3 => PLCOUNT(0),
      O => UN1_STATE_3_1_AND2
    );
  UN1_STATE_4_0_AND2_212 : X_LUT4
    generic map (
      INIT => X"8000"
    )
    port map (
      ADR0 => PLCOUNT(1),
      ADR1 => PLCOUNT(0),
      ADR2 => N_2575,
      ADR3 => PLCOUNT(2),
      O => UN1_STATE_4_0_AND2
    );
  UN1_STATE_5_0_AND2_213 : X_LUT4
    generic map (
      INIT => X"0800"
    )
    port map (
      ADR0 => N_2575,
      ADR1 => PLCOUNT(2),
      ADR2 => PLCOUNT(1),
      ADR3 => PLCOUNT(0),
      O => UN1_STATE_5_0_AND2
    );
  UN1_STATE_6_0_AND2_214 : X_LUT4
    generic map (
      INIT => X"0080"
    )
    port map (
      ADR0 => N_2575,
      ADR1 => PLCOUNT(2),
      ADR2 => PLCOUNT(1),
      ADR3 => PLCOUNT(0),
      O => UN1_STATE_6_0_AND2
    );
  UN1_STATE_7_0_AND2_215 : X_LUT4
    generic map (
      INIT => X"0200"
    )
    port map (
      ADR0 => N_2575,
      ADR1 => PLCOUNT(2),
      ADR2 => PLCOUNT(1),
      ADR3 => PLCOUNT(0),
      O => UN1_STATE_7_0_AND2
    );
  UN4_IS_CONTROL_CELL_NE_216 : X_LUT3
    generic map (
      INIT => X"FE"
    )
    port map (
      ADR0 => G_3343,
      ADR1 => G_3339,
      ADR2 => G_3337,
      O => UN4_IS_CONTROL_CELL_NE
    );
  UN4_IS_CONTROL_CELL_NE_G_3334 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => NGD2VHDL_OI51,
      ADR1 => CTRLCELL_VPI(3),
      ADR2 => CTRLCELL_VPI(2),
      ADR3 => NGD2VHDL_OI52,
      O => G_3334
    );
  UN4_IS_CONTROL_CELL_NE_G_3335 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => NGD2VHDL_OI53,
      ADR1 => CTRLCELL_VPI(1),
      ADR2 => NGD2VHDL_OI54,
      ADR3 => CTRLCELL_VPI(0),
      O => G_3335
    );
  UN4_IS_CONTROL_CELL_NE_G_3336 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => NGD2VHDL_OI46,
      ADR1 => CTRLCELL_VPI(8),
      ADR2 => NGD2VHDL_OI47,
      ADR3 => CTRLCELL_VPI(7),
      O => G_3336
    );
  UN4_IS_CONTROL_CELL_NE_G_3337 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => NGD2VHDL_OI50,
      ADR1 => CTRLCELL_VPI(4),
      ADR2 => CTRLCELL_VPI(10),
      ADR3 => NGD2VHDL_OI44,
      O => G_3337
    );
  UN4_IS_CONTROL_CELL_NE_G_3338 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => NGD2VHDL_OI45,
      ADR1 => CTRLCELL_VPI(9),
      ADR2 => NGD2VHDL_OI48,
      ADR3 => CTRLCELL_VPI(6),
      O => G_3338
    );
  UN4_IS_CONTROL_CELL_NE_G_3339 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => NGD2VHDL_OI49,
      ADR1 => CTRLCELL_VPI(5),
      ADR2 => NGD2VHDL_OI43,
      ADR3 => CTRLCELL_VPI(11),
      O => G_3339
    );
  UN4_IS_CONTROL_CELL_NE_G_3343 : X_LUT4
    generic map (
      INIT => X"FFFE"
    )
    port map (
      ADR0 => G_3334,
      ADR1 => G_3335,
      ADR2 => G_3338,
      ADR3 => G_3336,
      O => G_3343
    );
  UN10_IS_CONTROL_CELL_0_I_2 : X_MUX2
    port map (
      IA => GND_INT,
      IB => UN10_IS_CONTROL_CELL_0_DATA_TMP(3),
      SEL => UN10_IS_CONTROL_CELL_0_N_3,
      O => UN10_IS_CONTROL_CELL_0_I_2_O
    );
  UN10_IS_CONTROL_CELL_0_I_2_MUXCY_L_BUF : X_BUF
    port map (
      I => UN10_IS_CONTROL_CELL_0_I_2_O,
      O => UN10_IS_CONTROL_CELL_0_DATA_TMP(4)
    );
  UN10_IS_CONTROL_CELL_0_I_10 : X_LUT4
    generic map (
      INIT => X"9009"
    )
    port map (
      ADR0 => NGD2VHDL_OI61,
      ADR1 => CTRLCELL_VCI(9),
      ADR2 => NGD2VHDL_OI62,
      ADR3 => CTRLCELL_VCI(8),
      O => UN10_IS_CONTROL_CELL_0_N_3
    );
  UN10_IS_CONTROL_CELL_0_I_11 : X_MUX2
    port map (
      IA => GND_INT,
      IB => UN10_IS_CONTROL_CELL_0_DATA_TMP(6),
      SEL => UN10_IS_CONTROL_CELL_0_N_11,
      O => UN10_IS_CONTROL_CELL_0_I_11_O
    );
  UN10_IS_CONTROL_CELL_0_I_11_MUXCY_L_BUF : X_BUF
    port map (
      I => UN10_IS_CONTROL_CELL_0_I_11_O,
      O => I_11
    );
  UN10_IS_CONTROL_CELL_0_I_19 : X_LUT4
    generic map (
      INIT => X"9009"
    )
    port map (
      ADR0 => NGD2VHDL_OI55,
      ADR1 => CTRLCELL_VCI(15),
      ADR2 => NGD2VHDL_OI56,
      ADR3 => CTRLCELL_VCI(14),
      O => UN10_IS_CONTROL_CELL_0_N_11
    );
  UN10_IS_CONTROL_CELL_0_I_20 : X_MUX2
    port map (
      IA => GND_INT,
      IB => UN10_IS_CONTROL_CELL_0_DATA_TMP(2),
      SEL => UN10_IS_CONTROL_CELL_0_N_19,
      O => UN10_IS_CONTROL_CELL_0_I_20_O
    );
  UN10_IS_CONTROL_CELL_0_I_20_MUXCY_L_BUF : X_BUF
    port map (
      I => UN10_IS_CONTROL_CELL_0_I_20_O,
      O => UN10_IS_CONTROL_CELL_0_DATA_TMP(3)
    );
  UN10_IS_CONTROL_CELL_0_I_28 : X_LUT4
    generic map (
      INIT => X"9009"
    )
    port map (
      ADR0 => NGD2VHDL_OI63,
      ADR1 => CTRLCELL_VCI(7),
      ADR2 => NGD2VHDL_OI64,
      ADR3 => CTRLCELL_VCI(6),
      O => UN10_IS_CONTROL_CELL_0_N_19
    );
  UN10_IS_CONTROL_CELL_0_I_29 : X_MUX2
    port map (
      IA => GND_INT,
      IB => UN10_IS_CONTROL_CELL_0_DATA_TMP(5),
      SEL => UN10_IS_CONTROL_CELL_0_N_27,
      O => UN10_IS_CONTROL_CELL_0_I_29_O
    );
  UN10_IS_CONTROL_CELL_0_I_29_MUXCY_L_BUF : X_BUF
    port map (
      I => UN10_IS_CONTROL_CELL_0_I_29_O,
      O => UN10_IS_CONTROL_CELL_0_DATA_TMP(6)
    );
  UN10_IS_CONTROL_CELL_0_I_37 : X_LUT4
    generic map (
      INIT => X"9009"
    )
    port map (
      ADR0 => NGD2VHDL_OI57,
      ADR1 => CTRLCELL_VCI(13),
      ADR2 => NGD2VHDL_OI58,
      ADR3 => CTRLCELL_VCI(12),
      O => UN10_IS_CONTROL_CELL_0_N_27
    );
  UN10_IS_CONTROL_CELL_0_I_38 : X_MUX2
    port map (
      IA => GND_INT,
      IB => UN10_IS_CONTROL_CELL_0_DATA_TMP(1),
      SEL => UN10_IS_CONTROL_CELL_0_N_35,
      O => UN10_IS_CONTROL_CELL_0_I_38_O
    );
  UN10_IS_CONTROL_CELL_0_I_38_MUXCY_L_BUF : X_BUF
    port map (
      I => UN10_IS_CONTROL_CELL_0_I_38_O,
      O => UN10_IS_CONTROL_CELL_0_DATA_TMP(2)
    );
  UN10_IS_CONTROL_CELL_0_I_46 : X_LUT4
    generic map (
      INIT => X"9009"
    )
    port map (
      ADR0 => NGD2VHDL_OI65,
      ADR1 => CTRLCELL_VCI(5),
      ADR2 => NGD2VHDL_OI66,
      ADR3 => CTRLCELL_VCI(4),
      O => UN10_IS_CONTROL_CELL_0_N_35
    );
  UN10_IS_CONTROL_CELL_0_I_47 : X_MUX2
    port map (
      IA => GND_INT,
      IB => UN10_IS_CONTROL_CELL_0_DATA_TMP(4),
      SEL => UN10_IS_CONTROL_CELL_0_N_43,
      O => UN10_IS_CONTROL_CELL_0_I_47_O
    );
  UN10_IS_CONTROL_CELL_0_I_47_MUXCY_L_BUF : X_BUF
    port map (
      I => UN10_IS_CONTROL_CELL_0_I_47_O,
      O => UN10_IS_CONTROL_CELL_0_DATA_TMP(5)
    );
  UN10_IS_CONTROL_CELL_0_I_55 : X_LUT4
    generic map (
      INIT => X"9009"
    )
    port map (
      ADR0 => NGD2VHDL_OI59,
      ADR1 => CTRLCELL_VCI(11),
      ADR2 => NGD2VHDL_OI60,
      ADR3 => CTRLCELL_VCI(10),
      O => UN10_IS_CONTROL_CELL_0_N_43
    );
  UN10_IS_CONTROL_CELL_0_I_56 : X_MUX2
    port map (
      IA => GND_INT,
      IB => UN10_IS_CONTROL_CELL_0_DATA_TMP(0),
      SEL => UN10_IS_CONTROL_CELL_0_N_51,
      O => UN10_IS_CONTROL_CELL_0_I_56_O
    );
  UN10_IS_CONTROL_CELL_0_I_56_MUXCY_L_BUF : X_BUF
    port map (
      I => UN10_IS_CONTROL_CELL_0_I_56_O,
      O => UN10_IS_CONTROL_CELL_0_DATA_TMP(1)
    );
  UN10_IS_CONTROL_CELL_0_I_64 : X_LUT4
    generic map (
      INIT => X"9009"
    )
    port map (
      ADR0 => NGD2VHDL_OI67,
      ADR1 => CTRLCELL_VCI(3),
      ADR2 => NGD2VHDL_OI68,
      ADR3 => CTRLCELL_VCI(2),
      O => UN10_IS_CONTROL_CELL_0_N_51
    );
  UN10_IS_CONTROL_CELL_0_I_65 : X_MUX2
    port map (
      IA => GND_INT,
      IB => VCC_INT,
      SEL => UN10_IS_CONTROL_CELL_0_N_59,
      O => UN10_IS_CONTROL_CELL_0_I_65_O
    );
  UN10_IS_CONTROL_CELL_0_I_65_MUXCY_L_BUF : X_BUF
    port map (
      I => UN10_IS_CONTROL_CELL_0_I_65_O,
      O => UN10_IS_CONTROL_CELL_0_DATA_TMP(0)
    );
  UN10_IS_CONTROL_CELL_0_I_73 : X_LUT4
    generic map (
      INIT => X"9009"
    )
    port map (
      ADR0 => NGD2VHDL_OI69,
      ADR1 => CTRLCELL_VCI(1),
      ADR2 => NGD2VHDL_OI70,
      ADR3 => CTRLCELL_VCI(0),
      O => UN10_IS_CONTROL_CELL_0_N_59
    );
  VALID_02_217 : X_FF
    port map (
      I => SEL_REGVPIVCI_VALID_02_1,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VALID_02
    );
  VALID_04_218 : X_FF
    port map (
      I => VALID_02,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VALID_04
    );
  VCI_02_0_Q : X_FF
    port map (
      I => G_2960,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VCI_02(0)
    );
  VCI_02_1_Q : X_FF
    port map (
      I => G_2959,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VCI_02(1)
    );
  VCI_02_2_Q : X_FF
    port map (
      I => G_2958,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VCI_02(2)
    );
  VCI_02_3_Q : X_FF
    port map (
      I => G_2957,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VCI_02(3)
    );
  VCI_02_4_Q : X_FF
    port map (
      I => G_2956,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VCI_02(4)
    );
  VCI_02_5_Q : X_FF
    port map (
      I => G_2955,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VCI_02(5)
    );
  VCI_02_6_Q : X_FF
    port map (
      I => G_2954,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VCI_02(6)
    );
  VCI_02_7_Q : X_FF
    port map (
      I => G_2953,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VCI_02(7)
    );
  VCI_02_8_Q : X_FF
    port map (
      I => G_2952,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VCI_02(8)
    );
  VCI_02_9_Q : X_FF
    port map (
      I => G_2951,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VCI_02(9)
    );
  VCI_02_10_Q : X_FF
    port map (
      I => G_2950,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VCI_02(10)
    );
  VCI_02_11_Q : X_FF
    port map (
      I => G_2949,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VCI_02(11)
    );
  VCI_02_12_Q : X_FF
    port map (
      I => G_2948,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VCI_02(12)
    );
  VCI_02_13_Q : X_FF
    port map (
      I => G_2947,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VCI_02(13)
    );
  VCI_02_14_Q : X_FF
    port map (
      I => G_2946,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VCI_02(14)
    );
  VCI_02_15_Q : X_FF
    port map (
      I => G_2945,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VCI_02(15)
    );
  VPI_02_0_Q : X_FF
    port map (
      I => G_2944,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VPI_02(0)
    );
  VPI_02_1_Q : X_FF
    port map (
      I => G_2943,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VPI_02(1)
    );
  VPI_02_2_Q : X_FF
    port map (
      I => G_2942,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VPI_02(2)
    );
  VPI_02_3_Q : X_FF
    port map (
      I => G_2941,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VPI_02(3)
    );
  VPI_02_4_Q : X_FF
    port map (
      I => G_2940,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VPI_02(4)
    );
  VPI_02_5_Q : X_FF
    port map (
      I => G_2939,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VPI_02(5)
    );
  VPI_02_6_Q : X_FF
    port map (
      I => G_2966,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VPI_02(6)
    );
  VPI_02_7_Q : X_FF
    port map (
      I => G_2965,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VPI_02(7)
    );
  VPI_02_8_Q : X_FF
    port map (
      I => G_2964,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VPI_02(8)
    );
  VPI_02_9_Q : X_FF
    port map (
      I => G_2963,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VPI_02(9)
    );
  VPI_02_10_Q : X_FF
    port map (
      I => G_2962,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VPI_02(10)
    );
  VPI_02_11_Q : X_FF
    port map (
      I => G_2961,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => VPI_02(11)
    );
  GND_219 : X_ZERO
    port map (
      O => GND
    );
  CHECK_D_OUT_MOD_0_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI74
    );
  CHECK_D_OUT_MOD_1_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI73
    );
  CHECK_D_OUT_MOD_2_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI72
    );
  CHECK_D_OUT_MOD_3_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI71
    );
  CHECK_D_OUT_MOD_4_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI70
    );
  CHECK_D_OUT_MOD_5_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI69
    );
  CHECK_D_OUT_MOD_6_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI68
    );
  CHECK_D_OUT_MOD_7_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI67
    );
  CHECK_D_OUT_MOD_8_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI66
    );
  CHECK_D_OUT_MOD_9_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI65
    );
  CHECK_D_OUT_MOD_10_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI64
    );
  CHECK_D_OUT_MOD_11_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI63
    );
  CHECK_D_OUT_MOD_12_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI62
    );
  CHECK_D_OUT_MOD_13_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI61
    );
  CHECK_D_OUT_MOD_14_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(14),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI60
    );
  CHECK_D_OUT_MOD_15_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(15),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI59
    );
  CHECK_D_OUT_MOD_16_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(16),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI58
    );
  CHECK_D_OUT_MOD_17_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(17),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI57
    );
  CHECK_D_OUT_MOD_18_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(18),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI56
    );
  CHECK_D_OUT_MOD_19_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(19),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI55
    );
  CHECK_D_OUT_MOD_20_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(20),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI54
    );
  CHECK_D_OUT_MOD_21_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(21),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI53
    );
  CHECK_D_OUT_MOD_22_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(22),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI52
    );
  CHECK_D_OUT_MOD_23_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(23),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI51
    );
  CHECK_D_OUT_MOD_24_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(24),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI50
    );
  CHECK_D_OUT_MOD_25_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(25),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI49
    );
  CHECK_D_OUT_MOD_26_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(26),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI48
    );
  CHECK_D_OUT_MOD_27_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(27),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI47
    );
  CHECK_D_OUT_MOD_28_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(28),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI46
    );
  CHECK_D_OUT_MOD_29_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(29),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI45
    );
  CHECK_D_OUT_MOD_30_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(30),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI44
    );
  CHECK_D_OUT_MOD_31_Q : X_FF
    port map (
      I => CHECK_DATA_OUT(31),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI43
    );
  CHECK_G_19 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_DATA_IN(29),
      ADR1 => CHECK_DATA_IN(17),
      O => CHECK_N_54
    );
  CHECK_G_21 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_DATA_IN(13),
      ADR1 => CHECK_DATA_IN(15),
      O => CHECK_N_56
    );
  CHECK_G_23 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_DATA_IN(18),
      ADR1 => CHECK_DATA_IN(16),
      O => CHECK_N_58
    );
  CHECK_G_24 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CHECK_DATA_IN(6),
      ADR1 => CHECK_DATA_IN(28),
      ADR2 => CHECK_DATA_IN(12),
      O => CHECK_N_59
    );
  CHECK_G_27 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CHECK_N_54,
      ADR1 => CHECK_N_56,
      ADR2 => CHECK_DATA_IN(22),
      O => CHECK_N_62
    );
  CHECK_G_28 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_DATA_IN(14),
      ADR1 => CHECK_DATA_IN(30),
      ADR2 => CHECK_N_58,
      ADR3 => CHECK_DATA_IN(23),
      O => CHECK_N_63
    );
  CHECK_G_29 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_DATA_IN(21),
      ADR1 => CHECK_DATA_IN(6),
      ADR2 => CHECK_DATA_IN(28),
      ADR3 => CHECK_DATA_IN(12),
      O => CHECK_N_64
    );
  CHECK_G_30 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_DATA_IN(24),
      ADR1 => CHECK_DATA_IN(0),
      O => CHECK_N_65
    );
  CHECK_G_31 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_DATA_IN(1),
      ADR1 => CHECK_DATA_IN(25),
      O => CHECK_N_66
    );
  CHECK_G_32 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_DATA_IN(27),
      ADR1 => CHECK_DATA_IN(20),
      O => CHECK_N_67
    );
  CHECK_G_33 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_DATA_IN(26),
      ADR1 => CHECK_DATA_IN(19),
      O => CHECK_N_68
    );
  CHECK_G_34 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_DATA_IN(9),
      ADR1 => CHECK_DATA_IN(11),
      O => CHECK_N_69
    );
  CHECK_G_35 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_DATA_IN(4),
      ADR1 => CHECK_DATA_IN(5),
      O => CHECK_N_70
    );
  CHECK_G_36 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_DATA_IN(2),
      ADR1 => CHECK_DATA_IN(3),
      O => CHECK_N_71
    );
  CHECK_G_37 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_DATA_IN(8),
      ADR1 => CHECK_DATA_IN(10),
      O => CHECK_N_72
    );
  CHECK_HEC_PROC_V_HEC_1_0_AND2_1_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_N_64,
      ADR1 => CHECK_G_3422,
      ADR2 => CHECK_N_62,
      ADR3 => CHECK_N_63,
      O => CHECK_HEC_CALC_1_Q
    );
  CHECK_HEC_PROC_V_HEC_1_0_AND2_3_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_N_63,
      ADR1 => CHECK_G_3411,
      ADR2 => CHECK_G_3410,
      ADR3 => CHECK_N_66,
      O => CHECK_HEC_CALC_3_Q
    );
  CHECK_HEC_PROC_V_HEC_1_0_AND2_5_Q : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CHECK_G_3316,
      ADR1 => CHECK_G_3312,
      ADR2 => CHECK_N_70,
      O => CHECK_HEC_CALC_5_Q
    );
  CHECK_HEC_PROC_V_HEC_1_0_AND2_7_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_N_62,
      ADR1 => CHECK_G_3405,
      ADR2 => CHECK_N_67,
      ADR3 => CHECK_G_3404,
      O => CHECK_HEC_CALC_7_Q
    );
  CHECK_HEC_PROC_V_HEC_1_0_AND2_0_G_3416 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_DATA_IN(31),
      ADR1 => CHECK_DATA_IN(8),
      O => CHECK_G_3416
    );
  CHECK_HEC_PROC_V_HEC_1_0_AND2_0_G_3417 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CHECK_DATA_IN(7),
      ADR1 => CHECK_DATA_IN(0),
      ADR2 => CHECK_DATA_IN(19),
      O => CHECK_G_3417
    );
  CHECK_HEC_PROC_V_HEC_1_0_AND2_1_G_3422 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_N_65,
      ADR1 => CHECK_DATA_IN(1),
      ADR2 => CHECK_DATA_IN(20),
      ADR3 => CHECK_DATA_IN(9),
      O => CHECK_G_3422
    );
  CHECK_HEC_PROC_V_HEC_1_0_AND2_2_G_3395 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CHECK_N_59,
      ADR1 => CHECK_N_65,
      ADR2 => CHECK_DATA_IN(2),
      O => CHECK_G_3395
    );
  CHECK_HEC_PROC_V_HEC_1_0_AND2_3_G_3410 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_DATA_IN(29),
      ADR1 => CHECK_DATA_IN(13),
      ADR2 => CHECK_DATA_IN(7),
      ADR3 => CHECK_DATA_IN(26),
      O => CHECK_G_3410
    );
  CHECK_HEC_PROC_V_HEC_1_0_AND2_3_G_3411 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_DATA_IN(11),
      ADR1 => CHECK_DATA_IN(9),
      ADR2 => CHECK_DATA_IN(3),
      ADR3 => CHECK_DATA_IN(2),
      O => CHECK_G_3411
    );
  CHECK_HEC_PROC_V_HEC_1_0_AND2_4_G_3305 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_DATA_IN(24),
      ADR1 => CHECK_DATA_IN(27),
      ADR2 => CHECK_DATA_IN(31),
      ADR3 => CHECK_DATA_IN(17),
      O => CHECK_G_3305
    );
  CHECK_HEC_PROC_V_HEC_1_0_AND2_4_G_3306 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_DATA_IN(19),
      ADR1 => CHECK_DATA_IN(26),
      ADR2 => CHECK_DATA_IN(14),
      ADR3 => CHECK_DATA_IN(30),
      O => CHECK_G_3306
    );
  CHECK_HEC_PROC_V_HEC_1_0_AND2_4_G_3308 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_G_3305,
      ADR1 => CHECK_DATA_IN(4),
      ADR2 => CHECK_DATA_IN(12),
      ADR3 => CHECK_DATA_IN(15),
      O => CHECK_G_3308
    );
  CHECK_HEC_PROC_V_HEC_1_0_AND2_5_G_3312 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_DATA_IN(3),
      ADR1 => CHECK_DATA_IN(25),
      ADR2 => CHECK_DATA_IN(31),
      ADR3 => CHECK_DATA_IN(28),
      O => CHECK_G_3312
    );
  CHECK_HEC_PROC_V_HEC_1_0_AND2_5_G_3316 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_N_56,
      ADR1 => CHECK_N_58,
      ADR2 => CHECK_N_67,
      ADR3 => CHECK_N_69,
      O => CHECK_G_3316
    );
  CHECK_HEC_PROC_V_HEC_1_0_AND2_6_G_3400 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_N_70,
      ADR1 => CHECK_DATA_IN(14),
      ADR2 => CHECK_DATA_IN(16),
      ADR3 => CHECK_DATA_IN(10),
      O => CHECK_G_3400
    );
  CHECK_HEC_PROC_V_HEC_1_0_AND2_7_G_3404 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_DATA_IN(6),
      ADR1 => CHECK_DATA_IN(7),
      O => CHECK_G_3404
    );
  CHECK_HEC_PROC_V_HEC_1_0_AND2_7_G_3405 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_DATA_IN(18),
      ADR1 => CHECK_DATA_IN(11),
      ADR2 => CHECK_DATA_IN(5),
      ADR3 => CHECK_DATA_IN(30),
      O => CHECK_G_3405
    );
  CHECK_HEC_PROC_V_HEC_1_I_0_Q_220 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => CHECK_N_63,
      ADR1 => CHECK_N_64,
      ADR2 => CHECK_G_3417,
      ADR3 => CHECK_G_3416,
      O => CHECK_HEC_PROC_V_HEC_1_I_0_Q
    );
  CHECK_HEC_PROC_V_HEC_1_I_2_Q_221 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => CHECK_N_62,
      ADR1 => CHECK_G_3395,
      ADR2 => CHECK_N_66,
      ADR3 => CHECK_N_72,
      O => CHECK_HEC_PROC_V_HEC_1_I_2_Q
    );
  CHECK_HEC_PROC_V_HEC_1_I_4_Q_222 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => CHECK_G_3308,
      ADR1 => CHECK_G_3306,
      ADR2 => CHECK_N_72,
      ADR3 => CHECK_N_71,
      O => CHECK_HEC_PROC_V_HEC_1_I_4_Q
    );
  CHECK_HEC_PROC_V_HEC_1_I_6_Q_223 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => CHECK_N_64,
      ADR1 => CHECK_G_3400,
      ADR2 => CHECK_N_54,
      ADR3 => CHECK_N_68,
      O => CHECK_HEC_PROC_V_HEC_1_I_6_Q
    );
  CHECK_SOC_OUT_MOD : X_SFF
    port map (
      I => CHECK_SOC_OUT,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_OUT_PROC_UN6_SOC_OUT_NE,
      O => SOC
    );
  CHECK_CRC_OK : X_SFF
    port map (
      I => G_3668,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_CRC_CALC_0(13),
      O => CRC_OK
    );
  CHECK_DATA_IN_0_Q : X_FF
    port map (
      I => DATA_IN(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(0)
    );
  CHECK_DATA_IN_1_Q : X_FF
    port map (
      I => DATA_IN(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(1)
    );
  CHECK_DATA_IN_2_Q : X_FF
    port map (
      I => DATA_IN(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(2)
    );
  CHECK_DATA_IN_3_Q : X_FF
    port map (
      I => DATA_IN(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(3)
    );
  CHECK_DATA_IN_4_Q : X_FF
    port map (
      I => DATA_IN(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(4)
    );
  CHECK_DATA_IN_5_Q : X_FF
    port map (
      I => DATA_IN(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(5)
    );
  CHECK_DATA_IN_6_Q : X_FF
    port map (
      I => DATA_IN(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(6)
    );
  CHECK_DATA_IN_7_Q : X_FF
    port map (
      I => DATA_IN(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(7)
    );
  CHECK_DATA_IN_8_Q : X_FF
    port map (
      I => DATA_IN(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(8)
    );
  CHECK_DATA_IN_9_Q : X_FF
    port map (
      I => DATA_IN(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(9)
    );
  CHECK_DATA_IN_10_Q : X_FF
    port map (
      I => DATA_IN(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(10)
    );
  CHECK_DATA_IN_11_Q : X_FF
    port map (
      I => DATA_IN(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(11)
    );
  CHECK_DATA_IN_12_Q : X_FF
    port map (
      I => DATA_IN(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(12)
    );
  CHECK_DATA_IN_13_Q : X_FF
    port map (
      I => DATA_IN(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(13)
    );
  CHECK_DATA_IN_14_Q : X_FF
    port map (
      I => DATA_IN(14),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(14)
    );
  CHECK_DATA_IN_15_Q : X_FF
    port map (
      I => DATA_IN(15),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(15)
    );
  CHECK_DATA_IN_16_Q : X_FF
    port map (
      I => DATA_IN(16),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(16)
    );
  CHECK_DATA_IN_17_Q : X_FF
    port map (
      I => DATA_IN(17),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(17)
    );
  CHECK_DATA_IN_18_Q : X_FF
    port map (
      I => DATA_IN(18),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(18)
    );
  CHECK_DATA_IN_19_Q : X_FF
    port map (
      I => DATA_IN(19),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(19)
    );
  CHECK_DATA_IN_20_Q : X_FF
    port map (
      I => DATA_IN(20),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(20)
    );
  CHECK_DATA_IN_21_Q : X_FF
    port map (
      I => DATA_IN(21),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(21)
    );
  CHECK_DATA_IN_22_Q : X_FF
    port map (
      I => DATA_IN(22),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(22)
    );
  CHECK_DATA_IN_23_Q : X_FF
    port map (
      I => DATA_IN(23),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(23)
    );
  CHECK_DATA_IN_24_Q : X_FF
    port map (
      I => DATA_IN(24),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(24)
    );
  CHECK_DATA_IN_25_Q : X_FF
    port map (
      I => DATA_IN(25),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(25)
    );
  CHECK_DATA_IN_26_Q : X_FF
    port map (
      I => DATA_IN(26),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(26)
    );
  CHECK_DATA_IN_27_Q : X_FF
    port map (
      I => DATA_IN(27),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(27)
    );
  CHECK_DATA_IN_28_Q : X_FF
    port map (
      I => DATA_IN(28),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(28)
    );
  CHECK_DATA_IN_29_Q : X_FF
    port map (
      I => DATA_IN(29),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(29)
    );
  CHECK_DATA_IN_30_Q : X_FF
    port map (
      I => DATA_IN(30),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(30)
    );
  CHECK_DATA_IN_31_Q : X_FF
    port map (
      I => DATA_IN(31),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_IN(31)
    );
  CHECK_DATA_OUT_0_Q : X_FF
    port map (
      I => CHECK_DATA_IN(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(0)
    );
  CHECK_DATA_OUT_1_Q : X_FF
    port map (
      I => CHECK_DATA_IN(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(1)
    );
  CHECK_DATA_OUT_2_Q : X_FF
    port map (
      I => CHECK_DATA_IN(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(2)
    );
  CHECK_DATA_OUT_3_Q : X_FF
    port map (
      I => CHECK_DATA_IN(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(3)
    );
  CHECK_DATA_OUT_4_Q : X_FF
    port map (
      I => CHECK_DATA_IN(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(4)
    );
  CHECK_DATA_OUT_5_Q : X_FF
    port map (
      I => CHECK_DATA_IN(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(5)
    );
  CHECK_DATA_OUT_6_Q : X_FF
    port map (
      I => CHECK_DATA_IN(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(6)
    );
  CHECK_DATA_OUT_7_Q : X_FF
    port map (
      I => CHECK_DATA_IN(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(7)
    );
  CHECK_DATA_OUT_8_Q : X_FF
    port map (
      I => CHECK_DATA_IN(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(8)
    );
  CHECK_DATA_OUT_9_Q : X_FF
    port map (
      I => CHECK_DATA_IN(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(9)
    );
  CHECK_DATA_OUT_10_Q : X_FF
    port map (
      I => CHECK_DATA_IN(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(10)
    );
  CHECK_DATA_OUT_11_Q : X_FF
    port map (
      I => CHECK_DATA_IN(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(11)
    );
  CHECK_DATA_OUT_12_Q : X_FF
    port map (
      I => CHECK_DATA_IN(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(12)
    );
  CHECK_DATA_OUT_13_Q : X_FF
    port map (
      I => CHECK_DATA_IN(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(13)
    );
  CHECK_DATA_OUT_14_Q : X_FF
    port map (
      I => CHECK_DATA_IN(14),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(14)
    );
  CHECK_DATA_OUT_15_Q : X_FF
    port map (
      I => CHECK_DATA_IN(15),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(15)
    );
  CHECK_DATA_OUT_16_Q : X_FF
    port map (
      I => CHECK_DATA_IN(16),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(16)
    );
  CHECK_DATA_OUT_17_Q : X_FF
    port map (
      I => CHECK_DATA_IN(17),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(17)
    );
  CHECK_DATA_OUT_18_Q : X_FF
    port map (
      I => CHECK_DATA_IN(18),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(18)
    );
  CHECK_DATA_OUT_19_Q : X_FF
    port map (
      I => CHECK_DATA_IN(19),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(19)
    );
  CHECK_DATA_OUT_20_Q : X_FF
    port map (
      I => CHECK_DATA_IN(20),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(20)
    );
  CHECK_DATA_OUT_21_Q : X_FF
    port map (
      I => CHECK_DATA_IN(21),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(21)
    );
  CHECK_DATA_OUT_22_Q : X_FF
    port map (
      I => CHECK_DATA_IN(22),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(22)
    );
  CHECK_DATA_OUT_23_Q : X_FF
    port map (
      I => CHECK_DATA_IN(23),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(23)
    );
  CHECK_DATA_OUT_24_Q : X_FF
    port map (
      I => CHECK_DATA_IN(24),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(24)
    );
  CHECK_DATA_OUT_25_Q : X_FF
    port map (
      I => CHECK_DATA_IN(25),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(25)
    );
  CHECK_DATA_OUT_26_Q : X_FF
    port map (
      I => CHECK_DATA_IN(26),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(26)
    );
  CHECK_DATA_OUT_27_Q : X_FF
    port map (
      I => CHECK_DATA_IN(27),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(27)
    );
  CHECK_DATA_OUT_28_Q : X_FF
    port map (
      I => CHECK_DATA_IN(28),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(28)
    );
  CHECK_DATA_OUT_29_Q : X_FF
    port map (
      I => CHECK_DATA_IN(29),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(29)
    );
  CHECK_DATA_OUT_30_Q : X_FF
    port map (
      I => CHECK_DATA_IN(30),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(30)
    );
  CHECK_DATA_OUT_31_Q : X_FF
    port map (
      I => CHECK_DATA_IN(31),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_DATA_OUT(31)
    );
  CHECK_HEC_0_Q : X_FF
    port map (
      I => CHECK_HEC_PROC_V_HEC_1_I_0_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_HEC(0)
    );
  CHECK_HEC_1_Q : X_FF
    port map (
      I => CHECK_HEC_CALC_1_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_HEC(1)
    );
  CHECK_HEC_2_Q : X_FF
    port map (
      I => CHECK_HEC_PROC_V_HEC_1_I_2_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_HEC(2)
    );
  CHECK_HEC_3_Q : X_FF
    port map (
      I => CHECK_HEC_CALC_3_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_HEC(3)
    );
  CHECK_HEC_4_Q : X_FF
    port map (
      I => CHECK_HEC_PROC_V_HEC_1_I_4_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_HEC(4)
    );
  CHECK_HEC_5_Q : X_FF
    port map (
      I => CHECK_HEC_CALC_5_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_HEC(5)
    );
  CHECK_HEC_6_Q : X_FF
    port map (
      I => CHECK_HEC_PROC_V_HEC_1_I_6_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_HEC(6)
    );
  CHECK_HEC_7_Q : X_FF
    port map (
      I => CHECK_HEC_CALC_7_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_HEC(7)
    );
  CHECK_OUT_PROC_UN6_SOC_OUT_NE_224 : X_LUT4
    generic map (
      INIT => X"FFFE"
    )
    port map (
      ADR0 => CHECK_G_3279,
      ADR1 => CHECK_G_3277,
      ADR2 => CHECK_G_3280,
      ADR3 => CHECK_G_3278,
      O => CHECK_OUT_PROC_UN6_SOC_OUT_NE
    );
  CHECK_OUT_PROC_UN6_SOC_OUT_NE_G_3277 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => CHECK_HEC(5),
      ADR1 => CHECK_DATA_IN(29),
      ADR2 => CHECK_HEC(1),
      ADR3 => CHECK_DATA_IN(25),
      O => CHECK_G_3277
    );
  CHECK_OUT_PROC_UN6_SOC_OUT_NE_G_3278 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => CHECK_HEC(6),
      ADR1 => CHECK_DATA_IN(30),
      ADR2 => CHECK_HEC(4),
      ADR3 => CHECK_DATA_IN(28),
      O => CHECK_G_3278
    );
  CHECK_OUT_PROC_UN6_SOC_OUT_NE_G_3279 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => CHECK_HEC(3),
      ADR1 => CHECK_DATA_IN(27),
      ADR2 => CHECK_HEC(2),
      ADR3 => CHECK_DATA_IN(26),
      O => CHECK_G_3279
    );
  CHECK_OUT_PROC_UN6_SOC_OUT_NE_G_3280 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => CHECK_HEC(0),
      ADR1 => CHECK_DATA_IN(24),
      ADR2 => CHECK_HEC(7),
      ADR3 => CHECK_DATA_IN(31),
      O => CHECK_G_3280
    );
  CHECK_SOC_IN_225 : X_FF
    port map (
      I => SOC_IN,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_SOC_IN
    );
  CHECK_SOC_OUT_226 : X_FF
    port map (
      I => CHECK_SOC_IN,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CHECK_SOC_OUT
    );
  CHECK_SOC_OUT_I_227 : X_INV
    port map (
      I => CHECK_SOC_OUT,
      O => CHECK_SOC_OUT_I
    );
  CHECK_CRC_GEN_G_134 : X_LUT4
    generic map (
      INIT => X"F7FF"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_COUNTER(0),
      ADR1 => CHECK_CRC_GEN_COUNTER(1),
      ADR2 => CHECK_CRC_GEN_COUNTER(2),
      ADR3 => CHECK_CRC_GEN_N_4_1,
      O => CHECK_CRC_GEN_G_134_0
    );
  CHECK_CRC_GEN_G_135_228 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => CHECK_DATA_IN(3),
      ADR1 => CHECK_DATA_IN(7),
      O => CHECK_CRC_GEN_G_135
    );
  CHECK_CRC_GEN_G_137_229 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => CHECK_DATA_IN(6),
      ADR1 => CHECK_DATA_IN(2),
      O => CHECK_CRC_GEN_G_137
    );
  CHECK_CRC_GEN_G_139 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CHECK_DATA_IN(11),
      ADR1 => CHECK_DATA_IN(7),
      ADR2 => CHECK_DATA_IN(3),
      O => CHECK_CRC_GEN_G_139_0
    );
  CHECK_CRC_GEN_G_140 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => CHECK_DATA_IN(5),
      ADR1 => CHECK_DATA_IN(9),
      O => CHECK_CRC_GEN_G_140_0
    );
  CHECK_CRC_GEN_G_141 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => CHECK_DATA_IN(12),
      ADR1 => CHECK_DATA_IN(4),
      ADR2 => CHECK_DATA_IN(1),
      ADR3 => CHECK_DATA_IN(0),
      O => CHECK_CRC_GEN_G_141_0
    );
  CHECK_CRC_GEN_G_143_230 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CHECK_DATA_IN(13),
      ADR1 => CHECK_DATA_IN(9),
      ADR2 => CHECK_DATA_IN(5),
      O => CHECK_CRC_GEN_G_143
    );
  CHECK_CRC_GEN_G_150 : X_LUT3
    generic map (
      INIT => X"6A"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_COUNTER(2),
      ADR1 => CHECK_CRC_GEN_COUNTER(0),
      ADR2 => CHECK_CRC_GEN_COUNTER(1),
      O => CHECK_CRC_GEN_G_150_0
    );
  CHECK_CRC_GEN_G_151 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_139_0,
      ADR1 => CHECK_CRC_GEN_G_3356,
      ADR2 => CHECK_CRC_GEN_G_137,
      ADR3 => CHECK_DATA_IN(10),
      O => CHECK_CRC_GEN_G_151_0
    );
  CHECK_CRC_GEN_G_155 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_137,
      ADR1 => CHECK_CRC_GEN_G_139_0,
      ADR2 => CHECK_DATA_IN(0),
      O => CHECK_CRC_GEN_G_155_0
    );
  CHECK_CRC_GEN_G_156_231 : X_LUT4
    generic map (
      INIT => X"2EE2"
    )
    port map (
      ADR0 => CHECK_DATA_IN(0),
      ADR1 => CHECK_CRC_GEN_G_134_0,
      ADR2 => CHECK_CRC_GEN_G_3356,
      ADR3 => CHECK_CRC_GEN_G_139_0,
      O => CHECK_CRC_GEN_G_156
    );
  CHECK_CRC_GEN_G_158_232 : X_LUT4
    generic map (
      INIT => X"A66A"
    )
    port map (
      ADR0 => CHECK_DATA_IN(2),
      ADR1 => CHECK_CRC_GEN_G_134_0,
      ADR2 => CHECK_CRC_GEN_G_143,
      ADR3 => CHECK_DATA_IN(1),
      O => CHECK_CRC_GEN_G_158
    );
  CHECK_CRC_GEN_G_162_233 : X_LUT4
    generic map (
      INIT => X"E22E"
    )
    port map (
      ADR0 => CHECK_DATA_IN(11),
      ADR1 => CHECK_CRC_GEN_G_134_0,
      ADR2 => CHECK_CRC_GEN_G_3273,
      ADR3 => CHECK_CRC_GEN_G_140_0,
      O => CHECK_CRC_GEN_G_162
    );
  CHECK_CRC_GEN_G_171 : X_LUT4
    generic map (
      INIT => X"E22E"
    )
    port map (
      ADR0 => CHECK_DATA_IN(3),
      ADR1 => CHECK_CRC_GEN_G_134_0,
      ADR2 => CHECK_CRC_GEN_G_141_0,
      ADR3 => CHECK_DATA_IN(8),
      O => CHECK_CRC_GEN_G_171_0
    );
  CHECK_CRC_GEN_N_86_I_234 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_COUNTER(1),
      ADR1 => CHECK_CRC_GEN_COUNTER(0),
      O => CHECK_CRC_GEN_N_86_I
    );
  CHECK_CRC_GEN_N_87_I_235 : X_LUT4
    generic map (
      INIT => X"6AAA"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_N_4_1,
      ADR1 => CHECK_CRC_GEN_COUNTER(2),
      ADR2 => CHECK_CRC_GEN_COUNTER(0),
      ADR3 => CHECK_CRC_GEN_COUNTER(1),
      O => CHECK_CRC_GEN_N_87_I
    );
  CHECK_CRC_GEN_COUNTER_0_Q : X_SFF
    port map (
      I => CHECK_SOC_OUT_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_CRC_GEN_COUNTER(0),
      O => CHECK_CRC_GEN_COUNTER(0)
    );
  CHECK_CRC_GEN_COUNTER_1_Q : X_SFF
    port map (
      I => CHECK_CRC_GEN_N_86_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_SOC_OUT,
      O => CHECK_CRC_GEN_COUNTER(1)
    );
  CHECK_CRC_GEN_COUNTER_2_Q : X_SFF
    port map (
      I => CHECK_CRC_GEN_G_150_0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_SOC_OUT,
      O => CHECK_CRC_GEN_COUNTER(2)
    );
  CHECK_CRC_GEN_COUNTER_3_Q : X_SFF
    port map (
      I => CHECK_CRC_GEN_N_87_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_SOC_OUT,
      O => CHECK_CRC_GEN_N_4_1
    );
  CHECK_CRC_GEN_CRC16_OUT_0_Q : X_SFF
    port map (
      I => CHECK_CRC_GEN_UN5_NX_CRC_0(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_SOC_OUT,
      O => CHECK_CRC_CALC_0_Q
    );
  CHECK_CRC_GEN_CRC16_OUT_1_Q : X_SFF
    port map (
      I => CHECK_CRC_GEN_UN5_NX_CRC_0(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_SOC_OUT,
      O => CHECK_CRC_CALC_1_Q
    );
  CHECK_CRC_GEN_CRC16_OUT_2_Q : X_SFF
    port map (
      I => CHECK_CRC_GEN_UN5_NX_CRC_0(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_SOC_OUT,
      O => CHECK_CRC_CALC_2_Q
    );
  CHECK_CRC_GEN_CRC16_OUT_3_Q : X_SFF
    port map (
      I => CHECK_CRC_GEN_UN5_NX_CRC_0(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_SOC_OUT,
      O => CHECK_CRC_CALC_3_Q
    );
  CHECK_CRC_GEN_CRC16_OUT_4_Q : X_SFF
    port map (
      I => CHECK_CRC_GEN_UN5_NX_CRC_0(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_SOC_OUT,
      O => CHECK_CRC_CALC_4_Q
    );
  CHECK_CRC_GEN_CRC16_OUT_5_Q : X_SFF
    port map (
      I => CHECK_CRC_GEN_UN5_NX_CRC_0(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_SOC_OUT,
      O => CHECK_CRC_CALC_5_Q
    );
  CHECK_CRC_GEN_CRC16_OUT_6_Q : X_SFF
    port map (
      I => CHECK_CRC_GEN_UN5_NX_CRC_0(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_SOC_OUT,
      O => CHECK_CRC_CALC_6_Q
    );
  CHECK_CRC_GEN_CRC16_OUT_7_Q : X_SFF
    port map (
      I => CHECK_CRC_GEN_UN5_NX_CRC_0(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_SOC_OUT,
      O => CHECK_CRC_CALC_7_Q
    );
  CHECK_CRC_GEN_CRC16_OUT_8_Q : X_SFF
    port map (
      I => CHECK_CRC_GEN_UN5_NX_CRC_0(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_SOC_OUT,
      O => CHECK_CRC_CALC_8_Q
    );
  CHECK_CRC_GEN_CRC16_OUT_9_Q : X_SFF
    port map (
      I => CHECK_CRC_GEN_UN5_NX_CRC_0(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_SOC_OUT,
      O => CHECK_CRC_CALC_9_Q
    );
  CHECK_CRC_GEN_CRC16_OUT_10_Q : X_SFF
    port map (
      I => CHECK_CRC_GEN_UN5_NX_CRC_0(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_SOC_OUT,
      O => CHECK_CRC_CALC_10_Q
    );
  CHECK_CRC_GEN_CRC16_OUT_11_Q : X_SFF
    port map (
      I => CHECK_CRC_GEN_UN5_NX_CRC_0(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_SOC_OUT,
      O => CHECK_CRC_CALC_11_Q
    );
  CHECK_CRC_GEN_CRC16_OUT_12_Q : X_SFF
    port map (
      I => CHECK_CRC_GEN_UN5_NX_CRC_0(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_SOC_OUT,
      O => CHECK_CRC_CALC_12_Q
    );
  CHECK_CRC_GEN_CRC16_OUT_13_Q : X_SFF
    port map (
      I => CHECK_CRC_GEN_UN5_NX_CRC_0(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_SOC_OUT,
      O => CHECK_CRC_CALC_0(13)
    );
  CHECK_CRC_GEN_CRC16_OUT_14_Q : X_SFF
    port map (
      I => CHECK_CRC_GEN_UN5_NX_CRC_0(14),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_SOC_OUT,
      O => CHECK_CRC_CALC_14_Q
    );
  CHECK_CRC_GEN_CRC16_OUT_15_Q : X_SFF
    port map (
      I => CHECK_CRC_GEN_UN5_NX_CRC_0(15),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CHECK_SOC_OUT,
      O => CHECK_CRC_CALC_15_Q
    );
  CHECK_CRC_GEN_CRC_L_M_0_MUX2_4_Q : X_LUT4
    generic map (
      INIT => X"2EE2"
    )
    port map (
      ADR0 => CHECK_DATA_IN(4),
      ADR1 => CHECK_CRC_GEN_G_134_0,
      ADR2 => CHECK_CRC_GEN_G_139_0,
      ADR3 => CHECK_DATA_IN(0),
      O => CHECK_CRC_GEN_CRC_L_M_4_Q
    );
  CHECK_CRC_GEN_CRC_L_M_0_MUX2_14_Q : X_LUT4
    generic map (
      INIT => X"2EE2"
    )
    port map (
      ADR0 => CHECK_DATA_IN(14),
      ADR1 => CHECK_CRC_GEN_G_134_0,
      ADR2 => CHECK_CRC_GEN_G_143,
      ADR3 => CHECK_DATA_IN(6),
      O => CHECK_CRC_GEN_CRC_L_M_14_Q
    );
  CHECK_CRC_GEN_UN5_NX_CRC_0_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_156,
      ADR1 => CHECK_CRC_CALC_0_Q,
      ADR2 => CHECK_CRC_GEN_G_3345,
      ADR3 => CHECK_CRC_GEN_N_51,
      O => CHECK_CRC_GEN_UN5_NX_CRC_0(0)
    );
  CHECK_CRC_GEN_UN5_NX_CRC_1_Q : X_LUT4
    generic map (
      INIT => X"596A"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_3445,
      ADR1 => CHECK_CRC_GEN_G_134_0,
      ADR2 => CHECK_CRC_GEN_CRC_L_1_Q,
      ADR3 => CHECK_DATA_IN(1),
      O => CHECK_CRC_GEN_UN5_NX_CRC_0(1)
    );
  CHECK_CRC_GEN_UN5_NX_CRC_2_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_158,
      ADR1 => CHECK_CRC_GEN_N_53,
      ADR2 => CHECK_CRC_GEN_G_3500,
      ADR3 => CHECK_DATA_IN(17),
      O => CHECK_CRC_GEN_UN5_NX_CRC_0(2)
    );
  CHECK_CRC_GEN_UN5_NX_CRC_3_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_171_0,
      ADR1 => CHECK_CRC_CALC_3_Q,
      ADR2 => CHECK_CRC_GEN_N_54,
      ADR3 => CHECK_DATA_IN(28),
      O => CHECK_CRC_GEN_UN5_NX_CRC_0(3)
    );
  CHECK_CRC_GEN_UN5_NX_CRC_4_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_CRC_L_M_4_Q,
      ADR1 => CHECK_CRC_CALC_4_Q,
      ADR2 => CHECK_CRC_GEN_N_51,
      ADR3 => CHECK_DATA_IN(16),
      O => CHECK_CRC_GEN_UN5_NX_CRC_0(4)
    );
  CHECK_CRC_GEN_UN5_NX_CRC_5_Q : X_LUT4
    generic map (
      INIT => X"95A6"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_3520,
      ADR1 => CHECK_CRC_GEN_G_134_0,
      ADR2 => CHECK_CRC_GEN_G_151_0,
      ADR3 => CHECK_DATA_IN(5),
      O => CHECK_CRC_GEN_UN5_NX_CRC_0(5)
    );
  CHECK_CRC_GEN_UN5_NX_CRC_6_Q : X_LUT4
    generic map (
      INIT => X"596A"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_3529,
      ADR1 => CHECK_CRC_GEN_G_134_0,
      ADR2 => CHECK_CRC_GEN_CRC_L_6_Q,
      ADR3 => CHECK_DATA_IN(6),
      O => CHECK_CRC_GEN_UN5_NX_CRC_0(6)
    );
  CHECK_CRC_GEN_UN5_NX_CRC_7_Q : X_LUT4
    generic map (
      INIT => X"95A6"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_3505,
      ADR1 => CHECK_CRC_GEN_G_134_0,
      ADR2 => CHECK_CRC_GEN_CRC16_OUT_1_0_AND2_I_7_Q,
      ADR3 => CHECK_DATA_IN(7),
      O => CHECK_CRC_GEN_UN5_NX_CRC_0(7)
    );
  CHECK_CRC_GEN_UN5_NX_CRC_8_Q : X_LUT4
    generic map (
      INIT => X"A66A"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_3518,
      ADR1 => CHECK_CRC_GEN_G_134_0,
      ADR2 => CHECK_CRC_GEN_G_141_0,
      ADR3 => CHECK_CRC_GEN_G_135,
      O => CHECK_CRC_GEN_UN5_NX_CRC_0(8)
    );
  CHECK_CRC_GEN_UN5_NX_CRC_9_Q : X_LUT4
    generic map (
      INIT => X"95A6"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_3515,
      ADR1 => CHECK_CRC_GEN_G_134_0,
      ADR2 => CHECK_CRC_GEN_G_155_0,
      ADR3 => CHECK_DATA_IN(9),
      O => CHECK_CRC_GEN_UN5_NX_CRC_0(9)
    );
  CHECK_CRC_GEN_UN5_NX_CRC_10_Q : X_LUT4
    generic map (
      INIT => X"596A"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_3513,
      ADR1 => CHECK_CRC_GEN_G_134_0,
      ADR2 => CHECK_CRC_GEN_CRC_L_10_Q,
      ADR3 => CHECK_DATA_IN(10),
      O => CHECK_CRC_GEN_UN5_NX_CRC_0(10)
    );
  CHECK_CRC_GEN_UN5_NX_CRC_11_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_162,
      ADR1 => CHECK_CRC_GEN_G_3486,
      ADR2 => CHECK_DATA_IN(17),
      ADR3 => CHECK_DATA_IN(16),
      O => CHECK_CRC_GEN_UN5_NX_CRC_0(11)
    );
  CHECK_CRC_GEN_UN5_NX_CRC_12_Q : X_LUT4
    generic map (
      INIT => X"596A"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_3480,
      ADR1 => CHECK_CRC_GEN_G_134_0,
      ADR2 => CHECK_CRC_GEN_CRC_L_12_Q,
      ADR3 => CHECK_DATA_IN(12),
      O => CHECK_CRC_GEN_UN5_NX_CRC_0(12)
    );
  CHECK_CRC_GEN_UN5_NX_CRC_13_Q : X_LUT4
    generic map (
      INIT => X"596A"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_3469,
      ADR1 => CHECK_CRC_GEN_G_134_0,
      ADR2 => CHECK_CRC_GEN_CRC_L_13_Q,
      ADR3 => CHECK_DATA_IN(13),
      O => CHECK_CRC_GEN_UN5_NX_CRC_0(13)
    );
  CHECK_CRC_GEN_UN5_NX_CRC_14_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_CRC_L_M_14_Q,
      ADR1 => CHECK_CRC_GEN_N_53,
      ADR2 => CHECK_DATA_IN(22),
      ADR3 => CHECK_CRC_CALC_14_Q,
      O => CHECK_CRC_GEN_UN5_NX_CRC_0(14)
    );
  CHECK_CRC_GEN_UN5_NX_CRC_15_Q : X_LUT4
    generic map (
      INIT => X"95A6"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_3498,
      ADR1 => CHECK_CRC_GEN_G_134_0,
      ADR2 => CHECK_CRC_GEN_CRC16_OUT_1_0_AND2_I_15_Q,
      ADR3 => CHECK_DATA_IN(15),
      O => CHECK_CRC_GEN_UN5_NX_CRC_0(15)
    );
  CHECK_CRC_GEN_UN5_NX_CRC_1_G_3445 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_CRC_CALC_1_Q,
      ADR1 => CHECK_CRC_GEN_N_52,
      ADR2 => CHECK_DATA_IN(30),
      ADR3 => CHECK_DATA_IN(19),
      O => CHECK_CRC_GEN_G_3445
    );
  CHECK_CRC_GEN_UN5_NX_CRC_2_G_3500 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_CRC_CALC_2_Q,
      ADR1 => CHECK_DATA_IN(18),
      O => CHECK_CRC_GEN_G_3500
    );
  CHECK_CRC_GEN_UN5_NX_CRC_5_G_3520 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_N_52,
      ADR1 => CHECK_CRC_CALC_5_Q,
      ADR2 => CHECK_CRC_GEN_G_3345,
      ADR3 => CHECK_CRC_GEN_N_51,
      O => CHECK_CRC_GEN_G_3520
    );
  CHECK_CRC_GEN_UN5_NX_CRC_6_G_3528 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_DATA_IN(17),
      ADR1 => CHECK_CRC_CALC_6_Q,
      ADR2 => CHECK_DATA_IN(25),
      ADR3 => CHECK_DATA_IN(21),
      O => CHECK_CRC_GEN_G_3528
    );
  CHECK_CRC_GEN_UN5_NX_CRC_6_G_3529 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_3528,
      ADR1 => CHECK_CRC_GEN_N_52,
      ADR2 => CHECK_DATA_IN(30),
      ADR3 => CHECK_DATA_IN(19),
      O => CHECK_CRC_GEN_G_3529
    );
  CHECK_CRC_GEN_UN5_NX_CRC_7_G_3505 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_N_53,
      ADR1 => CHECK_CRC_GEN_N_54,
      ADR2 => CHECK_DATA_IN(18),
      ADR3 => CHECK_CRC_CALC_7_Q,
      O => CHECK_CRC_GEN_G_3505
    );
  CHECK_CRC_GEN_UN5_NX_CRC_8_G_3516 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_CRC_CALC_8_Q,
      ADR1 => CHECK_DATA_IN(8),
      O => CHECK_CRC_GEN_G_3516
    );
  CHECK_CRC_GEN_UN5_NX_CRC_8_G_3518 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_N_48,
      ADR1 => CHECK_CRC_GEN_G_3516,
      ADR2 => CHECK_CRC_GEN_N_54,
      ADR3 => CHECK_DATA_IN(28),
      O => CHECK_CRC_GEN_G_3518
    );
  CHECK_CRC_GEN_UN5_NX_CRC_9_G_3515 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_N_46,
      ADR1 => CHECK_CRC_CALC_9_Q,
      ADR2 => CHECK_CRC_GEN_N_51,
      ADR3 => CHECK_DATA_IN(16),
      O => CHECK_CRC_GEN_G_3515
    );
  CHECK_CRC_GEN_UN5_NX_CRC_10_G_3513 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_N_52,
      ADR1 => CHECK_DATA_IN(17),
      ADR2 => CHECK_DATA_IN(21),
      ADR3 => CHECK_CRC_CALC_10_Q,
      O => CHECK_CRC_GEN_G_3513
    );
  CHECK_CRC_GEN_UN5_NX_CRC_11_G_3486 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_DATA_IN(20),
      ADR1 => CHECK_CRC_CALC_11_Q,
      ADR2 => CHECK_DATA_IN(25),
      ADR3 => CHECK_DATA_IN(21),
      O => CHECK_CRC_GEN_G_3486
    );
  CHECK_CRC_GEN_UN5_NX_CRC_12_G_3479 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_DATA_IN(23),
      ADR1 => CHECK_CRC_CALC_12_Q,
      ADR2 => CHECK_DATA_IN(27),
      ADR3 => CHECK_DATA_IN(24),
      O => CHECK_CRC_GEN_G_3479
    );
  CHECK_CRC_GEN_UN5_NX_CRC_12_G_3480 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_3479,
      ADR1 => CHECK_DATA_IN(31),
      ADR2 => CHECK_DATA_IN(16),
      O => CHECK_CRC_GEN_G_3480
    );
  CHECK_CRC_GEN_UN5_NX_CRC_13_G_3467 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_DATA_IN(22),
      ADR1 => CHECK_DATA_IN(30),
      O => CHECK_CRC_GEN_G_3467
    );
  CHECK_CRC_GEN_UN5_NX_CRC_13_G_3469 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_3467,
      ADR1 => CHECK_DATA_IN(26),
      ADR2 => CHECK_DATA_IN(23),
      ADR3 => CHECK_CRC_CALC_0(13),
      O => CHECK_CRC_GEN_G_3469
    );
  CHECK_CRC_GEN_UN5_NX_CRC_15_G_3496 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_CRC_CALC_15_Q,
      ADR1 => CHECK_DATA_IN(21),
      O => CHECK_CRC_GEN_G_3496
    );
  CHECK_CRC_GEN_UN5_NX_CRC_15_G_3498 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_DATA_IN(24),
      ADR1 => CHECK_DATA_IN(20),
      ADR2 => CHECK_CRC_GEN_G_3496,
      ADR3 => CHECK_DATA_IN(28),
      O => CHECK_CRC_GEN_G_3498
    );
  CHECK_CRC_GEN_GEN_CRC_H_G_15 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_DATA_IN(22),
      ADR1 => CHECK_DATA_IN(18),
      O => CHECK_CRC_GEN_N_46
    );
  CHECK_CRC_GEN_GEN_CRC_H_G_17 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_DATA_IN(19),
      ADR1 => CHECK_DATA_IN(23),
      O => CHECK_CRC_GEN_N_48
    );
  CHECK_CRC_GEN_GEN_CRC_H_G_20 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CHECK_DATA_IN(27),
      ADR1 => CHECK_DATA_IN(23),
      ADR2 => CHECK_DATA_IN(19),
      O => CHECK_CRC_GEN_N_51
    );
  CHECK_CRC_GEN_GEN_CRC_H_G_21 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CHECK_DATA_IN(26),
      ADR1 => CHECK_DATA_IN(18),
      ADR2 => CHECK_DATA_IN(22),
      O => CHECK_CRC_GEN_N_52
    );
  CHECK_CRC_GEN_GEN_CRC_H_G_22 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CHECK_DATA_IN(29),
      ADR1 => CHECK_DATA_IN(25),
      ADR2 => CHECK_DATA_IN(21),
      O => CHECK_CRC_GEN_N_53
    );
  CHECK_CRC_GEN_GEN_CRC_H_G_23 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_DATA_IN(17),
      ADR1 => CHECK_DATA_IN(16),
      ADR2 => CHECK_DATA_IN(24),
      ADR3 => CHECK_DATA_IN(20),
      O => CHECK_CRC_GEN_N_54
    );
  CHECK_CRC_GEN_GEN_CRC_H_G_28_G_3345 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_DATA_IN(20),
      ADR1 => CHECK_DATA_IN(31),
      O => CHECK_CRC_GEN_G_3345
    );
  CHECK_CRC_GEN_GEN_CRC_L_G_28_G_3356 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_DATA_IN(15),
      ADR1 => CHECK_DATA_IN(4),
      O => CHECK_CRC_GEN_G_3356
    );
  CHECK_CRC_GEN_GEN_CRC_L_G_29 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_137,
      ADR1 => CHECK_DATA_IN(10),
      ADR2 => CHECK_DATA_IN(14),
      ADR3 => CHECK_DATA_IN(3),
      O => CHECK_CRC_GEN_CRC_L_1_Q
    );
  CHECK_CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_6_Q : X_LUT3
    generic map (
      INIT => X"69"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_CRC_L_1_Q,
      ADR1 => CHECK_CRC_GEN_G_140_0,
      ADR2 => CHECK_DATA_IN(1),
      O => CHECK_CRC_GEN_CRC_L_6_Q
    );
  CHECK_CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_7_Q : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_143,
      ADR1 => CHECK_CRC_GEN_G_3273,
      ADR2 => CHECK_DATA_IN(8),
      ADR3 => CHECK_DATA_IN(2),
      O => CHECK_CRC_GEN_CRC16_OUT_1_0_AND2_I_7_Q
    );
  CHECK_CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_10_Q : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_G_137,
      ADR1 => CHECK_DATA_IN(10),
      ADR2 => CHECK_DATA_IN(1),
      ADR3 => CHECK_DATA_IN(5),
      O => CHECK_CRC_GEN_CRC_L_10_Q
    );
  CHECK_CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_12_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_CRC_GEN_GEN_CRC_L_G_3262,
      ADR1 => CHECK_DATA_IN(8),
      ADR2 => CHECK_DATA_IN(11),
      ADR3 => CHECK_DATA_IN(15),
      O => CHECK_CRC_GEN_CRC_L_12_Q
    );
  CHECK_CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_13_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CHECK_DATA_IN(10),
      ADR1 => CHECK_DATA_IN(14),
      ADR2 => CHECK_DATA_IN(7),
      ADR3 => CHECK_DATA_IN(6),
      O => CHECK_CRC_GEN_CRC_L_13_Q
    );
  CHECK_CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_15_Q : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => CHECK_DATA_IN(5),
      ADR1 => CHECK_DATA_IN(12),
      ADR2 => CHECK_DATA_IN(4),
      ADR3 => CHECK_DATA_IN(8),
      O => CHECK_CRC_GEN_CRC16_OUT_1_0_AND2_I_15_Q
    );
  CHECK_CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_11_G_3273 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CHECK_DATA_IN(4),
      ADR1 => CHECK_DATA_IN(1),
      ADR2 => CHECK_DATA_IN(0),
      O => CHECK_CRC_GEN_G_3273
    );
  CHECK_CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_12_G_3262 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CHECK_DATA_IN(0),
      ADR1 => CHECK_DATA_IN(7),
      O => CHECK_CRC_GEN_GEN_CRC_L_G_3262
    );
  CMUX_D_OUT_MOD_1_0_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(0),
      ADR1 => CMUX_DOUT_CTRL(0),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_66
    );
  CMUX_D_OUT_MOD_1_1_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(1),
      ADR1 => CMUX_DOUT_CTRL(1),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_67
    );
  CMUX_D_OUT_MOD_1_2_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(2),
      ADR1 => CMUX_DOUT_CTRL(2),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_68
    );
  CMUX_D_OUT_MOD_1_3_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(3),
      ADR1 => CMUX_DOUT_CTRL(3),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_69
    );
  CMUX_D_OUT_MOD_1_4_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(4),
      ADR1 => CMUX_DOUT_CTRL(4),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_70
    );
  CMUX_D_OUT_MOD_1_5_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(5),
      ADR1 => CMUX_DOUT_CTRL(5),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_71
    );
  CMUX_D_OUT_MOD_1_6_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(6),
      ADR1 => CMUX_DOUT_CTRL(6),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_72
    );
  CMUX_D_OUT_MOD_1_7_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(7),
      ADR1 => CMUX_DOUT_CTRL(7),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_73
    );
  CMUX_D_OUT_MOD_1_8_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(8),
      ADR1 => CMUX_DOUT_CTRL(8),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_74
    );
  CMUX_D_OUT_MOD_1_9_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(9),
      ADR1 => CMUX_DOUT_CTRL(9),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_75
    );
  CMUX_D_OUT_MOD_1_10_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(10),
      ADR1 => CMUX_DOUT_CTRL(10),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_76
    );
  CMUX_D_OUT_MOD_1_11_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(11),
      ADR1 => CMUX_DOUT_CTRL(11),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_77
    );
  CMUX_D_OUT_MOD_1_12_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(12),
      ADR1 => CMUX_DOUT_CTRL(12),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_78
    );
  CMUX_D_OUT_MOD_1_13_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(13),
      ADR1 => CMUX_DOUT_CTRL(13),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_79
    );
  CMUX_D_OUT_MOD_1_14_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(14),
      ADR1 => CMUX_DOUT_CTRL(14),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_80
    );
  CMUX_D_OUT_MOD_1_15_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(15),
      ADR1 => CMUX_DOUT_CTRL(15),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_81
    );
  CMUX_D_OUT_MOD_1_16_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(16),
      ADR1 => CMUX_DOUT_CTRL(16),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_82
    );
  CMUX_D_OUT_MOD_1_17_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(17),
      ADR1 => CMUX_DOUT_CTRL(17),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_83
    );
  CMUX_D_OUT_MOD_1_18_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(18),
      ADR1 => CMUX_DOUT_CTRL(18),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_84
    );
  CMUX_D_OUT_MOD_1_19_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(19),
      ADR1 => CMUX_DOUT_CTRL(19),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_85
    );
  CMUX_D_OUT_MOD_1_20_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(20),
      ADR1 => CMUX_DOUT_CTRL(20),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_86
    );
  CMUX_D_OUT_MOD_1_21_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(21),
      ADR1 => CMUX_DOUT_CTRL(21),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_87
    );
  CMUX_D_OUT_MOD_1_22_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(22),
      ADR1 => CMUX_DOUT_CTRL(22),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_88
    );
  CMUX_D_OUT_MOD_1_23_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(23),
      ADR1 => CMUX_DOUT_CTRL(23),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_89
    );
  CMUX_D_OUT_MOD_1_24_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(24),
      ADR1 => CMUX_DOUT_CTRL(24),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_90
    );
  CMUX_D_OUT_MOD_1_25_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(25),
      ADR1 => CMUX_DOUT_CTRL(25),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_91
    );
  CMUX_D_OUT_MOD_1_26_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(26),
      ADR1 => CMUX_DOUT_CTRL(26),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_92
    );
  CMUX_D_OUT_MOD_1_27_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(27),
      ADR1 => CMUX_DOUT_CTRL(27),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_93
    );
  CMUX_D_OUT_MOD_1_28_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(28),
      ADR1 => CMUX_DOUT_CTRL(28),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_94
    );
  CMUX_D_OUT_MOD_1_29_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(29),
      ADR1 => CMUX_DOUT_CTRL(29),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_95
    );
  CMUX_D_OUT_MOD_1_30_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(30),
      ADR1 => CMUX_DOUT_CTRL(30),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_96
    );
  CMUX_D_OUT_MOD_1_31_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_APPL(31),
      ADR1 => CMUX_DOUT_CTRL(31),
      ADR2 => CMUX_STATE(1),
      O => CMUX_N_97
    );
  CMUX_D_OUT_MOD_2_0_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(0),
      ADR1 => CMUX_N_66,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(0)
    );
  CMUX_D_OUT_MOD_2_1_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(1),
      ADR1 => CMUX_N_67,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(1)
    );
  CMUX_D_OUT_MOD_2_2_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(2),
      ADR1 => CMUX_N_68,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(2)
    );
  CMUX_D_OUT_MOD_2_3_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(3),
      ADR1 => CMUX_N_69,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(3)
    );
  CMUX_D_OUT_MOD_2_4_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(4),
      ADR1 => CMUX_N_70,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(4)
    );
  CMUX_D_OUT_MOD_2_5_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(5),
      ADR1 => CMUX_N_71,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(5)
    );
  CMUX_D_OUT_MOD_2_6_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(6),
      ADR1 => CMUX_N_72,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(6)
    );
  CMUX_D_OUT_MOD_2_7_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(7),
      ADR1 => CMUX_N_73,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(7)
    );
  CMUX_D_OUT_MOD_2_8_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(8),
      ADR1 => CMUX_N_74,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(8)
    );
  CMUX_D_OUT_MOD_2_9_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(9),
      ADR1 => CMUX_N_75,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(9)
    );
  CMUX_D_OUT_MOD_2_10_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(10),
      ADR1 => CMUX_N_76,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(10)
    );
  CMUX_D_OUT_MOD_2_11_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(11),
      ADR1 => CMUX_N_77,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(11)
    );
  CMUX_D_OUT_MOD_2_12_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(12),
      ADR1 => CMUX_N_78,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(12)
    );
  CMUX_D_OUT_MOD_2_13_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(13),
      ADR1 => CMUX_N_79,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(13)
    );
  CMUX_D_OUT_MOD_2_14_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(14),
      ADR1 => CMUX_N_80,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(14)
    );
  CMUX_D_OUT_MOD_2_15_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(15),
      ADR1 => CMUX_N_81,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(15)
    );
  CMUX_D_OUT_MOD_2_16_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(16),
      ADR1 => CMUX_N_82,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(16)
    );
  CMUX_D_OUT_MOD_2_17_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(17),
      ADR1 => CMUX_N_83,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(17)
    );
  CMUX_D_OUT_MOD_2_18_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(18),
      ADR1 => CMUX_N_84,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(18)
    );
  CMUX_D_OUT_MOD_2_19_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(19),
      ADR1 => CMUX_N_85,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(19)
    );
  CMUX_D_OUT_MOD_2_20_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(20),
      ADR1 => CMUX_N_86,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(20)
    );
  CMUX_D_OUT_MOD_2_21_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(21),
      ADR1 => CMUX_N_87,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(21)
    );
  CMUX_D_OUT_MOD_2_22_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(22),
      ADR1 => CMUX_N_88,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(22)
    );
  CMUX_D_OUT_MOD_2_23_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(23),
      ADR1 => CMUX_N_89,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(23)
    );
  CMUX_D_OUT_MOD_2_24_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(24),
      ADR1 => CMUX_N_90,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(24)
    );
  CMUX_D_OUT_MOD_2_25_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(25),
      ADR1 => CMUX_N_91,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(25)
    );
  CMUX_D_OUT_MOD_2_26_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(26),
      ADR1 => CMUX_N_92,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(26)
    );
  CMUX_D_OUT_MOD_2_27_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(27),
      ADR1 => CMUX_N_93,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(27)
    );
  CMUX_D_OUT_MOD_2_28_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(28),
      ADR1 => CMUX_N_94,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(28)
    );
  CMUX_D_OUT_MOD_2_29_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(29),
      ADR1 => CMUX_N_95,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(29)
    );
  CMUX_D_OUT_MOD_2_30_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(30),
      ADR1 => CMUX_N_96,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(30)
    );
  CMUX_D_OUT_MOD_2_31_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_DOUT_BYPASS(31),
      ADR1 => CMUX_N_97,
      ADR2 => CMUX_STATE(0),
      O => DATA_M(31)
    );
  CMUX_G_4 : X_LUT4
    generic map (
      INIT => X"8000"
    )
    port map (
      ADR0 => RESET_L,
      ADR1 => CMUX_OUTPUT_UN5_STATE,
      ADR2 => CMUX_UN1_UN1_EMPTY_APPL,
      ADR3 => TCA_OUT_MOD,
      O => CMUX_SOC_OUT
    );
  CMUX_SOC_OUT_MOD : X_SFF
    port map (
      I => CMUX_UN1_UN1_UN5_STATE_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => SOC_M
    );
  CMUX_COUNTER_0_Q : X_SFF
    port map (
      I => CMUX_COUNTER_I(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CMUX_SOC_OUT,
      O => CMUX_COUNTER(0)
    );
  CMUX_COUNTER_1_Q : X_SFF
    port map (
      I => CMUX_N_131,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CMUX_SOC_OUT,
      O => CMUX_COUNTER(1)
    );
  CMUX_COUNTER_2_Q : X_SFF
    port map (
      I => CMUX_N_132,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CMUX_SOC_OUT,
      O => CMUX_COUNTER(2)
    );
  CMUX_COUNTER_3_Q : X_SFF
    port map (
      I => CMUX_N_133,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CMUX_SOC_OUT,
      O => CMUX_N_133_1
    );
  CMUX_COUNTER_I_0_Q : X_INV
    port map (
      I => CMUX_COUNTER(0),
      O => CMUX_COUNTER_I(0)
    );
  CMUX_DATA_APPL_IN_0_Q : X_FF
    port map (
      I => D_APPL_IN(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(0)
    );
  CMUX_DATA_APPL_IN_1_Q : X_FF
    port map (
      I => D_APPL_IN(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(1)
    );
  CMUX_DATA_APPL_IN_2_Q : X_FF
    port map (
      I => D_APPL_IN(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(2)
    );
  CMUX_DATA_APPL_IN_3_Q : X_FF
    port map (
      I => D_APPL_IN(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(3)
    );
  CMUX_DATA_APPL_IN_4_Q : X_FF
    port map (
      I => D_APPL_IN(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(4)
    );
  CMUX_DATA_APPL_IN_5_Q : X_FF
    port map (
      I => D_APPL_IN(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(5)
    );
  CMUX_DATA_APPL_IN_6_Q : X_FF
    port map (
      I => D_APPL_IN(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(6)
    );
  CMUX_DATA_APPL_IN_7_Q : X_FF
    port map (
      I => D_APPL_IN(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(7)
    );
  CMUX_DATA_APPL_IN_8_Q : X_FF
    port map (
      I => D_APPL_IN(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(8)
    );
  CMUX_DATA_APPL_IN_9_Q : X_FF
    port map (
      I => D_APPL_IN(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(9)
    );
  CMUX_DATA_APPL_IN_10_Q : X_FF
    port map (
      I => D_APPL_IN(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(10)
    );
  CMUX_DATA_APPL_IN_11_Q : X_FF
    port map (
      I => D_APPL_IN(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(11)
    );
  CMUX_DATA_APPL_IN_12_Q : X_FF
    port map (
      I => D_APPL_IN(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(12)
    );
  CMUX_DATA_APPL_IN_13_Q : X_FF
    port map (
      I => D_APPL_IN(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(13)
    );
  CMUX_DATA_APPL_IN_14_Q : X_FF
    port map (
      I => D_APPL_IN(14),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(14)
    );
  CMUX_DATA_APPL_IN_15_Q : X_FF
    port map (
      I => D_APPL_IN(15),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(15)
    );
  CMUX_DATA_APPL_IN_16_Q : X_FF
    port map (
      I => D_APPL_IN(16),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(16)
    );
  CMUX_DATA_APPL_IN_17_Q : X_FF
    port map (
      I => D_APPL_IN(17),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(17)
    );
  CMUX_DATA_APPL_IN_18_Q : X_FF
    port map (
      I => D_APPL_IN(18),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(18)
    );
  CMUX_DATA_APPL_IN_19_Q : X_FF
    port map (
      I => D_APPL_IN(19),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(19)
    );
  CMUX_DATA_APPL_IN_20_Q : X_FF
    port map (
      I => D_APPL_IN(20),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(20)
    );
  CMUX_DATA_APPL_IN_21_Q : X_FF
    port map (
      I => D_APPL_IN(21),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(21)
    );
  CMUX_DATA_APPL_IN_22_Q : X_FF
    port map (
      I => D_APPL_IN(22),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(22)
    );
  CMUX_DATA_APPL_IN_23_Q : X_FF
    port map (
      I => D_APPL_IN(23),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(23)
    );
  CMUX_DATA_APPL_IN_24_Q : X_FF
    port map (
      I => D_APPL_IN(24),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(24)
    );
  CMUX_DATA_APPL_IN_25_Q : X_FF
    port map (
      I => D_APPL_IN(25),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(25)
    );
  CMUX_DATA_APPL_IN_26_Q : X_FF
    port map (
      I => D_APPL_IN(26),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(26)
    );
  CMUX_DATA_APPL_IN_27_Q : X_FF
    port map (
      I => D_APPL_IN(27),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(27)
    );
  CMUX_DATA_APPL_IN_28_Q : X_FF
    port map (
      I => D_APPL_IN(28),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(28)
    );
  CMUX_DATA_APPL_IN_29_Q : X_FF
    port map (
      I => D_APPL_IN(29),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(29)
    );
  CMUX_DATA_APPL_IN_30_Q : X_FF
    port map (
      I => D_APPL_IN(30),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(30)
    );
  CMUX_DATA_APPL_IN_31_Q : X_FF
    port map (
      I => D_APPL_IN(31),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_APPL_IN(31)
    );
  CMUX_DATA_BP_IN_0_Q : X_FF
    port map (
      I => NGD2VHDL_OI74,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(0)
    );
  CMUX_DATA_BP_IN_1_Q : X_FF
    port map (
      I => NGD2VHDL_OI73,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(1)
    );
  CMUX_DATA_BP_IN_2_Q : X_FF
    port map (
      I => NGD2VHDL_OI72,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(2)
    );
  CMUX_DATA_BP_IN_3_Q : X_FF
    port map (
      I => NGD2VHDL_OI71,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(3)
    );
  CMUX_DATA_BP_IN_4_Q : X_FF
    port map (
      I => NGD2VHDL_OI70,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(4)
    );
  CMUX_DATA_BP_IN_5_Q : X_FF
    port map (
      I => NGD2VHDL_OI69,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(5)
    );
  CMUX_DATA_BP_IN_6_Q : X_FF
    port map (
      I => NGD2VHDL_OI68,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(6)
    );
  CMUX_DATA_BP_IN_7_Q : X_FF
    port map (
      I => NGD2VHDL_OI67,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(7)
    );
  CMUX_DATA_BP_IN_8_Q : X_FF
    port map (
      I => NGD2VHDL_OI66,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(8)
    );
  CMUX_DATA_BP_IN_9_Q : X_FF
    port map (
      I => NGD2VHDL_OI65,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(9)
    );
  CMUX_DATA_BP_IN_10_Q : X_FF
    port map (
      I => NGD2VHDL_OI64,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(10)
    );
  CMUX_DATA_BP_IN_11_Q : X_FF
    port map (
      I => NGD2VHDL_OI63,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(11)
    );
  CMUX_DATA_BP_IN_12_Q : X_FF
    port map (
      I => NGD2VHDL_OI62,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(12)
    );
  CMUX_DATA_BP_IN_13_Q : X_FF
    port map (
      I => NGD2VHDL_OI61,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(13)
    );
  CMUX_DATA_BP_IN_14_Q : X_FF
    port map (
      I => NGD2VHDL_OI60,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(14)
    );
  CMUX_DATA_BP_IN_15_Q : X_FF
    port map (
      I => NGD2VHDL_OI59,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(15)
    );
  CMUX_DATA_BP_IN_16_Q : X_FF
    port map (
      I => NGD2VHDL_OI58,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(16)
    );
  CMUX_DATA_BP_IN_17_Q : X_FF
    port map (
      I => NGD2VHDL_OI57,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(17)
    );
  CMUX_DATA_BP_IN_18_Q : X_FF
    port map (
      I => NGD2VHDL_OI56,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(18)
    );
  CMUX_DATA_BP_IN_19_Q : X_FF
    port map (
      I => NGD2VHDL_OI55,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(19)
    );
  CMUX_DATA_BP_IN_20_Q : X_FF
    port map (
      I => NGD2VHDL_OI54,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(20)
    );
  CMUX_DATA_BP_IN_21_Q : X_FF
    port map (
      I => NGD2VHDL_OI53,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(21)
    );
  CMUX_DATA_BP_IN_22_Q : X_FF
    port map (
      I => NGD2VHDL_OI52,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(22)
    );
  CMUX_DATA_BP_IN_23_Q : X_FF
    port map (
      I => NGD2VHDL_OI51,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(23)
    );
  CMUX_DATA_BP_IN_24_Q : X_FF
    port map (
      I => NGD2VHDL_OI50,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(24)
    );
  CMUX_DATA_BP_IN_25_Q : X_FF
    port map (
      I => NGD2VHDL_OI49,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(25)
    );
  CMUX_DATA_BP_IN_26_Q : X_FF
    port map (
      I => NGD2VHDL_OI48,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(26)
    );
  CMUX_DATA_BP_IN_27_Q : X_FF
    port map (
      I => NGD2VHDL_OI47,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(27)
    );
  CMUX_DATA_BP_IN_28_Q : X_FF
    port map (
      I => NGD2VHDL_OI46,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(28)
    );
  CMUX_DATA_BP_IN_29_Q : X_FF
    port map (
      I => NGD2VHDL_OI45,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(29)
    );
  CMUX_DATA_BP_IN_30_Q : X_FF
    port map (
      I => NGD2VHDL_OI44,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(30)
    );
  CMUX_DATA_BP_IN_31_Q : X_FF
    port map (
      I => NGD2VHDL_OI43,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_BP_IN(31)
    );
  CMUX_DATA_CTRL_IN_0_Q : X_FF
    port map (
      I => DATA_CC_1(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(0)
    );
  CMUX_DATA_CTRL_IN_1_Q : X_FF
    port map (
      I => DATA_CC_1(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(1)
    );
  CMUX_DATA_CTRL_IN_2_Q : X_FF
    port map (
      I => DATA_CC_1(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(2)
    );
  CMUX_DATA_CTRL_IN_3_Q : X_FF
    port map (
      I => DATA_CC_1(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(3)
    );
  CMUX_DATA_CTRL_IN_4_Q : X_FF
    port map (
      I => DATA_CC_1(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(4)
    );
  CMUX_DATA_CTRL_IN_5_Q : X_FF
    port map (
      I => DATA_CC_1(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(5)
    );
  CMUX_DATA_CTRL_IN_6_Q : X_FF
    port map (
      I => DATA_CC_1(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(6)
    );
  CMUX_DATA_CTRL_IN_7_Q : X_FF
    port map (
      I => DATA_CC_1(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(7)
    );
  CMUX_DATA_CTRL_IN_8_Q : X_FF
    port map (
      I => DATA_CC_1(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(8)
    );
  CMUX_DATA_CTRL_IN_9_Q : X_FF
    port map (
      I => DATA_CC_1(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(9)
    );
  CMUX_DATA_CTRL_IN_10_Q : X_FF
    port map (
      I => DATA_CC_1(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(10)
    );
  CMUX_DATA_CTRL_IN_11_Q : X_FF
    port map (
      I => DATA_CC_1(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(11)
    );
  CMUX_DATA_CTRL_IN_12_Q : X_FF
    port map (
      I => DATA_CC_1(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(12)
    );
  CMUX_DATA_CTRL_IN_13_Q : X_FF
    port map (
      I => DATA_CC_1(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(13)
    );
  CMUX_DATA_CTRL_IN_14_Q : X_FF
    port map (
      I => DATA_CC_1(14),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(14)
    );
  CMUX_DATA_CTRL_IN_15_Q : X_FF
    port map (
      I => DATA_CC_1(15),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(15)
    );
  CMUX_DATA_CTRL_IN_16_Q : X_FF
    port map (
      I => DATA_CC_DELAY(16),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(16)
    );
  CMUX_DATA_CTRL_IN_17_Q : X_FF
    port map (
      I => DATA_CC_DELAY(17),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(17)
    );
  CMUX_DATA_CTRL_IN_18_Q : X_FF
    port map (
      I => DATA_CC_DELAY(18),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(18)
    );
  CMUX_DATA_CTRL_IN_19_Q : X_FF
    port map (
      I => DATA_CC_DELAY(19),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(19)
    );
  CMUX_DATA_CTRL_IN_20_Q : X_FF
    port map (
      I => DATA_CC_DELAY(20),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(20)
    );
  CMUX_DATA_CTRL_IN_21_Q : X_FF
    port map (
      I => DATA_CC_DELAY(21),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(21)
    );
  CMUX_DATA_CTRL_IN_22_Q : X_FF
    port map (
      I => DATA_CC_DELAY(22),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(22)
    );
  CMUX_DATA_CTRL_IN_23_Q : X_FF
    port map (
      I => DATA_CC_DELAY(23),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(23)
    );
  CMUX_DATA_CTRL_IN_24_Q : X_FF
    port map (
      I => DATA_CC_DELAY(24),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(24)
    );
  CMUX_DATA_CTRL_IN_25_Q : X_FF
    port map (
      I => DATA_CC_DELAY(25),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(25)
    );
  CMUX_DATA_CTRL_IN_26_Q : X_FF
    port map (
      I => DATA_CC_DELAY(26),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(26)
    );
  CMUX_DATA_CTRL_IN_27_Q : X_FF
    port map (
      I => DATA_CC_DELAY(27),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(27)
    );
  CMUX_DATA_CTRL_IN_28_Q : X_FF
    port map (
      I => DATA_CC_DELAY(28),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(28)
    );
  CMUX_DATA_CTRL_IN_29_Q : X_FF
    port map (
      I => DATA_CC_DELAY(29),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(29)
    );
  CMUX_DATA_CTRL_IN_30_Q : X_FF
    port map (
      I => DATA_CC_DELAY(30),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(30)
    );
  CMUX_DATA_CTRL_IN_31_Q : X_FF
    port map (
      I => DATA_CC_DELAY(31),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_DATA_CTRL_IN(31)
    );
  CMUX_FIFO_RES_236 : X_FF
    port map (
      I => RESET_L_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_FIFO_RES
    );
  CMUX_FULL_APPL_I : X_INV
    port map (
      I => CMUX_FULL_APPL,
      O => TCA_APPL_IN
    );
  CMUX_NX_STATE_M3_0_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_STATE(1),
      ADR1 => CMUX_N_57_1,
      ADR2 => CMUX_OUTPUT_UN5_STATE,
      O => CMUX_NX_STATE_M3(0)
    );
  CMUX_NX_STATE_M3_1_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => CMUX_STATE(0),
      ADR1 => CMUX_NX_STATE_SS0,
      ADR2 => CMUX_OUTPUT_UN5_STATE,
      O => CMUX_NX_STATE_M3(1)
    );
  CMUX_NX_STATE_SS0_237 : X_LUT4
    generic map (
      INIT => X"7050"
    )
    port map (
      ADR0 => CMUX_EMPTY_CTRL,
      ADR1 => CMUX_EMPTY_APPL,
      ADR2 => TCA_OUT_MOD,
      ADR3 => CMUX_EMPTY_BYPASS,
      O => CMUX_NX_STATE_SS0
    );
  CMUX_OUTPUT_UN4_STATE_238 : X_LUT4
    generic map (
      INIT => X"0080"
    )
    port map (
      ADR0 => CMUX_N_133_1,
      ADR1 => CMUX_COUNTER(2),
      ADR2 => CMUX_COUNTER(0),
      ADR3 => CMUX_COUNTER(1),
      O => CMUX_OUTPUT_UN4_STATE
    );
  CMUX_OUTPUT_UN5_STATE_239 : X_LUT3
    generic map (
      INIT => X"AB"
    )
    port map (
      ADR0 => CMUX_OUTPUT_UN4_STATE,
      ADR1 => CMUX_STATE(1),
      ADR2 => CMUX_STATE(0),
      O => CMUX_OUTPUT_UN5_STATE
    );
  CMUX_OUTPUT_UN20_TMP_STATE_240 : X_LUT3
    generic map (
      INIT => X"40"
    )
    port map (
      ADR0 => CMUX_NX_STATE_M3(0),
      ADR1 => CMUX_NX_STATE_M3(1),
      ADR2 => RESET_L,
      O => CMUX_OUTPUT_UN20_TMP_STATE
    );
  CMUX_OUTPUT_UN22_TMP_STATE_241 : X_LUT3
    generic map (
      INIT => X"40"
    )
    port map (
      ADR0 => CMUX_NX_STATE_M3(1),
      ADR1 => RESET_L,
      ADR2 => CMUX_NX_STATE_M3(0),
      O => CMUX_OUTPUT_UN22_TMP_STATE
    );
  CMUX_OUTPUT_UN24_TMP_STATE_242 : X_LUT3
    generic map (
      INIT => X"80"
    )
    port map (
      ADR0 => CMUX_NX_STATE_M3(0),
      ADR1 => CMUX_NX_STATE_M3(1),
      ADR2 => RESET_L,
      O => CMUX_OUTPUT_UN24_TMP_STATE
    );
  CMUX_SOC_APPL_IN_243 : X_FF
    port map (
      I => SOC_APPL_IN,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_SOC_APPL_IN
    );
  CMUX_SOC_BP_IN_244 : X_SFF
    port map (
      I => G_3667,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => DISPATCH_UN9_SOC,
      O => CMUX_SOC_BP_IN
    );
  CMUX_SOC_CTRL_IN_245 : X_FF
    port map (
      I => SOC_CC,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CMUX_SOC_CTRL_IN
    );
  CMUX_UN1_UN1_EMPTY_APPL_246 : X_LUT3
    generic map (
      INIT => X"7F"
    )
    port map (
      ADR0 => CMUX_EMPTY_CTRL,
      ADR1 => CMUX_EMPTY_BYPASS,
      ADR2 => CMUX_EMPTY_APPL,
      O => CMUX_UN1_UN1_EMPTY_APPL
    );
  CMUX_UN1_UN1_UN5_STATE_I_247 : X_LUT3
    generic map (
      INIT => X"80"
    )
    port map (
      ADR0 => CMUX_OUTPUT_UN5_STATE,
      ADR1 => CMUX_UN1_UN1_EMPTY_APPL,
      ADR2 => TCA_OUT_MOD,
      O => CMUX_UN1_UN1_UN5_STATE_I
    );
  CMUX_UN6_TMP_COUNT_AXBXC1 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CMUX_COUNTER(1),
      ADR1 => CMUX_COUNTER(0),
      O => CMUX_N_131
    );
  CMUX_UN6_TMP_COUNT_AXBXC2 : X_LUT3
    generic map (
      INIT => X"6A"
    )
    port map (
      ADR0 => CMUX_COUNTER(2),
      ADR1 => CMUX_COUNTER(1),
      ADR2 => CMUX_COUNTER(0),
      O => CMUX_N_132
    );
  CMUX_UN6_TMP_COUNT_AXBXC3 : X_LUT4
    generic map (
      INIT => X"6AAA"
    )
    port map (
      ADR0 => CMUX_N_133_1,
      ADR1 => CMUX_COUNTER(2),
      ADR2 => CMUX_COUNTER(1),
      ADR3 => CMUX_COUNTER(0),
      O => CMUX_N_133
    );
  CMUX_APPL_IN_I_11_0 : X_LUT4
    generic map (
      INIT => X"AEAA"
    )
    port map (
      ADR0 => CMUX_SOC_APPL_IN,
      ADR1 => CMUX_APPL_IN_G_3212,
      ADR2 => CMUX_APPL_IN_COUNTER(1),
      ADR3 => CMUX_APPL_IN_STATE(0),
      O => CMUX_APPL_IN_N_13
    );
  CMUX_APPL_IN_I_11_0_AND3_G_3212 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => CMUX_APPL_IN_COUNTER(2),
      ADR1 => CMUX_APPL_IN_N_20_1,
      O => CMUX_APPL_IN_G_3212
    );
  CMUX_APPL_IN_N_31_I : X_LUT3
    generic map (
      INIT => X"A8"
    )
    port map (
      ADR0 => RESET_L,
      ADR1 => CMUX_APPL_IN_STATE(0),
      ADR2 => CMUX_SOC_APPL_IN,
      O => CMUX_N_31_I_1
    );
  CMUX_APPL_IN_N_37_I_248 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CMUX_APPL_IN_COUNTER(1),
      ADR1 => CMUX_APPL_IN_COUNTER(0),
      O => CMUX_APPL_IN_N_37_I
    );
  CMUX_APPL_IN_N_38_I_249 : X_LUT3
    generic map (
      INIT => X"6A"
    )
    port map (
      ADR0 => CMUX_APPL_IN_COUNTER(2),
      ADR1 => CMUX_APPL_IN_COUNTER(1),
      ADR2 => CMUX_APPL_IN_COUNTER(0),
      O => CMUX_APPL_IN_N_38_I
    );
  CMUX_APPL_IN_N_39_I_250 : X_LUT4
    generic map (
      INIT => X"6AAA"
    )
    port map (
      ADR0 => CMUX_APPL_IN_N_20_1,
      ADR1 => CMUX_APPL_IN_COUNTER(2),
      ADR2 => CMUX_APPL_IN_COUNTER(1),
      ADR3 => CMUX_APPL_IN_COUNTER(0),
      O => CMUX_APPL_IN_N_39_I
    );
  CMUX_APPL_IN_COUNTER_0_Q : X_SFF
    port map (
      I => CMUX_APPL_IN_COUNTER_I(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CMUX_SOC_APPL_IN,
      O => CMUX_APPL_IN_COUNTER(0)
    );
  CMUX_APPL_IN_COUNTER_1_Q : X_SFF
    port map (
      I => CMUX_APPL_IN_N_37_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CMUX_SOC_APPL_IN,
      O => CMUX_APPL_IN_COUNTER(1)
    );
  CMUX_APPL_IN_COUNTER_2_Q : X_SFF
    port map (
      I => CMUX_APPL_IN_N_38_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CMUX_SOC_APPL_IN,
      O => CMUX_APPL_IN_COUNTER(2)
    );
  CMUX_APPL_IN_COUNTER_3_Q : X_SFF
    port map (
      I => CMUX_APPL_IN_N_39_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CMUX_SOC_APPL_IN,
      O => CMUX_APPL_IN_N_20_1
    );
  CMUX_APPL_IN_COUNTER_I_0_Q : X_INV
    port map (
      I => CMUX_APPL_IN_COUNTER(0),
      O => CMUX_APPL_IN_COUNTER_I(0)
    );
  CMUX_APPL_IN_STATE_0_Q : X_SFF
    port map (
      I => CMUX_SOC_APPL_IN,
      CLK => CLK,
      CE => CMUX_APPL_IN_N_13,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CMUX_APPL_IN_STATE(0)
    );
  CMUX_BYPASS_IN_I_11_0 : X_LUT4
    generic map (
      INIT => X"AEAA"
    )
    port map (
      ADR0 => CMUX_SOC_BP_IN,
      ADR1 => CMUX_BYPASS_IN_G_3209,
      ADR2 => CMUX_BYPASS_IN_COUNTER(1),
      ADR3 => CMUX_BYPASS_IN_STATE(0),
      O => CMUX_BYPASS_IN_N_13
    );
  CMUX_BYPASS_IN_I_11_0_AND3_G_3209 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => CMUX_BYPASS_IN_COUNTER(2),
      ADR1 => CMUX_BYPASS_IN_N_20_1,
      O => CMUX_BYPASS_IN_G_3209
    );
  CMUX_BYPASS_IN_N_31_I : X_LUT3
    generic map (
      INIT => X"A8"
    )
    port map (
      ADR0 => RESET_L,
      ADR1 => CMUX_BYPASS_IN_STATE(0),
      ADR2 => CMUX_SOC_BP_IN,
      O => CMUX_N_31_I_0
    );
  CMUX_BYPASS_IN_N_37_I_251 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CMUX_BYPASS_IN_COUNTER(1),
      ADR1 => CMUX_BYPASS_IN_COUNTER(0),
      O => CMUX_BYPASS_IN_N_37_I
    );
  CMUX_BYPASS_IN_N_38_I_252 : X_LUT3
    generic map (
      INIT => X"6A"
    )
    port map (
      ADR0 => CMUX_BYPASS_IN_COUNTER(2),
      ADR1 => CMUX_BYPASS_IN_COUNTER(1),
      ADR2 => CMUX_BYPASS_IN_COUNTER(0),
      O => CMUX_BYPASS_IN_N_38_I
    );
  CMUX_BYPASS_IN_N_39_I_253 : X_LUT4
    generic map (
      INIT => X"6AAA"
    )
    port map (
      ADR0 => CMUX_BYPASS_IN_N_20_1,
      ADR1 => CMUX_BYPASS_IN_COUNTER(2),
      ADR2 => CMUX_BYPASS_IN_COUNTER(1),
      ADR3 => CMUX_BYPASS_IN_COUNTER(0),
      O => CMUX_BYPASS_IN_N_39_I
    );
  CMUX_BYPASS_IN_COUNTER_0_Q : X_SFF
    port map (
      I => CMUX_BYPASS_IN_COUNTER_I(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CMUX_SOC_BP_IN,
      O => CMUX_BYPASS_IN_COUNTER(0)
    );
  CMUX_BYPASS_IN_COUNTER_1_Q : X_SFF
    port map (
      I => CMUX_BYPASS_IN_N_37_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CMUX_SOC_BP_IN,
      O => CMUX_BYPASS_IN_COUNTER(1)
    );
  CMUX_BYPASS_IN_COUNTER_2_Q : X_SFF
    port map (
      I => CMUX_BYPASS_IN_N_38_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CMUX_SOC_BP_IN,
      O => CMUX_BYPASS_IN_COUNTER(2)
    );
  CMUX_BYPASS_IN_COUNTER_3_Q : X_SFF
    port map (
      I => CMUX_BYPASS_IN_N_39_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CMUX_SOC_BP_IN,
      O => CMUX_BYPASS_IN_N_20_1
    );
  CMUX_BYPASS_IN_COUNTER_I_0_Q : X_INV
    port map (
      I => CMUX_BYPASS_IN_COUNTER(0),
      O => CMUX_BYPASS_IN_COUNTER_I(0)
    );
  CMUX_BYPASS_IN_STATE_0_Q : X_SFF
    port map (
      I => CMUX_SOC_BP_IN,
      CLK => CLK,
      CE => CMUX_BYPASS_IN_N_13,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CMUX_BYPASS_IN_STATE(0)
    );
  CMUX_CTRLCELL_IN_I_11_0 : X_LUT4
    generic map (
      INIT => X"AEAA"
    )
    port map (
      ADR0 => CMUX_SOC_CTRL_IN,
      ADR1 => CMUX_CTRLCELL_IN_G_3214,
      ADR2 => CMUX_CTRLCELL_IN_COUNTER(1),
      ADR3 => CMUX_CTRLCELL_IN_STATE(0),
      O => CMUX_CTRLCELL_IN_N_13
    );
  CMUX_CTRLCELL_IN_I_11_0_AND3_G_3214 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => CMUX_CTRLCELL_IN_COUNTER(2),
      ADR1 => CMUX_CTRLCELL_IN_N_20_1,
      O => CMUX_CTRLCELL_IN_G_3214
    );
  CMUX_CTRLCELL_IN_N_31_I : X_LUT3
    generic map (
      INIT => X"A8"
    )
    port map (
      ADR0 => RESET_L,
      ADR1 => CMUX_CTRLCELL_IN_STATE(0),
      ADR2 => CMUX_SOC_CTRL_IN,
      O => CMUX_N_31_I
    );
  CMUX_CTRLCELL_IN_N_37_I_254 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CMUX_CTRLCELL_IN_COUNTER(1),
      ADR1 => CMUX_CTRLCELL_IN_COUNTER(0),
      O => CMUX_CTRLCELL_IN_N_37_I
    );
  CMUX_CTRLCELL_IN_N_38_I_255 : X_LUT3
    generic map (
      INIT => X"6A"
    )
    port map (
      ADR0 => CMUX_CTRLCELL_IN_COUNTER(2),
      ADR1 => CMUX_CTRLCELL_IN_COUNTER(1),
      ADR2 => CMUX_CTRLCELL_IN_COUNTER(0),
      O => CMUX_CTRLCELL_IN_N_38_I
    );
  CMUX_CTRLCELL_IN_N_39_I_256 : X_LUT4
    generic map (
      INIT => X"6AAA"
    )
    port map (
      ADR0 => CMUX_CTRLCELL_IN_N_20_1,
      ADR1 => CMUX_CTRLCELL_IN_COUNTER(2),
      ADR2 => CMUX_CTRLCELL_IN_COUNTER(1),
      ADR3 => CMUX_CTRLCELL_IN_COUNTER(0),
      O => CMUX_CTRLCELL_IN_N_39_I
    );
  CMUX_CTRLCELL_IN_COUNTER_0_Q : X_SFF
    port map (
      I => CMUX_CTRLCELL_IN_COUNTER_I(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CMUX_SOC_CTRL_IN,
      O => CMUX_CTRLCELL_IN_COUNTER(0)
    );
  CMUX_CTRLCELL_IN_COUNTER_1_Q : X_SFF
    port map (
      I => CMUX_CTRLCELL_IN_N_37_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CMUX_SOC_CTRL_IN,
      O => CMUX_CTRLCELL_IN_COUNTER(1)
    );
  CMUX_CTRLCELL_IN_COUNTER_2_Q : X_SFF
    port map (
      I => CMUX_CTRLCELL_IN_N_38_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CMUX_SOC_CTRL_IN,
      O => CMUX_CTRLCELL_IN_COUNTER(2)
    );
  CMUX_CTRLCELL_IN_COUNTER_3_Q : X_SFF
    port map (
      I => CMUX_CTRLCELL_IN_N_39_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CMUX_SOC_CTRL_IN,
      O => CMUX_CTRLCELL_IN_N_20_1
    );
  CMUX_CTRLCELL_IN_COUNTER_I_0_Q : X_INV
    port map (
      I => CMUX_CTRLCELL_IN_COUNTER(0),
      O => CMUX_CTRLCELL_IN_COUNTER_I(0)
    );
  CMUX_CTRLCELL_IN_STATE_0_Q : X_SFF
    port map (
      I => CMUX_SOC_CTRL_IN,
      CLK => CLK,
      CE => CMUX_CTRLCELL_IN_N_13,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CMUX_CTRLCELL_IN_STATE(0)
    );
  CMUX_FIFO_APPL_BU0 : X_RAMB4_S16_S16
    generic map (
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map (
      WEB => CMUX_FIFO_APPL_N2147483641,
      WEA => CMUX_FIFO_APPL_N216,
      RSTB => CMUX_FIFO_APPL_N2147483641,
      RSTA => CMUX_FIFO_APPL_N2147483641,
      ENB => CMUX_FIFO_APPL_N214,
      ENA => CMUX_FIFO_APPL_N2147483644,
      CLKB => CLK,
      CLKA => CLK,
      GSR => GSR,
      DOB(15) => CMUX_DOUT_APPL(15),
      DOB(14) => CMUX_DOUT_APPL(14),
      DOB(13) => CMUX_DOUT_APPL(13),
      DOB(12) => CMUX_DOUT_APPL(12),
      DOB(11) => CMUX_DOUT_APPL(11),
      DOB(10) => CMUX_DOUT_APPL(10),
      DOB(9) => CMUX_DOUT_APPL(9),
      DOB(8) => CMUX_DOUT_APPL(8),
      DOB(7) => CMUX_DOUT_APPL(7),
      DOB(6) => CMUX_DOUT_APPL(6),
      DOB(5) => CMUX_DOUT_APPL(5),
      DOB(4) => CMUX_DOUT_APPL(4),
      DOB(3) => CMUX_DOUT_APPL(3),
      DOB(2) => CMUX_DOUT_APPL(2),
      DOB(1) => CMUX_DOUT_APPL(1),
      DOB(0) => CMUX_DOUT_APPL(0),
      DOA(15) => NGD2VHDL_X_1752_31,
      DOA(14) => NGD2VHDL_X_1752_32,
      DOA(13) => NGD2VHDL_X_1752_33,
      DOA(12) => NGD2VHDL_X_1752_34,
      DOA(11) => NGD2VHDL_X_1752_35,
      DOA(10) => NGD2VHDL_X_1752_36,
      DOA(9) => NGD2VHDL_X_1752_22,
      DOA(8) => NGD2VHDL_X_1752_23,
      DOA(7) => NGD2VHDL_X_1752_24,
      DOA(6) => NGD2VHDL_X_1752_25,
      DOA(5) => NGD2VHDL_X_1752_26,
      DOA(4) => NGD2VHDL_X_1752_27,
      DOA(3) => NGD2VHDL_X_1752_28,
      DOA(2) => NGD2VHDL_X_1752_29,
      DOA(1) => NGD2VHDL_X_1752_30,
      DOA(0) => NGD2VHDL_X_1752_37,
      DIB(15) => CMUX_FIFO_APPL_N2147483641,
      DIB(14) => CMUX_FIFO_APPL_N2147483641,
      DIB(13) => CMUX_FIFO_APPL_N2147483641,
      DIB(12) => CMUX_FIFO_APPL_N2147483641,
      DIB(11) => CMUX_FIFO_APPL_N2147483641,
      DIB(10) => CMUX_FIFO_APPL_N2147483641,
      DIB(9) => CMUX_FIFO_APPL_N2147483641,
      DIB(8) => CMUX_FIFO_APPL_N2147483641,
      DIB(7) => CMUX_FIFO_APPL_N2147483641,
      DIB(6) => CMUX_FIFO_APPL_N2147483641,
      DIB(5) => CMUX_FIFO_APPL_N2147483641,
      DIB(4) => CMUX_FIFO_APPL_N2147483641,
      DIB(3) => CMUX_FIFO_APPL_N2147483641,
      DIB(2) => CMUX_FIFO_APPL_N2147483641,
      DIB(1) => CMUX_FIFO_APPL_N2147483641,
      DIB(0) => CMUX_FIFO_APPL_N2147483641,
      DIA(15) => CMUX_DATA_APPL_IN(15),
      DIA(14) => CMUX_DATA_APPL_IN(14),
      DIA(13) => CMUX_DATA_APPL_IN(13),
      DIA(12) => CMUX_DATA_APPL_IN(12),
      DIA(11) => CMUX_DATA_APPL_IN(11),
      DIA(10) => CMUX_DATA_APPL_IN(10),
      DIA(9) => CMUX_DATA_APPL_IN(9),
      DIA(8) => CMUX_DATA_APPL_IN(8),
      DIA(7) => CMUX_DATA_APPL_IN(7),
      DIA(6) => CMUX_DATA_APPL_IN(6),
      DIA(5) => CMUX_DATA_APPL_IN(5),
      DIA(4) => CMUX_DATA_APPL_IN(4),
      DIA(3) => CMUX_DATA_APPL_IN(3),
      DIA(2) => CMUX_DATA_APPL_IN(2),
      DIA(1) => CMUX_DATA_APPL_IN(1),
      DIA(0) => CMUX_DATA_APPL_IN(0),
      ADDRB(7) => CMUX_FIFO_APPL_N2147483641,
      ADDRB(6) => CMUX_FIFO_APPL_N206,
      ADDRB(5) => CMUX_FIFO_APPL_N207,
      ADDRB(4) => CMUX_FIFO_APPL_N208,
      ADDRB(3) => CMUX_FIFO_APPL_N209,
      ADDRB(2) => CMUX_FIFO_APPL_N210,
      ADDRB(1) => CMUX_FIFO_APPL_N211,
      ADDRB(0) => CMUX_FIFO_APPL_N212,
      ADDRA(7) => CMUX_FIFO_APPL_N2147483641,
      ADDRA(6) => CMUX_FIFO_APPL_N198,
      ADDRA(5) => CMUX_FIFO_APPL_N199,
      ADDRA(4) => CMUX_FIFO_APPL_N200,
      ADDRA(3) => CMUX_FIFO_APPL_N201,
      ADDRA(2) => CMUX_FIFO_APPL_N202,
      ADDRA(1) => CMUX_FIFO_APPL_N203,
      ADDRA(0) => CMUX_FIFO_APPL_N204
    );
  CMUX_FIFO_APPL_BU1 : X_RAMB4_S16_S16
    generic map (
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map (
      WEB => CMUX_FIFO_APPL_N2147483641,
      WEA => CMUX_FIFO_APPL_N216,
      RSTB => CMUX_FIFO_APPL_N2147483641,
      RSTA => CMUX_FIFO_APPL_N2147483641,
      ENB => CMUX_FIFO_APPL_N214,
      ENA => CMUX_FIFO_APPL_N2147483644,
      CLKB => CLK,
      CLKA => CLK,
      GSR => GSR,
      DOB(15) => CMUX_DOUT_APPL(31),
      DOB(14) => CMUX_DOUT_APPL(30),
      DOB(13) => CMUX_DOUT_APPL(29),
      DOB(12) => CMUX_DOUT_APPL(28),
      DOB(11) => CMUX_DOUT_APPL(27),
      DOB(10) => CMUX_DOUT_APPL(26),
      DOB(9) => CMUX_DOUT_APPL(25),
      DOB(8) => CMUX_DOUT_APPL(24),
      DOB(7) => CMUX_DOUT_APPL(23),
      DOB(6) => CMUX_DOUT_APPL(22),
      DOB(5) => CMUX_DOUT_APPL(21),
      DOB(4) => CMUX_DOUT_APPL(20),
      DOB(3) => CMUX_DOUT_APPL(19),
      DOB(2) => CMUX_DOUT_APPL(18),
      DOB(1) => CMUX_DOUT_APPL(17),
      DOB(0) => CMUX_DOUT_APPL(16),
      DOA(15) => NGD2VHDL_X_1753_31,
      DOA(14) => NGD2VHDL_X_1753_32,
      DOA(13) => NGD2VHDL_X_1753_33,
      DOA(12) => NGD2VHDL_X_1753_34,
      DOA(11) => NGD2VHDL_X_1753_35,
      DOA(10) => NGD2VHDL_X_1753_36,
      DOA(9) => NGD2VHDL_X_1753_22,
      DOA(8) => NGD2VHDL_X_1753_23,
      DOA(7) => NGD2VHDL_X_1753_24,
      DOA(6) => NGD2VHDL_X_1753_25,
      DOA(5) => NGD2VHDL_X_1753_26,
      DOA(4) => NGD2VHDL_X_1753_27,
      DOA(3) => NGD2VHDL_X_1753_28,
      DOA(2) => NGD2VHDL_X_1753_29,
      DOA(1) => NGD2VHDL_X_1753_30,
      DOA(0) => NGD2VHDL_X_1753_37,
      DIB(15) => CMUX_FIFO_APPL_N2147483641,
      DIB(14) => CMUX_FIFO_APPL_N2147483641,
      DIB(13) => CMUX_FIFO_APPL_N2147483641,
      DIB(12) => CMUX_FIFO_APPL_N2147483641,
      DIB(11) => CMUX_FIFO_APPL_N2147483641,
      DIB(10) => CMUX_FIFO_APPL_N2147483641,
      DIB(9) => CMUX_FIFO_APPL_N2147483641,
      DIB(8) => CMUX_FIFO_APPL_N2147483641,
      DIB(7) => CMUX_FIFO_APPL_N2147483641,
      DIB(6) => CMUX_FIFO_APPL_N2147483641,
      DIB(5) => CMUX_FIFO_APPL_N2147483641,
      DIB(4) => CMUX_FIFO_APPL_N2147483641,
      DIB(3) => CMUX_FIFO_APPL_N2147483641,
      DIB(2) => CMUX_FIFO_APPL_N2147483641,
      DIB(1) => CMUX_FIFO_APPL_N2147483641,
      DIB(0) => CMUX_FIFO_APPL_N2147483641,
      DIA(15) => CMUX_DATA_APPL_IN(31),
      DIA(14) => CMUX_DATA_APPL_IN(30),
      DIA(13) => CMUX_DATA_APPL_IN(29),
      DIA(12) => CMUX_DATA_APPL_IN(28),
      DIA(11) => CMUX_DATA_APPL_IN(27),
      DIA(10) => CMUX_DATA_APPL_IN(26),
      DIA(9) => CMUX_DATA_APPL_IN(25),
      DIA(8) => CMUX_DATA_APPL_IN(24),
      DIA(7) => CMUX_DATA_APPL_IN(23),
      DIA(6) => CMUX_DATA_APPL_IN(22),
      DIA(5) => CMUX_DATA_APPL_IN(21),
      DIA(4) => CMUX_DATA_APPL_IN(20),
      DIA(3) => CMUX_DATA_APPL_IN(19),
      DIA(2) => CMUX_DATA_APPL_IN(18),
      DIA(1) => CMUX_DATA_APPL_IN(17),
      DIA(0) => CMUX_DATA_APPL_IN(16),
      ADDRB(7) => CMUX_FIFO_APPL_N2147483641,
      ADDRB(6) => CMUX_FIFO_APPL_N206,
      ADDRB(5) => CMUX_FIFO_APPL_N207,
      ADDRB(4) => CMUX_FIFO_APPL_N208,
      ADDRB(3) => CMUX_FIFO_APPL_N209,
      ADDRB(2) => CMUX_FIFO_APPL_N210,
      ADDRB(1) => CMUX_FIFO_APPL_N211,
      ADDRB(0) => CMUX_FIFO_APPL_N212,
      ADDRA(7) => CMUX_FIFO_APPL_N2147483641,
      ADDRA(6) => CMUX_FIFO_APPL_N198,
      ADDRA(5) => CMUX_FIFO_APPL_N199,
      ADDRA(4) => CMUX_FIFO_APPL_N200,
      ADDRA(3) => CMUX_FIFO_APPL_N201,
      ADDRA(2) => CMUX_FIFO_APPL_N202,
      ADDRA(1) => CMUX_FIFO_APPL_N203,
      ADDRA(0) => CMUX_FIFO_APPL_N204
    );
  CMUX_FIFO_APPL_VCC : X_ONE
    port map (
      O => CMUX_FIFO_APPL_N2147483644
    );
  CMUX_FIFO_APPL_GND : X_ZERO
    port map (
      O => CMUX_FIFO_APPL_N2147483641
    );
  CMUX_FIFO_APPL_BU2 : X_LUT4
    generic map (
      INIT => X"2222"
    )
    port map (
      ADR0 => CMUX_OUTPUT_UN20_TMP_STATE,
      ADR1 => CMUX_EMPTY_APPL,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N1710
    );
  CMUX_FIFO_APPL_BU3 : X_LUT4
    generic map (
      INIT => X"2222"
    )
    port map (
      ADR0 => CMUX_OUTPUT_UN20_TMP_STATE,
      ADR1 => CMUX_EMPTY_APPL,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N214
    );
  CMUX_FIFO_APPL_BU4 : X_LUT4
    generic map (
      INIT => X"5555"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N212,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N2124
    );
  CMUX_FIFO_APPL_BU5 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N212,
      IB => CMUX_FIFO_APPL_N2147483641,
      SEL => CMUX_FIFO_APPL_N2124,
      O => CMUX_FIFO_APPL_N2138
    );
  CMUX_FIFO_APPL_BU6 : X_XOR2
    port map (
      I0 => CMUX_FIFO_APPL_N2124,
      I1 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N2116
    );
  CMUX_FIFO_APPL_BU7 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N2116,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU7_GSR_OR,
      O => CMUX_FIFO_APPL_N212
    );
  CMUX_FIFO_APPL_BU8 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N211,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N2154
    );
  CMUX_FIFO_APPL_BU9 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N211,
      IB => CMUX_FIFO_APPL_N2138,
      SEL => CMUX_FIFO_APPL_N2154,
      O => CMUX_FIFO_APPL_N2168
    );
  CMUX_FIFO_APPL_BU10 : X_XOR2
    port map (
      I0 => CMUX_FIFO_APPL_N2154,
      I1 => CMUX_FIFO_APPL_N2138,
      O => CMUX_FIFO_APPL_N2117
    );
  CMUX_FIFO_APPL_BU11 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N2117,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU11_GSR_OR,
      O => CMUX_FIFO_APPL_N211
    );
  CMUX_FIFO_APPL_BU12 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N210,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N2184
    );
  CMUX_FIFO_APPL_BU13 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N210,
      IB => CMUX_FIFO_APPL_N2168,
      SEL => CMUX_FIFO_APPL_N2184,
      O => CMUX_FIFO_APPL_N2198
    );
  CMUX_FIFO_APPL_BU14 : X_XOR2
    port map (
      I0 => CMUX_FIFO_APPL_N2184,
      I1 => CMUX_FIFO_APPL_N2168,
      O => CMUX_FIFO_APPL_N2118
    );
  CMUX_FIFO_APPL_BU15 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N2118,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU15_GSR_OR,
      O => CMUX_FIFO_APPL_N210
    );
  CMUX_FIFO_APPL_BU16 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N209,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N2214
    );
  CMUX_FIFO_APPL_BU17 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N209,
      IB => CMUX_FIFO_APPL_N2198,
      SEL => CMUX_FIFO_APPL_N2214,
      O => CMUX_FIFO_APPL_N2228
    );
  CMUX_FIFO_APPL_BU18 : X_XOR2
    port map (
      I0 => CMUX_FIFO_APPL_N2214,
      I1 => CMUX_FIFO_APPL_N2198,
      O => CMUX_FIFO_APPL_N2119
    );
  CMUX_FIFO_APPL_BU19 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N2119,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU19_GSR_OR,
      O => CMUX_FIFO_APPL_N209
    );
  CMUX_FIFO_APPL_BU20 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N208,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N2244
    );
  CMUX_FIFO_APPL_BU21 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N208,
      IB => CMUX_FIFO_APPL_N2228,
      SEL => CMUX_FIFO_APPL_N2244,
      O => CMUX_FIFO_APPL_N2258
    );
  CMUX_FIFO_APPL_BU22 : X_XOR2
    port map (
      I0 => CMUX_FIFO_APPL_N2244,
      I1 => CMUX_FIFO_APPL_N2228,
      O => CMUX_FIFO_APPL_N2120
    );
  CMUX_FIFO_APPL_BU23 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N2120,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU23_GSR_OR,
      O => CMUX_FIFO_APPL_N208
    );
  CMUX_FIFO_APPL_BU24 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N207,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N2274
    );
  CMUX_FIFO_APPL_BU25 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N207,
      IB => CMUX_FIFO_APPL_N2258,
      SEL => CMUX_FIFO_APPL_N2274,
      O => CMUX_FIFO_APPL_N2288
    );
  CMUX_FIFO_APPL_BU26 : X_XOR2
    port map (
      I0 => CMUX_FIFO_APPL_N2274,
      I1 => CMUX_FIFO_APPL_N2258,
      O => CMUX_FIFO_APPL_N2121
    );
  CMUX_FIFO_APPL_BU27 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N2121,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU27_GSR_OR,
      O => CMUX_FIFO_APPL_N207
    );
  CMUX_FIFO_APPL_BU28 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N206,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N2304
    );
  CMUX_FIFO_APPL_BU29 : X_XOR2
    port map (
      I0 => CMUX_FIFO_APPL_N2304,
      I1 => CMUX_FIFO_APPL_N2288,
      O => CMUX_FIFO_APPL_N2122
    );
  CMUX_FIFO_APPL_BU30 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N2122,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU30_GSR_OR,
      O => CMUX_FIFO_APPL_N206
    );
  CMUX_FIFO_APPL_BU31 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N212,
      ADR1 => CMUX_FIFO_APPL_N211,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N2514
    );
  CMUX_FIFO_APPL_BU32 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N2514,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU32_GSR_OR,
      O => CMUX_FIFO_APPL_N1764
    );
  CMUX_FIFO_APPL_BU33 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N211,
      ADR1 => CMUX_FIFO_APPL_N210,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N2590
    );
  CMUX_FIFO_APPL_BU34 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N2590,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU34_GSR_OR,
      O => CMUX_FIFO_APPL_N1763
    );
  CMUX_FIFO_APPL_BU35 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N210,
      ADR1 => CMUX_FIFO_APPL_N209,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N2666
    );
  CMUX_FIFO_APPL_BU36 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N2666,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU36_GSR_OR,
      O => CMUX_FIFO_APPL_N1762
    );
  CMUX_FIFO_APPL_BU37 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N209,
      ADR1 => CMUX_FIFO_APPL_N208,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N2742
    );
  CMUX_FIFO_APPL_BU38 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N2742,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU38_GSR_OR,
      O => CMUX_FIFO_APPL_N1761
    );
  CMUX_FIFO_APPL_BU39 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N208,
      ADR1 => CMUX_FIFO_APPL_N207,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N2818
    );
  CMUX_FIFO_APPL_BU40 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N2818,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU40_GSR_OR,
      O => CMUX_FIFO_APPL_N1760
    );
  CMUX_FIFO_APPL_BU41 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N207,
      ADR1 => CMUX_FIFO_APPL_N206,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N2894
    );
  CMUX_FIFO_APPL_BU42 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N2894,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU42_GSR_OR,
      O => CMUX_FIFO_APPL_N1759
    );
  CMUX_FIFO_APPL_BU43 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N206,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N2970
    );
  CMUX_FIFO_APPL_BU44 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N2970,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => CMUX_FIFO_APPL_BU44_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_APPL_N1758
    );
  CMUX_FIFO_APPL_BU45 : X_LUT4
    generic map (
      INIT => X"fffe"
    )
    port map (
      ADR0 => CMUX_OUTPUT_UN20_TMP_STATE,
      ADR1 => CMUX_EMPTY_APPL,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N3057
    );
  CMUX_FIFO_APPL_BU46 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N2147483641,
      IB => CMUX_FIFO_APPL_N2147483644,
      SEL => CMUX_FIFO_APPL_BU46_S,
      O => CMUX_FIFO_APPL_BU46_O
    );
  CMUX_FIFO_APPL_BU46_MUXCY_L_BUF : X_BUF
    port map (
      I => CMUX_FIFO_APPL_BU46_O,
      O => CMUX_FIFO_APPL_BU46_LO
    );
  CMUX_FIFO_APPL_BU47 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1828,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => CMUX_FIFO_APPL_BU47_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_APPL_N1844
    );
  CMUX_FIFO_APPL_BU48 : X_LUT4
    generic map (
      INIT => X"ffff"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N2147483641,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N3061
    );
  CMUX_FIFO_APPL_BU49 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N2147483641,
      IB => CMUX_FIFO_APPL_N2147483644,
      SEL => CMUX_FIFO_APPL_N3061,
      O => CMUX_FIFO_APPL_BU49_O
    );
  CMUX_FIFO_APPL_BU49_MUXCY_L_BUF : X_BUF
    port map (
      I => CMUX_FIFO_APPL_BU49_O,
      O => CMUX_FIFO_APPL_BU49_LO
    );
  CMUX_FIFO_APPL_BU50 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1827,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU50_GSR_OR,
      O => CMUX_FIFO_APPL_N1843
    );
  CMUX_FIFO_APPL_BU51 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N1764,
      ADR1 => CMUX_FIFO_APPL_N1828,
      ADR2 => CMUX_FIFO_APPL_N1844,
      ADR3 => CMUX_EMPTY_APPL,
      O => CMUX_FIFO_APPL_N3046
    );
  CMUX_FIFO_APPL_BU52 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N2147483641,
      IB => CMUX_FIFO_APPL_N2147483644,
      SEL => CMUX_FIFO_APPL_N3046,
      O => CMUX_FIFO_APPL_N3054
    );
  CMUX_FIFO_APPL_BU53 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N2147483641,
      CLK => CMUX_FIFO_APPL_N2147483641,
      CE => CMUX_FIFO_APPL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_1805_5
    );
  CMUX_FIFO_APPL_BU54 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N1763,
      ADR1 => CMUX_FIFO_APPL_N1827,
      ADR2 => CMUX_FIFO_APPL_N1843,
      ADR3 => CMUX_EMPTY_APPL,
      O => CMUX_FIFO_APPL_N3045
    );
  CMUX_FIFO_APPL_BU55 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N2147483641,
      IB => CMUX_FIFO_APPL_N3054,
      SEL => CMUX_FIFO_APPL_N3045,
      O => CMUX_FIFO_APPL_N3053
    );
  CMUX_FIFO_APPL_BU56 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1826,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU56_GSR_OR,
      O => CMUX_FIFO_APPL_N1842
    );
  CMUX_FIFO_APPL_BU57 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N1762,
      ADR1 => CMUX_FIFO_APPL_N1826,
      ADR2 => CMUX_FIFO_APPL_N1842,
      ADR3 => CMUX_EMPTY_APPL,
      O => CMUX_FIFO_APPL_N3044
    );
  CMUX_FIFO_APPL_BU58 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N2147483641,
      IB => CMUX_FIFO_APPL_N3053,
      SEL => CMUX_FIFO_APPL_N3044,
      O => CMUX_FIFO_APPL_N3052
    );
  CMUX_FIFO_APPL_BU59 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1825,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU59_GSR_OR,
      O => CMUX_FIFO_APPL_N1841
    );
  CMUX_FIFO_APPL_BU60 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N1761,
      ADR1 => CMUX_FIFO_APPL_N1825,
      ADR2 => CMUX_FIFO_APPL_N1841,
      ADR3 => CMUX_EMPTY_APPL,
      O => CMUX_FIFO_APPL_N3043
    );
  CMUX_FIFO_APPL_BU61 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N2147483641,
      IB => CMUX_FIFO_APPL_N3052,
      SEL => CMUX_FIFO_APPL_N3043,
      O => CMUX_FIFO_APPL_N3051
    );
  CMUX_FIFO_APPL_BU62 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1824,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU62_GSR_OR,
      O => CMUX_FIFO_APPL_N1840
    );
  CMUX_FIFO_APPL_BU63 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N1760,
      ADR1 => CMUX_FIFO_APPL_N1824,
      ADR2 => CMUX_FIFO_APPL_N1840,
      ADR3 => CMUX_EMPTY_APPL,
      O => CMUX_FIFO_APPL_N3042
    );
  CMUX_FIFO_APPL_BU64 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N2147483641,
      IB => CMUX_FIFO_APPL_N3051,
      SEL => CMUX_FIFO_APPL_N3042,
      O => CMUX_FIFO_APPL_N3050
    );
  CMUX_FIFO_APPL_BU65 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1823,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU65_GSR_OR,
      O => CMUX_FIFO_APPL_N1839
    );
  CMUX_FIFO_APPL_BU66 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N1759,
      ADR1 => CMUX_FIFO_APPL_N1823,
      ADR2 => CMUX_FIFO_APPL_N1839,
      ADR3 => CMUX_EMPTY_APPL,
      O => CMUX_FIFO_APPL_N3041
    );
  CMUX_FIFO_APPL_BU67 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N2147483641,
      IB => CMUX_FIFO_APPL_N3050,
      SEL => CMUX_FIFO_APPL_N3041,
      O => CMUX_FIFO_APPL_N3049
    );
  CMUX_FIFO_APPL_BU68 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1822,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => CMUX_FIFO_APPL_BU68_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_APPL_N1838
    );
  CMUX_FIFO_APPL_BU69 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N1758,
      ADR1 => CMUX_FIFO_APPL_N1822,
      ADR2 => CMUX_FIFO_APPL_N1838,
      ADR3 => CMUX_EMPTY_APPL,
      O => CMUX_FIFO_APPL_N3040
    );
  CMUX_FIFO_APPL_BU70 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N2147483641,
      IB => CMUX_FIFO_APPL_N3049,
      SEL => CMUX_FIFO_APPL_N3040,
      O => CMUX_FIFO_APPL_BU70_O
    );
  CMUX_FIFO_APPL_BU70_MUXCY_D_BUF : X_BUF
    port map (
      I => CMUX_FIFO_APPL_BU70_O,
      O => CMUX_FIFO_APPL_N3048
    );
  CMUX_FIFO_APPL_BU71 : X_LUT4
    generic map (
      INIT => X"ffff"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N2147483641,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => NGD2VHDL_X_1823_4
    );
  CMUX_FIFO_APPL_BU72 : X_XOR2
    port map (
      I0 => CMUX_FIFO_APPL_N2147483641,
      I1 => CMUX_FIFO_APPL_N3048,
      O => CMUX_FIFO_APPL_N3059
    );
  CMUX_FIFO_APPL_BU73 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N3059,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N3057,
      SET => CMUX_FIFO_APPL_BU73_GSR_OR,
      RST => GND,
      O => CMUX_EMPTY_APPL
    );
  CMUX_FIFO_APPL_BU74 : X_LUT4
    generic map (
      INIT => X"2222"
    )
    port map (
      ADR0 => CMUX_N_31_I_1,
      ADR1 => CMUX_FULL_APPL,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N1714
    );
  CMUX_FIFO_APPL_BU75 : X_LUT4
    generic map (
      INIT => X"2222"
    )
    port map (
      ADR0 => CMUX_N_31_I_1,
      ADR1 => CMUX_FULL_APPL,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N216
    );
  CMUX_FIFO_APPL_BU76 : X_LUT4
    generic map (
      INIT => X"5555"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N204,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N3409
    );
  CMUX_FIFO_APPL_BU77 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N204,
      IB => CMUX_FIFO_APPL_N2147483641,
      SEL => CMUX_FIFO_APPL_N3409,
      O => CMUX_FIFO_APPL_N3423
    );
  CMUX_FIFO_APPL_BU78 : X_XOR2
    port map (
      I0 => CMUX_FIFO_APPL_N3409,
      I1 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N3401
    );
  CMUX_FIFO_APPL_BU79 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N3401,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU79_GSR_OR,
      O => CMUX_FIFO_APPL_N204
    );
  CMUX_FIFO_APPL_BU80 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N203,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N3439
    );
  CMUX_FIFO_APPL_BU81 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N203,
      IB => CMUX_FIFO_APPL_N3423,
      SEL => CMUX_FIFO_APPL_N3439,
      O => CMUX_FIFO_APPL_N3453
    );
  CMUX_FIFO_APPL_BU82 : X_XOR2
    port map (
      I0 => CMUX_FIFO_APPL_N3439,
      I1 => CMUX_FIFO_APPL_N3423,
      O => CMUX_FIFO_APPL_N3402
    );
  CMUX_FIFO_APPL_BU83 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N3402,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU83_GSR_OR,
      O => CMUX_FIFO_APPL_N203
    );
  CMUX_FIFO_APPL_BU84 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N202,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N3469
    );
  CMUX_FIFO_APPL_BU85 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N202,
      IB => CMUX_FIFO_APPL_N3453,
      SEL => CMUX_FIFO_APPL_N3469,
      O => CMUX_FIFO_APPL_N3483
    );
  CMUX_FIFO_APPL_BU86 : X_XOR2
    port map (
      I0 => CMUX_FIFO_APPL_N3469,
      I1 => CMUX_FIFO_APPL_N3453,
      O => CMUX_FIFO_APPL_N3403
    );
  CMUX_FIFO_APPL_BU87 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N3403,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU87_GSR_OR,
      O => CMUX_FIFO_APPL_N202
    );
  CMUX_FIFO_APPL_BU88 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N201,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N3499
    );
  CMUX_FIFO_APPL_BU89 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N201,
      IB => CMUX_FIFO_APPL_N3483,
      SEL => CMUX_FIFO_APPL_N3499,
      O => CMUX_FIFO_APPL_N3513
    );
  CMUX_FIFO_APPL_BU90 : X_XOR2
    port map (
      I0 => CMUX_FIFO_APPL_N3499,
      I1 => CMUX_FIFO_APPL_N3483,
      O => CMUX_FIFO_APPL_N3404
    );
  CMUX_FIFO_APPL_BU91 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N3404,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU91_GSR_OR,
      O => CMUX_FIFO_APPL_N201
    );
  CMUX_FIFO_APPL_BU92 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N200,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N3529
    );
  CMUX_FIFO_APPL_BU93 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N200,
      IB => CMUX_FIFO_APPL_N3513,
      SEL => CMUX_FIFO_APPL_N3529,
      O => CMUX_FIFO_APPL_N3543
    );
  CMUX_FIFO_APPL_BU94 : X_XOR2
    port map (
      I0 => CMUX_FIFO_APPL_N3529,
      I1 => CMUX_FIFO_APPL_N3513,
      O => CMUX_FIFO_APPL_N3405
    );
  CMUX_FIFO_APPL_BU95 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N3405,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU95_GSR_OR,
      O => CMUX_FIFO_APPL_N200
    );
  CMUX_FIFO_APPL_BU96 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N199,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N3559
    );
  CMUX_FIFO_APPL_BU97 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N199,
      IB => CMUX_FIFO_APPL_N3543,
      SEL => CMUX_FIFO_APPL_N3559,
      O => CMUX_FIFO_APPL_N3573
    );
  CMUX_FIFO_APPL_BU98 : X_XOR2
    port map (
      I0 => CMUX_FIFO_APPL_N3559,
      I1 => CMUX_FIFO_APPL_N3543,
      O => CMUX_FIFO_APPL_N3406
    );
  CMUX_FIFO_APPL_BU99 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N3406,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU99_GSR_OR,
      O => CMUX_FIFO_APPL_N199
    );
  CMUX_FIFO_APPL_BU100 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N198,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N3589
    );
  CMUX_FIFO_APPL_BU101 : X_XOR2
    port map (
      I0 => CMUX_FIFO_APPL_N3589,
      I1 => CMUX_FIFO_APPL_N3573,
      O => CMUX_FIFO_APPL_N3407
    );
  CMUX_FIFO_APPL_BU102 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N3407,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU102_GSR_OR,
      O => CMUX_FIFO_APPL_N198
    );
  CMUX_FIFO_APPL_BU103 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N204,
      ADR1 => CMUX_FIFO_APPL_N203,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N3799
    );
  CMUX_FIFO_APPL_BU104 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N3799,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU104_GSR_OR,
      O => CMUX_FIFO_APPL_N1828
    );
  CMUX_FIFO_APPL_BU105 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N203,
      ADR1 => CMUX_FIFO_APPL_N202,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N3875
    );
  CMUX_FIFO_APPL_BU106 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N3875,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU106_GSR_OR,
      O => CMUX_FIFO_APPL_N1827
    );
  CMUX_FIFO_APPL_BU107 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N202,
      ADR1 => CMUX_FIFO_APPL_N201,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N3951
    );
  CMUX_FIFO_APPL_BU108 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N3951,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU108_GSR_OR,
      O => CMUX_FIFO_APPL_N1826
    );
  CMUX_FIFO_APPL_BU109 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N201,
      ADR1 => CMUX_FIFO_APPL_N200,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N4027
    );
  CMUX_FIFO_APPL_BU110 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N4027,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU110_GSR_OR,
      O => CMUX_FIFO_APPL_N1825
    );
  CMUX_FIFO_APPL_BU111 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N200,
      ADR1 => CMUX_FIFO_APPL_N199,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N4103
    );
  CMUX_FIFO_APPL_BU112 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N4103,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU112_GSR_OR,
      O => CMUX_FIFO_APPL_N1824
    );
  CMUX_FIFO_APPL_BU113 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N199,
      ADR1 => CMUX_FIFO_APPL_N198,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N4179
    );
  CMUX_FIFO_APPL_BU114 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N4179,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU114_GSR_OR,
      O => CMUX_FIFO_APPL_N1823
    );
  CMUX_FIFO_APPL_BU115 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N198,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N4255
    );
  CMUX_FIFO_APPL_BU116 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N4255,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1714,
      SET => CMUX_FIFO_APPL_BU116_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_APPL_N1822
    );
  CMUX_FIFO_APPL_BU117 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1764,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => CMUX_FIFO_APPL_BU117_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_APPL_N1780
    );
  CMUX_FIFO_APPL_BU118 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1763,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU118_GSR_OR,
      O => CMUX_FIFO_APPL_N1779
    );
  CMUX_FIFO_APPL_BU119 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1762,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU119_GSR_OR,
      O => CMUX_FIFO_APPL_N1778
    );
  CMUX_FIFO_APPL_BU120 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1761,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU120_GSR_OR,
      O => CMUX_FIFO_APPL_N1777
    );
  CMUX_FIFO_APPL_BU121 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1760,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU121_GSR_OR,
      O => CMUX_FIFO_APPL_N1776
    );
  CMUX_FIFO_APPL_BU122 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1759,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU122_GSR_OR,
      O => CMUX_FIFO_APPL_N1775
    );
  CMUX_FIFO_APPL_BU123 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1758,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => CMUX_FIFO_APPL_BU123_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_APPL_N1774
    );
  CMUX_FIFO_APPL_BU124 : X_LUT4
    generic map (
      INIT => X"fffe"
    )
    port map (
      ADR0 => CMUX_N_31_I_1,
      ADR1 => CMUX_FULL_APPL,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N4500
    );
  CMUX_FIFO_APPL_BU125 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N2147483641,
      IB => CMUX_FIFO_APPL_N2147483644,
      SEL => CMUX_FIFO_APPL_BU125_S,
      O => CMUX_FIFO_APPL_BU125_O
    );
  CMUX_FIFO_APPL_BU125_MUXCY_L_BUF : X_BUF
    port map (
      I => CMUX_FIFO_APPL_BU125_O,
      O => CMUX_FIFO_APPL_BU125_LO
    );
  CMUX_FIFO_APPL_BU126 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1780,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => CMUX_FIFO_APPL_BU126_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_APPL_N1788
    );
  CMUX_FIFO_APPL_BU127 : X_LUT4
    generic map (
      INIT => X"ffff"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N2147483641,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => CMUX_FIFO_APPL_N4504
    );
  CMUX_FIFO_APPL_BU128 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N2147483641,
      IB => CMUX_FIFO_APPL_N2147483644,
      SEL => CMUX_FIFO_APPL_N4504,
      O => CMUX_FIFO_APPL_BU128_O
    );
  CMUX_FIFO_APPL_BU128_MUXCY_L_BUF : X_BUF
    port map (
      I => CMUX_FIFO_APPL_BU128_O,
      O => CMUX_FIFO_APPL_BU128_LO
    );
  CMUX_FIFO_APPL_BU129 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1779,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => CMUX_FIFO_APPL_BU129_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_APPL_N1787
    );
  CMUX_FIFO_APPL_BU130 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N1828,
      ADR1 => CMUX_FIFO_APPL_N1780,
      ADR2 => CMUX_FIFO_APPL_N1788,
      ADR3 => CMUX_FULL_APPL,
      O => CMUX_FIFO_APPL_N4489
    );
  CMUX_FIFO_APPL_BU131 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N2147483641,
      IB => CMUX_FIFO_APPL_N2147483644,
      SEL => CMUX_FIFO_APPL_N4489,
      O => CMUX_FIFO_APPL_N4497
    );
  CMUX_FIFO_APPL_BU132 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N2147483641,
      CLK => CMUX_FIFO_APPL_N2147483641,
      CE => CMUX_FIFO_APPL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_1884_5
    );
  CMUX_FIFO_APPL_BU133 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N1827,
      ADR1 => CMUX_FIFO_APPL_N1779,
      ADR2 => CMUX_FIFO_APPL_N1787,
      ADR3 => CMUX_FULL_APPL,
      O => CMUX_FIFO_APPL_N4488
    );
  CMUX_FIFO_APPL_BU134 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N2147483641,
      IB => CMUX_FIFO_APPL_N4497,
      SEL => CMUX_FIFO_APPL_N4488,
      O => CMUX_FIFO_APPL_N4496
    );
  CMUX_FIFO_APPL_BU135 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1778,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU135_GSR_OR,
      O => CMUX_FIFO_APPL_N1786
    );
  CMUX_FIFO_APPL_BU136 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N1826,
      ADR1 => CMUX_FIFO_APPL_N1778,
      ADR2 => CMUX_FIFO_APPL_N1786,
      ADR3 => CMUX_FULL_APPL,
      O => CMUX_FIFO_APPL_N4487
    );
  CMUX_FIFO_APPL_BU137 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N2147483641,
      IB => CMUX_FIFO_APPL_N4496,
      SEL => CMUX_FIFO_APPL_N4487,
      O => CMUX_FIFO_APPL_N4495
    );
  CMUX_FIFO_APPL_BU138 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1777,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU138_GSR_OR,
      O => CMUX_FIFO_APPL_N1785
    );
  CMUX_FIFO_APPL_BU139 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N1825,
      ADR1 => CMUX_FIFO_APPL_N1777,
      ADR2 => CMUX_FIFO_APPL_N1785,
      ADR3 => CMUX_FULL_APPL,
      O => CMUX_FIFO_APPL_N4486
    );
  CMUX_FIFO_APPL_BU140 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N2147483641,
      IB => CMUX_FIFO_APPL_N4495,
      SEL => CMUX_FIFO_APPL_N4486,
      O => CMUX_FIFO_APPL_N4494
    );
  CMUX_FIFO_APPL_BU141 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1776,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU141_GSR_OR,
      O => CMUX_FIFO_APPL_N1784
    );
  CMUX_FIFO_APPL_BU142 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N1824,
      ADR1 => CMUX_FIFO_APPL_N1776,
      ADR2 => CMUX_FIFO_APPL_N1784,
      ADR3 => CMUX_FULL_APPL,
      O => CMUX_FIFO_APPL_N4485
    );
  CMUX_FIFO_APPL_BU143 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N2147483641,
      IB => CMUX_FIFO_APPL_N4494,
      SEL => CMUX_FIFO_APPL_N4485,
      O => CMUX_FIFO_APPL_N4493
    );
  CMUX_FIFO_APPL_BU144 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1775,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => GND,
      RST => CMUX_FIFO_APPL_BU144_GSR_OR,
      O => CMUX_FIFO_APPL_N1783
    );
  CMUX_FIFO_APPL_BU145 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N1823,
      ADR1 => CMUX_FIFO_APPL_N1775,
      ADR2 => CMUX_FIFO_APPL_N1783,
      ADR3 => CMUX_FULL_APPL,
      O => CMUX_FIFO_APPL_N4484
    );
  CMUX_FIFO_APPL_BU146 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N2147483641,
      IB => CMUX_FIFO_APPL_N4493,
      SEL => CMUX_FIFO_APPL_N4484,
      O => CMUX_FIFO_APPL_N4492
    );
  CMUX_FIFO_APPL_BU147 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N1774,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N1710,
      SET => CMUX_FIFO_APPL_BU147_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_APPL_N1782
    );
  CMUX_FIFO_APPL_BU148 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N1822,
      ADR1 => CMUX_FIFO_APPL_N1774,
      ADR2 => CMUX_FIFO_APPL_N1782,
      ADR3 => CMUX_FULL_APPL,
      O => CMUX_FIFO_APPL_N4483
    );
  CMUX_FIFO_APPL_BU149 : X_MUX2
    port map (
      IA => CMUX_FIFO_APPL_N2147483641,
      IB => CMUX_FIFO_APPL_N4492,
      SEL => CMUX_FIFO_APPL_N4483,
      O => CMUX_FIFO_APPL_BU149_O
    );
  CMUX_FIFO_APPL_BU149_MUXCY_D_BUF : X_BUF
    port map (
      I => CMUX_FIFO_APPL_BU149_O,
      O => CMUX_FIFO_APPL_N4491
    );
  CMUX_FIFO_APPL_BU150 : X_LUT4
    generic map (
      INIT => X"ffff"
    )
    port map (
      ADR0 => CMUX_FIFO_APPL_N2147483641,
      ADR1 => CMUX_FIFO_APPL_N2147483641,
      ADR2 => CMUX_FIFO_APPL_N2147483641,
      ADR3 => CMUX_FIFO_APPL_N2147483641,
      O => NGD2VHDL_X_1902_4
    );
  CMUX_FIFO_APPL_BU151 : X_XOR2
    port map (
      I0 => CMUX_FIFO_APPL_N2147483641,
      I1 => CMUX_FIFO_APPL_N4491,
      O => CMUX_FIFO_APPL_N4502
    );
  CMUX_FIFO_APPL_BU152 : X_FF
    port map (
      I => CMUX_FIFO_APPL_N4502,
      CLK => CLK,
      CE => CMUX_FIFO_APPL_N4500,
      SET => CMUX_FIFO_APPL_BU152_GSR_OR,
      RST => GND,
      O => CMUX_FULL_APPL
    );
  CMUX_FIFO_APPL_BU7_GSR_OR_257 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU7_GSR_OR
    );
  CMUX_FIFO_APPL_BU11_GSR_OR_258 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU11_GSR_OR
    );
  CMUX_FIFO_APPL_BU15_GSR_OR_259 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU15_GSR_OR
    );
  CMUX_FIFO_APPL_BU19_GSR_OR_260 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU19_GSR_OR
    );
  CMUX_FIFO_APPL_BU23_GSR_OR_261 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU23_GSR_OR
    );
  CMUX_FIFO_APPL_BU27_GSR_OR_262 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU27_GSR_OR
    );
  CMUX_FIFO_APPL_BU30_GSR_OR_263 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU30_GSR_OR
    );
  CMUX_FIFO_APPL_BU32_GSR_OR_264 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU32_GSR_OR
    );
  CMUX_FIFO_APPL_BU34_GSR_OR_265 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU34_GSR_OR
    );
  CMUX_FIFO_APPL_BU36_GSR_OR_266 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU36_GSR_OR
    );
  CMUX_FIFO_APPL_BU38_GSR_OR_267 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU38_GSR_OR
    );
  CMUX_FIFO_APPL_BU40_GSR_OR_268 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU40_GSR_OR
    );
  CMUX_FIFO_APPL_BU42_GSR_OR_269 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU42_GSR_OR
    );
  CMUX_FIFO_APPL_BU44_GSR_OR_270 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU44_GSR_OR
    );
  CMUX_FIFO_APPL_BU47_GSR_OR_271 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU47_GSR_OR
    );
  CMUX_FIFO_APPL_BU50_GSR_OR_272 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU50_GSR_OR
    );
  CMUX_FIFO_APPL_BU56_GSR_OR_273 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU56_GSR_OR
    );
  CMUX_FIFO_APPL_BU59_GSR_OR_274 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU59_GSR_OR
    );
  CMUX_FIFO_APPL_BU62_GSR_OR_275 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU62_GSR_OR
    );
  CMUX_FIFO_APPL_BU65_GSR_OR_276 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU65_GSR_OR
    );
  CMUX_FIFO_APPL_BU68_GSR_OR_277 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU68_GSR_OR
    );
  CMUX_FIFO_APPL_BU73_GSR_OR_278 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU73_GSR_OR
    );
  CMUX_FIFO_APPL_BU79_GSR_OR_279 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU79_GSR_OR
    );
  CMUX_FIFO_APPL_BU83_GSR_OR_280 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU83_GSR_OR
    );
  CMUX_FIFO_APPL_BU87_GSR_OR_281 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU87_GSR_OR
    );
  CMUX_FIFO_APPL_BU91_GSR_OR_282 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU91_GSR_OR
    );
  CMUX_FIFO_APPL_BU95_GSR_OR_283 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU95_GSR_OR
    );
  CMUX_FIFO_APPL_BU99_GSR_OR_284 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU99_GSR_OR
    );
  CMUX_FIFO_APPL_BU102_GSR_OR_285 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU102_GSR_OR
    );
  CMUX_FIFO_APPL_BU104_GSR_OR_286 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU104_GSR_OR
    );
  CMUX_FIFO_APPL_BU106_GSR_OR_287 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU106_GSR_OR
    );
  CMUX_FIFO_APPL_BU108_GSR_OR_288 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU108_GSR_OR
    );
  CMUX_FIFO_APPL_BU110_GSR_OR_289 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU110_GSR_OR
    );
  CMUX_FIFO_APPL_BU112_GSR_OR_290 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU112_GSR_OR
    );
  CMUX_FIFO_APPL_BU114_GSR_OR_291 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU114_GSR_OR
    );
  CMUX_FIFO_APPL_BU116_GSR_OR_292 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU116_GSR_OR
    );
  CMUX_FIFO_APPL_BU117_GSR_OR_293 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU117_GSR_OR
    );
  CMUX_FIFO_APPL_BU118_GSR_OR_294 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU118_GSR_OR
    );
  CMUX_FIFO_APPL_BU119_GSR_OR_295 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU119_GSR_OR
    );
  CMUX_FIFO_APPL_BU120_GSR_OR_296 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU120_GSR_OR
    );
  CMUX_FIFO_APPL_BU121_GSR_OR_297 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU121_GSR_OR
    );
  CMUX_FIFO_APPL_BU122_GSR_OR_298 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU122_GSR_OR
    );
  CMUX_FIFO_APPL_BU123_GSR_OR_299 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU123_GSR_OR
    );
  CMUX_FIFO_APPL_BU126_GSR_OR_300 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU126_GSR_OR
    );
  CMUX_FIFO_APPL_BU129_GSR_OR_301 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU129_GSR_OR
    );
  CMUX_FIFO_APPL_BU135_GSR_OR_302 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU135_GSR_OR
    );
  CMUX_FIFO_APPL_BU138_GSR_OR_303 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU138_GSR_OR
    );
  CMUX_FIFO_APPL_BU141_GSR_OR_304 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU141_GSR_OR
    );
  CMUX_FIFO_APPL_BU144_GSR_OR_305 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU144_GSR_OR
    );
  CMUX_FIFO_APPL_BU147_GSR_OR_306 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU147_GSR_OR
    );
  CMUX_FIFO_APPL_BU152_GSR_OR_307 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_APPL_BU152_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU0 : X_RAMB4_S16_S16
    generic map (
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map (
      WEB => CMUX_FIFO_BYPASS_N2147483641,
      WEA => CMUX_FIFO_BYPASS_N216,
      RSTB => CMUX_FIFO_BYPASS_N2147483641,
      RSTA => CMUX_FIFO_BYPASS_N2147483641,
      ENB => CMUX_FIFO_BYPASS_N214,
      ENA => CMUX_FIFO_BYPASS_N2147483644,
      CLKB => CLK,
      CLKA => CLK,
      GSR => GSR,
      DOB(15) => CMUX_DOUT_BYPASS(15),
      DOB(14) => CMUX_DOUT_BYPASS(14),
      DOB(13) => CMUX_DOUT_BYPASS(13),
      DOB(12) => CMUX_DOUT_BYPASS(12),
      DOB(11) => CMUX_DOUT_BYPASS(11),
      DOB(10) => CMUX_DOUT_BYPASS(10),
      DOB(9) => CMUX_DOUT_BYPASS(9),
      DOB(8) => CMUX_DOUT_BYPASS(8),
      DOB(7) => CMUX_DOUT_BYPASS(7),
      DOB(6) => CMUX_DOUT_BYPASS(6),
      DOB(5) => CMUX_DOUT_BYPASS(5),
      DOB(4) => CMUX_DOUT_BYPASS(4),
      DOB(3) => CMUX_DOUT_BYPASS(3),
      DOB(2) => CMUX_DOUT_BYPASS(2),
      DOB(1) => CMUX_DOUT_BYPASS(1),
      DOB(0) => CMUX_DOUT_BYPASS(0),
      DOA(15) => NGD2VHDL_X_1919_31,
      DOA(14) => NGD2VHDL_X_1919_32,
      DOA(13) => NGD2VHDL_X_1919_33,
      DOA(12) => NGD2VHDL_X_1919_34,
      DOA(11) => NGD2VHDL_X_1919_35,
      DOA(10) => NGD2VHDL_X_1919_36,
      DOA(9) => NGD2VHDL_X_1919_22,
      DOA(8) => NGD2VHDL_X_1919_23,
      DOA(7) => NGD2VHDL_X_1919_24,
      DOA(6) => NGD2VHDL_X_1919_25,
      DOA(5) => NGD2VHDL_X_1919_26,
      DOA(4) => NGD2VHDL_X_1919_27,
      DOA(3) => NGD2VHDL_X_1919_28,
      DOA(2) => NGD2VHDL_X_1919_29,
      DOA(1) => NGD2VHDL_X_1919_30,
      DOA(0) => NGD2VHDL_X_1919_37,
      DIB(15) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(14) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(13) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(12) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(11) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(10) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(9) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(8) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(7) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(6) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(5) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(4) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(3) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(2) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(1) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(0) => CMUX_FIFO_BYPASS_N2147483641,
      DIA(15) => CMUX_DATA_BP_IN(15),
      DIA(14) => CMUX_DATA_BP_IN(14),
      DIA(13) => CMUX_DATA_BP_IN(13),
      DIA(12) => CMUX_DATA_BP_IN(12),
      DIA(11) => CMUX_DATA_BP_IN(11),
      DIA(10) => CMUX_DATA_BP_IN(10),
      DIA(9) => CMUX_DATA_BP_IN(9),
      DIA(8) => CMUX_DATA_BP_IN(8),
      DIA(7) => CMUX_DATA_BP_IN(7),
      DIA(6) => CMUX_DATA_BP_IN(6),
      DIA(5) => CMUX_DATA_BP_IN(5),
      DIA(4) => CMUX_DATA_BP_IN(4),
      DIA(3) => CMUX_DATA_BP_IN(3),
      DIA(2) => CMUX_DATA_BP_IN(2),
      DIA(1) => CMUX_DATA_BP_IN(1),
      DIA(0) => CMUX_DATA_BP_IN(0),
      ADDRB(7) => CMUX_FIFO_BYPASS_N2147483641,
      ADDRB(6) => CMUX_FIFO_BYPASS_N206,
      ADDRB(5) => CMUX_FIFO_BYPASS_N207,
      ADDRB(4) => CMUX_FIFO_BYPASS_N208,
      ADDRB(3) => CMUX_FIFO_BYPASS_N209,
      ADDRB(2) => CMUX_FIFO_BYPASS_N210,
      ADDRB(1) => CMUX_FIFO_BYPASS_N211,
      ADDRB(0) => CMUX_FIFO_BYPASS_N212,
      ADDRA(7) => CMUX_FIFO_BYPASS_N2147483641,
      ADDRA(6) => CMUX_FIFO_BYPASS_N198,
      ADDRA(5) => CMUX_FIFO_BYPASS_N199,
      ADDRA(4) => CMUX_FIFO_BYPASS_N200,
      ADDRA(3) => CMUX_FIFO_BYPASS_N201,
      ADDRA(2) => CMUX_FIFO_BYPASS_N202,
      ADDRA(1) => CMUX_FIFO_BYPASS_N203,
      ADDRA(0) => CMUX_FIFO_BYPASS_N204
    );
  CMUX_FIFO_BYPASS_BU1 : X_RAMB4_S16_S16
    generic map (
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000"
    )
    port map (
      WEB => CMUX_FIFO_BYPASS_N2147483641,
      WEA => CMUX_FIFO_BYPASS_N216,
      RSTB => CMUX_FIFO_BYPASS_N2147483641,
      RSTA => CMUX_FIFO_BYPASS_N2147483641,
      ENB => CMUX_FIFO_BYPASS_N214,
      ENA => CMUX_FIFO_BYPASS_N2147483644,
      CLKB => CLK,
      CLKA => CLK,
      GSR => GSR,
      DOB(15) => CMUX_DOUT_BYPASS(31),
      DOB(14) => CMUX_DOUT_BYPASS(30),
      DOB(13) => CMUX_DOUT_BYPASS(29),
      DOB(12) => CMUX_DOUT_BYPASS(28),
      DOB(11) => CMUX_DOUT_BYPASS(27),
      DOB(10) => CMUX_DOUT_BYPASS(26),
      DOB(9) => CMUX_DOUT_BYPASS(25),
      DOB(8) => CMUX_DOUT_BYPASS(24),
      DOB(7) => CMUX_DOUT_BYPASS(23),
      DOB(6) => CMUX_DOUT_BYPASS(22),
      DOB(5) => CMUX_DOUT_BYPASS(21),
      DOB(4) => CMUX_DOUT_BYPASS(20),
      DOB(3) => CMUX_DOUT_BYPASS(19),
      DOB(2) => CMUX_DOUT_BYPASS(18),
      DOB(1) => CMUX_DOUT_BYPASS(17),
      DOB(0) => CMUX_DOUT_BYPASS(16),
      DOA(15) => NGD2VHDL_X_1920_31,
      DOA(14) => NGD2VHDL_X_1920_32,
      DOA(13) => NGD2VHDL_X_1920_33,
      DOA(12) => NGD2VHDL_X_1920_34,
      DOA(11) => NGD2VHDL_X_1920_35,
      DOA(10) => NGD2VHDL_X_1920_36,
      DOA(9) => NGD2VHDL_X_1920_22,
      DOA(8) => NGD2VHDL_X_1920_23,
      DOA(7) => NGD2VHDL_X_1920_24,
      DOA(6) => NGD2VHDL_X_1920_25,
      DOA(5) => NGD2VHDL_X_1920_26,
      DOA(4) => NGD2VHDL_X_1920_27,
      DOA(3) => NGD2VHDL_X_1920_28,
      DOA(2) => NGD2VHDL_X_1920_29,
      DOA(1) => NGD2VHDL_X_1920_30,
      DOA(0) => NGD2VHDL_X_1920_37,
      DIB(15) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(14) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(13) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(12) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(11) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(10) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(9) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(8) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(7) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(6) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(5) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(4) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(3) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(2) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(1) => CMUX_FIFO_BYPASS_N2147483641,
      DIB(0) => CMUX_FIFO_BYPASS_N2147483641,
      DIA(15) => CMUX_DATA_BP_IN(31),
      DIA(14) => CMUX_DATA_BP_IN(30),
      DIA(13) => CMUX_DATA_BP_IN(29),
      DIA(12) => CMUX_DATA_BP_IN(28),
      DIA(11) => CMUX_DATA_BP_IN(27),
      DIA(10) => CMUX_DATA_BP_IN(26),
      DIA(9) => CMUX_DATA_BP_IN(25),
      DIA(8) => CMUX_DATA_BP_IN(24),
      DIA(7) => CMUX_DATA_BP_IN(23),
      DIA(6) => CMUX_DATA_BP_IN(22),
      DIA(5) => CMUX_DATA_BP_IN(21),
      DIA(4) => CMUX_DATA_BP_IN(20),
      DIA(3) => CMUX_DATA_BP_IN(19),
      DIA(2) => CMUX_DATA_BP_IN(18),
      DIA(1) => CMUX_DATA_BP_IN(17),
      DIA(0) => CMUX_DATA_BP_IN(16),
      ADDRB(7) => CMUX_FIFO_BYPASS_N2147483641,
      ADDRB(6) => CMUX_FIFO_BYPASS_N206,
      ADDRB(5) => CMUX_FIFO_BYPASS_N207,
      ADDRB(4) => CMUX_FIFO_BYPASS_N208,
      ADDRB(3) => CMUX_FIFO_BYPASS_N209,
      ADDRB(2) => CMUX_FIFO_BYPASS_N210,
      ADDRB(1) => CMUX_FIFO_BYPASS_N211,
      ADDRB(0) => CMUX_FIFO_BYPASS_N212,
      ADDRA(7) => CMUX_FIFO_BYPASS_N2147483641,
      ADDRA(6) => CMUX_FIFO_BYPASS_N198,
      ADDRA(5) => CMUX_FIFO_BYPASS_N199,
      ADDRA(4) => CMUX_FIFO_BYPASS_N200,
      ADDRA(3) => CMUX_FIFO_BYPASS_N201,
      ADDRA(2) => CMUX_FIFO_BYPASS_N202,
      ADDRA(1) => CMUX_FIFO_BYPASS_N203,
      ADDRA(0) => CMUX_FIFO_BYPASS_N204
    );
  CMUX_FIFO_BYPASS_VCC : X_ONE
    port map (
      O => CMUX_FIFO_BYPASS_N2147483644
    );
  CMUX_FIFO_BYPASS_GND : X_ZERO
    port map (
      O => CMUX_FIFO_BYPASS_N2147483641
    );
  CMUX_FIFO_BYPASS_BU2 : X_LUT4
    generic map (
      INIT => X"2222"
    )
    port map (
      ADR0 => CMUX_OUTPUT_UN22_TMP_STATE,
      ADR1 => CMUX_EMPTY_BYPASS,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N1710
    );
  CMUX_FIFO_BYPASS_BU3 : X_LUT4
    generic map (
      INIT => X"2222"
    )
    port map (
      ADR0 => CMUX_OUTPUT_UN22_TMP_STATE,
      ADR1 => CMUX_EMPTY_BYPASS,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N214
    );
  CMUX_FIFO_BYPASS_BU4 : X_LUT4
    generic map (
      INIT => X"5555"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N212,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N2124
    );
  CMUX_FIFO_BYPASS_BU5 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N212,
      IB => CMUX_FIFO_BYPASS_N2147483641,
      SEL => CMUX_FIFO_BYPASS_N2124,
      O => CMUX_FIFO_BYPASS_N2138
    );
  CMUX_FIFO_BYPASS_BU6 : X_XOR2
    port map (
      I0 => CMUX_FIFO_BYPASS_N2124,
      I1 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N2116
    );
  CMUX_FIFO_BYPASS_BU7 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N2116,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU7_GSR_OR,
      O => CMUX_FIFO_BYPASS_N212
    );
  CMUX_FIFO_BYPASS_BU8 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N211,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N2154
    );
  CMUX_FIFO_BYPASS_BU9 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N211,
      IB => CMUX_FIFO_BYPASS_N2138,
      SEL => CMUX_FIFO_BYPASS_N2154,
      O => CMUX_FIFO_BYPASS_N2168
    );
  CMUX_FIFO_BYPASS_BU10 : X_XOR2
    port map (
      I0 => CMUX_FIFO_BYPASS_N2154,
      I1 => CMUX_FIFO_BYPASS_N2138,
      O => CMUX_FIFO_BYPASS_N2117
    );
  CMUX_FIFO_BYPASS_BU11 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N2117,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU11_GSR_OR,
      O => CMUX_FIFO_BYPASS_N211
    );
  CMUX_FIFO_BYPASS_BU12 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N210,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N2184
    );
  CMUX_FIFO_BYPASS_BU13 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N210,
      IB => CMUX_FIFO_BYPASS_N2168,
      SEL => CMUX_FIFO_BYPASS_N2184,
      O => CMUX_FIFO_BYPASS_N2198
    );
  CMUX_FIFO_BYPASS_BU14 : X_XOR2
    port map (
      I0 => CMUX_FIFO_BYPASS_N2184,
      I1 => CMUX_FIFO_BYPASS_N2168,
      O => CMUX_FIFO_BYPASS_N2118
    );
  CMUX_FIFO_BYPASS_BU15 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N2118,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU15_GSR_OR,
      O => CMUX_FIFO_BYPASS_N210
    );
  CMUX_FIFO_BYPASS_BU16 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N209,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N2214
    );
  CMUX_FIFO_BYPASS_BU17 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N209,
      IB => CMUX_FIFO_BYPASS_N2198,
      SEL => CMUX_FIFO_BYPASS_N2214,
      O => CMUX_FIFO_BYPASS_N2228
    );
  CMUX_FIFO_BYPASS_BU18 : X_XOR2
    port map (
      I0 => CMUX_FIFO_BYPASS_N2214,
      I1 => CMUX_FIFO_BYPASS_N2198,
      O => CMUX_FIFO_BYPASS_N2119
    );
  CMUX_FIFO_BYPASS_BU19 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N2119,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU19_GSR_OR,
      O => CMUX_FIFO_BYPASS_N209
    );
  CMUX_FIFO_BYPASS_BU20 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N208,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N2244
    );
  CMUX_FIFO_BYPASS_BU21 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N208,
      IB => CMUX_FIFO_BYPASS_N2228,
      SEL => CMUX_FIFO_BYPASS_N2244,
      O => CMUX_FIFO_BYPASS_N2258
    );
  CMUX_FIFO_BYPASS_BU22 : X_XOR2
    port map (
      I0 => CMUX_FIFO_BYPASS_N2244,
      I1 => CMUX_FIFO_BYPASS_N2228,
      O => CMUX_FIFO_BYPASS_N2120
    );
  CMUX_FIFO_BYPASS_BU23 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N2120,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU23_GSR_OR,
      O => CMUX_FIFO_BYPASS_N208
    );
  CMUX_FIFO_BYPASS_BU24 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N207,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N2274
    );
  CMUX_FIFO_BYPASS_BU25 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N207,
      IB => CMUX_FIFO_BYPASS_N2258,
      SEL => CMUX_FIFO_BYPASS_N2274,
      O => CMUX_FIFO_BYPASS_N2288
    );
  CMUX_FIFO_BYPASS_BU26 : X_XOR2
    port map (
      I0 => CMUX_FIFO_BYPASS_N2274,
      I1 => CMUX_FIFO_BYPASS_N2258,
      O => CMUX_FIFO_BYPASS_N2121
    );
  CMUX_FIFO_BYPASS_BU27 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N2121,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU27_GSR_OR,
      O => CMUX_FIFO_BYPASS_N207
    );
  CMUX_FIFO_BYPASS_BU28 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N206,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N2304
    );
  CMUX_FIFO_BYPASS_BU29 : X_XOR2
    port map (
      I0 => CMUX_FIFO_BYPASS_N2304,
      I1 => CMUX_FIFO_BYPASS_N2288,
      O => CMUX_FIFO_BYPASS_N2122
    );
  CMUX_FIFO_BYPASS_BU30 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N2122,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU30_GSR_OR,
      O => CMUX_FIFO_BYPASS_N206
    );
  CMUX_FIFO_BYPASS_BU31 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N212,
      ADR1 => CMUX_FIFO_BYPASS_N211,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N2514
    );
  CMUX_FIFO_BYPASS_BU32 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N2514,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU32_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1764
    );
  CMUX_FIFO_BYPASS_BU33 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N211,
      ADR1 => CMUX_FIFO_BYPASS_N210,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N2590
    );
  CMUX_FIFO_BYPASS_BU34 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N2590,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU34_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1763
    );
  CMUX_FIFO_BYPASS_BU35 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N210,
      ADR1 => CMUX_FIFO_BYPASS_N209,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N2666
    );
  CMUX_FIFO_BYPASS_BU36 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N2666,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU36_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1762
    );
  CMUX_FIFO_BYPASS_BU37 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N209,
      ADR1 => CMUX_FIFO_BYPASS_N208,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N2742
    );
  CMUX_FIFO_BYPASS_BU38 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N2742,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU38_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1761
    );
  CMUX_FIFO_BYPASS_BU39 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N208,
      ADR1 => CMUX_FIFO_BYPASS_N207,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N2818
    );
  CMUX_FIFO_BYPASS_BU40 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N2818,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU40_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1760
    );
  CMUX_FIFO_BYPASS_BU41 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N207,
      ADR1 => CMUX_FIFO_BYPASS_N206,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N2894
    );
  CMUX_FIFO_BYPASS_BU42 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N2894,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU42_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1759
    );
  CMUX_FIFO_BYPASS_BU43 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N206,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N2970
    );
  CMUX_FIFO_BYPASS_BU44 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N2970,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => CMUX_FIFO_BYPASS_BU44_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_BYPASS_N1758
    );
  CMUX_FIFO_BYPASS_BU45 : X_LUT4
    generic map (
      INIT => X"fffe"
    )
    port map (
      ADR0 => CMUX_OUTPUT_UN22_TMP_STATE,
      ADR1 => CMUX_EMPTY_BYPASS,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N3057
    );
  CMUX_FIFO_BYPASS_BU46 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N2147483641,
      IB => CMUX_FIFO_BYPASS_N2147483644,
      SEL => CMUX_FIFO_BYPASS_BU46_S,
      O => CMUX_FIFO_BYPASS_BU46_O
    );
  CMUX_FIFO_BYPASS_BU46_MUXCY_L_BUF : X_BUF
    port map (
      I => CMUX_FIFO_BYPASS_BU46_O,
      O => CMUX_FIFO_BYPASS_BU46_LO
    );
  CMUX_FIFO_BYPASS_BU47 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1828,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => CMUX_FIFO_BYPASS_BU47_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_BYPASS_N1844
    );
  CMUX_FIFO_BYPASS_BU48 : X_LUT4
    generic map (
      INIT => X"ffff"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N2147483641,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N3061
    );
  CMUX_FIFO_BYPASS_BU49 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N2147483641,
      IB => CMUX_FIFO_BYPASS_N2147483644,
      SEL => CMUX_FIFO_BYPASS_N3061,
      O => CMUX_FIFO_BYPASS_BU49_O
    );
  CMUX_FIFO_BYPASS_BU49_MUXCY_L_BUF : X_BUF
    port map (
      I => CMUX_FIFO_BYPASS_BU49_O,
      O => CMUX_FIFO_BYPASS_BU49_LO
    );
  CMUX_FIFO_BYPASS_BU50 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1827,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU50_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1843
    );
  CMUX_FIFO_BYPASS_BU51 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N1764,
      ADR1 => CMUX_FIFO_BYPASS_N1828,
      ADR2 => CMUX_FIFO_BYPASS_N1844,
      ADR3 => CMUX_EMPTY_BYPASS,
      O => CMUX_FIFO_BYPASS_N3046
    );
  CMUX_FIFO_BYPASS_BU52 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N2147483641,
      IB => CMUX_FIFO_BYPASS_N2147483644,
      SEL => CMUX_FIFO_BYPASS_N3046,
      O => CMUX_FIFO_BYPASS_N3054
    );
  CMUX_FIFO_BYPASS_BU53 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N2147483641,
      CLK => CMUX_FIFO_BYPASS_N2147483641,
      CE => CMUX_FIFO_BYPASS_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_1972_5
    );
  CMUX_FIFO_BYPASS_BU54 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N1763,
      ADR1 => CMUX_FIFO_BYPASS_N1827,
      ADR2 => CMUX_FIFO_BYPASS_N1843,
      ADR3 => CMUX_EMPTY_BYPASS,
      O => CMUX_FIFO_BYPASS_N3045
    );
  CMUX_FIFO_BYPASS_BU55 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N2147483641,
      IB => CMUX_FIFO_BYPASS_N3054,
      SEL => CMUX_FIFO_BYPASS_N3045,
      O => CMUX_FIFO_BYPASS_N3053
    );
  CMUX_FIFO_BYPASS_BU56 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1826,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU56_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1842
    );
  CMUX_FIFO_BYPASS_BU57 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N1762,
      ADR1 => CMUX_FIFO_BYPASS_N1826,
      ADR2 => CMUX_FIFO_BYPASS_N1842,
      ADR3 => CMUX_EMPTY_BYPASS,
      O => CMUX_FIFO_BYPASS_N3044
    );
  CMUX_FIFO_BYPASS_BU58 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N2147483641,
      IB => CMUX_FIFO_BYPASS_N3053,
      SEL => CMUX_FIFO_BYPASS_N3044,
      O => CMUX_FIFO_BYPASS_N3052
    );
  CMUX_FIFO_BYPASS_BU59 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1825,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU59_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1841
    );
  CMUX_FIFO_BYPASS_BU60 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N1761,
      ADR1 => CMUX_FIFO_BYPASS_N1825,
      ADR2 => CMUX_FIFO_BYPASS_N1841,
      ADR3 => CMUX_EMPTY_BYPASS,
      O => CMUX_FIFO_BYPASS_N3043
    );
  CMUX_FIFO_BYPASS_BU61 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N2147483641,
      IB => CMUX_FIFO_BYPASS_N3052,
      SEL => CMUX_FIFO_BYPASS_N3043,
      O => CMUX_FIFO_BYPASS_N3051
    );
  CMUX_FIFO_BYPASS_BU62 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1824,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU62_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1840
    );
  CMUX_FIFO_BYPASS_BU63 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N1760,
      ADR1 => CMUX_FIFO_BYPASS_N1824,
      ADR2 => CMUX_FIFO_BYPASS_N1840,
      ADR3 => CMUX_EMPTY_BYPASS,
      O => CMUX_FIFO_BYPASS_N3042
    );
  CMUX_FIFO_BYPASS_BU64 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N2147483641,
      IB => CMUX_FIFO_BYPASS_N3051,
      SEL => CMUX_FIFO_BYPASS_N3042,
      O => CMUX_FIFO_BYPASS_N3050
    );
  CMUX_FIFO_BYPASS_BU65 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1823,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU65_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1839
    );
  CMUX_FIFO_BYPASS_BU66 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N1759,
      ADR1 => CMUX_FIFO_BYPASS_N1823,
      ADR2 => CMUX_FIFO_BYPASS_N1839,
      ADR3 => CMUX_EMPTY_BYPASS,
      O => CMUX_FIFO_BYPASS_N3041
    );
  CMUX_FIFO_BYPASS_BU67 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N2147483641,
      IB => CMUX_FIFO_BYPASS_N3050,
      SEL => CMUX_FIFO_BYPASS_N3041,
      O => CMUX_FIFO_BYPASS_N3049
    );
  CMUX_FIFO_BYPASS_BU68 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1822,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => CMUX_FIFO_BYPASS_BU68_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_BYPASS_N1838
    );
  CMUX_FIFO_BYPASS_BU69 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N1758,
      ADR1 => CMUX_FIFO_BYPASS_N1822,
      ADR2 => CMUX_FIFO_BYPASS_N1838,
      ADR3 => CMUX_EMPTY_BYPASS,
      O => CMUX_FIFO_BYPASS_N3040
    );
  CMUX_FIFO_BYPASS_BU70 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N2147483641,
      IB => CMUX_FIFO_BYPASS_N3049,
      SEL => CMUX_FIFO_BYPASS_N3040,
      O => CMUX_FIFO_BYPASS_BU70_O
    );
  CMUX_FIFO_BYPASS_BU70_MUXCY_D_BUF : X_BUF
    port map (
      I => CMUX_FIFO_BYPASS_BU70_O,
      O => CMUX_FIFO_BYPASS_N3048
    );
  CMUX_FIFO_BYPASS_BU71 : X_LUT4
    generic map (
      INIT => X"ffff"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N2147483641,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => NGD2VHDL_X_1990_4
    );
  CMUX_FIFO_BYPASS_BU72 : X_XOR2
    port map (
      I0 => CMUX_FIFO_BYPASS_N2147483641,
      I1 => CMUX_FIFO_BYPASS_N3048,
      O => CMUX_FIFO_BYPASS_N3059
    );
  CMUX_FIFO_BYPASS_BU73 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N3059,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N3057,
      SET => CMUX_FIFO_BYPASS_BU73_GSR_OR,
      RST => GND,
      O => CMUX_EMPTY_BYPASS
    );
  CMUX_FIFO_BYPASS_BU74 : X_LUT4
    generic map (
      INIT => X"2222"
    )
    port map (
      ADR0 => CMUX_N_31_I_0,
      ADR1 => CMUX_FULL_BYPASS,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N1714
    );
  CMUX_FIFO_BYPASS_BU75 : X_LUT4
    generic map (
      INIT => X"2222"
    )
    port map (
      ADR0 => CMUX_N_31_I_0,
      ADR1 => CMUX_FULL_BYPASS,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N216
    );
  CMUX_FIFO_BYPASS_BU76 : X_LUT4
    generic map (
      INIT => X"5555"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N204,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N3409
    );
  CMUX_FIFO_BYPASS_BU77 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N204,
      IB => CMUX_FIFO_BYPASS_N2147483641,
      SEL => CMUX_FIFO_BYPASS_N3409,
      O => CMUX_FIFO_BYPASS_N3423
    );
  CMUX_FIFO_BYPASS_BU78 : X_XOR2
    port map (
      I0 => CMUX_FIFO_BYPASS_N3409,
      I1 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N3401
    );
  CMUX_FIFO_BYPASS_BU79 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N3401,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU79_GSR_OR,
      O => CMUX_FIFO_BYPASS_N204
    );
  CMUX_FIFO_BYPASS_BU80 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N203,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N3439
    );
  CMUX_FIFO_BYPASS_BU81 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N203,
      IB => CMUX_FIFO_BYPASS_N3423,
      SEL => CMUX_FIFO_BYPASS_N3439,
      O => CMUX_FIFO_BYPASS_N3453
    );
  CMUX_FIFO_BYPASS_BU82 : X_XOR2
    port map (
      I0 => CMUX_FIFO_BYPASS_N3439,
      I1 => CMUX_FIFO_BYPASS_N3423,
      O => CMUX_FIFO_BYPASS_N3402
    );
  CMUX_FIFO_BYPASS_BU83 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N3402,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU83_GSR_OR,
      O => CMUX_FIFO_BYPASS_N203
    );
  CMUX_FIFO_BYPASS_BU84 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N202,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N3469
    );
  CMUX_FIFO_BYPASS_BU85 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N202,
      IB => CMUX_FIFO_BYPASS_N3453,
      SEL => CMUX_FIFO_BYPASS_N3469,
      O => CMUX_FIFO_BYPASS_N3483
    );
  CMUX_FIFO_BYPASS_BU86 : X_XOR2
    port map (
      I0 => CMUX_FIFO_BYPASS_N3469,
      I1 => CMUX_FIFO_BYPASS_N3453,
      O => CMUX_FIFO_BYPASS_N3403
    );
  CMUX_FIFO_BYPASS_BU87 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N3403,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU87_GSR_OR,
      O => CMUX_FIFO_BYPASS_N202
    );
  CMUX_FIFO_BYPASS_BU88 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N201,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N3499
    );
  CMUX_FIFO_BYPASS_BU89 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N201,
      IB => CMUX_FIFO_BYPASS_N3483,
      SEL => CMUX_FIFO_BYPASS_N3499,
      O => CMUX_FIFO_BYPASS_N3513
    );
  CMUX_FIFO_BYPASS_BU90 : X_XOR2
    port map (
      I0 => CMUX_FIFO_BYPASS_N3499,
      I1 => CMUX_FIFO_BYPASS_N3483,
      O => CMUX_FIFO_BYPASS_N3404
    );
  CMUX_FIFO_BYPASS_BU91 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N3404,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU91_GSR_OR,
      O => CMUX_FIFO_BYPASS_N201
    );
  CMUX_FIFO_BYPASS_BU92 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N200,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N3529
    );
  CMUX_FIFO_BYPASS_BU93 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N200,
      IB => CMUX_FIFO_BYPASS_N3513,
      SEL => CMUX_FIFO_BYPASS_N3529,
      O => CMUX_FIFO_BYPASS_N3543
    );
  CMUX_FIFO_BYPASS_BU94 : X_XOR2
    port map (
      I0 => CMUX_FIFO_BYPASS_N3529,
      I1 => CMUX_FIFO_BYPASS_N3513,
      O => CMUX_FIFO_BYPASS_N3405
    );
  CMUX_FIFO_BYPASS_BU95 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N3405,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU95_GSR_OR,
      O => CMUX_FIFO_BYPASS_N200
    );
  CMUX_FIFO_BYPASS_BU96 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N199,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N3559
    );
  CMUX_FIFO_BYPASS_BU97 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N199,
      IB => CMUX_FIFO_BYPASS_N3543,
      SEL => CMUX_FIFO_BYPASS_N3559,
      O => CMUX_FIFO_BYPASS_N3573
    );
  CMUX_FIFO_BYPASS_BU98 : X_XOR2
    port map (
      I0 => CMUX_FIFO_BYPASS_N3559,
      I1 => CMUX_FIFO_BYPASS_N3543,
      O => CMUX_FIFO_BYPASS_N3406
    );
  CMUX_FIFO_BYPASS_BU99 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N3406,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU99_GSR_OR,
      O => CMUX_FIFO_BYPASS_N199
    );
  CMUX_FIFO_BYPASS_BU100 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N198,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N3589
    );
  CMUX_FIFO_BYPASS_BU101 : X_XOR2
    port map (
      I0 => CMUX_FIFO_BYPASS_N3589,
      I1 => CMUX_FIFO_BYPASS_N3573,
      O => CMUX_FIFO_BYPASS_N3407
    );
  CMUX_FIFO_BYPASS_BU102 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N3407,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU102_GSR_OR,
      O => CMUX_FIFO_BYPASS_N198
    );
  CMUX_FIFO_BYPASS_BU103 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N204,
      ADR1 => CMUX_FIFO_BYPASS_N203,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N3799
    );
  CMUX_FIFO_BYPASS_BU104 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N3799,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU104_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1828
    );
  CMUX_FIFO_BYPASS_BU105 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N203,
      ADR1 => CMUX_FIFO_BYPASS_N202,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N3875
    );
  CMUX_FIFO_BYPASS_BU106 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N3875,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU106_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1827
    );
  CMUX_FIFO_BYPASS_BU107 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N202,
      ADR1 => CMUX_FIFO_BYPASS_N201,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N3951
    );
  CMUX_FIFO_BYPASS_BU108 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N3951,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU108_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1826
    );
  CMUX_FIFO_BYPASS_BU109 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N201,
      ADR1 => CMUX_FIFO_BYPASS_N200,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N4027
    );
  CMUX_FIFO_BYPASS_BU110 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N4027,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU110_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1825
    );
  CMUX_FIFO_BYPASS_BU111 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N200,
      ADR1 => CMUX_FIFO_BYPASS_N199,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N4103
    );
  CMUX_FIFO_BYPASS_BU112 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N4103,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU112_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1824
    );
  CMUX_FIFO_BYPASS_BU113 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N199,
      ADR1 => CMUX_FIFO_BYPASS_N198,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N4179
    );
  CMUX_FIFO_BYPASS_BU114 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N4179,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU114_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1823
    );
  CMUX_FIFO_BYPASS_BU115 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N198,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N4255
    );
  CMUX_FIFO_BYPASS_BU116 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N4255,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1714,
      SET => CMUX_FIFO_BYPASS_BU116_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_BYPASS_N1822
    );
  CMUX_FIFO_BYPASS_BU117 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1764,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => CMUX_FIFO_BYPASS_BU117_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_BYPASS_N1780
    );
  CMUX_FIFO_BYPASS_BU118 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1763,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU118_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1779
    );
  CMUX_FIFO_BYPASS_BU119 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1762,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU119_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1778
    );
  CMUX_FIFO_BYPASS_BU120 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1761,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU120_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1777
    );
  CMUX_FIFO_BYPASS_BU121 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1760,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU121_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1776
    );
  CMUX_FIFO_BYPASS_BU122 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1759,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU122_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1775
    );
  CMUX_FIFO_BYPASS_BU123 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1758,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => CMUX_FIFO_BYPASS_BU123_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_BYPASS_N1774
    );
  CMUX_FIFO_BYPASS_BU124 : X_LUT4
    generic map (
      INIT => X"fffe"
    )
    port map (
      ADR0 => CMUX_N_31_I_0,
      ADR1 => CMUX_FULL_BYPASS,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N4500
    );
  CMUX_FIFO_BYPASS_BU125 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N2147483641,
      IB => CMUX_FIFO_BYPASS_N2147483644,
      SEL => CMUX_FIFO_BYPASS_BU125_S,
      O => CMUX_FIFO_BYPASS_BU125_O
    );
  CMUX_FIFO_BYPASS_BU125_MUXCY_L_BUF : X_BUF
    port map (
      I => CMUX_FIFO_BYPASS_BU125_O,
      O => CMUX_FIFO_BYPASS_BU125_LO
    );
  CMUX_FIFO_BYPASS_BU126 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1780,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => CMUX_FIFO_BYPASS_BU126_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_BYPASS_N1788
    );
  CMUX_FIFO_BYPASS_BU127 : X_LUT4
    generic map (
      INIT => X"ffff"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N2147483641,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => CMUX_FIFO_BYPASS_N4504
    );
  CMUX_FIFO_BYPASS_BU128 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N2147483641,
      IB => CMUX_FIFO_BYPASS_N2147483644,
      SEL => CMUX_FIFO_BYPASS_N4504,
      O => CMUX_FIFO_BYPASS_BU128_O
    );
  CMUX_FIFO_BYPASS_BU128_MUXCY_L_BUF : X_BUF
    port map (
      I => CMUX_FIFO_BYPASS_BU128_O,
      O => CMUX_FIFO_BYPASS_BU128_LO
    );
  CMUX_FIFO_BYPASS_BU129 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1779,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => CMUX_FIFO_BYPASS_BU129_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_BYPASS_N1787
    );
  CMUX_FIFO_BYPASS_BU130 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N1828,
      ADR1 => CMUX_FIFO_BYPASS_N1780,
      ADR2 => CMUX_FIFO_BYPASS_N1788,
      ADR3 => CMUX_FULL_BYPASS,
      O => CMUX_FIFO_BYPASS_N4489
    );
  CMUX_FIFO_BYPASS_BU131 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N2147483641,
      IB => CMUX_FIFO_BYPASS_N2147483644,
      SEL => CMUX_FIFO_BYPASS_N4489,
      O => CMUX_FIFO_BYPASS_N4497
    );
  CMUX_FIFO_BYPASS_BU132 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N2147483641,
      CLK => CMUX_FIFO_BYPASS_N2147483641,
      CE => CMUX_FIFO_BYPASS_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2051_5
    );
  CMUX_FIFO_BYPASS_BU133 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N1827,
      ADR1 => CMUX_FIFO_BYPASS_N1779,
      ADR2 => CMUX_FIFO_BYPASS_N1787,
      ADR3 => CMUX_FULL_BYPASS,
      O => CMUX_FIFO_BYPASS_N4488
    );
  CMUX_FIFO_BYPASS_BU134 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N2147483641,
      IB => CMUX_FIFO_BYPASS_N4497,
      SEL => CMUX_FIFO_BYPASS_N4488,
      O => CMUX_FIFO_BYPASS_N4496
    );
  CMUX_FIFO_BYPASS_BU135 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1778,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU135_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1786
    );
  CMUX_FIFO_BYPASS_BU136 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N1826,
      ADR1 => CMUX_FIFO_BYPASS_N1778,
      ADR2 => CMUX_FIFO_BYPASS_N1786,
      ADR3 => CMUX_FULL_BYPASS,
      O => CMUX_FIFO_BYPASS_N4487
    );
  CMUX_FIFO_BYPASS_BU137 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N2147483641,
      IB => CMUX_FIFO_BYPASS_N4496,
      SEL => CMUX_FIFO_BYPASS_N4487,
      O => CMUX_FIFO_BYPASS_N4495
    );
  CMUX_FIFO_BYPASS_BU138 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1777,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU138_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1785
    );
  CMUX_FIFO_BYPASS_BU139 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N1825,
      ADR1 => CMUX_FIFO_BYPASS_N1777,
      ADR2 => CMUX_FIFO_BYPASS_N1785,
      ADR3 => CMUX_FULL_BYPASS,
      O => CMUX_FIFO_BYPASS_N4486
    );
  CMUX_FIFO_BYPASS_BU140 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N2147483641,
      IB => CMUX_FIFO_BYPASS_N4495,
      SEL => CMUX_FIFO_BYPASS_N4486,
      O => CMUX_FIFO_BYPASS_N4494
    );
  CMUX_FIFO_BYPASS_BU141 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1776,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU141_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1784
    );
  CMUX_FIFO_BYPASS_BU142 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N1824,
      ADR1 => CMUX_FIFO_BYPASS_N1776,
      ADR2 => CMUX_FIFO_BYPASS_N1784,
      ADR3 => CMUX_FULL_BYPASS,
      O => CMUX_FIFO_BYPASS_N4485
    );
  CMUX_FIFO_BYPASS_BU143 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N2147483641,
      IB => CMUX_FIFO_BYPASS_N4494,
      SEL => CMUX_FIFO_BYPASS_N4485,
      O => CMUX_FIFO_BYPASS_N4493
    );
  CMUX_FIFO_BYPASS_BU144 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1775,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => GND,
      RST => CMUX_FIFO_BYPASS_BU144_GSR_OR,
      O => CMUX_FIFO_BYPASS_N1783
    );
  CMUX_FIFO_BYPASS_BU145 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N1823,
      ADR1 => CMUX_FIFO_BYPASS_N1775,
      ADR2 => CMUX_FIFO_BYPASS_N1783,
      ADR3 => CMUX_FULL_BYPASS,
      O => CMUX_FIFO_BYPASS_N4484
    );
  CMUX_FIFO_BYPASS_BU146 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N2147483641,
      IB => CMUX_FIFO_BYPASS_N4493,
      SEL => CMUX_FIFO_BYPASS_N4484,
      O => CMUX_FIFO_BYPASS_N4492
    );
  CMUX_FIFO_BYPASS_BU147 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N1774,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N1710,
      SET => CMUX_FIFO_BYPASS_BU147_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_BYPASS_N1782
    );
  CMUX_FIFO_BYPASS_BU148 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N1822,
      ADR1 => CMUX_FIFO_BYPASS_N1774,
      ADR2 => CMUX_FIFO_BYPASS_N1782,
      ADR3 => CMUX_FULL_BYPASS,
      O => CMUX_FIFO_BYPASS_N4483
    );
  CMUX_FIFO_BYPASS_BU149 : X_MUX2
    port map (
      IA => CMUX_FIFO_BYPASS_N2147483641,
      IB => CMUX_FIFO_BYPASS_N4492,
      SEL => CMUX_FIFO_BYPASS_N4483,
      O => CMUX_FIFO_BYPASS_BU149_O
    );
  CMUX_FIFO_BYPASS_BU149_MUXCY_D_BUF : X_BUF
    port map (
      I => CMUX_FIFO_BYPASS_BU149_O,
      O => CMUX_FIFO_BYPASS_N4491
    );
  CMUX_FIFO_BYPASS_BU150 : X_LUT4
    generic map (
      INIT => X"ffff"
    )
    port map (
      ADR0 => CMUX_FIFO_BYPASS_N2147483641,
      ADR1 => CMUX_FIFO_BYPASS_N2147483641,
      ADR2 => CMUX_FIFO_BYPASS_N2147483641,
      ADR3 => CMUX_FIFO_BYPASS_N2147483641,
      O => NGD2VHDL_X_2069_4
    );
  CMUX_FIFO_BYPASS_BU151 : X_XOR2
    port map (
      I0 => CMUX_FIFO_BYPASS_N2147483641,
      I1 => CMUX_FIFO_BYPASS_N4491,
      O => CMUX_FIFO_BYPASS_N4502
    );
  CMUX_FIFO_BYPASS_BU152 : X_FF
    port map (
      I => CMUX_FIFO_BYPASS_N4502,
      CLK => CLK,
      CE => CMUX_FIFO_BYPASS_N4500,
      SET => CMUX_FIFO_BYPASS_BU152_GSR_OR,
      RST => GND,
      O => CMUX_FULL_BYPASS
    );
  CMUX_FIFO_BYPASS_BU7_GSR_OR_308 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU7_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU11_GSR_OR_309 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU11_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU15_GSR_OR_310 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU15_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU19_GSR_OR_311 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU19_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU23_GSR_OR_312 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU23_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU27_GSR_OR_313 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU27_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU30_GSR_OR_314 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU30_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU32_GSR_OR_315 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU32_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU34_GSR_OR_316 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU34_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU36_GSR_OR_317 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU36_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU38_GSR_OR_318 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU38_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU40_GSR_OR_319 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU40_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU42_GSR_OR_320 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU42_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU44_GSR_OR_321 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU44_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU47_GSR_OR_322 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU47_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU50_GSR_OR_323 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU50_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU56_GSR_OR_324 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU56_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU59_GSR_OR_325 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU59_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU62_GSR_OR_326 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU62_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU65_GSR_OR_327 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU65_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU68_GSR_OR_328 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU68_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU73_GSR_OR_329 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU73_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU79_GSR_OR_330 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU79_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU83_GSR_OR_331 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU83_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU87_GSR_OR_332 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU87_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU91_GSR_OR_333 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU91_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU95_GSR_OR_334 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU95_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU99_GSR_OR_335 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU99_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU102_GSR_OR_336 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU102_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU104_GSR_OR_337 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU104_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU106_GSR_OR_338 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU106_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU108_GSR_OR_339 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU108_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU110_GSR_OR_340 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU110_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU112_GSR_OR_341 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU112_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU114_GSR_OR_342 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU114_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU116_GSR_OR_343 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU116_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU117_GSR_OR_344 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU117_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU118_GSR_OR_345 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU118_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU119_GSR_OR_346 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU119_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU120_GSR_OR_347 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU120_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU121_GSR_OR_348 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU121_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU122_GSR_OR_349 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU122_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU123_GSR_OR_350 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU123_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU126_GSR_OR_351 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU126_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU129_GSR_OR_352 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU129_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU135_GSR_OR_353 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU135_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU138_GSR_OR_354 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU138_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU141_GSR_OR_355 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU141_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU144_GSR_OR_356 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU144_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU147_GSR_OR_357 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU147_GSR_OR
    );
  CMUX_FIFO_BYPASS_BU152_GSR_OR_358 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_BYPASS_BU152_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_VCC : X_ONE
    port map (
      O => CMUX_FIFO_CTRLCELL_N2147483644
    );
  CMUX_FIFO_CTRLCELL_GND : X_ZERO
    port map (
      O => CMUX_FIFO_CTRLCELL_N2147483641
    );
  CMUX_FIFO_CTRLCELL_BU1 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N993,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2087_5
    );
  CMUX_FIFO_CTRLCELL_BU2 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N960,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(0)
    );
  CMUX_FIFO_CTRLCELL_BU4 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N994,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2090_5
    );
  CMUX_FIFO_CTRLCELL_BU5 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N961,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(1)
    );
  CMUX_FIFO_CTRLCELL_BU7 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N995,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2093_5
    );
  CMUX_FIFO_CTRLCELL_BU8 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N962,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(2)
    );
  CMUX_FIFO_CTRLCELL_BU10 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N996,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2096_5
    );
  CMUX_FIFO_CTRLCELL_BU11 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N963,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(3)
    );
  CMUX_FIFO_CTRLCELL_BU13 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N997,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2099_5
    );
  CMUX_FIFO_CTRLCELL_BU14 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N964,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(4)
    );
  CMUX_FIFO_CTRLCELL_BU16 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N998,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2102_5
    );
  CMUX_FIFO_CTRLCELL_BU17 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N965,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(5)
    );
  CMUX_FIFO_CTRLCELL_BU19 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N999,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2105_5
    );
  CMUX_FIFO_CTRLCELL_BU20 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N966,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(6)
    );
  CMUX_FIFO_CTRLCELL_BU22 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1000,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2108_5
    );
  CMUX_FIFO_CTRLCELL_BU23 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N967,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(7)
    );
  CMUX_FIFO_CTRLCELL_BU25 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1001,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2111_5
    );
  CMUX_FIFO_CTRLCELL_BU26 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N968,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(8)
    );
  CMUX_FIFO_CTRLCELL_BU28 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1002,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2114_5
    );
  CMUX_FIFO_CTRLCELL_BU29 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N969,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(9)
    );
  CMUX_FIFO_CTRLCELL_BU31 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1003,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2117_5
    );
  CMUX_FIFO_CTRLCELL_BU32 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N970,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(10)
    );
  CMUX_FIFO_CTRLCELL_BU34 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1004,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2120_5
    );
  CMUX_FIFO_CTRLCELL_BU35 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N971,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(11)
    );
  CMUX_FIFO_CTRLCELL_BU37 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1005,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2123_5
    );
  CMUX_FIFO_CTRLCELL_BU38 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N972,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(12)
    );
  CMUX_FIFO_CTRLCELL_BU40 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1006,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2126_5
    );
  CMUX_FIFO_CTRLCELL_BU41 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N973,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(13)
    );
  CMUX_FIFO_CTRLCELL_BU43 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1007,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2129_5
    );
  CMUX_FIFO_CTRLCELL_BU44 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N974,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(14)
    );
  CMUX_FIFO_CTRLCELL_BU46 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1008,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2132_5
    );
  CMUX_FIFO_CTRLCELL_BU47 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N975,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(15)
    );
  CMUX_FIFO_CTRLCELL_BU49 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1009,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2135_5
    );
  CMUX_FIFO_CTRLCELL_BU50 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N976,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(16)
    );
  CMUX_FIFO_CTRLCELL_BU52 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1010,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2138_5
    );
  CMUX_FIFO_CTRLCELL_BU53 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N977,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(17)
    );
  CMUX_FIFO_CTRLCELL_BU55 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1011,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2141_5
    );
  CMUX_FIFO_CTRLCELL_BU56 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N978,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(18)
    );
  CMUX_FIFO_CTRLCELL_BU58 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1012,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2144_5
    );
  CMUX_FIFO_CTRLCELL_BU59 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N979,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(19)
    );
  CMUX_FIFO_CTRLCELL_BU61 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1013,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2147_5
    );
  CMUX_FIFO_CTRLCELL_BU62 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N980,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(20)
    );
  CMUX_FIFO_CTRLCELL_BU64 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1014,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2150_5
    );
  CMUX_FIFO_CTRLCELL_BU65 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N981,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(21)
    );
  CMUX_FIFO_CTRLCELL_BU67 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1015,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2153_5
    );
  CMUX_FIFO_CTRLCELL_BU68 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N982,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(22)
    );
  CMUX_FIFO_CTRLCELL_BU70 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1016,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2156_5
    );
  CMUX_FIFO_CTRLCELL_BU71 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N983,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(23)
    );
  CMUX_FIFO_CTRLCELL_BU73 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1017,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2159_5
    );
  CMUX_FIFO_CTRLCELL_BU74 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N984,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(24)
    );
  CMUX_FIFO_CTRLCELL_BU76 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1018,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2162_5
    );
  CMUX_FIFO_CTRLCELL_BU77 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N985,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(25)
    );
  CMUX_FIFO_CTRLCELL_BU79 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1019,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2165_5
    );
  CMUX_FIFO_CTRLCELL_BU80 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N986,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(26)
    );
  CMUX_FIFO_CTRLCELL_BU82 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1020,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2168_5
    );
  CMUX_FIFO_CTRLCELL_BU83 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N987,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(27)
    );
  CMUX_FIFO_CTRLCELL_BU85 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1021,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2171_5
    );
  CMUX_FIFO_CTRLCELL_BU86 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N988,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(28)
    );
  CMUX_FIFO_CTRLCELL_BU88 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1022,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2174_5
    );
  CMUX_FIFO_CTRLCELL_BU89 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N989,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(29)
    );
  CMUX_FIFO_CTRLCELL_BU91 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1023,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2177_5
    );
  CMUX_FIFO_CTRLCELL_BU92 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N990,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(30)
    );
  CMUX_FIFO_CTRLCELL_BU94 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1024,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2180_5
    );
  CMUX_FIFO_CTRLCELL_BU95 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N991,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N208,
      SET => GND,
      RST => GSR,
      O => CMUX_DOUT_CTRL(31)
    );
  CMUX_FIFO_CTRLCELL_BU96 : X_LUT4
    generic map (
      INIT => X"2222"
    )
    port map (
      ADR0 => CMUX_OUTPUT_UN24_TMP_STATE,
      ADR1 => CMUX_EMPTY_CTRL,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N1947
    );
  CMUX_FIFO_CTRLCELL_BU97 : X_LUT4
    generic map (
      INIT => X"2222"
    )
    port map (
      ADR0 => CMUX_OUTPUT_UN24_TMP_STATE,
      ADR1 => CMUX_EMPTY_CTRL,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N208
    );
  CMUX_FIFO_CTRLCELL_BU98 : X_LUT4
    generic map (
      INIT => X"5555"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N206,
      ADR1 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N2265
    );
  CMUX_FIFO_CTRLCELL_BU99 : X_MUX2
    port map (
      IA => CMUX_FIFO_CTRLCELL_N206,
      IB => CMUX_FIFO_CTRLCELL_N2147483641,
      SEL => CMUX_FIFO_CTRLCELL_N2265,
      O => CMUX_FIFO_CTRLCELL_N2279
    );
  CMUX_FIFO_CTRLCELL_BU100 : X_XOR2
    port map (
      I0 => CMUX_FIFO_CTRLCELL_N2265,
      I1 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N2260
    );
  CMUX_FIFO_CTRLCELL_BU101 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N2260,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1947,
      SET => GND,
      RST => CMUX_FIFO_CTRLCELL_BU101_GSR_OR,
      O => CMUX_FIFO_CTRLCELL_N206
    );
  CMUX_FIFO_CTRLCELL_BU102 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N205,
      ADR1 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N2295
    );
  CMUX_FIFO_CTRLCELL_BU103 : X_MUX2
    port map (
      IA => CMUX_FIFO_CTRLCELL_N205,
      IB => CMUX_FIFO_CTRLCELL_N2279,
      SEL => CMUX_FIFO_CTRLCELL_N2295,
      O => CMUX_FIFO_CTRLCELL_N2309
    );
  CMUX_FIFO_CTRLCELL_BU104 : X_XOR2
    port map (
      I0 => CMUX_FIFO_CTRLCELL_N2295,
      I1 => CMUX_FIFO_CTRLCELL_N2279,
      O => CMUX_FIFO_CTRLCELL_N2261
    );
  CMUX_FIFO_CTRLCELL_BU105 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N2261,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1947,
      SET => GND,
      RST => CMUX_FIFO_CTRLCELL_BU105_GSR_OR,
      O => CMUX_FIFO_CTRLCELL_N205
    );
  CMUX_FIFO_CTRLCELL_BU106 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N204,
      ADR1 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N2325
    );
  CMUX_FIFO_CTRLCELL_BU107 : X_MUX2
    port map (
      IA => CMUX_FIFO_CTRLCELL_N204,
      IB => CMUX_FIFO_CTRLCELL_N2309,
      SEL => CMUX_FIFO_CTRLCELL_N2325,
      O => CMUX_FIFO_CTRLCELL_N2339
    );
  CMUX_FIFO_CTRLCELL_BU108 : X_XOR2
    port map (
      I0 => CMUX_FIFO_CTRLCELL_N2325,
      I1 => CMUX_FIFO_CTRLCELL_N2309,
      O => CMUX_FIFO_CTRLCELL_N2262
    );
  CMUX_FIFO_CTRLCELL_BU109 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N2262,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1947,
      SET => GND,
      RST => CMUX_FIFO_CTRLCELL_BU109_GSR_OR,
      O => CMUX_FIFO_CTRLCELL_N204
    );
  CMUX_FIFO_CTRLCELL_BU110 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N203,
      ADR1 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N2355
    );
  CMUX_FIFO_CTRLCELL_BU111 : X_XOR2
    port map (
      I0 => CMUX_FIFO_CTRLCELL_N2355,
      I1 => CMUX_FIFO_CTRLCELL_N2339,
      O => CMUX_FIFO_CTRLCELL_N2263
    );
  CMUX_FIFO_CTRLCELL_BU112 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N2263,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1947,
      SET => GND,
      RST => CMUX_FIFO_CTRLCELL_BU112_GSR_OR,
      O => CMUX_FIFO_CTRLCELL_N203
    );
  CMUX_FIFO_CTRLCELL_BU113 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N206,
      ADR1 => CMUX_FIFO_CTRLCELL_N205,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N2526
    );
  CMUX_FIFO_CTRLCELL_BU114 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N2526,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1947,
      SET => GND,
      RST => CMUX_FIFO_CTRLCELL_BU114_GSR_OR,
      O => CMUX_FIFO_CTRLCELL_N1992
    );
  CMUX_FIFO_CTRLCELL_BU115 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N205,
      ADR1 => CMUX_FIFO_CTRLCELL_N204,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N2602
    );
  CMUX_FIFO_CTRLCELL_BU116 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N2602,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1947,
      SET => GND,
      RST => CMUX_FIFO_CTRLCELL_BU116_GSR_OR,
      O => CMUX_FIFO_CTRLCELL_N1991
    );
  CMUX_FIFO_CTRLCELL_BU117 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N204,
      ADR1 => CMUX_FIFO_CTRLCELL_N203,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N2678
    );
  CMUX_FIFO_CTRLCELL_BU118 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N2678,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1947,
      SET => GND,
      RST => CMUX_FIFO_CTRLCELL_BU118_GSR_OR,
      O => CMUX_FIFO_CTRLCELL_N1990
    );
  CMUX_FIFO_CTRLCELL_BU119 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N203,
      ADR1 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N2754
    );
  CMUX_FIFO_CTRLCELL_BU120 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N2754,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1947,
      SET => CMUX_FIFO_CTRLCELL_BU120_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_CTRLCELL_N1989
    );
  CMUX_FIFO_CTRLCELL_BU121 : X_LUT4
    generic map (
      INIT => X"fffe"
    )
    port map (
      ADR0 => CMUX_OUTPUT_UN24_TMP_STATE,
      ADR1 => CMUX_EMPTY_CTRL,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N2823
    );
  CMUX_FIFO_CTRLCELL_BU122 : X_MUX2
    port map (
      IA => CMUX_FIFO_CTRLCELL_N2147483641,
      IB => CMUX_FIFO_CTRLCELL_N2147483644,
      SEL => CMUX_FIFO_CTRLCELL_BU122_S,
      O => CMUX_FIFO_CTRLCELL_BU122_O
    );
  CMUX_FIFO_CTRLCELL_BU122_MUXCY_L_BUF : X_BUF
    port map (
      I => CMUX_FIFO_CTRLCELL_BU122_O,
      O => CMUX_FIFO_CTRLCELL_BU122_LO
    );
  CMUX_FIFO_CTRLCELL_BU123 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N2032,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1951,
      SET => CMUX_FIFO_CTRLCELL_BU123_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_CTRLCELL_N2042
    );
  CMUX_FIFO_CTRLCELL_BU124 : X_LUT4
    generic map (
      INIT => X"ffff"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR1 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N2827
    );
  CMUX_FIFO_CTRLCELL_BU125 : X_MUX2
    port map (
      IA => CMUX_FIFO_CTRLCELL_N2147483641,
      IB => CMUX_FIFO_CTRLCELL_N2147483644,
      SEL => CMUX_FIFO_CTRLCELL_N2827,
      O => CMUX_FIFO_CTRLCELL_BU125_O
    );
  CMUX_FIFO_CTRLCELL_BU125_MUXCY_L_BUF : X_BUF
    port map (
      I => CMUX_FIFO_CTRLCELL_BU125_O,
      O => CMUX_FIFO_CTRLCELL_BU125_LO
    );
  CMUX_FIFO_CTRLCELL_BU126 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N2031,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1951,
      SET => GND,
      RST => CMUX_FIFO_CTRLCELL_BU126_GSR_OR,
      O => CMUX_FIFO_CTRLCELL_N2041
    );
  CMUX_FIFO_CTRLCELL_BU127 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N1992,
      ADR1 => CMUX_FIFO_CTRLCELL_N2032,
      ADR2 => CMUX_FIFO_CTRLCELL_N2042,
      ADR3 => CMUX_EMPTY_CTRL,
      O => CMUX_FIFO_CTRLCELL_N2815
    );
  CMUX_FIFO_CTRLCELL_BU128 : X_MUX2
    port map (
      IA => CMUX_FIFO_CTRLCELL_N2147483641,
      IB => CMUX_FIFO_CTRLCELL_N2147483644,
      SEL => CMUX_FIFO_CTRLCELL_N2815,
      O => CMUX_FIFO_CTRLCELL_N2820
    );
  CMUX_FIFO_CTRLCELL_BU129 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N2147483641,
      CLK => CMUX_FIFO_CTRLCELL_N2147483641,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2215_5
    );
  CMUX_FIFO_CTRLCELL_BU130 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N1991,
      ADR1 => CMUX_FIFO_CTRLCELL_N2031,
      ADR2 => CMUX_FIFO_CTRLCELL_N2041,
      ADR3 => CMUX_EMPTY_CTRL,
      O => CMUX_FIFO_CTRLCELL_N2814
    );
  CMUX_FIFO_CTRLCELL_BU131 : X_MUX2
    port map (
      IA => CMUX_FIFO_CTRLCELL_N2147483641,
      IB => CMUX_FIFO_CTRLCELL_N2820,
      SEL => CMUX_FIFO_CTRLCELL_N2814,
      O => CMUX_FIFO_CTRLCELL_N2819
    );
  CMUX_FIFO_CTRLCELL_BU132 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N2030,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1951,
      SET => GND,
      RST => CMUX_FIFO_CTRLCELL_BU132_GSR_OR,
      O => CMUX_FIFO_CTRLCELL_N2040
    );
  CMUX_FIFO_CTRLCELL_BU133 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N1990,
      ADR1 => CMUX_FIFO_CTRLCELL_N2030,
      ADR2 => CMUX_FIFO_CTRLCELL_N2040,
      ADR3 => CMUX_EMPTY_CTRL,
      O => CMUX_FIFO_CTRLCELL_N2813
    );
  CMUX_FIFO_CTRLCELL_BU134 : X_MUX2
    port map (
      IA => CMUX_FIFO_CTRLCELL_N2147483641,
      IB => CMUX_FIFO_CTRLCELL_N2819,
      SEL => CMUX_FIFO_CTRLCELL_N2813,
      O => CMUX_FIFO_CTRLCELL_N2818
    );
  CMUX_FIFO_CTRLCELL_BU135 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N2029,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1951,
      SET => CMUX_FIFO_CTRLCELL_BU135_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_CTRLCELL_N2039
    );
  CMUX_FIFO_CTRLCELL_BU136 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N1989,
      ADR1 => CMUX_FIFO_CTRLCELL_N2029,
      ADR2 => CMUX_FIFO_CTRLCELL_N2039,
      ADR3 => CMUX_EMPTY_CTRL,
      O => CMUX_FIFO_CTRLCELL_N2812
    );
  CMUX_FIFO_CTRLCELL_BU137 : X_MUX2
    port map (
      IA => CMUX_FIFO_CTRLCELL_N2147483641,
      IB => CMUX_FIFO_CTRLCELL_N2818,
      SEL => CMUX_FIFO_CTRLCELL_N2812,
      O => CMUX_FIFO_CTRLCELL_BU137_O
    );
  CMUX_FIFO_CTRLCELL_BU137_MUXCY_D_BUF : X_BUF
    port map (
      I => CMUX_FIFO_CTRLCELL_BU137_O,
      O => CMUX_FIFO_CTRLCELL_N2817
    );
  CMUX_FIFO_CTRLCELL_BU138 : X_LUT4
    generic map (
      INIT => X"ffff"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR1 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => NGD2VHDL_X_2224_4
    );
  CMUX_FIFO_CTRLCELL_BU139 : X_XOR2
    port map (
      I0 => CMUX_FIFO_CTRLCELL_N2147483641,
      I1 => CMUX_FIFO_CTRLCELL_N2817,
      O => CMUX_FIFO_CTRLCELL_N2825
    );
  CMUX_FIFO_CTRLCELL_BU140 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N2825,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N2823,
      SET => CMUX_FIFO_CTRLCELL_BU140_GSR_OR,
      RST => GND,
      O => CMUX_EMPTY_CTRL
    );
  CMUX_FIFO_CTRLCELL_BU141 : X_LUT4
    generic map (
      INIT => X"2222"
    )
    port map (
      ADR0 => CMUX_N_31_I,
      ADR1 => CMUX_FIFO_CTRLCELL_FULL,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N1951
    );
  CMUX_FIFO_CTRLCELL_BU142 : X_LUT4
    generic map (
      INIT => X"2222"
    )
    port map (
      ADR0 => CMUX_N_31_I,
      ADR1 => CMUX_FIFO_CTRLCELL_FULL,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N210
    );
  CMUX_FIFO_CTRLCELL_BU143 : X_LUT4
    generic map (
      INIT => X"5555"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N3094
    );
  CMUX_FIFO_CTRLCELL_BU144 : X_MUX2
    port map (
      IA => CMUX_FIFO_CTRLCELL_N201,
      IB => CMUX_FIFO_CTRLCELL_N2147483641,
      SEL => CMUX_FIFO_CTRLCELL_N3094,
      O => CMUX_FIFO_CTRLCELL_N3108
    );
  CMUX_FIFO_CTRLCELL_BU145 : X_XOR2
    port map (
      I0 => CMUX_FIFO_CTRLCELL_N3094,
      I1 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N3089
    );
  CMUX_FIFO_CTRLCELL_BU146 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N3089,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1951,
      SET => GND,
      RST => CMUX_FIFO_CTRLCELL_BU146_GSR_OR,
      O => CMUX_FIFO_CTRLCELL_N201
    );
  CMUX_FIFO_CTRLCELL_BU147 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N200,
      ADR1 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N3124
    );
  CMUX_FIFO_CTRLCELL_BU148 : X_MUX2
    port map (
      IA => CMUX_FIFO_CTRLCELL_N200,
      IB => CMUX_FIFO_CTRLCELL_N3108,
      SEL => CMUX_FIFO_CTRLCELL_N3124,
      O => CMUX_FIFO_CTRLCELL_N3138
    );
  CMUX_FIFO_CTRLCELL_BU149 : X_XOR2
    port map (
      I0 => CMUX_FIFO_CTRLCELL_N3124,
      I1 => CMUX_FIFO_CTRLCELL_N3108,
      O => CMUX_FIFO_CTRLCELL_N3090
    );
  CMUX_FIFO_CTRLCELL_BU150 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N3090,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1951,
      SET => GND,
      RST => CMUX_FIFO_CTRLCELL_BU150_GSR_OR,
      O => CMUX_FIFO_CTRLCELL_N200
    );
  CMUX_FIFO_CTRLCELL_BU151 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N199,
      ADR1 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N3154
    );
  CMUX_FIFO_CTRLCELL_BU152 : X_MUX2
    port map (
      IA => CMUX_FIFO_CTRLCELL_N199,
      IB => CMUX_FIFO_CTRLCELL_N3138,
      SEL => CMUX_FIFO_CTRLCELL_N3154,
      O => CMUX_FIFO_CTRLCELL_N3168
    );
  CMUX_FIFO_CTRLCELL_BU153 : X_XOR2
    port map (
      I0 => CMUX_FIFO_CTRLCELL_N3154,
      I1 => CMUX_FIFO_CTRLCELL_N3138,
      O => CMUX_FIFO_CTRLCELL_N3091
    );
  CMUX_FIFO_CTRLCELL_BU154 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N3091,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1951,
      SET => GND,
      RST => CMUX_FIFO_CTRLCELL_BU154_GSR_OR,
      O => CMUX_FIFO_CTRLCELL_N199
    );
  CMUX_FIFO_CTRLCELL_BU155 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N198,
      ADR1 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N3184
    );
  CMUX_FIFO_CTRLCELL_BU156 : X_XOR2
    port map (
      I0 => CMUX_FIFO_CTRLCELL_N3184,
      I1 => CMUX_FIFO_CTRLCELL_N3168,
      O => CMUX_FIFO_CTRLCELL_N3092
    );
  CMUX_FIFO_CTRLCELL_BU157 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N3092,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1951,
      SET => GND,
      RST => CMUX_FIFO_CTRLCELL_BU157_GSR_OR,
      O => CMUX_FIFO_CTRLCELL_N198
    );
  CMUX_FIFO_CTRLCELL_BU158 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N3355
    );
  CMUX_FIFO_CTRLCELL_BU159 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N3355,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1951,
      SET => GND,
      RST => CMUX_FIFO_CTRLCELL_BU159_GSR_OR,
      O => CMUX_FIFO_CTRLCELL_N2032
    );
  CMUX_FIFO_CTRLCELL_BU160 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N200,
      ADR1 => CMUX_FIFO_CTRLCELL_N199,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N3431
    );
  CMUX_FIFO_CTRLCELL_BU161 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N3431,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1951,
      SET => GND,
      RST => CMUX_FIFO_CTRLCELL_BU161_GSR_OR,
      O => CMUX_FIFO_CTRLCELL_N2031
    );
  CMUX_FIFO_CTRLCELL_BU162 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N199,
      ADR1 => CMUX_FIFO_CTRLCELL_N198,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N3507
    );
  CMUX_FIFO_CTRLCELL_BU163 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N3507,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1951,
      SET => GND,
      RST => CMUX_FIFO_CTRLCELL_BU163_GSR_OR,
      O => CMUX_FIFO_CTRLCELL_N2030
    );
  CMUX_FIFO_CTRLCELL_BU164 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N198,
      ADR1 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N3583
    );
  CMUX_FIFO_CTRLCELL_BU165 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N3583,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1951,
      SET => CMUX_FIFO_CTRLCELL_BU165_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_CTRLCELL_N2029
    );
  CMUX_FIFO_CTRLCELL_BU166 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1992,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1947,
      SET => CMUX_FIFO_CTRLCELL_BU166_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_CTRLCELL_N2002
    );
  CMUX_FIFO_CTRLCELL_BU167 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1991,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1947,
      SET => GND,
      RST => CMUX_FIFO_CTRLCELL_BU167_GSR_OR,
      O => CMUX_FIFO_CTRLCELL_N2001
    );
  CMUX_FIFO_CTRLCELL_BU168 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1990,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1947,
      SET => GND,
      RST => CMUX_FIFO_CTRLCELL_BU168_GSR_OR,
      O => CMUX_FIFO_CTRLCELL_N2000
    );
  CMUX_FIFO_CTRLCELL_BU169 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1989,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1947,
      SET => CMUX_FIFO_CTRLCELL_BU169_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_CTRLCELL_N1999
    );
  CMUX_FIFO_CTRLCELL_BU170 : X_LUT4
    generic map (
      INIT => X"fffe"
    )
    port map (
      ADR0 => CMUX_N_31_I,
      ADR1 => CMUX_FIFO_CTRLCELL_FULL,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N3750
    );
  CMUX_FIFO_CTRLCELL_BU171 : X_MUX2
    port map (
      IA => CMUX_FIFO_CTRLCELL_N2147483641,
      IB => CMUX_FIFO_CTRLCELL_N2147483644,
      SEL => CMUX_FIFO_CTRLCELL_BU171_S,
      O => CMUX_FIFO_CTRLCELL_BU171_O
    );
  CMUX_FIFO_CTRLCELL_BU171_MUXCY_L_BUF : X_BUF
    port map (
      I => CMUX_FIFO_CTRLCELL_BU171_O,
      O => CMUX_FIFO_CTRLCELL_BU171_LO
    );
  CMUX_FIFO_CTRLCELL_BU172 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N2002,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1947,
      SET => CMUX_FIFO_CTRLCELL_BU172_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_CTRLCELL_N2007
    );
  CMUX_FIFO_CTRLCELL_BU173 : X_LUT4
    generic map (
      INIT => X"ffff"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR1 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => CMUX_FIFO_CTRLCELL_N3754
    );
  CMUX_FIFO_CTRLCELL_BU174 : X_MUX2
    port map (
      IA => CMUX_FIFO_CTRLCELL_N2147483641,
      IB => CMUX_FIFO_CTRLCELL_N2147483644,
      SEL => CMUX_FIFO_CTRLCELL_N3754,
      O => CMUX_FIFO_CTRLCELL_BU174_O
    );
  CMUX_FIFO_CTRLCELL_BU174_MUXCY_L_BUF : X_BUF
    port map (
      I => CMUX_FIFO_CTRLCELL_BU174_O,
      O => CMUX_FIFO_CTRLCELL_BU174_LO
    );
  CMUX_FIFO_CTRLCELL_BU175 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N2001,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1947,
      SET => CMUX_FIFO_CTRLCELL_BU175_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_CTRLCELL_N2006
    );
  CMUX_FIFO_CTRLCELL_BU176 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N2032,
      ADR1 => CMUX_FIFO_CTRLCELL_N2002,
      ADR2 => CMUX_FIFO_CTRLCELL_N2007,
      ADR3 => CMUX_FIFO_CTRLCELL_FULL,
      O => CMUX_FIFO_CTRLCELL_N3742
    );
  CMUX_FIFO_CTRLCELL_BU177 : X_MUX2
    port map (
      IA => CMUX_FIFO_CTRLCELL_N2147483641,
      IB => CMUX_FIFO_CTRLCELL_N2147483644,
      SEL => CMUX_FIFO_CTRLCELL_N3742,
      O => CMUX_FIFO_CTRLCELL_N3747
    );
  CMUX_FIFO_CTRLCELL_BU178 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N2147483641,
      CLK => CMUX_FIFO_CTRLCELL_N2147483641,
      CE => CMUX_FIFO_CTRLCELL_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_2264_5
    );
  CMUX_FIFO_CTRLCELL_BU179 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N2031,
      ADR1 => CMUX_FIFO_CTRLCELL_N2001,
      ADR2 => CMUX_FIFO_CTRLCELL_N2006,
      ADR3 => CMUX_FIFO_CTRLCELL_FULL,
      O => CMUX_FIFO_CTRLCELL_N3741
    );
  CMUX_FIFO_CTRLCELL_BU180 : X_MUX2
    port map (
      IA => CMUX_FIFO_CTRLCELL_N2147483641,
      IB => CMUX_FIFO_CTRLCELL_N3747,
      SEL => CMUX_FIFO_CTRLCELL_N3741,
      O => CMUX_FIFO_CTRLCELL_N3746
    );
  CMUX_FIFO_CTRLCELL_BU181 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N2000,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1947,
      SET => GND,
      RST => CMUX_FIFO_CTRLCELL_BU181_GSR_OR,
      O => CMUX_FIFO_CTRLCELL_N2005
    );
  CMUX_FIFO_CTRLCELL_BU182 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N2030,
      ADR1 => CMUX_FIFO_CTRLCELL_N2000,
      ADR2 => CMUX_FIFO_CTRLCELL_N2005,
      ADR3 => CMUX_FIFO_CTRLCELL_FULL,
      O => CMUX_FIFO_CTRLCELL_N3740
    );
  CMUX_FIFO_CTRLCELL_BU183 : X_MUX2
    port map (
      IA => CMUX_FIFO_CTRLCELL_N2147483641,
      IB => CMUX_FIFO_CTRLCELL_N3746,
      SEL => CMUX_FIFO_CTRLCELL_N3740,
      O => CMUX_FIFO_CTRLCELL_N3745
    );
  CMUX_FIFO_CTRLCELL_BU184 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N1999,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N1947,
      SET => CMUX_FIFO_CTRLCELL_BU184_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_CTRLCELL_N2004
    );
  CMUX_FIFO_CTRLCELL_BU185 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N2029,
      ADR1 => CMUX_FIFO_CTRLCELL_N1999,
      ADR2 => CMUX_FIFO_CTRLCELL_N2004,
      ADR3 => CMUX_FIFO_CTRLCELL_FULL,
      O => CMUX_FIFO_CTRLCELL_N3739
    );
  CMUX_FIFO_CTRLCELL_BU186 : X_MUX2
    port map (
      IA => CMUX_FIFO_CTRLCELL_N2147483641,
      IB => CMUX_FIFO_CTRLCELL_N3745,
      SEL => CMUX_FIFO_CTRLCELL_N3739,
      O => CMUX_FIFO_CTRLCELL_BU186_O
    );
  CMUX_FIFO_CTRLCELL_BU186_MUXCY_D_BUF : X_BUF
    port map (
      I => CMUX_FIFO_CTRLCELL_BU186_O,
      O => CMUX_FIFO_CTRLCELL_N3744
    );
  CMUX_FIFO_CTRLCELL_BU187 : X_LUT4
    generic map (
      INIT => X"ffff"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR1 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR2 => CMUX_FIFO_CTRLCELL_N2147483641,
      ADR3 => CMUX_FIFO_CTRLCELL_N2147483641,
      O => NGD2VHDL_X_2273_4
    );
  CMUX_FIFO_CTRLCELL_BU188 : X_XOR2
    port map (
      I0 => CMUX_FIFO_CTRLCELL_N2147483641,
      I1 => CMUX_FIFO_CTRLCELL_N3744,
      O => CMUX_FIFO_CTRLCELL_N3752
    );
  CMUX_FIFO_CTRLCELL_BU189 : X_FF
    port map (
      I => CMUX_FIFO_CTRLCELL_N3752,
      CLK => CLK,
      CE => CMUX_FIFO_CTRLCELL_N3750,
      SET => CMUX_FIFO_CTRLCELL_BU189_GSR_OR,
      RST => GND,
      O => CMUX_FIFO_CTRLCELL_FULL
    );
  CMUX_FIFO_CTRLCELL_BU101_GSR_OR_359 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU101_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU105_GSR_OR_360 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU105_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU109_GSR_OR_361 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU109_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU112_GSR_OR_362 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU112_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU114_GSR_OR_363 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU114_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU116_GSR_OR_364 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU116_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU118_GSR_OR_365 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU118_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU120_GSR_OR_366 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU120_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU123_GSR_OR_367 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU123_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU126_GSR_OR_368 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU126_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU132_GSR_OR_369 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU132_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU135_GSR_OR_370 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU135_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU140_GSR_OR_371 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU140_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU146_GSR_OR_372 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU146_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU150_GSR_OR_373 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU150_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU154_GSR_OR_374 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU154_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU157_GSR_OR_375 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU157_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU159_GSR_OR_376 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU159_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU161_GSR_OR_377 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU161_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU163_GSR_OR_378 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU163_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU165_GSR_OR_379 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU165_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU166_GSR_OR_380 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU166_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU167_GSR_OR_381 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU167_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU168_GSR_OR_382 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU168_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU169_GSR_OR_383 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU169_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU172_GSR_OR_384 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU172_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU175_GSR_OR_385 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU175_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU181_GSR_OR_386 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU181_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU184_GSR_OR_387 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU184_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU189_GSR_OR_388 : X_OR2
    port map (
      I0 => CMUX_FIFO_RES,
      I1 => GSR,
      O => CMUX_FIFO_CTRLCELL_BU189_GSR_OR
    );
  CMUX_FIFO_CTRLCELL_BU0_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(0),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N993
    );
  CMUX_FIFO_CTRLCELL_BU0_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(0),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N960
    );
  CMUX_FIFO_CTRLCELL_BU3_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(1),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N994
    );
  CMUX_FIFO_CTRLCELL_BU3_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(1),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N961
    );
  CMUX_FIFO_CTRLCELL_BU6_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(2),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N995
    );
  CMUX_FIFO_CTRLCELL_BU6_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(2),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N962
    );
  CMUX_FIFO_CTRLCELL_BU9_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(3),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N996
    );
  CMUX_FIFO_CTRLCELL_BU9_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(3),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N963
    );
  CMUX_FIFO_CTRLCELL_BU12_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(4),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N997
    );
  CMUX_FIFO_CTRLCELL_BU12_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(4),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N964
    );
  CMUX_FIFO_CTRLCELL_BU15_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(5),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N998
    );
  CMUX_FIFO_CTRLCELL_BU15_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(5),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N965
    );
  CMUX_FIFO_CTRLCELL_BU18_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(6),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N999
    );
  CMUX_FIFO_CTRLCELL_BU18_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(6),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N966
    );
  CMUX_FIFO_CTRLCELL_BU21_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(7),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1000
    );
  CMUX_FIFO_CTRLCELL_BU21_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(7),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N967
    );
  CMUX_FIFO_CTRLCELL_BU24_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(8),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1001
    );
  CMUX_FIFO_CTRLCELL_BU24_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(8),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N968
    );
  CMUX_FIFO_CTRLCELL_BU27_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(9),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1002
    );
  CMUX_FIFO_CTRLCELL_BU27_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(9),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N969
    );
  CMUX_FIFO_CTRLCELL_BU30_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(10),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1003
    );
  CMUX_FIFO_CTRLCELL_BU30_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(10),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N970
    );
  CMUX_FIFO_CTRLCELL_BU33_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(11),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1004
    );
  CMUX_FIFO_CTRLCELL_BU33_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(11),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N971
    );
  CMUX_FIFO_CTRLCELL_BU36_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(12),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1005
    );
  CMUX_FIFO_CTRLCELL_BU36_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(12),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N972
    );
  CMUX_FIFO_CTRLCELL_BU39_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(13),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1006
    );
  CMUX_FIFO_CTRLCELL_BU39_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(13),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N973
    );
  CMUX_FIFO_CTRLCELL_BU42_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(14),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1007
    );
  CMUX_FIFO_CTRLCELL_BU42_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(14),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N974
    );
  CMUX_FIFO_CTRLCELL_BU45_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(15),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1008
    );
  CMUX_FIFO_CTRLCELL_BU45_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(15),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N975
    );
  CMUX_FIFO_CTRLCELL_BU48_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(16),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1009
    );
  CMUX_FIFO_CTRLCELL_BU48_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(16),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N976
    );
  CMUX_FIFO_CTRLCELL_BU51_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(17),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1010
    );
  CMUX_FIFO_CTRLCELL_BU51_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(17),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N977
    );
  CMUX_FIFO_CTRLCELL_BU54_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(18),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1011
    );
  CMUX_FIFO_CTRLCELL_BU54_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(18),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N978
    );
  CMUX_FIFO_CTRLCELL_BU57_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(19),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1012
    );
  CMUX_FIFO_CTRLCELL_BU57_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(19),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N979
    );
  CMUX_FIFO_CTRLCELL_BU60_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(20),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1013
    );
  CMUX_FIFO_CTRLCELL_BU60_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(20),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N980
    );
  CMUX_FIFO_CTRLCELL_BU63_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(21),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1014
    );
  CMUX_FIFO_CTRLCELL_BU63_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(21),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N981
    );
  CMUX_FIFO_CTRLCELL_BU66_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(22),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1015
    );
  CMUX_FIFO_CTRLCELL_BU66_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(22),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N982
    );
  CMUX_FIFO_CTRLCELL_BU69_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(23),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1016
    );
  CMUX_FIFO_CTRLCELL_BU69_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(23),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N983
    );
  CMUX_FIFO_CTRLCELL_BU72_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(24),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1017
    );
  CMUX_FIFO_CTRLCELL_BU72_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(24),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N984
    );
  CMUX_FIFO_CTRLCELL_BU75_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(25),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1018
    );
  CMUX_FIFO_CTRLCELL_BU75_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(25),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N985
    );
  CMUX_FIFO_CTRLCELL_BU78_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(26),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1019
    );
  CMUX_FIFO_CTRLCELL_BU78_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(26),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N986
    );
  CMUX_FIFO_CTRLCELL_BU81_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(27),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1020
    );
  CMUX_FIFO_CTRLCELL_BU81_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(27),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N987
    );
  CMUX_FIFO_CTRLCELL_BU84_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(28),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1021
    );
  CMUX_FIFO_CTRLCELL_BU84_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(28),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N988
    );
  CMUX_FIFO_CTRLCELL_BU87_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(29),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1022
    );
  CMUX_FIFO_CTRLCELL_BU87_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(29),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N989
    );
  CMUX_FIFO_CTRLCELL_BU90_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(30),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1023
    );
  CMUX_FIFO_CTRLCELL_BU90_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(30),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N990
    );
  CMUX_FIFO_CTRLCELL_BU93_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => CMUX_FIFO_CTRLCELL_N201,
      ADR1 => CMUX_FIFO_CTRLCELL_N200,
      ADR2 => CMUX_FIFO_CTRLCELL_N199,
      ADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(31),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N1024
    );
  CMUX_FIFO_CTRLCELL_BU93_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => CMUX_FIFO_CTRLCELL_N206,
      RADR1 => CMUX_FIFO_CTRLCELL_N205,
      RADR2 => CMUX_FIFO_CTRLCELL_N204,
      RADR3 => CMUX_FIFO_CTRLCELL_N203,
      WADR0 => CMUX_FIFO_CTRLCELL_N201,
      WADR1 => CMUX_FIFO_CTRLCELL_N200,
      WADR2 => CMUX_FIFO_CTRLCELL_N199,
      WADR3 => CMUX_FIFO_CTRLCELL_N198,
      I => CMUX_DATA_CTRL_IN(31),
      CLK => CLK,
      WE => CMUX_FIFO_CTRLCELL_N210,
      O => CMUX_FIFO_CTRLCELL_N991
    );
  CMUX_STATE_H_STATE_0_Q : X_SFF
    port map (
      I => CMUX_NX_STATE_SS0,
      CLK => CLK,
      CE => CMUX_OUTPUT_UN5_STATE,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CMUX_STATE(0)
    );
  CMUX_STATE_H_STATE_1_Q : X_SFF
    port map (
      I => CMUX_N_57_1,
      CLK => CLK,
      CE => CMUX_OUTPUT_UN5_STATE,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => CMUX_STATE(1)
    );
  CMUX_STATE_H_STATE_NS_AND3_1_1_Q : X_LUT3
    generic map (
      INIT => X"2A"
    )
    port map (
      ADR0 => TCA_OUT_MOD,
      ADR1 => CMUX_EMPTY_BYPASS,
      ADR2 => CMUX_EMPTY_CTRL,
      O => CMUX_N_57_1
    );
  CRC_GEN_G_134_389 : X_LUT4
    generic map (
      INIT => X"F7FF"
    )
    port map (
      ADR0 => CRC_GEN_COUNTER(0),
      ADR1 => CRC_GEN_COUNTER(1),
      ADR2 => CRC_GEN_COUNTER(2),
      ADR3 => CRC_GEN_N_4_1,
      O => CRC_GEN_G_134
    );
  CRC_GEN_G_139_390 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => DATA_CC_M(11),
      ADR1 => DATA_CC_M(7),
      ADR2 => DATA_CC_M(3),
      O => CRC_GEN_G_139
    );
  CRC_GEN_G_140_391 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => DATA_CC_M(5),
      ADR1 => DATA_CC_M(9),
      O => CRC_GEN_G_140
    );
  CRC_GEN_G_141_392 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => DATA_CC_M(12),
      ADR1 => DATA_CC_M(4),
      ADR2 => DATA_CC_M(1),
      ADR3 => DATA_CC_M(0),
      O => CRC_GEN_G_141
    );
  CRC_GEN_G_150_393 : X_LUT3
    generic map (
      INIT => X"6A"
    )
    port map (
      ADR0 => CRC_GEN_COUNTER(2),
      ADR1 => CRC_GEN_COUNTER(0),
      ADR2 => CRC_GEN_COUNTER(1),
      O => CRC_GEN_G_150
    );
  CRC_GEN_G_151_394 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => CRC_GEN_CRC_L_0_Q,
      ADR1 => DATA_CC_M(10),
      ADR2 => DATA_CC_M(2),
      ADR3 => DATA_CC_M(6),
      O => CRC_GEN_G_151
    );
  CRC_GEN_G_152_395 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => DATA_CC_M(6),
      ADR1 => DATA_CC_M(13),
      ADR2 => DATA_CC_M(9),
      ADR3 => DATA_CC_M(5),
      O => CRC_GEN_G_152
    );
  CRC_GEN_G_155_396 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => DATA_CC_M(2),
      ADR1 => DATA_CC_M(6),
      ADR2 => CRC_GEN_G_139,
      ADR3 => DATA_CC_M(0),
      O => CRC_GEN_G_155
    );
  CRC_GEN_G_169_397 : X_LUT4
    generic map (
      INIT => X"D77D"
    )
    port map (
      ADR0 => CRC_GEN_G_134,
      ADR1 => CRC_GEN_G_141,
      ADR2 => DATA_CC_M(7),
      ADR3 => DATA_CC_M(3),
      O => CRC_GEN_G_169
    );
  CRC_GEN_G_171_398 : X_LUT4
    generic map (
      INIT => X"E22E"
    )
    port map (
      ADR0 => DATA_CC_M(3),
      ADR1 => CRC_GEN_G_134,
      ADR2 => CRC_GEN_G_141,
      ADR3 => DATA_CC_M(8),
      O => CRC_GEN_G_171
    );
  CRC_GEN_N_86_I_399 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_GEN_COUNTER(1),
      ADR1 => CRC_GEN_COUNTER(0),
      O => CRC_GEN_N_86_I
    );
  CRC_GEN_N_87_I_400 : X_LUT4
    generic map (
      INIT => X"6AAA"
    )
    port map (
      ADR0 => CRC_GEN_N_4_1,
      ADR1 => CRC_GEN_COUNTER(2),
      ADR2 => CRC_GEN_COUNTER(0),
      ADR3 => CRC_GEN_COUNTER(1),
      O => CRC_GEN_N_87_I
    );
  CRC_GEN_COUNTER_0_Q : X_SFF
    port map (
      I => CRC_GEN_COUNTER_I(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_GEN_COUNTER(0)
    );
  CRC_GEN_COUNTER_1_Q : X_SFF
    port map (
      I => CRC_GEN_N_86_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_GEN_COUNTER(1)
    );
  CRC_GEN_COUNTER_2_Q : X_SFF
    port map (
      I => CRC_GEN_G_150,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_GEN_COUNTER(2)
    );
  CRC_GEN_COUNTER_3_Q : X_SFF
    port map (
      I => CRC_GEN_N_87_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_GEN_N_4_1
    );
  CRC_GEN_COUNTER_I_0_Q : X_INV
    port map (
      I => CRC_GEN_COUNTER(0),
      O => CRC_GEN_COUNTER_I(0)
    );
  CRC_GEN_CRC16_OUT_0_Q : X_SFF
    port map (
      I => CRC_GEN_UN5_NX_CRC(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_NEW(0)
    );
  CRC_GEN_CRC16_OUT_1_Q : X_SFF
    port map (
      I => CRC_GEN_UN5_NX_CRC(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_NEW(1)
    );
  CRC_GEN_CRC16_OUT_2_Q : X_SFF
    port map (
      I => CRC_GEN_UN5_NX_CRC(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_NEW(2)
    );
  CRC_GEN_CRC16_OUT_3_Q : X_SFF
    port map (
      I => CRC_GEN_UN5_NX_CRC(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_NEW(3)
    );
  CRC_GEN_CRC16_OUT_4_Q : X_SFF
    port map (
      I => CRC_GEN_UN5_NX_CRC(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_NEW(4)
    );
  CRC_GEN_CRC16_OUT_5_Q : X_SFF
    port map (
      I => CRC_GEN_UN5_NX_CRC(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_NEW(5)
    );
  CRC_GEN_CRC16_OUT_6_Q : X_SFF
    port map (
      I => CRC_GEN_UN5_NX_CRC(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_NEW(6)
    );
  CRC_GEN_CRC16_OUT_7_Q : X_SFF
    port map (
      I => CRC_GEN_UN5_NX_CRC(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_NEW(7)
    );
  CRC_GEN_CRC16_OUT_8_Q : X_SFF
    port map (
      I => CRC_GEN_UN5_NX_CRC(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_NEW(8)
    );
  CRC_GEN_CRC16_OUT_9_Q : X_SFF
    port map (
      I => CRC_GEN_UN5_NX_CRC(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_NEW(9)
    );
  CRC_GEN_CRC16_OUT_10_Q : X_SFF
    port map (
      I => CRC_GEN_UN5_NX_CRC(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_NEW(10)
    );
  CRC_GEN_CRC16_OUT_11_Q : X_SFF
    port map (
      I => CRC_GEN_UN5_NX_CRC(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_NEW(11)
    );
  CRC_GEN_CRC16_OUT_12_Q : X_SFF
    port map (
      I => CRC_GEN_UN5_NX_CRC(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_NEW(12)
    );
  CRC_GEN_CRC16_OUT_13_Q : X_SFF
    port map (
      I => CRC_GEN_UN5_NX_CRC(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_NEW(13)
    );
  CRC_GEN_CRC16_OUT_14_Q : X_SFF
    port map (
      I => CRC_GEN_UN5_NX_CRC(14),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_NEW(14)
    );
  CRC_GEN_CRC16_OUT_15_Q : X_SFF
    port map (
      I => CRC_GEN_UN5_NX_CRC(15),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SOC_CC,
      O => CRC_NEW(15)
    );
  CRC_GEN_CRC_L_M_0_MUX2_4_Q : X_LUT4
    generic map (
      INIT => X"2EE2"
    )
    port map (
      ADR0 => DATA_CC_M(4),
      ADR1 => CRC_GEN_G_134,
      ADR2 => CRC_GEN_G_139,
      ADR3 => DATA_CC_M(0),
      O => CRC_GEN_CRC_L_M(4)
    );
  CRC_GEN_UN5_NX_CRC_0_Q : X_LUT4
    generic map (
      INIT => X"596A"
    )
    port map (
      ADR0 => CRC_GEN_G_3435,
      ADR1 => CRC_GEN_G_134,
      ADR2 => CRC_GEN_CRC_L_0_Q,
      ADR3 => DATA_CC_M(0),
      O => CRC_GEN_UN5_NX_CRC(0)
    );
  CRC_GEN_UN5_NX_CRC_1_Q : X_LUT4
    generic map (
      INIT => X"596A"
    )
    port map (
      ADR0 => CRC_GEN_G_3439,
      ADR1 => CRC_GEN_G_134,
      ADR2 => CRC_GEN_CRC_L_1_Q,
      ADR3 => DATA_CC_M(1),
      O => CRC_GEN_UN5_NX_CRC(1)
    );
  CRC_GEN_UN5_NX_CRC_2_Q : X_LUT4
    generic map (
      INIT => X"596A"
    )
    port map (
      ADR0 => CRC_GEN_G_3465,
      ADR1 => CRC_GEN_G_134,
      ADR2 => CRC_GEN_CRC_L_2_Q,
      ADR3 => DATA_CC_M(2),
      O => CRC_GEN_UN5_NX_CRC(2)
    );
  CRC_GEN_UN5_NX_CRC_3_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_GEN_G_171,
      ADR1 => CRC_NEW(3),
      ADR2 => CRC_GEN_N_54,
      ADR3 => DATA_CC_M(28),
      O => CRC_GEN_UN5_NX_CRC(3)
    );
  CRC_GEN_UN5_NX_CRC_4_Q : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_GEN_CRC_L_M(4),
      ADR1 => CRC_GEN_CRC_H_4_Q,
      ADR2 => CRC_NEW(4),
      O => CRC_GEN_UN5_NX_CRC(4)
    );
  CRC_GEN_UN5_NX_CRC_5_Q : X_LUT4
    generic map (
      INIT => X"95A6"
    )
    port map (
      ADR0 => CRC_GEN_G_3510,
      ADR1 => CRC_GEN_G_134,
      ADR2 => CRC_GEN_G_151,
      ADR3 => DATA_CC_M(5),
      O => CRC_GEN_UN5_NX_CRC(5)
    );
  CRC_GEN_UN5_NX_CRC_6_Q : X_LUT4
    generic map (
      INIT => X"596A"
    )
    port map (
      ADR0 => CRC_GEN_G_3526,
      ADR1 => CRC_GEN_G_134,
      ADR2 => CRC_GEN_CRC_L_6_Q,
      ADR3 => DATA_CC_M(6),
      O => CRC_GEN_UN5_NX_CRC(6)
    );
  CRC_GEN_UN5_NX_CRC_7_Q : X_LUT4
    generic map (
      INIT => X"95A6"
    )
    port map (
      ADR0 => CRC_GEN_G_3462,
      ADR1 => CRC_GEN_G_134,
      ADR2 => CRC_GEN_CRC16_OUT_1_0_AND2_I_7_Q,
      ADR3 => DATA_CC_M(7),
      O => CRC_GEN_UN5_NX_CRC(7)
    );
  CRC_GEN_UN5_NX_CRC_8_Q : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => CRC_GEN_G_169,
      ADR1 => CRC_GEN_G_3507,
      ADR2 => CRC_GEN_N_54,
      ADR3 => DATA_CC_M(28),
      O => CRC_GEN_UN5_NX_CRC(8)
    );
  CRC_GEN_UN5_NX_CRC_9_Q : X_LUT4
    generic map (
      INIT => X"95A6"
    )
    port map (
      ADR0 => CRC_GEN_G_3453,
      ADR1 => CRC_GEN_G_134,
      ADR2 => CRC_GEN_G_155,
      ADR3 => DATA_CC_M(9),
      O => CRC_GEN_UN5_NX_CRC(9)
    );
  CRC_GEN_UN5_NX_CRC_10_Q : X_LUT4
    generic map (
      INIT => X"596A"
    )
    port map (
      ADR0 => CRC_GEN_G_3490,
      ADR1 => CRC_GEN_G_134,
      ADR2 => CRC_GEN_CRC_L_10_Q,
      ADR3 => DATA_CC_M(10),
      O => CRC_GEN_UN5_NX_CRC(10)
    );
  CRC_GEN_UN5_NX_CRC_11_Q : X_LUT4
    generic map (
      INIT => X"596A"
    )
    port map (
      ADR0 => CRC_GEN_G_3475,
      ADR1 => CRC_GEN_G_134,
      ADR2 => CRC_GEN_CRC_L_11_Q,
      ADR3 => DATA_CC_M(11),
      O => CRC_GEN_UN5_NX_CRC(11)
    );
  CRC_GEN_UN5_NX_CRC_12_Q : X_LUT4
    generic map (
      INIT => X"596A"
    )
    port map (
      ADR0 => CRC_GEN_G_3495,
      ADR1 => CRC_GEN_G_134,
      ADR2 => CRC_GEN_CRC_L_12_Q,
      ADR3 => DATA_CC_M(12),
      O => CRC_GEN_UN5_NX_CRC(12)
    );
  CRC_GEN_UN5_NX_CRC_13_Q : X_LUT4
    generic map (
      INIT => X"596A"
    )
    port map (
      ADR0 => CRC_GEN_G_3484,
      ADR1 => CRC_GEN_G_134,
      ADR2 => CRC_GEN_CRC_L_13_Q,
      ADR3 => DATA_CC_M(13),
      O => CRC_GEN_UN5_NX_CRC(13)
    );
  CRC_GEN_UN5_NX_CRC_14_Q : X_LUT4
    generic map (
      INIT => X"95A6"
    )
    port map (
      ADR0 => CRC_GEN_G_3431,
      ADR1 => CRC_GEN_G_134,
      ADR2 => CRC_GEN_G_152,
      ADR3 => DATA_CC_M(14),
      O => CRC_GEN_UN5_NX_CRC(14)
    );
  CRC_GEN_UN5_NX_CRC_15_Q : X_LUT4
    generic map (
      INIT => X"95A6"
    )
    port map (
      ADR0 => CRC_GEN_G_3472,
      ADR1 => CRC_GEN_G_134,
      ADR2 => CRC_GEN_CRC16_OUT_1_0_AND2_I_15_Q,
      ADR3 => DATA_CC_M(15),
      O => CRC_GEN_UN5_NX_CRC(15)
    );
  CRC_GEN_UN5_NX_CRC_0_G_3435 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_NEW(0),
      ADR1 => CRC_GEN_CRC_H_0_Q,
      O => CRC_GEN_G_3435
    );
  CRC_GEN_UN5_NX_CRC_1_G_3439 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_NEW(1),
      ADR1 => CRC_GEN_N_52,
      ADR2 => DATA_CC_M(30),
      ADR3 => DATA_CC_M(19),
      O => CRC_GEN_G_3439
    );
  CRC_GEN_UN5_NX_CRC_2_G_3465 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_GEN_N_53,
      ADR1 => DATA_CC_M(17),
      ADR2 => DATA_CC_M(18),
      ADR3 => CRC_NEW(2),
      O => CRC_GEN_G_3465
    );
  CRC_GEN_UN5_NX_CRC_5_G_3510 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_GEN_CRC_H_0_Q,
      ADR1 => CRC_GEN_N_52,
      ADR2 => CRC_NEW(5),
      O => CRC_GEN_G_3510
    );
  CRC_GEN_UN5_NX_CRC_6_G_3525 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => DATA_CC_M(17),
      ADR1 => CRC_NEW(6),
      ADR2 => DATA_CC_M(25),
      ADR3 => DATA_CC_M(21),
      O => CRC_GEN_G_3525
    );
  CRC_GEN_UN5_NX_CRC_6_G_3526 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_GEN_G_3525,
      ADR1 => CRC_GEN_N_52,
      ADR2 => DATA_CC_M(30),
      ADR3 => DATA_CC_M(19),
      O => CRC_GEN_G_3526
    );
  CRC_GEN_UN5_NX_CRC_7_G_3462 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_GEN_N_53,
      ADR1 => CRC_GEN_N_54,
      ADR2 => DATA_CC_M(18),
      ADR3 => CRC_NEW(7),
      O => CRC_GEN_G_3462
    );
  CRC_GEN_UN5_NX_CRC_8_G_3507 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => DATA_CC_M(8),
      ADR1 => CRC_NEW(8),
      ADR2 => DATA_CC_M(23),
      ADR3 => DATA_CC_M(19),
      O => CRC_GEN_G_3507
    );
  CRC_GEN_UN5_NX_CRC_9_G_3453 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_GEN_CRC_H_4_Q,
      ADR1 => CRC_NEW(9),
      ADR2 => DATA_CC_M(18),
      ADR3 => DATA_CC_M(22),
      O => CRC_GEN_G_3453
    );
  CRC_GEN_UN5_NX_CRC_10_G_3490 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_GEN_N_52,
      ADR1 => DATA_CC_M(17),
      ADR2 => DATA_CC_M(21),
      ADR3 => CRC_NEW(10),
      O => CRC_GEN_G_3490
    );
  CRC_GEN_UN5_NX_CRC_11_G_3474 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => DATA_CC_M(20),
      ADR1 => CRC_NEW(11),
      ADR2 => DATA_CC_M(17),
      ADR3 => DATA_CC_M(16),
      O => CRC_GEN_G_3474
    );
  CRC_GEN_UN5_NX_CRC_11_G_3475 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_GEN_G_3474,
      ADR1 => DATA_CC_M(25),
      ADR2 => DATA_CC_M(21),
      O => CRC_GEN_G_3475
    );
  CRC_GEN_UN5_NX_CRC_12_G_3494 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_NEW(12),
      ADR1 => DATA_CC_M(27),
      ADR2 => DATA_CC_M(31),
      ADR3 => DATA_CC_M(24),
      O => CRC_GEN_G_3494
    );
  CRC_GEN_UN5_NX_CRC_12_G_3495 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_GEN_G_3494,
      ADR1 => DATA_CC_M(16),
      ADR2 => DATA_CC_M(23),
      O => CRC_GEN_G_3495
    );
  CRC_GEN_UN5_NX_CRC_13_G_3482 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_NEW(13),
      ADR1 => DATA_CC_M(23),
      O => CRC_GEN_G_3482
    );
  CRC_GEN_UN5_NX_CRC_13_G_3484 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_GEN_G_3482,
      ADR1 => DATA_CC_M(22),
      ADR2 => DATA_CC_M(26),
      ADR3 => DATA_CC_M(30),
      O => CRC_GEN_G_3484
    );
  CRC_GEN_UN5_NX_CRC_14_G_3431 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_GEN_N_53,
      ADR1 => DATA_CC_M(22),
      ADR2 => CRC_NEW(14),
      O => CRC_GEN_G_3431
    );
  CRC_GEN_UN5_NX_CRC_15_G_3472 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_GEN_N_50,
      ADR1 => DATA_CC_M(21),
      ADR2 => CRC_NEW(15),
      ADR3 => DATA_CC_M(28),
      O => CRC_GEN_G_3472
    );
  CRC_GEN_GEN_CRC_H_G_19 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => DATA_CC_M(20),
      ADR1 => DATA_CC_M(24),
      O => CRC_GEN_N_50
    );
  CRC_GEN_GEN_CRC_H_G_20 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => DATA_CC_M(27),
      ADR1 => DATA_CC_M(23),
      ADR2 => DATA_CC_M(19),
      O => CRC_GEN_GEN_CRC_H_N_51
    );
  CRC_GEN_GEN_CRC_H_G_21 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => DATA_CC_M(26),
      ADR1 => DATA_CC_M(18),
      ADR2 => DATA_CC_M(22),
      O => CRC_GEN_N_52
    );
  CRC_GEN_GEN_CRC_H_G_22 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => DATA_CC_M(29),
      ADR1 => DATA_CC_M(25),
      ADR2 => DATA_CC_M(21),
      O => CRC_GEN_N_53
    );
  CRC_GEN_GEN_CRC_H_G_23 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => DATA_CC_M(17),
      ADR1 => DATA_CC_M(16),
      ADR2 => DATA_CC_M(24),
      ADR3 => DATA_CC_M(20),
      O => CRC_GEN_N_54
    );
  CRC_GEN_GEN_CRC_H_G_24 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => DATA_CC_M(16),
      ADR1 => DATA_CC_M(27),
      ADR2 => DATA_CC_M(23),
      ADR3 => DATA_CC_M(19),
      O => CRC_GEN_CRC_H_4_Q
    );
  CRC_GEN_GEN_CRC_H_G_28 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_GEN_GEN_CRC_H_N_51,
      ADR1 => DATA_CC_M(20),
      ADR2 => DATA_CC_M(31),
      O => CRC_GEN_CRC_H_0_Q
    );
  CRC_GEN_GEN_CRC_L_G_28 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_GEN_G_139,
      ADR1 => DATA_CC_M(4),
      ADR2 => DATA_CC_M(15),
      O => CRC_GEN_CRC_L_0_Q
    );
  CRC_GEN_GEN_CRC_L_G_29 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_GEN_GEN_CRC_L_G_3351,
      ADR1 => DATA_CC_M(10),
      ADR2 => DATA_CC_M(2),
      ADR3 => DATA_CC_M(6),
      O => CRC_GEN_CRC_L_1_Q
    );
  CRC_GEN_GEN_CRC_L_G_29_G_3351 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => DATA_CC_M(3),
      ADR1 => DATA_CC_M(14),
      O => CRC_GEN_GEN_CRC_L_G_3351
    );
  CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_2_Q : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => CRC_GEN_G_140,
      ADR1 => DATA_CC_M(13),
      ADR2 => DATA_CC_M(1),
      ADR3 => DATA_CC_M(2),
      O => CRC_GEN_CRC_L_2_Q
    );
  CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_6_Q : X_LUT3
    generic map (
      INIT => X"69"
    )
    port map (
      ADR0 => CRC_GEN_CRC_L_1_Q,
      ADR1 => CRC_GEN_G_140,
      ADR2 => DATA_CC_M(1),
      O => CRC_GEN_CRC_L_6_Q
    );
  CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_7_Q : X_LUT3
    generic map (
      INIT => X"69"
    )
    port map (
      ADR0 => CRC_GEN_GEN_CRC_L_G_3318,
      ADR1 => CRC_GEN_G_140,
      ADR2 => DATA_CC_M(13),
      O => CRC_GEN_CRC16_OUT_1_0_AND2_I_7_Q
    );
  CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_10_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_GEN_GEN_CRC_L_G_3320,
      ADR1 => DATA_CC_M(10),
      ADR2 => DATA_CC_M(2),
      ADR3 => DATA_CC_M(6),
      O => CRC_GEN_CRC_L_10_Q
    );
  CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_11_Q : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => CRC_GEN_G_140,
      ADR1 => DATA_CC_M(4),
      ADR2 => DATA_CC_M(1),
      ADR3 => DATA_CC_M(0),
      O => CRC_GEN_CRC_L_11_Q
    );
  CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_12_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_GEN_GEN_CRC_L_G_3234,
      ADR1 => DATA_CC_M(8),
      ADR2 => DATA_CC_M(11),
      ADR3 => DATA_CC_M(15),
      O => CRC_GEN_CRC_L_12_Q
    );
  CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_13_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => DATA_CC_M(10),
      ADR1 => DATA_CC_M(14),
      ADR2 => DATA_CC_M(6),
      ADR3 => DATA_CC_M(7),
      O => CRC_GEN_CRC_L_13_Q
    );
  CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_15_Q : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => DATA_CC_M(5),
      ADR1 => DATA_CC_M(12),
      ADR2 => DATA_CC_M(4),
      ADR3 => DATA_CC_M(8),
      O => CRC_GEN_CRC16_OUT_1_0_AND2_I_15_Q
    );
  CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_7_G_3317 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => DATA_CC_M(2),
      ADR1 => DATA_CC_M(8),
      O => CRC_GEN_GEN_CRC_L_G_3317
    );
  CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_7_G_3318 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => CRC_GEN_GEN_CRC_L_G_3317,
      ADR1 => DATA_CC_M(4),
      ADR2 => DATA_CC_M(1),
      ADR3 => DATA_CC_M(0),
      O => CRC_GEN_GEN_CRC_L_G_3318
    );
  CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_10_G_3320 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => DATA_CC_M(5),
      ADR1 => DATA_CC_M(1),
      O => CRC_GEN_GEN_CRC_L_G_3320
    );
  CRC_GEN_GEN_CRC_L_CRC16_OUT_1_0_AND2_12_G_3234 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => DATA_CC_M(7),
      ADR1 => DATA_CC_M(0),
      O => CRC_GEN_GEN_CRC_L_G_3234
    );
  HEC_SET_D_OUT_MOD_0_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(0)
    );
  HEC_SET_D_OUT_MOD_1_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(1)
    );
  HEC_SET_D_OUT_MOD_2_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(2)
    );
  HEC_SET_D_OUT_MOD_3_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(3)
    );
  HEC_SET_D_OUT_MOD_4_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(4)
    );
  HEC_SET_D_OUT_MOD_5_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(5)
    );
  HEC_SET_D_OUT_MOD_6_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(6)
    );
  HEC_SET_D_OUT_MOD_7_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(7)
    );
  HEC_SET_D_OUT_MOD_8_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(8)
    );
  HEC_SET_D_OUT_MOD_9_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(9)
    );
  HEC_SET_D_OUT_MOD_10_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(10)
    );
  HEC_SET_D_OUT_MOD_11_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(11)
    );
  HEC_SET_D_OUT_MOD_12_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(12)
    );
  HEC_SET_D_OUT_MOD_13_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(13)
    );
  HEC_SET_D_OUT_MOD_14_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(14),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(14)
    );
  HEC_SET_D_OUT_MOD_15_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(15),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(15)
    );
  HEC_SET_D_OUT_MOD_16_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(16),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(16)
    );
  HEC_SET_D_OUT_MOD_17_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(17),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(17)
    );
  HEC_SET_D_OUT_MOD_18_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(18),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(18)
    );
  HEC_SET_D_OUT_MOD_19_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(19),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(19)
    );
  HEC_SET_D_OUT_MOD_20_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(20),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(20)
    );
  HEC_SET_D_OUT_MOD_21_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(21),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(21)
    );
  HEC_SET_D_OUT_MOD_22_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(22),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(22)
    );
  HEC_SET_D_OUT_MOD_23_Q : X_SFF
    port map (
      I => HEC_SET_DATA_IN(23),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => NGD2VHDL_OI4,
      O => D_OUT_MOD(23)
    );
  HEC_SET_D_OUT_MOD_24_Q : X_FF
    port map (
      I => HEC_SET_G_119,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(24)
    );
  HEC_SET_D_OUT_MOD_25_Q : X_FF
    port map (
      I => HEC_SET_G_120,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(25)
    );
  HEC_SET_D_OUT_MOD_26_Q : X_FF
    port map (
      I => HEC_SET_G_121,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(26)
    );
  HEC_SET_D_OUT_MOD_27_Q : X_FF
    port map (
      I => HEC_SET_G_122,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(27)
    );
  HEC_SET_D_OUT_MOD_28_Q : X_FF
    port map (
      I => HEC_SET_G_123,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(28)
    );
  HEC_SET_D_OUT_MOD_29_Q : X_FF
    port map (
      I => HEC_SET_G_124,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(29)
    );
  HEC_SET_D_OUT_MOD_30_Q : X_FF
    port map (
      I => HEC_SET_G_125,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(30)
    );
  HEC_SET_D_OUT_MOD_31_Q : X_FF
    port map (
      I => HEC_SET_G_126,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(31)
    );
  HEC_SET_G_16 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(12),
      ADR1 => HEC_SET_DATA_IN(28),
      ADR2 => HEC_SET_DATA_IN(6),
      O => HEC_SET_N_43
    );
  HEC_SET_G_19 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(13),
      ADR1 => HEC_SET_DATA_IN(15),
      ADR2 => HEC_SET_G_107,
      ADR3 => HEC_SET_DATA_IN(22),
      O => HEC_SET_N_46
    );
  HEC_SET_G_20 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => HEC_SET_G_108,
      ADR1 => HEC_SET_DATA_IN(23),
      ADR2 => HEC_SET_DATA_IN(14),
      ADR3 => HEC_SET_DATA_IN(30),
      O => HEC_SET_N_47
    );
  HEC_SET_G_107_401 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(29),
      ADR1 => HEC_SET_DATA_IN(17),
      O => HEC_SET_G_107
    );
  HEC_SET_G_108_402 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(18),
      ADR1 => HEC_SET_DATA_IN(16),
      O => HEC_SET_G_108
    );
  HEC_SET_G_110_403 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(21),
      ADR1 => HEC_SET_DATA_IN(12),
      ADR2 => HEC_SET_DATA_IN(28),
      ADR3 => HEC_SET_DATA_IN(6),
      O => HEC_SET_G_110
    );
  HEC_SET_G_113_404 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(9),
      ADR1 => HEC_SET_DATA_IN(1),
      O => HEC_SET_G_113
    );
  HEC_SET_G_116_405 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(31),
      ADR1 => HEC_SET_DATA_IN(4),
      O => HEC_SET_G_116
    );
  HEC_SET_G_117_406 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(25),
      ADR1 => HEC_SET_DATA_IN(2),
      O => HEC_SET_G_117
    );
  HEC_SET_G_118_407 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(19),
      ADR1 => HEC_SET_DATA_IN(8),
      O => HEC_SET_G_118
    );
  HEC_SET_G_119_408 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(24),
      ADR1 => HEC_SET_HEC(0),
      ADR2 => NGD2VHDL_OI4,
      O => HEC_SET_G_119
    );
  HEC_SET_G_120_409 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(25),
      ADR1 => HEC_SET_HEC(1),
      ADR2 => NGD2VHDL_OI4,
      O => HEC_SET_G_120
    );
  HEC_SET_G_121_410 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(26),
      ADR1 => HEC_SET_HEC(2),
      ADR2 => NGD2VHDL_OI4,
      O => HEC_SET_G_121
    );
  HEC_SET_G_122_411 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(27),
      ADR1 => HEC_SET_HEC(3),
      ADR2 => NGD2VHDL_OI4,
      O => HEC_SET_G_122
    );
  HEC_SET_G_123_412 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(28),
      ADR1 => HEC_SET_HEC(4),
      ADR2 => NGD2VHDL_OI4,
      O => HEC_SET_G_123
    );
  HEC_SET_G_124_413 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(29),
      ADR1 => HEC_SET_HEC(5),
      ADR2 => NGD2VHDL_OI4,
      O => HEC_SET_G_124
    );
  HEC_SET_G_125_414 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(30),
      ADR1 => HEC_SET_HEC(6),
      ADR2 => NGD2VHDL_OI4,
      O => HEC_SET_G_125
    );
  HEC_SET_G_126_415 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(31),
      ADR1 => HEC_SET_HEC(7),
      ADR2 => NGD2VHDL_OI4,
      O => HEC_SET_G_126
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_1_Q : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => HEC_SET_G_110,
      ADR1 => HEC_SET_G_3384,
      ADR2 => HEC_SET_N_46,
      ADR3 => HEC_SET_N_47,
      O => HEC_SET_HEC_CALC_1_Q
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_3_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => HEC_SET_N_47,
      ADR1 => HEC_SET_G_3362,
      ADR2 => HEC_SET_G_113,
      ADR3 => HEC_SET_G_117,
      O => HEC_SET_HEC_CALC_3_Q
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_5_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => HEC_SET_G_3300,
      ADR1 => HEC_SET_G_3296,
      ADR2 => HEC_SET_DATA_IN(13),
      ADR3 => HEC_SET_DATA_IN(15),
      O => HEC_SET_HEC_CALC_5_Q
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_7_Q : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => HEC_SET_N_46,
      ADR1 => HEC_SET_G_3373,
      ADR2 => HEC_SET_G_3372,
      O => HEC_SET_HEC_CALC_7_Q
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_0_G_3388 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(0),
      ADR1 => HEC_SET_DATA_IN(7),
      ADR2 => HEC_SET_DATA_IN(31),
      O => HEC_SET_G_3388
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_1_G_3384 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(0),
      ADR1 => HEC_SET_DATA_IN(24),
      ADR2 => HEC_SET_G_113,
      ADR3 => HEC_SET_DATA_IN(20),
      O => HEC_SET_G_3384
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_2_G_3376 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(1),
      ADR1 => HEC_SET_DATA_IN(10),
      ADR2 => HEC_SET_DATA_IN(8),
      O => HEC_SET_G_3376
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_2_G_3377 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(2),
      ADR1 => HEC_SET_DATA_IN(25),
      ADR2 => HEC_SET_DATA_IN(0),
      ADR3 => HEC_SET_DATA_IN(24),
      O => HEC_SET_G_3377
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_3_G_3360 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(29),
      ADR1 => HEC_SET_DATA_IN(26),
      ADR2 => HEC_SET_DATA_IN(3),
      ADR3 => HEC_SET_DATA_IN(13),
      O => HEC_SET_G_3360
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_3_G_3362 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => HEC_SET_G_3360,
      ADR1 => HEC_SET_DATA_IN(7),
      ADR2 => HEC_SET_DATA_IN(11),
      O => HEC_SET_G_3362
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_4_G_3288 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(17),
      ADR1 => HEC_SET_DATA_IN(24),
      ADR2 => HEC_SET_DATA_IN(27),
      ADR3 => HEC_SET_DATA_IN(2),
      O => HEC_SET_G_3288
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_4_G_3290 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(10),
      ADR1 => HEC_SET_DATA_IN(26),
      ADR2 => HEC_SET_DATA_IN(14),
      ADR3 => HEC_SET_DATA_IN(30),
      O => HEC_SET_G_3290
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_4_G_3291 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => HEC_SET_G_3288,
      ADR1 => HEC_SET_DATA_IN(3),
      ADR2 => HEC_SET_DATA_IN(12),
      ADR3 => HEC_SET_DATA_IN(15),
      O => HEC_SET_G_3291
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_5_G_3296 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(11),
      ADR1 => HEC_SET_DATA_IN(28),
      ADR2 => HEC_SET_DATA_IN(9),
      ADR3 => HEC_SET_DATA_IN(25),
      O => HEC_SET_G_3296
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_5_G_3298 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(20),
      ADR1 => HEC_SET_DATA_IN(27),
      ADR2 => HEC_SET_DATA_IN(16),
      ADR3 => HEC_SET_DATA_IN(18),
      O => HEC_SET_G_3298
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_5_G_3300 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => HEC_SET_G_3298,
      ADR1 => HEC_SET_G_116,
      ADR2 => HEC_SET_DATA_IN(3),
      ADR3 => HEC_SET_DATA_IN(5),
      O => HEC_SET_G_3300
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_6_G_3366 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(5),
      ADR1 => HEC_SET_DATA_IN(16),
      ADR2 => HEC_SET_DATA_IN(14),
      O => HEC_SET_G_3366
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_6_G_3367 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(4),
      ADR1 => HEC_SET_DATA_IN(19),
      ADR2 => HEC_SET_DATA_IN(10),
      ADR3 => HEC_SET_DATA_IN(26),
      O => HEC_SET_G_3367
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_7_G_3372 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(18),
      ADR1 => HEC_SET_DATA_IN(30),
      ADR2 => HEC_SET_DATA_IN(5),
      ADR3 => HEC_SET_DATA_IN(6),
      O => HEC_SET_G_3372
    );
  HEC_SET_HEC_PROC_V_HEC_1_0_AND2_7_G_3373 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => HEC_SET_DATA_IN(20),
      ADR1 => HEC_SET_DATA_IN(27),
      ADR2 => HEC_SET_DATA_IN(7),
      ADR3 => HEC_SET_DATA_IN(11),
      O => HEC_SET_G_3373
    );
  HEC_SET_HEC_PROC_V_HEC_1_I_0_Q_416 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => HEC_SET_N_47,
      ADR1 => HEC_SET_G_110,
      ADR2 => HEC_SET_G_3388,
      ADR3 => HEC_SET_G_118,
      O => HEC_SET_HEC_PROC_V_HEC_1_I_0_Q
    );
  HEC_SET_HEC_PROC_V_HEC_1_I_2_Q_417 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => HEC_SET_N_46,
      ADR1 => HEC_SET_N_43,
      ADR2 => HEC_SET_G_3377,
      ADR3 => HEC_SET_G_3376,
      O => HEC_SET_HEC_PROC_V_HEC_1_I_2_Q
    );
  HEC_SET_HEC_PROC_V_HEC_1_I_4_Q_418 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => HEC_SET_G_3291,
      ADR1 => HEC_SET_G_3290,
      ADR2 => HEC_SET_G_116,
      ADR3 => HEC_SET_G_118,
      O => HEC_SET_HEC_PROC_V_HEC_1_I_4_Q
    );
  HEC_SET_HEC_PROC_V_HEC_1_I_6_Q_419 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => HEC_SET_G_110,
      ADR1 => HEC_SET_G_3367,
      ADR2 => HEC_SET_G_3366,
      ADR3 => HEC_SET_G_107,
      O => HEC_SET_HEC_PROC_V_HEC_1_I_6_Q
    );
  HEC_SET_SOC_OUT_MOD : X_SFF
    port map (
      I => HEC_SET_SOC_IN,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => NGD2VHDL_OI4
    );
  HEC_SET_DATA_IN_0_Q : X_FF
    port map (
      I => DATA_M(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(0)
    );
  HEC_SET_DATA_IN_1_Q : X_FF
    port map (
      I => DATA_M(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(1)
    );
  HEC_SET_DATA_IN_2_Q : X_FF
    port map (
      I => DATA_M(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(2)
    );
  HEC_SET_DATA_IN_3_Q : X_FF
    port map (
      I => DATA_M(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(3)
    );
  HEC_SET_DATA_IN_4_Q : X_FF
    port map (
      I => DATA_M(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(4)
    );
  HEC_SET_DATA_IN_5_Q : X_FF
    port map (
      I => DATA_M(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(5)
    );
  HEC_SET_DATA_IN_6_Q : X_FF
    port map (
      I => DATA_M(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(6)
    );
  HEC_SET_DATA_IN_7_Q : X_FF
    port map (
      I => DATA_M(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(7)
    );
  HEC_SET_DATA_IN_8_Q : X_FF
    port map (
      I => DATA_M(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(8)
    );
  HEC_SET_DATA_IN_9_Q : X_FF
    port map (
      I => DATA_M(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(9)
    );
  HEC_SET_DATA_IN_10_Q : X_FF
    port map (
      I => DATA_M(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(10)
    );
  HEC_SET_DATA_IN_11_Q : X_FF
    port map (
      I => DATA_M(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(11)
    );
  HEC_SET_DATA_IN_12_Q : X_FF
    port map (
      I => DATA_M(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(12)
    );
  HEC_SET_DATA_IN_13_Q : X_FF
    port map (
      I => DATA_M(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(13)
    );
  HEC_SET_DATA_IN_14_Q : X_FF
    port map (
      I => DATA_M(14),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(14)
    );
  HEC_SET_DATA_IN_15_Q : X_FF
    port map (
      I => DATA_M(15),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(15)
    );
  HEC_SET_DATA_IN_16_Q : X_FF
    port map (
      I => DATA_M(16),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(16)
    );
  HEC_SET_DATA_IN_17_Q : X_FF
    port map (
      I => DATA_M(17),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(17)
    );
  HEC_SET_DATA_IN_18_Q : X_FF
    port map (
      I => DATA_M(18),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(18)
    );
  HEC_SET_DATA_IN_19_Q : X_FF
    port map (
      I => DATA_M(19),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(19)
    );
  HEC_SET_DATA_IN_20_Q : X_FF
    port map (
      I => DATA_M(20),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(20)
    );
  HEC_SET_DATA_IN_21_Q : X_FF
    port map (
      I => DATA_M(21),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(21)
    );
  HEC_SET_DATA_IN_22_Q : X_FF
    port map (
      I => DATA_M(22),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(22)
    );
  HEC_SET_DATA_IN_23_Q : X_FF
    port map (
      I => DATA_M(23),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(23)
    );
  HEC_SET_DATA_IN_24_Q : X_FF
    port map (
      I => DATA_M(24),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(24)
    );
  HEC_SET_DATA_IN_25_Q : X_FF
    port map (
      I => DATA_M(25),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(25)
    );
  HEC_SET_DATA_IN_26_Q : X_FF
    port map (
      I => DATA_M(26),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(26)
    );
  HEC_SET_DATA_IN_27_Q : X_FF
    port map (
      I => DATA_M(27),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(27)
    );
  HEC_SET_DATA_IN_28_Q : X_FF
    port map (
      I => DATA_M(28),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(28)
    );
  HEC_SET_DATA_IN_29_Q : X_FF
    port map (
      I => DATA_M(29),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(29)
    );
  HEC_SET_DATA_IN_30_Q : X_FF
    port map (
      I => DATA_M(30),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(30)
    );
  HEC_SET_DATA_IN_31_Q : X_FF
    port map (
      I => DATA_M(31),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_DATA_IN(31)
    );
  HEC_SET_HEC_0_Q : X_FF
    port map (
      I => HEC_SET_HEC_PROC_V_HEC_1_I_0_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_HEC(0)
    );
  HEC_SET_HEC_1_Q : X_FF
    port map (
      I => HEC_SET_HEC_CALC_1_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_HEC(1)
    );
  HEC_SET_HEC_2_Q : X_FF
    port map (
      I => HEC_SET_HEC_PROC_V_HEC_1_I_2_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_HEC(2)
    );
  HEC_SET_HEC_3_Q : X_FF
    port map (
      I => HEC_SET_HEC_CALC_3_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_HEC(3)
    );
  HEC_SET_HEC_4_Q : X_FF
    port map (
      I => HEC_SET_HEC_PROC_V_HEC_1_I_4_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_HEC(4)
    );
  HEC_SET_HEC_5_Q : X_FF
    port map (
      I => HEC_SET_HEC_CALC_5_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_HEC(5)
    );
  HEC_SET_HEC_6_Q : X_FF
    port map (
      I => HEC_SET_HEC_PROC_V_HEC_1_I_6_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_HEC(6)
    );
  HEC_SET_HEC_7_Q : X_FF
    port map (
      I => HEC_SET_HEC_CALC_7_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => HEC_SET_HEC(7)
    );
  HEC_SET_SOC_IN_420 : X_SFF
    port map (
      I => SOC_M,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => HEC_SET_SOC_IN
    );
  STATE00_H_N_1816_I_421 : X_LUT4
    generic map (
      INIT => X"CEEE"
    )
    port map (
      ADR0 => STATE00(2),
      ADR1 => STATE00(3),
      ADR2 => N_3550,
      ADR3 => N_894_1,
      O => STATE00_H_N_1816_I
    );
  STATE00_H_N_3006_I_422 : X_LUT4
    generic map (
      INIT => X"EEAE"
    )
    port map (
      ADR0 => STATE00(0),
      ADR1 => STATE00_H_STATE00_0(6),
      ADR2 => STATE00_H_G_3392,
      ADR3 => N_3299,
      O => STATE00_H_N_3006_I
    );
  STATE00_H_STATE00_0_Q : X_SFF
    port map (
      I => STATE00(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE00(0)
    );
  STATE00_H_STATE00_1_Q : X_SFF
    port map (
      I => G_3662,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE00(1)
    );
  STATE00_H_STATE00_2_Q : X_SFF
    port map (
      I => STATE00_H_N_1816_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE00(2)
    );
  STATE00_H_STATE00_3_Q : X_SFF
    port map (
      I => G_3663,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE00(3)
    );
  STATE00_H_STATE00_4_Q : X_SFF
    port map (
      I => STATE00(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE00(4)
    );
  STATE00_H_STATE00_5_Q : X_SFF
    port map (
      I => STATE00_H_STATE00_NS(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE00(5)
    );
  STATE00_H_STATE00_6_Q : X_SFF
    port map (
      I => STATE00_H_N_3006_I,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => STATE00_H_STATE00_0(6)
    );
  STATE00_H_STATE00_FAST_1_Q : X_SFF
    port map (
      I => G_3662,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE00_FAST(1)
    );
  STATE00_H_STATE00_NS_0_IV_0_0_1_Q : X_LUT4
    generic map (
      INIT => X"2F22"
    )
    port map (
      ADR0 => STATE00_H_G_3392,
      ADR1 => N_3299,
      ADR2 => N_3343,
      ADR3 => STATE00(4),
      O => STATE00_H_STATE00_NS(1)
    );
  STATE00_H_STATE00_NS_0_IV_0_0_AND2_0_1_G_3392 : X_LUT4
    generic map (
      INIT => X"4000"
    )
    port map (
      ADR0 => CCOPCODE(1),
      ADR1 => STATE00_H_STATE00_0(6),
      ADR2 => CRC_OK,
      ADR3 => STATE(0),
      O => STATE00_H_G_3392
    );
  STATE02_H_N_1410_I_423 : X_LUT4
    generic map (
      INIT => X"0222"
    )
    port map (
      ADR0 => STATE02_H_STATE02(0),
      ADR1 => STATE02_H_STATE02(1),
      ADR2 => STATE02_H_G_3442,
      ADR3 => N_3428,
      O => STATE02_H_N_1410_I
    );
  STATE02_H_STATE02_0_Q : X_SFF
    port map (
      I => STATE02_H_STATE02_NS(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE02_H_STATE02(0)
    );
  STATE02_H_STATE02_1_Q : X_SFF
    port map (
      I => STATE02_H_N_1410_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE02_H_STATE02(1)
    );
  STATE02_H_STATE02_NS_0_IV_0_0_0_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => STATE02_H_N_2978,
      ADR1 => N_3300,
      ADR2 => STATE02_H_G_3458,
      ADR3 => N_3428,
      O => STATE02_H_STATE02_NS(0)
    );
  STATE02_H_STATE02_NS_0_IV_0_0_AND2_0_Q : X_LUT4
    generic map (
      INIT => X"4044"
    )
    port map (
      ADR0 => STATE02_H_STATE02(0),
      ADR1 => STATE02_H_STATE02(1),
      ADR2 => G_3355,
      ADR3 => GENCOUNT(2),
      O => STATE02_H_N_2978
    );
  STATE02_H_STATE02_NS_0_IV_0_0_AND2_0_0_G_3456 : X_LUT4
    generic map (
      INIT => X"0010"
    )
    port map (
      ADR0 => STATE04(4),
      ADR1 => STATE02_H_STATE02(0),
      ADR2 => STATE04(6),
      ADR3 => STATE02_H_STATE02(1),
      O => STATE02_H_G_3456
    );
  STATE02_H_STATE02_NS_0_IV_0_0_AND2_0_0_G_3458 : X_LUT4
    generic map (
      INIT => X"0008"
    )
    port map (
      ADR0 => N_3118,
      ADR1 => STATE02_H_G_3456,
      ADR2 => STATE04(8),
      ADR3 => STATE04(0),
      O => STATE02_H_G_3458
    );
  STATE02_H_STATE02_TR5_I_0_AND2_G_3440 : X_LUT2
    generic map (
      INIT => X"1"
    )
    port map (
      ADR0 => STATE04(6),
      ADR1 => STATE04(4),
      O => STATE02_H_G_3440
    );
  STATE02_H_STATE02_TR5_I_0_AND2_G_3442 : X_LUT4
    generic map (
      INIT => X"0008"
    )
    port map (
      ADR0 => N_3118,
      ADR1 => STATE02_H_G_3440,
      ADR2 => STATE04(8),
      ADR3 => STATE04(0),
      O => STATE02_H_G_3442
    );
  STATE04_H_N_1223_I_424 : X_LUT4
    generic map (
      INIT => X"4555"
    )
    port map (
      ADR0 => N_3428,
      ADR1 => STATE04(5),
      ADR2 => STATE04_H_G_3352,
      ADR3 => GENCOUNT(2),
      O => STATE04_H_N_1223_I
    );
  STATE04_H_N_2100_I_425 : X_LUT4
    generic map (
      INIT => X"F4FC"
    )
    port map (
      ADR0 => N_3455,
      ADR1 => STATE04(8),
      ADR2 => STATE04(0),
      ADR3 => N_2855,
      O => STATE04_H_N_2100_I
    );
  STATE04_H_STATE04_0_Q : X_SFF
    port map (
      I => STATE04(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE04(0)
    );
  STATE04_H_STATE04_1_Q : X_SFF
    port map (
      I => STATE04(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE04(1)
    );
  STATE04_H_STATE04_2_Q : X_SFF
    port map (
      I => G_3660,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE04(2)
    );
  STATE04_H_STATE04_3_Q : X_SFF
    port map (
      I => STATE04(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE04(3)
    );
  STATE04_H_STATE04_4_Q : X_SFF
    port map (
      I => STATE04_H_N_1223_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE04(4)
    );
  STATE04_H_STATE04_5_Q : X_SFF
    port map (
      I => G_3661,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE04(5)
    );
  STATE04_H_STATE04_6_Q : X_SFF
    port map (
      I => STATE04(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE04(6)
    );
  STATE04_H_STATE04_7_Q : X_SFF
    port map (
      I => STATE04_H_STATE04_NS(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE04(7)
    );
  STATE04_H_STATE04_8_Q : X_SFF
    port map (
      I => STATE04_H_N_2100_I,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => STATE04(8)
    );
  STATE04_H_STATE04_FAST_5_Q : X_SFF
    port map (
      I => G_3661,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE04_FAST(5)
    );
  STATE04_H_STATE04_NS_0_IV_0_0_1_Q : X_LUT4
    generic map (
      INIT => X"EAAA"
    )
    port map (
      ADR0 => STATE04_H_N_2981,
      ADR1 => N_3455,
      ADR2 => N_2855,
      ADR3 => STATE04(8),
      O => STATE04_H_STATE04_NS(1)
    );
  STATE04_H_STATE04_NS_0_IV_0_0_AND2_0_1_Q : X_LUT2
    generic map (
      INIT => X"2"
    )
    port map (
      ADR0 => STATE04(6),
      ADR1 => N_3152,
      O => STATE04_H_N_2981
    );
  STATE04_H_STATE04_NS_0_IV_I_0_AND2_4_Q : X_LUT2
    generic map (
      INIT => X"1"
    )
    port map (
      ADR0 => STATE04(5),
      ADR1 => STATE04(3),
      O => N_3428
    );
  STATE04_H_STATE04_NS_0_IV_I_0_AND2_0_4_G_3352 : X_LUT3
    generic map (
      INIT => X"40"
    )
    port map (
      ADR0 => N_894_1,
      ADR1 => GENCOUNT(1),
      ADR2 => GENCOUNT(0),
      O => STATE04_H_G_3352
    );
  STATE_H_N_2547_I_426 : X_LUT4
    generic map (
      INIT => X"CEEE"
    )
    port map (
      ADR0 => STATE(2),
      ADR1 => STATE(3),
      ADR2 => N_2580,
      ADR3 => N_2584,
      O => STATE_H_N_2547_I
    );
  STATE_H_N_3430_I_427 : X_LUT3
    generic map (
      INIT => X"AE"
    )
    port map (
      ADR0 => STATE(0),
      ADR1 => STATE_H_STATE(5),
      ADR2 => N_3554,
      O => STATE_H_N_3430_I
    );
  STATE_H_STATE_0_Q : X_SFF
    port map (
      I => STATE(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE(0)
    );
  STATE_H_STATE_1_Q : X_SFF
    port map (
      I => G_3659,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE(1)
    );
  STATE_H_STATE_2_Q : X_SFF
    port map (
      I => STATE_H_N_2547_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE(2)
    );
  STATE_H_STATE_3_Q : X_SFF
    port map (
      I => STATE_H_STATE_0(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE(3)
    );
  STATE_H_STATE_4_Q : X_SFF
    port map (
      I => G_3658,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => STATE_H_STATE_0(4)
    );
  STATE_H_STATE_5_Q : X_SFF
    port map (
      I => STATE_H_N_3430_I,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => STATE_H_STATE(5)
    );
  VCC_428 : X_ONE
    port map (
      O => VCC
    );
  ROC_NGD2VHDL : ROC port map (O => GSR);
end STRUCTURE;

