-- Xilinx Vhdl produced by program ngd2vhdl D.27
-- Command: -w frameproc.ngd frameproc_sim.vhd 
-- Options: -w -ti UUT 
-- Date: Wed Aug 15 18:27:14 2001 
-- Input file: frameproc.ngd
-- Output file: frameproc_sim.vhd
-- Tmp file: c:/DOCUME~1/hwf1/LOCALS~1/Temp/xil_42
-- Design name: FrameProc
-- Xilinx: C:/Xilinx
-- # of Entities: 1
-- Device: xcv1000e-7-fg680

-- The output of ngd2vhdl is a simulation model. This file cannot be synthesized,
-- or used in any other manner other than simulation. This netlist uses simulation
-- primitives which may not represent the true implementation of the device, however
-- the netlist is functionally correct. Do not modify this file.

-- Model for  ROC (Reset-On-Configuration) Cell
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.VITAL_Timing.all;
entity ROC is
  generic (InstancePath: STRING := "*";
           WIDTH : Time := 100 ns);
  port(O : out std_ulogic := '1') ;
  attribute VITAL_LEVEL0 of ROC : entity is TRUE;
end ROC;

architecture ROC_V of ROC is
attribute VITAL_LEVEL0 of ROC_V : architecture is TRUE;
begin
  ONE_SHOT : process
  begin
    if (WIDTH <= 0 ns) then
       assert FALSE report
       "*** Error: a positive value of WIDTH must be specified ***"
       severity failure;
    else
       wait for WIDTH;
       O <= '0';
    end if;
    wait;
  end process ONE_SHOT;
end ROC_V;

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library SIMPRIM;
use SIMPRIM.VCOMPONENTS.ALL;
use SIMPRIM.VPACKAGE.ALL;
entity FRAMEPROC is
  port (
    TCA_OUT_MOD : in STD_LOGIC := 'X'; 
    TCA_OUT_APPL : in STD_LOGIC := 'X'; 
    TCA_MOD_IN : out STD_LOGIC; 
    TCA_APPL_IN : out STD_LOGIC; 
    SOF_OUT_APPL : out STD_LOGIC; 
    SOF_APPL_IN : in STD_LOGIC := 'X'; 
    SOC_OUT_MOD : out STD_LOGIC; 
    SOC_MOD_IN : in STD_LOGIC := 'X'; 
    RESET_L : in STD_LOGIC := 'X'; 
    READY_L : out STD_LOGIC; 
    EOF_OUT_APPL : out STD_LOGIC; 
    EOF_APPL_IN : in STD_LOGIC := 'X'; 
    ENABLE_L : in STD_LOGIC := 'X'; 
    DATAEN_OUT_APPL : out STD_LOGIC; 
    DATAEN_APPL_IN : in STD_LOGIC := 'X'; 
    CLK : in STD_LOGIC := 'X'; 
    D_OUT_MOD : out STD_LOGIC_VECTOR ( 31 downto 0 ); 
    D_OUT_APPL : out STD_LOGIC_VECTOR ( 31 downto 0 ); 
    D_MOD_IN : in STD_LOGIC_VECTOR ( 31 downto 0 ); 
    D_APPL_IN : in STD_LOGIC_VECTOR ( 31 downto 0 ) 
  );
end FRAMEPROC;

architecture STRUCTURE of FRAMEPROC is
  component ROC
    generic (InstancePath: STRING := "*";
             WIDTH : Time := 100 ns);
    port (O : out STD_ULOGIC := '1');
  end component;
  signal SEGMENT_STATE_1_I_I_AND2_Q_O2 : STD_LOGIC; 
  signal G_842 : STD_LOGIC; 
  signal G_27_0_AND2 : STD_LOGIC; 
  signal G_795 : STD_LOGIC; 
  signal SEGMENT_G_767_Q_O2 : STD_LOGIC; 
  signal G_18_0_AND2 : STD_LOGIC; 
  signal SEGMENT_N_146_1 : STD_LOGIC; 
  signal G_807 : STD_LOGIC; 
  signal SEGMENT_STATE_2_Q : STD_LOGIC; 
  signal SEGMENT_STATE_11_Q : STD_LOGIC; 
  signal SEGMENT_STATE_3_Q : STD_LOGIC; 
  signal SEGMENT_STATE_0_Q : STD_LOGIC; 
  signal G_752 : STD_LOGIC; 
  signal G_1752 : STD_LOGIC; 
  signal G_1774 : STD_LOGIC; 
  signal RESET_L_1 : STD_LOGIC; 
  signal G_839 : STD_LOGIC; 
  signal G_785 : STD_LOGIC; 
  signal N_1005_I : STD_LOGIC; 
  signal N_1005_1 : STD_LOGIC; 
  signal G_814 : STD_LOGIC; 
  signal G_776 : STD_LOGIC; 
  signal G_838 : STD_LOGIC; 
  signal G_766 : STD_LOGIC; 
  signal G_831 : STD_LOGIC; 
  signal G_813 : STD_LOGIC; 
  signal G_811 : STD_LOGIC; 
  signal G_753 : STD_LOGIC; 
  signal G_780 : STD_LOGIC; 
  signal G_777 : STD_LOGIC; 
  signal G_759 : STD_LOGIC; 
  signal G_778 : STD_LOGIC; 
  signal G_1777 : STD_LOGIC; 
  signal G_757 : STD_LOGIC; 
  signal G_806 : STD_LOGIC; 
  signal G_818 : STD_LOGIC; 
  signal G_834 : STD_LOGIC; 
  signal G_833 : STD_LOGIC; 
  signal G_773 : STD_LOGIC; 
  signal G_779 : STD_LOGIC; 
  signal DATA_ENABLE_STATE_OUT_0_Q : STD_LOGIC; 
  signal DATA_ENABLE_STATE_OUT_1_Q : STD_LOGIC; 
  signal G_5 : STD_LOGIC; 
  signal DATA_ENABLE_STATE_OUT_4_Q : STD_LOGIC; 
  signal G_808 : STD_LOGIC; 
  signal G_809 : STD_LOGIC; 
  signal G_822 : STD_LOGIC; 
  signal G_820 : STD_LOGIC; 
  signal G_784 : STD_LOGIC; 
  signal G_824 : STD_LOGIC; 
  signal G_827 : STD_LOGIC; 
  signal G_775 : STD_LOGIC; 
  signal G_823 : STD_LOGIC; 
  signal G_835 : STD_LOGIC; 
  signal G_836 : STD_LOGIC; 
  signal G_828 : STD_LOGIC; 
  signal G_760 : STD_LOGIC; 
  signal G_821 : STD_LOGIC; 
  signal G_819 : STD_LOGIC; 
  signal G_783 : STD_LOGIC; 
  signal G_816 : STD_LOGIC; 
  signal G_812 : STD_LOGIC; 
  signal G_810 : STD_LOGIC; 
  signal G_837 : STD_LOGIC; 
  signal G_770 : STD_LOGIC; 
  signal G_769 : STD_LOGIC; 
  signal G_832 : STD_LOGIC; 
  signal G_765 : STD_LOGIC; 
  signal G_829 : STD_LOGIC; 
  signal G_761 : STD_LOGIC; 
  signal G_762 : STD_LOGIC; 
  signal G_758 : STD_LOGIC; 
  signal G_756 : STD_LOGIC; 
  signal G_755 : STD_LOGIC; 
  signal G_754 : STD_LOGIC; 
  signal G_781 : STD_LOGIC; 
  signal G_817 : STD_LOGIC; 
  signal G_815 : STD_LOGIC; 
  signal G_763 : STD_LOGIC; 
  signal G_774 : STD_LOGIC; 
  signal G_767 : STD_LOGIC; 
  signal G_764 : STD_LOGIC; 
  signal G_782 : STD_LOGIC; 
  signal G_768 : STD_LOGIC; 
  signal G_830 : STD_LOGIC; 
  signal DATA_ENABLE_N_1949_I : STD_LOGIC; 
  signal DATA_ENABLE_STATE_OUT_2_Q : STD_LOGIC; 
  signal DATA_ENABLE_STATE_OUT_3_Q : STD_LOGIC; 
  signal G_15_FAST : STD_LOGIC; 
  signal DATA_ENABLE_SOC_IN : STD_LOGIC; 
  signal DATA_ENABLE_N_2366_REP1 : STD_LOGIC; 
  signal SEGMENT_G_844_Q_O0 : STD_LOGIC; 
  signal DATA_ENABLE_LC_FLAG : STD_LOGIC; 
  signal DATA_ENABLE_N_2366 : STD_LOGIC; 
  signal DATA_ENABLE_N_2269 : STD_LOGIC; 
  signal G_1828 : STD_LOGIC; 
  signal DATA_ENABLE_STATE_OUT_6_Q : STD_LOGIC; 
  signal DATA_ENABLE_N_971_1 : STD_LOGIC; 
  signal DATA_ENABLE_STATE_IN_5_Q : STD_LOGIC; 
  signal DATA_ENABLE_UN2_CWCOUNT_IN_1_C2 : STD_LOGIC; 
  signal G_761_0 : STD_LOGIC; 
  signal CRC_OUT_N_63_1 : STD_LOGIC; 
  signal CRC_IN_N_63_1 : STD_LOGIC; 
  signal SEGMENT_STATE_9_Q : STD_LOGIC; 
  signal RESET_L_I : STD_LOGIC; 
  signal RESET_L_0 : STD_LOGIC; 
  signal G_803 : STD_LOGIC; 
  signal G_826 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_UN4_COUNT_C2 : STD_LOGIC; 
  signal SEGMENT_UN16_CELL_COUNT_C2 : STD_LOGIC; 
  signal N_996_1 : STD_LOGIC; 
  signal G_802 : STD_LOGIC; 
  signal CRC_SEL_UN11_RES_0_AND3 : STD_LOGIC; 
  signal G_800 : STD_LOGIC; 
  signal G_1829 : STD_LOGIC; 
  signal G_804 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_UN4_COUNT_C2 : STD_LOGIC; 
  signal CRC_SEL_UN11_RES_0_AND3_0 : STD_LOGIC; 
  signal G_792 : STD_LOGIC; 
  signal G_796 : STD_LOGIC; 
  signal DATA_ENABLE_UN2_CWCOUNT_IN_1_C3 : STD_LOGIC; 
  signal G_772 : STD_LOGIC; 
  signal G_786 : STD_LOGIC; 
  signal G_825 : STD_LOGIC; 
  signal G_787 : STD_LOGIC; 
  signal G_788 : STD_LOGIC; 
  signal N_994_I : STD_LOGIC; 
  signal G_840 : STD_LOGIC; 
  signal G_790 : STD_LOGIC; 
  signal G_791 : STD_LOGIC; 
  signal G_789 : STD_LOGIC; 
  signal G_771 : STD_LOGIC; 
  signal N_999_I : STD_LOGIC; 
  signal G_801 : STD_LOGIC; 
  signal G_841 : STD_LOGIC; 
  signal DATA_ENABLE_STATE_IN_7_Q : STD_LOGIC; 
  signal DATA_ENABLE_STATE_IN_3_Q : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_DATAEN_BUF : STD_LOGIC; 
  signal DATA_ENABLE_STATE_IN_0_Q : STD_LOGIC; 
  signal SOC2 : STD_LOGIC; 
  signal NGD2VHDL_OI6 : STD_LOGIC; 
  signal DATA_ENABLE_STATE_IN_6_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_DATAEN_BUF : STD_LOGIC; 
  signal G_797 : STD_LOGIC; 
  signal G_793 : STD_LOGIC; 
  signal ENABLE_IN : STD_LOGIC; 
  signal SOC8 : STD_LOGIC; 
  signal NGD2VHDL_IO1 : STD_LOGIC; 
  signal NGD2VHDL_IO0 : STD_LOGIC; 
  signal VCC_INT : STD_LOGIC; 
  signal GND_INT : STD_LOGIC; 
  signal GSR : STD_LOGIC; 
  signal CRC_IN_G_249 : STD_LOGIC; 
  signal CRC_IN_G_34 : STD_LOGIC; 
  signal CRC_IN_G_103 : STD_LOGIC; 
  signal CRC_IN_IS_LASTCELL : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_N_1_I : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_SOC_WIRE : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_PREXORED_6_Q : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_PREXORED_13_Q : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_PREXORED_4_Q : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_PREXORED_14_Q : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_PREXORED_21_Q : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_PREXORED_3_Q : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_PREXORED_23_Q : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_PREXORED_22_Q : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_PREXORED_20_Q : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_PREXORED_2_Q : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_PREXORED_26_Q : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_PREXORED_0_Q : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_PREXORED_24_Q : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_PREXORED_9_Q : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_0 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_9 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_3 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_6 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q011_1 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11_3 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11_0 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_1 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q100_2 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q100 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11_1 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_4 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_2 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_2 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_1 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_2 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q011_0 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_1 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_0 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_G_432 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_5 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q000_0 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11_2 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q000 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_4 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_2 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_5 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q00 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_0 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_7 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_4 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_G_56 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_1 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_8 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_0 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_G_578 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_6 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_3 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_3 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q100_0 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q100_1 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q011 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_3 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_412 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_418 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_415 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_G_216 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_G_218 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_G_352 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_G_357 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_G_355 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_121 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_114 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_120 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_116 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_115 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_295 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_289 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_291 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_294 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_288 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_G_568 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_G_569 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_G_573 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_258 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_262 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_261 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_475 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_477 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_472 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_471 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_G_564 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_G_561 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_G_565 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_82 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_80 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_81 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_87 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_G_576 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_G_580 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_341 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_351 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_348 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_342 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_343 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_344 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_142 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_145 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_149 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_144 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_148 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_143 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_298 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_302 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_304 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_299 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_230 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_233 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_228 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_227 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_G_270 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_G_268 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_G_265 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_201 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_197 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_204 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_199 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_202 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_174 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_167 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_171 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_173 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_169 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_446 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_445 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_449 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_G_187 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_G_186 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_G_189 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_G_110 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_G_108 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_G_112 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ_G_526 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ_G_528 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_493 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_492 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_494 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_497 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_G_506 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_G_507 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_G_508 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ_G_420 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ_G_423 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ_G_499 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ_G_502 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_G_456 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_G_451 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_G_453 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_G_318 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_G_314 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_G_320 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_G_437 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_G_430 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_G_434 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_491 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_489 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_487 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_486 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_G_234 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_G_238 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_G_240 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_G_425 : STD_LOGIC; 
  signal CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_G_428 : STD_LOGIC; 
  signal CRC_OUT_N_143_I : STD_LOGIC; 
  signal CRC_OUT_G_249_0 : STD_LOGIC; 
  signal CRC_OUT_G_36 : STD_LOGIC; 
  signal CRC_OUT_IS_LASTCELL : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_N_1_I : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_SOC_WIRE : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_8_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_26_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_5_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_6_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_2_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_13_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_28_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_29_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_10_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_11_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_17_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_19_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_21_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_23_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_7_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_4_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_27_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_22_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_24_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_1_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_PREXORED_9_Q : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_G_406 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_1 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q00_0 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11_0 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_4 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_5 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_7 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11_3 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_6 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_2 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_0 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_0 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q000_0 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_3 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q100_2 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_0 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_G_584 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q100_0 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q00 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q0000 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_2 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_2 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_1 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q100_1 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_6 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_5 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q100 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_4 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11_2 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q011 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_4 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q010_1 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_1 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11_1 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_3 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q011_0 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_5 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q000 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_3 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q010 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q010_0 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_400 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_396 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_402 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_399 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_G_224 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_G_220 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_G_222 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_G_360 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_G_365 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_134 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_136 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_139 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_138 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_132 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_273 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_275 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_279 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_274 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_272 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_277 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_G_552 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_G_549 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_G_551 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_242 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_247 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_243 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_246 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_484 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_479 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_478 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_G_557 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_G_554 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_G_558 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_93 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_95 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_91 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_90 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_G_582 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_G_586 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_331 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_335 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_330 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_337 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_333 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_339 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_160 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_166 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_161 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_158 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_159 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_310 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_306 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_307 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_312 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_255 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_251 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_254 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_G_285 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_G_281 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_G_286 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_180 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_183 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_178 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_181 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_129 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_124 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_130 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_125 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_468 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_466 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_465 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_469 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_G_193 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_G_192 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_G_195 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_G_153 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_G_151 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_G_155 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ_G_543 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ_G_544 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_540 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_537 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_536 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_G_511 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_G_516 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_G_513 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ_G_391 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ_G_394 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ_G_530 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ_G_533 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_G_463 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_G_459 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_G_460 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_G_322 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_G_326 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_G_328 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_G_409 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_Q_AM : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_G_408 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_Q_BM : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_522 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_524 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_519 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_G_212 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_G_210 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_G_208 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_G_440 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_G_438 : STD_LOGIC; 
  signal CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_G_441 : STD_LOGIC; 
  signal DATA_ENABLE_G_685 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_27_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_28_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_30_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_27_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_7_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_689 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_28_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_25_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_26_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_7_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_29_Q : STD_LOGIC; 
  signal DATA_ENABLE_N_983_1 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_25_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_26_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_30_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_28_Q : STD_LOGIC; 
  signal DATA_ENABLE_N_983_1_1 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_29_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_30_Q : STD_LOGIC; 
  signal DATA_ENABLE_N_2077 : STD_LOGIC; 
  signal DATA_ENABLE_G_677 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_25_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_741 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_26_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_629 : STD_LOGIC; 
  signal DATA_ENABLE_G_673 : STD_LOGIC; 
  signal DATA_ENABLE_G_625 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_27_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_29_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_28_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_25_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_26_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_30_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_29_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_25_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_29_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_7_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_26_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_7_Q : STD_LOGIC; 
  signal DATA_ENABLE_N_983_1_0 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_27_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_27_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_30_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_28_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_4_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_10_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_13_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_18_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_2_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_3_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_0_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_5_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_15_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_737 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_16_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_8_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_12_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_24_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_14_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_16_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_15_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_23_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_16_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_669 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_19_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_20_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_17_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_21_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_22_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_19_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_9_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_20_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_13_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_11_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_6_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_23_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_745 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_9_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_12_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_20_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_11_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_11_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_653 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_12_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_701 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_0_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_17_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_2_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_3_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_705 : STD_LOGIC; 
  signal DATA_ENABLE_G_641 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_21_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_4_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_9_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_23_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_713 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_5_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_22_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_13_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_681 : STD_LOGIC; 
  signal DATA_ENABLE_G_633 : STD_LOGIC; 
  signal DATA_ENABLE_G_717 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_6_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_14_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_733 : STD_LOGIC; 
  signal DATA_ENABLE_G_637 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_14_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_721 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_18_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_657 : STD_LOGIC; 
  signal DATA_ENABLE_G_649 : STD_LOGIC; 
  signal DATA_ENABLE_G_725 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_6_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_709 : STD_LOGIC; 
  signal DATA_ENABLE_G_697 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_21_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_24_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_5_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_22_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_729 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_0_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_24_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_665 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_18_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_8_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_3_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_4_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_2_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_17_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_19_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_8_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_10_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_10_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_15_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_645 : STD_LOGIC; 
  signal DATA_ENABLE_G_661 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_8_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_11_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_13_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_9_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_16_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_12_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_19_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_18_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_0_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_10_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_17_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_24_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_3_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_4_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_22_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_6_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_20_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_21_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_15_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_14_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_5_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_23_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_2_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_0_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_7_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_3_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_4_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_10_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_15_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_20_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_16_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_15_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_25_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_16_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_2_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_26_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_2_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_13_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_11_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_10_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_14_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_9_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_5_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_6_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_9_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_8_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_5_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_29_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_23_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_11_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_13_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_4_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_24_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_21_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_3_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_14_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_22_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_20_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_28_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_17_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_18_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_21_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_22_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_12_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_23_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_17_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_18_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_27_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_6_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_12_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_19_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_19_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_24_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_0_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_30_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_8_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_4_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_26_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_5_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_20_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_3_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_10_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_17_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_19_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_11_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_16_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_28_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_22_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_14_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_27_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_30_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_15_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_29_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_9_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_18_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_23_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_2_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_24_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_8_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_12_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_13_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_21_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_25_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_0_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_7_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_6_Q : STD_LOGIC; 
  signal DATA_ENABLE_N_677 : STD_LOGIC; 
  signal DATA_ENABLE_N_2043 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_31_Q : STD_LOGIC; 
  signal DATA_ENABLE_N_773 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_31_Q : STD_LOGIC; 
  signal DATA_ENABLE_BUF_COPY : STD_LOGIC; 
  signal DATA_ENABLE_LC_COPY : STD_LOGIC; 
  signal DATA_ENABLE_N_2016_REP1 : STD_LOGIC; 
  signal DATA_ENABLE_STATE_OUT_0_5_Q : STD_LOGIC; 
  signal DATA_ENABLE_N_2016_REP2 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_31_Q : STD_LOGIC; 
  signal DATA_ENABLE_N_837 : STD_LOGIC; 
  signal DATA_ENABLE_N_869 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_31_Q : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_EOF_OUT_MOD_1 : STD_LOGIC; 
  signal DATA_ENABLE_G_1808 : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_EOF_OUT_MOD_1_0_0_0_OR3 : STD_LOGIC; 
  signal DATA_ENABLE_G_25 : STD_LOGIC; 
  signal DATA_ENABLE_G_31 : STD_LOGIC; 
  signal DATA_ENABLE_G_24 : STD_LOGIC; 
  signal DATA_ENABLE_G_28 : STD_LOGIC; 
  signal DATA_ENABLE_G_33 : STD_LOGIC; 
  signal DATA_ENABLE_STATE_OUT_1_1_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_26 : STD_LOGIC; 
  signal DATA_ENABLE_G_27_0 : STD_LOGIC; 
  signal DATA_ENABLE_G_1754 : STD_LOGIC; 
  signal DATA_ENABLE_G_679 : STD_LOGIC; 
  signal DATA_ENABLE_G_722 : STD_LOGIC; 
  signal DATA_ENABLE_G_698 : STD_LOGIC; 
  signal DATA_ENABLE_G_730 : STD_LOGIC; 
  signal DATA_ENABLE_G_702 : STD_LOGIC; 
  signal DATA_ENABLE_G_638 : STD_LOGIC; 
  signal DATA_ENABLE_G_663 : STD_LOGIC; 
  signal DATA_ENABLE_G_655 : STD_LOGIC; 
  signal DATA_ENABLE_G_622 : STD_LOGIC; 
  signal DATA_ENABLE_G_670 : STD_LOGIC; 
  signal DATA_ENABLE_G_678 : STD_LOGIC; 
  signal DATA_ENABLE_G_718 : STD_LOGIC; 
  signal DATA_ENABLE_G_683 : STD_LOGIC; 
  signal DATA_ENABLE_G_734 : STD_LOGIC; 
  signal DATA_ENABLE_G_631 : STD_LOGIC; 
  signal DATA_ENABLE_G_666 : STD_LOGIC; 
  signal DATA_ENABLE_G_650 : STD_LOGIC; 
  signal DATA_ENABLE_G_662 : STD_LOGIC; 
  signal DATA_ENABLE_G_727 : STD_LOGIC; 
  signal DATA_ENABLE_G_711 : STD_LOGIC; 
  signal DATA_ENABLE_G_743 : STD_LOGIC; 
  signal DATA_ENABLE_G_714 : STD_LOGIC; 
  signal DATA_ENABLE_G_647 : STD_LOGIC; 
  signal DATA_ENABLE_G_738 : STD_LOGIC; 
  signal DATA_ENABLE_G_715 : STD_LOGIC; 
  signal DATA_ENABLE_G_682 : STD_LOGIC; 
  signal DATA_ENABLE_G_667 : STD_LOGIC; 
  signal DATA_ENABLE_G_651 : STD_LOGIC; 
  signal DATA_ENABLE_G_635 : STD_LOGIC; 
  signal DATA_ENABLE_G_626 : STD_LOGIC; 
  signal DATA_ENABLE_G_686 : STD_LOGIC; 
  signal DATA_ENABLE_G_643 : STD_LOGIC; 
  signal DATA_ENABLE_G_719 : STD_LOGIC; 
  signal DATA_ENABLE_G_630 : STD_LOGIC; 
  signal DATA_ENABLE_G_703 : STD_LOGIC; 
  signal DATA_ENABLE_G_687 : STD_LOGIC; 
  signal DATA_ENABLE_G_739 : STD_LOGIC; 
  signal DATA_ENABLE_G_623 : STD_LOGIC; 
  signal DATA_ENABLE_G_654 : STD_LOGIC; 
  signal DATA_ENABLE_G_634 : STD_LOGIC; 
  signal DATA_ENABLE_G_671 : STD_LOGIC; 
  signal DATA_ENABLE_G_699 : STD_LOGIC; 
  signal DATA_ENABLE_G_723 : STD_LOGIC; 
  signal DATA_ENABLE_G_735 : STD_LOGIC; 
  signal DATA_ENABLE_G_658 : STD_LOGIC; 
  signal DATA_ENABLE_G_659 : STD_LOGIC; 
  signal DATA_ENABLE_G_742 : STD_LOGIC; 
  signal DATA_ENABLE_G_675 : STD_LOGIC; 
  signal DATA_ENABLE_G_674 : STD_LOGIC; 
  signal DATA_ENABLE_G_695 : STD_LOGIC; 
  signal DATA_ENABLE_G_639 : STD_LOGIC; 
  signal DATA_ENABLE_G_642 : STD_LOGIC; 
  signal DATA_ENABLE_G_726 : STD_LOGIC; 
  signal DATA_ENABLE_G_707 : STD_LOGIC; 
  signal DATA_ENABLE_G_646 : STD_LOGIC; 
  signal DATA_ENABLE_G_627 : STD_LOGIC; 
  signal DATA_ENABLE_G_731 : STD_LOGIC; 
  signal DATA_ENABLE_G_710 : STD_LOGIC; 
  signal DATA_ENABLE_G_706 : STD_LOGIC; 
  signal DATA_ENABLE_G_694 : STD_LOGIC; 
  signal DATA_ENABLE_G_67 : STD_LOGIC; 
  signal DATA_ENABLE_STATE_OUT_1_4_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_73 : STD_LOGIC; 
  signal DATA_ENABLE_G_65 : STD_LOGIC; 
  signal DATA_ENABLE_UN3_CWCOUNT_OUT_5_C1 : STD_LOGIC; 
  signal DATA_ENABLE_G_68 : STD_LOGIC; 
  signal DATA_ENABLE_G_22 : STD_LOGIC; 
  signal DATA_ENABLE_G_2 : STD_LOGIC; 
  signal DATA_ENABLE_N_2231 : STD_LOGIC; 
  signal DATA_ENABLE_N_2354 : STD_LOGIC; 
  signal DATA_ENABLE_G_1 : STD_LOGIC; 
  signal DATA_ENABLE_OUT_SM_PROC_UN20_STATE_IN_NE : STD_LOGIC; 
  signal DATA_ENABLE_N_2228 : STD_LOGIC; 
  signal DATA_ENABLE_G_66 : STD_LOGIC; 
  signal DATA_ENABLE_G_592 : STD_LOGIC; 
  signal DATA_ENABLE_STATE_OUT_1_2_Q : STD_LOGIC; 
  signal DATA_ENABLE_BUF_FLAG : STD_LOGIC; 
  signal DATA_ENABLE_STATE_OUT_1_3_Q : STD_LOGIC; 
  signal DATA_ENABLE_STATE_OUT_1_7_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_443 : STD_LOGIC; 
  signal DATA_ENABLE_G_1744 : STD_LOGIC; 
  signal DATA_ENABLE_G_444 : STD_LOGIC; 
  signal DATA_ENABLE_N_2239 : STD_LOGIC; 
  signal DATA_ENABLE_STATE_OUT_1_6_Q : STD_LOGIC; 
  signal DATA_ENABLE_STATE_IN_0_4_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_53 : STD_LOGIC; 
  signal DATA_ENABLE_G_54 : STD_LOGIC; 
  signal DATA_ENABLE_G_1_0 : STD_LOGIC; 
  signal DATA_ENABLE_UN3_CWCOUNT_OUT_5_C2 : STD_LOGIC; 
  signal DATA_ENABLE_G_63 : STD_LOGIC; 
  signal DATA_ENABLE_STATE_OUT_0_8_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_690 : STD_LOGIC; 
  signal DATA_ENABLE_G_62 : STD_LOGIC; 
  signal DATA_ENABLE_G_4_0_AND6_1 : STD_LOGIC; 
  signal DATA_ENABLE_G_4_0_AND2_3 : STD_LOGIC; 
  signal DATA_ENABLE_DATAEN_OUT_MOD_1 : STD_LOGIC; 
  signal DATA_ENABLE_G_14 : STD_LOGIC; 
  signal DATA_ENABLE_G_29 : STD_LOGIC; 
  signal DATA_ENABLE_G_30 : STD_LOGIC; 
  signal DATA_ENABLE_G_27 : STD_LOGIC; 
  signal DATA_ENABLE_G_64 : STD_LOGIC; 
  signal DATA_ENABLE_N_2362 : STD_LOGIC; 
  signal DATA_ENABLE_G_1822 : STD_LOGIC; 
  signal DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0 : STD_LOGIC; 
  signal DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3 : STD_LOGIC; 
  signal DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3 : STD_LOGIC; 
  signal DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3 : STD_LOGIC; 
  signal DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3 : STD_LOGIC; 
  signal DATA_ENABLE_G_1671 : STD_LOGIC; 
  signal DATA_ENABLE_G_1745 : STD_LOGIC; 
  signal DATA_ENABLE_G_1666 : STD_LOGIC; 
  signal DATA_ENABLE_G_1743 : STD_LOGIC; 
  signal DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3 : STD_LOGIC; 
  signal DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3 : STD_LOGIC; 
  signal DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3 : STD_LOGIC; 
  signal DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3 : STD_LOGIC; 
  signal DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3 : STD_LOGIC; 
  signal DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3 : STD_LOGIC; 
  signal DATA_ENABLE_G_1667 : STD_LOGIC; 
  signal DATA_ENABLE_N_2276 : STD_LOGIC; 
  signal DATA_ENABLE_CWCOUNT_OUT_PROC_UN5_STATE_OUT : STD_LOGIC; 
  signal DATA_ENABLE_STATE_OUT_0_7_Q : STD_LOGIC; 
  signal DATA_ENABLE_G_1772 : STD_LOGIC; 
  signal DATA_ENABLE_G_1740 : STD_LOGIC; 
  signal DATA_ENABLE_G_4_0_AND2 : STD_LOGIC; 
  signal DATA_ENABLE_N_998_I : STD_LOGIC; 
  signal DATA_ENABLE_STATE_IN_0_2_Q : STD_LOGIC; 
  signal DATA_ENABLE_N_1893 : STD_LOGIC; 
  signal DATA_ENABLE_UN1_STATE_IN_11_0_0 : STD_LOGIC; 
  signal DATA_ENABLE_N_49_I : STD_LOGIC; 
  signal DATA_ENABLE_N_54_I : STD_LOGIC; 
  signal DATA_ENABLE_N_44_I : STD_LOGIC; 
  signal DATA_ENABLE_G_1664 : STD_LOGIC; 
  signal DATA_ENABLE_BUF_FLAG_PROC_BUF_FLAG_1_PMX : STD_LOGIC; 
  signal DATA_ENABLE_STATE_IN_0_1_Q : STD_LOGIC; 
  signal DATA_ENABLE_GND : STD_LOGIC; 
  signal DATA_ENABLE_VCC : STD_LOGIC; 
  signal DATA_ENABLE_FWCOUNT_CRY_0_O : STD_LOGIC; 
  signal DATA_ENABLE_FWCOUNT_CRY_1_O : STD_LOGIC; 
  signal DATA_ENABLE_FWCOUNT_CRY_2_O : STD_LOGIC; 
  signal DATA_ENABLE_FWCOUNT_CRY_3_O : STD_LOGIC; 
  signal DATA_ENABLE_FWCOUNT_CRY_4_O : STD_LOGIC; 
  signal DATA_ENABLE_FWCOUNT_CRY_5_O : STD_LOGIC; 
  signal DATA_ENABLE_FWCOUNT_CRY_6_O : STD_LOGIC; 
  signal DATA_ENABLE_FWCOUNT_CRY_7_O : STD_LOGIC; 
  signal DATA_ENABLE_FWCOUNT_CRY_8_O : STD_LOGIC; 
  signal DATA_ENABLE_FWCOUNT_CRY_9_O : STD_LOGIC; 
  signal DATA_ENABLE_FWCOUNT_CRY_10_O : STD_LOGIC; 
  signal DATA_ENABLE_FWCOUNT_CRY_11_O : STD_LOGIC; 
  signal DATA_ENABLE_FWCOUNT_CRY_12_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_0_G_633_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_2_G_697_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_3_G_641_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_4_G_645_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_5_G_649_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_6_G_653_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_7_G_677_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_8_G_657_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_9_G_661_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_10_G_665_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_11_G_669_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_12_G_701_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_13_G_705_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_14_G_637_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_15_G_713_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_16_G_717_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_17_G_721_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_18_G_725_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_19_G_729_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_20_G_733_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_21_G_709_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_22_G_681_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_23_G_745_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_24_G_737_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_25_G_741_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_26_G_629_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_27_G_673_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_28_G_625_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_29_G_685_O : STD_LOGIC; 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_30_G_689_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_0 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_8 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_4 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_2 : STD_LOGIC; 
  signal SEGMENT_G_602 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_7 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_6 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_10 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_5 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_1 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_12 : STD_LOGIC; 
  signal SEGMENT_N_862_I : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_9 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_3 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_11 : STD_LOGIC; 
  signal SEGMENT_N_869_I : STD_LOGIC; 
  signal SEGMENT_N_870_I : STD_LOGIC; 
  signal SEGMENT_G_600 : STD_LOGIC; 
  signal SEGMENT_N_863_I : STD_LOGIC; 
  signal SEGMENT_N_871_I : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_9 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_6 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_1 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_2 : STD_LOGIC; 
  signal SEGMENT_G_27_0_AND2_SX : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_5 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_7 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_3 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_8 : STD_LOGIC; 
  signal SEGMENT_G_814_0 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_10 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_0 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_12 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_11 : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_4 : STD_LOGIC; 
  signal SEGMENT_N_872_I : STD_LOGIC; 
  signal SEGMENT_G_841_0 : STD_LOGIC; 
  signal SEGMENT_N_873_I : STD_LOGIC; 
  signal SEGMENT_G_840_0 : STD_LOGIC; 
  signal SEGMENT_N_874_I : STD_LOGIC; 
  signal SEGMENT_G_813_0 : STD_LOGIC; 
  signal SEGMENT_N_875_I : STD_LOGIC; 
  signal SEGMENT_G_839_0 : STD_LOGIC; 
  signal SEGMENT_G_773_0 : STD_LOGIC; 
  signal SEGMENT_DFIFO_RE_I_0_OR2 : STD_LOGIC; 
  signal SEGMENT_G_3_SX : STD_LOGIC; 
  signal SEGMENT_N_5 : STD_LOGIC; 
  signal SEGMENT_N_1269 : STD_LOGIC; 
  signal SEGMENT_N_451_I : STD_LOGIC; 
  signal SEGMENT_N_876_I : STD_LOGIC; 
  signal SEGMENT_G_838_0 : STD_LOGIC; 
  signal SEGMENT_N_877_I : STD_LOGIC; 
  signal SEGMENT_G_837_0 : STD_LOGIC; 
  signal SEGMENT_N_878_I : STD_LOGIC; 
  signal SEGMENT_N_138_1 : STD_LOGIC; 
  signal SEGMENT_G_836_0 : STD_LOGIC; 
  signal SEGMENT_N_879_I : STD_LOGIC; 
  signal SEGMENT_G_835_0 : STD_LOGIC; 
  signal SEGMENT_N_6 : STD_LOGIC; 
  signal SEGMENT_G_834_0 : STD_LOGIC; 
  signal SEGMENT_G_833_0 : STD_LOGIC; 
  signal SEGMENT_G_832_0 : STD_LOGIC; 
  signal SEGMENT_G_748 : STD_LOGIC; 
  signal SEGMENT_G_831_0 : STD_LOGIC; 
  signal SEGMENT_G_830_0 : STD_LOGIC; 
  signal SEGMENT_STATE_1_3_Q : STD_LOGIC; 
  signal SEGMENT_STATE_1_2_Q : STD_LOGIC; 
  signal SEGMENT_G_17 : STD_LOGIC; 
  signal SEGMENT_N_1272 : STD_LOGIC; 
  signal SEGMENT_G_16 : STD_LOGIC; 
  signal SEGMENT_N_1273 : STD_LOGIC; 
  signal SEGMENT_N_880_I : STD_LOGIC; 
  signal SEGMENT_G_48 : STD_LOGIC; 
  signal SEGMENT_STATE_1_0_0_AND2_0_2_Q : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN21_CFIFO_AVAIL_NE : STD_LOGIC; 
  signal SEGMENT_G_611 : STD_LOGIC; 
  signal SEGMENT_G_50 : STD_LOGIC; 
  signal SEGMENT_G_49 : STD_LOGIC; 
  signal SEGMENT_G_668 : STD_LOGIC; 
  signal SEGMENT_G_769_0 : STD_LOGIC; 
  signal SEGMENT_G_13 : STD_LOGIC; 
  signal SEGMENT_G_786_0 : STD_LOGIC; 
  signal SEGMENT_STATE_0_6_Q : STD_LOGIC; 
  signal SEGMENT_G_41 : STD_LOGIC; 
  signal SEGMENT_G_846 : STD_LOGIC; 
  signal SEGMENT_G_609 : STD_LOGIC; 
  signal SEGMENT_G_755_0 : STD_LOGIC; 
  signal SEGMENT_G_795_0 : STD_LOGIC; 
  signal SEGMENT_G_779_FAST : STD_LOGIC; 
  signal SEGMENT_G_804_0 : STD_LOGIC; 
  signal SEGMENT_CFIFO_AVAIL : STD_LOGIC; 
  signal SEGMENT_STATE_0_4_Q : STD_LOGIC; 
  signal SEGMENT_STATE_0_5_Q : STD_LOGIC; 
  signal SEGMENT_G_681_0 : STD_LOGIC; 
  signal SEGMENT_G_588 : STD_LOGIC; 
  signal SEGMENT_STATE_0_8_Q : STD_LOGIC; 
  signal SEGMENT_G_790_0 : STD_LOGIC; 
  signal SEGMENT_G_104 : STD_LOGIC; 
  signal SEGMENT_STATE_1_9_Q : STD_LOGIC; 
  signal SEGMENT_G_39 : STD_LOGIC; 
  signal SEGMENT_G_105 : STD_LOGIC; 
  signal SEGMENT_G_596 : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_12_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_8_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_9_Q : STD_LOGIC; 
  signal SEGMENT_G_375 : STD_LOGIC; 
  signal SEGMENT_G_376 : STD_LOGIC; 
  signal SEGMENT_G_382 : STD_LOGIC; 
  signal SEGMENT_G_381 : STD_LOGIC; 
  signal SEGMENT_STATE_1_0_0_AND2_0_9_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_4_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_3_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_11_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_6_Q : STD_LOGIC; 
  signal SEGMENT_G_379 : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_5_Q : STD_LOGIC; 
  signal SEGMENT_G_387 : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_2_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_13_Q : STD_LOGIC; 
  signal SEGMENT_G_383 : STD_LOGIC; 
  signal SEGMENT_G_386 : STD_LOGIC; 
  signal SEGMENT_G_385 : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_10_Q : STD_LOGIC; 
  signal SEGMENT_G_377 : STD_LOGIC; 
  signal SEGMENT_G_788_0 : STD_LOGIC; 
  signal SEGMENT_G_388 : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_14_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_7_Q : STD_LOGIC; 
  signal SEGMENT_G_378 : STD_LOGIC; 
  signal SEGMENT_G_380 : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_15_Q : STD_LOGIC; 
  signal SEGMENT_G_384 : STD_LOGIC; 
  signal SEGMENT_DFIFO_RE_I_0_MUX2 : STD_LOGIC; 
  signal SEGMENT_G_589 : STD_LOGIC; 
  signal SEGMENT_G_6 : STD_LOGIC; 
  signal SEGMENT_G_442 : STD_LOGIC; 
  signal SEGMENT_N_1018_I : STD_LOGIC; 
  signal SEGMENT_N_992_I : STD_LOGIC; 
  signal SEGMENT_G_779_0 : STD_LOGIC; 
  signal SEGMENT_N_910_I : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_18_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_16_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_29_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_20_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_0_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_17_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_25_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_19_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_27_Q : STD_LOGIC; 
  signal SEGMENT_STATE_0_1_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_28_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_23_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_31_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_24_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_30_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_26_Q : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_21_Q : STD_LOGIC; 
  signal SEGMENT_G_858 : STD_LOGIC; 
  signal SEGMENT_DOUT_PROC_D_OUT_MOD_1_22_Q : STD_LOGIC; 
  signal SEGMENT_STATE_0_10_Q : STD_LOGIC; 
  signal SEGMENT_G_847 : STD_LOGIC; 
  signal SEGMENT_SOF_IN : STD_LOGIC; 
  signal SEGMENT_EOF_DELAY0 : STD_LOGIC; 
  signal SEGMENT_DATAEN_IN : STD_LOGIC; 
  signal SEGMENT_N_894_I : STD_LOGIC; 
  signal SEGMENT_G_808_0 : STD_LOGIC; 
  signal SEGMENT_STATE_0_7_Q : STD_LOGIC; 
  signal SEGMENT_RDDONE_BUF : STD_LOGIC; 
  signal SEGMENT_G_809_0 : STD_LOGIC; 
  signal SEGMENT_STATE_I_8_Q : STD_LOGIC; 
  signal SEGMENT_STATE_I_5_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_0_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_29_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_2_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_27_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_10_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_9_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_5_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_31_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_15_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_11_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_19_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_7_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_3_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_14_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_13_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_23_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_12_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_4_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_30_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_22_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_6_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_21_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_18_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_16_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_20_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_17_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_26_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_8_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_28_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_25_Q : STD_LOGIC; 
  signal SEGMENT_HEADER_24_Q : STD_LOGIC; 
  signal SEGMENT_CFIFO_AVAIL_W : STD_LOGIC; 
  signal SEGMENT_N_991_I : STD_LOGIC; 
  signal SEGMENT_EOF_DELAY1 : STD_LOGIC; 
  signal SEGMENT_EOF_IN : STD_LOGIC; 
  signal SEGMENT_FIFO_RESET : STD_LOGIC; 
  signal SEGMENT_GND : STD_LOGIC; 
  signal SEGMENT_VCC : STD_LOGIC; 
  signal SEGMENT_G_860_G_3_O : STD_LOGIC; 
  signal SEGMENT_IN_COUNT_CRY_0_O : STD_LOGIC; 
  signal SEGMENT_IN_COUNT_CRY_1_O : STD_LOGIC; 
  signal SEGMENT_IN_COUNT_CRY_2_O : STD_LOGIC; 
  signal SEGMENT_IN_COUNT_CRY_3_O : STD_LOGIC; 
  signal SEGMENT_IN_COUNT_CRY_4_O : STD_LOGIC; 
  signal SEGMENT_IN_COUNT_CRY_5_O : STD_LOGIC; 
  signal SEGMENT_IN_COUNT_CRY_6_O : STD_LOGIC; 
  signal SEGMENT_IN_COUNT_CRY_7_O : STD_LOGIC; 
  signal SEGMENT_IN_COUNT_CRY_8_O : STD_LOGIC; 
  signal SEGMENT_IN_COUNT_CRY_9_O : STD_LOGIC; 
  signal SEGMENT_IN_COUNT_CRY_10_O : STD_LOGIC; 
  signal SEGMENT_IN_COUNT_CRY_11_O : STD_LOGIC; 
  signal SEGMENT_IN_COUNT_CRY_12_O : STD_LOGIC; 
  signal SEGMENT_OUT_COUNT_CRY_0_O : STD_LOGIC; 
  signal SEGMENT_OUT_COUNT_CRY_1_O : STD_LOGIC; 
  signal SEGMENT_OUT_COUNT_CRY_2_O : STD_LOGIC; 
  signal SEGMENT_OUT_COUNT_CRY_3_O : STD_LOGIC; 
  signal SEGMENT_OUT_COUNT_CRY_4_O : STD_LOGIC; 
  signal SEGMENT_OUT_COUNT_CRY_5_O : STD_LOGIC; 
  signal SEGMENT_OUT_COUNT_CRY_6_O : STD_LOGIC; 
  signal SEGMENT_OUT_COUNT_CRY_7_O : STD_LOGIC; 
  signal SEGMENT_OUT_COUNT_CRY_8_O : STD_LOGIC; 
  signal SEGMENT_OUT_COUNT_CRY_9_O : STD_LOGIC; 
  signal SEGMENT_OUT_COUNT_CRY_10_O : STD_LOGIC; 
  signal SEGMENT_OUT_COUNT_CRY_11_O : STD_LOGIC; 
  signal SEGMENT_OUT_COUNT_CRY_12_O : STD_LOGIC; 
  signal SEGMENT_STATE_1_I_I_AND2_Q_G_7_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_0_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_1_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_2_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_3_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_4_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_5_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_6_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_7_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_8_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_9_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_10_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_11_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_12_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_0_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_1_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_2_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_3_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_4_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_5_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_6_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_7_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_8_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_9_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_10_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_11_O : STD_LOGIC; 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_12_O : STD_LOGIC; 
  signal SEGMENT_CFIFO_UN1_RESET_L_3_0_AND3_0_AND2_0_AND2 : STD_LOGIC; 
  signal SEGMENT_CFIFO_UN1_RESET_L_4_0_AND3_0_AND2_0_AND2 : STD_LOGIC; 
  signal SEGMENT_CFIFO_UN1_RESET_L_1_0_AND3_0_AND2_0_AND2 : STD_LOGIC; 
  signal SEGMENT_CFIFO_UN1_RESET_L_2_0_AND3_0_AND2_0_AND2 : STD_LOGIC; 
  signal SEGMENT_CFIFO_N_893_I : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16301 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16299 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19561 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9762 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9760 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13019 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13017 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16277 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9738 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N12995 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6464 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19499 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19497 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16217 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16215 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19475 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22723 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22722 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22720 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16193 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22719 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22718 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6402 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6400 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9662 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22708 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6378 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19415 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19413 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19391 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9600 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9598 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16117 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6318 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6316 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9576 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6294 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16055 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16053 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19315 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9516 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9514 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16031 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9492 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2955 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6218 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2954 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2953 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2952 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2951 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2950 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2949 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2948 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2947 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2946 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2945 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2944 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2943 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2942 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2941 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2940 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2939 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2938 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19253 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2937 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2936 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19251 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2935 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2934 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2933 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2932 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2931 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2930 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2929 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2928 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2927 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2926 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2925 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2924 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2922 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2921 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2920 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2919 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15971 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2918 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2917 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15969 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2916 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2915 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2914 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19229 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2913 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2912 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2911 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2910 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2909 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2908 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2907 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2906 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2905 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2904 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2903 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2902 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2901 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2900 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2899 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2898 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2897 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2896 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2895 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15947 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2894 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2893 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6156 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2892 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2891 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6154 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9416 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6132 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19169 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19167 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19145 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9354 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9352 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N12614 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15871 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6072 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6070 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9330 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6048 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N12552 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N12550 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15809 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15807 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19069 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9270 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9268 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N12528 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15785 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9246 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5972 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19007 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19005 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N12468 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N12466 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15725 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15723 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18983 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N12444 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15701 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5910 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5908 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9170 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22220 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22218 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22216 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22213 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22212 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22211 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22210 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22209 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22208 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22207 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22205 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22204 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22203 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22202 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5886 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22201 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22200 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22199 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18923 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18921 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18899 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9108 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9106 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N12368 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15625 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2566 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2565 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2564 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2563 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5826 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2562 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2561 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5824 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2560 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2559 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2558 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9084 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2557 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2556 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2555 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2554 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2553 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2552 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2551 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22129 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2550 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2549 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2548 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2547 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2546 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2545 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2544 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2543 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2542 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2541 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2540 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2539 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5802 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2538 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2537 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2536 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2535 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2533 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2532 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2531 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2530 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2529 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2528 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2527 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2526 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2525 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2524 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2523 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2522 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2521 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2520 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2519 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2518 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2517 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N12306 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2516 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2515 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N12304 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2514 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2513 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2512 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2511 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15563 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2510 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2509 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15561 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2508 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18823 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2507 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2506 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2505 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2504 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2503 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2502 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9024 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9022 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N12282 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15539 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N22053 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9000 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5726 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18761 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18759 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N12222 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N12220 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15479 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15477 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18737 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N12198 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15455 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5664 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5662 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21977 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8924 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5640 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18677 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18675 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N25186 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N25184 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N25182 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N25179 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18653 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N25178 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N25177 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8862 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N25176 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N25175 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8860 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N25174 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N12122 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N25173 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N25171 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N25170 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N25169 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N25168 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15379 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N25167 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N25166 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N25165 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21901 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5580 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5578 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8838 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5556 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N12060 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N12058 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15317 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15315 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18577 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8778 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8776 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N12036 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21825 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15293 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8754 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5480 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18515 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18513 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2147483644 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2147483641 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11976 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11974 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15233 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15231 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2177 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2176 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18491 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2175 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2174 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2173 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2172 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2171 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21749 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2170 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2169 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2168 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2167 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2166 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2165 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2164 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2163 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11952 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2162 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2161 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2160 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2159 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2158 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2157 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15209 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2156 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2155 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5418 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2154 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2153 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5416 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2152 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8678 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2151 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2150 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2149 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2148 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2147 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2146 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2144 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2143 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2142 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2141 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2140 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2139 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2138 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2137 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2136 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2135 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2134 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2133 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2132 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2131 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5394 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2130 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2129 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2128 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2127 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2126 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2125 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2124 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2123 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2122 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2121 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2120 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2119 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2118 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2117 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2116 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18431 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2115 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2114 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18429 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N2113 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24937 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21673 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18407 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8616 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8614 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11876 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15133 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5334 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5332 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8592 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5310 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11814 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11812 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24861 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15071 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15069 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18331 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8532 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8530 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11790 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N15047 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8508 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5234 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18269 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18267 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24785 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11730 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11728 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14987 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14985 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18245 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11706 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14963 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5172 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5170 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8432 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5148 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21463 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18185 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21447 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24709 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18183 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21433 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18161 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8370 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8368 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11630 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21417 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14887 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5088 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21403 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5086 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8346 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21387 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N5064 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21373 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24633 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1788 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1787 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1786 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1785 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1784 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1783 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1782 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1781 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1780 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1779 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11568 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21357 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1778 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1777 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11566 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1776 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1775 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1774 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1773 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14825 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1772 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1771 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14823 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1770 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18085 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1769 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1768 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1767 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1766 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1765 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21343 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1764 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1763 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1762 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1761 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1760 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8286 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1759 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1758 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8284 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1757 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1755 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11544 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1754 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1753 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1752 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1751 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1750 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1749 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14801 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21327 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1748 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1747 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1746 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1745 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1744 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1743 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1742 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1741 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1740 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1739 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1738 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1737 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1736 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8262 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1735 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21313 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1734 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1733 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1732 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1731 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1730 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1729 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1728 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1727 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1726 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1725 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4988 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1724 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21297 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24557 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18023 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N18021 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21283 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21281 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21280 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21279 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21278 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21277 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21276 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21275 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11484 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11482 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14741 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14739 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17999 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11460 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14717 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4926 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4924 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8186 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24481 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4902 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17939 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17937 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17915 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8124 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8122 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11384 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14641 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4842 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4840 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8100 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4818 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11322 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11320 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14579 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14577 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17839 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8040 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8038 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11298 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14555 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N8016 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17777 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17775 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11238 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11236 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14495 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14493 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17753 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21014 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21013 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21012 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21011 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21010 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21009 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24271 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21008 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21006 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21005 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21004 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11214 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21003 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21002 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21001 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N21000 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20998 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14471 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20997 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20996 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20995 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20994 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20993 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24255 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7940 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20992 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20982 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20981 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20980 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20979 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24241 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20978 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1399 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20977 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1398 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20976 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1397 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1396 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1395 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1394 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1393 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1392 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1391 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1390 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1389 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1388 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1387 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1386 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1385 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24225 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1384 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1383 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1382 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1381 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1380 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1379 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1378 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17693 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1377 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1376 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17691 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1375 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1374 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1373 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1372 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1371 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24211 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1370 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1369 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1368 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1366 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1365 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20942 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1364 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20941 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1363 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20940 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1362 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20939 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1361 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20938 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1360 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20937 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1359 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20936 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1358 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1357 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20934 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1356 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20933 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1355 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20932 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24195 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1354 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17669 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20931 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1353 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20930 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1352 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7878 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20929 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1351 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20928 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1350 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7876 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1349 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11138 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1348 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1347 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1346 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1345 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1344 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1343 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14395 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1342 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1341 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24181 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1340 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20918 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1339 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20917 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1338 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20916 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1337 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20915 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1336 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20914 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N1335 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20913 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20912 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20910 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20909 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20908 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20907 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7854 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20906 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20905 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20904 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24165 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24151 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24135 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20868 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11076 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20864 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11074 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14333 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24121 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14331 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17593 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7794 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7792 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24105 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N11052 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14309 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24091 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24089 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24088 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24087 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24086 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24085 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7770 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24084 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N24083 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17531 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17529 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20791 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10992 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10990 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14249 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14247 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17507 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10968 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14225 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7694 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20729 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20727 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17447 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17445 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20705 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17423 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7632 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7630 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10892 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14149 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7608 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20645 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20643 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20621 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10830 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10828 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14087 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14085 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17347 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7548 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7546 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10806 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14063 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23849 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7524 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23835 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23819 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17285 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17283 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20545 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23805 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10746 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10744 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14003 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N14001 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23789 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17261 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23775 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10722 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13979 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7448 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N919 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N918 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23759 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N917 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N916 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N915 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N914 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N913 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N912 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20483 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23745 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20481 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23729 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17201 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17199 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20459 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23715 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17177 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7386 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4122 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4121 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7384 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23699 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4120 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10646 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4119 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4118 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4117 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4116 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4115 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4114 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13903 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4113 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4112 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4111 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4110 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4109 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4108 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4107 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23685 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4106 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4105 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4104 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4103 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4102 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4101 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4100 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4099 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7362 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4098 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4097 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4096 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4095 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4094 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4093 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4092 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4091 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23669 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23667 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4089 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4088 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23666 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4087 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23665 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4086 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23664 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4085 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23663 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4084 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20399 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23662 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4083 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N23661 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4082 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20397 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4081 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4080 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4079 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4078 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4077 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4076 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4075 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4074 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4073 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4072 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4071 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4070 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4069 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4068 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4067 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4066 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4065 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4064 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4063 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4062 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4061 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4060 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20375 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4059 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N4058 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10584 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10582 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13841 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13839 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17101 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7302 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7300 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10560 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13817 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7278 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17039 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17037 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20299 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10500 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10498 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13757 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13755 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N17015 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10476 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13733 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7202 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20237 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20235 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16955 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16953 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20213 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16931 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7140 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7138 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10400 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13657 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7116 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20153 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20151 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20129 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10338 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10336 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13595 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13593 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16855 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7056 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7054 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10314 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13571 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N7032 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16793 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16791 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N20053 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3733 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3732 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3731 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3730 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3729 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3728 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10254 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3727 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3726 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10252 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3725 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3724 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3723 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3722 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13511 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3721 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3720 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13509 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3719 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3718 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3717 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16769 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3716 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3715 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3714 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3713 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3712 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3711 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3710 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3709 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3708 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3707 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3706 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3705 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3704 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10230 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3703 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3702 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3700 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3699 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3698 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13487 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3697 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3696 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3695 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3694 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3693 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6956 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3692 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3691 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3690 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3689 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3688 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3687 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3686 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3685 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3684 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3683 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3682 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3681 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3680 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3679 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3678 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3677 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3676 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19991 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3675 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3674 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19989 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3673 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3672 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3671 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3670 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3669 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16709 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16707 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19967 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16685 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6894 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6892 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10154 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13411 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6870 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19907 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19905 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19883 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10092 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10090 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13349 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13347 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16609 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6810 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6808 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10068 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13325 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6786 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16547 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16545 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19807 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N226 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N224 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N222 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N221 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N220 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N219 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10008 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N218 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N217 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N10006 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N216 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N214 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N213 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13265 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N212 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N211 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13263 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N210 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N209 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N208 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16523 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9984 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13241 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6710 : STD_LOGIC; 
  signal SEGMENT_DFIFO_EMPTY : STD_LOGIC; 
  signal SEGMENT_DFIFO_FULL : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19745 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19743 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16463 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16461 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19721 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16439 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6648 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6646 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9908 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13165 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6624 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19661 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3344 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19659 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3343 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3342 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3341 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3340 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3339 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3338 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3337 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3336 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3335 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3334 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3333 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3332 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3331 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3330 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3329 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3328 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3327 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3326 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3325 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3324 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3323 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3322 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N19637 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3321 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3320 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9846 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3319 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3318 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9844 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3317 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3316 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3315 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3314 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13103 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3313 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13101 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3311 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N16363 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3310 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3309 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3308 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3307 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3306 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3305 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3304 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3303 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3302 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3301 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6564 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3300 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3299 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6562 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3298 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3297 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3296 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N9822 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3295 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3294 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3293 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3292 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3291 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3290 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N13079 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3289 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3288 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3287 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3286 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3285 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3284 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3283 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3282 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3281 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N3280 : STD_LOGIC; 
  signal SEGMENT_DFIFO_N6540 : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU820_S : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU820_LO : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU820_O : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU823_LO : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU823_O : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU844_O : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU955_S : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU955_LO : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU955_O : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU958_LO : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU958_O : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU979_O : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU781_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU785_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU789_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU793_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU797_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU801_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU804_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU806_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU808_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU810_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU812_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU814_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU816_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU818_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU821_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU824_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU830_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU833_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU836_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU839_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU842_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU847_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU848_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU849_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU850_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU851_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU852_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU853_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU854_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU855_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU856_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU857_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU858_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU859_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU860_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU861_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU868_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU869_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU870_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU871_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU872_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU873_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU874_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU878_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU882_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU886_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU890_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU894_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU898_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU902_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU909_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU913_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU917_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU921_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU925_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU929_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU932_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU934_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU936_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU938_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU940_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU942_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU944_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU946_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU947_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU948_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU949_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU950_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU951_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU952_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU953_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU956_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU959_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU965_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU968_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU971_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU974_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU977_GSR_OR : STD_LOGIC; 
  signal SEGMENT_DFIFO_BU982_GSR_OR : STD_LOGIC; 
  signal GND : STD_LOGIC; 
  signal VCC : STD_LOGIC; 
  signal NGD2VHDL_X_3193_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3201_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3209_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3217_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3225_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3233_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3241_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3249_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3257_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3265_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3273_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3281_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3289_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3297_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3305_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3313_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3321_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3329_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3337_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3345_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3353_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3361_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3369_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3377_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3385_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3393_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3401_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3409_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3417_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3425_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3433_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3441_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3757_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3775_4 : STD_LOGIC; 
  signal NGD2VHDL_X_3830_3 : STD_LOGIC; 
  signal NGD2VHDL_X_3833_4 : STD_LOGIC; 
  signal NGD2VHDL_X_3892_5 : STD_LOGIC; 
  signal NGD2VHDL_X_3910_4 : STD_LOGIC; 
  signal SEGMENT_CELL_COUNT : STD_LOGIC_VECTOR ( 2 downto 0 ); 
  signal CRC_IN_CRC_GEN_CRC_OUT : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal CRC_IN_CRC_GEN_CRC_CALC : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal CRC_OUT_CRC_GEN_CRC_OUT : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal CRC_OUT_CRC_GEN_CRC_CALC : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal STATE_OUT_FAST : STD_LOGIC_VECTOR ( 6 downto 6 ); 
  signal CRC_OUT_CRC_GEN_COUNT : STD_LOGIC_VECTOR ( 2 downto 0 ); 
  signal DATA_ENABLE_CWCOUNT_IN : STD_LOGIC_VECTOR ( 2 downto 0 ); 
  signal CRC_IN_CRC_GEN_COUNT : STD_LOGIC_VECTOR ( 2 downto 0 ); 
  signal DATA8 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA2 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal CRC_IN_DATA_WIRE : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal CRC_IN_NX_DATA : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal CRC_OUT_DATA_WIRE : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal CRC_OUT_NX_DATA : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_FWCOUNT_CRY : STD_LOGIC_VECTOR ( 12 downto 0 ); 
  signal DATA_ENABLE_FWCOUNT : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal DATA_ENABLE_FWCOUNT_S : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal DATA_ENABLE_FWCOUNT_LM : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal DATA_ENABLE_FWCOUNT_QXU : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal DATA_ENABLE_CWCOUNT_OUT_1 : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal DATA_ENABLE_CWCOUNT_OUT : STD_LOGIC_VECTOR ( 2 downto 0 ); 
  signal DATA_ENABLE_CELL_BUF_8 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_CELL_BUF_0 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_CELL_BUF_2 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_CELL_BUF_9 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_CELL_BUF_10 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_CELL_BUF_1 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_CELL_BUF_3 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_CELL_BUF_11 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_CWCOUNT_OUT_0 : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3 : STD_LOGIC_VECTOR ( 31 downto 31 ); 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_11_AM : STD_LOGIC_VECTOR ( 31 downto 31 ); 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_4_AM : STD_LOGIC_VECTOR ( 1 downto 1 ); 
  signal DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_11_BM : STD_LOGIC_VECTOR ( 31 downto 31 ); 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_4_BM : STD_LOGIC_VECTOR ( 1 downto 1 ); 
  signal DATA_ENABLE_CELL_BUF_5 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_CELL_BUF_4 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_CELL_BUF_7 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_CELL_BUF_6 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_STATE_OUT_1_I_AND3_0 : STD_LOGIC_VECTOR ( 5 downto 5 ); 
  signal DATA_ENABLE_DATA_IN : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_STATE_OUT_1_0_0_AND3_1 : STD_LOGIC_VECTOR ( 7 downto 7 ); 
  signal DATA_ENABLE_DELAY_WORD1 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_CWCOUNT_OUT_PROC_CWCOUNT_OUT_1_1_I : STD_LOGIC_VECTOR ( 3 downto 0 ); 
  signal DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3 : STD_LOGIC_VECTOR ( 31 downto 31 ); 
  signal DATA_ENABLE_DELAY_WORD0 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal DATA_ENABLE_STATE_IN_1_0_IV_I_0_AND3_0 : STD_LOGIC_VECTOR ( 5 downto 5 ); 
  signal DATA_ENABLE_STATE_IN_1 : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal DATA_ENABLE_STATE_OUT_1_0_0_AND3 : STD_LOGIC_VECTOR ( 8 downto 8 ); 
  signal SEGMENT_OUT_COUNT : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL : STD_LOGIC_VECTOR ( 13 downto 1 ); 
  signal SEGMENT_CFIFO_OUT : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal SEGMENT_OUT_COUNT_CRY : STD_LOGIC_VECTOR ( 12 downto 0 ); 
  signal SEGMENT_IN_COUNT_CRY : STD_LOGIC_VECTOR ( 12 downto 0 ); 
  signal SEGMENT_OUT_COUNT_QXU : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal SEGMENT_IN_COUNT_LM : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal SEGMENT_IN_COUNT_QXU : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal SEGMENT_IN_COUNT_S : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal SEGMENT_OUT_COUNT_S : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal SEGMENT_IN_COUNT : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal SEGMENT_OUT_COUNT_LM : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal SEGMENT_STATE_1_I_0_AND2 : STD_LOGIC_VECTOR ( 6 downto 6 ); 
  signal SEGMENT_STATE_1_0_0_AND2 : STD_LOGIC_VECTOR ( 9 downto 9 ); 
  signal SEGMENT_DFIFO_COUNT : STD_LOGIC_VECTOR ( 6 downto 0 ); 
  signal SEGMENT_TAIL : STD_LOGIC_VECTOR ( 1 downto 0 ); 
  signal SEGMENT_CFIFO_OUT_W : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal SEGMENT_HEAD : STD_LOGIC_VECTOR ( 0 downto 0 ); 
  signal SEGMENT_DFIFO_DOUT : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal SEGMENT_DATA_IN : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal SEGMENT_CFIFO_DATA_OUT_3_AM : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal SEGMENT_CFIFO_FIFO_0 : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal SEGMENT_CFIFO_FIFO_1 : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal SEGMENT_CFIFO_FIFO_2 : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal SEGMENT_CFIFO_FIFO_3 : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal SEGMENT_CFIFO_DATA_OUT_3_BM : STD_LOGIC_VECTOR ( 13 downto 0 ); 
  signal SEGMENT_CFIFO_HEAD_0 : STD_LOGIC_VECTOR ( 1 downto 1 ); 
  signal SEGMENT_CFIFO_DATA_BUF : STD_LOGIC_VECTOR ( 13 downto 0 ); 
begin
  NGD2VHDL_IO0 <= TCA_OUT_MOD;
  NGD2VHDL_IO1 <= TCA_OUT_APPL;
  TCA_MOD_IN <= NGD2VHDL_IO1;
  TCA_APPL_IN <= NGD2VHDL_IO0;
  SOC_OUT_MOD <= NGD2VHDL_OI6;
  GND_0 : X_ZERO
    port map (
      O => GND_INT
    );
  G_13 : X_LUT3
    generic map (
      INIT => X"01"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR1 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR2 => DATA_ENABLE_STATE_OUT_1_Q,
      O => DATA_ENABLE_N_2269
    );
  G_15 : X_LUT3
    generic map (
      INIT => X"FE"
    )
    port map (
      ADR0 => STATE_OUT_FAST(6),
      ADR1 => DATA_ENABLE_STATE_OUT_4_Q,
      ADR2 => DATA_ENABLE_STATE_OUT_3_Q,
      O => DATA_ENABLE_N_1949_I
    );
  G_15_FAST_1 : X_LUT3
    generic map (
      INIT => X"FE"
    )
    port map (
      ADR0 => STATE_OUT_FAST(6),
      ADR1 => DATA_ENABLE_STATE_OUT_4_Q,
      ADR2 => DATA_ENABLE_STATE_OUT_3_Q,
      O => G_15_FAST
    );
  G_752_2 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(28),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(28),
      O => G_752
    );
  G_753_3 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(29),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(29),
      O => G_753
    );
  G_754_4 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(30),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(30),
      O => G_754
    );
  G_755_5 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(31),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(31),
      O => G_755
    );
  G_756_6 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(13),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(13),
      O => G_756
    );
  G_757_7 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(14),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(14),
      O => G_757
    );
  G_758_8 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(15),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(15),
      O => G_758
    );
  G_759_9 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(16),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(16),
      O => G_759
    );
  G_760_10 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(17),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(17),
      O => G_760
    );
  G_761_11 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(18),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(18),
      O => G_761
    );
  G_762_12 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(19),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(19),
      O => G_762
    );
  G_763_13 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(20),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(20),
      O => G_763
    );
  G_764_14 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(21),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(21),
      O => G_764
    );
  G_765_15 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(22),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(22),
      O => G_765
    );
  G_766_16 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(23),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(23),
      O => G_766
    );
  G_767_17 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(24),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(24),
      O => G_767
    );
  G_768_18 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(25),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(25),
      O => G_768
    );
  G_769_19 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(26),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(26),
      O => G_769
    );
  G_770_20 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(27),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(27),
      O => G_770
    );
  G_771_21 : X_LUT4
    generic map (
      INIT => X"2888"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => CRC_OUT_CRC_GEN_COUNT(2),
      ADR2 => CRC_OUT_CRC_GEN_COUNT(1),
      ADR3 => CRC_OUT_CRC_GEN_COUNT(0),
      O => G_771
    );
  G_772_22 : X_LUT4
    generic map (
      INIT => X"2888"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => CRC_OUT_N_63_1,
      ADR2 => CRC_OUT_CRC_GEN_COUNT(2),
      ADR3 => CRC_OUT_CRC_GEN_UN4_COUNT_C2,
      O => G_772
    );
  G_773_23 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(0),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(0),
      O => G_773
    );
  G_774_24 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(1),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(1),
      O => G_774
    );
  G_775_25 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(2),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(2),
      O => G_775
    );
  G_776_26 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(3),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(3),
      O => G_776
    );
  G_777_27 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(4),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(4),
      O => G_777
    );
  G_778_28 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(5),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(5),
      O => G_778
    );
  G_779_29 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(6),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(6),
      O => G_779
    );
  G_780_30 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(7),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(7),
      O => G_780
    );
  G_781_31 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(8),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(8),
      O => G_781
    );
  G_782_32 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(9),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(9),
      O => G_782
    );
  G_783_33 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(10),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(10),
      O => G_783
    );
  G_784_34 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(11),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(11),
      O => G_784
    );
  G_785_35 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3_0,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_CRC_GEN_CRC_CALC(12),
      ADR3 => CRC_OUT_CRC_GEN_CRC_OUT(12),
      O => G_785
    );
  G_786_36 : X_LUT2
    generic map (
      INIT => X"4"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_COUNT(0),
      ADR1 => RESET_L_1,
      O => G_786
    );
  G_787_37 : X_LUT3
    generic map (
      INIT => X"28"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => CRC_OUT_CRC_GEN_COUNT(1),
      ADR2 => CRC_OUT_CRC_GEN_COUNT(0),
      O => G_787
    );
  G_788_38 : X_LUT3
    generic map (
      INIT => X"A8"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => SEGMENT_STATE_2_Q,
      ADR2 => SEGMENT_STATE_3_Q,
      O => G_788
    );
  G_789_39 : X_LUT2
    generic map (
      INIT => X"4"
    )
    port map (
      ADR0 => SEGMENT_CELL_COUNT(0),
      ADR1 => RESET_L_1,
      O => G_789
    );
  G_790_40 : X_LUT3
    generic map (
      INIT => X"28"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => SEGMENT_CELL_COUNT(0),
      ADR2 => SEGMENT_CELL_COUNT(1),
      O => G_790
    );
  G_791_41 : X_LUT4
    generic map (
      INIT => X"2888"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => SEGMENT_CELL_COUNT(2),
      ADR2 => SEGMENT_CELL_COUNT(1),
      ADR3 => SEGMENT_CELL_COUNT(0),
      O => G_791
    );
  G_792_42 : X_LUT4
    generic map (
      INIT => X"2888"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => SEGMENT_N_146_1,
      ADR2 => SEGMENT_CELL_COUNT(2),
      ADR3 => SEGMENT_UN16_CELL_COUNT_C2,
      O => G_792
    );
  G_793_43 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => SEGMENT_STATE_0_Q,
      ADR1 => G_761_0,
      ADR2 => SEGMENT_STATE_11_Q,
      O => G_793
    );
  G_795_44 : X_LUT4
    generic map (
      INIT => X"A280"
    )
    port map (
      ADR0 => SEGMENT_STATE_9_Q,
      ADR1 => G_27_0_AND2,
      ADR2 => SEGMENT_G_767_Q_O2,
      ADR3 => G_18_0_AND2,
      O => G_795
    );
  G_796_45 : X_LUT4
    generic map (
      INIT => X"0008"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => N_996_1,
      ADR2 => DATA_ENABLE_LC_FLAG,
      ADR3 => G_1828,
      O => G_796
    );
  G_797_46 : X_LUT3
    generic map (
      INIT => X"AE"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_IN_3_Q,
      ADR1 => DATA_ENABLE_STATE_IN_7_Q,
      ADR2 => DATA_ENABLE_SOC_IN,
      O => G_797
    );
  G_800_47 : X_LUT4
    generic map (
      INIT => X"0080"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => N_996_1,
      ADR2 => DATA_ENABLE_LC_FLAG,
      ADR3 => G_1828,
      O => G_800
    );
  G_800_1 : X_LUT2
    generic map (
      INIT => X"2"
    )
    port map (
      ADR0 => DATA_ENABLE_N_971_1,
      ADR1 => DATA_ENABLE_CWCOUNT_IN(1),
      O => N_996_1
    );
  G_801_48 : X_LUT4
    generic map (
      INIT => X"0220"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => DATA_ENABLE_STATE_IN_0_Q,
      ADR2 => DATA_ENABLE_CWCOUNT_IN(0),
      ADR3 => DATA_ENABLE_STATE_IN_5_Q,
      O => G_801
    );
  G_802_49 : X_LUT4
    generic map (
      INIT => X"4004"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_IN_0_Q,
      ADR1 => RESET_L_1,
      ADR2 => G_1828,
      ADR3 => DATA_ENABLE_CWCOUNT_IN(1),
      O => G_802
    );
  G_803_50 : X_LUT4
    generic map (
      INIT => X"0220"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => DATA_ENABLE_STATE_IN_0_Q,
      ADR2 => DATA_ENABLE_UN2_CWCOUNT_IN_1_C2,
      ADR3 => DATA_ENABLE_CWCOUNT_IN(2),
      O => G_803
    );
  G_804_51 : X_LUT4
    generic map (
      INIT => X"0220"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => DATA_ENABLE_STATE_IN_0_Q,
      ADR2 => DATA_ENABLE_UN2_CWCOUNT_IN_1_C3,
      ADR3 => DATA_ENABLE_N_971_1,
      O => G_804
    );
  G_805_1 : X_LUT4
    generic map (
      INIT => X"55D5"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => G_1777,
      ADR2 => G_1752,
      ADR3 => DATA_ENABLE_STATE_OUT_6_Q,
      O => N_1005_1
    );
  G_806_52 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(28),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(28),
      O => G_806
    );
  G_807_53 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(29),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(29),
      O => G_807
    );
  G_808_54 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(30),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(30),
      O => G_808
    );
  G_809_55 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(31),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(31),
      O => G_809
    );
  G_810_56 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(13),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(13),
      O => G_810
    );
  G_811_57 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(14),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(14),
      O => G_811
    );
  G_812_58 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(15),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(15),
      O => G_812
    );
  G_813_59 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(16),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(16),
      O => G_813
    );
  G_814_60 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(17),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(17),
      O => G_814
    );
  G_815_61 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(18),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(18),
      O => G_815
    );
  G_816_62 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(19),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(19),
      O => G_816
    );
  G_817_63 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(20),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(20),
      O => G_817
    );
  G_818_64 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(21),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(21),
      O => G_818
    );
  G_819_65 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(22),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(22),
      O => G_819
    );
  G_820_66 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(23),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(23),
      O => G_820
    );
  G_821_67 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(24),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(24),
      O => G_821
    );
  G_822_68 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(25),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(25),
      O => G_822
    );
  G_823_69 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(26),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(26),
      O => G_823
    );
  G_824_70 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(27),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(27),
      O => G_824
    );
  G_825_71 : X_LUT4
    generic map (
      INIT => X"2888"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => CRC_IN_CRC_GEN_COUNT(2),
      ADR2 => CRC_IN_CRC_GEN_COUNT(1),
      ADR3 => CRC_IN_CRC_GEN_COUNT(0),
      O => G_825
    );
  G_826_72 : X_LUT4
    generic map (
      INIT => X"2888"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => CRC_IN_N_63_1,
      ADR2 => CRC_IN_CRC_GEN_COUNT(2),
      ADR3 => CRC_IN_CRC_GEN_UN4_COUNT_C2,
      O => G_826
    );
  G_827_73 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(0),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(0),
      O => G_827
    );
  G_828_74 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(1),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(1),
      O => G_828
    );
  G_829_75 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(2),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(2),
      O => G_829
    );
  G_830_76 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(3),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(3),
      O => G_830
    );
  G_831_77 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(4),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(4),
      O => G_831
    );
  G_832_78 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(5),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(5),
      O => G_832
    );
  G_833_79 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(6),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(6),
      O => G_833
    );
  G_834_80 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(7),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(7),
      O => G_834
    );
  G_835_81 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(8),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(8),
      O => G_835
    );
  G_836_82 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(9),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(9),
      O => G_836
    );
  G_837_83 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(10),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(10),
      O => G_837
    );
  G_838_84 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(11),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(11),
      O => G_838
    );
  G_839_85 : X_LUT4
    generic map (
      INIT => X"FBEA"
    )
    port map (
      ADR0 => CRC_SEL_UN11_RES_0_AND3,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_CRC_GEN_CRC_CALC(12),
      ADR3 => CRC_IN_CRC_GEN_CRC_OUT(12),
      O => G_839
    );
  G_840_86 : X_LUT2
    generic map (
      INIT => X"4"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_COUNT(0),
      ADR1 => RESET_L_1,
      O => G_840
    );
  G_841_87 : X_LUT3
    generic map (
      INIT => X"28"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => CRC_IN_CRC_GEN_COUNT(1),
      ADR2 => CRC_IN_CRC_GEN_COUNT(0),
      O => G_841
    );
  G_842_88 : X_LUT3
    generic map (
      INIT => X"40"
    )
    port map (
      ADR0 => SEGMENT_G_844_Q_O0,
      ADR1 => SEGMENT_STATE_9_Q,
      ADR2 => SEGMENT_STATE_1_I_I_AND2_Q_O2,
      O => G_842
    );
  N_21_I : X_LUT2
    generic map (
      INIT => X"B"
    )
    port map (
      ADR0 => G_15_FAST,
      ADR1 => G_5,
      O => DATA_ENABLE_N_2366
    );
  N_21_I_REP1 : X_LUT2
    generic map (
      INIT => X"B"
    )
    port map (
      ADR0 => G_15_FAST,
      ADR1 => G_5,
      O => DATA_ENABLE_N_2366_REP1
    );
  N_994_I_89 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => SEGMENT_STATE_11_Q,
      ADR1 => RESET_L_1,
      O => N_994_I
    );
  N_999_I_90 : X_LUT3
    generic map (
      INIT => X"A8"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => DATA_ENABLE_STATE_IN_6_Q,
      ADR2 => DATA_ENABLE_STATE_IN_5_Q,
      O => N_999_I
    );
  N_1005_I_91 : X_LUT4
    generic map (
      INIT => X"5545"
    )
    port map (
      ADR0 => N_1005_1,
      ADR1 => G_1774,
      ADR2 => G_1829,
      ADR3 => DATA_ENABLE_STATE_OUT_6_Q,
      O => N_1005_I
    );
  RESET_L_0_92 : X_BUF
    port map (
      I => RESET_L,
      O => RESET_L_0
    );
  RESET_L_1_93 : X_BUF
    port map (
      I => RESET_L,
      O => RESET_L_1
    );
  RESET_L_I_94 : X_INV
    port map (
      I => RESET_L_1,
      O => RESET_L_I
    );
  VCC_95 : X_ONE
    port map (
      O => VCC_INT
    );
  ENABLE_IN_96 : X_FF
    port map (
      I => ENABLE_L,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => ENABLE_IN
    );
  ENABLE_IN_I : X_INV
    port map (
      I => ENABLE_IN,
      O => READY_L
    );
  CRC_IN_G_28 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_COUNT(0),
      ADR1 => CRC_IN_CRC_GEN_COUNT(1),
      O => CRC_IN_CRC_GEN_UN4_COUNT_C2
    );
  CRC_IN_G_180_G_103 : X_LUT3
    generic map (
      INIT => X"7F"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_COUNT(2),
      ADR1 => CRC_IN_N_63_1,
      ADR2 => CRC_IN_IS_LASTCELL,
      O => CRC_IN_G_103
    );
  CRC_IN_G_186 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(0),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(0),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(0)
    );
  CRC_IN_G_188 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(1),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(1),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(1)
    );
  CRC_IN_G_190 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(2),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(2),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(2)
    );
  CRC_IN_G_192 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(3),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(3),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(3)
    );
  CRC_IN_G_194 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(4),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(4),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(4)
    );
  CRC_IN_G_196 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(5),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(5),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(5)
    );
  CRC_IN_G_198 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(6),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(6),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(6)
    );
  CRC_IN_G_200 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(7),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(7),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(7)
    );
  CRC_IN_G_202 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(8),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(8),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(8)
    );
  CRC_IN_G_204 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(9),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(9),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(9)
    );
  CRC_IN_G_206 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(10),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(10),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(10)
    );
  CRC_IN_G_208 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(11),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(11),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(11)
    );
  CRC_IN_G_210 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(12),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(12),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(12)
    );
  CRC_IN_G_212 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(13),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(13),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(13)
    );
  CRC_IN_G_214 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(14),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(14),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(14)
    );
  CRC_IN_G_216 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(15),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(15),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(15)
    );
  CRC_IN_G_218 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(16),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(16),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(16)
    );
  CRC_IN_G_220 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(17),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(17),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(17)
    );
  CRC_IN_G_222 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(18),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(18),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(18)
    );
  CRC_IN_G_224 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(19),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(19),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(19)
    );
  CRC_IN_G_226 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(20),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(20),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(20)
    );
  CRC_IN_G_228 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(21),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(21),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(21)
    );
  CRC_IN_G_230 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(22),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(22),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(22)
    );
  CRC_IN_G_232 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(23),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(23),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(23)
    );
  CRC_IN_G_234 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(24),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(24),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(24)
    );
  CRC_IN_G_236 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(25),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(25),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(25)
    );
  CRC_IN_G_238 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(26),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(26),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(26)
    );
  CRC_IN_G_240 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(27),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(27),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(27)
    );
  CRC_IN_G_242 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(28),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(28),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(28)
    );
  CRC_IN_G_244 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(29),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(29),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(29)
    );
  CRC_IN_G_246 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(30),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(30),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(30)
    );
  CRC_IN_G_248 : X_LUT4
    generic map (
      INIT => X"AAA9"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(31),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(31),
      ADR2 => CRC_IN_G_103,
      ADR3 => CRC_IN_G_249,
      O => CRC_IN_NX_DATA(31)
    );
  CRC_IN_G_249_97 : X_LUT2
    generic map (
      INIT => X"E"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_COUNT(0),
      ADR1 => CRC_IN_CRC_GEN_COUNT(1),
      O => CRC_IN_G_249
    );
  CRC_IN_I_12_0_AND3_G_34 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => CRC_IN_N_63_1,
      ADR1 => CRC_IN_CRC_GEN_COUNT(2),
      O => CRC_IN_G_34
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_0_Q : X_FF
    port map (
      I => D_MOD_IN(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(0)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_1_Q : X_FF
    port map (
      I => D_MOD_IN(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(1)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_2_Q : X_FF
    port map (
      I => D_MOD_IN(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(2)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_3_Q : X_FF
    port map (
      I => D_MOD_IN(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(3)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_4_Q : X_FF
    port map (
      I => D_MOD_IN(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(4)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_5_Q : X_FF
    port map (
      I => D_MOD_IN(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(5)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_6_Q : X_FF
    port map (
      I => D_MOD_IN(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(6)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_7_Q : X_FF
    port map (
      I => D_MOD_IN(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(7)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_8_Q : X_FF
    port map (
      I => D_MOD_IN(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(8)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_9_Q : X_FF
    port map (
      I => D_MOD_IN(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(9)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_10_Q : X_FF
    port map (
      I => D_MOD_IN(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(10)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_11_Q : X_FF
    port map (
      I => D_MOD_IN(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(11)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_12_Q : X_FF
    port map (
      I => D_MOD_IN(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(12)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_13_Q : X_FF
    port map (
      I => D_MOD_IN(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(13)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_14_Q : X_FF
    port map (
      I => D_MOD_IN(14),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(14)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_15_Q : X_FF
    port map (
      I => D_MOD_IN(15),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(15)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_16_Q : X_FF
    port map (
      I => D_MOD_IN(16),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(16)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_17_Q : X_FF
    port map (
      I => D_MOD_IN(17),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(17)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_18_Q : X_FF
    port map (
      I => D_MOD_IN(18),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(18)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_19_Q : X_FF
    port map (
      I => D_MOD_IN(19),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(19)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_20_Q : X_FF
    port map (
      I => D_MOD_IN(20),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(20)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_21_Q : X_FF
    port map (
      I => D_MOD_IN(21),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(21)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_22_Q : X_FF
    port map (
      I => D_MOD_IN(22),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(22)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_23_Q : X_FF
    port map (
      I => D_MOD_IN(23),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(23)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_24_Q : X_FF
    port map (
      I => D_MOD_IN(24),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(24)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_25_Q : X_FF
    port map (
      I => D_MOD_IN(25),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(25)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_26_Q : X_FF
    port map (
      I => D_MOD_IN(26),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(26)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_27_Q : X_FF
    port map (
      I => D_MOD_IN(27),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(27)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_28_Q : X_FF
    port map (
      I => D_MOD_IN(28),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(28)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_29_Q : X_FF
    port map (
      I => D_MOD_IN(29),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(29)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_30_Q : X_FF
    port map (
      I => D_MOD_IN(30),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(30)
    );
  CRC_IN_CRC_GEN_D_OUT_MOD_31_Q : X_FF
    port map (
      I => D_MOD_IN(31),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_DATA_WIRE(31)
    );
  CRC_IN_CRC_GEN_N_1_I_98 : X_LUT4
    generic map (
      INIT => X"1511"
    )
    port map (
      ADR0 => SOC2,
      ADR1 => CRC_IN_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_IN_G_249,
      ADR3 => CRC_IN_G_34,
      O => CRC_IN_CRC_GEN_N_1_I
    );
  CRC_IN_CRC_GEN_SOC_OUT_MOD : X_FF
    port map (
      I => SOC_MOD_IN,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_IN_CRC_GEN_SOC_WIRE
    );
  CRC_IN_CRC_GEN_COUNT_0_Q : X_SFF
    port map (
      I => G_840,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CRC_IN_CRC_GEN_SOC_WIRE,
      O => CRC_IN_CRC_GEN_COUNT(0)
    );
  CRC_IN_CRC_GEN_COUNT_1_Q : X_SFF
    port map (
      I => G_841,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CRC_IN_CRC_GEN_SOC_WIRE,
      O => CRC_IN_CRC_GEN_COUNT(1)
    );
  CRC_IN_CRC_GEN_COUNT_2_Q : X_SFF
    port map (
      I => G_825,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CRC_IN_CRC_GEN_SOC_WIRE,
      O => CRC_IN_CRC_GEN_COUNT(2)
    );
  CRC_IN_CRC_GEN_COUNT_3_Q : X_SFF
    port map (
      I => G_826,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CRC_IN_CRC_GEN_SOC_WIRE,
      O => CRC_IN_N_63_1
    );
  CRC_IN_CRC_GEN_CRC_OUT_0_Q : X_SFF
    port map (
      I => G_827,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(0)
    );
  CRC_IN_CRC_GEN_CRC_OUT_1_Q : X_SFF
    port map (
      I => G_828,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(1)
    );
  CRC_IN_CRC_GEN_CRC_OUT_2_Q : X_SFF
    port map (
      I => G_829,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(2)
    );
  CRC_IN_CRC_GEN_CRC_OUT_3_Q : X_SFF
    port map (
      I => G_830,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(3)
    );
  CRC_IN_CRC_GEN_CRC_OUT_4_Q : X_SFF
    port map (
      I => G_831,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(4)
    );
  CRC_IN_CRC_GEN_CRC_OUT_5_Q : X_SFF
    port map (
      I => G_832,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(5)
    );
  CRC_IN_CRC_GEN_CRC_OUT_6_Q : X_SFF
    port map (
      I => G_833,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(6)
    );
  CRC_IN_CRC_GEN_CRC_OUT_7_Q : X_SFF
    port map (
      I => G_834,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(7)
    );
  CRC_IN_CRC_GEN_CRC_OUT_8_Q : X_SFF
    port map (
      I => G_835,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(8)
    );
  CRC_IN_CRC_GEN_CRC_OUT_9_Q : X_SFF
    port map (
      I => G_836,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(9)
    );
  CRC_IN_CRC_GEN_CRC_OUT_10_Q : X_SFF
    port map (
      I => G_837,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(10)
    );
  CRC_IN_CRC_GEN_CRC_OUT_11_Q : X_SFF
    port map (
      I => G_838,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(11)
    );
  CRC_IN_CRC_GEN_CRC_OUT_12_Q : X_SFF
    port map (
      I => G_839,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(12)
    );
  CRC_IN_CRC_GEN_CRC_OUT_13_Q : X_SFF
    port map (
      I => G_810,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(13)
    );
  CRC_IN_CRC_GEN_CRC_OUT_14_Q : X_SFF
    port map (
      I => G_811,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(14)
    );
  CRC_IN_CRC_GEN_CRC_OUT_15_Q : X_SFF
    port map (
      I => G_812,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(15)
    );
  CRC_IN_CRC_GEN_CRC_OUT_16_Q : X_SFF
    port map (
      I => G_813,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(16)
    );
  CRC_IN_CRC_GEN_CRC_OUT_17_Q : X_SFF
    port map (
      I => G_814,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(17)
    );
  CRC_IN_CRC_GEN_CRC_OUT_18_Q : X_SFF
    port map (
      I => G_815,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(18)
    );
  CRC_IN_CRC_GEN_CRC_OUT_19_Q : X_SFF
    port map (
      I => G_816,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(19)
    );
  CRC_IN_CRC_GEN_CRC_OUT_20_Q : X_SFF
    port map (
      I => G_817,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(20)
    );
  CRC_IN_CRC_GEN_CRC_OUT_21_Q : X_SFF
    port map (
      I => G_818,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(21)
    );
  CRC_IN_CRC_GEN_CRC_OUT_22_Q : X_SFF
    port map (
      I => G_819,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(22)
    );
  CRC_IN_CRC_GEN_CRC_OUT_23_Q : X_SFF
    port map (
      I => G_820,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(23)
    );
  CRC_IN_CRC_GEN_CRC_OUT_24_Q : X_SFF
    port map (
      I => G_821,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(24)
    );
  CRC_IN_CRC_GEN_CRC_OUT_25_Q : X_SFF
    port map (
      I => G_822,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(25)
    );
  CRC_IN_CRC_GEN_CRC_OUT_26_Q : X_SFF
    port map (
      I => G_823,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(26)
    );
  CRC_IN_CRC_GEN_CRC_OUT_27_Q : X_SFF
    port map (
      I => G_824,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(27)
    );
  CRC_IN_CRC_GEN_CRC_OUT_28_Q : X_SFF
    port map (
      I => G_806,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(28)
    );
  CRC_IN_CRC_GEN_CRC_OUT_29_Q : X_SFF
    port map (
      I => G_807,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(29)
    );
  CRC_IN_CRC_GEN_CRC_OUT_30_Q : X_SFF
    port map (
      I => G_808,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(30)
    );
  CRC_IN_CRC_GEN_CRC_OUT_31_Q : X_SFF
    port map (
      I => G_809,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_CRC_GEN_CRC_OUT(31)
    );
  CRC_IN_CRC_GEN_CRC_SEL_UN11_RES_0_AND3 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_SOC_WIRE,
      ADR1 => CRC_IN_IS_LASTCELL,
      O => CRC_SEL_UN11_RES_0_AND3
    );
  CRC_IN_CRC_GEN_DATAEN_BUF_99 : X_SFF
    port map (
      I => RESET_L_0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CRC_IN_CRC_GEN_N_1_I,
      O => CRC_IN_CRC_GEN_DATAEN_BUF
    );
  CRC_IN_CRC_GEN_IS_LASTCELL : X_SFF
    port map (
      I => CRC_IN_DATA_WIRE(1),
      CLK => CLK,
      CE => CRC_IN_CRC_GEN_SOC_WIRE,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_IN_IS_LASTCELL
    );
  CRC_IN_CRC_GEN_SOC_DELAY : X_FF
    port map (
      I => CRC_IN_CRC_GEN_SOC_WIRE,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SOC2
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_418,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_415,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_G_432,
      O => CRC_IN_CRC_GEN_CRC_CALC(0)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_Q_G_412 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(28),
      ADR1 => CRC_IN_DATA_WIRE(28),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(16),
      ADR3 => CRC_IN_DATA_WIRE(16),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_412
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_Q_G_415 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(26),
      ADR1 => CRC_IN_DATA_WIRE(26),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(24),
      ADR3 => CRC_IN_DATA_WIRE(24),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_415
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_Q_G_418 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_412,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_0_Q,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_6_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_418
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ11_Q : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110,
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(29),
      ADR2 => CRC_IN_DATA_WIRE(29),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_G_218,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_G_216,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_0,
      O => CRC_IN_CRC_GEN_CRC_CALC(1)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_Q_G_216 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q100,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_0,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_G_216
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_Q_G_218 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q000,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_13_Q,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_24_Q,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_9_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_G_218
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_G_357,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_G_355,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_1,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q100_0,
      O => CRC_IN_CRC_GEN_CRC_CALC(2)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_Q_G_352 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(9),
      ADR1 => CRC_IN_DATA_WIRE(9),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(13),
      ADR3 => CRC_IN_DATA_WIRE(13),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_G_352
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_Q_G_355 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q000,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_G_355
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_Q_G_357 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_G_352,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_0,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_1,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_G_357
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_121,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_120,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q100_1,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q000_0,
      O => CRC_IN_CRC_GEN_CRC_CALC(3)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_Q_G_114 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(31),
      ADR1 => CRC_IN_DATA_WIRE(31),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(7),
      ADR3 => CRC_IN_DATA_WIRE(7),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_114
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_Q_G_115 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(10),
      ADR1 => CRC_IN_DATA_WIRE(10),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(3),
      ADR3 => CRC_IN_DATA_WIRE(3),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_115
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_Q_G_116 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(27),
      ADR1 => CRC_IN_DATA_WIRE(27),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(25),
      ADR3 => CRC_IN_DATA_WIRE(25),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_116
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_Q_G_120 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_0,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_114,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_14_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_120
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_Q_G_121 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_1,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_116,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_115,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_121
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_295,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_294,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_0,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q011,
      O => CRC_IN_CRC_GEN_CRC_CALC(4)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_Q_G_288 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(29),
      ADR1 => CRC_IN_DATA_WIRE(29),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(20),
      ADR3 => CRC_IN_DATA_WIRE(20),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_288
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_Q_G_289 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(0),
      ADR1 => CRC_IN_DATA_WIRE(0),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(25),
      ADR3 => CRC_IN_DATA_WIRE(25),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_289
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_Q_G_291 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_289,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_291
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_Q_G_294 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_2,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_288,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_24_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_294
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_Q_G_295 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_291,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_2,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_3_Q,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_2_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_295
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_G_573,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q00,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q011_0,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_1,
      O => CRC_IN_CRC_GEN_CRC_CALC(5)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_Q_G_568 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(6),
      ADR1 => CRC_IN_DATA_WIRE(6),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(19),
      ADR3 => CRC_IN_DATA_WIRE(19),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_G_568
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_Q_G_569 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(5),
      ADR1 => CRC_IN_DATA_WIRE(5),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(24),
      ADR3 => CRC_IN_DATA_WIRE(24),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_G_569
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_Q_G_573 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_G_568,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_13_Q,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_2,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_G_569,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_G_573
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ00_Q : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q000,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_4_Q,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_3_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q00
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_262,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_261,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_3,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_3,
      O => CRC_IN_CRC_GEN_CRC_CALC(6)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_Q_G_258 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_14_Q,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_20_Q,
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(25),
      ADR3 => CRC_IN_DATA_WIRE(25),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_258
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_Q_G_261 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_2,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_0,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_261
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_Q_G_262 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_258,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_2,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q000_0,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_262
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_477,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_4,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_0,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_2,
      O => CRC_IN_CRC_GEN_CRC_CALC(7)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_Q_G_471 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(16),
      ADR1 => CRC_IN_DATA_WIRE(16),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(15),
      ADR3 => CRC_IN_DATA_WIRE(15),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_471
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_Q_G_472 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(21),
      ADR1 => CRC_IN_DATA_WIRE(21),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(10),
      ADR3 => CRC_IN_DATA_WIRE(10),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_472
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_Q_G_475 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_3,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_472,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_471,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_475
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_Q_G_477 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_475,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_G_56,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_4,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_477
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ00_Q_G_56 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(2),
      ADR1 => CRC_IN_DATA_WIRE(2),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(0),
      ADR3 => CRC_IN_DATA_WIRE(0),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_G_56
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ111_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(28),
      ADR1 => CRC_IN_DATA_WIRE(28),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(29),
      ADR3 => CRC_IN_DATA_WIRE(29),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_2
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q00,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_G_565,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_G_564,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_5,
      O => CRC_IN_CRC_GEN_CRC_CALC(8)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_Q_G_561 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(22),
      ADR1 => CRC_IN_DATA_WIRE(22),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(17),
      ADR3 => CRC_IN_DATA_WIRE(17),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_G_561
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_Q_G_562 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(8),
      ADR1 => CRC_IN_DATA_WIRE(8),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(11),
      ADR3 => CRC_IN_DATA_WIRE(11),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_2
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_Q_G_564 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_2,
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(12),
      ADR2 => CRC_IN_DATA_WIRE(12),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_G_564
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_Q_G_565 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_G_561,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_23_Q,
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(10),
      ADR3 => CRC_IN_DATA_WIRE(10),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_G_565
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_87,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_3,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_13_Q,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_24_Q,
      O => CRC_IN_CRC_GEN_CRC_CALC(9)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_Q_G_79 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(1),
      ADR1 => CRC_IN_DATA_WIRE(1),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(2),
      ADR3 => CRC_IN_DATA_WIRE(2),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q000_0
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_Q_G_80 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(23),
      ADR1 => CRC_IN_DATA_WIRE(23),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(29),
      ADR3 => CRC_IN_DATA_WIRE(29),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_80
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_Q_G_81 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(18),
      ADR1 => CRC_IN_DATA_WIRE(18),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(5),
      ADR3 => CRC_IN_DATA_WIRE(5),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_81
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_Q_G_82 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(4),
      ADR1 => CRC_IN_DATA_WIRE(4),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(12),
      ADR3 => CRC_IN_DATA_WIRE(12),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_82
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_Q_G_87 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_80,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q000_0,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_82,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_81,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_87
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_G_580,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11_0,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_G_56,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_4,
      O => CRC_IN_CRC_GEN_CRC_CALC(10)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_Q_G_576 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(16),
      ADR1 => CRC_IN_DATA_WIRE(16),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(19),
      ADR3 => CRC_IN_DATA_WIRE(19),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_G_576
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_Q_G_578 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(14),
      ADR1 => CRC_IN_DATA_WIRE(14),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(13),
      ADR3 => CRC_IN_DATA_WIRE(13),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_G_578
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_Q_G_580 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_G_578,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_G_576,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_26_Q,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_9_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_G_580
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ11_Q : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_6,
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(28),
      ADR2 => CRC_IN_DATA_WIRE(28),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11_0
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_351,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_4,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_5,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_344,
      O => CRC_IN_CRC_GEN_CRC_CALC(11)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_Q_G_341 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(1),
      ADR1 => CRC_IN_DATA_WIRE(1),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(17),
      ADR3 => CRC_IN_DATA_WIRE(17),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_341
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_Q_G_342 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(20),
      ADR1 => CRC_IN_DATA_WIRE(20),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(3),
      ADR3 => CRC_IN_DATA_WIRE(3),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_342
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_Q_G_343 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(4),
      ADR1 => CRC_IN_DATA_WIRE(4),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(0),
      ADR3 => CRC_IN_DATA_WIRE(0),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_343
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_Q_G_344 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(12),
      ADR1 => CRC_IN_DATA_WIRE(12),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(9),
      ADR3 => CRC_IN_DATA_WIRE(9),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_344
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_Q_G_348 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q011_1,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_341,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_14_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_348
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_Q_G_351 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_348,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_7,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_343,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_342,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_351
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_149,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_148,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_3,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q100_1,
      O => CRC_IN_CRC_GEN_CRC_CALC(12)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_Q_G_142 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(27),
      ADR1 => CRC_IN_DATA_WIRE(27),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(0),
      ADR3 => CRC_IN_DATA_WIRE(0),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_142
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_Q_G_143 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(12),
      ADR1 => CRC_IN_DATA_WIRE(12),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(24),
      ADR3 => CRC_IN_DATA_WIRE(24),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_143
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_Q_G_144 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_13_Q,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_21_Q,
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(18),
      ADR3 => CRC_IN_DATA_WIRE(18),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_144
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_Q_G_145 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_142,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_145
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_Q_G_148 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_144,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_9_Q,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_6_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_148
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_Q_G_149 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_145,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_143,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q000_0,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_149
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ001_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(4),
      ADR1 => CRC_IN_DATA_WIRE(4),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(5),
      ADR3 => CRC_IN_DATA_WIRE(5),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_3
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_304,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_302,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q100_0,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_0,
      O => CRC_IN_CRC_GEN_CRC_CALC(13)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_Q_G_298 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(22),
      ADR1 => CRC_IN_DATA_WIRE(22),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(10),
      ADR3 => CRC_IN_DATA_WIRE(10),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_298
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_Q_G_299 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(25),
      ADR1 => CRC_IN_DATA_WIRE(25),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(13),
      ADR3 => CRC_IN_DATA_WIRE(13),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_299
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_Q_G_302 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_4,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_0,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_302
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_Q_G_304 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q000_0,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_298,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_5,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_299,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_304
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ001_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(3),
      ADR1 => CRC_IN_DATA_WIRE(3),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(5),
      ADR3 => CRC_IN_DATA_WIRE(5),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_4
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ010_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(6),
      ADR1 => CRC_IN_DATA_WIRE(6),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(7),
      ADR3 => CRC_IN_DATA_WIRE(7),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_0
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ100_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(14),
      ADR1 => CRC_IN_DATA_WIRE(14),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(16),
      ADR3 => CRC_IN_DATA_WIRE(16),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q100_0
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ101_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(18),
      ADR1 => CRC_IN_DATA_WIRE(18),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(19),
      ADR3 => CRC_IN_DATA_WIRE(19),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_0
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_233,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_228,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q100_1,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_227,
      O => CRC_IN_CRC_GEN_CRC_CALC(14)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_Q_G_227 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(29),
      ADR1 => CRC_IN_DATA_WIRE(29),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(26),
      ADR3 => CRC_IN_DATA_WIRE(26),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_227
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_Q_G_228 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_14_Q,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_23_Q,
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(11),
      ADR3 => CRC_IN_DATA_WIRE(11),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_228
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_Q_G_230 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_0,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_3_Q,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_2_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_230
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_Q_G_233 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_230,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_2,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_4,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_233
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ100_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(15),
      ADR1 => CRC_IN_DATA_WIRE(15),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(17),
      ADR3 => CRC_IN_DATA_WIRE(17),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q100_1
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_G_270,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_G_268,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_1,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q011,
      O => CRC_IN_CRC_GEN_CRC_CALC(15)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_Q_G_265 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(30),
      ADR1 => CRC_IN_DATA_WIRE(30),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(27),
      ADR3 => CRC_IN_DATA_WIRE(27),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_G_265
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_Q_G_268 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_1,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_4_Q,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_3_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_G_268
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_Q_G_270 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_G_265,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_24_Q,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_5,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q100_2,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_G_270
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ011_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(12),
      ADR1 => CRC_IN_DATA_WIRE(12),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(15),
      ADR3 => CRC_IN_DATA_WIRE(15),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q011
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_204,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_202,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_3,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_6,
      O => CRC_IN_CRC_GEN_CRC_CALC(16)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_Q_G_197 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(17),
      ADR1 => CRC_IN_DATA_WIRE(17),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(21),
      ADR3 => CRC_IN_DATA_WIRE(21),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_197
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_Q_G_199 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(0),
      ADR1 => CRC_IN_DATA_WIRE(0),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(12),
      ADR3 => CRC_IN_DATA_WIRE(12),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_199
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_Q_G_201 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_197,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_4_Q,
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(19),
      ADR3 => CRC_IN_DATA_WIRE(19),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_201
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_Q_G_202 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_199,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_13_Q,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_26_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_202
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_Q_G_204 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_201,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_24_Q,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_22_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_204
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_174,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_173,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_169,
      O => CRC_IN_CRC_GEN_CRC_CALC(17)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_Q_G_167 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(1),
      ADR1 => CRC_IN_DATA_WIRE(1),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(22),
      ADR3 => CRC_IN_DATA_WIRE(22),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_167
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_Q_G_169 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(27),
      ADR1 => CRC_IN_DATA_WIRE(27),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(5),
      ADR3 => CRC_IN_DATA_WIRE(5),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_169
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_Q_G_171 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_167,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_20_Q,
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(18),
      ADR3 => CRC_IN_DATA_WIRE(18),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_171
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_Q_G_173 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_G_578,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_23_Q,
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(25),
      ADR3 => CRC_IN_DATA_WIRE(25),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_173
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_Q_G_174 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_171,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_9_Q,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_6_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_174
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_449,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11_1,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q011_0,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_1,
      O => CRC_IN_CRC_GEN_CRC_CALC(18)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_Q_G_445 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(15),
      ADR1 => CRC_IN_DATA_WIRE(15),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(21),
      ADR3 => CRC_IN_DATA_WIRE(21),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_445
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_Q_G_446 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(19),
      ADR1 => CRC_IN_DATA_WIRE(19),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(14),
      ADR3 => CRC_IN_DATA_WIRE(14),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_446
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_Q_G_449 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_24_Q,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_23_Q,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_446,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_445,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_449
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ000_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(2),
      ADR1 => CRC_IN_DATA_WIRE(2),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(6),
      ADR3 => CRC_IN_DATA_WIRE(6),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_1
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ11_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_5,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_26_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11_1
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_G_189,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_G_187,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_0,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q011_1,
      O => CRC_IN_CRC_GEN_CRC_CALC(19)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_Q_G_186 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(3),
      ADR1 => CRC_IN_DATA_WIRE(3),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(25),
      ADR3 => CRC_IN_DATA_WIRE(25),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_G_186
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_Q_G_187 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_G_186,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_20_Q,
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(11),
      ADR3 => CRC_IN_DATA_WIRE(11),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_G_187
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_Q_G_189 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_8,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_24_Q,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_22_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_G_189
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ000_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(7),
      ADR1 => CRC_IN_DATA_WIRE(7),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(8),
      ADR3 => CRC_IN_DATA_WIRE(8),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_0
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_G_112,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_G_110,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q100,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_9,
      O => CRC_IN_CRC_GEN_CRC_CALC(20)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_Q_G_108 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(21),
      ADR1 => CRC_IN_DATA_WIRE(21),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(4),
      ADR3 => CRC_IN_DATA_WIRE(4),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_G_108
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_Q_G_110 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_G_108,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_26_Q,
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(12),
      ADR3 => CRC_IN_DATA_WIRE(12),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_G_110
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_Q_G_112 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_1,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_23_Q,
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(25),
      ADR3 => CRC_IN_DATA_WIRE(25),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_G_112
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ000_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(8),
      ADR1 => CRC_IN_DATA_WIRE(8),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(9),
      ADR3 => CRC_IN_DATA_WIRE(9),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_1
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11_2,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ_G_528,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101,
      O => CRC_IN_CRC_GEN_CRC_CALC(21)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ_Q_G_526 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_13_Q,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_22_Q,
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(5),
      ADR3 => CRC_IN_DATA_WIRE(5),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ_G_526
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ_Q_G_528 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ_G_526,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_1,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ_G_528
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ000_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(9),
      ADR1 => CRC_IN_DATA_WIRE(9),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(10),
      ADR3 => CRC_IN_DATA_WIRE(10),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ11_Q : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_6,
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(27),
      ADR2 => CRC_IN_DATA_WIRE(27),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11_2
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_497,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11_2,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_494,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010,
      O => CRC_IN_CRC_GEN_CRC_CALC(22)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_Q_G_492 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(23),
      ADR1 => CRC_IN_DATA_WIRE(23),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(19),
      ADR3 => CRC_IN_DATA_WIRE(19),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_492
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_Q_G_493 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(0),
      ADR1 => CRC_IN_DATA_WIRE(0),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(9),
      ADR3 => CRC_IN_DATA_WIRE(9),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_493
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_Q_G_494 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_14_Q,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_492,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_494
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_Q_G_497 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_1,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q100_2,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_493,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_497
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ001_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(11),
      ADR1 => CRC_IN_DATA_WIRE(11),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(12),
      ADR3 => CRC_IN_DATA_WIRE(12),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ010_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(16),
      ADR1 => CRC_IN_DATA_WIRE(16),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(18),
      ADR3 => CRC_IN_DATA_WIRE(18),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q100_2
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ101_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(24),
      ADR1 => CRC_IN_DATA_WIRE(24),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(26),
      ADR3 => CRC_IN_DATA_WIRE(26),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_1
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_G_507,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_G_506,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11_2,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_G_508,
      O => CRC_IN_CRC_GEN_CRC_CALC(23)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_Q_G_506 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_13_Q,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_20_Q,
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(17),
      ADR3 => CRC_IN_DATA_WIRE(17),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_G_506
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_Q_G_507 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q011_1,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_26_Q,
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(19),
      ADR3 => CRC_IN_DATA_WIRE(19),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_G_507
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_Q_G_508 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q000,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_9_Q,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_6_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_G_508
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ000_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(0),
      ADR1 => CRC_IN_DATA_WIRE(0),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(1),
      ADR3 => CRC_IN_DATA_WIRE(1),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q000
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ010_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(15),
      ADR1 => CRC_IN_DATA_WIRE(15),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(16),
      ADR3 => CRC_IN_DATA_WIRE(16),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q011_1
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ_G_423,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11_3,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_1,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q100,
      O => CRC_IN_CRC_GEN_CRC_CALC(24)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ_Q_G_420 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(18),
      ADR1 => CRC_IN_DATA_WIRE(18),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(14),
      ADR3 => CRC_IN_DATA_WIRE(14),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ_G_420
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ_Q_G_423 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q011_0,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q000_0,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ_G_420,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ_G_423
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ010_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(16),
      ADR1 => CRC_IN_DATA_WIRE(16),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(17),
      ADR3 => CRC_IN_DATA_WIRE(17),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q100
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ11_Q : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_9,
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(27),
      ADR2 => CRC_IN_DATA_WIRE(27),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11_3
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ_G_502,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11_0,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_2,
      O => CRC_IN_CRC_GEN_CRC_CALC(25)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ_Q_G_499 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(15),
      ADR1 => CRC_IN_DATA_WIRE(15),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(19),
      ADR3 => CRC_IN_DATA_WIRE(19),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ_G_499
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ_Q_G_502 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_3_Q,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_2_Q,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_2,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ_G_499,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ_G_502
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ010_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(17),
      ADR1 => CRC_IN_DATA_WIRE(17),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(18),
      ADR3 => CRC_IN_DATA_WIRE(18),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_G_456,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11_1,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_G_453,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_2,
      O => CRC_IN_CRC_GEN_CRC_CALC(26)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_Q_G_451 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(18),
      ADR1 => CRC_IN_DATA_WIRE(18),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(10),
      ADR3 => CRC_IN_DATA_WIRE(10),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_G_451
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_Q_G_453 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_G_451,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_0_Q,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_3_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_G_453
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_Q_G_456 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_4,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_4,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_3,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_G_456
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ001_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(4),
      ADR1 => CRC_IN_DATA_WIRE(4),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(6),
      ADR3 => CRC_IN_DATA_WIRE(6),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_2
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ110_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(28),
      ADR1 => CRC_IN_DATA_WIRE(28),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(31),
      ADR3 => CRC_IN_DATA_WIRE(31),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_5
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_G_320,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_G_318,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_4,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_5,
      O => CRC_IN_CRC_GEN_CRC_CALC(27)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_Q_G_314 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(1),
      ADR1 => CRC_IN_DATA_WIRE(1),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(11),
      ADR3 => CRC_IN_DATA_WIRE(11),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_G_314
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_Q_G_318 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_8,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_26_Q,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_4_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_G_318
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_Q_G_320 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_4,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_G_314,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_21_Q,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_23_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_G_320
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ001_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(5),
      ADR1 => CRC_IN_DATA_WIRE(5),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(7),
      ADR3 => CRC_IN_DATA_WIRE(7),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_5
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ010_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(19),
      ADR1 => CRC_IN_DATA_WIRE(19),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(20),
      ADR3 => CRC_IN_DATA_WIRE(20),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_4
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ101_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(24),
      ADR1 => CRC_IN_DATA_WIRE(24),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(25),
      ADR3 => CRC_IN_DATA_WIRE(25),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_4
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ110_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(27),
      ADR1 => CRC_IN_DATA_WIRE(27),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(29),
      ADR3 => CRC_IN_DATA_WIRE(29),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_8
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_G_437,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_G_434,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_24_Q,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_22_Q,
      O => CRC_IN_CRC_GEN_CRC_CALC(28)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_Q_G_430 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(2),
      ADR1 => CRC_IN_DATA_WIRE(2),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(8),
      ADR3 => CRC_IN_DATA_WIRE(8),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_G_430
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_Q_G_432 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(25),
      ADR1 => CRC_IN_DATA_WIRE(25),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(12),
      ADR3 => CRC_IN_DATA_WIRE(12),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_G_432
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_Q_G_434 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_G_432,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_6_Q,
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(5),
      ADR3 => CRC_IN_DATA_WIRE(5),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_G_434
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_Q_G_437 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11_3,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_26_Q,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_G_430,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_1,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_G_437
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ010_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(20),
      ADR1 => CRC_IN_DATA_WIRE(20),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(21),
      ADR3 => CRC_IN_DATA_WIRE(21),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_1
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ110_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(28),
      ADR1 => CRC_IN_DATA_WIRE(28),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(30),
      ADR3 => CRC_IN_DATA_WIRE(30),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_9
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_491,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_7,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_2,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_486,
      O => CRC_IN_CRC_GEN_CRC_CALC(29)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_Q_G_486 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(3),
      ADR1 => CRC_IN_DATA_WIRE(3),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(9),
      ADR3 => CRC_IN_DATA_WIRE(9),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_486
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_Q_G_487 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_13_Q,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_6_Q,
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(7),
      ADR3 => CRC_IN_DATA_WIRE(7),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_487
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_Q_G_489 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_487,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_23_Q,
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(25),
      ADR3 => CRC_IN_DATA_WIRE(25),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_489
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_Q_G_491 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_489,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11_0,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_491
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ010_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(21),
      ADR1 => CRC_IN_DATA_WIRE(21),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(22),
      ADR3 => CRC_IN_DATA_WIRE(22),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_2
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ110_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(29),
      ADR1 => CRC_IN_DATA_WIRE(29),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(31),
      ADR3 => CRC_IN_DATA_WIRE(31),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_6
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_G_240,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_G_238,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_3,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_3,
      O => CRC_IN_CRC_GEN_CRC_CALC(30)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_Q_G_234 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(28),
      ADR1 => CRC_IN_DATA_WIRE(28),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(8),
      ADR3 => CRC_IN_DATA_WIRE(8),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_G_234
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_Q_G_235 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(7),
      ADR1 => CRC_IN_DATA_WIRE(7),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(10),
      ADR3 => CRC_IN_DATA_WIRE(10),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q011_0
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_Q_G_238 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q011_0,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_14_Q,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_4_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_G_238
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_Q_G_240 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_7,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_G_234,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_24_Q,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_G_240
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ010_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(22),
      ADR1 => CRC_IN_DATA_WIRE(22),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(23),
      ADR3 => CRC_IN_DATA_WIRE(23),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q101_3
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ100_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(26),
      ADR1 => CRC_IN_DATA_WIRE(26),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(27),
      ADR3 => CRC_IN_DATA_WIRE(27),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_7
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ110_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(29),
      ADR1 => CRC_IN_DATA_WIRE(29),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(30),
      ADR3 => CRC_IN_DATA_WIRE(30),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_3
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_G_428,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q11,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_3,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_6,
      O => CRC_IN_CRC_GEN_CRC_CALC(31)
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_Q_G_425 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(15),
      ADR1 => CRC_IN_DATA_WIRE(15),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(25),
      ADR3 => CRC_IN_DATA_WIRE(25),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_G_425
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_Q_G_428 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_24_Q,
      ADR1 => CRC_IN_CRC_GEN_CRCCALC_PREXORED_23_Q,
      ADR2 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_0,
      ADR3 => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_G_425,
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_G_428
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ000_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(5),
      ADR1 => CRC_IN_DATA_WIRE(5),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(8),
      ADR3 => CRC_IN_DATA_WIRE(8),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q001_6
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ001_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(9),
      ADR1 => CRC_IN_DATA_WIRE(9),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(11),
      ADR3 => CRC_IN_DATA_WIRE(11),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q010_3
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ100_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(27),
      ADR1 => CRC_IN_DATA_WIRE(27),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(28),
      ADR3 => CRC_IN_DATA_WIRE(28),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110_0
    );
  CRC_IN_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ110_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_IN_CRC_GEN_CRC_OUT(30),
      ADR1 => CRC_IN_DATA_WIRE(30),
      ADR2 => CRC_IN_CRC_GEN_CRC_OUT(31),
      ADR3 => CRC_IN_DATA_WIRE(31),
      O => CRC_IN_CRC_GEN_CRCCALC_MATRIX_Q110
    );
  CRC_IN_CRC_GEN_CRCCALC_PREXOR_THEXOR0_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(0),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(0),
      O => CRC_IN_CRC_GEN_CRCCALC_PREXORED_0_Q
    );
  CRC_IN_CRC_GEN_CRCCALC_PREXOR_THEXOR2_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(2),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(2),
      O => CRC_IN_CRC_GEN_CRCCALC_PREXORED_2_Q
    );
  CRC_IN_CRC_GEN_CRCCALC_PREXOR_THEXOR3_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(3),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(3),
      O => CRC_IN_CRC_GEN_CRCCALC_PREXORED_3_Q
    );
  CRC_IN_CRC_GEN_CRCCALC_PREXOR_THEXOR4_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(4),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(4),
      O => CRC_IN_CRC_GEN_CRCCALC_PREXORED_4_Q
    );
  CRC_IN_CRC_GEN_CRCCALC_PREXOR_THEXOR6_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(6),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(6),
      O => CRC_IN_CRC_GEN_CRCCALC_PREXORED_6_Q
    );
  CRC_IN_CRC_GEN_CRCCALC_PREXOR_THEXOR9_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(9),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(9),
      O => CRC_IN_CRC_GEN_CRCCALC_PREXORED_9_Q
    );
  CRC_IN_CRC_GEN_CRCCALC_PREXOR_THEXOR13_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(13),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(13),
      O => CRC_IN_CRC_GEN_CRCCALC_PREXORED_13_Q
    );
  CRC_IN_CRC_GEN_CRCCALC_PREXOR_THEXOR14_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(14),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(14),
      O => CRC_IN_CRC_GEN_CRCCALC_PREXORED_14_Q
    );
  CRC_IN_CRC_GEN_CRCCALC_PREXOR_THEXOR20_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(20),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(20),
      O => CRC_IN_CRC_GEN_CRCCALC_PREXORED_20_Q
    );
  CRC_IN_CRC_GEN_CRCCALC_PREXOR_THEXOR21_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(21),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(21),
      O => CRC_IN_CRC_GEN_CRCCALC_PREXORED_21_Q
    );
  CRC_IN_CRC_GEN_CRCCALC_PREXOR_THEXOR22_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(22),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(22),
      O => CRC_IN_CRC_GEN_CRCCALC_PREXORED_22_Q
    );
  CRC_IN_CRC_GEN_CRCCALC_PREXOR_THEXOR23_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(23),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(23),
      O => CRC_IN_CRC_GEN_CRCCALC_PREXORED_23_Q
    );
  CRC_IN_CRC_GEN_CRCCALC_PREXOR_THEXOR24_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(24),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(24),
      O => CRC_IN_CRC_GEN_CRCCALC_PREXORED_24_Q
    );
  CRC_IN_CRC_GEN_CRCCALC_PREXOR_THEXOR26_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_IN_DATA_WIRE(26),
      ADR1 => CRC_IN_CRC_GEN_CRC_OUT(26),
      O => CRC_IN_CRC_GEN_CRCCALC_PREXORED_26_Q
    );
  CRC_IN_CRC_SET_D_OUT_MOD_0_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(0)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_1_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(1)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_2_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(2)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_3_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(3)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_4_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(4)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_5_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(5)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_6_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(6)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_7_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(7)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_8_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(8)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_9_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(9)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_10_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(10)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_11_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(11)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_12_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(12)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_13_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(13)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_14_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(14),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(14)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_15_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(15),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(15)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_16_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(16),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(16)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_17_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(17),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(17)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_18_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(18),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(18)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_19_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(19),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(19)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_20_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(20),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(20)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_21_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(21),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(21)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_22_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(22),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(22)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_23_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(23),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(23)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_24_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(24),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(24)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_25_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(25),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(25)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_26_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(26),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(26)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_27_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(27),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(27)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_28_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(28),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(28)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_29_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(29),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(29)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_30_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(30),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(30)
    );
  CRC_IN_CRC_SET_D_OUT_MOD_31_Q : X_FF
    port map (
      I => CRC_IN_NX_DATA(31),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA2(31)
    );
  CRC_OUT_G_28 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_COUNT(0),
      ADR1 => CRC_OUT_CRC_GEN_COUNT(1),
      O => CRC_OUT_CRC_GEN_UN4_COUNT_C2
    );
  CRC_OUT_G_180 : X_LUT4
    generic map (
      INIT => X"BFFF"
    )
    port map (
      ADR0 => CRC_OUT_G_249_0,
      ADR1 => CRC_OUT_CRC_GEN_COUNT(2),
      ADR2 => CRC_OUT_N_63_1,
      ADR3 => CRC_OUT_IS_LASTCELL,
      O => CRC_OUT_N_143_I
    );
  CRC_OUT_G_186 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(0),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(0),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(0)
    );
  CRC_OUT_G_188 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(1),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(1),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(1)
    );
  CRC_OUT_G_190 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(2),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(2),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(2)
    );
  CRC_OUT_G_192 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(3),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(3),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(3)
    );
  CRC_OUT_G_194 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(4),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(4),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(4)
    );
  CRC_OUT_G_196 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(5),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(5),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(5)
    );
  CRC_OUT_G_198 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(6),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(6),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(6)
    );
  CRC_OUT_G_200 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(7),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(7),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(7)
    );
  CRC_OUT_G_202 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(8),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(8),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(8)
    );
  CRC_OUT_G_204 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(9),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(9),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(9)
    );
  CRC_OUT_G_206 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(10),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(10),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(10)
    );
  CRC_OUT_G_208 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(11),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(11),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(11)
    );
  CRC_OUT_G_210 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(12),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(12),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(12)
    );
  CRC_OUT_G_212 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(13),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(13),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(13)
    );
  CRC_OUT_G_214 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(14),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(14),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(14)
    );
  CRC_OUT_G_216 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(15),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(15),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(15)
    );
  CRC_OUT_G_218 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(16),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(16),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(16)
    );
  CRC_OUT_G_220 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(17),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(17),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(17)
    );
  CRC_OUT_G_222 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(18),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(18),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(18)
    );
  CRC_OUT_G_224 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(19),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(19),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(19)
    );
  CRC_OUT_G_226 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(20),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(20),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(20)
    );
  CRC_OUT_G_228 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(21),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(21),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(21)
    );
  CRC_OUT_G_230 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(22),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(22),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(22)
    );
  CRC_OUT_G_232 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(23),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(23),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(23)
    );
  CRC_OUT_G_234 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(24),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(24),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(24)
    );
  CRC_OUT_G_236 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(25),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(25),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(25)
    );
  CRC_OUT_G_238 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(26),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(26),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(26)
    );
  CRC_OUT_G_240 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(27),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(27),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(27)
    );
  CRC_OUT_G_242 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(28),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(28),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(28)
    );
  CRC_OUT_G_244 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(29),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(29),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(29)
    );
  CRC_OUT_G_246 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(30),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(30),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(30)
    );
  CRC_OUT_G_248 : X_LUT3
    generic map (
      INIT => X"A9"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(31),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(31),
      ADR2 => CRC_OUT_N_143_I,
      O => CRC_OUT_NX_DATA(31)
    );
  CRC_OUT_G_249 : X_LUT2
    generic map (
      INIT => X"E"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_COUNT(0),
      ADR1 => CRC_OUT_CRC_GEN_COUNT(1),
      O => CRC_OUT_G_249_0
    );
  CRC_OUT_I_12_0_AND3_G_36 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => CRC_OUT_N_63_1,
      ADR1 => CRC_OUT_CRC_GEN_COUNT(2),
      O => CRC_OUT_G_36
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_0_Q : X_FF
    port map (
      I => DATA8(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(0)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_1_Q : X_FF
    port map (
      I => DATA8(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(1)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_2_Q : X_FF
    port map (
      I => DATA8(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(2)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_3_Q : X_FF
    port map (
      I => DATA8(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(3)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_4_Q : X_FF
    port map (
      I => DATA8(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(4)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_5_Q : X_FF
    port map (
      I => DATA8(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(5)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_6_Q : X_FF
    port map (
      I => DATA8(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(6)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_7_Q : X_FF
    port map (
      I => DATA8(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(7)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_8_Q : X_FF
    port map (
      I => DATA8(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(8)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_9_Q : X_FF
    port map (
      I => DATA8(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(9)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_10_Q : X_FF
    port map (
      I => DATA8(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(10)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_11_Q : X_FF
    port map (
      I => DATA8(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(11)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_12_Q : X_FF
    port map (
      I => DATA8(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(12)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_13_Q : X_FF
    port map (
      I => DATA8(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(13)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_14_Q : X_FF
    port map (
      I => DATA8(14),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(14)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_15_Q : X_FF
    port map (
      I => DATA8(15),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(15)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_16_Q : X_FF
    port map (
      I => DATA8(16),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(16)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_17_Q : X_FF
    port map (
      I => DATA8(17),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(17)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_18_Q : X_FF
    port map (
      I => DATA8(18),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(18)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_19_Q : X_FF
    port map (
      I => DATA8(19),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(19)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_20_Q : X_FF
    port map (
      I => DATA8(20),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(20)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_21_Q : X_FF
    port map (
      I => DATA8(21),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(21)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_22_Q : X_FF
    port map (
      I => DATA8(22),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(22)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_23_Q : X_FF
    port map (
      I => DATA8(23),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(23)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_24_Q : X_FF
    port map (
      I => DATA8(24),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(24)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_25_Q : X_FF
    port map (
      I => DATA8(25),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(25)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_26_Q : X_FF
    port map (
      I => DATA8(26),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(26)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_27_Q : X_FF
    port map (
      I => DATA8(27),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(27)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_28_Q : X_FF
    port map (
      I => DATA8(28),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(28)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_29_Q : X_FF
    port map (
      I => DATA8(29),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(29)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_30_Q : X_FF
    port map (
      I => DATA8(30),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(30)
    );
  CRC_OUT_CRC_GEN_D_OUT_MOD_31_Q : X_FF
    port map (
      I => DATA8(31),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_DATA_WIRE(31)
    );
  CRC_OUT_CRC_GEN_N_1_I_100 : X_LUT4
    generic map (
      INIT => X"1511"
    )
    port map (
      ADR0 => NGD2VHDL_OI6,
      ADR1 => CRC_OUT_CRC_GEN_DATAEN_BUF,
      ADR2 => CRC_OUT_G_249_0,
      ADR3 => CRC_OUT_G_36,
      O => CRC_OUT_CRC_GEN_N_1_I
    );
  CRC_OUT_CRC_GEN_SOC_OUT_MOD : X_FF
    port map (
      I => SOC8,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => CRC_OUT_CRC_GEN_SOC_WIRE
    );
  CRC_OUT_CRC_GEN_COUNT_0_Q : X_SFF
    port map (
      I => G_786,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CRC_OUT_CRC_GEN_SOC_WIRE,
      O => CRC_OUT_CRC_GEN_COUNT(0)
    );
  CRC_OUT_CRC_GEN_COUNT_1_Q : X_SFF
    port map (
      I => G_787,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CRC_OUT_CRC_GEN_SOC_WIRE,
      O => CRC_OUT_CRC_GEN_COUNT(1)
    );
  CRC_OUT_CRC_GEN_COUNT_2_Q : X_SFF
    port map (
      I => G_771,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CRC_OUT_CRC_GEN_SOC_WIRE,
      O => CRC_OUT_CRC_GEN_COUNT(2)
    );
  CRC_OUT_CRC_GEN_COUNT_3_Q : X_SFF
    port map (
      I => G_772,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CRC_OUT_CRC_GEN_SOC_WIRE,
      O => CRC_OUT_N_63_1
    );
  CRC_OUT_CRC_GEN_CRC_OUT_0_Q : X_SFF
    port map (
      I => G_773,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(0)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_1_Q : X_SFF
    port map (
      I => G_774,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(1)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_2_Q : X_SFF
    port map (
      I => G_775,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(2)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_3_Q : X_SFF
    port map (
      I => G_776,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(3)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_4_Q : X_SFF
    port map (
      I => G_777,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(4)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_5_Q : X_SFF
    port map (
      I => G_778,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(5)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_6_Q : X_SFF
    port map (
      I => G_779,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(6)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_7_Q : X_SFF
    port map (
      I => G_780,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(7)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_8_Q : X_SFF
    port map (
      I => G_781,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(8)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_9_Q : X_SFF
    port map (
      I => G_782,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(9)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_10_Q : X_SFF
    port map (
      I => G_783,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(10)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_11_Q : X_SFF
    port map (
      I => G_784,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(11)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_12_Q : X_SFF
    port map (
      I => G_785,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(12)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_13_Q : X_SFF
    port map (
      I => G_756,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(13)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_14_Q : X_SFF
    port map (
      I => G_757,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(14)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_15_Q : X_SFF
    port map (
      I => G_758,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(15)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_16_Q : X_SFF
    port map (
      I => G_759,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(16)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_17_Q : X_SFF
    port map (
      I => G_760,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(17)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_18_Q : X_SFF
    port map (
      I => G_761,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(18)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_19_Q : X_SFF
    port map (
      I => G_762,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(19)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_20_Q : X_SFF
    port map (
      I => G_763,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(20)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_21_Q : X_SFF
    port map (
      I => G_764,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(21)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_22_Q : X_SFF
    port map (
      I => G_765,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(22)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_23_Q : X_SFF
    port map (
      I => G_766,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(23)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_24_Q : X_SFF
    port map (
      I => G_767,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(24)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_25_Q : X_SFF
    port map (
      I => G_768,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(25)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_26_Q : X_SFF
    port map (
      I => G_769,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(26)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_27_Q : X_SFF
    port map (
      I => G_770,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(27)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_28_Q : X_SFF
    port map (
      I => G_752,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(28)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_29_Q : X_SFF
    port map (
      I => G_753,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(29)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_30_Q : X_SFF
    port map (
      I => G_754,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(30)
    );
  CRC_OUT_CRC_GEN_CRC_OUT_31_Q : X_SFF
    port map (
      I => G_755,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_CRC_GEN_CRC_OUT(31)
    );
  CRC_OUT_CRC_GEN_CRC_SEL_UN11_RES_0_AND3 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_SOC_WIRE,
      ADR1 => CRC_OUT_IS_LASTCELL,
      O => CRC_SEL_UN11_RES_0_AND3_0
    );
  CRC_OUT_CRC_GEN_DATAEN_BUF_101 : X_SFF
    port map (
      I => RESET_L_0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => CRC_OUT_CRC_GEN_N_1_I,
      O => CRC_OUT_CRC_GEN_DATAEN_BUF
    );
  CRC_OUT_CRC_GEN_IS_LASTCELL : X_SFF
    port map (
      I => CRC_OUT_DATA_WIRE(1),
      CLK => CLK,
      CE => CRC_OUT_CRC_GEN_SOC_WIRE,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => CRC_OUT_IS_LASTCELL
    );
  CRC_OUT_CRC_GEN_SOC_DELAY : X_FF
    port map (
      I => CRC_OUT_CRC_GEN_SOC_WIRE,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_OI6
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_402,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_399,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_G_406,
      O => CRC_OUT_CRC_GEN_CRC_CALC(0)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_Q_G_396 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(28),
      ADR1 => CRC_OUT_DATA_WIRE(28),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(16),
      ADR3 => CRC_OUT_DATA_WIRE(16),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_396
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_Q_G_399 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(26),
      ADR1 => CRC_OUT_DATA_WIRE(26),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(24),
      ADR3 => CRC_OUT_DATA_WIRE(24),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_399
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_Q_G_400 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_396,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_6_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(0),
      ADR3 => CRC_OUT_DATA_WIRE(0),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_400
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_Q_G_402 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_400,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_10_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_9_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ_G_402
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW0_XORQ11_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_29_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_G_224,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_G_222,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q010,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001,
      O => CRC_OUT_CRC_GEN_CRC_CALC(1)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_Q_G_220 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(9),
      ADR1 => CRC_OUT_DATA_WIRE(9),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(24),
      ADR3 => CRC_OUT_DATA_WIRE(24),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_G_220
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_Q_G_222 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q100,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_0,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_G_222
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_Q_G_224 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q000,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_G_220,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_13_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW1_XORQ_G_224
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_G_365,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_G_360,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q010_0,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_0,
      O => CRC_OUT_CRC_GEN_CRC_CALC(2)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_Q_G_360 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_13_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_9_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_G_360
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_Q_G_365 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q000,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_1,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q100_0,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW2_XORQ_G_365
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_139,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_138,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q100_1,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q000_0,
      O => CRC_OUT_CRC_GEN_CRC_CALC(3)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_Q_G_132 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(31),
      ADR1 => CRC_OUT_DATA_WIRE(31),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(7),
      ADR3 => CRC_OUT_DATA_WIRE(7),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_132
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_Q_G_134 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(27),
      ADR1 => CRC_OUT_DATA_WIRE(27),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(25),
      ADR3 => CRC_OUT_DATA_WIRE(25),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_134
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_Q_G_136 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_134,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_10_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(3),
      ADR3 => CRC_OUT_DATA_WIRE(3),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_136
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_Q_G_138 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_0,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_132,
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(14),
      ADR3 => CRC_OUT_DATA_WIRE(14),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_138
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_Q_G_139 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_136,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_9_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_8_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW3_XORQ_G_139
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_279,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_277,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_274,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_1,
      O => CRC_OUT_CRC_GEN_CRC_CALC(4)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_Q_G_272 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(29),
      ADR1 => CRC_OUT_DATA_WIRE(29),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(20),
      ADR3 => CRC_OUT_DATA_WIRE(20),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_272
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_Q_G_273 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(0),
      ADR1 => CRC_OUT_DATA_WIRE(0),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(25),
      ADR3 => CRC_OUT_DATA_WIRE(25),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_273
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_Q_G_274 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_24_Q,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_272,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_274
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_Q_G_275 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_273,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_275
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_Q_G_277 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q011,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_0,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_277
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_Q_G_279 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_275,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q0000,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_11_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_8_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW4_XORQ_G_279
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_Q : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_G_552,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q00,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_G_551,
      O => CRC_OUT_CRC_GEN_CRC_CALC(5)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_Q_G_549 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_13_Q,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_19_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_6_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_G_549
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_Q_G_551 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_1,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_10_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_7_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_G_551
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_Q_G_552 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_G_549,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_2,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_24_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_5_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ_G_552
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW5_XORQ00_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q000,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_2,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q00
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_247,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_246,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_3,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_3,
      O => CRC_OUT_CRC_GEN_CRC_CALC(6)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_Q_G_242 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(20),
      ADR1 => CRC_OUT_DATA_WIRE(20),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(25),
      ADR3 => CRC_OUT_DATA_WIRE(25),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_242
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_Q_G_243 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_242,
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(14),
      ADR2 => CRC_OUT_DATA_WIRE(14),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_243
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_Q_G_246 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_2,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_246
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_Q_G_247 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_243,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q000_0,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_11_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_8_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW6_XORQ_G_247
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_484,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_4,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q010_0,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_2,
      O => CRC_OUT_CRC_GEN_CRC_CALC(7)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_Q_G_478 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(16),
      ADR1 => CRC_OUT_DATA_WIRE(16),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(15),
      ADR3 => CRC_OUT_DATA_WIRE(15),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_478
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_Q_G_479 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(21),
      ADR1 => CRC_OUT_DATA_WIRE(21),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(10),
      ADR3 => CRC_OUT_DATA_WIRE(10),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_479
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_Q_G_484 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q00_0,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_3,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_479,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_478,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ_G_484
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ00_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_4,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_2_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(0),
      ADR3 => CRC_OUT_DATA_WIRE(0),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q00_0
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW7_XORQ111_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(28),
      ADR1 => CRC_OUT_DATA_WIRE(28),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(29),
      ADR3 => CRC_OUT_DATA_WIRE(29),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_2
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q00,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_G_558,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_G_557,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_5,
      O => CRC_OUT_CRC_GEN_CRC_CALC(8)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_Q_G_554 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(22),
      ADR1 => CRC_OUT_DATA_WIRE(22),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(17),
      ADR3 => CRC_OUT_DATA_WIRE(17),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_G_554
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_Q_G_557 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(12),
      ADR1 => CRC_OUT_DATA_WIRE(12),
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_11_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_8_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_G_557
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_Q_G_558 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_G_554,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_10_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_23_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW8_XORQ_G_558
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_95,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_93,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_91,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_90,
      O => CRC_OUT_CRC_GEN_CRC_CALC(9)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_Q_G_88 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(1),
      ADR1 => CRC_OUT_DATA_WIRE(1),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(2),
      ADR3 => CRC_OUT_DATA_WIRE(2),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q000_0
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_Q_G_90 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(18),
      ADR1 => CRC_OUT_DATA_WIRE(18),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(5),
      ADR3 => CRC_OUT_DATA_WIRE(5),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_90
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_Q_G_91 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(4),
      ADR1 => CRC_OUT_DATA_WIRE(4),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(12),
      ADR3 => CRC_OUT_DATA_WIRE(12),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_91
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_Q_G_93 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q000_0,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_29_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_23_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_93
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_Q_G_95 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_13_Q,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_24_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_11_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_9_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW9_XORQ_G_95
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_Q : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_G_586,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11_0,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q00_0,
      O => CRC_OUT_CRC_GEN_CRC_CALC(10)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_Q_G_582 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(16),
      ADR1 => CRC_OUT_DATA_WIRE(16),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(19),
      ADR3 => CRC_OUT_DATA_WIRE(19),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_G_582
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_Q_G_584 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(14),
      ADR1 => CRC_OUT_DATA_WIRE(14),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(13),
      ADR3 => CRC_OUT_DATA_WIRE(13),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_G_584
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_Q_G_586 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_G_584,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_G_582,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_26_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_9_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ_G_586
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW10_XORQ11_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_28_Q,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_29_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(31),
      ADR3 => CRC_OUT_DATA_WIRE(31),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11_0
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_339,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_337,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_335,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_6,
      O => CRC_OUT_CRC_GEN_CRC_CALC(11)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_Q_G_330 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(1),
      ADR1 => CRC_OUT_DATA_WIRE(1),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(17),
      ADR3 => CRC_OUT_DATA_WIRE(17),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_330
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_Q_G_331 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(20),
      ADR1 => CRC_OUT_DATA_WIRE(20),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(3),
      ADR3 => CRC_OUT_DATA_WIRE(3),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_331
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_Q_G_333 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(12),
      ADR1 => CRC_OUT_DATA_WIRE(12),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(9),
      ADR3 => CRC_OUT_DATA_WIRE(9),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_333
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_Q_G_335 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_331,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_4_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(0),
      ADR3 => CRC_OUT_DATA_WIRE(0),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_335
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_Q_G_337 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q011_0,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_330,
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(14),
      ADR3 => CRC_OUT_DATA_WIRE(14),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_337
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_Q_G_339 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_4,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_5,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_333,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW11_XORQ_G_339
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_166,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_161,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_159,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q000_0,
      O => CRC_OUT_CRC_GEN_CRC_CALC(12)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_Q_G_158 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(27),
      ADR1 => CRC_OUT_DATA_WIRE(27),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(0),
      ADR3 => CRC_OUT_DATA_WIRE(0),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_158
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_Q_G_159 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(12),
      ADR1 => CRC_OUT_DATA_WIRE(12),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(24),
      ADR3 => CRC_OUT_DATA_WIRE(24),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_159
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_Q_G_160 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_13_Q,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_21_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(18),
      ADR3 => CRC_OUT_DATA_WIRE(18),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_160
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_Q_G_161 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_158,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_161
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_Q_G_166 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_3,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q100_1,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_160,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q010_1,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ_G_166
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW12_XORQ001_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(4),
      ADR1 => CRC_OUT_DATA_WIRE(4),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(5),
      ADR3 => CRC_OUT_DATA_WIRE(5),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_3
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_312,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_310,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q100_0,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_0,
      O => CRC_OUT_CRC_GEN_CRC_CALC(13)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_Q_G_306 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(22),
      ADR1 => CRC_OUT_DATA_WIRE(22),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(10),
      ADR3 => CRC_OUT_DATA_WIRE(10),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_306
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_Q_G_307 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(25),
      ADR1 => CRC_OUT_DATA_WIRE(25),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(13),
      ADR3 => CRC_OUT_DATA_WIRE(13),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_307
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_Q_G_310 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_4,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_310
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_Q_G_312 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q000_0,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_306,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_5,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_307,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ_G_312
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ001_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(3),
      ADR1 => CRC_OUT_DATA_WIRE(3),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(5),
      ADR3 => CRC_OUT_DATA_WIRE(5),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_4
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ010_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(6),
      ADR1 => CRC_OUT_DATA_WIRE(6),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(7),
      ADR3 => CRC_OUT_DATA_WIRE(7),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ100_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(14),
      ADR1 => CRC_OUT_DATA_WIRE(14),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(16),
      ADR3 => CRC_OUT_DATA_WIRE(16),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q100_0
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW13_XORQ101_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(18),
      ADR1 => CRC_OUT_DATA_WIRE(18),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(19),
      ADR3 => CRC_OUT_DATA_WIRE(19),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_0
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_255,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_254,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q0000,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q010_0,
      O => CRC_OUT_CRC_GEN_CRC_CALC(14)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_Q_G_251 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(14),
      ADR1 => CRC_OUT_DATA_WIRE(14),
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_23_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_11_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_251
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_Q_G_254 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_4,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_1,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_254
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_Q_G_255 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_251,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q100_1,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_26_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_29_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ_G_255
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW14_XORQ100_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(15),
      ADR1 => CRC_OUT_DATA_WIRE(15),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(17),
      ADR3 => CRC_OUT_DATA_WIRE(17),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q100_1
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_G_286,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_G_285,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_1,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_2,
      O => CRC_OUT_CRC_GEN_CRC_CALC(15)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_Q_G_281 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(30),
      ADR1 => CRC_OUT_DATA_WIRE(30),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(27),
      ADR3 => CRC_OUT_DATA_WIRE(27),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_G_281
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_Q_G_285 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q011,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_9_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_8_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_G_285
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_Q_G_286 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_G_281,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_24_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_5,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q100_2,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ_G_286
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ000_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(3),
      ADR1 => CRC_OUT_DATA_WIRE(3),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(4),
      ADR3 => CRC_OUT_DATA_WIRE(4),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_2
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW15_XORQ011_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(12),
      ADR1 => CRC_OUT_DATA_WIRE(12),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(15),
      ADR3 => CRC_OUT_DATA_WIRE(15),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q011
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_183,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_181,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_3,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_6,
      O => CRC_OUT_CRC_GEN_CRC_CALC(16)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_Q_G_178 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(0),
      ADR1 => CRC_OUT_DATA_WIRE(0),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(12),
      ADR3 => CRC_OUT_DATA_WIRE(12),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_178
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_Q_G_180 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_21_Q,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_17_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_4_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_19_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_180
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_Q_G_181 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_178,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_13_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_26_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_181
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_Q_G_183 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_180,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_24_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_22_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW16_XORQ_G_183
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_130,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_129,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_125,
      O => CRC_OUT_CRC_GEN_CRC_CALC(17)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_Q_G_124 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(20),
      ADR1 => CRC_OUT_DATA_WIRE(20),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(18),
      ADR3 => CRC_OUT_DATA_WIRE(18),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_124
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_Q_G_125 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(27),
      ADR1 => CRC_OUT_DATA_WIRE(27),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(5),
      ADR3 => CRC_OUT_DATA_WIRE(5),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_125
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_Q_G_129 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_G_584,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_5,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_129
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_Q_G_130 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q010_1,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_124,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_22_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_1_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW17_XORQ_G_130
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_Q : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_469,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11_1,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_468,
      O => CRC_OUT_CRC_GEN_CRC_CALC(18)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_Q_G_465 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(15),
      ADR1 => CRC_OUT_DATA_WIRE(15),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(21),
      ADR3 => CRC_OUT_DATA_WIRE(21),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_465
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_Q_G_466 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(19),
      ADR1 => CRC_OUT_DATA_WIRE(19),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(14),
      ADR3 => CRC_OUT_DATA_WIRE(14),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_466
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_Q_G_468 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_0,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_10_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_7_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_468
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_Q_G_469 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_24_Q,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_23_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_466,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_465,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ_G_469
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ000_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(2),
      ADR1 => CRC_OUT_DATA_WIRE(2),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(6),
      ADR3 => CRC_OUT_DATA_WIRE(6),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_0
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW18_XORQ11_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_5,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_26_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11_1
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_G_195,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_G_193,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q010_0,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q011_0,
      O => CRC_OUT_CRC_GEN_CRC_CALC(19)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_Q_G_192 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(3),
      ADR1 => CRC_OUT_DATA_WIRE(3),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(25),
      ADR3 => CRC_OUT_DATA_WIRE(25),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_G_192
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_Q_G_193 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_G_192,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_11_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(20),
      ADR3 => CRC_OUT_DATA_WIRE(20),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_G_193
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_Q_G_195 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_29_Q,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_27_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_24_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_22_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ_G_195
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW19_XORQ000_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(7),
      ADR1 => CRC_OUT_DATA_WIRE(7),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(8),
      ADR3 => CRC_OUT_DATA_WIRE(8),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q010_0
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_G_155,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_G_153,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q100,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_7,
      O => CRC_OUT_CRC_GEN_CRC_CALC(20)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_Q_G_151 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(21),
      ADR1 => CRC_OUT_DATA_WIRE(21),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(4),
      ADR3 => CRC_OUT_DATA_WIRE(4),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_G_151
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_Q_G_153 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_G_151,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_26_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(12),
      ADR3 => CRC_OUT_DATA_WIRE(12),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_G_153
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_Q_G_155 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_5,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_9_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_8_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW20_XORQ_G_155
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11_2,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ_G_544,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_1,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ_G_543,
      O => CRC_OUT_CRC_GEN_CRC_CALC(21)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ_Q_G_543 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_13_Q,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_5_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_22_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ_G_543
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ_Q_G_544 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_10_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_9_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ_G_544
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW21_XORQ11_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_27_Q,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_29_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(31),
      ADR3 => CRC_OUT_DATA_WIRE(31),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11_2
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_540,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11_2,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_537,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q010,
      O => CRC_OUT_CRC_GEN_CRC_CALC(22)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_Q_G_536 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(0),
      ADR1 => CRC_OUT_DATA_WIRE(0),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(9),
      ADR3 => CRC_OUT_DATA_WIRE(9),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_536
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_Q_G_537 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(14),
      ADR1 => CRC_OUT_DATA_WIRE(14),
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_19_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_23_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_537
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_Q_G_540 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_1,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q100_2,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_536,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ_G_540
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ001_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(11),
      ADR1 => CRC_OUT_DATA_WIRE(11),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(12),
      ADR3 => CRC_OUT_DATA_WIRE(12),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q010
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ010_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(16),
      ADR1 => CRC_OUT_DATA_WIRE(16),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(18),
      ADR3 => CRC_OUT_DATA_WIRE(18),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q100_2
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW22_XORQ101_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(24),
      ADR1 => CRC_OUT_DATA_WIRE(24),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(26),
      ADR3 => CRC_OUT_DATA_WIRE(26),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_1
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_G_516,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11_2,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q010_1,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q000,
      O => CRC_OUT_CRC_GEN_CRC_CALC(23)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_Q_G_511 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(17),
      ADR1 => CRC_OUT_DATA_WIRE(17),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(20),
      ADR3 => CRC_OUT_DATA_WIRE(20),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_G_511
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_Q_G_513 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_13_Q,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_G_511,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_G_513
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_Q_G_516 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_G_513,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q011_0,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_26_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_19_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ_G_516
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ000_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(0),
      ADR1 => CRC_OUT_DATA_WIRE(0),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(1),
      ADR3 => CRC_OUT_DATA_WIRE(1),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q000
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ001_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(6),
      ADR1 => CRC_OUT_DATA_WIRE(6),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(9),
      ADR3 => CRC_OUT_DATA_WIRE(9),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q010_1
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW23_XORQ010_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(15),
      ADR1 => CRC_OUT_DATA_WIRE(15),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(16),
      ADR3 => CRC_OUT_DATA_WIRE(16),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q011_0
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ_G_394,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11_3,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_1,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q100,
      O => CRC_OUT_CRC_GEN_CRC_CALC(24)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ_Q_G_391 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(18),
      ADR1 => CRC_OUT_DATA_WIRE(18),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(14),
      ADR3 => CRC_OUT_DATA_WIRE(14),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ_G_391
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ_Q_G_394 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_10_Q,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_7_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q000_0,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ_G_391,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ_G_394
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ010_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(16),
      ADR1 => CRC_OUT_DATA_WIRE(16),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(17),
      ADR3 => CRC_OUT_DATA_WIRE(17),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q100
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW24_XORQ11_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_7,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_27_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11_3
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ_G_533,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11_0,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_2,
      O => CRC_OUT_CRC_GEN_CRC_CALC(25)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ_Q_G_530 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(15),
      ADR1 => CRC_OUT_DATA_WIRE(15),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(19),
      ADR3 => CRC_OUT_DATA_WIRE(19),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ_G_530
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ_Q_G_533 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q0000,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ_G_530,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_11_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_8_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ_G_533
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ000_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(2),
      ADR1 => CRC_OUT_DATA_WIRE(2),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(3),
      ADR3 => CRC_OUT_DATA_WIRE(3),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q0000
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW25_XORQ010_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(17),
      ADR1 => CRC_OUT_DATA_WIRE(17),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(18),
      ADR3 => CRC_OUT_DATA_WIRE(18),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_G_463,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11_1,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_G_460,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_1,
      O => CRC_OUT_CRC_GEN_CRC_CALC(26)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_Q_G_459 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(3),
      ADR1 => CRC_OUT_DATA_WIRE(3),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(0),
      ADR3 => CRC_OUT_DATA_WIRE(0),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_G_459
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_Q_G_460 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_G_459,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_10_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(18),
      ADR3 => CRC_OUT_DATA_WIRE(18),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_G_460
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_Q_G_463 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_4,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_4,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_3,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ_G_463
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ001_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(4),
      ADR1 => CRC_OUT_DATA_WIRE(4),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(6),
      ADR3 => CRC_OUT_DATA_WIRE(6),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_1
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW26_XORQ110_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(28),
      ADR1 => CRC_OUT_DATA_WIRE(28),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(31),
      ADR3 => CRC_OUT_DATA_WIRE(31),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_5
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_G_328,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_G_326,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_4,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_5,
      O => CRC_OUT_CRC_GEN_CRC_CALC(27)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_Q_G_322 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(1),
      ADR1 => CRC_OUT_DATA_WIRE(1),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(11),
      ADR3 => CRC_OUT_DATA_WIRE(11),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_G_322
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_Q_G_326 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_26_Q,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_4_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_29_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_27_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_G_326
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_Q_G_328 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_4,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_G_322,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_21_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_23_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ_G_328
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ001_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(5),
      ADR1 => CRC_OUT_DATA_WIRE(5),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(7),
      ADR3 => CRC_OUT_DATA_WIRE(7),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_5
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ010_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(19),
      ADR1 => CRC_OUT_DATA_WIRE(19),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(20),
      ADR3 => CRC_OUT_DATA_WIRE(20),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_4
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW27_XORQ101_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(24),
      ADR1 => CRC_OUT_DATA_WIRE(24),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(25),
      ADR3 => CRC_OUT_DATA_WIRE(25),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_4
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_Q : X_MUX2
    port map (
      IA => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_Q_AM,
      IB => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_Q_BM,
      SEL => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11_3,
      O => CRC_OUT_CRC_GEN_CRC_CALC(28)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_Q_G_406 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(25),
      ADR1 => CRC_OUT_DATA_WIRE(25),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(12),
      ADR3 => CRC_OUT_DATA_WIRE(12),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_G_406
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_Q_G_408 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_G_406,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_5_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_6_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_G_408
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_Q_G_409 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_1,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_2_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_8_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_26_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_G_409
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_Q_AM_102 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_G_409,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_22_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_24_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_G_408,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_Q_AM
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_Q_BM_103 : X_LUT4
    generic map (
      INIT => X"9669"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_G_409,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_22_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_24_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_G_408,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ_Q_BM
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ010_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(20),
      ADR1 => CRC_OUT_DATA_WIRE(20),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(21),
      ADR3 => CRC_OUT_DATA_WIRE(21),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_1
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW28_XORQ110_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(28),
      ADR1 => CRC_OUT_DATA_WIRE(28),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(30),
      ADR3 => CRC_OUT_DATA_WIRE(30),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_7
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_524,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_6,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_2,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_519,
      O => CRC_OUT_CRC_GEN_CRC_CALC(29)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_Q_G_519 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(3),
      ADR1 => CRC_OUT_DATA_WIRE(3),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(9),
      ADR3 => CRC_OUT_DATA_WIRE(9),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_519
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_Q_G_522 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_5,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_7_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_6_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_13_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_522
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_Q_G_524 : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_522,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11_0,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ_G_524
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ010_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(21),
      ADR1 => CRC_OUT_DATA_WIRE(21),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(22),
      ADR3 => CRC_OUT_DATA_WIRE(22),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_2
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW29_XORQ100_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(23),
      ADR1 => CRC_OUT_DATA_WIRE(23),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(25),
      ADR3 => CRC_OUT_DATA_WIRE(25),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_5
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_G_212,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_G_210,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_3,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_3,
      O => CRC_OUT_CRC_GEN_CRC_CALC(30)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_Q_G_208 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(4),
      ADR1 => CRC_OUT_DATA_WIRE(4),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(14),
      ADR3 => CRC_OUT_DATA_WIRE(14),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_G_208
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_Q_G_210 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_G_208,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_10_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_7_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_G_210
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_Q_G_212 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_6,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_24_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_8_Q,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_28_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ_G_212
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ010_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(22),
      ADR1 => CRC_OUT_DATA_WIRE(22),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(23),
      ADR3 => CRC_OUT_DATA_WIRE(23),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q101_3
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ100_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(26),
      ADR1 => CRC_OUT_DATA_WIRE(26),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(27),
      ADR3 => CRC_OUT_DATA_WIRE(27),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_6
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW30_XORQ110_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(29),
      ADR1 => CRC_OUT_DATA_WIRE(29),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(30),
      ADR3 => CRC_OUT_DATA_WIRE(30),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_3
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_Q : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_G_441,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q11,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_G_440,
      O => CRC_OUT_CRC_GEN_CRC_CALC(31)
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_Q_G_438 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(15),
      ADR1 => CRC_OUT_DATA_WIRE(15),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(25),
      ADR3 => CRC_OUT_DATA_WIRE(25),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_G_438
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_Q_G_440 : X_LUT3
    generic map (
      INIT => X"96"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_6,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_11_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_9_Q,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_G_440
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_Q_G_441 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_24_Q,
      ADR1 => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_23_Q,
      ADR2 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_0,
      ADR3 => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_G_438,
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ_G_441
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ000_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(5),
      ADR1 => CRC_OUT_DATA_WIRE(5),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(8),
      ADR3 => CRC_OUT_DATA_WIRE(8),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q001_6
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ100_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(27),
      ADR1 => CRC_OUT_DATA_WIRE(27),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(28),
      ADR3 => CRC_OUT_DATA_WIRE(28),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110_0
    );
  CRC_OUT_CRC_GEN_CRCCALC_MATRIX_ROW31_XORQ110_Q : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => CRC_OUT_CRC_GEN_CRC_OUT(30),
      ADR1 => CRC_OUT_DATA_WIRE(30),
      ADR2 => CRC_OUT_CRC_GEN_CRC_OUT(31),
      ADR3 => CRC_OUT_DATA_WIRE(31),
      O => CRC_OUT_CRC_GEN_CRCCALC_MATRIX_Q110
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR1_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(1),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(1),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_1_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR2_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(2),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(2),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_2_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR4_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(4),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(4),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_4_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR5_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(5),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(5),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_5_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR6_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(6),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(6),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_6_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR7_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(7),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(7),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_7_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR8_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(8),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(8),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_8_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR9_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(9),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(9),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_9_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR10_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(10),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(10),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_10_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR11_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(11),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(11),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_11_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR13_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(13),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(13),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_13_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR17_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(17),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(17),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_17_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR19_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(19),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(19),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_19_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR21_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(21),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(21),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_21_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR22_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(22),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(22),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_22_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR23_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(23),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(23),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_23_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR24_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(24),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(24),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_24_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR26_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(26),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(26),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_26_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR27_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(27),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(27),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_27_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR28_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(28),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(28),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_28_Q
    );
  CRC_OUT_CRC_GEN_CRCCALC_PREXOR_THEXOR29_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => CRC_OUT_DATA_WIRE(29),
      ADR1 => CRC_OUT_CRC_GEN_CRC_OUT(29),
      O => CRC_OUT_CRC_GEN_CRCCALC_PREXORED_29_Q
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_0_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(0)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_1_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(1)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_2_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(2)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_3_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(3)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_4_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(4)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_5_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(5)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_6_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(6)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_7_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(7)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_8_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(8)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_9_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(9)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_10_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(10)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_11_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(11)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_12_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(12)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_13_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(13)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_14_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(14),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(14)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_15_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(15),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(15)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_16_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(16),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(16)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_17_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(17),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(17)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_18_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(18),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(18)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_19_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(19),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(19)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_20_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(20),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(20)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_21_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(21),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(21)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_22_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(22),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(22)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_23_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(23),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(23)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_24_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(24),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(24)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_25_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(25),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(25)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_26_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(26),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(26)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_27_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(27),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(27)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_28_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(28),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(28)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_29_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(29),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(29)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_30_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(30),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(30)
    );
  CRC_OUT_CRC_SET_D_OUT_MOD_31_Q : X_FF
    port map (
      I => CRC_OUT_NX_DATA(31),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_MOD(31)
    );
  DATA_ENABLE_D_OUT_MOD_0_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(0)
    );
  DATA_ENABLE_D_OUT_MOD_1_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(1)
    );
  DATA_ENABLE_D_OUT_MOD_2_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(2)
    );
  DATA_ENABLE_D_OUT_MOD_3_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(3)
    );
  DATA_ENABLE_D_OUT_MOD_4_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(4)
    );
  DATA_ENABLE_D_OUT_MOD_5_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(5)
    );
  DATA_ENABLE_D_OUT_MOD_6_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(6)
    );
  DATA_ENABLE_D_OUT_MOD_7_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(7)
    );
  DATA_ENABLE_D_OUT_MOD_8_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(8)
    );
  DATA_ENABLE_D_OUT_MOD_9_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(9)
    );
  DATA_ENABLE_D_OUT_MOD_10_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(10)
    );
  DATA_ENABLE_D_OUT_MOD_11_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(11)
    );
  DATA_ENABLE_D_OUT_MOD_12_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(12)
    );
  DATA_ENABLE_D_OUT_MOD_13_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(13)
    );
  DATA_ENABLE_D_OUT_MOD_14_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(14),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(14)
    );
  DATA_ENABLE_D_OUT_MOD_15_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(15),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(15)
    );
  DATA_ENABLE_D_OUT_MOD_16_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(16),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(16)
    );
  DATA_ENABLE_D_OUT_MOD_17_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(17),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(17)
    );
  DATA_ENABLE_D_OUT_MOD_18_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(18),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(18)
    );
  DATA_ENABLE_D_OUT_MOD_19_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(19),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(19)
    );
  DATA_ENABLE_D_OUT_MOD_20_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(20),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(20)
    );
  DATA_ENABLE_D_OUT_MOD_21_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(21),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(21)
    );
  DATA_ENABLE_D_OUT_MOD_22_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(22),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(22)
    );
  DATA_ENABLE_D_OUT_MOD_23_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(23),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(23)
    );
  DATA_ENABLE_D_OUT_MOD_24_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(24),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(24)
    );
  DATA_ENABLE_D_OUT_MOD_25_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(25),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(25)
    );
  DATA_ENABLE_D_OUT_MOD_26_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(26),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(26)
    );
  DATA_ENABLE_D_OUT_MOD_27_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(27),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(27)
    );
  DATA_ENABLE_D_OUT_MOD_28_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(28),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(28)
    );
  DATA_ENABLE_D_OUT_MOD_29_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(29),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(29)
    );
  DATA_ENABLE_D_OUT_MOD_30_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(30),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(30)
    );
  DATA_ENABLE_D_OUT_MOD_31_Q : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(31),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => D_OUT_APPL(31)
    );
  DATA_ENABLE_DATAEN_OUT_MOD : X_FF
    port map (
      I => DATA_ENABLE_DATAEN_OUT_MOD_1,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATAEN_OUT_APPL
    );
  DATA_ENABLE_EOF_OUT_MOD : X_FF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_EOF_OUT_MOD_1,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => EOF_OUT_APPL
    );
  DATA_ENABLE_GND_104 : X_ZERO
    port map (
      O => DATA_ENABLE_GND
    );
  DATA_ENABLE_G_1_0_105 : X_LUT4
    generic map (
      INIT => X"FFFB"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_PROC_UN5_STATE_OUT,
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_G_54,
      ADR3 => DATA_ENABLE_N_2276,
      O => DATA_ENABLE_G_1_0
    );
  DATA_ENABLE_G_1_0_1_G_53 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_0_5_Q,
      ADR1 => DATA_ENABLE_STATE_IN_0_4_Q,
      ADR2 => DATA_ENABLE_STATE_OUT_3_Q,
      O => DATA_ENABLE_G_53
    );
  DATA_ENABLE_G_1_0_1_G_54 : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_53,
      ADR1 => DATA_ENABLE_DATA_IN(1),
      ADR2 => DATA_ENABLE_STATE_OUT_4_Q,
      ADR3 => DATA_ENABLE_SOC_IN,
      O => DATA_ENABLE_G_54
    );
  DATA_ENABLE_G_1_0_OR3 : X_LUT2
    generic map (
      INIT => X"E"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_6_Q,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      O => DATA_ENABLE_CWCOUNT_OUT_PROC_UN5_STATE_OUT
    );
  DATA_ENABLE_G_625_106 : X_LUT3
    generic map (
      INIT => X"80"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_IN(1),
      ADR1 => DATA_ENABLE_CWCOUNT_IN(0),
      ADR2 => DATA_ENABLE_STATE_IN_5_Q,
      O => DATA_ENABLE_UN2_CWCOUNT_IN_1_C2
    );
  DATA_ENABLE_G_627_107 : X_LUT4
    generic map (
      INIT => X"8000"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_IN(2),
      ADR1 => DATA_ENABLE_CWCOUNT_IN(1),
      ADR2 => DATA_ENABLE_CWCOUNT_IN(0),
      ADR3 => DATA_ENABLE_STATE_IN_5_Q,
      O => DATA_ENABLE_UN2_CWCOUNT_IN_1_C3
    );
  DATA_ENABLE_G_633_108 : X_LUT3
    generic map (
      INIT => X"80"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT(1),
      ADR1 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR2 => DATA_ENABLE_STATE_OUT_0_5_Q,
      O => DATA_ENABLE_UN3_CWCOUNT_OUT_5_C2
    );
  DATA_ENABLE_G_1664_109 : X_LUT2
    generic map (
      INIT => X"1"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_IN_7_Q,
      ADR1 => DATA_ENABLE_STATE_IN_0_Q,
      O => DATA_ENABLE_G_1664
    );
  DATA_ENABLE_G_1666_110 : X_LUT2
    generic map (
      INIT => X"2"
    )
    port map (
      ADR0 => DATA_ENABLE_N_971_1,
      ADR1 => DATA_ENABLE_CWCOUNT_IN(2),
      O => DATA_ENABLE_G_1666
    );
  DATA_ENABLE_G_1667_111 : X_LUT2
    generic map (
      INIT => X"2"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_IN_5_Q,
      ADR1 => DATA_ENABLE_CWCOUNT_IN(0),
      O => DATA_ENABLE_G_1667
    );
  DATA_ENABLE_G_1668 : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => DATA_ENABLE_BUF_FLAG,
      ADR1 => DATA_ENABLE_LC_FLAG,
      ADR2 => DATA_ENABLE_STATE_OUT_4_Q,
      O => DATA_ENABLE_N_2276
    );
  DATA_ENABLE_G_1671_112 : X_LUT3
    generic map (
      INIT => X"40"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_IN(1),
      ADR1 => DATA_ENABLE_CWCOUNT_IN(0),
      ADR2 => DATA_ENABLE_STATE_IN_5_Q,
      O => DATA_ENABLE_G_1671
    );
  DATA_ENABLE_G_1740_113 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_3_Q,
      ADR1 => DATA_ENABLE_STATE_IN_0_4_Q,
      O => DATA_ENABLE_G_1740
    );
  DATA_ENABLE_G_1743_114 : X_LUT2
    generic map (
      INIT => X"4"
    )
    port map (
      ADR0 => DATA_ENABLE_N_971_1,
      ADR1 => DATA_ENABLE_CWCOUNT_IN(1),
      O => DATA_ENABLE_G_1743
    );
  DATA_ENABLE_G_1744_115 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => DATA_ENABLE_BUF_FLAG,
      O => DATA_ENABLE_G_1744
    );
  DATA_ENABLE_G_1745_116 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => DATA_ENABLE_G_1666,
      ADR1 => DATA_ENABLE_G_1671,
      O => DATA_ENABLE_G_1745
    );
  DATA_ENABLE_G_1748 : X_LUT2
    generic map (
      INIT => X"4"
    )
    port map (
      ADR0 => DATA_ENABLE_BUF_FLAG,
      ADR1 => DATA_ENABLE_STATE_OUT_4_Q,
      O => DATA_ENABLE_N_2354
    );
  DATA_ENABLE_G_1749 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_0_5_Q,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      O => DATA_ENABLE_UN3_CWCOUNT_OUT_5_C1
    );
  DATA_ENABLE_G_1752 : X_LUT4
    generic map (
      INIT => X"0002"
    )
    port map (
      ADR0 => DATA_ENABLE_LC_FLAG,
      ADR1 => DATA_ENABLE_G_33,
      ADR2 => DATA_ENABLE_G_31,
      ADR3 => DATA_ENABLE_G_22,
      O => G_1752
    );
  DATA_ENABLE_G_1754_117 : X_LUT2
    generic map (
      INIT => X"4"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT(1),
      ADR1 => DATA_ENABLE_N_983_1_0,
      O => DATA_ENABLE_G_1754
    );
  DATA_ENABLE_G_1756 : X_LUT2
    generic map (
      INIT => X"2"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => DATA_ENABLE_SOC_IN,
      O => DATA_ENABLE_N_2362
    );
  DATA_ENABLE_G_1772_118 : X_LUT3
    generic map (
      INIT => X"BA"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR1 => DATA_ENABLE_SOC_IN,
      ADR2 => DATA_ENABLE_STATE_OUT_0_8_Q,
      O => DATA_ENABLE_G_1772
    );
  DATA_ENABLE_G_1774 : X_LUT4
    generic map (
      INIT => X"FFFD"
    )
    port map (
      ADR0 => DATA_ENABLE_LC_COPY,
      ADR1 => DATA_ENABLE_G_33,
      ADR2 => DATA_ENABLE_G_31,
      ADR3 => DATA_ENABLE_G_22,
      O => G_1774
    );
  DATA_ENABLE_G_1777 : X_LUT4
    generic map (
      INIT => X"55D5"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_0_5_Q,
      ADR1 => DATA_ENABLE_G_1754,
      ADR2 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR3 => DATA_ENABLE_CWCOUNT_OUT(2),
      O => G_1777
    );
  DATA_ENABLE_G_1808_119 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT(11),
      ADR1 => DATA_ENABLE_CELL_BUF_10(13),
      O => DATA_ENABLE_G_1808
    );
  DATA_ENABLE_G_1822_120 : X_LUT2
    generic map (
      INIT => X"E"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_IN_0_4_Q,
      ADR1 => DATA_ENABLE_STATE_IN_5_Q,
      O => DATA_ENABLE_G_1822
    );
  DATA_ENABLE_G_1828 : X_LUT2
    generic map (
      INIT => X"7"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_IN_5_Q,
      ADR1 => DATA_ENABLE_CWCOUNT_IN(0),
      O => G_1828
    );
  DATA_ENABLE_G_1829 : X_LUT2
    generic map (
      INIT => X"D"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR1 => DATA_ENABLE_LC_FLAG,
      O => G_1829
    );
  DATA_ENABLE_G_1830_G_5 : X_LUT3
    generic map (
      INIT => X"57"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_0_5_Q,
      ADR1 => DATA_ENABLE_BUF_COPY,
      ADR2 => DATA_ENABLE_LC_COPY,
      O => G_5
    );
  DATA_ENABLE_G_1830_G_5_REP1 : X_LUT3
    generic map (
      INIT => X"57"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_0_5_Q,
      ADR1 => DATA_ENABLE_BUF_COPY,
      ADR2 => DATA_ENABLE_LC_COPY,
      O => DATA_ENABLE_N_2016_REP1
    );
  DATA_ENABLE_G_1830_G_5_REP2 : X_LUT3
    generic map (
      INIT => X"57"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_0_5_Q,
      ADR1 => DATA_ENABLE_BUF_COPY,
      ADR2 => DATA_ENABLE_LC_COPY,
      O => DATA_ENABLE_N_2016_REP2
    );
  DATA_ENABLE_I_16_0_AND2_I : X_LUT3
    generic map (
      INIT => X"FE"
    )
    port map (
      ADR0 => DATA_ENABLE_SOC_IN,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_STATE_OUT_6_Q,
      O => DATA_ENABLE_N_1893
    );
  DATA_ENABLE_I_29_0_AND2_0_AND3 : X_LUT4
    generic map (
      INIT => X"0001"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR1 => DATA_ENABLE_STATE_OUT_6_Q,
      ADR2 => DATA_ENABLE_STATE_OUT_4_Q,
      ADR3 => DATA_ENABLE_STATE_OUT_0_8_Q,
      O => DATA_ENABLE_BUF_FLAG_PROC_BUF_FLAG_1_PMX
    );
  DATA_ENABLE_N_44_I_121 : X_LUT4
    generic map (
      INIT => X"5553"
    )
    port map (
      ADR0 => DATA_ENABLE_LC_FLAG,
      ADR1 => DATA_ENABLE_LC_COPY,
      ADR2 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR3 => DATA_ENABLE_STATE_OUT_6_Q,
      O => DATA_ENABLE_N_44_I
    );
  DATA_ENABLE_N_49_I_122 : X_LUT4
    generic map (
      INIT => X"5553"
    )
    port map (
      ADR0 => DATA_ENABLE_BUF_FLAG,
      ADR1 => DATA_ENABLE_BUF_COPY,
      ADR2 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR3 => DATA_ENABLE_STATE_OUT_6_Q,
      O => DATA_ENABLE_N_49_I
    );
  DATA_ENABLE_N_54_I_123 : X_LUT3
    generic map (
      INIT => X"27"
    )
    port map (
      ADR0 => DATA_ENABLE_SOC_IN,
      ADR1 => DATA_ENABLE_DATA_IN(1),
      ADR2 => DATA_ENABLE_LC_FLAG,
      O => DATA_ENABLE_N_54_I
    );
  DATA_ENABLE_N_983_1_0_124 : X_BUF
    port map (
      I => DATA_ENABLE_N_983_1,
      O => DATA_ENABLE_N_983_1_0
    );
  DATA_ENABLE_N_983_1_1_125 : X_BUF
    port map (
      I => DATA_ENABLE_N_983_1,
      O => DATA_ENABLE_N_983_1_1
    );
  DATA_ENABLE_N_1971_I : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => DATA_ENABLE_SOC_IN,
      ADR1 => RESET_L_1,
      O => DATA_ENABLE_N_998_I
    );
  DATA_ENABLE_SOF_OUT_MOD : X_FF
    port map (
      I => DATA_ENABLE_STATE_OUT_6_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SOF_OUT_APPL
    );
  DATA_ENABLE_VCC_126 : X_ONE
    port map (
      O => DATA_ENABLE_VCC
    );
  DATA_ENABLE_BUF_COPY_127 : X_SFF
    port map (
      I => RESET_L_0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => DATA_ENABLE_N_49_I,
      O => DATA_ENABLE_BUF_COPY
    );
  DATA_ENABLE_BUF_FLAG_128 : X_SFF
    port map (
      I => DATA_ENABLE_BUF_FLAG_PROC_BUF_FLAG_1_PMX,
      CLK => CLK,
      CE => DATA_ENABLE_N_1893,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => DATA_ENABLE_BUF_FLAG
    );
  DATA_ENABLE_CELL_BUF_0_0_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(0),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(0)
    );
  DATA_ENABLE_CELL_BUF_0_1_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(1),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(1)
    );
  DATA_ENABLE_CELL_BUF_0_2_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(2),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(2)
    );
  DATA_ENABLE_CELL_BUF_0_3_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(3),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(3)
    );
  DATA_ENABLE_CELL_BUF_0_4_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(4),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(4)
    );
  DATA_ENABLE_CELL_BUF_0_5_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(5),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(5)
    );
  DATA_ENABLE_CELL_BUF_0_6_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(6),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(6)
    );
  DATA_ENABLE_CELL_BUF_0_7_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(7),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(7)
    );
  DATA_ENABLE_CELL_BUF_0_8_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(8),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(8)
    );
  DATA_ENABLE_CELL_BUF_0_9_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(9),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(9)
    );
  DATA_ENABLE_CELL_BUF_0_10_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(10),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(10)
    );
  DATA_ENABLE_CELL_BUF_0_11_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(11),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(11)
    );
  DATA_ENABLE_CELL_BUF_0_12_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(12),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(12)
    );
  DATA_ENABLE_CELL_BUF_0_13_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(13),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(13)
    );
  DATA_ENABLE_CELL_BUF_0_14_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(14),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(14)
    );
  DATA_ENABLE_CELL_BUF_0_15_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(15),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(15)
    );
  DATA_ENABLE_CELL_BUF_0_16_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(16),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(16)
    );
  DATA_ENABLE_CELL_BUF_0_17_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(17),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(17)
    );
  DATA_ENABLE_CELL_BUF_0_18_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(18),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(18)
    );
  DATA_ENABLE_CELL_BUF_0_19_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(19),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(19)
    );
  DATA_ENABLE_CELL_BUF_0_20_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(20),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(20)
    );
  DATA_ENABLE_CELL_BUF_0_21_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(21),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(21)
    );
  DATA_ENABLE_CELL_BUF_0_22_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(22),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(22)
    );
  DATA_ENABLE_CELL_BUF_0_23_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(23),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(23)
    );
  DATA_ENABLE_CELL_BUF_0_24_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(24),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(24)
    );
  DATA_ENABLE_CELL_BUF_0_25_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(25),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(25)
    );
  DATA_ENABLE_CELL_BUF_0_26_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(26),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(26)
    );
  DATA_ENABLE_CELL_BUF_0_27_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(27),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(27)
    );
  DATA_ENABLE_CELL_BUF_0_28_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(28),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(28)
    );
  DATA_ENABLE_CELL_BUF_0_29_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(29),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(29)
    );
  DATA_ENABLE_CELL_BUF_0_30_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(30),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(30)
    );
  DATA_ENABLE_CELL_BUF_0_31_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(31),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_0(31)
    );
  DATA_ENABLE_CELL_BUF_1_0_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(0),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(0)
    );
  DATA_ENABLE_CELL_BUF_1_1_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(1),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(1)
    );
  DATA_ENABLE_CELL_BUF_1_2_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(2),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(2)
    );
  DATA_ENABLE_CELL_BUF_1_3_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(3),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(3)
    );
  DATA_ENABLE_CELL_BUF_1_4_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(4),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(4)
    );
  DATA_ENABLE_CELL_BUF_1_5_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(5),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(5)
    );
  DATA_ENABLE_CELL_BUF_1_6_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(6),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(6)
    );
  DATA_ENABLE_CELL_BUF_1_7_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(7),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(7)
    );
  DATA_ENABLE_CELL_BUF_1_8_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(8),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(8)
    );
  DATA_ENABLE_CELL_BUF_1_9_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(9),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(9)
    );
  DATA_ENABLE_CELL_BUF_1_10_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(10),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(10)
    );
  DATA_ENABLE_CELL_BUF_1_11_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(11),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(11)
    );
  DATA_ENABLE_CELL_BUF_1_12_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(12),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(12)
    );
  DATA_ENABLE_CELL_BUF_1_13_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(13),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(13)
    );
  DATA_ENABLE_CELL_BUF_1_14_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(14),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(14)
    );
  DATA_ENABLE_CELL_BUF_1_15_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(15),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(15)
    );
  DATA_ENABLE_CELL_BUF_1_16_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(16),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(16)
    );
  DATA_ENABLE_CELL_BUF_1_17_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(17),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(17)
    );
  DATA_ENABLE_CELL_BUF_1_18_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(18),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(18)
    );
  DATA_ENABLE_CELL_BUF_1_19_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(19),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(19)
    );
  DATA_ENABLE_CELL_BUF_1_20_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(20),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(20)
    );
  DATA_ENABLE_CELL_BUF_1_21_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(21),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(21)
    );
  DATA_ENABLE_CELL_BUF_1_22_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(22),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(22)
    );
  DATA_ENABLE_CELL_BUF_1_23_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(23),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(23)
    );
  DATA_ENABLE_CELL_BUF_1_24_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(24),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(24)
    );
  DATA_ENABLE_CELL_BUF_1_25_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(25),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(25)
    );
  DATA_ENABLE_CELL_BUF_1_26_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(26),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(26)
    );
  DATA_ENABLE_CELL_BUF_1_27_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(27),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(27)
    );
  DATA_ENABLE_CELL_BUF_1_28_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(28),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(28)
    );
  DATA_ENABLE_CELL_BUF_1_29_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(29),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(29)
    );
  DATA_ENABLE_CELL_BUF_1_30_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(30),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(30)
    );
  DATA_ENABLE_CELL_BUF_1_31_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(31),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_1(31)
    );
  DATA_ENABLE_CELL_BUF_2_0_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(0),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(0)
    );
  DATA_ENABLE_CELL_BUF_2_1_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(1),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(1)
    );
  DATA_ENABLE_CELL_BUF_2_2_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(2),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(2)
    );
  DATA_ENABLE_CELL_BUF_2_3_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(3),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(3)
    );
  DATA_ENABLE_CELL_BUF_2_4_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(4),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(4)
    );
  DATA_ENABLE_CELL_BUF_2_5_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(5),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(5)
    );
  DATA_ENABLE_CELL_BUF_2_6_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(6),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(6)
    );
  DATA_ENABLE_CELL_BUF_2_7_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(7),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(7)
    );
  DATA_ENABLE_CELL_BUF_2_8_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(8),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(8)
    );
  DATA_ENABLE_CELL_BUF_2_9_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(9),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(9)
    );
  DATA_ENABLE_CELL_BUF_2_10_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(10),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(10)
    );
  DATA_ENABLE_CELL_BUF_2_11_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(11),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(11)
    );
  DATA_ENABLE_CELL_BUF_2_12_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(12),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(12)
    );
  DATA_ENABLE_CELL_BUF_2_13_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(13),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(13)
    );
  DATA_ENABLE_CELL_BUF_2_14_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(14),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(14)
    );
  DATA_ENABLE_CELL_BUF_2_15_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(15),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(15)
    );
  DATA_ENABLE_CELL_BUF_2_16_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(16),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(16)
    );
  DATA_ENABLE_CELL_BUF_2_17_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(17),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(17)
    );
  DATA_ENABLE_CELL_BUF_2_18_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(18),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(18)
    );
  DATA_ENABLE_CELL_BUF_2_19_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(19),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(19)
    );
  DATA_ENABLE_CELL_BUF_2_20_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(20),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(20)
    );
  DATA_ENABLE_CELL_BUF_2_21_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(21),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(21)
    );
  DATA_ENABLE_CELL_BUF_2_22_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(22),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(22)
    );
  DATA_ENABLE_CELL_BUF_2_23_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(23),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(23)
    );
  DATA_ENABLE_CELL_BUF_2_24_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(24),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(24)
    );
  DATA_ENABLE_CELL_BUF_2_25_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(25),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(25)
    );
  DATA_ENABLE_CELL_BUF_2_26_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(26),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(26)
    );
  DATA_ENABLE_CELL_BUF_2_27_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(27),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(27)
    );
  DATA_ENABLE_CELL_BUF_2_28_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(28),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(28)
    );
  DATA_ENABLE_CELL_BUF_2_29_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(29),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(29)
    );
  DATA_ENABLE_CELL_BUF_2_30_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(30),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(30)
    );
  DATA_ENABLE_CELL_BUF_2_31_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(31),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_2(31)
    );
  DATA_ENABLE_CELL_BUF_3_0_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(0),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(0)
    );
  DATA_ENABLE_CELL_BUF_3_1_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(1),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(1)
    );
  DATA_ENABLE_CELL_BUF_3_2_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(2),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(2)
    );
  DATA_ENABLE_CELL_BUF_3_3_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(3),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(3)
    );
  DATA_ENABLE_CELL_BUF_3_4_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(4),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(4)
    );
  DATA_ENABLE_CELL_BUF_3_5_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(5),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(5)
    );
  DATA_ENABLE_CELL_BUF_3_6_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(6),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(6)
    );
  DATA_ENABLE_CELL_BUF_3_7_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(7),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(7)
    );
  DATA_ENABLE_CELL_BUF_3_8_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(8),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(8)
    );
  DATA_ENABLE_CELL_BUF_3_9_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(9),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(9)
    );
  DATA_ENABLE_CELL_BUF_3_10_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(10),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(10)
    );
  DATA_ENABLE_CELL_BUF_3_11_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(11),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(11)
    );
  DATA_ENABLE_CELL_BUF_3_12_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(12),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(12)
    );
  DATA_ENABLE_CELL_BUF_3_13_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(13),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(13)
    );
  DATA_ENABLE_CELL_BUF_3_14_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(14),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(14)
    );
  DATA_ENABLE_CELL_BUF_3_15_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(15),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(15)
    );
  DATA_ENABLE_CELL_BUF_3_16_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(16),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(16)
    );
  DATA_ENABLE_CELL_BUF_3_17_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(17),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(17)
    );
  DATA_ENABLE_CELL_BUF_3_18_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(18),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(18)
    );
  DATA_ENABLE_CELL_BUF_3_19_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(19),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(19)
    );
  DATA_ENABLE_CELL_BUF_3_20_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(20),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(20)
    );
  DATA_ENABLE_CELL_BUF_3_21_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(21),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(21)
    );
  DATA_ENABLE_CELL_BUF_3_22_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(22),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(22)
    );
  DATA_ENABLE_CELL_BUF_3_23_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(23),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(23)
    );
  DATA_ENABLE_CELL_BUF_3_24_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(24),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(24)
    );
  DATA_ENABLE_CELL_BUF_3_25_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(25),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(25)
    );
  DATA_ENABLE_CELL_BUF_3_26_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(26),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(26)
    );
  DATA_ENABLE_CELL_BUF_3_27_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(27),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(27)
    );
  DATA_ENABLE_CELL_BUF_3_28_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(28),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(28)
    );
  DATA_ENABLE_CELL_BUF_3_29_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(29),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(29)
    );
  DATA_ENABLE_CELL_BUF_3_30_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(30),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(30)
    );
  DATA_ENABLE_CELL_BUF_3_31_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(31),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_3(31)
    );
  DATA_ENABLE_CELL_BUF_4_0_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(0),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(0)
    );
  DATA_ENABLE_CELL_BUF_4_1_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(1),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(1)
    );
  DATA_ENABLE_CELL_BUF_4_2_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(2),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(2)
    );
  DATA_ENABLE_CELL_BUF_4_3_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(3),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(3)
    );
  DATA_ENABLE_CELL_BUF_4_4_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(4),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(4)
    );
  DATA_ENABLE_CELL_BUF_4_5_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(5),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(5)
    );
  DATA_ENABLE_CELL_BUF_4_6_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(6),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(6)
    );
  DATA_ENABLE_CELL_BUF_4_7_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(7),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(7)
    );
  DATA_ENABLE_CELL_BUF_4_8_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(8),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(8)
    );
  DATA_ENABLE_CELL_BUF_4_9_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(9),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(9)
    );
  DATA_ENABLE_CELL_BUF_4_10_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(10),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(10)
    );
  DATA_ENABLE_CELL_BUF_4_11_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(11),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(11)
    );
  DATA_ENABLE_CELL_BUF_4_12_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(12),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(12)
    );
  DATA_ENABLE_CELL_BUF_4_13_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(13),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(13)
    );
  DATA_ENABLE_CELL_BUF_4_14_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(14),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(14)
    );
  DATA_ENABLE_CELL_BUF_4_15_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(15),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(15)
    );
  DATA_ENABLE_CELL_BUF_4_16_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(16),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(16)
    );
  DATA_ENABLE_CELL_BUF_4_17_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(17),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(17)
    );
  DATA_ENABLE_CELL_BUF_4_18_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(18),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(18)
    );
  DATA_ENABLE_CELL_BUF_4_19_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(19),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(19)
    );
  DATA_ENABLE_CELL_BUF_4_20_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(20),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(20)
    );
  DATA_ENABLE_CELL_BUF_4_21_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(21),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(21)
    );
  DATA_ENABLE_CELL_BUF_4_22_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(22),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(22)
    );
  DATA_ENABLE_CELL_BUF_4_23_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(23),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(23)
    );
  DATA_ENABLE_CELL_BUF_4_24_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(24),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(24)
    );
  DATA_ENABLE_CELL_BUF_4_25_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(25),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(25)
    );
  DATA_ENABLE_CELL_BUF_4_26_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(26),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(26)
    );
  DATA_ENABLE_CELL_BUF_4_27_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(27),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(27)
    );
  DATA_ENABLE_CELL_BUF_4_28_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(28),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(28)
    );
  DATA_ENABLE_CELL_BUF_4_29_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(29),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(29)
    );
  DATA_ENABLE_CELL_BUF_4_30_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(30),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(30)
    );
  DATA_ENABLE_CELL_BUF_4_31_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(31),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_4(31)
    );
  DATA_ENABLE_CELL_BUF_5_0_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(0),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(0)
    );
  DATA_ENABLE_CELL_BUF_5_1_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(1),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(1)
    );
  DATA_ENABLE_CELL_BUF_5_2_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(2),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(2)
    );
  DATA_ENABLE_CELL_BUF_5_3_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(3),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(3)
    );
  DATA_ENABLE_CELL_BUF_5_4_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(4),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(4)
    );
  DATA_ENABLE_CELL_BUF_5_5_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(5),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(5)
    );
  DATA_ENABLE_CELL_BUF_5_6_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(6),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(6)
    );
  DATA_ENABLE_CELL_BUF_5_7_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(7),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(7)
    );
  DATA_ENABLE_CELL_BUF_5_8_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(8),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(8)
    );
  DATA_ENABLE_CELL_BUF_5_9_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(9),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(9)
    );
  DATA_ENABLE_CELL_BUF_5_10_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(10),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(10)
    );
  DATA_ENABLE_CELL_BUF_5_11_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(11),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(11)
    );
  DATA_ENABLE_CELL_BUF_5_12_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(12),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(12)
    );
  DATA_ENABLE_CELL_BUF_5_13_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(13),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(13)
    );
  DATA_ENABLE_CELL_BUF_5_14_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(14),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(14)
    );
  DATA_ENABLE_CELL_BUF_5_15_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(15),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(15)
    );
  DATA_ENABLE_CELL_BUF_5_16_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(16),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(16)
    );
  DATA_ENABLE_CELL_BUF_5_17_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(17),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(17)
    );
  DATA_ENABLE_CELL_BUF_5_18_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(18),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(18)
    );
  DATA_ENABLE_CELL_BUF_5_19_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(19),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(19)
    );
  DATA_ENABLE_CELL_BUF_5_20_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(20),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(20)
    );
  DATA_ENABLE_CELL_BUF_5_21_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(21),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(21)
    );
  DATA_ENABLE_CELL_BUF_5_22_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(22),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(22)
    );
  DATA_ENABLE_CELL_BUF_5_23_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(23),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(23)
    );
  DATA_ENABLE_CELL_BUF_5_24_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(24),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(24)
    );
  DATA_ENABLE_CELL_BUF_5_25_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(25),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(25)
    );
  DATA_ENABLE_CELL_BUF_5_26_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(26),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(26)
    );
  DATA_ENABLE_CELL_BUF_5_27_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(27),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(27)
    );
  DATA_ENABLE_CELL_BUF_5_28_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(28),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(28)
    );
  DATA_ENABLE_CELL_BUF_5_29_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(29),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(29)
    );
  DATA_ENABLE_CELL_BUF_5_30_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(30),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(30)
    );
  DATA_ENABLE_CELL_BUF_5_31_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(31),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_5(31)
    );
  DATA_ENABLE_CELL_BUF_6_0_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(0),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(0)
    );
  DATA_ENABLE_CELL_BUF_6_1_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(1),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(1)
    );
  DATA_ENABLE_CELL_BUF_6_2_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(2),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(2)
    );
  DATA_ENABLE_CELL_BUF_6_3_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(3),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(3)
    );
  DATA_ENABLE_CELL_BUF_6_4_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(4),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(4)
    );
  DATA_ENABLE_CELL_BUF_6_5_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(5),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(5)
    );
  DATA_ENABLE_CELL_BUF_6_6_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(6),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(6)
    );
  DATA_ENABLE_CELL_BUF_6_7_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(7),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(7)
    );
  DATA_ENABLE_CELL_BUF_6_8_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(8),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(8)
    );
  DATA_ENABLE_CELL_BUF_6_9_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(9),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(9)
    );
  DATA_ENABLE_CELL_BUF_6_10_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(10),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(10)
    );
  DATA_ENABLE_CELL_BUF_6_11_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(11),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(11)
    );
  DATA_ENABLE_CELL_BUF_6_12_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(12),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(12)
    );
  DATA_ENABLE_CELL_BUF_6_13_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(13),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(13)
    );
  DATA_ENABLE_CELL_BUF_6_14_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(14),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(14)
    );
  DATA_ENABLE_CELL_BUF_6_15_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(15),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(15)
    );
  DATA_ENABLE_CELL_BUF_6_16_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(16),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(16)
    );
  DATA_ENABLE_CELL_BUF_6_17_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(17),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(17)
    );
  DATA_ENABLE_CELL_BUF_6_18_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(18),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(18)
    );
  DATA_ENABLE_CELL_BUF_6_19_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(19),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(19)
    );
  DATA_ENABLE_CELL_BUF_6_20_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(20),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(20)
    );
  DATA_ENABLE_CELL_BUF_6_21_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(21),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(21)
    );
  DATA_ENABLE_CELL_BUF_6_22_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(22),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(22)
    );
  DATA_ENABLE_CELL_BUF_6_23_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(23),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(23)
    );
  DATA_ENABLE_CELL_BUF_6_24_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(24),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(24)
    );
  DATA_ENABLE_CELL_BUF_6_25_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(25),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(25)
    );
  DATA_ENABLE_CELL_BUF_6_26_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(26),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(26)
    );
  DATA_ENABLE_CELL_BUF_6_27_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(27),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(27)
    );
  DATA_ENABLE_CELL_BUF_6_28_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(28),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(28)
    );
  DATA_ENABLE_CELL_BUF_6_29_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(29),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(29)
    );
  DATA_ENABLE_CELL_BUF_6_30_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(30),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(30)
    );
  DATA_ENABLE_CELL_BUF_6_31_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(31),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_6(31)
    );
  DATA_ENABLE_CELL_BUF_7_0_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(0),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(0)
    );
  DATA_ENABLE_CELL_BUF_7_1_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(1),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(1)
    );
  DATA_ENABLE_CELL_BUF_7_2_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(2),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(2)
    );
  DATA_ENABLE_CELL_BUF_7_3_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(3),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(3)
    );
  DATA_ENABLE_CELL_BUF_7_4_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(4),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(4)
    );
  DATA_ENABLE_CELL_BUF_7_5_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(5),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(5)
    );
  DATA_ENABLE_CELL_BUF_7_6_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(6),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(6)
    );
  DATA_ENABLE_CELL_BUF_7_7_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(7),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(7)
    );
  DATA_ENABLE_CELL_BUF_7_8_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(8),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(8)
    );
  DATA_ENABLE_CELL_BUF_7_9_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(9),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(9)
    );
  DATA_ENABLE_CELL_BUF_7_10_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(10),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(10)
    );
  DATA_ENABLE_CELL_BUF_7_11_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(11),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(11)
    );
  DATA_ENABLE_CELL_BUF_7_12_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(12),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(12)
    );
  DATA_ENABLE_CELL_BUF_7_13_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(13),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(13)
    );
  DATA_ENABLE_CELL_BUF_7_14_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(14),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(14)
    );
  DATA_ENABLE_CELL_BUF_7_15_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(15),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(15)
    );
  DATA_ENABLE_CELL_BUF_7_16_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(16),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(16)
    );
  DATA_ENABLE_CELL_BUF_7_17_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(17),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(17)
    );
  DATA_ENABLE_CELL_BUF_7_18_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(18),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(18)
    );
  DATA_ENABLE_CELL_BUF_7_19_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(19),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(19)
    );
  DATA_ENABLE_CELL_BUF_7_20_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(20),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(20)
    );
  DATA_ENABLE_CELL_BUF_7_21_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(21),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(21)
    );
  DATA_ENABLE_CELL_BUF_7_22_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(22),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(22)
    );
  DATA_ENABLE_CELL_BUF_7_23_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(23),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(23)
    );
  DATA_ENABLE_CELL_BUF_7_24_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(24),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(24)
    );
  DATA_ENABLE_CELL_BUF_7_25_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(25),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(25)
    );
  DATA_ENABLE_CELL_BUF_7_26_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(26),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(26)
    );
  DATA_ENABLE_CELL_BUF_7_27_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(27),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(27)
    );
  DATA_ENABLE_CELL_BUF_7_28_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(28),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(28)
    );
  DATA_ENABLE_CELL_BUF_7_29_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(29),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(29)
    );
  DATA_ENABLE_CELL_BUF_7_30_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(30),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(30)
    );
  DATA_ENABLE_CELL_BUF_7_31_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(31),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_7(31)
    );
  DATA_ENABLE_CELL_BUF_8_0_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(0),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(0)
    );
  DATA_ENABLE_CELL_BUF_8_1_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(1),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(1)
    );
  DATA_ENABLE_CELL_BUF_8_2_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(2),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(2)
    );
  DATA_ENABLE_CELL_BUF_8_3_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(3),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(3)
    );
  DATA_ENABLE_CELL_BUF_8_4_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(4),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(4)
    );
  DATA_ENABLE_CELL_BUF_8_5_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(5),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(5)
    );
  DATA_ENABLE_CELL_BUF_8_6_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(6),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(6)
    );
  DATA_ENABLE_CELL_BUF_8_7_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(7),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(7)
    );
  DATA_ENABLE_CELL_BUF_8_8_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(8),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(8)
    );
  DATA_ENABLE_CELL_BUF_8_9_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(9),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(9)
    );
  DATA_ENABLE_CELL_BUF_8_10_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(10),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(10)
    );
  DATA_ENABLE_CELL_BUF_8_11_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(11),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(11)
    );
  DATA_ENABLE_CELL_BUF_8_12_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(12),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(12)
    );
  DATA_ENABLE_CELL_BUF_8_13_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(13),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(13)
    );
  DATA_ENABLE_CELL_BUF_8_14_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(14),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(14)
    );
  DATA_ENABLE_CELL_BUF_8_15_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(15),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(15)
    );
  DATA_ENABLE_CELL_BUF_8_16_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(16),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(16)
    );
  DATA_ENABLE_CELL_BUF_8_17_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(17),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(17)
    );
  DATA_ENABLE_CELL_BUF_8_18_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(18),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(18)
    );
  DATA_ENABLE_CELL_BUF_8_19_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(19),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(19)
    );
  DATA_ENABLE_CELL_BUF_8_20_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(20),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(20)
    );
  DATA_ENABLE_CELL_BUF_8_21_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(21),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(21)
    );
  DATA_ENABLE_CELL_BUF_8_22_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(22),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(22)
    );
  DATA_ENABLE_CELL_BUF_8_23_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(23),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(23)
    );
  DATA_ENABLE_CELL_BUF_8_24_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(24),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(24)
    );
  DATA_ENABLE_CELL_BUF_8_25_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(25),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(25)
    );
  DATA_ENABLE_CELL_BUF_8_26_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(26),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(26)
    );
  DATA_ENABLE_CELL_BUF_8_27_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(27),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(27)
    );
  DATA_ENABLE_CELL_BUF_8_28_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(28),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(28)
    );
  DATA_ENABLE_CELL_BUF_8_29_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(29),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(29)
    );
  DATA_ENABLE_CELL_BUF_8_30_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(30),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(30)
    );
  DATA_ENABLE_CELL_BUF_8_31_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(31),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_8(31)
    );
  DATA_ENABLE_CELL_BUF_9_0_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(0),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(0)
    );
  DATA_ENABLE_CELL_BUF_9_1_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(1),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(1)
    );
  DATA_ENABLE_CELL_BUF_9_2_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(2),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(2)
    );
  DATA_ENABLE_CELL_BUF_9_3_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(3),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(3)
    );
  DATA_ENABLE_CELL_BUF_9_4_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(4),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(4)
    );
  DATA_ENABLE_CELL_BUF_9_5_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(5),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(5)
    );
  DATA_ENABLE_CELL_BUF_9_6_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(6),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(6)
    );
  DATA_ENABLE_CELL_BUF_9_7_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(7),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(7)
    );
  DATA_ENABLE_CELL_BUF_9_8_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(8),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(8)
    );
  DATA_ENABLE_CELL_BUF_9_9_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(9),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(9)
    );
  DATA_ENABLE_CELL_BUF_9_10_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(10),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(10)
    );
  DATA_ENABLE_CELL_BUF_9_11_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(11),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(11)
    );
  DATA_ENABLE_CELL_BUF_9_12_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(12),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(12)
    );
  DATA_ENABLE_CELL_BUF_9_13_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(13),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(13)
    );
  DATA_ENABLE_CELL_BUF_9_14_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(14),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(14)
    );
  DATA_ENABLE_CELL_BUF_9_15_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(15),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(15)
    );
  DATA_ENABLE_CELL_BUF_9_16_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(16),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(16)
    );
  DATA_ENABLE_CELL_BUF_9_17_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(17),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(17)
    );
  DATA_ENABLE_CELL_BUF_9_18_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(18),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(18)
    );
  DATA_ENABLE_CELL_BUF_9_19_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(19),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(19)
    );
  DATA_ENABLE_CELL_BUF_9_20_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(20),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(20)
    );
  DATA_ENABLE_CELL_BUF_9_21_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(21),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(21)
    );
  DATA_ENABLE_CELL_BUF_9_22_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(22),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(22)
    );
  DATA_ENABLE_CELL_BUF_9_23_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(23),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(23)
    );
  DATA_ENABLE_CELL_BUF_9_24_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(24),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(24)
    );
  DATA_ENABLE_CELL_BUF_9_25_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(25),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(25)
    );
  DATA_ENABLE_CELL_BUF_9_26_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(26),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(26)
    );
  DATA_ENABLE_CELL_BUF_9_27_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(27),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(27)
    );
  DATA_ENABLE_CELL_BUF_9_28_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(28),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(28)
    );
  DATA_ENABLE_CELL_BUF_9_29_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(29),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(29)
    );
  DATA_ENABLE_CELL_BUF_9_30_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(30),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(30)
    );
  DATA_ENABLE_CELL_BUF_9_31_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(31),
      CLK => CLK,
      CE => DATA_ENABLE_G_1745,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_9(31)
    );
  DATA_ENABLE_CELL_BUF_10_0_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(0),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(0)
    );
  DATA_ENABLE_CELL_BUF_10_1_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(1),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(1)
    );
  DATA_ENABLE_CELL_BUF_10_2_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(2),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(2)
    );
  DATA_ENABLE_CELL_BUF_10_3_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(3),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(3)
    );
  DATA_ENABLE_CELL_BUF_10_4_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(4),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(4)
    );
  DATA_ENABLE_CELL_BUF_10_5_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(5),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(5)
    );
  DATA_ENABLE_CELL_BUF_10_6_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(6),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(6)
    );
  DATA_ENABLE_CELL_BUF_10_7_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(7),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(7)
    );
  DATA_ENABLE_CELL_BUF_10_8_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(8),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(8)
    );
  DATA_ENABLE_CELL_BUF_10_9_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(9),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(9)
    );
  DATA_ENABLE_CELL_BUF_10_10_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(10),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(10)
    );
  DATA_ENABLE_CELL_BUF_10_11_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(11),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(11)
    );
  DATA_ENABLE_CELL_BUF_10_12_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(12),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(12)
    );
  DATA_ENABLE_CELL_BUF_10_13_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(13),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(13)
    );
  DATA_ENABLE_CELL_BUF_10_14_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(14),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(14)
    );
  DATA_ENABLE_CELL_BUF_10_15_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(15),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(15)
    );
  DATA_ENABLE_CELL_BUF_10_16_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(16),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(16)
    );
  DATA_ENABLE_CELL_BUF_10_17_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(17),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(17)
    );
  DATA_ENABLE_CELL_BUF_10_18_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(18),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(18)
    );
  DATA_ENABLE_CELL_BUF_10_19_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(19),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(19)
    );
  DATA_ENABLE_CELL_BUF_10_20_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(20),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(20)
    );
  DATA_ENABLE_CELL_BUF_10_21_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(21),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(21)
    );
  DATA_ENABLE_CELL_BUF_10_22_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(22),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(22)
    );
  DATA_ENABLE_CELL_BUF_10_23_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(23),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(23)
    );
  DATA_ENABLE_CELL_BUF_10_24_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(24),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(24)
    );
  DATA_ENABLE_CELL_BUF_10_25_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(25),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(25)
    );
  DATA_ENABLE_CELL_BUF_10_26_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(26),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(26)
    );
  DATA_ENABLE_CELL_BUF_10_27_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(27),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(27)
    );
  DATA_ENABLE_CELL_BUF_10_28_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(28),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(28)
    );
  DATA_ENABLE_CELL_BUF_10_29_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(29),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(29)
    );
  DATA_ENABLE_CELL_BUF_10_30_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(30),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(30)
    );
  DATA_ENABLE_CELL_BUF_10_31_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(31),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_10(31)
    );
  DATA_ENABLE_CELL_BUF_11_0_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(0),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(0)
    );
  DATA_ENABLE_CELL_BUF_11_1_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(1),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(1)
    );
  DATA_ENABLE_CELL_BUF_11_2_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(2),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(2)
    );
  DATA_ENABLE_CELL_BUF_11_3_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(3),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(3)
    );
  DATA_ENABLE_CELL_BUF_11_4_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(4),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(4)
    );
  DATA_ENABLE_CELL_BUF_11_5_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(5),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(5)
    );
  DATA_ENABLE_CELL_BUF_11_6_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(6),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(6)
    );
  DATA_ENABLE_CELL_BUF_11_7_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(7),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(7)
    );
  DATA_ENABLE_CELL_BUF_11_8_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(8),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(8)
    );
  DATA_ENABLE_CELL_BUF_11_9_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(9),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(9)
    );
  DATA_ENABLE_CELL_BUF_11_10_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(10),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(10)
    );
  DATA_ENABLE_CELL_BUF_11_11_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(11),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(11)
    );
  DATA_ENABLE_CELL_BUF_11_12_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(12),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(12)
    );
  DATA_ENABLE_CELL_BUF_11_13_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(13),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(13)
    );
  DATA_ENABLE_CELL_BUF_11_14_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(14),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(14)
    );
  DATA_ENABLE_CELL_BUF_11_15_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(15),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(15)
    );
  DATA_ENABLE_CELL_BUF_11_16_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(16),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(16)
    );
  DATA_ENABLE_CELL_BUF_11_17_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(17),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(17)
    );
  DATA_ENABLE_CELL_BUF_11_18_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(18),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(18)
    );
  DATA_ENABLE_CELL_BUF_11_19_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(19),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(19)
    );
  DATA_ENABLE_CELL_BUF_11_20_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(20),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(20)
    );
  DATA_ENABLE_CELL_BUF_11_21_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(21),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(21)
    );
  DATA_ENABLE_CELL_BUF_11_22_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(22),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(22)
    );
  DATA_ENABLE_CELL_BUF_11_23_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(23),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(23)
    );
  DATA_ENABLE_CELL_BUF_11_24_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(24),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(24)
    );
  DATA_ENABLE_CELL_BUF_11_25_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(25),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(25)
    );
  DATA_ENABLE_CELL_BUF_11_26_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(26),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(26)
    );
  DATA_ENABLE_CELL_BUF_11_27_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(27),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(27)
    );
  DATA_ENABLE_CELL_BUF_11_28_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(28),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(28)
    );
  DATA_ENABLE_CELL_BUF_11_29_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(29),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(29)
    );
  DATA_ENABLE_CELL_BUF_11_30_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(30),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(30)
    );
  DATA_ENABLE_CELL_BUF_11_31_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(31),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_CELL_BUF_11(31)
    );
  DATA_ENABLE_CWCOUNT_IN_0_Q : X_SFF
    port map (
      I => G_801,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => DATA_ENABLE_STATE_IN_7_Q,
      O => DATA_ENABLE_CWCOUNT_IN(0)
    );
  DATA_ENABLE_CWCOUNT_IN_1_Q : X_SFF
    port map (
      I => G_802,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => DATA_ENABLE_STATE_IN_7_Q,
      O => DATA_ENABLE_CWCOUNT_IN(1)
    );
  DATA_ENABLE_CWCOUNT_IN_2_Q : X_SFF
    port map (
      I => G_803,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => DATA_ENABLE_STATE_IN_7_Q,
      O => DATA_ENABLE_CWCOUNT_IN(2)
    );
  DATA_ENABLE_CWCOUNT_IN_3_Q : X_SFF
    port map (
      I => G_804,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => DATA_ENABLE_STATE_IN_7_Q,
      O => DATA_ENABLE_N_971_1
    );
  DATA_ENABLE_CWCOUNT_OUT_0_Q : X_SFF
    port map (
      I => RESET_L_0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => DATA_ENABLE_CWCOUNT_OUT_PROC_CWCOUNT_OUT_1_1_I(0),
      O => DATA_ENABLE_CWCOUNT_OUT(0)
    );
  DATA_ENABLE_CWCOUNT_OUT_1_Q : X_SFF
    port map (
      I => RESET_L_0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => DATA_ENABLE_CWCOUNT_OUT_PROC_CWCOUNT_OUT_1_1_I(1),
      O => DATA_ENABLE_CWCOUNT_OUT(1)
    );
  DATA_ENABLE_CWCOUNT_OUT_2_Q : X_SFF
    port map (
      I => RESET_L_0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => DATA_ENABLE_CWCOUNT_OUT_PROC_CWCOUNT_OUT_1_1_I(2),
      O => DATA_ENABLE_CWCOUNT_OUT(2)
    );
  DATA_ENABLE_CWCOUNT_OUT_3_Q : X_SFF
    port map (
      I => RESET_L_0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => DATA_ENABLE_CWCOUNT_OUT_PROC_CWCOUNT_OUT_1_1_I(3),
      O => DATA_ENABLE_N_983_1
    );
  DATA_ENABLE_CWCOUNT_OUT_0_0_Q : X_BUF
    port map (
      I => DATA_ENABLE_CWCOUNT_OUT(0),
      O => DATA_ENABLE_CWCOUNT_OUT_0(0)
    );
  DATA_ENABLE_CWCOUNT_OUT_1_0_Q : X_BUF
    port map (
      I => DATA_ENABLE_CWCOUNT_OUT(0),
      O => DATA_ENABLE_CWCOUNT_OUT_1(0)
    );
  DATA_ENABLE_CWCOUNT_OUT_PROC_CWCOUNT_OUT_1_1_I_0_Q : X_LUT4
    generic map (
      INIT => X"FFF9"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_STATE_OUT_0_5_Q,
      ADR2 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR3 => DATA_ENABLE_STATE_OUT_6_Q,
      O => DATA_ENABLE_CWCOUNT_OUT_PROC_CWCOUNT_OUT_1_1_I(0)
    );
  DATA_ENABLE_CWCOUNT_OUT_PROC_CWCOUNT_OUT_1_1_I_1_Q : X_LUT3
    generic map (
      INIT => X"EB"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_PROC_UN5_STATE_OUT,
      ADR1 => DATA_ENABLE_UN3_CWCOUNT_OUT_5_C1,
      ADR2 => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_CWCOUNT_OUT_PROC_CWCOUNT_OUT_1_1_I(1)
    );
  DATA_ENABLE_CWCOUNT_OUT_PROC_CWCOUNT_OUT_1_1_I_2_Q : X_LUT3
    generic map (
      INIT => X"EB"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_PROC_UN5_STATE_OUT,
      ADR1 => DATA_ENABLE_UN3_CWCOUNT_OUT_5_C2,
      ADR2 => DATA_ENABLE_CWCOUNT_OUT(2),
      O => DATA_ENABLE_CWCOUNT_OUT_PROC_CWCOUNT_OUT_1_1_I(2)
    );
  DATA_ENABLE_CWCOUNT_OUT_PROC_CWCOUNT_OUT_1_1_I_3_Q : X_LUT4
    generic map (
      INIT => X"EBBB"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_PROC_UN5_STATE_OUT,
      ADR1 => DATA_ENABLE_N_983_1_0,
      ADR2 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR3 => DATA_ENABLE_UN3_CWCOUNT_OUT_5_C2,
      O => DATA_ENABLE_CWCOUNT_OUT_PROC_CWCOUNT_OUT_1_1_I(3)
    );
  DATA_ENABLE_DATA_IN_0_Q : X_FF
    port map (
      I => DATA2(0),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(0)
    );
  DATA_ENABLE_DATA_IN_1_Q : X_FF
    port map (
      I => DATA2(1),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(1)
    );
  DATA_ENABLE_DATA_IN_2_Q : X_FF
    port map (
      I => DATA2(2),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(2)
    );
  DATA_ENABLE_DATA_IN_3_Q : X_FF
    port map (
      I => DATA2(3),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(3)
    );
  DATA_ENABLE_DATA_IN_4_Q : X_FF
    port map (
      I => DATA2(4),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(4)
    );
  DATA_ENABLE_DATA_IN_5_Q : X_FF
    port map (
      I => DATA2(5),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(5)
    );
  DATA_ENABLE_DATA_IN_6_Q : X_FF
    port map (
      I => DATA2(6),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(6)
    );
  DATA_ENABLE_DATA_IN_7_Q : X_FF
    port map (
      I => DATA2(7),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(7)
    );
  DATA_ENABLE_DATA_IN_8_Q : X_FF
    port map (
      I => DATA2(8),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(8)
    );
  DATA_ENABLE_DATA_IN_9_Q : X_FF
    port map (
      I => DATA2(9),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(9)
    );
  DATA_ENABLE_DATA_IN_10_Q : X_FF
    port map (
      I => DATA2(10),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(10)
    );
  DATA_ENABLE_DATA_IN_11_Q : X_FF
    port map (
      I => DATA2(11),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(11)
    );
  DATA_ENABLE_DATA_IN_12_Q : X_FF
    port map (
      I => DATA2(12),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(12)
    );
  DATA_ENABLE_DATA_IN_13_Q : X_FF
    port map (
      I => DATA2(13),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(13)
    );
  DATA_ENABLE_DATA_IN_14_Q : X_FF
    port map (
      I => DATA2(14),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(14)
    );
  DATA_ENABLE_DATA_IN_15_Q : X_FF
    port map (
      I => DATA2(15),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(15)
    );
  DATA_ENABLE_DATA_IN_16_Q : X_FF
    port map (
      I => DATA2(16),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(16)
    );
  DATA_ENABLE_DATA_IN_17_Q : X_FF
    port map (
      I => DATA2(17),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(17)
    );
  DATA_ENABLE_DATA_IN_18_Q : X_FF
    port map (
      I => DATA2(18),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(18)
    );
  DATA_ENABLE_DATA_IN_19_Q : X_FF
    port map (
      I => DATA2(19),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(19)
    );
  DATA_ENABLE_DATA_IN_20_Q : X_FF
    port map (
      I => DATA2(20),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(20)
    );
  DATA_ENABLE_DATA_IN_21_Q : X_FF
    port map (
      I => DATA2(21),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(21)
    );
  DATA_ENABLE_DATA_IN_22_Q : X_FF
    port map (
      I => DATA2(22),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(22)
    );
  DATA_ENABLE_DATA_IN_23_Q : X_FF
    port map (
      I => DATA2(23),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(23)
    );
  DATA_ENABLE_DATA_IN_24_Q : X_FF
    port map (
      I => DATA2(24),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(24)
    );
  DATA_ENABLE_DATA_IN_25_Q : X_FF
    port map (
      I => DATA2(25),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(25)
    );
  DATA_ENABLE_DATA_IN_26_Q : X_FF
    port map (
      I => DATA2(26),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(26)
    );
  DATA_ENABLE_DATA_IN_27_Q : X_FF
    port map (
      I => DATA2(27),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(27)
    );
  DATA_ENABLE_DATA_IN_28_Q : X_FF
    port map (
      I => DATA2(28),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(28)
    );
  DATA_ENABLE_DATA_IN_29_Q : X_FF
    port map (
      I => DATA2(29),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(29)
    );
  DATA_ENABLE_DATA_IN_30_Q : X_FF
    port map (
      I => DATA2(30),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(30)
    );
  DATA_ENABLE_DATA_IN_31_Q : X_FF
    port map (
      I => DATA2(31),
      CLK => CLK,
      CE => RESET_L_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DATA_IN(31)
    );
  DATA_ENABLE_DATAEN_OUT_MOD_1_0 : X_LUT3
    generic map (
      INIT => X"FE"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR1 => DATA_ENABLE_G_54,
      ADR2 => DATA_ENABLE_N_2276,
      O => DATA_ENABLE_DATAEN_OUT_MOD_1
    );
  DATA_ENABLE_DELAY_WORD0_0_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(0),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(0)
    );
  DATA_ENABLE_DELAY_WORD0_1_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(1),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(1)
    );
  DATA_ENABLE_DELAY_WORD0_2_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(2),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(2)
    );
  DATA_ENABLE_DELAY_WORD0_3_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(3),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(3)
    );
  DATA_ENABLE_DELAY_WORD0_4_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(4),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(4)
    );
  DATA_ENABLE_DELAY_WORD0_5_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(5),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(5)
    );
  DATA_ENABLE_DELAY_WORD0_6_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(6),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(6)
    );
  DATA_ENABLE_DELAY_WORD0_7_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(7),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(7)
    );
  DATA_ENABLE_DELAY_WORD0_8_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(8),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(8)
    );
  DATA_ENABLE_DELAY_WORD0_9_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(9),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(9)
    );
  DATA_ENABLE_DELAY_WORD0_10_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(10),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(10)
    );
  DATA_ENABLE_DELAY_WORD0_11_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(11),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(11)
    );
  DATA_ENABLE_DELAY_WORD0_12_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(12),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(12)
    );
  DATA_ENABLE_DELAY_WORD0_13_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(13),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(13)
    );
  DATA_ENABLE_DELAY_WORD0_14_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(14),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(14)
    );
  DATA_ENABLE_DELAY_WORD0_15_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(15),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(15)
    );
  DATA_ENABLE_DELAY_WORD0_16_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(16),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(16)
    );
  DATA_ENABLE_DELAY_WORD0_17_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(17),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(17)
    );
  DATA_ENABLE_DELAY_WORD0_18_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(18),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(18)
    );
  DATA_ENABLE_DELAY_WORD0_19_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(19),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(19)
    );
  DATA_ENABLE_DELAY_WORD0_20_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(20),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(20)
    );
  DATA_ENABLE_DELAY_WORD0_21_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(21),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(21)
    );
  DATA_ENABLE_DELAY_WORD0_22_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(22),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(22)
    );
  DATA_ENABLE_DELAY_WORD0_23_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(23),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(23)
    );
  DATA_ENABLE_DELAY_WORD0_24_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(24),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(24)
    );
  DATA_ENABLE_DELAY_WORD0_25_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(25),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(25)
    );
  DATA_ENABLE_DELAY_WORD0_26_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(26),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(26)
    );
  DATA_ENABLE_DELAY_WORD0_27_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(27),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(27)
    );
  DATA_ENABLE_DELAY_WORD0_28_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(28),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(28)
    );
  DATA_ENABLE_DELAY_WORD0_29_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(29),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(29)
    );
  DATA_ENABLE_DELAY_WORD0_30_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(30),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(30)
    );
  DATA_ENABLE_DELAY_WORD0_31_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(31),
      CLK => CLK,
      CE => DATA_ENABLE_UN1_STATE_IN_11_0_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD0(31)
    );
  DATA_ENABLE_DELAY_WORD1_0_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(0),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(0)
    );
  DATA_ENABLE_DELAY_WORD1_1_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(1),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(1)
    );
  DATA_ENABLE_DELAY_WORD1_2_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(2),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(2)
    );
  DATA_ENABLE_DELAY_WORD1_3_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(3),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(3)
    );
  DATA_ENABLE_DELAY_WORD1_4_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(4),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(4)
    );
  DATA_ENABLE_DELAY_WORD1_5_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(5),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(5)
    );
  DATA_ENABLE_DELAY_WORD1_6_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(6),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(6)
    );
  DATA_ENABLE_DELAY_WORD1_7_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(7),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(7)
    );
  DATA_ENABLE_DELAY_WORD1_8_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(8),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(8)
    );
  DATA_ENABLE_DELAY_WORD1_9_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(9),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(9)
    );
  DATA_ENABLE_DELAY_WORD1_10_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(10),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(10)
    );
  DATA_ENABLE_DELAY_WORD1_11_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(11),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(11)
    );
  DATA_ENABLE_DELAY_WORD1_12_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(12),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(12)
    );
  DATA_ENABLE_DELAY_WORD1_13_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(13),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(13)
    );
  DATA_ENABLE_DELAY_WORD1_14_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(14),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(14)
    );
  DATA_ENABLE_DELAY_WORD1_15_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(15),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(15)
    );
  DATA_ENABLE_DELAY_WORD1_16_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(16),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(16)
    );
  DATA_ENABLE_DELAY_WORD1_17_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(17),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(17)
    );
  DATA_ENABLE_DELAY_WORD1_18_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(18),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(18)
    );
  DATA_ENABLE_DELAY_WORD1_19_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(19),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(19)
    );
  DATA_ENABLE_DELAY_WORD1_20_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(20),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(20)
    );
  DATA_ENABLE_DELAY_WORD1_21_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(21),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(21)
    );
  DATA_ENABLE_DELAY_WORD1_22_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(22),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(22)
    );
  DATA_ENABLE_DELAY_WORD1_23_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(23),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(23)
    );
  DATA_ENABLE_DELAY_WORD1_24_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(24),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(24)
    );
  DATA_ENABLE_DELAY_WORD1_25_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(25),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(25)
    );
  DATA_ENABLE_DELAY_WORD1_26_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(26),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(26)
    );
  DATA_ENABLE_DELAY_WORD1_27_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(27),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(27)
    );
  DATA_ENABLE_DELAY_WORD1_28_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(28),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(28)
    );
  DATA_ENABLE_DELAY_WORD1_29_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(29),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(29)
    );
  DATA_ENABLE_DELAY_WORD1_30_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(30),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(30)
    );
  DATA_ENABLE_DELAY_WORD1_31_Q : X_FF
    port map (
      I => DATA_ENABLE_DATA_IN(31),
      CLK => CLK,
      CE => DATA_ENABLE_STATE_IN_0_1_Q,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_DELAY_WORD1(31)
    );
  DATA_ENABLE_FWCOUNT_0_Q : X_FF
    port map (
      I => DATA_ENABLE_FWCOUNT_LM(0),
      CLK => CLK,
      CE => DATA_ENABLE_G_1_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_FWCOUNT(0)
    );
  DATA_ENABLE_FWCOUNT_1_Q : X_FF
    port map (
      I => DATA_ENABLE_FWCOUNT_LM(1),
      CLK => CLK,
      CE => DATA_ENABLE_G_1_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_FWCOUNT(1)
    );
  DATA_ENABLE_FWCOUNT_2_Q : X_FF
    port map (
      I => DATA_ENABLE_FWCOUNT_LM(2),
      CLK => CLK,
      CE => DATA_ENABLE_G_1_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_FWCOUNT(2)
    );
  DATA_ENABLE_FWCOUNT_3_Q : X_FF
    port map (
      I => DATA_ENABLE_FWCOUNT_LM(3),
      CLK => CLK,
      CE => DATA_ENABLE_G_1_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_FWCOUNT(3)
    );
  DATA_ENABLE_FWCOUNT_4_Q : X_FF
    port map (
      I => DATA_ENABLE_FWCOUNT_LM(4),
      CLK => CLK,
      CE => DATA_ENABLE_G_1_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_FWCOUNT(4)
    );
  DATA_ENABLE_FWCOUNT_5_Q : X_FF
    port map (
      I => DATA_ENABLE_FWCOUNT_LM(5),
      CLK => CLK,
      CE => DATA_ENABLE_G_1_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_FWCOUNT(5)
    );
  DATA_ENABLE_FWCOUNT_6_Q : X_FF
    port map (
      I => DATA_ENABLE_FWCOUNT_LM(6),
      CLK => CLK,
      CE => DATA_ENABLE_G_1_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_FWCOUNT(6)
    );
  DATA_ENABLE_FWCOUNT_7_Q : X_FF
    port map (
      I => DATA_ENABLE_FWCOUNT_LM(7),
      CLK => CLK,
      CE => DATA_ENABLE_G_1_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_FWCOUNT(7)
    );
  DATA_ENABLE_FWCOUNT_8_Q : X_FF
    port map (
      I => DATA_ENABLE_FWCOUNT_LM(8),
      CLK => CLK,
      CE => DATA_ENABLE_G_1_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_FWCOUNT(8)
    );
  DATA_ENABLE_FWCOUNT_9_Q : X_FF
    port map (
      I => DATA_ENABLE_FWCOUNT_LM(9),
      CLK => CLK,
      CE => DATA_ENABLE_G_1_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_FWCOUNT(9)
    );
  DATA_ENABLE_FWCOUNT_10_Q : X_FF
    port map (
      I => DATA_ENABLE_FWCOUNT_LM(10),
      CLK => CLK,
      CE => DATA_ENABLE_G_1_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_FWCOUNT(10)
    );
  DATA_ENABLE_FWCOUNT_11_Q : X_FF
    port map (
      I => DATA_ENABLE_FWCOUNT_LM(11),
      CLK => CLK,
      CE => DATA_ENABLE_G_1_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_FWCOUNT(11)
    );
  DATA_ENABLE_FWCOUNT_12_Q : X_FF
    port map (
      I => DATA_ENABLE_FWCOUNT_LM(12),
      CLK => CLK,
      CE => DATA_ENABLE_G_1_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_FWCOUNT(12)
    );
  DATA_ENABLE_FWCOUNT_13_Q : X_FF
    port map (
      I => DATA_ENABLE_FWCOUNT_LM(13),
      CLK => CLK,
      CE => DATA_ENABLE_G_1_0,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_FWCOUNT(13)
    );
  DATA_ENABLE_FWCOUNT_CRY_0_Q : X_MUX2
    port map (
      IA => DATA_ENABLE_GND,
      IB => DATA_ENABLE_VCC,
      SEL => DATA_ENABLE_FWCOUNT_QXU(0),
      O => DATA_ENABLE_FWCOUNT_CRY_0_O
    );
  DATA_ENABLE_FWCOUNT_CRY_0_MUXCY_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_FWCOUNT_CRY_0_O,
      O => DATA_ENABLE_FWCOUNT_CRY(0)
    );
  DATA_ENABLE_FWCOUNT_CRY_1_Q : X_MUX2
    port map (
      IA => DATA_ENABLE_GND,
      IB => DATA_ENABLE_FWCOUNT_CRY(0),
      SEL => DATA_ENABLE_FWCOUNT_QXU(1),
      O => DATA_ENABLE_FWCOUNT_CRY_1_O
    );
  DATA_ENABLE_FWCOUNT_CRY_1_MUXCY_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_FWCOUNT_CRY_1_O,
      O => DATA_ENABLE_FWCOUNT_CRY(1)
    );
  DATA_ENABLE_FWCOUNT_CRY_2_Q : X_MUX2
    port map (
      IA => DATA_ENABLE_GND,
      IB => DATA_ENABLE_FWCOUNT_CRY(1),
      SEL => DATA_ENABLE_FWCOUNT_QXU(2),
      O => DATA_ENABLE_FWCOUNT_CRY_2_O
    );
  DATA_ENABLE_FWCOUNT_CRY_2_MUXCY_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_FWCOUNT_CRY_2_O,
      O => DATA_ENABLE_FWCOUNT_CRY(2)
    );
  DATA_ENABLE_FWCOUNT_CRY_3_Q : X_MUX2
    port map (
      IA => DATA_ENABLE_GND,
      IB => DATA_ENABLE_FWCOUNT_CRY(2),
      SEL => DATA_ENABLE_FWCOUNT_QXU(3),
      O => DATA_ENABLE_FWCOUNT_CRY_3_O
    );
  DATA_ENABLE_FWCOUNT_CRY_3_MUXCY_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_FWCOUNT_CRY_3_O,
      O => DATA_ENABLE_FWCOUNT_CRY(3)
    );
  DATA_ENABLE_FWCOUNT_CRY_4_Q : X_MUX2
    port map (
      IA => DATA_ENABLE_GND,
      IB => DATA_ENABLE_FWCOUNT_CRY(3),
      SEL => DATA_ENABLE_FWCOUNT_QXU(4),
      O => DATA_ENABLE_FWCOUNT_CRY_4_O
    );
  DATA_ENABLE_FWCOUNT_CRY_4_MUXCY_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_FWCOUNT_CRY_4_O,
      O => DATA_ENABLE_FWCOUNT_CRY(4)
    );
  DATA_ENABLE_FWCOUNT_CRY_5_Q : X_MUX2
    port map (
      IA => DATA_ENABLE_GND,
      IB => DATA_ENABLE_FWCOUNT_CRY(4),
      SEL => DATA_ENABLE_FWCOUNT_QXU(5),
      O => DATA_ENABLE_FWCOUNT_CRY_5_O
    );
  DATA_ENABLE_FWCOUNT_CRY_5_MUXCY_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_FWCOUNT_CRY_5_O,
      O => DATA_ENABLE_FWCOUNT_CRY(5)
    );
  DATA_ENABLE_FWCOUNT_CRY_6_Q : X_MUX2
    port map (
      IA => DATA_ENABLE_GND,
      IB => DATA_ENABLE_FWCOUNT_CRY(5),
      SEL => DATA_ENABLE_FWCOUNT_QXU(6),
      O => DATA_ENABLE_FWCOUNT_CRY_6_O
    );
  DATA_ENABLE_FWCOUNT_CRY_6_MUXCY_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_FWCOUNT_CRY_6_O,
      O => DATA_ENABLE_FWCOUNT_CRY(6)
    );
  DATA_ENABLE_FWCOUNT_CRY_7_Q : X_MUX2
    port map (
      IA => DATA_ENABLE_GND,
      IB => DATA_ENABLE_FWCOUNT_CRY(6),
      SEL => DATA_ENABLE_FWCOUNT_QXU(7),
      O => DATA_ENABLE_FWCOUNT_CRY_7_O
    );
  DATA_ENABLE_FWCOUNT_CRY_7_MUXCY_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_FWCOUNT_CRY_7_O,
      O => DATA_ENABLE_FWCOUNT_CRY(7)
    );
  DATA_ENABLE_FWCOUNT_CRY_8_Q : X_MUX2
    port map (
      IA => DATA_ENABLE_GND,
      IB => DATA_ENABLE_FWCOUNT_CRY(7),
      SEL => DATA_ENABLE_FWCOUNT_QXU(8),
      O => DATA_ENABLE_FWCOUNT_CRY_8_O
    );
  DATA_ENABLE_FWCOUNT_CRY_8_MUXCY_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_FWCOUNT_CRY_8_O,
      O => DATA_ENABLE_FWCOUNT_CRY(8)
    );
  DATA_ENABLE_FWCOUNT_CRY_9_Q : X_MUX2
    port map (
      IA => DATA_ENABLE_GND,
      IB => DATA_ENABLE_FWCOUNT_CRY(8),
      SEL => DATA_ENABLE_FWCOUNT_QXU(9),
      O => DATA_ENABLE_FWCOUNT_CRY_9_O
    );
  DATA_ENABLE_FWCOUNT_CRY_9_MUXCY_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_FWCOUNT_CRY_9_O,
      O => DATA_ENABLE_FWCOUNT_CRY(9)
    );
  DATA_ENABLE_FWCOUNT_CRY_10_Q : X_MUX2
    port map (
      IA => DATA_ENABLE_GND,
      IB => DATA_ENABLE_FWCOUNT_CRY(9),
      SEL => DATA_ENABLE_FWCOUNT_QXU(10),
      O => DATA_ENABLE_FWCOUNT_CRY_10_O
    );
  DATA_ENABLE_FWCOUNT_CRY_10_MUXCY_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_FWCOUNT_CRY_10_O,
      O => DATA_ENABLE_FWCOUNT_CRY(10)
    );
  DATA_ENABLE_FWCOUNT_CRY_11_Q : X_MUX2
    port map (
      IA => DATA_ENABLE_GND,
      IB => DATA_ENABLE_FWCOUNT_CRY(10),
      SEL => DATA_ENABLE_FWCOUNT_QXU(11),
      O => DATA_ENABLE_FWCOUNT_CRY_11_O
    );
  DATA_ENABLE_FWCOUNT_CRY_11_MUXCY_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_FWCOUNT_CRY_11_O,
      O => DATA_ENABLE_FWCOUNT_CRY(11)
    );
  DATA_ENABLE_FWCOUNT_CRY_12_Q : X_MUX2
    port map (
      IA => DATA_ENABLE_GND,
      IB => DATA_ENABLE_FWCOUNT_CRY(11),
      SEL => DATA_ENABLE_FWCOUNT_QXU(12),
      O => DATA_ENABLE_FWCOUNT_CRY_12_O
    );
  DATA_ENABLE_FWCOUNT_CRY_12_MUXCY_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_FWCOUNT_CRY_12_O,
      O => DATA_ENABLE_FWCOUNT_CRY(12)
    );
  DATA_ENABLE_FWCOUNT_LM_0_0_Q : X_LUT3
    generic map (
      INIT => X"FB"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT_S(0),
      ADR1 => RESET_L_0,
      ADR2 => DATA_ENABLE_STATE_OUT_6_Q,
      O => DATA_ENABLE_FWCOUNT_LM(0)
    );
  DATA_ENABLE_FWCOUNT_LM_0_1_Q : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT_S(1),
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_STATE_OUT_6_Q,
      O => DATA_ENABLE_FWCOUNT_LM(1)
    );
  DATA_ENABLE_FWCOUNT_LM_0_2_Q : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT_S(2),
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_STATE_OUT_6_Q,
      O => DATA_ENABLE_FWCOUNT_LM(2)
    );
  DATA_ENABLE_FWCOUNT_LM_0_3_Q : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT_S(3),
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_STATE_OUT_6_Q,
      O => DATA_ENABLE_FWCOUNT_LM(3)
    );
  DATA_ENABLE_FWCOUNT_LM_0_4_Q : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT_S(4),
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_STATE_OUT_6_Q,
      O => DATA_ENABLE_FWCOUNT_LM(4)
    );
  DATA_ENABLE_FWCOUNT_LM_0_5_Q : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT_S(5),
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_STATE_OUT_6_Q,
      O => DATA_ENABLE_FWCOUNT_LM(5)
    );
  DATA_ENABLE_FWCOUNT_LM_0_6_Q : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT_S(6),
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_STATE_OUT_6_Q,
      O => DATA_ENABLE_FWCOUNT_LM(6)
    );
  DATA_ENABLE_FWCOUNT_LM_0_7_Q : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT_S(7),
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_STATE_OUT_6_Q,
      O => DATA_ENABLE_FWCOUNT_LM(7)
    );
  DATA_ENABLE_FWCOUNT_LM_0_8_Q : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT_S(8),
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_STATE_OUT_6_Q,
      O => DATA_ENABLE_FWCOUNT_LM(8)
    );
  DATA_ENABLE_FWCOUNT_LM_0_9_Q : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT_S(9),
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_STATE_OUT_6_Q,
      O => DATA_ENABLE_FWCOUNT_LM(9)
    );
  DATA_ENABLE_FWCOUNT_LM_0_10_Q : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT_S(10),
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_STATE_OUT_6_Q,
      O => DATA_ENABLE_FWCOUNT_LM(10)
    );
  DATA_ENABLE_FWCOUNT_LM_0_11_Q : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT_S(11),
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_STATE_OUT_6_Q,
      O => DATA_ENABLE_FWCOUNT_LM(11)
    );
  DATA_ENABLE_FWCOUNT_LM_0_12_Q : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT_S(12),
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_STATE_OUT_6_Q,
      O => DATA_ENABLE_FWCOUNT_LM(12)
    );
  DATA_ENABLE_FWCOUNT_LM_0_13_Q : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT_S(13),
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_STATE_OUT_6_Q,
      O => DATA_ENABLE_FWCOUNT_LM(13)
    );
  DATA_ENABLE_FWCOUNT_QXU_0_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT(0),
      ADR1 => DATA_ENABLE_GND,
      O => DATA_ENABLE_FWCOUNT_QXU(0)
    );
  DATA_ENABLE_FWCOUNT_QXU_1_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT(1),
      ADR1 => DATA_ENABLE_GND,
      O => DATA_ENABLE_FWCOUNT_QXU(1)
    );
  DATA_ENABLE_FWCOUNT_QXU_2_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT(2),
      ADR1 => DATA_ENABLE_GND,
      O => DATA_ENABLE_FWCOUNT_QXU(2)
    );
  DATA_ENABLE_FWCOUNT_QXU_3_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT(3),
      ADR1 => DATA_ENABLE_GND,
      O => DATA_ENABLE_FWCOUNT_QXU(3)
    );
  DATA_ENABLE_FWCOUNT_QXU_4_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT(4),
      ADR1 => DATA_ENABLE_GND,
      O => DATA_ENABLE_FWCOUNT_QXU(4)
    );
  DATA_ENABLE_FWCOUNT_QXU_5_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT(5),
      ADR1 => DATA_ENABLE_GND,
      O => DATA_ENABLE_FWCOUNT_QXU(5)
    );
  DATA_ENABLE_FWCOUNT_QXU_6_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT(6),
      ADR1 => DATA_ENABLE_GND,
      O => DATA_ENABLE_FWCOUNT_QXU(6)
    );
  DATA_ENABLE_FWCOUNT_QXU_7_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT(7),
      ADR1 => DATA_ENABLE_GND,
      O => DATA_ENABLE_FWCOUNT_QXU(7)
    );
  DATA_ENABLE_FWCOUNT_QXU_8_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT(8),
      ADR1 => DATA_ENABLE_GND,
      O => DATA_ENABLE_FWCOUNT_QXU(8)
    );
  DATA_ENABLE_FWCOUNT_QXU_9_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT(9),
      ADR1 => DATA_ENABLE_GND,
      O => DATA_ENABLE_FWCOUNT_QXU(9)
    );
  DATA_ENABLE_FWCOUNT_QXU_10_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT(10),
      ADR1 => DATA_ENABLE_GND,
      O => DATA_ENABLE_FWCOUNT_QXU(10)
    );
  DATA_ENABLE_FWCOUNT_QXU_11_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT(11),
      ADR1 => DATA_ENABLE_GND,
      O => DATA_ENABLE_FWCOUNT_QXU(11)
    );
  DATA_ENABLE_FWCOUNT_QXU_12_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT(12),
      ADR1 => DATA_ENABLE_GND,
      O => DATA_ENABLE_FWCOUNT_QXU(12)
    );
  DATA_ENABLE_FWCOUNT_QXU_13_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => DATA_ENABLE_FWCOUNT(13),
      ADR1 => DATA_ENABLE_GND,
      O => DATA_ENABLE_FWCOUNT_QXU(13)
    );
  DATA_ENABLE_FWCOUNT_S_0_Q : X_XOR2
    port map (
      I0 => DATA_ENABLE_FWCOUNT_QXU(0),
      I1 => DATA_ENABLE_VCC,
      O => DATA_ENABLE_FWCOUNT_S(0)
    );
  DATA_ENABLE_FWCOUNT_S_1_Q : X_XOR2
    port map (
      I0 => DATA_ENABLE_FWCOUNT_QXU(1),
      I1 => DATA_ENABLE_FWCOUNT_CRY(0),
      O => DATA_ENABLE_FWCOUNT_S(1)
    );
  DATA_ENABLE_FWCOUNT_S_2_Q : X_XOR2
    port map (
      I0 => DATA_ENABLE_FWCOUNT_QXU(2),
      I1 => DATA_ENABLE_FWCOUNT_CRY(1),
      O => DATA_ENABLE_FWCOUNT_S(2)
    );
  DATA_ENABLE_FWCOUNT_S_3_Q : X_XOR2
    port map (
      I0 => DATA_ENABLE_FWCOUNT_QXU(3),
      I1 => DATA_ENABLE_FWCOUNT_CRY(2),
      O => DATA_ENABLE_FWCOUNT_S(3)
    );
  DATA_ENABLE_FWCOUNT_S_4_Q : X_XOR2
    port map (
      I0 => DATA_ENABLE_FWCOUNT_QXU(4),
      I1 => DATA_ENABLE_FWCOUNT_CRY(3),
      O => DATA_ENABLE_FWCOUNT_S(4)
    );
  DATA_ENABLE_FWCOUNT_S_5_Q : X_XOR2
    port map (
      I0 => DATA_ENABLE_FWCOUNT_QXU(5),
      I1 => DATA_ENABLE_FWCOUNT_CRY(4),
      O => DATA_ENABLE_FWCOUNT_S(5)
    );
  DATA_ENABLE_FWCOUNT_S_6_Q : X_XOR2
    port map (
      I0 => DATA_ENABLE_FWCOUNT_QXU(6),
      I1 => DATA_ENABLE_FWCOUNT_CRY(5),
      O => DATA_ENABLE_FWCOUNT_S(6)
    );
  DATA_ENABLE_FWCOUNT_S_7_Q : X_XOR2
    port map (
      I0 => DATA_ENABLE_FWCOUNT_QXU(7),
      I1 => DATA_ENABLE_FWCOUNT_CRY(6),
      O => DATA_ENABLE_FWCOUNT_S(7)
    );
  DATA_ENABLE_FWCOUNT_S_8_Q : X_XOR2
    port map (
      I0 => DATA_ENABLE_FWCOUNT_QXU(8),
      I1 => DATA_ENABLE_FWCOUNT_CRY(7),
      O => DATA_ENABLE_FWCOUNT_S(8)
    );
  DATA_ENABLE_FWCOUNT_S_9_Q : X_XOR2
    port map (
      I0 => DATA_ENABLE_FWCOUNT_QXU(9),
      I1 => DATA_ENABLE_FWCOUNT_CRY(8),
      O => DATA_ENABLE_FWCOUNT_S(9)
    );
  DATA_ENABLE_FWCOUNT_S_10_Q : X_XOR2
    port map (
      I0 => DATA_ENABLE_FWCOUNT_QXU(10),
      I1 => DATA_ENABLE_FWCOUNT_CRY(9),
      O => DATA_ENABLE_FWCOUNT_S(10)
    );
  DATA_ENABLE_FWCOUNT_S_11_Q : X_XOR2
    port map (
      I0 => DATA_ENABLE_FWCOUNT_QXU(11),
      I1 => DATA_ENABLE_FWCOUNT_CRY(10),
      O => DATA_ENABLE_FWCOUNT_S(11)
    );
  DATA_ENABLE_FWCOUNT_S_12_Q : X_XOR2
    port map (
      I0 => DATA_ENABLE_FWCOUNT_QXU(12),
      I1 => DATA_ENABLE_FWCOUNT_CRY(11),
      O => DATA_ENABLE_FWCOUNT_S(12)
    );
  DATA_ENABLE_FWCOUNT_S_13_Q : X_XOR2
    port map (
      I0 => DATA_ENABLE_FWCOUNT_QXU(13),
      I1 => DATA_ENABLE_FWCOUNT_CRY(12),
      O => DATA_ENABLE_FWCOUNT_S(13)
    );
  DATA_ENABLE_LC_COPY_129 : X_SFF
    port map (
      I => RESET_L_0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => DATA_ENABLE_N_44_I,
      O => DATA_ENABLE_LC_COPY
    );
  DATA_ENABLE_LC_FLAG_130 : X_SFF
    port map (
      I => RESET_L_0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => DATA_ENABLE_N_54_I,
      O => DATA_ENABLE_LC_FLAG
    );
  DATA_ENABLE_OUT_SM_PROC_UN7_LC_COPY_NE_G_22 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_10(15),
      ADR1 => DATA_ENABLE_FWCOUNT(13),
      ADR2 => DATA_ENABLE_CELL_BUF_10(14),
      ADR3 => DATA_ENABLE_FWCOUNT(12),
      O => DATA_ENABLE_G_22
    );
  DATA_ENABLE_OUT_SM_PROC_UN7_LC_COPY_NE_G_24 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_10(11),
      ADR1 => DATA_ENABLE_FWCOUNT(9),
      ADR2 => DATA_ENABLE_CELL_BUF_10(10),
      ADR3 => DATA_ENABLE_FWCOUNT(8),
      O => DATA_ENABLE_G_24
    );
  DATA_ENABLE_OUT_SM_PROC_UN7_LC_COPY_NE_G_25 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_10(9),
      ADR1 => DATA_ENABLE_FWCOUNT(7),
      ADR2 => DATA_ENABLE_CELL_BUF_10(8),
      ADR3 => DATA_ENABLE_FWCOUNT(6),
      O => DATA_ENABLE_G_25
    );
  DATA_ENABLE_OUT_SM_PROC_UN7_LC_COPY_NE_G_26 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_10(7),
      ADR1 => DATA_ENABLE_FWCOUNT(5),
      ADR2 => DATA_ENABLE_CELL_BUF_10(6),
      ADR3 => DATA_ENABLE_FWCOUNT(4),
      O => DATA_ENABLE_G_26
    );
  DATA_ENABLE_OUT_SM_PROC_UN7_LC_COPY_NE_G_27 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_10(5),
      ADR1 => DATA_ENABLE_FWCOUNT(3),
      ADR2 => DATA_ENABLE_CELL_BUF_10(4),
      ADR3 => DATA_ENABLE_FWCOUNT(2),
      O => DATA_ENABLE_G_27_0
    );
  DATA_ENABLE_OUT_SM_PROC_UN7_LC_COPY_NE_G_28 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_10(3),
      ADR1 => DATA_ENABLE_FWCOUNT(1),
      ADR2 => DATA_ENABLE_CELL_BUF_10(2),
      ADR3 => DATA_ENABLE_FWCOUNT(0),
      O => DATA_ENABLE_G_28
    );
  DATA_ENABLE_OUT_SM_PROC_UN7_LC_COPY_NE_G_31 : X_LUT4
    generic map (
      INIT => X"BFFB"
    )
    port map (
      ADR0 => DATA_ENABLE_G_24,
      ADR1 => DATA_ENABLE_G_1808,
      ADR2 => DATA_ENABLE_CELL_BUF_10(12),
      ADR3 => DATA_ENABLE_FWCOUNT(10),
      O => DATA_ENABLE_G_31
    );
  DATA_ENABLE_OUT_SM_PROC_UN7_LC_COPY_NE_G_33 : X_LUT4
    generic map (
      INIT => X"FFFE"
    )
    port map (
      ADR0 => DATA_ENABLE_G_25,
      ADR1 => DATA_ENABLE_G_26,
      ADR2 => DATA_ENABLE_G_27_0,
      ADR3 => DATA_ENABLE_G_28,
      O => DATA_ENABLE_G_33
    );
  DATA_ENABLE_OUT_SM_PROC_UN20_STATE_IN_NE_131 : X_LUT4
    generic map (
      INIT => X"FFFE"
    )
    port map (
      ADR0 => DATA_ENABLE_G_73,
      ADR1 => DATA_ENABLE_G_62,
      ADR2 => DATA_ENABLE_G_63,
      ADR3 => DATA_ENABLE_G_64,
      O => DATA_ENABLE_OUT_SM_PROC_UN20_STATE_IN_NE
    );
  DATA_ENABLE_OUT_SM_PROC_UN20_STATE_IN_NE_G_62 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => DATA_ENABLE_DATA_IN(15),
      ADR1 => DATA_ENABLE_FWCOUNT(13),
      ADR2 => DATA_ENABLE_DATA_IN(14),
      ADR3 => DATA_ENABLE_FWCOUNT(12),
      O => DATA_ENABLE_G_62
    );
  DATA_ENABLE_OUT_SM_PROC_UN20_STATE_IN_NE_G_63 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => DATA_ENABLE_DATA_IN(13),
      ADR1 => DATA_ENABLE_FWCOUNT(11),
      ADR2 => DATA_ENABLE_DATA_IN(12),
      ADR3 => DATA_ENABLE_FWCOUNT(10),
      O => DATA_ENABLE_G_63
    );
  DATA_ENABLE_OUT_SM_PROC_UN20_STATE_IN_NE_G_64 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => DATA_ENABLE_DATA_IN(11),
      ADR1 => DATA_ENABLE_FWCOUNT(9),
      ADR2 => DATA_ENABLE_DATA_IN(10),
      ADR3 => DATA_ENABLE_FWCOUNT(8),
      O => DATA_ENABLE_G_64
    );
  DATA_ENABLE_OUT_SM_PROC_UN20_STATE_IN_NE_G_65 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => DATA_ENABLE_DATA_IN(9),
      ADR1 => DATA_ENABLE_FWCOUNT(7),
      ADR2 => DATA_ENABLE_DATA_IN(8),
      ADR3 => DATA_ENABLE_FWCOUNT(6),
      O => DATA_ENABLE_G_65
    );
  DATA_ENABLE_OUT_SM_PROC_UN20_STATE_IN_NE_G_66 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => DATA_ENABLE_DATA_IN(7),
      ADR1 => DATA_ENABLE_FWCOUNT(5),
      ADR2 => DATA_ENABLE_DATA_IN(6),
      ADR3 => DATA_ENABLE_FWCOUNT(4),
      O => DATA_ENABLE_G_66
    );
  DATA_ENABLE_OUT_SM_PROC_UN20_STATE_IN_NE_G_67 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => DATA_ENABLE_DATA_IN(5),
      ADR1 => DATA_ENABLE_FWCOUNT(3),
      ADR2 => DATA_ENABLE_DATA_IN(4),
      ADR3 => DATA_ENABLE_FWCOUNT(2),
      O => DATA_ENABLE_G_67
    );
  DATA_ENABLE_OUT_SM_PROC_UN20_STATE_IN_NE_G_68 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => DATA_ENABLE_DATA_IN(3),
      ADR1 => DATA_ENABLE_FWCOUNT(1),
      ADR2 => DATA_ENABLE_DATA_IN(2),
      ADR3 => DATA_ENABLE_FWCOUNT(0),
      O => DATA_ENABLE_G_68
    );
  DATA_ENABLE_OUT_SM_PROC_UN20_STATE_IN_NE_G_73 : X_LUT4
    generic map (
      INIT => X"FFFE"
    )
    port map (
      ADR0 => DATA_ENABLE_G_65,
      ADR1 => DATA_ENABLE_G_66,
      ADR2 => DATA_ENABLE_G_67,
      ADR3 => DATA_ENABLE_G_68,
      O => DATA_ENABLE_G_73
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_0_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_633,
      ADR1 => DATA_ENABLE_N_2366,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(0),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(0)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_2_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_697,
      ADR1 => DATA_ENABLE_N_2366,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(2),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(2)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_3_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_641,
      ADR1 => DATA_ENABLE_N_2366,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(3),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(3)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_4_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_645,
      ADR1 => DATA_ENABLE_N_2366,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(4),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(4)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_5_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_649,
      ADR1 => DATA_ENABLE_N_2366,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(5),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(5)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_6_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_653,
      ADR1 => DATA_ENABLE_N_2366,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(6),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(6)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_7_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_677,
      ADR1 => DATA_ENABLE_N_2366,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(7),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(7)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_8_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_657,
      ADR1 => DATA_ENABLE_N_2366,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(8),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(8)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_9_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_661,
      ADR1 => DATA_ENABLE_N_2366,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(9),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(9)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_10_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_665,
      ADR1 => DATA_ENABLE_N_2366,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(10),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(10)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_11_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_669,
      ADR1 => DATA_ENABLE_N_2366,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(11),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(11)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_12_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_701,
      ADR1 => DATA_ENABLE_N_2366,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(12),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(12)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_13_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_705,
      ADR1 => DATA_ENABLE_N_2366,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(13),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(13)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_14_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_637,
      ADR1 => DATA_ENABLE_N_2366,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(14),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(14)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_15_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_713,
      ADR1 => DATA_ENABLE_N_2366,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(15),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(15)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_16_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_717,
      ADR1 => DATA_ENABLE_N_2366_REP1,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(16),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(16)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_17_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_721,
      ADR1 => DATA_ENABLE_N_2366_REP1,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(17),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(17)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_18_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_725,
      ADR1 => DATA_ENABLE_N_2366_REP1,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(18),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(18)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_19_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_729,
      ADR1 => DATA_ENABLE_N_2366_REP1,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(19),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(19)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_20_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_733,
      ADR1 => DATA_ENABLE_N_2366_REP1,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(20),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(20)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_21_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_709,
      ADR1 => DATA_ENABLE_N_2366_REP1,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(21),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(21)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_22_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_681,
      ADR1 => DATA_ENABLE_N_2366_REP1,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(22),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(22)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_23_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_745,
      ADR1 => DATA_ENABLE_N_2366_REP1,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(23),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(23)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_24_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_737,
      ADR1 => DATA_ENABLE_N_2366_REP1,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(24),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(24)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_25_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_741,
      ADR1 => DATA_ENABLE_N_2366_REP1,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(25),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(25)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_26_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_629,
      ADR1 => DATA_ENABLE_N_2366_REP1,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(26),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(26)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_27_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_673,
      ADR1 => DATA_ENABLE_N_2366_REP1,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(27),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(27)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_28_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_625,
      ADR1 => DATA_ENABLE_N_2366_REP1,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(28),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(28)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_29_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_685,
      ADR1 => DATA_ENABLE_N_2366_REP1,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(29),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(29)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_30_Q : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_689,
      ADR1 => DATA_ENABLE_N_2366_REP1,
      ADR2 => DATA_ENABLE_N_2269,
      ADR3 => DATA_ENABLE_DATA_IN(30),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(30)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_0_G_630 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(0),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(0),
      O => DATA_ENABLE_G_630
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_0_G_631 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_630,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(0),
      O => DATA_ENABLE_G_631
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_0_G_633 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_0_Q,
      ADR1 => DATA_ENABLE_G_631,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(0),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_0_G_633_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_0_G_633_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_0_G_633_O,
      O => DATA_ENABLE_G_633
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_1_G_4_0 : X_LUT4
    generic map (
      INIT => X"FFFE"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2043,
      ADR1 => DATA_ENABLE_G_4_0_AND2_3,
      ADR2 => DATA_ENABLE_G_4_0_AND2,
      ADR3 => DATA_ENABLE_G_30,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(1)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_1_G_4_0_G_29 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(1),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(1),
      O => DATA_ENABLE_G_29
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_1_G_4_0_G_30 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_29,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(1),
      O => DATA_ENABLE_G_30
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_1_G_4_0_AND2 : X_LUT4
    generic map (
      INIT => X"AAA8"
    )
    port map (
      ADR0 => DATA_ENABLE_DELAY_WORD0(1),
      ADR1 => DATA_ENABLE_STATE_OUT_6_Q,
      ADR2 => DATA_ENABLE_STATE_OUT_4_Q,
      ADR3 => DATA_ENABLE_STATE_OUT_3_Q,
      O => DATA_ENABLE_G_4_0_AND2
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_1_G_4_0_AND2_3 : X_LUT3
    generic map (
      INIT => X"40"
    )
    port map (
      ADR0 => DATA_ENABLE_N_1949_I,
      ADR1 => G_5,
      ADR2 => DATA_ENABLE_G_27,
      O => DATA_ENABLE_G_4_0_AND2_3
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_1_G_4_0_AND2_3_G_27 : X_LUT4
    generic map (
      INIT => X"0004"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_DATA_IN(1),
      ADR2 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR3 => DATA_ENABLE_STATE_OUT_0_Q,
      O => DATA_ENABLE_G_27
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_2_G_694 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(2),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(2),
      O => DATA_ENABLE_G_694
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_2_G_695 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_694,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(2),
      O => DATA_ENABLE_G_695
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_2_G_697 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_2_Q,
      ADR1 => DATA_ENABLE_G_695,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(2),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_2_G_697_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_2_G_697_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_2_G_697_O,
      O => DATA_ENABLE_G_697
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_3_G_638 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(3),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(3),
      O => DATA_ENABLE_G_638
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_3_G_639 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_638,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(3),
      O => DATA_ENABLE_G_639
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_3_G_641 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_3_Q,
      ADR1 => DATA_ENABLE_G_639,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(3),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_3_G_641_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_3_G_641_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_3_G_641_O,
      O => DATA_ENABLE_G_641
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_4_G_642 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(4),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(4),
      O => DATA_ENABLE_G_642
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_4_G_643 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_642,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(4),
      O => DATA_ENABLE_G_643
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_4_G_645 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_4_Q,
      ADR1 => DATA_ENABLE_G_643,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(4),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_4_G_645_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_4_G_645_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_4_G_645_O,
      O => DATA_ENABLE_G_645
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_5_G_646 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(5),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(5),
      O => DATA_ENABLE_G_646
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_5_G_647 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_646,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(5),
      O => DATA_ENABLE_G_647
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_5_G_649 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_5_Q,
      ADR1 => DATA_ENABLE_G_647,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(5),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_5_G_649_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_5_G_649_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_5_G_649_O,
      O => DATA_ENABLE_G_649
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_6_G_650 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(6),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(6),
      O => DATA_ENABLE_G_650
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_6_G_651 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_650,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(6),
      O => DATA_ENABLE_G_651
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_6_G_653 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_6_Q,
      ADR1 => DATA_ENABLE_G_651,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(6),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_6_G_653_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_6_G_653_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_6_G_653_O,
      O => DATA_ENABLE_G_653
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_7_G_674 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(7),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(7),
      O => DATA_ENABLE_G_674
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_7_G_675 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_674,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(7),
      O => DATA_ENABLE_G_675
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_7_G_677 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2077,
      ADR1 => DATA_ENABLE_G_675,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(7),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_7_G_677_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_7_G_677_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_7_G_677_O,
      O => DATA_ENABLE_G_677
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_8_G_654 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(8),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(8),
      O => DATA_ENABLE_G_654
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_8_G_655 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_654,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(8),
      O => DATA_ENABLE_G_655
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_8_G_657 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_8_Q,
      ADR1 => DATA_ENABLE_G_655,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(8),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_8_G_657_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_8_G_657_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_8_G_657_O,
      O => DATA_ENABLE_G_657
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_9_G_658 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(9),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(9),
      O => DATA_ENABLE_G_658
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_9_G_659 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_658,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(9),
      O => DATA_ENABLE_G_659
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_9_G_661 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_9_Q,
      ADR1 => DATA_ENABLE_G_659,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(9),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_9_G_661_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_9_G_661_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_9_G_661_O,
      O => DATA_ENABLE_G_661
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_10_G_662 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(10),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(10),
      O => DATA_ENABLE_G_662
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_10_G_663 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_662,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(10),
      O => DATA_ENABLE_G_663
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_10_G_665 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_10_Q,
      ADR1 => DATA_ENABLE_G_663,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(10),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_10_G_665_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_10_G_665_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_10_G_665_O,
      O => DATA_ENABLE_G_665
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_11_G_666 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(11),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(11),
      O => DATA_ENABLE_G_666
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_11_G_667 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_666,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(11),
      O => DATA_ENABLE_G_667
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_11_G_669 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_11_Q,
      ADR1 => DATA_ENABLE_G_667,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(11),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_11_G_669_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_11_G_669_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_11_G_669_O,
      O => DATA_ENABLE_G_669
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_12_G_698 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(12),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(12),
      O => DATA_ENABLE_G_698
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_12_G_699 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_698,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(12),
      O => DATA_ENABLE_G_699
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_12_G_701 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_12_Q,
      ADR1 => DATA_ENABLE_G_699,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(12),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_12_G_701_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_12_G_701_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_12_G_701_O,
      O => DATA_ENABLE_G_701
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_13_G_702 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(13),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(13),
      O => DATA_ENABLE_G_702
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_13_G_703 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_702,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(13),
      O => DATA_ENABLE_G_703
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_13_G_705 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_13_Q,
      ADR1 => DATA_ENABLE_G_703,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(13),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_13_G_705_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_13_G_705_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_13_G_705_O,
      O => DATA_ENABLE_G_705
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_14_G_634 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(14),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(14),
      O => DATA_ENABLE_G_634
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_14_G_635 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_634,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(14),
      O => DATA_ENABLE_G_635
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_14_G_637 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_14_Q,
      ADR1 => DATA_ENABLE_G_635,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(14),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_14_G_637_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_14_G_637_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_14_G_637_O,
      O => DATA_ENABLE_G_637
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_15_G_710 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(15),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(15),
      O => DATA_ENABLE_G_710
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_15_G_711 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_710,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(15),
      O => DATA_ENABLE_G_711
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_15_G_713 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_15_Q,
      ADR1 => DATA_ENABLE_G_711,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(15),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_15_G_713_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_15_G_713_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_15_G_713_O,
      O => DATA_ENABLE_G_713
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_16_G_714 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(16),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(16),
      O => DATA_ENABLE_G_714
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_16_G_715 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_714,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(16),
      O => DATA_ENABLE_G_715
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_16_G_717 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_16_Q,
      ADR1 => DATA_ENABLE_G_715,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(16),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_16_G_717_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_16_G_717_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_16_G_717_O,
      O => DATA_ENABLE_G_717
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_17_G_718 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(17),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(17),
      O => DATA_ENABLE_G_718
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_17_G_719 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_718,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(17),
      O => DATA_ENABLE_G_719
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_17_G_721 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_17_Q,
      ADR1 => DATA_ENABLE_G_719,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(17),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_17_G_721_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_17_G_721_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_17_G_721_O,
      O => DATA_ENABLE_G_721
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_18_G_722 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(18),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(18),
      O => DATA_ENABLE_G_722
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_18_G_723 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_722,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(18),
      O => DATA_ENABLE_G_723
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_18_G_725 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_18_Q,
      ADR1 => DATA_ENABLE_G_723,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(18),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_18_G_725_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_18_G_725_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_18_G_725_O,
      O => DATA_ENABLE_G_725
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_19_G_726 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(19),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(19),
      O => DATA_ENABLE_G_726
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_19_G_727 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_726,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(19),
      O => DATA_ENABLE_G_727
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_19_G_729 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_19_Q,
      ADR1 => DATA_ENABLE_G_727,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(19),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_19_G_729_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_19_G_729_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_19_G_729_O,
      O => DATA_ENABLE_G_729
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_20_G_730 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(20),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(20),
      O => DATA_ENABLE_G_730
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_20_G_731 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_730,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(20),
      O => DATA_ENABLE_G_731
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_20_G_733 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_20_Q,
      ADR1 => DATA_ENABLE_G_731,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(20),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_20_G_733_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_20_G_733_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_20_G_733_O,
      O => DATA_ENABLE_G_733
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_21_G_706 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(21),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(21),
      O => DATA_ENABLE_G_706
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_21_G_707 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_706,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(21),
      O => DATA_ENABLE_G_707
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_21_G_709 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_21_Q,
      ADR1 => DATA_ENABLE_G_707,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(21),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_21_G_709_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_21_G_709_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_21_G_709_O,
      O => DATA_ENABLE_G_709
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_22_G_678 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(22),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(22),
      O => DATA_ENABLE_G_678
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_22_G_679 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_678,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(22),
      O => DATA_ENABLE_G_679
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_22_G_681 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_22_Q,
      ADR1 => DATA_ENABLE_G_679,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(22),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_22_G_681_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_22_G_681_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_22_G_681_O,
      O => DATA_ENABLE_G_681
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_23_G_742 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(23),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(23),
      O => DATA_ENABLE_G_742
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_23_G_743 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_742,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(23),
      O => DATA_ENABLE_G_743
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_23_G_745 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_23_Q,
      ADR1 => DATA_ENABLE_G_743,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(23),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_23_G_745_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_23_G_745_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_23_G_745_O,
      O => DATA_ENABLE_G_745
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_24_G_734 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(24),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(24),
      O => DATA_ENABLE_G_734
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_24_G_735 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_734,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(24),
      O => DATA_ENABLE_G_735
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_24_G_737 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_24_Q,
      ADR1 => DATA_ENABLE_G_735,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(24),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_24_G_737_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_24_G_737_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_24_G_737_O,
      O => DATA_ENABLE_G_737
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_25_G_738 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(25),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(25),
      O => DATA_ENABLE_G_738
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_25_G_739 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_738,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(25),
      O => DATA_ENABLE_G_739
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_25_G_741 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_25_Q,
      ADR1 => DATA_ENABLE_G_739,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(25),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_25_G_741_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_25_G_741_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_25_G_741_O,
      O => DATA_ENABLE_G_741
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_26_G_626 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(26),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(26),
      O => DATA_ENABLE_G_626
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_26_G_627 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_626,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(26),
      O => DATA_ENABLE_G_627
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_26_G_629 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_26_Q,
      ADR1 => DATA_ENABLE_G_627,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(26),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_26_G_629_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_26_G_629_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_26_G_629_O,
      O => DATA_ENABLE_G_629
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_27_G_670 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(27),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(27),
      O => DATA_ENABLE_G_670
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_27_G_671 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_670,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(27),
      O => DATA_ENABLE_G_671
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_27_G_673 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_27_Q,
      ADR1 => DATA_ENABLE_G_671,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(27),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_27_G_673_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_27_G_673_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_27_G_673_O,
      O => DATA_ENABLE_G_673
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_28_G_622 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(28),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(28),
      O => DATA_ENABLE_G_622
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_28_G_623 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_622,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(28),
      O => DATA_ENABLE_G_623
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_28_G_625 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_28_Q,
      ADR1 => DATA_ENABLE_G_623,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(28),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_28_G_625_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_28_G_625_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_28_G_625_O,
      O => DATA_ENABLE_G_625
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_29_G_682 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(29),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(29),
      O => DATA_ENABLE_G_682
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_29_G_683 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_682,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(29),
      O => DATA_ENABLE_G_683
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_29_G_685 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_29_Q,
      ADR1 => DATA_ENABLE_G_683,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(29),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_29_G_685_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_29_G_685_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_29_G_685_O,
      O => DATA_ENABLE_G_685
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_30_G_686 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(30),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(30),
      O => DATA_ENABLE_G_686
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_30_G_687 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_686,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => DATA_ENABLE_DELAY_WORD1(30),
      O => DATA_ENABLE_G_687
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_30_G_689 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_30_Q,
      ADR1 => DATA_ENABLE_G_687,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(30),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_30_G_689_O
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_30_G_689_LUT4_L_BUF : X_BUF
    port map (
      I => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_30_G_689_O,
      O => DATA_ENABLE_G_689
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_31_G_690 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_Q,
      ADR1 => DATA_ENABLE_CELL_BUF_10(31),
      ADR2 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR3 => DATA_ENABLE_CELL_BUF_11(31),
      O => DATA_ENABLE_G_690
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_31_G_4_0 : X_LUT4
    generic map (
      INIT => X"FFF2"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3(31),
      ADR1 => G_5,
      ADR2 => DATA_ENABLE_G_4_0_AND6_1,
      ADR3 => DATA_ENABLE_G_14,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1(31)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_31_G_4_0_G_14 : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3(31),
      ADR1 => DATA_ENABLE_G_690,
      ADR2 => DATA_ENABLE_N_1949_I,
      ADR3 => DATA_ENABLE_DELAY_WORD0(31),
      O => DATA_ENABLE_G_14
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_31_G_4_0_AND6_1 : X_LUT4
    generic map (
      INIT => X"2000"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2269,
      ADR1 => DATA_ENABLE_N_1949_I,
      ADR2 => G_5,
      ADR3 => DATA_ENABLE_DATA_IN(31),
      O => DATA_ENABLE_G_4_0_AND6_1
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_31_Q : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => DATA_ENABLE_DELAY_WORD1(31),
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3(31)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_2_Q_132 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => G_5,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_2_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_2_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_2_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_3_Q_133 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => G_5,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_3_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_3_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_3_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_6_Q_134 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => G_5,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_6_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_6_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_6_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_7_Q : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_7_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_7_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_N_2077
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_9_Q_135 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => G_5,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_9_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_9_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_9_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_10_Q_136 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => G_5,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_10_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_10_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_10_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_12_Q_137 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => G_5,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_12_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_12_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_12_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_13_Q_138 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => G_5,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_13_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_13_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_13_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_14_Q_139 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => G_5,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_14_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_14_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_14_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_16_Q_140 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => G_5,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_16_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_16_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_16_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_17_Q_141 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => G_5,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_17_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_17_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_17_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_18_Q_142 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP1,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_18_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_18_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_18_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_19_Q_143 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP1,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_19_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_19_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_19_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_21_Q_144 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP1,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_21_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_21_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_21_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_22_Q_145 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP1,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_22_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_22_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_22_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_23_Q_146 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP1,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_23_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_23_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_23_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_24_Q_147 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP1,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_24_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_24_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_24_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_25_Q_148 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_25_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_25_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_25_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_26_Q_149 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_26_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_26_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_26_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_27_Q_150 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_27_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_27_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_27_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_28_Q_151 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_28_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_28_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_28_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_29_Q_152 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_29_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_29_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_29_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_30_Q_153 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_30_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_30_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_30_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_7_Q_154 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP1,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_7_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_7_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_7_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_25_Q_155 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP1,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_25_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_25_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_25_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_26_Q_156 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP1,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_26_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_26_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_26_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_27_Q_157 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP1,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_27_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_27_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_27_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_28_Q_158 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP1,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_28_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_28_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_28_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_29_Q_159 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP1,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_29_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_29_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_29_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_30_Q_160 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP1,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_30_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_30_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_AM_30_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_7_Q_161 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP1,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_7_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_7_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_7_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_25_Q_162 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP1,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_25_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_25_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_25_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_26_Q_163 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP2,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_26_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_26_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_26_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_27_Q_164 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP2,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_27_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_27_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_27_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_28_Q_165 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP2,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_28_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_28_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_28_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_29_Q_166 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP2,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_29_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_29_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_29_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_30_Q_167 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP2,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_30_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_30_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_2_BM_30_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_0_Q_168 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP2,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_0_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_0_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_0_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_4_Q_169 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP2,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_4_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_4_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_4_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_5_Q_170 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP2,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_5_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_5_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_5_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_8_Q_171 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP2,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_8_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_8_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_8_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_11_Q_172 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP2,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_11_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_11_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_11_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_15_Q_173 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP2,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_15_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_15_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_15_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_20_Q_174 : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP2,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_20_Q,
      ADR3 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_20_Q,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_3_20_Q
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_4_1_Q : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_4_AM(1),
      IB => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_4_BM(1),
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_N_2043
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_4_AM_1_Q : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP2,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_N_837,
      ADR3 => DATA_ENABLE_N_677,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_4_AM(1)
    );
  DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_4_BM_1_Q : X_LUT4
    generic map (
      INIT => X"5140"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2016_REP2,
      ADR1 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR2 => DATA_ENABLE_N_869,
      ADR3 => DATA_ENABLE_N_773,
      O => DATA_ENABLE_OUTPUT_PROC_D_OUT_MOD_1_0_AND3_4_BM(1)
    );
  DATA_ENABLE_OUTPUT_PROC_EOF_OUT_MOD_1_0_0_0 : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_EOF_OUT_MOD_1_0_0_0_OR3,
      ADR1 => DATA_ENABLE_OUT_SM_PROC_UN20_STATE_IN_NE,
      ADR2 => DATA_ENABLE_G_1740,
      ADR3 => DATA_ENABLE_LC_FLAG,
      O => DATA_ENABLE_OUTPUT_PROC_EOF_OUT_MOD_1
    );
  DATA_ENABLE_OUTPUT_PROC_EOF_OUT_MOD_1_0_0_0_OR3_175 : X_LUT4
    generic map (
      INIT => X"8F88"
    )
    port map (
      ADR0 => G_1752,
      ADR1 => DATA_ENABLE_STATE_OUT_2_Q,
      ADR2 => G_1774,
      ADR3 => DATA_ENABLE_STATE_OUT_0_5_Q,
      O => DATA_ENABLE_OUTPUT_PROC_EOF_OUT_MOD_1_0_0_0_OR3
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_0_Q_176 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(0),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(0),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_0_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_1_Q : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(1),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(1),
      SEL => DATA_ENABLE_CWCOUNT_OUT_0(0),
      O => DATA_ENABLE_N_677
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_2_Q_177 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(2),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(2),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_2_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_3_Q_178 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(3),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(3),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_3_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_4_Q_179 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(4),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(4),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_4_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_5_Q_180 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(5),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(5),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_5_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_6_Q_181 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(6),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(6),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_6_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_7_Q_182 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(7),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(7),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_7_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_8_Q_183 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(8),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(8),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_8_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_9_Q_184 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(9),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(9),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_9_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_10_Q_185 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(10),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(10),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_10_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_11_Q_186 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(11),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(11),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_11_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_12_Q_187 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(12),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(12),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_12_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_13_Q_188 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(13),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(13),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_13_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_14_Q_189 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(14),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(14),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_14_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_15_Q_190 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(15),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(15),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_15_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_16_Q_191 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(16),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(16),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_16_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_17_Q_192 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(17),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(17),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_17_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_18_Q_193 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(18),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(18),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_18_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_19_Q_194 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(19),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(19),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_19_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_20_Q_195 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(20),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(20),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_20_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_21_Q_196 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(21),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(21),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_21_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_22_Q_197 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(22),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(22),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_22_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_23_Q_198 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(23),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(23),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_23_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_24_Q_199 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(24),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(24),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_24_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_25_Q_200 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(25),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(25),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_25_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_26_Q_201 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(26),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(26),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_26_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_27_Q_202 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(27),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(27),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_27_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_28_Q_203 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(28),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(28),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_28_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_29_Q_204 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(29),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(29),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_29_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_30_Q_205 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(30),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(30),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_30_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_31_Q_206 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(31),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(31),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_31_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_0_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(0),
      ADR2 => DATA_ENABLE_CELL_BUF_0(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(0)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_1_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_8(1),
      ADR2 => DATA_ENABLE_CELL_BUF_0(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(1)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_2_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(2),
      ADR2 => DATA_ENABLE_CELL_BUF_0(2),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(2)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_3_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(3),
      ADR2 => DATA_ENABLE_CELL_BUF_0(3),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(3)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_4_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(4),
      ADR2 => DATA_ENABLE_CELL_BUF_0(4),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(4)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_5_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(5),
      ADR2 => DATA_ENABLE_CELL_BUF_0(5),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(5)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_6_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(6),
      ADR2 => DATA_ENABLE_CELL_BUF_0(6),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(6)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_7_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(7),
      ADR2 => DATA_ENABLE_CELL_BUF_0(7),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(7)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_8_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(8),
      ADR2 => DATA_ENABLE_CELL_BUF_0(8),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(8)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_9_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(9),
      ADR2 => DATA_ENABLE_CELL_BUF_0(9),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(9)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_10_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(10),
      ADR2 => DATA_ENABLE_CELL_BUF_0(10),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(10)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_11_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(11),
      ADR2 => DATA_ENABLE_CELL_BUF_0(11),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(11)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_12_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(12),
      ADR2 => DATA_ENABLE_CELL_BUF_0(12),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(12)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_13_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(13),
      ADR2 => DATA_ENABLE_CELL_BUF_0(13),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(13)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_14_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(14),
      ADR2 => DATA_ENABLE_CELL_BUF_0(14),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(14)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_15_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(15),
      ADR2 => DATA_ENABLE_CELL_BUF_0(15),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(15)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_16_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(16),
      ADR2 => DATA_ENABLE_CELL_BUF_0(16),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(16)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_17_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(17),
      ADR2 => DATA_ENABLE_CELL_BUF_0(17),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(17)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_18_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(18),
      ADR2 => DATA_ENABLE_CELL_BUF_0(18),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(18)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_19_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(19),
      ADR2 => DATA_ENABLE_CELL_BUF_0(19),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(19)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_20_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(20),
      ADR2 => DATA_ENABLE_CELL_BUF_0(20),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(20)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_21_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(21),
      ADR2 => DATA_ENABLE_CELL_BUF_0(21),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(21)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_22_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(22),
      ADR2 => DATA_ENABLE_CELL_BUF_0(22),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(22)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_23_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(23),
      ADR2 => DATA_ENABLE_CELL_BUF_0(23),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(23)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_24_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(24),
      ADR2 => DATA_ENABLE_CELL_BUF_0(24),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(24)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_25_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(25),
      ADR2 => DATA_ENABLE_CELL_BUF_0(25),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(25)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_26_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(26),
      ADR2 => DATA_ENABLE_CELL_BUF_0(26),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(26)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_27_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(27),
      ADR2 => DATA_ENABLE_CELL_BUF_0(27),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(27)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_28_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(28),
      ADR2 => DATA_ENABLE_CELL_BUF_0(28),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(28)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_29_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(29),
      ADR2 => DATA_ENABLE_CELL_BUF_0(29),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(29)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_30_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(30),
      ADR2 => DATA_ENABLE_CELL_BUF_0(30),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(30)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM_31_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_8(31),
      ADR2 => DATA_ENABLE_CELL_BUF_0(31),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_AM(31)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_0_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(0),
      ADR2 => DATA_ENABLE_CELL_BUF_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(0)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_1_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_9(1),
      ADR2 => DATA_ENABLE_CELL_BUF_1(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(1)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_2_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(2),
      ADR2 => DATA_ENABLE_CELL_BUF_1(2),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(2)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_3_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(3),
      ADR2 => DATA_ENABLE_CELL_BUF_1(3),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(3)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_4_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(4),
      ADR2 => DATA_ENABLE_CELL_BUF_1(4),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(4)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_5_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(5),
      ADR2 => DATA_ENABLE_CELL_BUF_1(5),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(5)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_6_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(6),
      ADR2 => DATA_ENABLE_CELL_BUF_1(6),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(6)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_7_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(7),
      ADR2 => DATA_ENABLE_CELL_BUF_1(7),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(7)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_8_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(8),
      ADR2 => DATA_ENABLE_CELL_BUF_1(8),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(8)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_9_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(9),
      ADR2 => DATA_ENABLE_CELL_BUF_1(9),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(9)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_10_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(10),
      ADR2 => DATA_ENABLE_CELL_BUF_1(10),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(10)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_11_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(11),
      ADR2 => DATA_ENABLE_CELL_BUF_1(11),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(11)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_12_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(12),
      ADR2 => DATA_ENABLE_CELL_BUF_1(12),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(12)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_13_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(13),
      ADR2 => DATA_ENABLE_CELL_BUF_1(13),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(13)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_14_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(14),
      ADR2 => DATA_ENABLE_CELL_BUF_1(14),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(14)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_15_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(15),
      ADR2 => DATA_ENABLE_CELL_BUF_1(15),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(15)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_16_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(16),
      ADR2 => DATA_ENABLE_CELL_BUF_1(16),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(16)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_17_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(17),
      ADR2 => DATA_ENABLE_CELL_BUF_1(17),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(17)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_18_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(18),
      ADR2 => DATA_ENABLE_CELL_BUF_1(18),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(18)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_19_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(19),
      ADR2 => DATA_ENABLE_CELL_BUF_1(19),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(19)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_20_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(20),
      ADR2 => DATA_ENABLE_CELL_BUF_1(20),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(20)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_21_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(21),
      ADR2 => DATA_ENABLE_CELL_BUF_1(21),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(21)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_22_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(22),
      ADR2 => DATA_ENABLE_CELL_BUF_1(22),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(22)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_23_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(23),
      ADR2 => DATA_ENABLE_CELL_BUF_1(23),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(23)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_24_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(24),
      ADR2 => DATA_ENABLE_CELL_BUF_1(24),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(24)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_25_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(25),
      ADR2 => DATA_ENABLE_CELL_BUF_1(25),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(25)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_26_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(26),
      ADR2 => DATA_ENABLE_CELL_BUF_1(26),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(26)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_27_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(27),
      ADR2 => DATA_ENABLE_CELL_BUF_1(27),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(27)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_28_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(28),
      ADR2 => DATA_ENABLE_CELL_BUF_1(28),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(28)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_29_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(29),
      ADR2 => DATA_ENABLE_CELL_BUF_1(29),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(29)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_30_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(30),
      ADR2 => DATA_ENABLE_CELL_BUF_1(30),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(30)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM_31_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_9(31),
      ADR2 => DATA_ENABLE_CELL_BUF_1(31),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_BM(31)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_0_Q_207 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(0),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(0),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_0_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_1_Q : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(1),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(1),
      SEL => DATA_ENABLE_CWCOUNT_OUT_0(0),
      O => DATA_ENABLE_N_773
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_2_Q_208 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(2),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(2),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_2_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_3_Q_209 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(3),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(3),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_3_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_4_Q_210 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(4),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(4),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_4_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_5_Q_211 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(5),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(5),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_5_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_6_Q_212 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(6),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(6),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_6_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_7_Q_213 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(7),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(7),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_7_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_8_Q_214 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(8),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(8),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_8_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_9_Q_215 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(9),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(9),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_9_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_10_Q_216 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(10),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(10),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_10_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_11_Q_217 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(11),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(11),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_11_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_12_Q_218 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(12),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(12),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_12_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_13_Q_219 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(13),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(13),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_13_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_14_Q_220 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(14),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(14),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_14_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_15_Q_221 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(15),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(15),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_15_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_16_Q_222 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(16),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(16),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_16_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_17_Q_223 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(17),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(17),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_17_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_18_Q_224 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(18),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(18),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_18_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_19_Q_225 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(19),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(19),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_19_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_20_Q_226 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(20),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(20),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_20_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_21_Q_227 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(21),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(21),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_21_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_22_Q_228 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(22),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(22),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_22_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_23_Q_229 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(23),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(23),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_23_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_24_Q_230 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(24),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(24),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_24_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_25_Q_231 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(25),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(25),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_25_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_26_Q_232 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(26),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(26),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_26_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_27_Q_233 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(27),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(27),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_27_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_28_Q_234 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(28),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(28),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_28_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_29_Q_235 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(29),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(29),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_29_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_30_Q_236 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(30),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(30),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_30_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_31_Q_237 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(31),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(31),
      SEL => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_31_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_0_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_10(0),
      ADR2 => DATA_ENABLE_CELL_BUF_2(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(0)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_1_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(1),
      ADR2 => DATA_ENABLE_CELL_BUF_2(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(1)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_2_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(2),
      ADR2 => DATA_ENABLE_CELL_BUF_2(2),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(2)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_3_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(3),
      ADR2 => DATA_ENABLE_CELL_BUF_2(3),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(3)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_4_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(4),
      ADR2 => DATA_ENABLE_CELL_BUF_2(4),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(4)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_5_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(5),
      ADR2 => DATA_ENABLE_CELL_BUF_2(5),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(5)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_6_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(6),
      ADR2 => DATA_ENABLE_CELL_BUF_2(6),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(6)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_7_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(7),
      ADR2 => DATA_ENABLE_CELL_BUF_2(7),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(7)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_8_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(8),
      ADR2 => DATA_ENABLE_CELL_BUF_2(8),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(8)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_9_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(9),
      ADR2 => DATA_ENABLE_CELL_BUF_2(9),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(9)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_10_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(10),
      ADR2 => DATA_ENABLE_CELL_BUF_2(10),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(10)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_11_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(11),
      ADR2 => DATA_ENABLE_CELL_BUF_2(11),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(11)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_12_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(12),
      ADR2 => DATA_ENABLE_CELL_BUF_2(12),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(12)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_13_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(13),
      ADR2 => DATA_ENABLE_CELL_BUF_2(13),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(13)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_14_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(14),
      ADR2 => DATA_ENABLE_CELL_BUF_2(14),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(14)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_15_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(15),
      ADR2 => DATA_ENABLE_CELL_BUF_2(15),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(15)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_16_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(16),
      ADR2 => DATA_ENABLE_CELL_BUF_2(16),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(16)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_17_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(17),
      ADR2 => DATA_ENABLE_CELL_BUF_2(17),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(17)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_18_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(18),
      ADR2 => DATA_ENABLE_CELL_BUF_2(18),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(18)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_19_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(19),
      ADR2 => DATA_ENABLE_CELL_BUF_2(19),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(19)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_20_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(20),
      ADR2 => DATA_ENABLE_CELL_BUF_2(20),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(20)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_21_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(21),
      ADR2 => DATA_ENABLE_CELL_BUF_2(21),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(21)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_22_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(22),
      ADR2 => DATA_ENABLE_CELL_BUF_2(22),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(22)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_23_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(23),
      ADR2 => DATA_ENABLE_CELL_BUF_2(23),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(23)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_24_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(24),
      ADR2 => DATA_ENABLE_CELL_BUF_2(24),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(24)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_25_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(25),
      ADR2 => DATA_ENABLE_CELL_BUF_2(25),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(25)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_26_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(26),
      ADR2 => DATA_ENABLE_CELL_BUF_2(26),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(26)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_27_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(27),
      ADR2 => DATA_ENABLE_CELL_BUF_2(27),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(27)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_28_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(28),
      ADR2 => DATA_ENABLE_CELL_BUF_2(28),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(28)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_29_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(29),
      ADR2 => DATA_ENABLE_CELL_BUF_2(29),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(29)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_30_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(30),
      ADR2 => DATA_ENABLE_CELL_BUF_2(30),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(30)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM_31_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_10(31),
      ADR2 => DATA_ENABLE_CELL_BUF_2(31),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_AM(31)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_0_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_11(0),
      ADR2 => DATA_ENABLE_CELL_BUF_3(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(0)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_1_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(1),
      ADR2 => DATA_ENABLE_CELL_BUF_3(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(1)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_2_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_1,
      ADR1 => DATA_ENABLE_CELL_BUF_11(2),
      ADR2 => DATA_ENABLE_CELL_BUF_3(2),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(2)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_3_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(3),
      ADR2 => DATA_ENABLE_CELL_BUF_3(3),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(3)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_4_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(4),
      ADR2 => DATA_ENABLE_CELL_BUF_3(4),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(4)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_5_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(5),
      ADR2 => DATA_ENABLE_CELL_BUF_3(5),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(5)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_6_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(6),
      ADR2 => DATA_ENABLE_CELL_BUF_3(6),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(6)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_7_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(7),
      ADR2 => DATA_ENABLE_CELL_BUF_3(7),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(7)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_8_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(8),
      ADR2 => DATA_ENABLE_CELL_BUF_3(8),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(8)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_9_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(9),
      ADR2 => DATA_ENABLE_CELL_BUF_3(9),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(9)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_10_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(10),
      ADR2 => DATA_ENABLE_CELL_BUF_3(10),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(10)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_11_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(11),
      ADR2 => DATA_ENABLE_CELL_BUF_3(11),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(11)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_12_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(12),
      ADR2 => DATA_ENABLE_CELL_BUF_3(12),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(12)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_13_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(13),
      ADR2 => DATA_ENABLE_CELL_BUF_3(13),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(13)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_14_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(14),
      ADR2 => DATA_ENABLE_CELL_BUF_3(14),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(14)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_15_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(15),
      ADR2 => DATA_ENABLE_CELL_BUF_3(15),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(15)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_16_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(16),
      ADR2 => DATA_ENABLE_CELL_BUF_3(16),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(16)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_17_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(17),
      ADR2 => DATA_ENABLE_CELL_BUF_3(17),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(17)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_18_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(18),
      ADR2 => DATA_ENABLE_CELL_BUF_3(18),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(18)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_19_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(19),
      ADR2 => DATA_ENABLE_CELL_BUF_3(19),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(19)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_20_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(20),
      ADR2 => DATA_ENABLE_CELL_BUF_3(20),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(20)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_21_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(21),
      ADR2 => DATA_ENABLE_CELL_BUF_3(21),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(21)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_22_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(22),
      ADR2 => DATA_ENABLE_CELL_BUF_3(22),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(22)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_23_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(23),
      ADR2 => DATA_ENABLE_CELL_BUF_3(23),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(23)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_24_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(24),
      ADR2 => DATA_ENABLE_CELL_BUF_3(24),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(24)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_25_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(25),
      ADR2 => DATA_ENABLE_CELL_BUF_3(25),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(25)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_26_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(26),
      ADR2 => DATA_ENABLE_CELL_BUF_3(26),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(26)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_27_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(27),
      ADR2 => DATA_ENABLE_CELL_BUF_3(27),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(27)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_28_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(28),
      ADR2 => DATA_ENABLE_CELL_BUF_3(28),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(28)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_29_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(29),
      ADR2 => DATA_ENABLE_CELL_BUF_3(29),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(29)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_30_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(30),
      ADR2 => DATA_ENABLE_CELL_BUF_3(30),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(30)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM_31_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_N_983_1_0,
      ADR1 => DATA_ENABLE_CELL_BUF_11(31),
      ADR2 => DATA_ENABLE_CELL_BUF_3(31),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_BM(31)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_0_Q_238 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_0_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_0_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_0_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_2_Q_239 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_2_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_2_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_2_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_3_Q_240 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_3_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_3_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_3_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_4_Q_241 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_4_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_4_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_4_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_5_Q_242 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_5_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_5_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_5_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_6_Q_243 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_6_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_6_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_6_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_8_Q_244 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_8_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_8_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_8_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_9_Q_245 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_9_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_9_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_9_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_10_Q_246 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_10_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_10_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_10_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_11_Q_247 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_11_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_11_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_11_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_12_Q_248 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_12_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_12_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_12_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_13_Q_249 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_13_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_13_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_13_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_14_Q_250 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_14_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_14_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_14_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_15_Q_251 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_15_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_15_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_15_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_16_Q_252 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_16_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_16_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_16_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_17_Q_253 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_17_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_17_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_17_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_18_Q_254 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_18_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_18_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_18_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_19_Q_255 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_19_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_19_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_19_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_20_Q_256 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_20_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_20_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_20_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_21_Q_257 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_21_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_21_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_21_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_22_Q_258 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_22_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_22_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_22_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_23_Q_259 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_23_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_23_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_23_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_24_Q_260 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_24_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_24_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_7_24_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_1_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_4(1),
      ADR1 => DATA_ENABLE_CELL_BUF_5(1),
      ADR2 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      O => DATA_ENABLE_N_837
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_7_Q_261 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_4(7),
      ADR1 => DATA_ENABLE_CELL_BUF_5(7),
      ADR2 => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_7_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_25_Q_262 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_4(25),
      ADR1 => DATA_ENABLE_CELL_BUF_5(25),
      ADR2 => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_25_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_26_Q_263 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_4(26),
      ADR1 => DATA_ENABLE_CELL_BUF_5(26),
      ADR2 => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_26_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_27_Q_264 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_4(27),
      ADR1 => DATA_ENABLE_CELL_BUF_5(27),
      ADR2 => DATA_ENABLE_CWCOUNT_OUT_1(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_27_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_28_Q_265 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_4(28),
      ADR1 => DATA_ENABLE_CELL_BUF_5(28),
      ADR2 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_28_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_29_Q_266 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_4(29),
      ADR1 => DATA_ENABLE_CELL_BUF_5(29),
      ADR2 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_29_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_30_Q_267 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_4(30),
      ADR1 => DATA_ENABLE_CELL_BUF_5(30),
      ADR2 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_30_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_31_Q_268 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_4(31),
      ADR1 => DATA_ENABLE_CELL_BUF_5(31),
      ADR2 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_31_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_1_Q : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_6(1),
      ADR1 => DATA_ENABLE_CELL_BUF_7(1),
      ADR2 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      O => DATA_ENABLE_N_869
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_7_Q_269 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_6(7),
      ADR1 => DATA_ENABLE_CELL_BUF_7(7),
      ADR2 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_7_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_25_Q_270 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_6(25),
      ADR1 => DATA_ENABLE_CELL_BUF_7(25),
      ADR2 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_25_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_26_Q_271 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_6(26),
      ADR1 => DATA_ENABLE_CELL_BUF_7(26),
      ADR2 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_26_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_27_Q_272 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_6(27),
      ADR1 => DATA_ENABLE_CELL_BUF_7(27),
      ADR2 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_27_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_28_Q_273 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_6(28),
      ADR1 => DATA_ENABLE_CELL_BUF_7(28),
      ADR2 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_28_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_29_Q_274 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_6(29),
      ADR1 => DATA_ENABLE_CELL_BUF_7(29),
      ADR2 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_29_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_30_Q_275 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_6(30),
      ADR1 => DATA_ENABLE_CELL_BUF_7(30),
      ADR2 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_30_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_31_Q_276 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => DATA_ENABLE_CELL_BUF_6(31),
      ADR1 => DATA_ENABLE_CELL_BUF_7(31),
      ADR2 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_31_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_0_Q_277 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_0_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_0_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_0_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_2_Q_278 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_2_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_2_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_2_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_3_Q_279 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_3_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_3_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_3_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_4_Q_280 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_4_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_4_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_4_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_5_Q_281 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_5_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_5_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_5_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_6_Q_282 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_6_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_6_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_6_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_8_Q_283 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_8_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_8_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_8_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_9_Q_284 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_9_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_9_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_9_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_10_Q_285 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_10_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_10_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_10_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_11_Q_286 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_11_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_11_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_11_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_12_Q_287 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_12_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_12_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_12_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_13_Q_288 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_13_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_13_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_13_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_14_Q_289 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_14_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_14_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_14_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_15_Q_290 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_15_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_15_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_15_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_16_Q_291 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_16_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_16_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_16_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_17_Q_292 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_17_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_17_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_17_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_18_Q_293 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_18_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_18_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_18_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_19_Q_294 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_19_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_19_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_19_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_20_Q_295 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_20_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_20_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_20_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_21_Q_296 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_21_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_21_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_21_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_22_Q_297 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_22_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_22_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_22_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_23_Q_298 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_23_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_23_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_23_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_24_Q_299 : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_24_Q,
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_24_Q,
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_24_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_0_Q_300 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(0),
      ADR2 => DATA_ENABLE_CELL_BUF_4(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_0_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_2_Q_301 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(2),
      ADR2 => DATA_ENABLE_CELL_BUF_4(2),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_2_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_3_Q_302 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(3),
      ADR2 => DATA_ENABLE_CELL_BUF_4(3),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_3_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_4_Q_303 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(4),
      ADR2 => DATA_ENABLE_CELL_BUF_4(4),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_4_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_5_Q_304 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(5),
      ADR2 => DATA_ENABLE_CELL_BUF_4(5),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_5_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_6_Q_305 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(6),
      ADR2 => DATA_ENABLE_CELL_BUF_4(6),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_6_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_8_Q_306 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(8),
      ADR2 => DATA_ENABLE_CELL_BUF_4(8),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_8_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_9_Q_307 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(9),
      ADR2 => DATA_ENABLE_CELL_BUF_4(9),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_9_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_10_Q_308 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(10),
      ADR2 => DATA_ENABLE_CELL_BUF_4(10),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_10_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_11_Q_309 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(11),
      ADR2 => DATA_ENABLE_CELL_BUF_4(11),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_11_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_12_Q_310 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(12),
      ADR2 => DATA_ENABLE_CELL_BUF_4(12),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_12_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_13_Q_311 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(13),
      ADR2 => DATA_ENABLE_CELL_BUF_4(13),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_13_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_14_Q_312 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(14),
      ADR2 => DATA_ENABLE_CELL_BUF_4(14),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_14_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_15_Q_313 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(15),
      ADR2 => DATA_ENABLE_CELL_BUF_4(15),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_15_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_16_Q_314 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(16),
      ADR2 => DATA_ENABLE_CELL_BUF_4(16),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_16_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_17_Q_315 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(17),
      ADR2 => DATA_ENABLE_CELL_BUF_4(17),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_17_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_18_Q_316 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(18),
      ADR2 => DATA_ENABLE_CELL_BUF_4(18),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_18_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_19_Q_317 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(19),
      ADR2 => DATA_ENABLE_CELL_BUF_4(19),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_19_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_20_Q_318 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(20),
      ADR2 => DATA_ENABLE_CELL_BUF_4(20),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_20_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_21_Q_319 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(21),
      ADR2 => DATA_ENABLE_CELL_BUF_4(21),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_21_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_22_Q_320 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(22),
      ADR2 => DATA_ENABLE_CELL_BUF_4(22),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_22_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_23_Q_321 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(23),
      ADR2 => DATA_ENABLE_CELL_BUF_4(23),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_23_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_24_Q_322 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_5(24),
      ADR2 => DATA_ENABLE_CELL_BUF_4(24),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_AM_24_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_0_Q_323 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(0),
      ADR2 => DATA_ENABLE_CELL_BUF_6(0),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_0_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_2_Q_324 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(2),
      ADR2 => DATA_ENABLE_CELL_BUF_6(2),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_2_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_3_Q_325 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(3),
      ADR2 => DATA_ENABLE_CELL_BUF_6(3),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_3_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_4_Q_326 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(4),
      ADR2 => DATA_ENABLE_CELL_BUF_6(4),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_4_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_5_Q_327 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(5),
      ADR2 => DATA_ENABLE_CELL_BUF_6(5),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_5_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_6_Q_328 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(6),
      ADR2 => DATA_ENABLE_CELL_BUF_6(6),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_6_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_8_Q_329 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(8),
      ADR2 => DATA_ENABLE_CELL_BUF_6(8),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_8_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_9_Q_330 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(9),
      ADR2 => DATA_ENABLE_CELL_BUF_6(9),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_9_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_10_Q_331 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(10),
      ADR2 => DATA_ENABLE_CELL_BUF_6(10),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_10_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_11_Q_332 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(11),
      ADR2 => DATA_ENABLE_CELL_BUF_6(11),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_11_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_12_Q_333 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(12),
      ADR2 => DATA_ENABLE_CELL_BUF_6(12),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_12_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_13_Q_334 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(13),
      ADR2 => DATA_ENABLE_CELL_BUF_6(13),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_13_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_14_Q_335 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(14),
      ADR2 => DATA_ENABLE_CELL_BUF_6(14),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_14_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_15_Q_336 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(15),
      ADR2 => DATA_ENABLE_CELL_BUF_6(15),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_15_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_16_Q_337 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(16),
      ADR2 => DATA_ENABLE_CELL_BUF_6(16),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_16_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_17_Q_338 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(17),
      ADR2 => DATA_ENABLE_CELL_BUF_6(17),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_17_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_18_Q_339 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(18),
      ADR2 => DATA_ENABLE_CELL_BUF_6(18),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_18_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_19_Q_340 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(19),
      ADR2 => DATA_ENABLE_CELL_BUF_6(19),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_19_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_20_Q_341 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(20),
      ADR2 => DATA_ENABLE_CELL_BUF_6(20),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_20_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_21_Q_342 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(21),
      ADR2 => DATA_ENABLE_CELL_BUF_6(21),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_21_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_22_Q_343 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(22),
      ADR2 => DATA_ENABLE_CELL_BUF_6(22),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_22_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_23_Q_344 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(23),
      ADR2 => DATA_ENABLE_CELL_BUF_6(23),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_23_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_24_Q_345 : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_0(0),
      ADR1 => DATA_ENABLE_CELL_BUF_7(24),
      ADR2 => DATA_ENABLE_CELL_BUF_6(24),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_10_BM_24_Q
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_11_31_Q : X_MUX2
    port map (
      IA => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_11_AM(31),
      IB => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_11_BM(31),
      SEL => DATA_ENABLE_CWCOUNT_OUT(1),
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3(31)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_11_AM_31_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR1 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_8_31_Q,
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_3_31_Q,
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_11_AM(31)
    );
  DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_11_BM_31_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR1 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_9_31_Q,
      ADR2 => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_6_31_Q,
      O => DATA_ENABLE_OUTPUT_PROC_TMP_DATA_3_11_BM(31)
    );
  DATA_ENABLE_SOC_IN_346 : X_SFF
    port map (
      I => SOC2,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => DATA_ENABLE_SOC_IN
    );
  DATA_ENABLE_STATE_IN_0_Q_347 : X_FF
    port map (
      I => DATA_ENABLE_STATE_IN_1(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_STATE_IN_0_Q
    );
  DATA_ENABLE_STATE_IN_1_Q : X_SFF
    port map (
      I => DATA_ENABLE_STATE_IN_0_2_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => DATA_ENABLE_STATE_IN_0_1_Q
    );
  DATA_ENABLE_STATE_IN_2_Q : X_SFF
    port map (
      I => G_796,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => DATA_ENABLE_CWCOUNT_IN(2),
      O => DATA_ENABLE_STATE_IN_0_2_Q
    );
  DATA_ENABLE_STATE_IN_3_Q_348 : X_SFF
    port map (
      I => DATA_ENABLE_STATE_IN_0_4_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => DATA_ENABLE_STATE_IN_3_Q
    );
  DATA_ENABLE_STATE_IN_4_Q : X_SFF
    port map (
      I => G_800,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => DATA_ENABLE_CWCOUNT_IN(2),
      O => DATA_ENABLE_STATE_IN_0_4_Q
    );
  DATA_ENABLE_STATE_IN_5_Q_349 : X_SFF
    port map (
      I => N_999_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => DATA_ENABLE_STATE_IN_1_0_IV_I_0_AND3_0(5),
      O => DATA_ENABLE_STATE_IN_5_Q
    );
  DATA_ENABLE_STATE_IN_6_Q_350 : X_SFF
    port map (
      I => DATA_ENABLE_N_998_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => DATA_ENABLE_G_1664,
      O => DATA_ENABLE_STATE_IN_6_Q
    );
  DATA_ENABLE_STATE_IN_7_Q_351 : X_SFF
    port map (
      I => G_797,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => DATA_ENABLE_STATE_IN_7_Q
    );
  DATA_ENABLE_STATE_IN_1_0_IV_0_0_0_Q : X_LUT4
    generic map (
      INIT => X"C0E0"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_IN_0_Q,
      ADR1 => DATA_ENABLE_STATE_IN_0_1_Q,
      ADR2 => RESET_L_1,
      ADR3 => DATA_ENABLE_SOC_IN,
      O => DATA_ENABLE_STATE_IN_1(0)
    );
  DATA_ENABLE_STATE_IN_1_0_IV_I_0_AND3_0_5_Q : X_LUT4
    generic map (
      INIT => X"0200"
    )
    port map (
      ADR0 => DATA_ENABLE_G_1666,
      ADR1 => DATA_ENABLE_STATE_IN_6_Q,
      ADR2 => DATA_ENABLE_CWCOUNT_IN(1),
      ADR3 => DATA_ENABLE_CWCOUNT_IN(0),
      O => DATA_ENABLE_STATE_IN_1_0_IV_I_0_AND3_0(5)
    );
  DATA_ENABLE_STATE_OUT_0_Q_352 : X_SFF
    port map (
      I => DATA_ENABLE_STATE_OUT_1_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => DATA_ENABLE_STATE_OUT_0_Q
    );
  DATA_ENABLE_STATE_OUT_1_Q_353 : X_FF
    port map (
      I => DATA_ENABLE_STATE_OUT_1_1_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_STATE_OUT_1_Q
    );
  DATA_ENABLE_STATE_OUT_2_Q_354 : X_FF
    port map (
      I => DATA_ENABLE_STATE_OUT_1_2_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_STATE_OUT_2_Q
    );
  DATA_ENABLE_STATE_OUT_3_Q_355 : X_FF
    port map (
      I => DATA_ENABLE_STATE_OUT_1_3_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_STATE_OUT_3_Q
    );
  DATA_ENABLE_STATE_OUT_4_Q_356 : X_FF
    port map (
      I => DATA_ENABLE_STATE_OUT_1_4_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_STATE_OUT_4_Q
    );
  DATA_ENABLE_STATE_OUT_5_Q : X_SFF
    port map (
      I => N_1005_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => DATA_ENABLE_STATE_OUT_1_I_AND3_0(5),
      O => DATA_ENABLE_STATE_OUT_0_5_Q
    );
  DATA_ENABLE_STATE_OUT_6_Q_357 : X_FF
    port map (
      I => DATA_ENABLE_STATE_OUT_1_6_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_STATE_OUT_6_Q
    );
  DATA_ENABLE_STATE_OUT_7_Q : X_FF
    port map (
      I => DATA_ENABLE_STATE_OUT_1_7_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA_ENABLE_STATE_OUT_0_7_Q
    );
  DATA_ENABLE_STATE_OUT_8_Q : X_SFF
    port map (
      I => DATA_ENABLE_STATE_OUT_1_0_0_AND3(8),
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => DATA_ENABLE_STATE_OUT_0_8_Q
    );
  DATA_ENABLE_STATE_OUT_1_0_0_1_Q : X_LUT4
    generic map (
      INIT => X"8C88"
    )
    port map (
      ADR0 => DATA_ENABLE_OUTPUT_PROC_EOF_OUT_MOD_1_0_0_0_OR3,
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_OUT_SM_PROC_UN20_STATE_IN_NE,
      ADR3 => DATA_ENABLE_G_1740,
      O => DATA_ENABLE_STATE_OUT_1_1_Q
    );
  DATA_ENABLE_STATE_OUT_1_0_0_2_Q : X_LUT4
    generic map (
      INIT => X"EAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_2,
      ADR1 => DATA_ENABLE_OUT_SM_PROC_UN20_STATE_IN_NE,
      ADR2 => RESET_L_1,
      ADR3 => DATA_ENABLE_G_1740,
      O => DATA_ENABLE_STATE_OUT_1_2_Q
    );
  DATA_ENABLE_STATE_OUT_1_0_0_3_Q : X_LUT4
    generic map (
      INIT => X"AEAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_1,
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_STATE_IN_0_4_Q,
      ADR3 => DATA_ENABLE_STATE_OUT_3_Q,
      O => DATA_ENABLE_STATE_OUT_1_3_Q
    );
  DATA_ENABLE_STATE_OUT_1_0_0_4_Q : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2362,
      ADR1 => DATA_ENABLE_N_2354,
      ADR2 => DATA_ENABLE_G_592,
      ADR3 => G_1774,
      O => DATA_ENABLE_STATE_OUT_1_4_Q
    );
  DATA_ENABLE_STATE_OUT_1_0_0_6_Q : X_LUT4
    generic map (
      INIT => X"AAEA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_444,
      ADR1 => DATA_ENABLE_G_1772,
      ADR2 => DATA_ENABLE_G_1744,
      ADR3 => DATA_ENABLE_LC_FLAG,
      O => DATA_ENABLE_STATE_OUT_1_6_Q
    );
  DATA_ENABLE_STATE_OUT_1_0_0_7_Q : X_LUT4
    generic map (
      INIT => X"EAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_G_443,
      ADR1 => DATA_ENABLE_G_1772,
      ADR2 => DATA_ENABLE_G_1744,
      ADR3 => DATA_ENABLE_LC_FLAG,
      O => DATA_ENABLE_STATE_OUT_1_7_Q
    );
  DATA_ENABLE_STATE_OUT_1_0_0_2_G_2 : X_LUT4
    generic map (
      INIT => X"AEAA"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2228,
      ADR1 => DATA_ENABLE_G_1744,
      ADR2 => DATA_ENABLE_LC_FLAG,
      ADR3 => DATA_ENABLE_STATE_OUT_4_Q,
      O => DATA_ENABLE_G_2
    );
  DATA_ENABLE_STATE_OUT_1_0_0_3_G_1 : X_LUT4
    generic map (
      INIT => X"EAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2231,
      ADR1 => DATA_ENABLE_G_1744,
      ADR2 => DATA_ENABLE_LC_FLAG,
      ADR3 => DATA_ENABLE_STATE_OUT_4_Q,
      O => DATA_ENABLE_G_1
    );
  DATA_ENABLE_STATE_OUT_1_0_0_6_G_444 : X_LUT4
    generic map (
      INIT => X"EAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_N_2239,
      ADR1 => DATA_ENABLE_STATE_IN_0_4_Q,
      ADR2 => DATA_ENABLE_STATE_OUT_0_7_Q,
      ADR3 => RESET_L_1,
      O => DATA_ENABLE_G_444
    );
  DATA_ENABLE_STATE_OUT_1_0_0_7_G_443 : X_LUT4
    generic map (
      INIT => X"BAAA"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_OUT_1_0_0_AND3_1(7),
      ADR1 => DATA_ENABLE_STATE_IN_0_4_Q,
      ADR2 => DATA_ENABLE_STATE_OUT_0_7_Q,
      ADR3 => RESET_L_1,
      O => DATA_ENABLE_G_443
    );
  DATA_ENABLE_STATE_OUT_1_0_0_AND3_8_Q : X_LUT4
    generic map (
      INIT => X"4544"
    )
    port map (
      ADR0 => DATA_ENABLE_BUF_FLAG,
      ADR1 => DATA_ENABLE_STATE_OUT_0_Q,
      ADR2 => DATA_ENABLE_SOC_IN,
      ADR3 => DATA_ENABLE_STATE_OUT_0_8_Q,
      O => DATA_ENABLE_STATE_OUT_1_0_0_AND3(8)
    );
  DATA_ENABLE_STATE_OUT_1_0_0_AND3_1_2_Q : X_LUT4
    generic map (
      INIT => X"0800"
    )
    port map (
      ADR0 => DATA_ENABLE_SOC_IN,
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_DATA_IN(1),
      ADR3 => DATA_ENABLE_N_2354,
      O => DATA_ENABLE_N_2228
    );
  DATA_ENABLE_STATE_OUT_1_0_0_AND3_1_3_Q : X_LUT4
    generic map (
      INIT => X"8000"
    )
    port map (
      ADR0 => DATA_ENABLE_SOC_IN,
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_N_2354,
      ADR3 => DATA_ENABLE_DATA_IN(1),
      O => DATA_ENABLE_N_2231
    );
  DATA_ENABLE_STATE_OUT_1_0_0_AND3_1_6_Q : X_LUT4
    generic map (
      INIT => X"0800"
    )
    port map (
      ADR0 => DATA_ENABLE_SOC_IN,
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_DATA_IN(1),
      ADR3 => DATA_ENABLE_STATE_OUT_0_8_Q,
      O => DATA_ENABLE_N_2239
    );
  DATA_ENABLE_STATE_OUT_1_0_0_AND3_1_7_Q : X_LUT4
    generic map (
      INIT => X"8000"
    )
    port map (
      ADR0 => DATA_ENABLE_SOC_IN,
      ADR1 => RESET_L_1,
      ADR2 => DATA_ENABLE_DATA_IN(1),
      ADR3 => DATA_ENABLE_STATE_OUT_0_8_Q,
      O => DATA_ENABLE_STATE_OUT_1_0_0_AND3_1(7)
    );
  DATA_ENABLE_STATE_OUT_1_0_0_AND3_4_G_592 : X_LUT4
    generic map (
      INIT => X"0800"
    )
    port map (
      ADR0 => DATA_ENABLE_UN3_CWCOUNT_OUT_5_C1,
      ADR1 => DATA_ENABLE_G_1754,
      ADR2 => DATA_ENABLE_CWCOUNT_OUT(2),
      ADR3 => RESET_L_1,
      O => DATA_ENABLE_G_592
    );
  DATA_ENABLE_STATE_OUT_1_I_AND3_0_5_Q : X_LUT2
    generic map (
      INIT => X"4"
    )
    port map (
      ADR0 => DATA_ENABLE_CWCOUNT_OUT_PROC_UN5_STATE_OUT,
      ADR1 => G_1777,
      O => DATA_ENABLE_STATE_OUT_1_I_AND3_0(5)
    );
  DATA_ENABLE_STATE_OUT_FAST_6_Q : X_FF
    port map (
      I => DATA_ENABLE_STATE_OUT_1_6_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => STATE_OUT_FAST(6)
    );
  DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3_358 : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => DATA_ENABLE_G_1671,
      ADR1 => DATA_ENABLE_CWCOUNT_IN(2),
      ADR2 => DATA_ENABLE_N_971_1,
      O => DATA_ENABLE_UN1_STATE_IN_2_0_AND2_0_AND3
    );
  DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3_359 : X_LUT4
    generic map (
      INIT => X"0002"
    )
    port map (
      ADR0 => DATA_ENABLE_G_1667,
      ADR1 => DATA_ENABLE_CWCOUNT_IN(1),
      ADR2 => DATA_ENABLE_CWCOUNT_IN(2),
      ADR3 => DATA_ENABLE_N_971_1,
      O => DATA_ENABLE_UN1_STATE_IN_3_0_AND2_0_AND3
    );
  DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3_360 : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => DATA_ENABLE_G_1667,
      ADR1 => DATA_ENABLE_G_1743,
      ADR2 => DATA_ENABLE_CWCOUNT_IN(2),
      O => DATA_ENABLE_UN1_STATE_IN_4_0_AND2_0_AND3
    );
  DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3_361 : X_LUT4
    generic map (
      INIT => X"0020"
    )
    port map (
      ADR0 => DATA_ENABLE_G_1667,
      ADR1 => DATA_ENABLE_CWCOUNT_IN(1),
      ADR2 => DATA_ENABLE_CWCOUNT_IN(2),
      ADR3 => DATA_ENABLE_N_971_1,
      O => DATA_ENABLE_UN1_STATE_IN_5_0_AND2_0_AND3
    );
  DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3_362 : X_LUT3
    generic map (
      INIT => X"80"
    )
    port map (
      ADR0 => DATA_ENABLE_G_1667,
      ADR1 => DATA_ENABLE_G_1743,
      ADR2 => DATA_ENABLE_CWCOUNT_IN(2),
      O => DATA_ENABLE_UN1_STATE_IN_6_0_AND2_0_AND3
    );
  DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3_363 : X_LUT3
    generic map (
      INIT => X"04"
    )
    port map (
      ADR0 => G_1828,
      ADR1 => DATA_ENABLE_G_1743,
      ADR2 => DATA_ENABLE_CWCOUNT_IN(2),
      O => DATA_ENABLE_UN1_STATE_IN_7_0_AND2_0_AND3
    );
  DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3_364 : X_LUT3
    generic map (
      INIT => X"40"
    )
    port map (
      ADR0 => G_1828,
      ADR1 => DATA_ENABLE_G_1743,
      ADR2 => DATA_ENABLE_CWCOUNT_IN(2),
      O => DATA_ENABLE_UN1_STATE_IN_8_0_AND2_0_AND3
    );
  DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3_365 : X_LUT3
    generic map (
      INIT => X"08"
    )
    port map (
      ADR0 => DATA_ENABLE_G_1666,
      ADR1 => DATA_ENABLE_G_1667,
      ADR2 => DATA_ENABLE_CWCOUNT_IN(1),
      O => DATA_ENABLE_UN1_STATE_IN_9_0_AND2_0_AND3
    );
  DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3_366 : X_LUT3
    generic map (
      INIT => X"02"
    )
    port map (
      ADR0 => DATA_ENABLE_G_1671,
      ADR1 => DATA_ENABLE_CWCOUNT_IN(2),
      ADR2 => DATA_ENABLE_N_971_1,
      O => DATA_ENABLE_UN1_STATE_IN_10_0_AND2_0_AND3
    );
  DATA_ENABLE_UN1_STATE_IN_11_0_0_367 : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => DATA_ENABLE_STATE_IN_0_2_Q,
      ADR1 => DATA_ENABLE_SOC_IN,
      ADR2 => DATA_ENABLE_STATE_IN_7_Q,
      O => DATA_ENABLE_UN1_STATE_IN_11_0_0
    );
  DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3_368 : X_LUT4
    generic map (
      INIT => X"0800"
    )
    port map (
      ADR0 => DATA_ENABLE_G_1666,
      ADR1 => DATA_ENABLE_G_1822,
      ADR2 => DATA_ENABLE_CWCOUNT_IN(0),
      ADR3 => DATA_ENABLE_CWCOUNT_IN(1),
      O => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_10_I_0_AND2_0_AND3
    );
  DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0_369 : X_LUT4
    generic map (
      INIT => X"8F88"
    )
    port map (
      ADR0 => DATA_ENABLE_UN2_CWCOUNT_IN_1_C2,
      ADR1 => DATA_ENABLE_G_1666,
      ADR2 => DATA_ENABLE_STATE_IN_5_Q,
      ADR3 => DATA_ENABLE_STATE_IN_3_Q,
      O => DATA_ENABLE_UN1_UN1_UN4_CELL_BUF_11_I_0_0
    );
  SEGMENT_D_OUT_MOD_0_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_0_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(0)
    );
  SEGMENT_D_OUT_MOD_1_Q : X_SFF
    port map (
      I => SEGMENT_N_910_I,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => SEGMENT_STATE_0_5_Q,
      SRST => GND,
      O => DATA8(1)
    );
  SEGMENT_D_OUT_MOD_2_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_2_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(2)
    );
  SEGMENT_D_OUT_MOD_3_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_3_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(3)
    );
  SEGMENT_D_OUT_MOD_4_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_4_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(4)
    );
  SEGMENT_D_OUT_MOD_5_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_5_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(5)
    );
  SEGMENT_D_OUT_MOD_6_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_6_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(6)
    );
  SEGMENT_D_OUT_MOD_7_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_7_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(7)
    );
  SEGMENT_D_OUT_MOD_8_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_8_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(8)
    );
  SEGMENT_D_OUT_MOD_9_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_9_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(9)
    );
  SEGMENT_D_OUT_MOD_10_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_10_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(10)
    );
  SEGMENT_D_OUT_MOD_11_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_11_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(11)
    );
  SEGMENT_D_OUT_MOD_12_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_12_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(12)
    );
  SEGMENT_D_OUT_MOD_13_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_13_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(13)
    );
  SEGMENT_D_OUT_MOD_14_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_14_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(14)
    );
  SEGMENT_D_OUT_MOD_15_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_15_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(15)
    );
  SEGMENT_D_OUT_MOD_16_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_16_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(16)
    );
  SEGMENT_D_OUT_MOD_17_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_17_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(17)
    );
  SEGMENT_D_OUT_MOD_18_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_18_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(18)
    );
  SEGMENT_D_OUT_MOD_19_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_19_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(19)
    );
  SEGMENT_D_OUT_MOD_20_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_20_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(20)
    );
  SEGMENT_D_OUT_MOD_21_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_21_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(21)
    );
  SEGMENT_D_OUT_MOD_22_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_22_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(22)
    );
  SEGMENT_D_OUT_MOD_23_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_23_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(23)
    );
  SEGMENT_D_OUT_MOD_24_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_24_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(24)
    );
  SEGMENT_D_OUT_MOD_25_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_25_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(25)
    );
  SEGMENT_D_OUT_MOD_26_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_26_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(26)
    );
  SEGMENT_D_OUT_MOD_27_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_27_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(27)
    );
  SEGMENT_D_OUT_MOD_28_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_28_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(28)
    );
  SEGMENT_D_OUT_MOD_29_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_29_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(29)
    );
  SEGMENT_D_OUT_MOD_30_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_30_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(30)
    );
  SEGMENT_D_OUT_MOD_31_Q : X_FF
    port map (
      I => SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_31_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => DATA8(31)
    );
  SEGMENT_GND_370 : X_ZERO
    port map (
      O => SEGMENT_GND
    );
  SEGMENT_G_74_G_600 : X_LUT2
    generic map (
      INIT => X"E"
    )
    port map (
      ADR0 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(10),
      ADR1 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(11),
      O => SEGMENT_G_600
    );
  SEGMENT_G_74_G_602 : X_LUT3
    generic map (
      INIT => X"FE"
    )
    port map (
      ADR0 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(13),
      ADR1 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(7),
      ADR2 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(6),
      O => SEGMENT_G_602
    );
  SEGMENT_G_78_1 : X_LUT2
    generic map (
      INIT => X"E"
    )
    port map (
      ADR0 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(1),
      ADR1 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(2),
      O => SEGMENT_N_138_1
    );
  SEGMENT_G_83 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => SEGMENT_CELL_COUNT(0),
      ADR1 => SEGMENT_CELL_COUNT(1),
      O => SEGMENT_UN16_CELL_COUNT_C2
    );
  SEGMENT_G_442_371 : X_LUT3
    generic map (
      INIT => X"01"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_COUNT(6),
      ADR1 => SEGMENT_DFIFO_COUNT(5),
      ADR2 => SEGMENT_DFIFO_COUNT(4),
      O => SEGMENT_G_442
    );
  SEGMENT_G_667_G_596 : X_LUT4
    generic map (
      INIT => X"2000"
    )
    port map (
      ADR0 => SEGMENT_STATE_0_6_Q,
      ADR1 => SEGMENT_STATE_0_4_Q,
      ADR2 => SEGMENT_STATE_3_Q,
      ADR3 => SEGMENT_CFIFO_AVAIL,
      O => SEGMENT_G_596
    );
  SEGMENT_G_668_372 : X_LUT4
    generic map (
      INIT => X"4000"
    )
    port map (
      ADR0 => SEGMENT_STATE_PROC_UN21_CFIFO_AVAIL_NE,
      ADR1 => SEGMENT_G_105,
      ADR2 => SEGMENT_G_790_0,
      ADR3 => SEGMENT_STATE_3_Q,
      O => SEGMENT_G_668
    );
  SEGMENT_G_668_G_105 : X_LUT3
    generic map (
      INIT => X"45"
    )
    port map (
      ADR0 => SEGMENT_STATE_0_4_Q,
      ADR1 => SEGMENT_CFIFO_AVAIL,
      ADR2 => SEGMENT_STATE_0_6_Q,
      O => SEGMENT_G_105
    );
  SEGMENT_G_670_G_13 : X_LUT3
    generic map (
      INIT => X"01"
    )
    port map (
      ADR0 => SEGMENT_STATE_11_Q,
      ADR1 => SEGMENT_STATE_3_Q,
      ADR2 => SEGMENT_STATE_0_6_Q,
      O => SEGMENT_G_13
    );
  SEGMENT_G_673_G_588 : X_LUT2
    generic map (
      INIT => X"2"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_AVAIL,
      ADR1 => SEGMENT_STATE_2_Q,
      O => SEGMENT_G_588
    );
  SEGMENT_G_681 : X_LUT4
    generic map (
      INIT => X"0008"
    )
    port map (
      ADR0 => SEGMENT_G_795_0,
      ADR1 => SEGMENT_STATE_11_Q,
      ADR2 => SEGMENT_STATE_2_Q,
      ADR3 => SEGMENT_STATE_0_4_Q,
      O => SEGMENT_G_681_0
    );
  SEGMENT_G_755 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => SEGMENT_STATE_2_Q,
      O => SEGMENT_G_755_0
    );
  SEGMENT_G_761 : X_LUT4
    generic map (
      INIT => X"0008"
    )
    port map (
      ADR0 => SEGMENT_G_442,
      ADR1 => SEGMENT_G_6,
      ADR2 => SEGMENT_DFIFO_COUNT(3),
      ADR3 => SEGMENT_DFIFO_COUNT(2),
      O => G_761_0
    );
  SEGMENT_G_761_G_6 : X_LUT2
    generic map (
      INIT => X"1"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_COUNT(0),
      ADR1 => SEGMENT_DFIFO_COUNT(1),
      O => SEGMENT_G_6
    );
  SEGMENT_G_767_Q_G_18_0_AND2 : X_LUT2
    generic map (
      INIT => X"2"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_AVAIL,
      ADR1 => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL,
      O => G_18_0_AND2
    );
  SEGMENT_G_767_Q_G_25_0_AND2 : X_LUT4
    generic map (
      INIT => X"0007"
    )
    port map (
      ADR0 => SEGMENT_N_138_1,
      ADR1 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(3),
      ADR2 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(9),
      ADR3 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(8),
      O => SEGMENT_G_767_Q_O2
    );
  SEGMENT_G_767_Q_G_27_0_AND2 : X_LUT4
    generic map (
      INIT => X"0001"
    )
    port map (
      ADR0 => SEGMENT_G_602,
      ADR1 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(12),
      ADR2 => SEGMENT_G_600,
      ADR3 => SEGMENT_G_27_0_AND2_SX,
      O => G_27_0_AND2
    );
  SEGMENT_G_767_Q_G_27_0_AND2_SX : X_LUT4
    generic map (
      INIT => X"FFF7"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_AVAIL,
      ADR1 => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL,
      ADR2 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(4),
      ADR3 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(5),
      O => SEGMENT_G_27_0_AND2_SX
    );
  SEGMENT_G_769 : X_LUT4
    generic map (
      INIT => X"0100"
    )
    port map (
      ADR0 => SEGMENT_STATE_0_4_Q,
      ADR1 => SEGMENT_G_786_0,
      ADR2 => SEGMENT_CELL_COUNT(1),
      ADR3 => SEGMENT_CELL_COUNT(2),
      O => SEGMENT_G_769_0
    );
  SEGMENT_G_770 : X_LUT4
    generic map (
      INIT => X"0444"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_AVAIL,
      ADR1 => SEGMENT_G_442,
      ADR2 => SEGMENT_DFIFO_COUNT(3),
      ADR3 => SEGMENT_DFIFO_COUNT(2),
      O => SEGMENT_G_844_Q_O0
    );
  SEGMENT_G_773 : X_LUT4
    generic map (
      INIT => X"4454"
    )
    port map (
      ADR0 => SEGMENT_STATE_3_Q,
      ADR1 => SEGMENT_G_769_0,
      ADR2 => SEGMENT_G_588,
      ADR3 => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL,
      O => SEGMENT_G_773_0
    );
  SEGMENT_G_779 : X_LUT2
    generic map (
      INIT => X"E"
    )
    port map (
      ADR0 => SEGMENT_STATE_0_8_Q,
      ADR1 => SEGMENT_STATE_0_5_Q,
      O => SEGMENT_G_779_0
    );
  SEGMENT_G_779_FAST_373 : X_LUT2
    generic map (
      INIT => X"E"
    )
    port map (
      ADR0 => SEGMENT_STATE_0_8_Q,
      ADR1 => SEGMENT_STATE_0_5_Q,
      O => SEGMENT_G_779_FAST
    );
  SEGMENT_G_786 : X_LUT2
    generic map (
      INIT => X"B"
    )
    port map (
      ADR0 => SEGMENT_CELL_COUNT(0),
      ADR1 => SEGMENT_N_146_1,
      O => SEGMENT_G_786_0
    );
  SEGMENT_G_788 : X_LUT3
    generic map (
      INIT => X"FE"
    )
    port map (
      ADR0 => SEGMENT_STATE_0_Q,
      ADR1 => SEGMENT_STATE_3_Q,
      ADR2 => SEGMENT_STATE_0_6_Q,
      O => SEGMENT_G_788_0
    );
  SEGMENT_G_790 : X_LUT4
    generic map (
      INIT => X"FFDF"
    )
    port map (
      ADR0 => SEGMENT_N_146_1,
      ADR1 => SEGMENT_CELL_COUNT(0),
      ADR2 => SEGMENT_CELL_COUNT(1),
      ADR3 => SEGMENT_CELL_COUNT(2),
      O => SEGMENT_G_790_0
    );
  SEGMENT_G_790_G_5 : X_LUT4
    generic map (
      INIT => X"FFBF"
    )
    port map (
      ADR0 => SEGMENT_CELL_COUNT(0),
      ADR1 => SEGMENT_N_146_1,
      ADR2 => SEGMENT_CELL_COUNT(1),
      ADR3 => SEGMENT_CELL_COUNT(2),
      O => SEGMENT_N_1272
    );
  SEGMENT_G_795 : X_LUT3
    generic map (
      INIT => X"D5"
    )
    port map (
      ADR0 => SEGMENT_STATE_0_6_Q,
      ADR1 => SEGMENT_STATE_3_Q,
      ADR2 => SEGMENT_CFIFO_AVAIL,
      O => SEGMENT_G_795_0
    );
  SEGMENT_G_804 : X_LUT4
    generic map (
      INIT => X"F2F7"
    )
    port map (
      ADR0 => SEGMENT_CELL_COUNT(1),
      ADR1 => SEGMENT_STATE_2_Q,
      ADR2 => SEGMENT_G_786_0,
      ADR3 => SEGMENT_CELL_COUNT(2),
      O => SEGMENT_G_804_0
    );
  SEGMENT_G_808 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_EOF_DELAY0,
      ADR1 => SEGMENT_HEAD(0),
      O => SEGMENT_G_808_0
    );
  SEGMENT_G_809 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_TAIL(0),
      ADR1 => SEGMENT_RDDONE_BUF,
      O => SEGMENT_G_809_0
    );
  SEGMENT_G_813 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(3),
      ADR1 => SEGMENT_OUT_COUNT(3),
      O => SEGMENT_G_813_0
    );
  SEGMENT_G_814 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(0),
      ADR1 => SEGMENT_OUT_COUNT(0),
      O => SEGMENT_G_814_0
    );
  SEGMENT_G_830 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(13),
      ADR1 => SEGMENT_OUT_COUNT(13),
      O => SEGMENT_G_830_0
    );
  SEGMENT_G_831 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(12),
      ADR1 => SEGMENT_OUT_COUNT(12),
      O => SEGMENT_G_831_0
    );
  SEGMENT_G_832 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(11),
      ADR1 => SEGMENT_OUT_COUNT(11),
      O => SEGMENT_G_832_0
    );
  SEGMENT_G_833 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(10),
      ADR1 => SEGMENT_OUT_COUNT(10),
      O => SEGMENT_G_833_0
    );
  SEGMENT_G_834 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(9),
      ADR1 => SEGMENT_OUT_COUNT(9),
      O => SEGMENT_G_834_0
    );
  SEGMENT_G_835 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(8),
      ADR1 => SEGMENT_OUT_COUNT(8),
      O => SEGMENT_G_835_0
    );
  SEGMENT_G_836 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(7),
      ADR1 => SEGMENT_OUT_COUNT(7),
      O => SEGMENT_G_836_0
    );
  SEGMENT_G_837 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(6),
      ADR1 => SEGMENT_OUT_COUNT(6),
      O => SEGMENT_G_837_0
    );
  SEGMENT_G_838 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(5),
      ADR1 => SEGMENT_OUT_COUNT(5),
      O => SEGMENT_G_838_0
    );
  SEGMENT_G_839 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(4),
      ADR1 => SEGMENT_OUT_COUNT(4),
      O => SEGMENT_G_839_0
    );
  SEGMENT_G_840 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(2),
      ADR1 => SEGMENT_OUT_COUNT(2),
      O => SEGMENT_G_840_0
    );
  SEGMENT_G_841 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(1),
      ADR1 => SEGMENT_OUT_COUNT(1),
      O => SEGMENT_G_841_0
    );
  SEGMENT_G_846_374 : X_LUT4
    generic map (
      INIT => X"5755"
    )
    port map (
      ADR0 => SEGMENT_STATE_0_6_Q,
      ADR1 => SEGMENT_G_786_0,
      ADR2 => SEGMENT_CELL_COUNT(1),
      ADR3 => SEGMENT_CELL_COUNT(2),
      O => SEGMENT_G_846
    );
  SEGMENT_G_847_375 : X_LUT2
    generic map (
      INIT => X"E"
    )
    port map (
      ADR0 => SEGMENT_STATE_0_10_Q,
      ADR1 => SEGMENT_STATE_9_Q,
      O => SEGMENT_G_847
    );
  SEGMENT_G_858_376 : X_LUT4
    generic map (
      INIT => X"FFFE"
    )
    port map (
      ADR0 => SEGMENT_STATE_0_1_Q,
      ADR1 => SEGMENT_STATE_0_Q,
      ADR2 => SEGMENT_STATE_3_Q,
      ADR3 => SEGMENT_STATE_0_6_Q,
      O => SEGMENT_G_858
    );
  SEGMENT_G_860_G_2 : X_LUT3
    generic map (
      INIT => X"A8"
    )
    port map (
      ADR0 => G_761_0,
      ADR1 => SEGMENT_G_773_0,
      ADR2 => SEGMENT_G_681_0,
      O => SEGMENT_N_5
    );
  SEGMENT_G_860_G_3 : X_LUT4
    generic map (
      INIT => X"FFFE"
    )
    port map (
      ADR0 => SEGMENT_N_5,
      ADR1 => SEGMENT_G_668,
      ADR2 => SEGMENT_N_6,
      ADR3 => SEGMENT_G_3_SX,
      O => SEGMENT_G_860_G_3_O
    );
  SEGMENT_G_860_G_3_LUT4_L_BUF : X_BUF
    port map (
      I => SEGMENT_G_860_G_3_O,
      O => SEGMENT_N_1269
    );
  SEGMENT_G_860_G_3_G_16 : X_LUT4
    generic map (
      INIT => X"AAAE"
    )
    port map (
      ADR0 => SEGMENT_N_1273,
      ADR1 => SEGMENT_G_13,
      ADR2 => SEGMENT_STATE_2_Q,
      ADR3 => SEGMENT_STATE_0_4_Q,
      O => SEGMENT_G_16
    );
  SEGMENT_G_860_G_3_G_17 : X_LUT4
    generic map (
      INIT => X"AAEA"
    )
    port map (
      ADR0 => SEGMENT_G_16,
      ADR1 => SEGMENT_G_769_0,
      ADR2 => SEGMENT_STATE_0_6_Q,
      ADR3 => SEGMENT_CFIFO_AVAIL,
      O => SEGMENT_G_17
    );
  SEGMENT_G_860_G_3_SX : X_LUT4
    generic map (
      INIT => X"FFF4"
    )
    port map (
      ADR0 => SEGMENT_STATE_11_Q,
      ADR1 => SEGMENT_G_773_0,
      ADR2 => SEGMENT_DFIFO_RE_I_0_OR2,
      ADR3 => SEGMENT_G_17,
      O => SEGMENT_G_3_SX
    );
  SEGMENT_G_860_G_619_G_1 : X_LUT3
    generic map (
      INIT => X"80"
    )
    port map (
      ADR0 => SEGMENT_G_804_0,
      ADR1 => SEGMENT_G_596,
      ADR2 => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL,
      O => SEGMENT_N_6
    );
  SEGMENT_N_451_I_G_5 : X_LUT4
    generic map (
      INIT => X"5551"
    )
    port map (
      ADR0 => SEGMENT_G_748,
      ADR1 => SEGMENT_N_1269,
      ADR2 => SEGMENT_STATE_0_1_Q,
      ADR3 => SEGMENT_STATE_0_7_Q,
      O => SEGMENT_N_451_I
    );
  SEGMENT_N_862_I_377 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(0),
      ADR1 => SEGMENT_OUT_COUNT(0),
      O => SEGMENT_N_862_I
    );
  SEGMENT_N_863_I_378 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(3),
      ADR1 => SEGMENT_OUT_COUNT(3),
      O => SEGMENT_N_863_I
    );
  SEGMENT_N_869_I_379 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(1),
      ADR1 => SEGMENT_OUT_COUNT(1),
      O => SEGMENT_N_869_I
    );
  SEGMENT_N_870_I_380 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(2),
      ADR1 => SEGMENT_OUT_COUNT(2),
      O => SEGMENT_N_870_I
    );
  SEGMENT_N_871_I_381 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(4),
      ADR1 => SEGMENT_OUT_COUNT(4),
      O => SEGMENT_N_871_I
    );
  SEGMENT_N_872_I_382 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(5),
      ADR1 => SEGMENT_OUT_COUNT(5),
      O => SEGMENT_N_872_I
    );
  SEGMENT_N_873_I_383 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(6),
      ADR1 => SEGMENT_OUT_COUNT(6),
      O => SEGMENT_N_873_I
    );
  SEGMENT_N_874_I_384 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(7),
      ADR1 => SEGMENT_OUT_COUNT(7),
      O => SEGMENT_N_874_I
    );
  SEGMENT_N_875_I_385 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(8),
      ADR1 => SEGMENT_OUT_COUNT(8),
      O => SEGMENT_N_875_I
    );
  SEGMENT_N_876_I_386 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(9),
      ADR1 => SEGMENT_OUT_COUNT(9),
      O => SEGMENT_N_876_I
    );
  SEGMENT_N_877_I_387 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(10),
      ADR1 => SEGMENT_OUT_COUNT(10),
      O => SEGMENT_N_877_I
    );
  SEGMENT_N_878_I_388 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(11),
      ADR1 => SEGMENT_OUT_COUNT(11),
      O => SEGMENT_N_878_I
    );
  SEGMENT_N_879_I_389 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(12),
      ADR1 => SEGMENT_OUT_COUNT(12),
      O => SEGMENT_N_879_I
    );
  SEGMENT_N_880_I_390 : X_LUT2
    generic map (
      INIT => X"9"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(13),
      ADR1 => SEGMENT_OUT_COUNT(13),
      O => SEGMENT_N_880_I
    );
  SEGMENT_N_894_I_391 : X_LUT3
    generic map (
      INIT => X"95"
    )
    port map (
      ADR0 => SEGMENT_TAIL(1),
      ADR1 => SEGMENT_RDDONE_BUF,
      ADR2 => SEGMENT_TAIL(0),
      O => SEGMENT_N_894_I
    );
  SEGMENT_N_910_I_392 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => SEGMENT_G_858,
      ADR1 => SEGMENT_DFIFO_DOUT(1),
      O => SEGMENT_N_910_I
    );
  SEGMENT_N_991_I_393 : X_LUT4
    generic map (
      INIT => X"FFFE"
    )
    port map (
      ADR0 => SEGMENT_DATAEN_IN,
      ADR1 => SEGMENT_SOF_IN,
      ADR2 => SEGMENT_EOF_DELAY0,
      ADR3 => SEGMENT_EOF_DELAY1,
      O => SEGMENT_N_991_I
    );
  SEGMENT_N_992_I_394 : X_LUT3
    generic map (
      INIT => X"EF"
    )
    port map (
      ADR0 => SEGMENT_DATAEN_IN,
      ADR1 => SEGMENT_SOF_IN,
      ADR2 => RESET_L_1,
      O => SEGMENT_N_992_I
    );
  SEGMENT_N_1018_I_395 : X_LUT4
    generic map (
      INIT => X"FFFB"
    )
    port map (
      ADR0 => SEGMENT_STATE_0_10_Q,
      ADR1 => RESET_L_1,
      ADR2 => SEGMENT_STATE_3_Q,
      ADR3 => SEGMENT_STATE_0_6_Q,
      O => SEGMENT_N_1018_I
    );
  SEGMENT_SOC_OUT_MOD : X_SFF
    port map (
      I => SEGMENT_STATE_0_5_Q,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => SEGMENT_STATE_0_8_Q,
      SRST => GND,
      O => SOC8
    );
  SEGMENT_VCC_396 : X_ONE
    port map (
      O => SEGMENT_VCC
    );
  SEGMENT_CELL_COUNT_0_Q : X_SFF
    port map (
      I => G_789,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SEGMENT_G_779_0,
      O => SEGMENT_CELL_COUNT(0)
    );
  SEGMENT_CELL_COUNT_1_Q : X_SFF
    port map (
      I => G_790,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SEGMENT_G_779_0,
      O => SEGMENT_CELL_COUNT(1)
    );
  SEGMENT_CELL_COUNT_2_Q : X_SFF
    port map (
      I => G_791,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SEGMENT_G_779_0,
      O => SEGMENT_CELL_COUNT(2)
    );
  SEGMENT_CELL_COUNT_3_Q : X_SFF
    port map (
      I => G_792,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SEGMENT_G_779_0,
      O => SEGMENT_N_146_1
    );
  SEGMENT_CFIFO_AVAIL_397 : X_FF
    port map (
      I => SEGMENT_CFIFO_AVAIL_W,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_AVAIL
    );
  SEGMENT_CFIFO_OUT_0_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_OUT_W(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_OUT(0)
    );
  SEGMENT_CFIFO_OUT_1_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_OUT_W(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_OUT(1)
    );
  SEGMENT_CFIFO_OUT_2_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_OUT_W(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_OUT(2)
    );
  SEGMENT_CFIFO_OUT_3_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_OUT_W(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_OUT(3)
    );
  SEGMENT_CFIFO_OUT_4_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_OUT_W(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_OUT(4)
    );
  SEGMENT_CFIFO_OUT_5_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_OUT_W(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_OUT(5)
    );
  SEGMENT_CFIFO_OUT_6_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_OUT_W(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_OUT(6)
    );
  SEGMENT_CFIFO_OUT_7_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_OUT_W(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_OUT(7)
    );
  SEGMENT_CFIFO_OUT_8_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_OUT_W(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_OUT(8)
    );
  SEGMENT_CFIFO_OUT_9_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_OUT_W(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_OUT(9)
    );
  SEGMENT_CFIFO_OUT_10_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_OUT_W(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_OUT(10)
    );
  SEGMENT_CFIFO_OUT_11_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_OUT_W(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_OUT(11)
    );
  SEGMENT_CFIFO_OUT_12_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_OUT_W(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_OUT(12)
    );
  SEGMENT_CFIFO_OUT_13_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_OUT_W(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_OUT(13)
    );
  SEGMENT_DATA_IN_0_Q : X_FF
    port map (
      I => D_APPL_IN(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(0)
    );
  SEGMENT_DATA_IN_1_Q : X_FF
    port map (
      I => D_APPL_IN(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(1)
    );
  SEGMENT_DATA_IN_2_Q : X_FF
    port map (
      I => D_APPL_IN(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(2)
    );
  SEGMENT_DATA_IN_3_Q : X_FF
    port map (
      I => D_APPL_IN(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(3)
    );
  SEGMENT_DATA_IN_4_Q : X_FF
    port map (
      I => D_APPL_IN(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(4)
    );
  SEGMENT_DATA_IN_5_Q : X_FF
    port map (
      I => D_APPL_IN(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(5)
    );
  SEGMENT_DATA_IN_6_Q : X_FF
    port map (
      I => D_APPL_IN(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(6)
    );
  SEGMENT_DATA_IN_7_Q : X_FF
    port map (
      I => D_APPL_IN(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(7)
    );
  SEGMENT_DATA_IN_8_Q : X_FF
    port map (
      I => D_APPL_IN(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(8)
    );
  SEGMENT_DATA_IN_9_Q : X_FF
    port map (
      I => D_APPL_IN(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(9)
    );
  SEGMENT_DATA_IN_10_Q : X_FF
    port map (
      I => D_APPL_IN(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(10)
    );
  SEGMENT_DATA_IN_11_Q : X_FF
    port map (
      I => D_APPL_IN(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(11)
    );
  SEGMENT_DATA_IN_12_Q : X_FF
    port map (
      I => D_APPL_IN(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(12)
    );
  SEGMENT_DATA_IN_13_Q : X_FF
    port map (
      I => D_APPL_IN(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(13)
    );
  SEGMENT_DATA_IN_14_Q : X_FF
    port map (
      I => D_APPL_IN(14),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(14)
    );
  SEGMENT_DATA_IN_15_Q : X_FF
    port map (
      I => D_APPL_IN(15),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(15)
    );
  SEGMENT_DATA_IN_16_Q : X_FF
    port map (
      I => D_APPL_IN(16),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(16)
    );
  SEGMENT_DATA_IN_17_Q : X_FF
    port map (
      I => D_APPL_IN(17),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(17)
    );
  SEGMENT_DATA_IN_18_Q : X_FF
    port map (
      I => D_APPL_IN(18),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(18)
    );
  SEGMENT_DATA_IN_19_Q : X_FF
    port map (
      I => D_APPL_IN(19),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(19)
    );
  SEGMENT_DATA_IN_20_Q : X_FF
    port map (
      I => D_APPL_IN(20),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(20)
    );
  SEGMENT_DATA_IN_21_Q : X_FF
    port map (
      I => D_APPL_IN(21),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(21)
    );
  SEGMENT_DATA_IN_22_Q : X_FF
    port map (
      I => D_APPL_IN(22),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(22)
    );
  SEGMENT_DATA_IN_23_Q : X_FF
    port map (
      I => D_APPL_IN(23),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(23)
    );
  SEGMENT_DATA_IN_24_Q : X_FF
    port map (
      I => D_APPL_IN(24),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(24)
    );
  SEGMENT_DATA_IN_25_Q : X_FF
    port map (
      I => D_APPL_IN(25),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(25)
    );
  SEGMENT_DATA_IN_26_Q : X_FF
    port map (
      I => D_APPL_IN(26),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(26)
    );
  SEGMENT_DATA_IN_27_Q : X_FF
    port map (
      I => D_APPL_IN(27),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(27)
    );
  SEGMENT_DATA_IN_28_Q : X_FF
    port map (
      I => D_APPL_IN(28),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(28)
    );
  SEGMENT_DATA_IN_29_Q : X_FF
    port map (
      I => D_APPL_IN(29),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(29)
    );
  SEGMENT_DATA_IN_30_Q : X_FF
    port map (
      I => D_APPL_IN(30),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(30)
    );
  SEGMENT_DATA_IN_31_Q : X_FF
    port map (
      I => D_APPL_IN(31),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATA_IN(31)
    );
  SEGMENT_DATAEN_IN_398 : X_FF
    port map (
      I => DATAEN_APPL_IN,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DATAEN_IN
    );
  SEGMENT_DFIFO_RE_I_0_G_748 : X_LUT4
    generic map (
      INIT => X"EEFE"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_RE_I_0_OR2,
      ADR1 => SEGMENT_DFIFO_RE_I_0_MUX2,
      ADR2 => SEGMENT_G_847,
      ADR3 => SEGMENT_STATE_2_Q,
      O => SEGMENT_G_748
    );
  SEGMENT_DFIFO_RE_I_0_MUX2_399 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => SEGMENT_STATE_0_Q,
      ADR1 => SEGMENT_G_790_0,
      ADR2 => SEGMENT_STATE_2_Q,
      O => SEGMENT_DFIFO_RE_I_0_MUX2
    );
  SEGMENT_DFIFO_RE_I_0_MUX2_G_1 : X_LUT3
    generic map (
      INIT => X"CA"
    )
    port map (
      ADR0 => SEGMENT_STATE_0_Q,
      ADR1 => SEGMENT_N_1272,
      ADR2 => SEGMENT_STATE_2_Q,
      O => SEGMENT_N_1273
    );
  SEGMENT_DFIFO_RE_I_0_OR2_400 : X_LUT4
    generic map (
      INIT => X"22F2"
    )
    port map (
      ADR0 => SEGMENT_G_779_FAST,
      ADR1 => SEGMENT_STATE_2_Q,
      ADR2 => SEGMENT_STATE_0_4_Q,
      ADR3 => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL,
      O => SEGMENT_DFIFO_RE_I_0_OR2
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_3_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => SEGMENT_G_383,
      ADR1 => SEGMENT_G_779_0,
      ADR2 => SEGMENT_HEADER_3_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_3_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_6_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => SEGMENT_G_384,
      ADR1 => SEGMENT_G_779_0,
      ADR2 => SEGMENT_HEADER_6_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_6_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_2_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => SEGMENT_G_378,
      ADR1 => SEGMENT_G_779_0,
      ADR2 => SEGMENT_HEADER_2_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_2_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_4_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => SEGMENT_G_388,
      ADR1 => SEGMENT_G_779_0,
      ADR2 => SEGMENT_HEADER_4_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_4_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_5_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => SEGMENT_G_385,
      ADR1 => SEGMENT_G_779_0,
      ADR2 => SEGMENT_HEADER_5_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_5_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_7_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => SEGMENT_G_379,
      ADR1 => SEGMENT_G_779_0,
      ADR2 => SEGMENT_HEADER_7_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_7_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_8_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => SEGMENT_G_387,
      ADR1 => SEGMENT_G_779_0,
      ADR2 => SEGMENT_HEADER_8_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_8_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_9_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => SEGMENT_G_386,
      ADR1 => SEGMENT_G_779_0,
      ADR2 => SEGMENT_HEADER_9_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_9_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_10_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => SEGMENT_G_381,
      ADR1 => SEGMENT_G_779_0,
      ADR2 => SEGMENT_HEADER_10_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_10_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_11_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => SEGMENT_G_380,
      ADR1 => SEGMENT_G_779_0,
      ADR2 => SEGMENT_HEADER_11_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_11_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_12_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => SEGMENT_G_377,
      ADR1 => SEGMENT_G_779_0,
      ADR2 => SEGMENT_HEADER_12_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_12_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_13_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => SEGMENT_G_382,
      ADR1 => SEGMENT_G_779_0,
      ADR2 => SEGMENT_HEADER_13_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_13_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_14_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => SEGMENT_G_375,
      ADR1 => SEGMENT_G_779_0,
      ADR2 => SEGMENT_HEADER_14_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_14_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_15_Q : X_LUT3
    generic map (
      INIT => X"EA"
    )
    port map (
      ADR0 => SEGMENT_G_376,
      ADR1 => SEGMENT_G_779_0,
      ADR2 => SEGMENT_HEADER_15_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_15_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_2_G_378 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(0),
      ADR1 => SEGMENT_STATE_0_1_Q,
      ADR2 => SEGMENT_G_788_0,
      ADR3 => SEGMENT_DFIFO_DOUT(2),
      O => SEGMENT_G_378
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_4_G_388 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(2),
      ADR1 => SEGMENT_STATE_0_1_Q,
      ADR2 => SEGMENT_G_788_0,
      ADR3 => SEGMENT_DFIFO_DOUT(4),
      O => SEGMENT_G_388
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_5_G_385 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(3),
      ADR1 => SEGMENT_STATE_0_1_Q,
      ADR2 => SEGMENT_G_788_0,
      ADR3 => SEGMENT_DFIFO_DOUT(5),
      O => SEGMENT_G_385
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_7_G_379 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(5),
      ADR1 => SEGMENT_STATE_0_1_Q,
      ADR2 => SEGMENT_G_788_0,
      ADR3 => SEGMENT_DFIFO_DOUT(7),
      O => SEGMENT_G_379
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_8_G_387 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(6),
      ADR1 => SEGMENT_STATE_0_1_Q,
      ADR2 => SEGMENT_G_788_0,
      ADR3 => SEGMENT_DFIFO_DOUT(8),
      O => SEGMENT_G_387
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_9_G_386 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(7),
      ADR1 => SEGMENT_STATE_0_1_Q,
      ADR2 => SEGMENT_G_788_0,
      ADR3 => SEGMENT_DFIFO_DOUT(9),
      O => SEGMENT_G_386
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_10_G_381 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(8),
      ADR1 => SEGMENT_STATE_0_1_Q,
      ADR2 => SEGMENT_G_788_0,
      ADR3 => SEGMENT_DFIFO_DOUT(10),
      O => SEGMENT_G_381
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_11_G_380 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(9),
      ADR1 => SEGMENT_STATE_0_1_Q,
      ADR2 => SEGMENT_G_788_0,
      ADR3 => SEGMENT_DFIFO_DOUT(11),
      O => SEGMENT_G_380
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_12_G_377 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(10),
      ADR1 => SEGMENT_STATE_0_1_Q,
      ADR2 => SEGMENT_G_788_0,
      ADR3 => SEGMENT_DFIFO_DOUT(12),
      O => SEGMENT_G_377
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_13_G_382 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(11),
      ADR1 => SEGMENT_STATE_0_1_Q,
      ADR2 => SEGMENT_G_788_0,
      ADR3 => SEGMENT_DFIFO_DOUT(13),
      O => SEGMENT_G_382
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_14_G_375 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(12),
      ADR1 => SEGMENT_STATE_0_1_Q,
      ADR2 => SEGMENT_G_788_0,
      ADR3 => SEGMENT_DFIFO_DOUT(14),
      O => SEGMENT_G_375
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_0_15_G_376 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(13),
      ADR1 => SEGMENT_STATE_0_1_Q,
      ADR2 => SEGMENT_G_788_0,
      ADR3 => SEGMENT_DFIFO_DOUT(15),
      O => SEGMENT_G_376
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_3_G_383 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(1),
      ADR1 => SEGMENT_STATE_0_1_Q,
      ADR2 => SEGMENT_G_788_0,
      ADR3 => SEGMENT_DFIFO_DOUT(3),
      O => SEGMENT_G_383
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_0_IV_0_6_G_384 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(4),
      ADR1 => SEGMENT_STATE_0_1_Q,
      ADR2 => SEGMENT_G_788_0,
      ADR3 => SEGMENT_DFIFO_DOUT(6),
      O => SEGMENT_G_384
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_0_16_Q : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_G_858,
      ADR1 => SEGMENT_DFIFO_DOUT(16),
      ADR2 => SEGMENT_G_779_0,
      ADR3 => SEGMENT_HEADER_16_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_16_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_0_18_Q : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_G_858,
      ADR1 => SEGMENT_DFIFO_DOUT(18),
      ADR2 => SEGMENT_G_779_0,
      ADR3 => SEGMENT_HEADER_18_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_18_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_0_20_Q : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_G_858,
      ADR1 => SEGMENT_DFIFO_DOUT(20),
      ADR2 => SEGMENT_G_779_0,
      ADR3 => SEGMENT_HEADER_20_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_20_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_0_22_Q : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_G_858,
      ADR1 => SEGMENT_DFIFO_DOUT(22),
      ADR2 => SEGMENT_G_779_0,
      ADR3 => SEGMENT_HEADER_22_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_22_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_0_24_Q : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_G_858,
      ADR1 => SEGMENT_DFIFO_DOUT(24),
      ADR2 => SEGMENT_G_779_0,
      ADR3 => SEGMENT_HEADER_24_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_24_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_0_26_Q : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_G_858,
      ADR1 => SEGMENT_DFIFO_DOUT(26),
      ADR2 => SEGMENT_G_779_0,
      ADR3 => SEGMENT_HEADER_26_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_26_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_0_28_Q : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_G_858,
      ADR1 => SEGMENT_DFIFO_DOUT(28),
      ADR2 => SEGMENT_G_779_0,
      ADR3 => SEGMENT_HEADER_28_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_28_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_0_30_Q : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_G_858,
      ADR1 => SEGMENT_DFIFO_DOUT(30),
      ADR2 => SEGMENT_G_779_0,
      ADR3 => SEGMENT_HEADER_30_Q,
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_30_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_0_Q_401 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_G_779_0,
      ADR1 => SEGMENT_HEADER_0_Q,
      ADR2 => SEGMENT_G_858,
      ADR3 => SEGMENT_DFIFO_DOUT(0),
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_0_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_17_Q_402 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_G_779_0,
      ADR1 => SEGMENT_HEADER_17_Q,
      ADR2 => SEGMENT_G_858,
      ADR3 => SEGMENT_DFIFO_DOUT(17),
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_17_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_19_Q_403 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_G_779_0,
      ADR1 => SEGMENT_HEADER_19_Q,
      ADR2 => SEGMENT_G_858,
      ADR3 => SEGMENT_DFIFO_DOUT(19),
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_19_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_21_Q_404 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_G_779_0,
      ADR1 => SEGMENT_HEADER_21_Q,
      ADR2 => SEGMENT_G_858,
      ADR3 => SEGMENT_DFIFO_DOUT(21),
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_21_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_23_Q_405 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_G_779_0,
      ADR1 => SEGMENT_HEADER_23_Q,
      ADR2 => SEGMENT_G_858,
      ADR3 => SEGMENT_DFIFO_DOUT(23),
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_23_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_25_Q_406 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_G_779_0,
      ADR1 => SEGMENT_HEADER_25_Q,
      ADR2 => SEGMENT_G_858,
      ADR3 => SEGMENT_DFIFO_DOUT(25),
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_25_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_27_Q_407 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_G_779_0,
      ADR1 => SEGMENT_HEADER_27_Q,
      ADR2 => SEGMENT_G_858,
      ADR3 => SEGMENT_DFIFO_DOUT(27),
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_27_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_29_Q_408 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_G_779_0,
      ADR1 => SEGMENT_HEADER_29_Q,
      ADR2 => SEGMENT_G_858,
      ADR3 => SEGMENT_DFIFO_DOUT(29),
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_29_Q
    );
  SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_31_Q_409 : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_G_779_0,
      ADR1 => SEGMENT_HEADER_31_Q,
      ADR2 => SEGMENT_G_858,
      ADR3 => SEGMENT_DFIFO_DOUT(31),
      O => SEGMENT_DOUT_PROC_D_OUT_MOD_1_1_IV_I_AND2_I_31_Q
    );
  SEGMENT_EOF_DELAY0_410 : X_FF
    port map (
      I => SEGMENT_EOF_IN,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_EOF_DELAY0
    );
  SEGMENT_EOF_DELAY1_411 : X_FF
    port map (
      I => SEGMENT_EOF_DELAY0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_EOF_DELAY1
    );
  SEGMENT_EOF_IN_412 : X_FF
    port map (
      I => EOF_APPL_IN,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_EOF_IN
    );
  SEGMENT_FIFO_RESET_413 : X_FF
    port map (
      I => RESET_L_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_FIFO_RESET
    );
  SEGMENT_HEADER_0_Q_414 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(0),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_0_Q
    );
  SEGMENT_HEADER_2_Q_415 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(2),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_2_Q
    );
  SEGMENT_HEADER_3_Q_416 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(3),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_3_Q
    );
  SEGMENT_HEADER_4_Q_417 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(4),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_4_Q
    );
  SEGMENT_HEADER_5_Q_418 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(5),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_5_Q
    );
  SEGMENT_HEADER_6_Q_419 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(6),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_6_Q
    );
  SEGMENT_HEADER_7_Q_420 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(7),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_7_Q
    );
  SEGMENT_HEADER_8_Q_421 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(8),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_8_Q
    );
  SEGMENT_HEADER_9_Q_422 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(9),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_9_Q
    );
  SEGMENT_HEADER_10_Q_423 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(10),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_10_Q
    );
  SEGMENT_HEADER_11_Q_424 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(11),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_11_Q
    );
  SEGMENT_HEADER_12_Q_425 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(12),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_12_Q
    );
  SEGMENT_HEADER_13_Q_426 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(13),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_13_Q
    );
  SEGMENT_HEADER_14_Q_427 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(14),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_14_Q
    );
  SEGMENT_HEADER_15_Q_428 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(15),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_15_Q
    );
  SEGMENT_HEADER_16_Q_429 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(16),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_16_Q
    );
  SEGMENT_HEADER_17_Q_430 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(17),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_17_Q
    );
  SEGMENT_HEADER_18_Q_431 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(18),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_18_Q
    );
  SEGMENT_HEADER_19_Q_432 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(19),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_19_Q
    );
  SEGMENT_HEADER_20_Q_433 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(20),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_20_Q
    );
  SEGMENT_HEADER_21_Q_434 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(21),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_21_Q
    );
  SEGMENT_HEADER_22_Q_435 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(22),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_22_Q
    );
  SEGMENT_HEADER_23_Q_436 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(23),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_23_Q
    );
  SEGMENT_HEADER_24_Q_437 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(24),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_24_Q
    );
  SEGMENT_HEADER_25_Q_438 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(25),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_25_Q
    );
  SEGMENT_HEADER_26_Q_439 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(26),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_26_Q
    );
  SEGMENT_HEADER_27_Q_440 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(27),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_27_Q
    );
  SEGMENT_HEADER_28_Q_441 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(28),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_28_Q
    );
  SEGMENT_HEADER_29_Q_442 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(29),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_29_Q
    );
  SEGMENT_HEADER_30_Q_443 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(30),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_30_Q
    );
  SEGMENT_HEADER_31_Q_444 : X_FF
    port map (
      I => SEGMENT_DFIFO_DOUT(31),
      CLK => CLK,
      CE => SEGMENT_STATE_0_10_Q,
      SET => GND,
      RST => GSR,
      O => SEGMENT_HEADER_31_Q
    );
  SEGMENT_IN_COUNT_0_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT_LM(0),
      CLK => CLK,
      CE => SEGMENT_N_992_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_IN_COUNT(0)
    );
  SEGMENT_IN_COUNT_1_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT_LM(1),
      CLK => CLK,
      CE => SEGMENT_N_992_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_IN_COUNT(1)
    );
  SEGMENT_IN_COUNT_2_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT_LM(2),
      CLK => CLK,
      CE => SEGMENT_N_992_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_IN_COUNT(2)
    );
  SEGMENT_IN_COUNT_3_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT_LM(3),
      CLK => CLK,
      CE => SEGMENT_N_992_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_IN_COUNT(3)
    );
  SEGMENT_IN_COUNT_4_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT_LM(4),
      CLK => CLK,
      CE => SEGMENT_N_992_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_IN_COUNT(4)
    );
  SEGMENT_IN_COUNT_5_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT_LM(5),
      CLK => CLK,
      CE => SEGMENT_N_992_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_IN_COUNT(5)
    );
  SEGMENT_IN_COUNT_6_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT_LM(6),
      CLK => CLK,
      CE => SEGMENT_N_992_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_IN_COUNT(6)
    );
  SEGMENT_IN_COUNT_7_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT_LM(7),
      CLK => CLK,
      CE => SEGMENT_N_992_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_IN_COUNT(7)
    );
  SEGMENT_IN_COUNT_8_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT_LM(8),
      CLK => CLK,
      CE => SEGMENT_N_992_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_IN_COUNT(8)
    );
  SEGMENT_IN_COUNT_9_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT_LM(9),
      CLK => CLK,
      CE => SEGMENT_N_992_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_IN_COUNT(9)
    );
  SEGMENT_IN_COUNT_10_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT_LM(10),
      CLK => CLK,
      CE => SEGMENT_N_992_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_IN_COUNT(10)
    );
  SEGMENT_IN_COUNT_11_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT_LM(11),
      CLK => CLK,
      CE => SEGMENT_N_992_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_IN_COUNT(11)
    );
  SEGMENT_IN_COUNT_12_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT_LM(12),
      CLK => CLK,
      CE => SEGMENT_N_992_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_IN_COUNT(12)
    );
  SEGMENT_IN_COUNT_13_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT_LM(13),
      CLK => CLK,
      CE => SEGMENT_N_992_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_IN_COUNT(13)
    );
  SEGMENT_IN_COUNT_CRY_0_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_VCC,
      SEL => SEGMENT_IN_COUNT_QXU(0),
      O => SEGMENT_IN_COUNT_CRY_0_O
    );
  SEGMENT_IN_COUNT_CRY_0_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_IN_COUNT_CRY_0_O,
      O => SEGMENT_IN_COUNT_CRY(0)
    );
  SEGMENT_IN_COUNT_CRY_1_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_IN_COUNT_CRY(0),
      SEL => SEGMENT_IN_COUNT_QXU(1),
      O => SEGMENT_IN_COUNT_CRY_1_O
    );
  SEGMENT_IN_COUNT_CRY_1_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_IN_COUNT_CRY_1_O,
      O => SEGMENT_IN_COUNT_CRY(1)
    );
  SEGMENT_IN_COUNT_CRY_2_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_IN_COUNT_CRY(1),
      SEL => SEGMENT_IN_COUNT_QXU(2),
      O => SEGMENT_IN_COUNT_CRY_2_O
    );
  SEGMENT_IN_COUNT_CRY_2_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_IN_COUNT_CRY_2_O,
      O => SEGMENT_IN_COUNT_CRY(2)
    );
  SEGMENT_IN_COUNT_CRY_3_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_IN_COUNT_CRY(2),
      SEL => SEGMENT_IN_COUNT_QXU(3),
      O => SEGMENT_IN_COUNT_CRY_3_O
    );
  SEGMENT_IN_COUNT_CRY_3_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_IN_COUNT_CRY_3_O,
      O => SEGMENT_IN_COUNT_CRY(3)
    );
  SEGMENT_IN_COUNT_CRY_4_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_IN_COUNT_CRY(3),
      SEL => SEGMENT_IN_COUNT_QXU(4),
      O => SEGMENT_IN_COUNT_CRY_4_O
    );
  SEGMENT_IN_COUNT_CRY_4_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_IN_COUNT_CRY_4_O,
      O => SEGMENT_IN_COUNT_CRY(4)
    );
  SEGMENT_IN_COUNT_CRY_5_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_IN_COUNT_CRY(4),
      SEL => SEGMENT_IN_COUNT_QXU(5),
      O => SEGMENT_IN_COUNT_CRY_5_O
    );
  SEGMENT_IN_COUNT_CRY_5_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_IN_COUNT_CRY_5_O,
      O => SEGMENT_IN_COUNT_CRY(5)
    );
  SEGMENT_IN_COUNT_CRY_6_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_IN_COUNT_CRY(5),
      SEL => SEGMENT_IN_COUNT_QXU(6),
      O => SEGMENT_IN_COUNT_CRY_6_O
    );
  SEGMENT_IN_COUNT_CRY_6_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_IN_COUNT_CRY_6_O,
      O => SEGMENT_IN_COUNT_CRY(6)
    );
  SEGMENT_IN_COUNT_CRY_7_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_IN_COUNT_CRY(6),
      SEL => SEGMENT_IN_COUNT_QXU(7),
      O => SEGMENT_IN_COUNT_CRY_7_O
    );
  SEGMENT_IN_COUNT_CRY_7_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_IN_COUNT_CRY_7_O,
      O => SEGMENT_IN_COUNT_CRY(7)
    );
  SEGMENT_IN_COUNT_CRY_8_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_IN_COUNT_CRY(7),
      SEL => SEGMENT_IN_COUNT_QXU(8),
      O => SEGMENT_IN_COUNT_CRY_8_O
    );
  SEGMENT_IN_COUNT_CRY_8_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_IN_COUNT_CRY_8_O,
      O => SEGMENT_IN_COUNT_CRY(8)
    );
  SEGMENT_IN_COUNT_CRY_9_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_IN_COUNT_CRY(8),
      SEL => SEGMENT_IN_COUNT_QXU(9),
      O => SEGMENT_IN_COUNT_CRY_9_O
    );
  SEGMENT_IN_COUNT_CRY_9_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_IN_COUNT_CRY_9_O,
      O => SEGMENT_IN_COUNT_CRY(9)
    );
  SEGMENT_IN_COUNT_CRY_10_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_IN_COUNT_CRY(9),
      SEL => SEGMENT_IN_COUNT_QXU(10),
      O => SEGMENT_IN_COUNT_CRY_10_O
    );
  SEGMENT_IN_COUNT_CRY_10_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_IN_COUNT_CRY_10_O,
      O => SEGMENT_IN_COUNT_CRY(10)
    );
  SEGMENT_IN_COUNT_CRY_11_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_IN_COUNT_CRY(10),
      SEL => SEGMENT_IN_COUNT_QXU(11),
      O => SEGMENT_IN_COUNT_CRY_11_O
    );
  SEGMENT_IN_COUNT_CRY_11_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_IN_COUNT_CRY_11_O,
      O => SEGMENT_IN_COUNT_CRY(11)
    );
  SEGMENT_IN_COUNT_CRY_12_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_IN_COUNT_CRY(11),
      SEL => SEGMENT_IN_COUNT_QXU(12),
      O => SEGMENT_IN_COUNT_CRY_12_O
    );
  SEGMENT_IN_COUNT_CRY_12_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_IN_COUNT_CRY_12_O,
      O => SEGMENT_IN_COUNT_CRY(12)
    );
  SEGMENT_IN_COUNT_LM_0_0_Q : X_LUT4
    generic map (
      INIT => X"3A33"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT_S(0),
      ADR1 => SEGMENT_DATAEN_IN,
      ADR2 => SEGMENT_SOF_IN,
      ADR3 => RESET_L_1,
      O => SEGMENT_IN_COUNT_LM(0)
    );
  SEGMENT_IN_COUNT_LM_0_1_Q : X_LUT4
    generic map (
      INIT => X"CACC"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT_S(1),
      ADR1 => SEGMENT_DATAEN_IN,
      ADR2 => SEGMENT_SOF_IN,
      ADR3 => RESET_L_1,
      O => SEGMENT_IN_COUNT_LM(1)
    );
  SEGMENT_IN_COUNT_LM_0_2_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT_S(2),
      ADR1 => SEGMENT_SOF_IN,
      ADR2 => RESET_L_1,
      O => SEGMENT_IN_COUNT_LM(2)
    );
  SEGMENT_IN_COUNT_LM_0_3_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT_S(3),
      ADR1 => SEGMENT_SOF_IN,
      ADR2 => RESET_L_1,
      O => SEGMENT_IN_COUNT_LM(3)
    );
  SEGMENT_IN_COUNT_LM_0_4_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT_S(4),
      ADR1 => SEGMENT_SOF_IN,
      ADR2 => RESET_L_1,
      O => SEGMENT_IN_COUNT_LM(4)
    );
  SEGMENT_IN_COUNT_LM_0_5_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT_S(5),
      ADR1 => SEGMENT_SOF_IN,
      ADR2 => RESET_L_1,
      O => SEGMENT_IN_COUNT_LM(5)
    );
  SEGMENT_IN_COUNT_LM_0_6_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT_S(6),
      ADR1 => SEGMENT_SOF_IN,
      ADR2 => RESET_L_0,
      O => SEGMENT_IN_COUNT_LM(6)
    );
  SEGMENT_IN_COUNT_LM_0_7_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT_S(7),
      ADR1 => SEGMENT_SOF_IN,
      ADR2 => RESET_L_0,
      O => SEGMENT_IN_COUNT_LM(7)
    );
  SEGMENT_IN_COUNT_LM_0_8_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT_S(8),
      ADR1 => SEGMENT_SOF_IN,
      ADR2 => RESET_L_0,
      O => SEGMENT_IN_COUNT_LM(8)
    );
  SEGMENT_IN_COUNT_LM_0_9_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT_S(9),
      ADR1 => SEGMENT_SOF_IN,
      ADR2 => RESET_L_0,
      O => SEGMENT_IN_COUNT_LM(9)
    );
  SEGMENT_IN_COUNT_LM_0_10_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT_S(10),
      ADR1 => SEGMENT_SOF_IN,
      ADR2 => RESET_L_0,
      O => SEGMENT_IN_COUNT_LM(10)
    );
  SEGMENT_IN_COUNT_LM_0_11_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT_S(11),
      ADR1 => SEGMENT_SOF_IN,
      ADR2 => RESET_L_0,
      O => SEGMENT_IN_COUNT_LM(11)
    );
  SEGMENT_IN_COUNT_LM_0_12_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT_S(12),
      ADR1 => SEGMENT_SOF_IN,
      ADR2 => RESET_L_0,
      O => SEGMENT_IN_COUNT_LM(12)
    );
  SEGMENT_IN_COUNT_LM_0_13_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT_S(13),
      ADR1 => SEGMENT_SOF_IN,
      ADR2 => RESET_L_0,
      O => SEGMENT_IN_COUNT_LM(13)
    );
  SEGMENT_IN_COUNT_QXU_0_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT(0),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_IN_COUNT_QXU(0)
    );
  SEGMENT_IN_COUNT_QXU_1_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT(1),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_IN_COUNT_QXU(1)
    );
  SEGMENT_IN_COUNT_QXU_2_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT(2),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_IN_COUNT_QXU(2)
    );
  SEGMENT_IN_COUNT_QXU_3_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT(3),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_IN_COUNT_QXU(3)
    );
  SEGMENT_IN_COUNT_QXU_4_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT(4),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_IN_COUNT_QXU(4)
    );
  SEGMENT_IN_COUNT_QXU_5_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT(5),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_IN_COUNT_QXU(5)
    );
  SEGMENT_IN_COUNT_QXU_6_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT(6),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_IN_COUNT_QXU(6)
    );
  SEGMENT_IN_COUNT_QXU_7_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT(7),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_IN_COUNT_QXU(7)
    );
  SEGMENT_IN_COUNT_QXU_8_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT(8),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_IN_COUNT_QXU(8)
    );
  SEGMENT_IN_COUNT_QXU_9_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT(9),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_IN_COUNT_QXU(9)
    );
  SEGMENT_IN_COUNT_QXU_10_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT(10),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_IN_COUNT_QXU(10)
    );
  SEGMENT_IN_COUNT_QXU_11_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT(11),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_IN_COUNT_QXU(11)
    );
  SEGMENT_IN_COUNT_QXU_12_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT(12),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_IN_COUNT_QXU(12)
    );
  SEGMENT_IN_COUNT_QXU_13_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_IN_COUNT(13),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_IN_COUNT_QXU(13)
    );
  SEGMENT_IN_COUNT_S_0_Q : X_XOR2
    port map (
      I0 => SEGMENT_IN_COUNT_QXU(0),
      I1 => SEGMENT_VCC,
      O => SEGMENT_IN_COUNT_S(0)
    );
  SEGMENT_IN_COUNT_S_1_Q : X_XOR2
    port map (
      I0 => SEGMENT_IN_COUNT_QXU(1),
      I1 => SEGMENT_IN_COUNT_CRY(0),
      O => SEGMENT_IN_COUNT_S(1)
    );
  SEGMENT_IN_COUNT_S_2_Q : X_XOR2
    port map (
      I0 => SEGMENT_IN_COUNT_QXU(2),
      I1 => SEGMENT_IN_COUNT_CRY(1),
      O => SEGMENT_IN_COUNT_S(2)
    );
  SEGMENT_IN_COUNT_S_3_Q : X_XOR2
    port map (
      I0 => SEGMENT_IN_COUNT_QXU(3),
      I1 => SEGMENT_IN_COUNT_CRY(2),
      O => SEGMENT_IN_COUNT_S(3)
    );
  SEGMENT_IN_COUNT_S_4_Q : X_XOR2
    port map (
      I0 => SEGMENT_IN_COUNT_QXU(4),
      I1 => SEGMENT_IN_COUNT_CRY(3),
      O => SEGMENT_IN_COUNT_S(4)
    );
  SEGMENT_IN_COUNT_S_5_Q : X_XOR2
    port map (
      I0 => SEGMENT_IN_COUNT_QXU(5),
      I1 => SEGMENT_IN_COUNT_CRY(4),
      O => SEGMENT_IN_COUNT_S(5)
    );
  SEGMENT_IN_COUNT_S_6_Q : X_XOR2
    port map (
      I0 => SEGMENT_IN_COUNT_QXU(6),
      I1 => SEGMENT_IN_COUNT_CRY(5),
      O => SEGMENT_IN_COUNT_S(6)
    );
  SEGMENT_IN_COUNT_S_7_Q : X_XOR2
    port map (
      I0 => SEGMENT_IN_COUNT_QXU(7),
      I1 => SEGMENT_IN_COUNT_CRY(6),
      O => SEGMENT_IN_COUNT_S(7)
    );
  SEGMENT_IN_COUNT_S_8_Q : X_XOR2
    port map (
      I0 => SEGMENT_IN_COUNT_QXU(8),
      I1 => SEGMENT_IN_COUNT_CRY(7),
      O => SEGMENT_IN_COUNT_S(8)
    );
  SEGMENT_IN_COUNT_S_9_Q : X_XOR2
    port map (
      I0 => SEGMENT_IN_COUNT_QXU(9),
      I1 => SEGMENT_IN_COUNT_CRY(8),
      O => SEGMENT_IN_COUNT_S(9)
    );
  SEGMENT_IN_COUNT_S_10_Q : X_XOR2
    port map (
      I0 => SEGMENT_IN_COUNT_QXU(10),
      I1 => SEGMENT_IN_COUNT_CRY(9),
      O => SEGMENT_IN_COUNT_S(10)
    );
  SEGMENT_IN_COUNT_S_11_Q : X_XOR2
    port map (
      I0 => SEGMENT_IN_COUNT_QXU(11),
      I1 => SEGMENT_IN_COUNT_CRY(10),
      O => SEGMENT_IN_COUNT_S(11)
    );
  SEGMENT_IN_COUNT_S_12_Q : X_XOR2
    port map (
      I0 => SEGMENT_IN_COUNT_QXU(12),
      I1 => SEGMENT_IN_COUNT_CRY(11),
      O => SEGMENT_IN_COUNT_S(12)
    );
  SEGMENT_IN_COUNT_S_13_Q : X_XOR2
    port map (
      I0 => SEGMENT_IN_COUNT_QXU(13),
      I1 => SEGMENT_IN_COUNT_CRY(12),
      O => SEGMENT_IN_COUNT_S(13)
    );
  SEGMENT_OUT_COUNT_0_Q : X_FF
    port map (
      I => SEGMENT_OUT_COUNT_LM(0),
      CLK => CLK,
      CE => SEGMENT_N_1018_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_OUT_COUNT(0)
    );
  SEGMENT_OUT_COUNT_1_Q : X_FF
    port map (
      I => SEGMENT_OUT_COUNT_LM(1),
      CLK => CLK,
      CE => SEGMENT_N_1018_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_OUT_COUNT(1)
    );
  SEGMENT_OUT_COUNT_2_Q : X_FF
    port map (
      I => SEGMENT_OUT_COUNT_LM(2),
      CLK => CLK,
      CE => SEGMENT_N_1018_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_OUT_COUNT(2)
    );
  SEGMENT_OUT_COUNT_3_Q : X_FF
    port map (
      I => SEGMENT_OUT_COUNT_LM(3),
      CLK => CLK,
      CE => SEGMENT_N_1018_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_OUT_COUNT(3)
    );
  SEGMENT_OUT_COUNT_4_Q : X_FF
    port map (
      I => SEGMENT_OUT_COUNT_LM(4),
      CLK => CLK,
      CE => SEGMENT_N_1018_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_OUT_COUNT(4)
    );
  SEGMENT_OUT_COUNT_5_Q : X_FF
    port map (
      I => SEGMENT_OUT_COUNT_LM(5),
      CLK => CLK,
      CE => SEGMENT_N_1018_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_OUT_COUNT(5)
    );
  SEGMENT_OUT_COUNT_6_Q : X_FF
    port map (
      I => SEGMENT_OUT_COUNT_LM(6),
      CLK => CLK,
      CE => SEGMENT_N_1018_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_OUT_COUNT(6)
    );
  SEGMENT_OUT_COUNT_7_Q : X_FF
    port map (
      I => SEGMENT_OUT_COUNT_LM(7),
      CLK => CLK,
      CE => SEGMENT_N_1018_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_OUT_COUNT(7)
    );
  SEGMENT_OUT_COUNT_8_Q : X_FF
    port map (
      I => SEGMENT_OUT_COUNT_LM(8),
      CLK => CLK,
      CE => SEGMENT_N_1018_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_OUT_COUNT(8)
    );
  SEGMENT_OUT_COUNT_9_Q : X_FF
    port map (
      I => SEGMENT_OUT_COUNT_LM(9),
      CLK => CLK,
      CE => SEGMENT_N_1018_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_OUT_COUNT(9)
    );
  SEGMENT_OUT_COUNT_10_Q : X_FF
    port map (
      I => SEGMENT_OUT_COUNT_LM(10),
      CLK => CLK,
      CE => SEGMENT_N_1018_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_OUT_COUNT(10)
    );
  SEGMENT_OUT_COUNT_11_Q : X_FF
    port map (
      I => SEGMENT_OUT_COUNT_LM(11),
      CLK => CLK,
      CE => SEGMENT_N_1018_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_OUT_COUNT(11)
    );
  SEGMENT_OUT_COUNT_12_Q : X_FF
    port map (
      I => SEGMENT_OUT_COUNT_LM(12),
      CLK => CLK,
      CE => SEGMENT_N_1018_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_OUT_COUNT(12)
    );
  SEGMENT_OUT_COUNT_13_Q : X_FF
    port map (
      I => SEGMENT_OUT_COUNT_LM(13),
      CLK => CLK,
      CE => SEGMENT_N_1018_I,
      SET => GND,
      RST => GSR,
      O => SEGMENT_OUT_COUNT(13)
    );
  SEGMENT_OUT_COUNT_CRY_0_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_VCC,
      SEL => SEGMENT_OUT_COUNT_QXU(0),
      O => SEGMENT_OUT_COUNT_CRY_0_O
    );
  SEGMENT_OUT_COUNT_CRY_0_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_OUT_COUNT_CRY_0_O,
      O => SEGMENT_OUT_COUNT_CRY(0)
    );
  SEGMENT_OUT_COUNT_CRY_1_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_OUT_COUNT_CRY(0),
      SEL => SEGMENT_OUT_COUNT_QXU(1),
      O => SEGMENT_OUT_COUNT_CRY_1_O
    );
  SEGMENT_OUT_COUNT_CRY_1_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_OUT_COUNT_CRY_1_O,
      O => SEGMENT_OUT_COUNT_CRY(1)
    );
  SEGMENT_OUT_COUNT_CRY_2_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_OUT_COUNT_CRY(1),
      SEL => SEGMENT_OUT_COUNT_QXU(2),
      O => SEGMENT_OUT_COUNT_CRY_2_O
    );
  SEGMENT_OUT_COUNT_CRY_2_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_OUT_COUNT_CRY_2_O,
      O => SEGMENT_OUT_COUNT_CRY(2)
    );
  SEGMENT_OUT_COUNT_CRY_3_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_OUT_COUNT_CRY(2),
      SEL => SEGMENT_OUT_COUNT_QXU(3),
      O => SEGMENT_OUT_COUNT_CRY_3_O
    );
  SEGMENT_OUT_COUNT_CRY_3_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_OUT_COUNT_CRY_3_O,
      O => SEGMENT_OUT_COUNT_CRY(3)
    );
  SEGMENT_OUT_COUNT_CRY_4_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_OUT_COUNT_CRY(3),
      SEL => SEGMENT_OUT_COUNT_QXU(4),
      O => SEGMENT_OUT_COUNT_CRY_4_O
    );
  SEGMENT_OUT_COUNT_CRY_4_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_OUT_COUNT_CRY_4_O,
      O => SEGMENT_OUT_COUNT_CRY(4)
    );
  SEGMENT_OUT_COUNT_CRY_5_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_OUT_COUNT_CRY(4),
      SEL => SEGMENT_OUT_COUNT_QXU(5),
      O => SEGMENT_OUT_COUNT_CRY_5_O
    );
  SEGMENT_OUT_COUNT_CRY_5_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_OUT_COUNT_CRY_5_O,
      O => SEGMENT_OUT_COUNT_CRY(5)
    );
  SEGMENT_OUT_COUNT_CRY_6_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_OUT_COUNT_CRY(5),
      SEL => SEGMENT_OUT_COUNT_QXU(6),
      O => SEGMENT_OUT_COUNT_CRY_6_O
    );
  SEGMENT_OUT_COUNT_CRY_6_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_OUT_COUNT_CRY_6_O,
      O => SEGMENT_OUT_COUNT_CRY(6)
    );
  SEGMENT_OUT_COUNT_CRY_7_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_OUT_COUNT_CRY(6),
      SEL => SEGMENT_OUT_COUNT_QXU(7),
      O => SEGMENT_OUT_COUNT_CRY_7_O
    );
  SEGMENT_OUT_COUNT_CRY_7_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_OUT_COUNT_CRY_7_O,
      O => SEGMENT_OUT_COUNT_CRY(7)
    );
  SEGMENT_OUT_COUNT_CRY_8_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_OUT_COUNT_CRY(7),
      SEL => SEGMENT_OUT_COUNT_QXU(8),
      O => SEGMENT_OUT_COUNT_CRY_8_O
    );
  SEGMENT_OUT_COUNT_CRY_8_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_OUT_COUNT_CRY_8_O,
      O => SEGMENT_OUT_COUNT_CRY(8)
    );
  SEGMENT_OUT_COUNT_CRY_9_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_OUT_COUNT_CRY(8),
      SEL => SEGMENT_OUT_COUNT_QXU(9),
      O => SEGMENT_OUT_COUNT_CRY_9_O
    );
  SEGMENT_OUT_COUNT_CRY_9_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_OUT_COUNT_CRY_9_O,
      O => SEGMENT_OUT_COUNT_CRY(9)
    );
  SEGMENT_OUT_COUNT_CRY_10_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_OUT_COUNT_CRY(9),
      SEL => SEGMENT_OUT_COUNT_QXU(10),
      O => SEGMENT_OUT_COUNT_CRY_10_O
    );
  SEGMENT_OUT_COUNT_CRY_10_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_OUT_COUNT_CRY_10_O,
      O => SEGMENT_OUT_COUNT_CRY(10)
    );
  SEGMENT_OUT_COUNT_CRY_11_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_OUT_COUNT_CRY(10),
      SEL => SEGMENT_OUT_COUNT_QXU(11),
      O => SEGMENT_OUT_COUNT_CRY_11_O
    );
  SEGMENT_OUT_COUNT_CRY_11_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_OUT_COUNT_CRY_11_O,
      O => SEGMENT_OUT_COUNT_CRY(11)
    );
  SEGMENT_OUT_COUNT_CRY_12_Q : X_MUX2
    port map (
      IA => SEGMENT_GND,
      IB => SEGMENT_OUT_COUNT_CRY(11),
      SEL => SEGMENT_OUT_COUNT_QXU(12),
      O => SEGMENT_OUT_COUNT_CRY_12_O
    );
  SEGMENT_OUT_COUNT_CRY_12_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_OUT_COUNT_CRY_12_O,
      O => SEGMENT_OUT_COUNT_CRY(12)
    );
  SEGMENT_OUT_COUNT_LM_0_0_Q : X_LUT3
    generic map (
      INIT => X"EF"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT_S(0),
      ADR1 => SEGMENT_STATE_0_10_Q,
      ADR2 => RESET_L_0,
      O => SEGMENT_OUT_COUNT_LM(0)
    );
  SEGMENT_OUT_COUNT_LM_0_1_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT_S(1),
      ADR1 => SEGMENT_STATE_0_10_Q,
      ADR2 => RESET_L_0,
      O => SEGMENT_OUT_COUNT_LM(1)
    );
  SEGMENT_OUT_COUNT_LM_0_2_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT_S(2),
      ADR1 => SEGMENT_STATE_0_10_Q,
      ADR2 => RESET_L_0,
      O => SEGMENT_OUT_COUNT_LM(2)
    );
  SEGMENT_OUT_COUNT_LM_0_3_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT_S(3),
      ADR1 => SEGMENT_STATE_0_10_Q,
      ADR2 => RESET_L_0,
      O => SEGMENT_OUT_COUNT_LM(3)
    );
  SEGMENT_OUT_COUNT_LM_0_4_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT_S(4),
      ADR1 => SEGMENT_STATE_0_10_Q,
      ADR2 => RESET_L_0,
      O => SEGMENT_OUT_COUNT_LM(4)
    );
  SEGMENT_OUT_COUNT_LM_0_5_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT_S(5),
      ADR1 => SEGMENT_STATE_0_10_Q,
      ADR2 => RESET_L_0,
      O => SEGMENT_OUT_COUNT_LM(5)
    );
  SEGMENT_OUT_COUNT_LM_0_6_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT_S(6),
      ADR1 => SEGMENT_STATE_0_10_Q,
      ADR2 => RESET_L_0,
      O => SEGMENT_OUT_COUNT_LM(6)
    );
  SEGMENT_OUT_COUNT_LM_0_7_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT_S(7),
      ADR1 => SEGMENT_STATE_0_10_Q,
      ADR2 => RESET_L_0,
      O => SEGMENT_OUT_COUNT_LM(7)
    );
  SEGMENT_OUT_COUNT_LM_0_8_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT_S(8),
      ADR1 => SEGMENT_STATE_0_10_Q,
      ADR2 => RESET_L_0,
      O => SEGMENT_OUT_COUNT_LM(8)
    );
  SEGMENT_OUT_COUNT_LM_0_9_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT_S(9),
      ADR1 => SEGMENT_STATE_0_10_Q,
      ADR2 => RESET_L_0,
      O => SEGMENT_OUT_COUNT_LM(9)
    );
  SEGMENT_OUT_COUNT_LM_0_10_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT_S(10),
      ADR1 => SEGMENT_STATE_0_10_Q,
      ADR2 => RESET_L_0,
      O => SEGMENT_OUT_COUNT_LM(10)
    );
  SEGMENT_OUT_COUNT_LM_0_11_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT_S(11),
      ADR1 => SEGMENT_STATE_0_10_Q,
      ADR2 => RESET_L_0,
      O => SEGMENT_OUT_COUNT_LM(11)
    );
  SEGMENT_OUT_COUNT_LM_0_12_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT_S(12),
      ADR1 => SEGMENT_STATE_0_10_Q,
      ADR2 => RESET_L_0,
      O => SEGMENT_OUT_COUNT_LM(12)
    );
  SEGMENT_OUT_COUNT_LM_0_13_Q : X_LUT3
    generic map (
      INIT => X"20"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT_S(13),
      ADR1 => SEGMENT_STATE_0_10_Q,
      ADR2 => RESET_L_0,
      O => SEGMENT_OUT_COUNT_LM(13)
    );
  SEGMENT_OUT_COUNT_QXU_0_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT(0),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_OUT_COUNT_QXU(0)
    );
  SEGMENT_OUT_COUNT_QXU_1_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT(1),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_OUT_COUNT_QXU(1)
    );
  SEGMENT_OUT_COUNT_QXU_2_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT(2),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_OUT_COUNT_QXU(2)
    );
  SEGMENT_OUT_COUNT_QXU_3_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT(3),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_OUT_COUNT_QXU(3)
    );
  SEGMENT_OUT_COUNT_QXU_4_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT(4),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_OUT_COUNT_QXU(4)
    );
  SEGMENT_OUT_COUNT_QXU_5_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT(5),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_OUT_COUNT_QXU(5)
    );
  SEGMENT_OUT_COUNT_QXU_6_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT(6),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_OUT_COUNT_QXU(6)
    );
  SEGMENT_OUT_COUNT_QXU_7_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT(7),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_OUT_COUNT_QXU(7)
    );
  SEGMENT_OUT_COUNT_QXU_8_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT(8),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_OUT_COUNT_QXU(8)
    );
  SEGMENT_OUT_COUNT_QXU_9_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT(9),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_OUT_COUNT_QXU(9)
    );
  SEGMENT_OUT_COUNT_QXU_10_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT(10),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_OUT_COUNT_QXU(10)
    );
  SEGMENT_OUT_COUNT_QXU_11_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT(11),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_OUT_COUNT_QXU(11)
    );
  SEGMENT_OUT_COUNT_QXU_12_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT(12),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_OUT_COUNT_QXU(12)
    );
  SEGMENT_OUT_COUNT_QXU_13_Q : X_LUT2
    generic map (
      INIT => X"6"
    )
    port map (
      ADR0 => SEGMENT_OUT_COUNT(13),
      ADR1 => SEGMENT_GND,
      O => SEGMENT_OUT_COUNT_QXU(13)
    );
  SEGMENT_OUT_COUNT_S_0_Q : X_XOR2
    port map (
      I0 => SEGMENT_OUT_COUNT_QXU(0),
      I1 => SEGMENT_VCC,
      O => SEGMENT_OUT_COUNT_S(0)
    );
  SEGMENT_OUT_COUNT_S_1_Q : X_XOR2
    port map (
      I0 => SEGMENT_OUT_COUNT_QXU(1),
      I1 => SEGMENT_OUT_COUNT_CRY(0),
      O => SEGMENT_OUT_COUNT_S(1)
    );
  SEGMENT_OUT_COUNT_S_2_Q : X_XOR2
    port map (
      I0 => SEGMENT_OUT_COUNT_QXU(2),
      I1 => SEGMENT_OUT_COUNT_CRY(1),
      O => SEGMENT_OUT_COUNT_S(2)
    );
  SEGMENT_OUT_COUNT_S_3_Q : X_XOR2
    port map (
      I0 => SEGMENT_OUT_COUNT_QXU(3),
      I1 => SEGMENT_OUT_COUNT_CRY(2),
      O => SEGMENT_OUT_COUNT_S(3)
    );
  SEGMENT_OUT_COUNT_S_4_Q : X_XOR2
    port map (
      I0 => SEGMENT_OUT_COUNT_QXU(4),
      I1 => SEGMENT_OUT_COUNT_CRY(3),
      O => SEGMENT_OUT_COUNT_S(4)
    );
  SEGMENT_OUT_COUNT_S_5_Q : X_XOR2
    port map (
      I0 => SEGMENT_OUT_COUNT_QXU(5),
      I1 => SEGMENT_OUT_COUNT_CRY(4),
      O => SEGMENT_OUT_COUNT_S(5)
    );
  SEGMENT_OUT_COUNT_S_6_Q : X_XOR2
    port map (
      I0 => SEGMENT_OUT_COUNT_QXU(6),
      I1 => SEGMENT_OUT_COUNT_CRY(5),
      O => SEGMENT_OUT_COUNT_S(6)
    );
  SEGMENT_OUT_COUNT_S_7_Q : X_XOR2
    port map (
      I0 => SEGMENT_OUT_COUNT_QXU(7),
      I1 => SEGMENT_OUT_COUNT_CRY(6),
      O => SEGMENT_OUT_COUNT_S(7)
    );
  SEGMENT_OUT_COUNT_S_8_Q : X_XOR2
    port map (
      I0 => SEGMENT_OUT_COUNT_QXU(8),
      I1 => SEGMENT_OUT_COUNT_CRY(7),
      O => SEGMENT_OUT_COUNT_S(8)
    );
  SEGMENT_OUT_COUNT_S_9_Q : X_XOR2
    port map (
      I0 => SEGMENT_OUT_COUNT_QXU(9),
      I1 => SEGMENT_OUT_COUNT_CRY(8),
      O => SEGMENT_OUT_COUNT_S(9)
    );
  SEGMENT_OUT_COUNT_S_10_Q : X_XOR2
    port map (
      I0 => SEGMENT_OUT_COUNT_QXU(10),
      I1 => SEGMENT_OUT_COUNT_CRY(9),
      O => SEGMENT_OUT_COUNT_S(10)
    );
  SEGMENT_OUT_COUNT_S_11_Q : X_XOR2
    port map (
      I0 => SEGMENT_OUT_COUNT_QXU(11),
      I1 => SEGMENT_OUT_COUNT_CRY(10),
      O => SEGMENT_OUT_COUNT_S(11)
    );
  SEGMENT_OUT_COUNT_S_12_Q : X_XOR2
    port map (
      I0 => SEGMENT_OUT_COUNT_QXU(12),
      I1 => SEGMENT_OUT_COUNT_CRY(11),
      O => SEGMENT_OUT_COUNT_S(12)
    );
  SEGMENT_OUT_COUNT_S_13_Q : X_XOR2
    port map (
      I0 => SEGMENT_OUT_COUNT_QXU(13),
      I1 => SEGMENT_OUT_COUNT_CRY(12),
      O => SEGMENT_OUT_COUNT_S(13)
    );
  SEGMENT_SOF_IN_445 : X_SFF
    port map (
      I => SOF_APPL_IN,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => SEGMENT_SOF_IN
    );
  SEGMENT_STATE_0_Q_446 : X_SFF
    port map (
      I => SEGMENT_STATE_0_1_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => SEGMENT_STATE_0_Q
    );
  SEGMENT_STATE_1_Q : X_SFF
    port map (
      I => G_788,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SEGMENT_G_790_0,
      O => SEGMENT_STATE_0_1_Q
    );
  SEGMENT_STATE_2_Q_447 : X_FF
    port map (
      I => SEGMENT_STATE_1_2_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_STATE_2_Q
    );
  SEGMENT_STATE_3_Q_448 : X_FF
    port map (
      I => SEGMENT_STATE_1_3_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_STATE_3_Q
    );
  SEGMENT_STATE_4_Q : X_SFF
    port map (
      I => RESET_L_0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SEGMENT_STATE_I_5_Q,
      O => SEGMENT_STATE_0_4_Q
    );
  SEGMENT_STATE_5_Q : X_SFF
    port map (
      I => G_795,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => SEGMENT_STATE_0_5_Q
    );
  SEGMENT_STATE_6_Q : X_SFF
    port map (
      I => RESET_L_0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SEGMENT_STATE_1_I_0_AND2(6),
      O => SEGMENT_STATE_0_6_Q
    );
  SEGMENT_STATE_7_Q : X_SFF
    port map (
      I => RESET_L_0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SEGMENT_STATE_I_8_Q,
      O => SEGMENT_STATE_0_7_Q
    );
  SEGMENT_STATE_8_Q : X_SFF
    port map (
      I => G_842,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => RESET_L_I,
      O => SEGMENT_STATE_0_8_Q
    );
  SEGMENT_STATE_9_Q_449 : X_FF
    port map (
      I => SEGMENT_STATE_1_9_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_STATE_9_Q
    );
  SEGMENT_STATE_10_Q : X_SFF
    port map (
      I => N_994_I,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => G_761_0,
      O => SEGMENT_STATE_0_10_Q
    );
  SEGMENT_STATE_11_Q_450 : X_SFF
    port map (
      I => G_793,
      CLK => CLK,
      CE => VCC,
      SET => GSR,
      RST => GND,
      SSET => RESET_L_I,
      SRST => GND,
      O => SEGMENT_STATE_11_Q
    );
  SEGMENT_STATE_1_0_0_2_Q : X_LUT4
    generic map (
      INIT => X"AAEA"
    )
    port map (
      ADR0 => SEGMENT_G_611,
      ADR1 => RESET_L_1,
      ADR2 => SEGMENT_STATE_0_4_Q,
      ADR3 => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL,
      O => SEGMENT_STATE_1_2_Q
    );
  SEGMENT_STATE_1_0_0_3_Q : X_LUT4
    generic map (
      INIT => X"F888"
    )
    port map (
      ADR0 => SEGMENT_G_104,
      ADR1 => SEGMENT_STATE_PROC_UN21_CFIFO_AVAIL_NE,
      ADR2 => SEGMENT_G_589,
      ADR3 => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL,
      O => SEGMENT_STATE_1_3_Q
    );
  SEGMENT_STATE_1_0_0_9_Q : X_LUT4
    generic map (
      INIT => X"FEEE"
    )
    port map (
      ADR0 => SEGMENT_STATE_1_0_0_AND2_0_9_Q,
      ADR1 => SEGMENT_STATE_1_0_0_AND2(9),
      ADR2 => SEGMENT_STATE_0_10_Q,
      ADR3 => RESET_L_1,
      O => SEGMENT_STATE_1_9_Q
    );
  SEGMENT_STATE_1_0_0_2_G_609 : X_LUT4
    generic map (
      INIT => X"AA82"
    )
    port map (
      ADR0 => SEGMENT_G_755_0,
      ADR1 => SEGMENT_CELL_COUNT(1),
      ADR2 => SEGMENT_CELL_COUNT(2),
      ADR3 => SEGMENT_G_786_0,
      O => SEGMENT_G_609
    );
  SEGMENT_STATE_1_0_0_2_G_611 : X_LUT4
    generic map (
      INIT => X"EEFE"
    )
    port map (
      ADR0 => SEGMENT_STATE_1_0_0_AND2_0_2_Q,
      ADR1 => SEGMENT_G_609,
      ADR2 => SEGMENT_G_104,
      ADR3 => SEGMENT_STATE_PROC_UN21_CFIFO_AVAIL_NE,
      O => SEGMENT_G_611
    );
  SEGMENT_STATE_1_0_0_AND2_9_Q : X_LUT4
    generic map (
      INIT => X"0200"
    )
    port map (
      ADR0 => SEGMENT_G_39,
      ADR1 => SEGMENT_G_786_0,
      ADR2 => SEGMENT_CELL_COUNT(1),
      ADR3 => SEGMENT_CELL_COUNT(2),
      O => SEGMENT_STATE_1_0_0_AND2(9)
    );
  SEGMENT_STATE_1_0_0_AND2_0_2_Q_451 : X_LUT4
    generic map (
      INIT => X"0400"
    )
    port map (
      ADR0 => SEGMENT_STATE_PROC_UN21_CFIFO_AVAIL_NE,
      ADR1 => SEGMENT_CFIFO_AVAIL,
      ADR2 => SEGMENT_G_846,
      ADR3 => RESET_L_1,
      O => SEGMENT_STATE_1_0_0_AND2_0_2_Q
    );
  SEGMENT_STATE_1_0_0_AND2_0_9_Q_452 : X_LUT3
    generic map (
      INIT => X"80"
    )
    port map (
      ADR0 => SEGMENT_G_844_Q_O0,
      ADR1 => SEGMENT_STATE_9_Q,
      ADR2 => RESET_L_1,
      O => SEGMENT_STATE_1_0_0_AND2_0_9_Q
    );
  SEGMENT_STATE_1_0_0_AND2_0_3_G_589 : X_LUT2
    generic map (
      INIT => X"8"
    )
    port map (
      ADR0 => SEGMENT_STATE_0_4_Q,
      ADR1 => RESET_L_1,
      O => SEGMENT_G_589
    );
  SEGMENT_STATE_1_0_0_AND2_1_2_G_104 : X_LUT3
    generic map (
      INIT => X"80"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => SEGMENT_G_790_0,
      ADR2 => SEGMENT_STATE_3_Q,
      O => SEGMENT_G_104
    );
  SEGMENT_STATE_1_0_0_AND2_9_G_39 : X_LUT3
    generic map (
      INIT => X"A8"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => SEGMENT_STATE_2_Q,
      ADR2 => SEGMENT_STATE_0_6_Q,
      O => SEGMENT_G_39
    );
  SEGMENT_STATE_1_I_0_AND2_6_Q : X_LUT4
    generic map (
      INIT => X"4544"
    )
    port map (
      ADR0 => SEGMENT_STATE_0_7_Q,
      ADR1 => SEGMENT_G_846,
      ADR2 => SEGMENT_STATE_PROC_UN21_CFIFO_AVAIL_NE,
      ADR3 => SEGMENT_CFIFO_AVAIL,
      O => SEGMENT_STATE_1_I_0_AND2(6)
    );
  SEGMENT_STATE_1_I_I_AND2_Q_G_7 : X_LUT3
    generic map (
      INIT => X"35"
    )
    port map (
      ADR0 => G_18_0_AND2,
      ADR1 => SEGMENT_G_767_Q_O2,
      ADR2 => G_27_0_AND2,
      O => SEGMENT_STATE_1_I_I_AND2_Q_G_7_O
    );
  SEGMENT_STATE_1_I_I_AND2_Q_G_7_LUT3_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_1_I_I_AND2_Q_G_7_O,
      O => SEGMENT_STATE_1_I_I_AND2_Q_O2
    );
  SEGMENT_STATE_I_5_Q_453 : X_INV
    port map (
      I => SEGMENT_STATE_0_5_Q,
      O => SEGMENT_STATE_I_5_Q
    );
  SEGMENT_STATE_I_8_Q_454 : X_INV
    port map (
      I => SEGMENT_STATE_0_8_Q,
      O => SEGMENT_STATE_I_8_Q
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_0_455 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(0),
      IB => SEGMENT_GND,
      SEL => SEGMENT_G_814_0,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_0_O
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_0_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_0_O,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_0
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_1_456 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(1),
      IB => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_0,
      SEL => SEGMENT_G_841_0,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_1_O
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_1_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_1_O,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_1
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_2_457 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(2),
      IB => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_1,
      SEL => SEGMENT_G_840_0,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_2_O
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_2_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_2_O,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_2
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_3_458 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(3),
      IB => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_2,
      SEL => SEGMENT_G_813_0,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_3_O
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_3_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_3_O,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_3
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_4_459 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(4),
      IB => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_3,
      SEL => SEGMENT_G_839_0,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_4_O
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_4_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_4_O,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_4
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_5_460 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(5),
      IB => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_4,
      SEL => SEGMENT_G_838_0,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_5_O
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_5_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_5_O,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_5
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_6_461 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(6),
      IB => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_5,
      SEL => SEGMENT_G_837_0,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_6_O
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_6_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_6_O,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_6
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_7_462 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(7),
      IB => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_6,
      SEL => SEGMENT_G_836_0,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_7_O
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_7_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_7_O,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_7
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_8_463 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(8),
      IB => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_7,
      SEL => SEGMENT_G_835_0,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_8_O
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_8_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_8_O,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_8
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_9_464 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(9),
      IB => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_8,
      SEL => SEGMENT_G_834_0,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_9_O
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_9_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_9_O,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_9
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_10_465 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(10),
      IB => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_9,
      SEL => SEGMENT_G_833_0,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_10_O
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_10_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_10_O,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_10
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_11_466 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(11),
      IB => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_10,
      SEL => SEGMENT_G_832_0,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_11_O
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_11_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_11_O,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_11
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_12_467 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(12),
      IB => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_11,
      SEL => SEGMENT_G_831_0,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_12_O
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_12_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_12_O,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_12
    );
  SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_13 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(13),
      IB => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL_CRY_12,
      SEL => SEGMENT_G_830_0,
      O => SEGMENT_STATE_PROC_UN7_CFIFO_AVAIL
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_0_468 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(0),
      IB => SEGMENT_VCC,
      SEL => SEGMENT_N_862_I,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_0_O
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_0_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_0_O,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_0
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_1_469 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(1),
      IB => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_0,
      SEL => SEGMENT_N_869_I,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_1_O
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_1_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_1_O,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_1
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_2_470 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(2),
      IB => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_1,
      SEL => SEGMENT_N_870_I,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_2_O
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_2_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_2_O,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_2
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_3_471 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(3),
      IB => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_2,
      SEL => SEGMENT_N_863_I,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_3_O
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_3_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_3_O,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_3
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_4_472 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(4),
      IB => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_3,
      SEL => SEGMENT_N_871_I,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_4_O
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_4_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_4_O,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_4
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_5_473 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(5),
      IB => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_4,
      SEL => SEGMENT_N_872_I,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_5_O
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_5_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_5_O,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_5
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_6_474 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(6),
      IB => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_5,
      SEL => SEGMENT_N_873_I,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_6_O
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_6_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_6_O,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_6
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_7_475 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(7),
      IB => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_6,
      SEL => SEGMENT_N_874_I,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_7_O
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_7_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_7_O,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_7
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_8_476 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(8),
      IB => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_7,
      SEL => SEGMENT_N_875_I,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_8_O
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_8_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_8_O,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_8
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_9_477 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(9),
      IB => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_8,
      SEL => SEGMENT_N_876_I,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_9_O
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_9_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_9_O,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_9
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_10_478 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(10),
      IB => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_9,
      SEL => SEGMENT_N_877_I,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_10_O
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_10_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_10_O,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_10
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_11_479 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(11),
      IB => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_10,
      SEL => SEGMENT_N_878_I,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_11_O
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_11_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_11_O,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_11
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_12_480 : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_OUT(12),
      IB => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_11,
      SEL => SEGMENT_N_879_I,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_12_O
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_12_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_12_O,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_12
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_S_1 : X_XOR2
    port map (
      I0 => SEGMENT_N_869_I,
      I1 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_0,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(1)
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_S_2 : X_XOR2
    port map (
      I0 => SEGMENT_N_870_I,
      I1 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_1,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(2)
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_S_3 : X_XOR2
    port map (
      I0 => SEGMENT_N_863_I,
      I1 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_2,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(3)
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_S_4 : X_XOR2
    port map (
      I0 => SEGMENT_N_871_I,
      I1 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_3,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(4)
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_S_5 : X_XOR2
    port map (
      I0 => SEGMENT_N_872_I,
      I1 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_4,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(5)
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_S_6 : X_XOR2
    port map (
      I0 => SEGMENT_N_873_I,
      I1 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_5,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(6)
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_S_7 : X_XOR2
    port map (
      I0 => SEGMENT_N_874_I,
      I1 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_6,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(7)
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_S_8 : X_XOR2
    port map (
      I0 => SEGMENT_N_875_I,
      I1 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_7,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(8)
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_S_9 : X_XOR2
    port map (
      I0 => SEGMENT_N_876_I,
      I1 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_8,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(9)
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_S_10 : X_XOR2
    port map (
      I0 => SEGMENT_N_877_I,
      I1 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_9,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(10)
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_S_11 : X_XOR2
    port map (
      I0 => SEGMENT_N_878_I,
      I1 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_10,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(11)
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_S_12 : X_XOR2
    port map (
      I0 => SEGMENT_N_879_I,
      I1 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_11,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(12)
    );
  SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_S_13 : X_XOR2
    port map (
      I0 => SEGMENT_N_880_I,
      I1 => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL_CRY_12,
      O => SEGMENT_STATE_PROC_UN10_CFIFO_AVAIL(13)
    );
  SEGMENT_STATE_PROC_UN21_CFIFO_AVAIL_NE_481 : X_LUT4
    generic map (
      INIT => X"FFFE"
    )
    port map (
      ADR0 => SEGMENT_G_50,
      ADR1 => SEGMENT_G_41,
      ADR2 => SEGMENT_G_48,
      ADR3 => SEGMENT_G_49,
      O => SEGMENT_STATE_PROC_UN21_CFIFO_AVAIL_NE
    );
  SEGMENT_STATE_PROC_UN21_CFIFO_AVAIL_NE_G_41 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_OUT(13),
      ADR1 => SEGMENT_OUT_COUNT(13),
      ADR2 => SEGMENT_CFIFO_OUT(12),
      ADR3 => SEGMENT_OUT_COUNT(12),
      O => SEGMENT_G_41
    );
  SEGMENT_STATE_PROC_UN21_CFIFO_AVAIL_NE_G_48 : X_LUT4
    generic map (
      INIT => X"7FFF"
    )
    port map (
      ADR0 => SEGMENT_G_814_0,
      ADR1 => SEGMENT_G_841_0,
      ADR2 => SEGMENT_G_840_0,
      ADR3 => SEGMENT_G_813_0,
      O => SEGMENT_G_48
    );
  SEGMENT_STATE_PROC_UN21_CFIFO_AVAIL_NE_G_49 : X_LUT4
    generic map (
      INIT => X"7FFF"
    )
    port map (
      ADR0 => SEGMENT_G_839_0,
      ADR1 => SEGMENT_G_838_0,
      ADR2 => SEGMENT_G_837_0,
      ADR3 => SEGMENT_G_836_0,
      O => SEGMENT_G_49
    );
  SEGMENT_STATE_PROC_UN21_CFIFO_AVAIL_NE_G_50 : X_LUT4
    generic map (
      INIT => X"7FFF"
    )
    port map (
      ADR0 => SEGMENT_G_835_0,
      ADR1 => SEGMENT_G_834_0,
      ADR2 => SEGMENT_G_833_0,
      ADR3 => SEGMENT_G_832_0,
      O => SEGMENT_G_50
    );
  SEGMENT_CFIFO_N_893_I_482 : X_LUT3
    generic map (
      INIT => X"95"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_HEAD_0(1),
      ADR1 => SEGMENT_HEAD(0),
      ADR2 => SEGMENT_EOF_DELAY0,
      O => SEGMENT_CFIFO_N_893_I
    );
  SEGMENT_CFIFO_DATA_BUF_0_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT(0),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_DATA_BUF(0)
    );
  SEGMENT_CFIFO_DATA_BUF_1_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT(1),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_DATA_BUF(1)
    );
  SEGMENT_CFIFO_DATA_BUF_2_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT(2),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_DATA_BUF(2)
    );
  SEGMENT_CFIFO_DATA_BUF_3_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT(3),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_DATA_BUF(3)
    );
  SEGMENT_CFIFO_DATA_BUF_4_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT(4),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_DATA_BUF(4)
    );
  SEGMENT_CFIFO_DATA_BUF_5_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT(5),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_DATA_BUF(5)
    );
  SEGMENT_CFIFO_DATA_BUF_6_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT(6),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_DATA_BUF(6)
    );
  SEGMENT_CFIFO_DATA_BUF_7_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT(7),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_DATA_BUF(7)
    );
  SEGMENT_CFIFO_DATA_BUF_8_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT(8),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_DATA_BUF(8)
    );
  SEGMENT_CFIFO_DATA_BUF_9_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT(9),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_DATA_BUF(9)
    );
  SEGMENT_CFIFO_DATA_BUF_10_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT(10),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_DATA_BUF(10)
    );
  SEGMENT_CFIFO_DATA_BUF_11_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT(11),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_DATA_BUF(11)
    );
  SEGMENT_CFIFO_DATA_BUF_12_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT(12),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_DATA_BUF(12)
    );
  SEGMENT_CFIFO_DATA_BUF_13_Q : X_FF
    port map (
      I => SEGMENT_IN_COUNT(13),
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_DATA_BUF(13)
    );
  SEGMENT_CFIFO_DATA_OUT_3_0_Q : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_DATA_OUT_3_AM(0),
      IB => SEGMENT_CFIFO_DATA_OUT_3_BM(0),
      SEL => SEGMENT_TAIL(1),
      O => SEGMENT_CFIFO_OUT_W(0)
    );
  SEGMENT_CFIFO_DATA_OUT_3_1_Q : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_DATA_OUT_3_AM(1),
      IB => SEGMENT_CFIFO_DATA_OUT_3_BM(1),
      SEL => SEGMENT_TAIL(1),
      O => SEGMENT_CFIFO_OUT_W(1)
    );
  SEGMENT_CFIFO_DATA_OUT_3_2_Q : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_DATA_OUT_3_AM(2),
      IB => SEGMENT_CFIFO_DATA_OUT_3_BM(2),
      SEL => SEGMENT_TAIL(1),
      O => SEGMENT_CFIFO_OUT_W(2)
    );
  SEGMENT_CFIFO_DATA_OUT_3_3_Q : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_DATA_OUT_3_AM(3),
      IB => SEGMENT_CFIFO_DATA_OUT_3_BM(3),
      SEL => SEGMENT_TAIL(1),
      O => SEGMENT_CFIFO_OUT_W(3)
    );
  SEGMENT_CFIFO_DATA_OUT_3_4_Q : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_DATA_OUT_3_AM(4),
      IB => SEGMENT_CFIFO_DATA_OUT_3_BM(4),
      SEL => SEGMENT_TAIL(1),
      O => SEGMENT_CFIFO_OUT_W(4)
    );
  SEGMENT_CFIFO_DATA_OUT_3_5_Q : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_DATA_OUT_3_AM(5),
      IB => SEGMENT_CFIFO_DATA_OUT_3_BM(5),
      SEL => SEGMENT_TAIL(1),
      O => SEGMENT_CFIFO_OUT_W(5)
    );
  SEGMENT_CFIFO_DATA_OUT_3_6_Q : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_DATA_OUT_3_AM(6),
      IB => SEGMENT_CFIFO_DATA_OUT_3_BM(6),
      SEL => SEGMENT_TAIL(1),
      O => SEGMENT_CFIFO_OUT_W(6)
    );
  SEGMENT_CFIFO_DATA_OUT_3_7_Q : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_DATA_OUT_3_AM(7),
      IB => SEGMENT_CFIFO_DATA_OUT_3_BM(7),
      SEL => SEGMENT_TAIL(0),
      O => SEGMENT_CFIFO_OUT_W(7)
    );
  SEGMENT_CFIFO_DATA_OUT_3_8_Q : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_DATA_OUT_3_AM(8),
      IB => SEGMENT_CFIFO_DATA_OUT_3_BM(8),
      SEL => SEGMENT_TAIL(0),
      O => SEGMENT_CFIFO_OUT_W(8)
    );
  SEGMENT_CFIFO_DATA_OUT_3_9_Q : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_DATA_OUT_3_AM(9),
      IB => SEGMENT_CFIFO_DATA_OUT_3_BM(9),
      SEL => SEGMENT_TAIL(0),
      O => SEGMENT_CFIFO_OUT_W(9)
    );
  SEGMENT_CFIFO_DATA_OUT_3_10_Q : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_DATA_OUT_3_AM(10),
      IB => SEGMENT_CFIFO_DATA_OUT_3_BM(10),
      SEL => SEGMENT_TAIL(0),
      O => SEGMENT_CFIFO_OUT_W(10)
    );
  SEGMENT_CFIFO_DATA_OUT_3_11_Q : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_DATA_OUT_3_AM(11),
      IB => SEGMENT_CFIFO_DATA_OUT_3_BM(11),
      SEL => SEGMENT_TAIL(0),
      O => SEGMENT_CFIFO_OUT_W(11)
    );
  SEGMENT_CFIFO_DATA_OUT_3_12_Q : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_DATA_OUT_3_AM(12),
      IB => SEGMENT_CFIFO_DATA_OUT_3_BM(12),
      SEL => SEGMENT_TAIL(0),
      O => SEGMENT_CFIFO_OUT_W(12)
    );
  SEGMENT_CFIFO_DATA_OUT_3_13_Q : X_MUX2
    port map (
      IA => SEGMENT_CFIFO_DATA_OUT_3_AM(13),
      IB => SEGMENT_CFIFO_DATA_OUT_3_BM(13),
      SEL => SEGMENT_TAIL(0),
      O => SEGMENT_CFIFO_OUT_W(13)
    );
  SEGMENT_CFIFO_DATA_OUT_3_AM_0_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(0),
      ADR1 => SEGMENT_CFIFO_FIFO_1(0),
      ADR2 => SEGMENT_CFIFO_FIFO_0(0),
      O => SEGMENT_CFIFO_DATA_OUT_3_AM(0)
    );
  SEGMENT_CFIFO_DATA_OUT_3_AM_1_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(0),
      ADR1 => SEGMENT_CFIFO_FIFO_1(1),
      ADR2 => SEGMENT_CFIFO_FIFO_0(1),
      O => SEGMENT_CFIFO_DATA_OUT_3_AM(1)
    );
  SEGMENT_CFIFO_DATA_OUT_3_AM_2_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(0),
      ADR1 => SEGMENT_CFIFO_FIFO_1(2),
      ADR2 => SEGMENT_CFIFO_FIFO_0(2),
      O => SEGMENT_CFIFO_DATA_OUT_3_AM(2)
    );
  SEGMENT_CFIFO_DATA_OUT_3_AM_3_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(0),
      ADR1 => SEGMENT_CFIFO_FIFO_1(3),
      ADR2 => SEGMENT_CFIFO_FIFO_0(3),
      O => SEGMENT_CFIFO_DATA_OUT_3_AM(3)
    );
  SEGMENT_CFIFO_DATA_OUT_3_AM_4_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(0),
      ADR1 => SEGMENT_CFIFO_FIFO_1(4),
      ADR2 => SEGMENT_CFIFO_FIFO_0(4),
      O => SEGMENT_CFIFO_DATA_OUT_3_AM(4)
    );
  SEGMENT_CFIFO_DATA_OUT_3_AM_5_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(0),
      ADR1 => SEGMENT_CFIFO_FIFO_1(5),
      ADR2 => SEGMENT_CFIFO_FIFO_0(5),
      O => SEGMENT_CFIFO_DATA_OUT_3_AM(5)
    );
  SEGMENT_CFIFO_DATA_OUT_3_AM_6_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(0),
      ADR1 => SEGMENT_CFIFO_FIFO_1(6),
      ADR2 => SEGMENT_CFIFO_FIFO_0(6),
      O => SEGMENT_CFIFO_DATA_OUT_3_AM(6)
    );
  SEGMENT_CFIFO_DATA_OUT_3_AM_7_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(1),
      ADR1 => SEGMENT_CFIFO_FIFO_2(7),
      ADR2 => SEGMENT_CFIFO_FIFO_0(7),
      O => SEGMENT_CFIFO_DATA_OUT_3_AM(7)
    );
  SEGMENT_CFIFO_DATA_OUT_3_AM_8_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(1),
      ADR1 => SEGMENT_CFIFO_FIFO_2(8),
      ADR2 => SEGMENT_CFIFO_FIFO_0(8),
      O => SEGMENT_CFIFO_DATA_OUT_3_AM(8)
    );
  SEGMENT_CFIFO_DATA_OUT_3_AM_9_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(1),
      ADR1 => SEGMENT_CFIFO_FIFO_2(9),
      ADR2 => SEGMENT_CFIFO_FIFO_0(9),
      O => SEGMENT_CFIFO_DATA_OUT_3_AM(9)
    );
  SEGMENT_CFIFO_DATA_OUT_3_AM_10_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(1),
      ADR1 => SEGMENT_CFIFO_FIFO_2(10),
      ADR2 => SEGMENT_CFIFO_FIFO_0(10),
      O => SEGMENT_CFIFO_DATA_OUT_3_AM(10)
    );
  SEGMENT_CFIFO_DATA_OUT_3_AM_11_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(1),
      ADR1 => SEGMENT_CFIFO_FIFO_2(11),
      ADR2 => SEGMENT_CFIFO_FIFO_0(11),
      O => SEGMENT_CFIFO_DATA_OUT_3_AM(11)
    );
  SEGMENT_CFIFO_DATA_OUT_3_AM_12_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(1),
      ADR1 => SEGMENT_CFIFO_FIFO_2(12),
      ADR2 => SEGMENT_CFIFO_FIFO_0(12),
      O => SEGMENT_CFIFO_DATA_OUT_3_AM(12)
    );
  SEGMENT_CFIFO_DATA_OUT_3_AM_13_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(1),
      ADR1 => SEGMENT_CFIFO_FIFO_2(13),
      ADR2 => SEGMENT_CFIFO_FIFO_0(13),
      O => SEGMENT_CFIFO_DATA_OUT_3_AM(13)
    );
  SEGMENT_CFIFO_DATA_OUT_3_BM_0_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(0),
      ADR1 => SEGMENT_CFIFO_FIFO_3(0),
      ADR2 => SEGMENT_CFIFO_FIFO_2(0),
      O => SEGMENT_CFIFO_DATA_OUT_3_BM(0)
    );
  SEGMENT_CFIFO_DATA_OUT_3_BM_1_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(0),
      ADR1 => SEGMENT_CFIFO_FIFO_3(1),
      ADR2 => SEGMENT_CFIFO_FIFO_2(1),
      O => SEGMENT_CFIFO_DATA_OUT_3_BM(1)
    );
  SEGMENT_CFIFO_DATA_OUT_3_BM_2_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(0),
      ADR1 => SEGMENT_CFIFO_FIFO_3(2),
      ADR2 => SEGMENT_CFIFO_FIFO_2(2),
      O => SEGMENT_CFIFO_DATA_OUT_3_BM(2)
    );
  SEGMENT_CFIFO_DATA_OUT_3_BM_3_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(0),
      ADR1 => SEGMENT_CFIFO_FIFO_3(3),
      ADR2 => SEGMENT_CFIFO_FIFO_2(3),
      O => SEGMENT_CFIFO_DATA_OUT_3_BM(3)
    );
  SEGMENT_CFIFO_DATA_OUT_3_BM_4_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(0),
      ADR1 => SEGMENT_CFIFO_FIFO_3(4),
      ADR2 => SEGMENT_CFIFO_FIFO_2(4),
      O => SEGMENT_CFIFO_DATA_OUT_3_BM(4)
    );
  SEGMENT_CFIFO_DATA_OUT_3_BM_5_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(0),
      ADR1 => SEGMENT_CFIFO_FIFO_3(5),
      ADR2 => SEGMENT_CFIFO_FIFO_2(5),
      O => SEGMENT_CFIFO_DATA_OUT_3_BM(5)
    );
  SEGMENT_CFIFO_DATA_OUT_3_BM_6_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(0),
      ADR1 => SEGMENT_CFIFO_FIFO_3(6),
      ADR2 => SEGMENT_CFIFO_FIFO_2(6),
      O => SEGMENT_CFIFO_DATA_OUT_3_BM(6)
    );
  SEGMENT_CFIFO_DATA_OUT_3_BM_7_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(1),
      ADR1 => SEGMENT_CFIFO_FIFO_3(7),
      ADR2 => SEGMENT_CFIFO_FIFO_1(7),
      O => SEGMENT_CFIFO_DATA_OUT_3_BM(7)
    );
  SEGMENT_CFIFO_DATA_OUT_3_BM_8_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(1),
      ADR1 => SEGMENT_CFIFO_FIFO_3(8),
      ADR2 => SEGMENT_CFIFO_FIFO_1(8),
      O => SEGMENT_CFIFO_DATA_OUT_3_BM(8)
    );
  SEGMENT_CFIFO_DATA_OUT_3_BM_9_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(1),
      ADR1 => SEGMENT_CFIFO_FIFO_3(9),
      ADR2 => SEGMENT_CFIFO_FIFO_1(9),
      O => SEGMENT_CFIFO_DATA_OUT_3_BM(9)
    );
  SEGMENT_CFIFO_DATA_OUT_3_BM_10_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(1),
      ADR1 => SEGMENT_CFIFO_FIFO_3(10),
      ADR2 => SEGMENT_CFIFO_FIFO_1(10),
      O => SEGMENT_CFIFO_DATA_OUT_3_BM(10)
    );
  SEGMENT_CFIFO_DATA_OUT_3_BM_11_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(1),
      ADR1 => SEGMENT_CFIFO_FIFO_3(11),
      ADR2 => SEGMENT_CFIFO_FIFO_1(11),
      O => SEGMENT_CFIFO_DATA_OUT_3_BM(11)
    );
  SEGMENT_CFIFO_DATA_OUT_3_BM_12_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(1),
      ADR1 => SEGMENT_CFIFO_FIFO_3(12),
      ADR2 => SEGMENT_CFIFO_FIFO_1(12),
      O => SEGMENT_CFIFO_DATA_OUT_3_BM(12)
    );
  SEGMENT_CFIFO_DATA_OUT_3_BM_13_Q : X_LUT3
    generic map (
      INIT => X"D8"
    )
    port map (
      ADR0 => SEGMENT_TAIL(1),
      ADR1 => SEGMENT_CFIFO_FIFO_3(13),
      ADR2 => SEGMENT_CFIFO_FIFO_1(13),
      O => SEGMENT_CFIFO_DATA_OUT_3_BM(13)
    );
  SEGMENT_CFIFO_FIFO_0_0_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(0),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_3_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_0(0)
    );
  SEGMENT_CFIFO_FIFO_0_1_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(1),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_3_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_0(1)
    );
  SEGMENT_CFIFO_FIFO_0_2_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(2),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_3_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_0(2)
    );
  SEGMENT_CFIFO_FIFO_0_3_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(3),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_3_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_0(3)
    );
  SEGMENT_CFIFO_FIFO_0_4_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(4),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_3_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_0(4)
    );
  SEGMENT_CFIFO_FIFO_0_5_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(5),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_3_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_0(5)
    );
  SEGMENT_CFIFO_FIFO_0_6_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(6),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_3_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_0(6)
    );
  SEGMENT_CFIFO_FIFO_0_7_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(7),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_3_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_0(7)
    );
  SEGMENT_CFIFO_FIFO_0_8_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(8),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_3_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_0(8)
    );
  SEGMENT_CFIFO_FIFO_0_9_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(9),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_3_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_0(9)
    );
  SEGMENT_CFIFO_FIFO_0_10_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(10),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_3_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_0(10)
    );
  SEGMENT_CFIFO_FIFO_0_11_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(11),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_3_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_0(11)
    );
  SEGMENT_CFIFO_FIFO_0_12_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(12),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_3_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_0(12)
    );
  SEGMENT_CFIFO_FIFO_0_13_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(13),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_3_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_0(13)
    );
  SEGMENT_CFIFO_FIFO_1_0_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(0),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_1_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_1(0)
    );
  SEGMENT_CFIFO_FIFO_1_1_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(1),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_1_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_1(1)
    );
  SEGMENT_CFIFO_FIFO_1_2_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(2),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_1_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_1(2)
    );
  SEGMENT_CFIFO_FIFO_1_3_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(3),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_1_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_1(3)
    );
  SEGMENT_CFIFO_FIFO_1_4_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(4),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_1_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_1(4)
    );
  SEGMENT_CFIFO_FIFO_1_5_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(5),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_1_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_1(5)
    );
  SEGMENT_CFIFO_FIFO_1_6_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(6),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_1_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_1(6)
    );
  SEGMENT_CFIFO_FIFO_1_7_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(7),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_1_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_1(7)
    );
  SEGMENT_CFIFO_FIFO_1_8_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(8),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_1_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_1(8)
    );
  SEGMENT_CFIFO_FIFO_1_9_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(9),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_1_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_1(9)
    );
  SEGMENT_CFIFO_FIFO_1_10_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(10),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_1_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_1(10)
    );
  SEGMENT_CFIFO_FIFO_1_11_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(11),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_1_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_1(11)
    );
  SEGMENT_CFIFO_FIFO_1_12_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(12),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_1_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_1(12)
    );
  SEGMENT_CFIFO_FIFO_1_13_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(13),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_1_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_1(13)
    );
  SEGMENT_CFIFO_FIFO_2_0_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(0),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_2_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_2(0)
    );
  SEGMENT_CFIFO_FIFO_2_1_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(1),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_2_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_2(1)
    );
  SEGMENT_CFIFO_FIFO_2_2_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(2),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_2_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_2(2)
    );
  SEGMENT_CFIFO_FIFO_2_3_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(3),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_2_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_2(3)
    );
  SEGMENT_CFIFO_FIFO_2_4_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(4),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_2_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_2(4)
    );
  SEGMENT_CFIFO_FIFO_2_5_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(5),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_2_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_2(5)
    );
  SEGMENT_CFIFO_FIFO_2_6_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(6),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_2_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_2(6)
    );
  SEGMENT_CFIFO_FIFO_2_7_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(7),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_2_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_2(7)
    );
  SEGMENT_CFIFO_FIFO_2_8_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(8),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_2_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_2(8)
    );
  SEGMENT_CFIFO_FIFO_2_9_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(9),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_2_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_2(9)
    );
  SEGMENT_CFIFO_FIFO_2_10_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(10),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_2_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_2(10)
    );
  SEGMENT_CFIFO_FIFO_2_11_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(11),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_2_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_2(11)
    );
  SEGMENT_CFIFO_FIFO_2_12_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(12),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_2_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_2(12)
    );
  SEGMENT_CFIFO_FIFO_2_13_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(13),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_2_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_2(13)
    );
  SEGMENT_CFIFO_FIFO_3_0_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(0),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_4_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_3(0)
    );
  SEGMENT_CFIFO_FIFO_3_1_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(1),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_4_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_3(1)
    );
  SEGMENT_CFIFO_FIFO_3_2_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(2),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_4_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_3(2)
    );
  SEGMENT_CFIFO_FIFO_3_3_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(3),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_4_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_3(3)
    );
  SEGMENT_CFIFO_FIFO_3_4_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(4),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_4_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_3(4)
    );
  SEGMENT_CFIFO_FIFO_3_5_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(5),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_4_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_3(5)
    );
  SEGMENT_CFIFO_FIFO_3_6_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(6),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_4_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_3(6)
    );
  SEGMENT_CFIFO_FIFO_3_7_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(7),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_4_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_3(7)
    );
  SEGMENT_CFIFO_FIFO_3_8_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(8),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_4_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_3(8)
    );
  SEGMENT_CFIFO_FIFO_3_9_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(9),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_4_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_3(9)
    );
  SEGMENT_CFIFO_FIFO_3_10_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(10),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_4_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_3(10)
    );
  SEGMENT_CFIFO_FIFO_3_11_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(11),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_4_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_3(11)
    );
  SEGMENT_CFIFO_FIFO_3_12_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(12),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_4_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_3(12)
    );
  SEGMENT_CFIFO_FIFO_3_13_Q : X_FF
    port map (
      I => SEGMENT_CFIFO_DATA_BUF(13),
      CLK => CLK,
      CE => SEGMENT_CFIFO_UN1_RESET_L_4_0_AND3_0_AND2_0_AND2,
      SET => GND,
      RST => GSR,
      O => SEGMENT_CFIFO_FIFO_3(13)
    );
  SEGMENT_CFIFO_HEAD_0_Q : X_SFF
    port map (
      I => RESET_L_0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SEGMENT_G_808_0,
      O => SEGMENT_HEAD(0)
    );
  SEGMENT_CFIFO_HEAD_1_Q : X_SFF
    port map (
      I => RESET_L_0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SEGMENT_CFIFO_N_893_I,
      O => SEGMENT_CFIFO_HEAD_0(1)
    );
  SEGMENT_CFIFO_RDDONE_BUF : X_FF
    port map (
      I => SEGMENT_STATE_0_Q,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      O => SEGMENT_RDDONE_BUF
    );
  SEGMENT_CFIFO_TAIL_0_Q : X_SFF
    port map (
      I => RESET_L_0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SEGMENT_G_809_0,
      O => SEGMENT_TAIL(0)
    );
  SEGMENT_CFIFO_TAIL_1_Q : X_SFF
    port map (
      I => RESET_L_0,
      CLK => CLK,
      CE => VCC,
      SET => GND,
      RST => GSR,
      SSET => GND,
      SRST => SEGMENT_N_894_I,
      O => SEGMENT_TAIL(1)
    );
  SEGMENT_CFIFO_UN1_RESET_L_1_0_AND3_0_AND2_0_AND2_483 : X_LUT4
    generic map (
      INIT => X"2000"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => SEGMENT_CFIFO_HEAD_0(1),
      ADR2 => SEGMENT_HEAD(0),
      ADR3 => SEGMENT_EOF_DELAY0,
      O => SEGMENT_CFIFO_UN1_RESET_L_1_0_AND3_0_AND2_0_AND2
    );
  SEGMENT_CFIFO_UN1_RESET_L_2_0_AND3_0_AND2_0_AND2_484 : X_LUT4
    generic map (
      INIT => X"0800"
    )
    port map (
      ADR0 => SEGMENT_CFIFO_HEAD_0(1),
      ADR1 => RESET_L_1,
      ADR2 => SEGMENT_HEAD(0),
      ADR3 => SEGMENT_EOF_DELAY0,
      O => SEGMENT_CFIFO_UN1_RESET_L_2_0_AND3_0_AND2_0_AND2
    );
  SEGMENT_CFIFO_UN1_RESET_L_3_0_AND3_0_AND2_0_AND2_485 : X_LUT4
    generic map (
      INIT => X"0200"
    )
    port map (
      ADR0 => RESET_L_1,
      ADR1 => SEGMENT_CFIFO_HEAD_0(1),
      ADR2 => SEGMENT_HEAD(0),
      ADR3 => SEGMENT_EOF_DELAY0,
      O => SEGMENT_CFIFO_UN1_RESET_L_3_0_AND3_0_AND2_0_AND2
    );
  SEGMENT_CFIFO_UN1_RESET_L_4_0_AND3_0_AND2_0_AND2_486 : X_LUT4
    generic map (
      INIT => X"8000"
    )
    port map (
      ADR0 => SEGMENT_HEAD(0),
      ADR1 => SEGMENT_EOF_DELAY0,
      ADR2 => SEGMENT_CFIFO_HEAD_0(1),
      ADR3 => RESET_L_1,
      O => SEGMENT_CFIFO_UN1_RESET_L_4_0_AND3_0_AND2_0_AND2
    );
  SEGMENT_CFIFO_UN2_DATA_AVAIL_NE_0_0_0 : X_LUT4
    generic map (
      INIT => X"6FF6"
    )
    port map (
      ADR0 => SEGMENT_HEAD(0),
      ADR1 => SEGMENT_TAIL(0),
      ADR2 => SEGMENT_TAIL(1),
      ADR3 => SEGMENT_CFIFO_HEAD_0(1),
      O => SEGMENT_CFIFO_AVAIL_W
    );
  SEGMENT_DFIFO_VCC : X_ONE
    port map (
      O => SEGMENT_DFIFO_N2147483644
    );
  SEGMENT_DFIFO_GND : X_ZERO
    port map (
      O => SEGMENT_DFIFO_N2147483641
    );
  SEGMENT_DFIFO_BU256 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1335,
      ADR1 => SEGMENT_DFIFO_N1724,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N4840
    );
  SEGMENT_DFIFO_BU257 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2113,
      ADR1 => SEGMENT_DFIFO_N2502,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N4842
    );
  SEGMENT_DFIFO_BU258 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N4840,
      IB => SEGMENT_DFIFO_N4842,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N4818
    );
  SEGMENT_DFIFO_BU259 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2891,
      ADR1 => SEGMENT_DFIFO_N3280,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N4924
    );
  SEGMENT_DFIFO_BU260 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3669,
      ADR1 => SEGMENT_DFIFO_N4058,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N4926
    );
  SEGMENT_DFIFO_BU261 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N4924,
      IB => SEGMENT_DFIFO_N4926,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N4902
    );
  SEGMENT_DFIFO_BU262 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N4818,
      IB => SEGMENT_DFIFO_N4902,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N4988
    );
  SEGMENT_DFIFO_BU263 : X_FF
    port map (
      I => SEGMENT_DFIFO_N4988,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3193_5
    );
  SEGMENT_DFIFO_BU264 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1336,
      ADR1 => SEGMENT_DFIFO_N1725,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N5086
    );
  SEGMENT_DFIFO_BU265 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2114,
      ADR1 => SEGMENT_DFIFO_N2503,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N5088
    );
  SEGMENT_DFIFO_BU266 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N5086,
      IB => SEGMENT_DFIFO_N5088,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N5064
    );
  SEGMENT_DFIFO_BU267 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2892,
      ADR1 => SEGMENT_DFIFO_N3281,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N5170
    );
  SEGMENT_DFIFO_BU268 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3670,
      ADR1 => SEGMENT_DFIFO_N4059,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N5172
    );
  SEGMENT_DFIFO_BU269 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N5170,
      IB => SEGMENT_DFIFO_N5172,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N5148
    );
  SEGMENT_DFIFO_BU270 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N5064,
      IB => SEGMENT_DFIFO_N5148,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N5234
    );
  SEGMENT_DFIFO_BU271 : X_FF
    port map (
      I => SEGMENT_DFIFO_N5234,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3201_5
    );
  SEGMENT_DFIFO_BU272 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1337,
      ADR1 => SEGMENT_DFIFO_N1726,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N5332
    );
  SEGMENT_DFIFO_BU273 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2115,
      ADR1 => SEGMENT_DFIFO_N2504,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N5334
    );
  SEGMENT_DFIFO_BU274 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N5332,
      IB => SEGMENT_DFIFO_N5334,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N5310
    );
  SEGMENT_DFIFO_BU275 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2893,
      ADR1 => SEGMENT_DFIFO_N3282,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N5416
    );
  SEGMENT_DFIFO_BU276 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3671,
      ADR1 => SEGMENT_DFIFO_N4060,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N5418
    );
  SEGMENT_DFIFO_BU277 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N5416,
      IB => SEGMENT_DFIFO_N5418,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N5394
    );
  SEGMENT_DFIFO_BU278 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N5310,
      IB => SEGMENT_DFIFO_N5394,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N5480
    );
  SEGMENT_DFIFO_BU279 : X_FF
    port map (
      I => SEGMENT_DFIFO_N5480,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3209_5
    );
  SEGMENT_DFIFO_BU280 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1338,
      ADR1 => SEGMENT_DFIFO_N1727,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N5578
    );
  SEGMENT_DFIFO_BU281 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2116,
      ADR1 => SEGMENT_DFIFO_N2505,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N5580
    );
  SEGMENT_DFIFO_BU282 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N5578,
      IB => SEGMENT_DFIFO_N5580,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N5556
    );
  SEGMENT_DFIFO_BU283 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2894,
      ADR1 => SEGMENT_DFIFO_N3283,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N5662
    );
  SEGMENT_DFIFO_BU284 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3672,
      ADR1 => SEGMENT_DFIFO_N4061,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N5664
    );
  SEGMENT_DFIFO_BU285 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N5662,
      IB => SEGMENT_DFIFO_N5664,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N5640
    );
  SEGMENT_DFIFO_BU286 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N5556,
      IB => SEGMENT_DFIFO_N5640,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N5726
    );
  SEGMENT_DFIFO_BU287 : X_FF
    port map (
      I => SEGMENT_DFIFO_N5726,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3217_5
    );
  SEGMENT_DFIFO_BU288 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1339,
      ADR1 => SEGMENT_DFIFO_N1728,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N5824
    );
  SEGMENT_DFIFO_BU289 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2117,
      ADR1 => SEGMENT_DFIFO_N2506,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N5826
    );
  SEGMENT_DFIFO_BU290 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N5824,
      IB => SEGMENT_DFIFO_N5826,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N5802
    );
  SEGMENT_DFIFO_BU291 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2895,
      ADR1 => SEGMENT_DFIFO_N3284,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N5908
    );
  SEGMENT_DFIFO_BU292 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3673,
      ADR1 => SEGMENT_DFIFO_N4062,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N5910
    );
  SEGMENT_DFIFO_BU293 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N5908,
      IB => SEGMENT_DFIFO_N5910,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N5886
    );
  SEGMENT_DFIFO_BU294 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N5802,
      IB => SEGMENT_DFIFO_N5886,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N5972
    );
  SEGMENT_DFIFO_BU295 : X_FF
    port map (
      I => SEGMENT_DFIFO_N5972,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3225_5
    );
  SEGMENT_DFIFO_BU296 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1340,
      ADR1 => SEGMENT_DFIFO_N1729,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N6070
    );
  SEGMENT_DFIFO_BU297 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2118,
      ADR1 => SEGMENT_DFIFO_N2507,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N6072
    );
  SEGMENT_DFIFO_BU298 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N6070,
      IB => SEGMENT_DFIFO_N6072,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N6048
    );
  SEGMENT_DFIFO_BU299 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2896,
      ADR1 => SEGMENT_DFIFO_N3285,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N6154
    );
  SEGMENT_DFIFO_BU300 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3674,
      ADR1 => SEGMENT_DFIFO_N4063,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N6156
    );
  SEGMENT_DFIFO_BU301 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N6154,
      IB => SEGMENT_DFIFO_N6156,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N6132
    );
  SEGMENT_DFIFO_BU302 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N6048,
      IB => SEGMENT_DFIFO_N6132,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N6218
    );
  SEGMENT_DFIFO_BU303 : X_FF
    port map (
      I => SEGMENT_DFIFO_N6218,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3233_5
    );
  SEGMENT_DFIFO_BU304 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1341,
      ADR1 => SEGMENT_DFIFO_N1730,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N6316
    );
  SEGMENT_DFIFO_BU305 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2119,
      ADR1 => SEGMENT_DFIFO_N2508,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N6318
    );
  SEGMENT_DFIFO_BU306 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N6316,
      IB => SEGMENT_DFIFO_N6318,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N6294
    );
  SEGMENT_DFIFO_BU307 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2897,
      ADR1 => SEGMENT_DFIFO_N3286,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N6400
    );
  SEGMENT_DFIFO_BU308 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3675,
      ADR1 => SEGMENT_DFIFO_N4064,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N6402
    );
  SEGMENT_DFIFO_BU309 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N6400,
      IB => SEGMENT_DFIFO_N6402,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N6378
    );
  SEGMENT_DFIFO_BU310 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N6294,
      IB => SEGMENT_DFIFO_N6378,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N6464
    );
  SEGMENT_DFIFO_BU311 : X_FF
    port map (
      I => SEGMENT_DFIFO_N6464,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3241_5
    );
  SEGMENT_DFIFO_BU312 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1342,
      ADR1 => SEGMENT_DFIFO_N1731,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N6562
    );
  SEGMENT_DFIFO_BU313 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2120,
      ADR1 => SEGMENT_DFIFO_N2509,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N6564
    );
  SEGMENT_DFIFO_BU314 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N6562,
      IB => SEGMENT_DFIFO_N6564,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N6540
    );
  SEGMENT_DFIFO_BU315 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2898,
      ADR1 => SEGMENT_DFIFO_N3287,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N6646
    );
  SEGMENT_DFIFO_BU316 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3676,
      ADR1 => SEGMENT_DFIFO_N4065,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N6648
    );
  SEGMENT_DFIFO_BU317 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N6646,
      IB => SEGMENT_DFIFO_N6648,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N6624
    );
  SEGMENT_DFIFO_BU318 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N6540,
      IB => SEGMENT_DFIFO_N6624,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N6710
    );
  SEGMENT_DFIFO_BU319 : X_FF
    port map (
      I => SEGMENT_DFIFO_N6710,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3249_5
    );
  SEGMENT_DFIFO_BU320 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1343,
      ADR1 => SEGMENT_DFIFO_N1732,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N6808
    );
  SEGMENT_DFIFO_BU321 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2121,
      ADR1 => SEGMENT_DFIFO_N2510,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N6810
    );
  SEGMENT_DFIFO_BU322 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N6808,
      IB => SEGMENT_DFIFO_N6810,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N6786
    );
  SEGMENT_DFIFO_BU323 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2899,
      ADR1 => SEGMENT_DFIFO_N3288,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N6892
    );
  SEGMENT_DFIFO_BU324 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3677,
      ADR1 => SEGMENT_DFIFO_N4066,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N6894
    );
  SEGMENT_DFIFO_BU325 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N6892,
      IB => SEGMENT_DFIFO_N6894,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N6870
    );
  SEGMENT_DFIFO_BU326 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N6786,
      IB => SEGMENT_DFIFO_N6870,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N6956
    );
  SEGMENT_DFIFO_BU327 : X_FF
    port map (
      I => SEGMENT_DFIFO_N6956,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3257_5
    );
  SEGMENT_DFIFO_BU328 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1344,
      ADR1 => SEGMENT_DFIFO_N1733,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N7054
    );
  SEGMENT_DFIFO_BU329 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2122,
      ADR1 => SEGMENT_DFIFO_N2511,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N7056
    );
  SEGMENT_DFIFO_BU330 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N7054,
      IB => SEGMENT_DFIFO_N7056,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N7032
    );
  SEGMENT_DFIFO_BU331 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2900,
      ADR1 => SEGMENT_DFIFO_N3289,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N7138
    );
  SEGMENT_DFIFO_BU332 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3678,
      ADR1 => SEGMENT_DFIFO_N4067,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N7140
    );
  SEGMENT_DFIFO_BU333 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N7138,
      IB => SEGMENT_DFIFO_N7140,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N7116
    );
  SEGMENT_DFIFO_BU334 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N7032,
      IB => SEGMENT_DFIFO_N7116,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N7202
    );
  SEGMENT_DFIFO_BU335 : X_FF
    port map (
      I => SEGMENT_DFIFO_N7202,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3265_5
    );
  SEGMENT_DFIFO_BU336 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1345,
      ADR1 => SEGMENT_DFIFO_N1734,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N7300
    );
  SEGMENT_DFIFO_BU337 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2123,
      ADR1 => SEGMENT_DFIFO_N2512,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N7302
    );
  SEGMENT_DFIFO_BU338 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N7300,
      IB => SEGMENT_DFIFO_N7302,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N7278
    );
  SEGMENT_DFIFO_BU339 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2901,
      ADR1 => SEGMENT_DFIFO_N3290,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N7384
    );
  SEGMENT_DFIFO_BU340 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3679,
      ADR1 => SEGMENT_DFIFO_N4068,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N7386
    );
  SEGMENT_DFIFO_BU341 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N7384,
      IB => SEGMENT_DFIFO_N7386,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N7362
    );
  SEGMENT_DFIFO_BU342 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N7278,
      IB => SEGMENT_DFIFO_N7362,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N7448
    );
  SEGMENT_DFIFO_BU343 : X_FF
    port map (
      I => SEGMENT_DFIFO_N7448,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3273_5
    );
  SEGMENT_DFIFO_BU344 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1346,
      ADR1 => SEGMENT_DFIFO_N1735,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N7546
    );
  SEGMENT_DFIFO_BU345 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2124,
      ADR1 => SEGMENT_DFIFO_N2513,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N7548
    );
  SEGMENT_DFIFO_BU346 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N7546,
      IB => SEGMENT_DFIFO_N7548,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N7524
    );
  SEGMENT_DFIFO_BU347 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2902,
      ADR1 => SEGMENT_DFIFO_N3291,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N7630
    );
  SEGMENT_DFIFO_BU348 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3680,
      ADR1 => SEGMENT_DFIFO_N4069,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N7632
    );
  SEGMENT_DFIFO_BU349 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N7630,
      IB => SEGMENT_DFIFO_N7632,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N7608
    );
  SEGMENT_DFIFO_BU350 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N7524,
      IB => SEGMENT_DFIFO_N7608,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N7694
    );
  SEGMENT_DFIFO_BU351 : X_FF
    port map (
      I => SEGMENT_DFIFO_N7694,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3281_5
    );
  SEGMENT_DFIFO_BU352 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1347,
      ADR1 => SEGMENT_DFIFO_N1736,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N7792
    );
  SEGMENT_DFIFO_BU353 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2125,
      ADR1 => SEGMENT_DFIFO_N2514,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N7794
    );
  SEGMENT_DFIFO_BU354 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N7792,
      IB => SEGMENT_DFIFO_N7794,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N7770
    );
  SEGMENT_DFIFO_BU355 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2903,
      ADR1 => SEGMENT_DFIFO_N3292,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N7876
    );
  SEGMENT_DFIFO_BU356 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3681,
      ADR1 => SEGMENT_DFIFO_N4070,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N7878
    );
  SEGMENT_DFIFO_BU357 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N7876,
      IB => SEGMENT_DFIFO_N7878,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N7854
    );
  SEGMENT_DFIFO_BU358 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N7770,
      IB => SEGMENT_DFIFO_N7854,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N7940
    );
  SEGMENT_DFIFO_BU359 : X_FF
    port map (
      I => SEGMENT_DFIFO_N7940,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3289_5
    );
  SEGMENT_DFIFO_BU360 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1348,
      ADR1 => SEGMENT_DFIFO_N1737,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N8038
    );
  SEGMENT_DFIFO_BU361 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2126,
      ADR1 => SEGMENT_DFIFO_N2515,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N8040
    );
  SEGMENT_DFIFO_BU362 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N8038,
      IB => SEGMENT_DFIFO_N8040,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N8016
    );
  SEGMENT_DFIFO_BU363 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2904,
      ADR1 => SEGMENT_DFIFO_N3293,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N8122
    );
  SEGMENT_DFIFO_BU364 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3682,
      ADR1 => SEGMENT_DFIFO_N4071,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N8124
    );
  SEGMENT_DFIFO_BU365 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N8122,
      IB => SEGMENT_DFIFO_N8124,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N8100
    );
  SEGMENT_DFIFO_BU366 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N8016,
      IB => SEGMENT_DFIFO_N8100,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N8186
    );
  SEGMENT_DFIFO_BU367 : X_FF
    port map (
      I => SEGMENT_DFIFO_N8186,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3297_5
    );
  SEGMENT_DFIFO_BU368 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1349,
      ADR1 => SEGMENT_DFIFO_N1738,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N8284
    );
  SEGMENT_DFIFO_BU369 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2127,
      ADR1 => SEGMENT_DFIFO_N2516,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N8286
    );
  SEGMENT_DFIFO_BU370 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N8284,
      IB => SEGMENT_DFIFO_N8286,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N8262
    );
  SEGMENT_DFIFO_BU371 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2905,
      ADR1 => SEGMENT_DFIFO_N3294,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N8368
    );
  SEGMENT_DFIFO_BU372 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3683,
      ADR1 => SEGMENT_DFIFO_N4072,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N8370
    );
  SEGMENT_DFIFO_BU373 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N8368,
      IB => SEGMENT_DFIFO_N8370,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N8346
    );
  SEGMENT_DFIFO_BU374 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N8262,
      IB => SEGMENT_DFIFO_N8346,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N8432
    );
  SEGMENT_DFIFO_BU375 : X_FF
    port map (
      I => SEGMENT_DFIFO_N8432,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3305_5
    );
  SEGMENT_DFIFO_BU376 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1350,
      ADR1 => SEGMENT_DFIFO_N1739,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N8530
    );
  SEGMENT_DFIFO_BU377 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2128,
      ADR1 => SEGMENT_DFIFO_N2517,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N8532
    );
  SEGMENT_DFIFO_BU378 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N8530,
      IB => SEGMENT_DFIFO_N8532,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N8508
    );
  SEGMENT_DFIFO_BU379 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2906,
      ADR1 => SEGMENT_DFIFO_N3295,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N8614
    );
  SEGMENT_DFIFO_BU380 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3684,
      ADR1 => SEGMENT_DFIFO_N4073,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N8616
    );
  SEGMENT_DFIFO_BU381 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N8614,
      IB => SEGMENT_DFIFO_N8616,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N8592
    );
  SEGMENT_DFIFO_BU382 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N8508,
      IB => SEGMENT_DFIFO_N8592,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N8678
    );
  SEGMENT_DFIFO_BU383 : X_FF
    port map (
      I => SEGMENT_DFIFO_N8678,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3313_5
    );
  SEGMENT_DFIFO_BU384 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1351,
      ADR1 => SEGMENT_DFIFO_N1740,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N8776
    );
  SEGMENT_DFIFO_BU385 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2129,
      ADR1 => SEGMENT_DFIFO_N2518,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N8778
    );
  SEGMENT_DFIFO_BU386 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N8776,
      IB => SEGMENT_DFIFO_N8778,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N8754
    );
  SEGMENT_DFIFO_BU387 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2907,
      ADR1 => SEGMENT_DFIFO_N3296,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N8860
    );
  SEGMENT_DFIFO_BU388 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3685,
      ADR1 => SEGMENT_DFIFO_N4074,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N8862
    );
  SEGMENT_DFIFO_BU389 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N8860,
      IB => SEGMENT_DFIFO_N8862,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N8838
    );
  SEGMENT_DFIFO_BU390 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N8754,
      IB => SEGMENT_DFIFO_N8838,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N8924
    );
  SEGMENT_DFIFO_BU391 : X_FF
    port map (
      I => SEGMENT_DFIFO_N8924,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3321_5
    );
  SEGMENT_DFIFO_BU392 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1352,
      ADR1 => SEGMENT_DFIFO_N1741,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N9022
    );
  SEGMENT_DFIFO_BU393 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2130,
      ADR1 => SEGMENT_DFIFO_N2519,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N9024
    );
  SEGMENT_DFIFO_BU394 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N9022,
      IB => SEGMENT_DFIFO_N9024,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N9000
    );
  SEGMENT_DFIFO_BU395 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2908,
      ADR1 => SEGMENT_DFIFO_N3297,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N9106
    );
  SEGMENT_DFIFO_BU396 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3686,
      ADR1 => SEGMENT_DFIFO_N4075,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N9108
    );
  SEGMENT_DFIFO_BU397 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N9106,
      IB => SEGMENT_DFIFO_N9108,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N9084
    );
  SEGMENT_DFIFO_BU398 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N9000,
      IB => SEGMENT_DFIFO_N9084,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N9170
    );
  SEGMENT_DFIFO_BU399 : X_FF
    port map (
      I => SEGMENT_DFIFO_N9170,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3329_5
    );
  SEGMENT_DFIFO_BU400 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1353,
      ADR1 => SEGMENT_DFIFO_N1742,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N9268
    );
  SEGMENT_DFIFO_BU401 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2131,
      ADR1 => SEGMENT_DFIFO_N2520,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N9270
    );
  SEGMENT_DFIFO_BU402 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N9268,
      IB => SEGMENT_DFIFO_N9270,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N9246
    );
  SEGMENT_DFIFO_BU403 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2909,
      ADR1 => SEGMENT_DFIFO_N3298,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N9352
    );
  SEGMENT_DFIFO_BU404 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3687,
      ADR1 => SEGMENT_DFIFO_N4076,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N9354
    );
  SEGMENT_DFIFO_BU405 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N9352,
      IB => SEGMENT_DFIFO_N9354,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N9330
    );
  SEGMENT_DFIFO_BU406 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N9246,
      IB => SEGMENT_DFIFO_N9330,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N9416
    );
  SEGMENT_DFIFO_BU407 : X_FF
    port map (
      I => SEGMENT_DFIFO_N9416,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3337_5
    );
  SEGMENT_DFIFO_BU408 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1354,
      ADR1 => SEGMENT_DFIFO_N1743,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N9514
    );
  SEGMENT_DFIFO_BU409 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2132,
      ADR1 => SEGMENT_DFIFO_N2521,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N9516
    );
  SEGMENT_DFIFO_BU410 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N9514,
      IB => SEGMENT_DFIFO_N9516,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N9492
    );
  SEGMENT_DFIFO_BU411 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2910,
      ADR1 => SEGMENT_DFIFO_N3299,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N9598
    );
  SEGMENT_DFIFO_BU412 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3688,
      ADR1 => SEGMENT_DFIFO_N4077,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N9600
    );
  SEGMENT_DFIFO_BU413 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N9598,
      IB => SEGMENT_DFIFO_N9600,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N9576
    );
  SEGMENT_DFIFO_BU414 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N9492,
      IB => SEGMENT_DFIFO_N9576,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N9662
    );
  SEGMENT_DFIFO_BU415 : X_FF
    port map (
      I => SEGMENT_DFIFO_N9662,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3345_5
    );
  SEGMENT_DFIFO_BU416 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1355,
      ADR1 => SEGMENT_DFIFO_N1744,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N9760
    );
  SEGMENT_DFIFO_BU417 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2133,
      ADR1 => SEGMENT_DFIFO_N2522,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N9762
    );
  SEGMENT_DFIFO_BU418 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N9760,
      IB => SEGMENT_DFIFO_N9762,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N9738
    );
  SEGMENT_DFIFO_BU419 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2911,
      ADR1 => SEGMENT_DFIFO_N3300,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N9844
    );
  SEGMENT_DFIFO_BU420 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3689,
      ADR1 => SEGMENT_DFIFO_N4078,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N9846
    );
  SEGMENT_DFIFO_BU421 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N9844,
      IB => SEGMENT_DFIFO_N9846,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N9822
    );
  SEGMENT_DFIFO_BU422 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N9738,
      IB => SEGMENT_DFIFO_N9822,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N9908
    );
  SEGMENT_DFIFO_BU423 : X_FF
    port map (
      I => SEGMENT_DFIFO_N9908,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3353_5
    );
  SEGMENT_DFIFO_BU424 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1356,
      ADR1 => SEGMENT_DFIFO_N1745,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N10006
    );
  SEGMENT_DFIFO_BU425 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2134,
      ADR1 => SEGMENT_DFIFO_N2523,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N10008
    );
  SEGMENT_DFIFO_BU426 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N10006,
      IB => SEGMENT_DFIFO_N10008,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N9984
    );
  SEGMENT_DFIFO_BU427 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2912,
      ADR1 => SEGMENT_DFIFO_N3301,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N10090
    );
  SEGMENT_DFIFO_BU428 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3690,
      ADR1 => SEGMENT_DFIFO_N4079,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N10092
    );
  SEGMENT_DFIFO_BU429 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N10090,
      IB => SEGMENT_DFIFO_N10092,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N10068
    );
  SEGMENT_DFIFO_BU430 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N9984,
      IB => SEGMENT_DFIFO_N10068,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N10154
    );
  SEGMENT_DFIFO_BU431 : X_FF
    port map (
      I => SEGMENT_DFIFO_N10154,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3361_5
    );
  SEGMENT_DFIFO_BU432 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1357,
      ADR1 => SEGMENT_DFIFO_N1746,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N10252
    );
  SEGMENT_DFIFO_BU433 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2135,
      ADR1 => SEGMENT_DFIFO_N2524,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N10254
    );
  SEGMENT_DFIFO_BU434 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N10252,
      IB => SEGMENT_DFIFO_N10254,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N10230
    );
  SEGMENT_DFIFO_BU435 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2913,
      ADR1 => SEGMENT_DFIFO_N3302,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N10336
    );
  SEGMENT_DFIFO_BU436 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3691,
      ADR1 => SEGMENT_DFIFO_N4080,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N10338
    );
  SEGMENT_DFIFO_BU437 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N10336,
      IB => SEGMENT_DFIFO_N10338,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N10314
    );
  SEGMENT_DFIFO_BU438 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N10230,
      IB => SEGMENT_DFIFO_N10314,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N10400
    );
  SEGMENT_DFIFO_BU439 : X_FF
    port map (
      I => SEGMENT_DFIFO_N10400,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3369_5
    );
  SEGMENT_DFIFO_BU440 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1358,
      ADR1 => SEGMENT_DFIFO_N1747,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N10498
    );
  SEGMENT_DFIFO_BU441 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2136,
      ADR1 => SEGMENT_DFIFO_N2525,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N10500
    );
  SEGMENT_DFIFO_BU442 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N10498,
      IB => SEGMENT_DFIFO_N10500,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N10476
    );
  SEGMENT_DFIFO_BU443 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2914,
      ADR1 => SEGMENT_DFIFO_N3303,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N10582
    );
  SEGMENT_DFIFO_BU444 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3692,
      ADR1 => SEGMENT_DFIFO_N4081,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N10584
    );
  SEGMENT_DFIFO_BU445 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N10582,
      IB => SEGMENT_DFIFO_N10584,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N10560
    );
  SEGMENT_DFIFO_BU446 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N10476,
      IB => SEGMENT_DFIFO_N10560,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N10646
    );
  SEGMENT_DFIFO_BU447 : X_FF
    port map (
      I => SEGMENT_DFIFO_N10646,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3377_5
    );
  SEGMENT_DFIFO_BU448 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1359,
      ADR1 => SEGMENT_DFIFO_N1748,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N10744
    );
  SEGMENT_DFIFO_BU449 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2137,
      ADR1 => SEGMENT_DFIFO_N2526,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N10746
    );
  SEGMENT_DFIFO_BU450 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N10744,
      IB => SEGMENT_DFIFO_N10746,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N10722
    );
  SEGMENT_DFIFO_BU451 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2915,
      ADR1 => SEGMENT_DFIFO_N3304,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N10828
    );
  SEGMENT_DFIFO_BU452 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3693,
      ADR1 => SEGMENT_DFIFO_N4082,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N10830
    );
  SEGMENT_DFIFO_BU453 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N10828,
      IB => SEGMENT_DFIFO_N10830,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N10806
    );
  SEGMENT_DFIFO_BU454 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N10722,
      IB => SEGMENT_DFIFO_N10806,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N10892
    );
  SEGMENT_DFIFO_BU455 : X_FF
    port map (
      I => SEGMENT_DFIFO_N10892,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3385_5
    );
  SEGMENT_DFIFO_BU456 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1360,
      ADR1 => SEGMENT_DFIFO_N1749,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N10990
    );
  SEGMENT_DFIFO_BU457 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2138,
      ADR1 => SEGMENT_DFIFO_N2527,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N10992
    );
  SEGMENT_DFIFO_BU458 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N10990,
      IB => SEGMENT_DFIFO_N10992,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N10968
    );
  SEGMENT_DFIFO_BU459 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2916,
      ADR1 => SEGMENT_DFIFO_N3305,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N11074
    );
  SEGMENT_DFIFO_BU460 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3694,
      ADR1 => SEGMENT_DFIFO_N4083,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N11076
    );
  SEGMENT_DFIFO_BU461 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N11074,
      IB => SEGMENT_DFIFO_N11076,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N11052
    );
  SEGMENT_DFIFO_BU462 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N10968,
      IB => SEGMENT_DFIFO_N11052,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N11138
    );
  SEGMENT_DFIFO_BU463 : X_FF
    port map (
      I => SEGMENT_DFIFO_N11138,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3393_5
    );
  SEGMENT_DFIFO_BU464 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1361,
      ADR1 => SEGMENT_DFIFO_N1750,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N11236
    );
  SEGMENT_DFIFO_BU465 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2139,
      ADR1 => SEGMENT_DFIFO_N2528,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N11238
    );
  SEGMENT_DFIFO_BU466 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N11236,
      IB => SEGMENT_DFIFO_N11238,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N11214
    );
  SEGMENT_DFIFO_BU467 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2917,
      ADR1 => SEGMENT_DFIFO_N3306,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N11320
    );
  SEGMENT_DFIFO_BU468 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3695,
      ADR1 => SEGMENT_DFIFO_N4084,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N11322
    );
  SEGMENT_DFIFO_BU469 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N11320,
      IB => SEGMENT_DFIFO_N11322,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N11298
    );
  SEGMENT_DFIFO_BU470 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N11214,
      IB => SEGMENT_DFIFO_N11298,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N11384
    );
  SEGMENT_DFIFO_BU471 : X_FF
    port map (
      I => SEGMENT_DFIFO_N11384,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3401_5
    );
  SEGMENT_DFIFO_BU472 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1362,
      ADR1 => SEGMENT_DFIFO_N1751,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N11482
    );
  SEGMENT_DFIFO_BU473 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2140,
      ADR1 => SEGMENT_DFIFO_N2529,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N11484
    );
  SEGMENT_DFIFO_BU474 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N11482,
      IB => SEGMENT_DFIFO_N11484,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N11460
    );
  SEGMENT_DFIFO_BU475 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2918,
      ADR1 => SEGMENT_DFIFO_N3307,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N11566
    );
  SEGMENT_DFIFO_BU476 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3696,
      ADR1 => SEGMENT_DFIFO_N4085,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N11568
    );
  SEGMENT_DFIFO_BU477 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N11566,
      IB => SEGMENT_DFIFO_N11568,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N11544
    );
  SEGMENT_DFIFO_BU478 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N11460,
      IB => SEGMENT_DFIFO_N11544,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N11630
    );
  SEGMENT_DFIFO_BU479 : X_FF
    port map (
      I => SEGMENT_DFIFO_N11630,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3409_5
    );
  SEGMENT_DFIFO_BU480 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1363,
      ADR1 => SEGMENT_DFIFO_N1752,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N11728
    );
  SEGMENT_DFIFO_BU481 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2141,
      ADR1 => SEGMENT_DFIFO_N2530,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N11730
    );
  SEGMENT_DFIFO_BU482 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N11728,
      IB => SEGMENT_DFIFO_N11730,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N11706
    );
  SEGMENT_DFIFO_BU483 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2919,
      ADR1 => SEGMENT_DFIFO_N3308,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N11812
    );
  SEGMENT_DFIFO_BU484 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3697,
      ADR1 => SEGMENT_DFIFO_N4086,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N11814
    );
  SEGMENT_DFIFO_BU485 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N11812,
      IB => SEGMENT_DFIFO_N11814,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N11790
    );
  SEGMENT_DFIFO_BU486 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N11706,
      IB => SEGMENT_DFIFO_N11790,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N11876
    );
  SEGMENT_DFIFO_BU487 : X_FF
    port map (
      I => SEGMENT_DFIFO_N11876,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3417_5
    );
  SEGMENT_DFIFO_BU488 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1364,
      ADR1 => SEGMENT_DFIFO_N1753,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N11974
    );
  SEGMENT_DFIFO_BU489 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2142,
      ADR1 => SEGMENT_DFIFO_N2531,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N11976
    );
  SEGMENT_DFIFO_BU490 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N11974,
      IB => SEGMENT_DFIFO_N11976,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N11952
    );
  SEGMENT_DFIFO_BU491 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2920,
      ADR1 => SEGMENT_DFIFO_N3309,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N12058
    );
  SEGMENT_DFIFO_BU492 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3698,
      ADR1 => SEGMENT_DFIFO_N4087,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N12060
    );
  SEGMENT_DFIFO_BU493 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N12058,
      IB => SEGMENT_DFIFO_N12060,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N12036
    );
  SEGMENT_DFIFO_BU494 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N11952,
      IB => SEGMENT_DFIFO_N12036,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N12122
    );
  SEGMENT_DFIFO_BU495 : X_FF
    port map (
      I => SEGMENT_DFIFO_N12122,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3425_5
    );
  SEGMENT_DFIFO_BU496 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1365,
      ADR1 => SEGMENT_DFIFO_N1754,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N12220
    );
  SEGMENT_DFIFO_BU497 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2143,
      ADR1 => SEGMENT_DFIFO_N2532,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N12222
    );
  SEGMENT_DFIFO_BU498 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N12220,
      IB => SEGMENT_DFIFO_N12222,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N12198
    );
  SEGMENT_DFIFO_BU499 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2921,
      ADR1 => SEGMENT_DFIFO_N3310,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N12304
    );
  SEGMENT_DFIFO_BU500 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3699,
      ADR1 => SEGMENT_DFIFO_N4088,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N12306
    );
  SEGMENT_DFIFO_BU501 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N12304,
      IB => SEGMENT_DFIFO_N12306,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N12282
    );
  SEGMENT_DFIFO_BU502 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N12198,
      IB => SEGMENT_DFIFO_N12282,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N12368
    );
  SEGMENT_DFIFO_BU503 : X_FF
    port map (
      I => SEGMENT_DFIFO_N12368,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3433_5
    );
  SEGMENT_DFIFO_BU504 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1366,
      ADR1 => SEGMENT_DFIFO_N1755,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N12466
    );
  SEGMENT_DFIFO_BU505 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2144,
      ADR1 => SEGMENT_DFIFO_N2533,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N12468
    );
  SEGMENT_DFIFO_BU506 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N12466,
      IB => SEGMENT_DFIFO_N12468,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N12444
    );
  SEGMENT_DFIFO_BU507 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2922,
      ADR1 => SEGMENT_DFIFO_N3311,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N12550
    );
  SEGMENT_DFIFO_BU508 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3700,
      ADR1 => SEGMENT_DFIFO_N4089,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N12552
    );
  SEGMENT_DFIFO_BU509 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N12550,
      IB => SEGMENT_DFIFO_N12552,
      SEL => SEGMENT_DFIFO_N209,
      O => SEGMENT_DFIFO_N12528
    );
  SEGMENT_DFIFO_BU510 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N12444,
      IB => SEGMENT_DFIFO_N12528,
      SEL => SEGMENT_DFIFO_N208,
      O => SEGMENT_DFIFO_N12614
    );
  SEGMENT_DFIFO_BU511 : X_FF
    port map (
      I => SEGMENT_DFIFO_N12614,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3441_5
    );
  SEGMENT_DFIFO_BU512 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1368,
      ADR1 => SEGMENT_DFIFO_N1757,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N13017
    );
  SEGMENT_DFIFO_BU513 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2146,
      ADR1 => SEGMENT_DFIFO_N2535,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N13019
    );
  SEGMENT_DFIFO_BU514 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N13017,
      IB => SEGMENT_DFIFO_N13019,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N12995
    );
  SEGMENT_DFIFO_BU515 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2924,
      ADR1 => SEGMENT_DFIFO_N3313,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N13101
    );
  SEGMENT_DFIFO_BU516 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3702,
      ADR1 => SEGMENT_DFIFO_N4091,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N13103
    );
  SEGMENT_DFIFO_BU517 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N13101,
      IB => SEGMENT_DFIFO_N13103,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N13079
    );
  SEGMENT_DFIFO_BU518 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N12995,
      IB => SEGMENT_DFIFO_N13079,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N13165
    );
  SEGMENT_DFIFO_BU519 : X_FF
    port map (
      I => SEGMENT_DFIFO_N13165,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(0)
    );
  SEGMENT_DFIFO_BU520 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1369,
      ADR1 => SEGMENT_DFIFO_N1758,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N13263
    );
  SEGMENT_DFIFO_BU521 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2147,
      ADR1 => SEGMENT_DFIFO_N2536,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N13265
    );
  SEGMENT_DFIFO_BU522 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N13263,
      IB => SEGMENT_DFIFO_N13265,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N13241
    );
  SEGMENT_DFIFO_BU523 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2925,
      ADR1 => SEGMENT_DFIFO_N3314,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N13347
    );
  SEGMENT_DFIFO_BU524 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3703,
      ADR1 => SEGMENT_DFIFO_N4092,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N13349
    );
  SEGMENT_DFIFO_BU525 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N13347,
      IB => SEGMENT_DFIFO_N13349,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N13325
    );
  SEGMENT_DFIFO_BU526 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N13241,
      IB => SEGMENT_DFIFO_N13325,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N13411
    );
  SEGMENT_DFIFO_BU527 : X_FF
    port map (
      I => SEGMENT_DFIFO_N13411,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(1)
    );
  SEGMENT_DFIFO_BU528 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1370,
      ADR1 => SEGMENT_DFIFO_N1759,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N13509
    );
  SEGMENT_DFIFO_BU529 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2148,
      ADR1 => SEGMENT_DFIFO_N2537,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N13511
    );
  SEGMENT_DFIFO_BU530 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N13509,
      IB => SEGMENT_DFIFO_N13511,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N13487
    );
  SEGMENT_DFIFO_BU531 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2926,
      ADR1 => SEGMENT_DFIFO_N3315,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N13593
    );
  SEGMENT_DFIFO_BU532 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3704,
      ADR1 => SEGMENT_DFIFO_N4093,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N13595
    );
  SEGMENT_DFIFO_BU533 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N13593,
      IB => SEGMENT_DFIFO_N13595,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N13571
    );
  SEGMENT_DFIFO_BU534 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N13487,
      IB => SEGMENT_DFIFO_N13571,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N13657
    );
  SEGMENT_DFIFO_BU535 : X_FF
    port map (
      I => SEGMENT_DFIFO_N13657,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(2)
    );
  SEGMENT_DFIFO_BU536 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1371,
      ADR1 => SEGMENT_DFIFO_N1760,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N13755
    );
  SEGMENT_DFIFO_BU537 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2149,
      ADR1 => SEGMENT_DFIFO_N2538,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N13757
    );
  SEGMENT_DFIFO_BU538 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N13755,
      IB => SEGMENT_DFIFO_N13757,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N13733
    );
  SEGMENT_DFIFO_BU539 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2927,
      ADR1 => SEGMENT_DFIFO_N3316,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N13839
    );
  SEGMENT_DFIFO_BU540 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3705,
      ADR1 => SEGMENT_DFIFO_N4094,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N13841
    );
  SEGMENT_DFIFO_BU541 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N13839,
      IB => SEGMENT_DFIFO_N13841,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N13817
    );
  SEGMENT_DFIFO_BU542 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N13733,
      IB => SEGMENT_DFIFO_N13817,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N13903
    );
  SEGMENT_DFIFO_BU543 : X_FF
    port map (
      I => SEGMENT_DFIFO_N13903,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(3)
    );
  SEGMENT_DFIFO_BU544 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1372,
      ADR1 => SEGMENT_DFIFO_N1761,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N14001
    );
  SEGMENT_DFIFO_BU545 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2150,
      ADR1 => SEGMENT_DFIFO_N2539,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N14003
    );
  SEGMENT_DFIFO_BU546 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N14001,
      IB => SEGMENT_DFIFO_N14003,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N13979
    );
  SEGMENT_DFIFO_BU547 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2928,
      ADR1 => SEGMENT_DFIFO_N3317,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N14085
    );
  SEGMENT_DFIFO_BU548 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3706,
      ADR1 => SEGMENT_DFIFO_N4095,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N14087
    );
  SEGMENT_DFIFO_BU549 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N14085,
      IB => SEGMENT_DFIFO_N14087,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N14063
    );
  SEGMENT_DFIFO_BU550 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N13979,
      IB => SEGMENT_DFIFO_N14063,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N14149
    );
  SEGMENT_DFIFO_BU551 : X_FF
    port map (
      I => SEGMENT_DFIFO_N14149,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(4)
    );
  SEGMENT_DFIFO_BU552 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1373,
      ADR1 => SEGMENT_DFIFO_N1762,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N14247
    );
  SEGMENT_DFIFO_BU553 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2151,
      ADR1 => SEGMENT_DFIFO_N2540,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N14249
    );
  SEGMENT_DFIFO_BU554 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N14247,
      IB => SEGMENT_DFIFO_N14249,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N14225
    );
  SEGMENT_DFIFO_BU555 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2929,
      ADR1 => SEGMENT_DFIFO_N3318,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N14331
    );
  SEGMENT_DFIFO_BU556 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3707,
      ADR1 => SEGMENT_DFIFO_N4096,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N14333
    );
  SEGMENT_DFIFO_BU557 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N14331,
      IB => SEGMENT_DFIFO_N14333,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N14309
    );
  SEGMENT_DFIFO_BU558 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N14225,
      IB => SEGMENT_DFIFO_N14309,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N14395
    );
  SEGMENT_DFIFO_BU559 : X_FF
    port map (
      I => SEGMENT_DFIFO_N14395,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(5)
    );
  SEGMENT_DFIFO_BU560 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1374,
      ADR1 => SEGMENT_DFIFO_N1763,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N14493
    );
  SEGMENT_DFIFO_BU561 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2152,
      ADR1 => SEGMENT_DFIFO_N2541,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N14495
    );
  SEGMENT_DFIFO_BU562 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N14493,
      IB => SEGMENT_DFIFO_N14495,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N14471
    );
  SEGMENT_DFIFO_BU563 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2930,
      ADR1 => SEGMENT_DFIFO_N3319,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N14577
    );
  SEGMENT_DFIFO_BU564 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3708,
      ADR1 => SEGMENT_DFIFO_N4097,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N14579
    );
  SEGMENT_DFIFO_BU565 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N14577,
      IB => SEGMENT_DFIFO_N14579,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N14555
    );
  SEGMENT_DFIFO_BU566 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N14471,
      IB => SEGMENT_DFIFO_N14555,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N14641
    );
  SEGMENT_DFIFO_BU567 : X_FF
    port map (
      I => SEGMENT_DFIFO_N14641,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(6)
    );
  SEGMENT_DFIFO_BU568 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1375,
      ADR1 => SEGMENT_DFIFO_N1764,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N14739
    );
  SEGMENT_DFIFO_BU569 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2153,
      ADR1 => SEGMENT_DFIFO_N2542,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N14741
    );
  SEGMENT_DFIFO_BU570 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N14739,
      IB => SEGMENT_DFIFO_N14741,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N14717
    );
  SEGMENT_DFIFO_BU571 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2931,
      ADR1 => SEGMENT_DFIFO_N3320,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N14823
    );
  SEGMENT_DFIFO_BU572 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3709,
      ADR1 => SEGMENT_DFIFO_N4098,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N14825
    );
  SEGMENT_DFIFO_BU573 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N14823,
      IB => SEGMENT_DFIFO_N14825,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N14801
    );
  SEGMENT_DFIFO_BU574 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N14717,
      IB => SEGMENT_DFIFO_N14801,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N14887
    );
  SEGMENT_DFIFO_BU575 : X_FF
    port map (
      I => SEGMENT_DFIFO_N14887,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(7)
    );
  SEGMENT_DFIFO_BU576 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1376,
      ADR1 => SEGMENT_DFIFO_N1765,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N14985
    );
  SEGMENT_DFIFO_BU577 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2154,
      ADR1 => SEGMENT_DFIFO_N2543,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N14987
    );
  SEGMENT_DFIFO_BU578 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N14985,
      IB => SEGMENT_DFIFO_N14987,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N14963
    );
  SEGMENT_DFIFO_BU579 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2932,
      ADR1 => SEGMENT_DFIFO_N3321,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N15069
    );
  SEGMENT_DFIFO_BU580 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3710,
      ADR1 => SEGMENT_DFIFO_N4099,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N15071
    );
  SEGMENT_DFIFO_BU581 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N15069,
      IB => SEGMENT_DFIFO_N15071,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N15047
    );
  SEGMENT_DFIFO_BU582 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N14963,
      IB => SEGMENT_DFIFO_N15047,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N15133
    );
  SEGMENT_DFIFO_BU583 : X_FF
    port map (
      I => SEGMENT_DFIFO_N15133,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(8)
    );
  SEGMENT_DFIFO_BU584 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1377,
      ADR1 => SEGMENT_DFIFO_N1766,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N15231
    );
  SEGMENT_DFIFO_BU585 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2155,
      ADR1 => SEGMENT_DFIFO_N2544,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N15233
    );
  SEGMENT_DFIFO_BU586 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N15231,
      IB => SEGMENT_DFIFO_N15233,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N15209
    );
  SEGMENT_DFIFO_BU587 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2933,
      ADR1 => SEGMENT_DFIFO_N3322,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N15315
    );
  SEGMENT_DFIFO_BU588 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3711,
      ADR1 => SEGMENT_DFIFO_N4100,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N15317
    );
  SEGMENT_DFIFO_BU589 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N15315,
      IB => SEGMENT_DFIFO_N15317,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N15293
    );
  SEGMENT_DFIFO_BU590 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N15209,
      IB => SEGMENT_DFIFO_N15293,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N15379
    );
  SEGMENT_DFIFO_BU591 : X_FF
    port map (
      I => SEGMENT_DFIFO_N15379,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(9)
    );
  SEGMENT_DFIFO_BU592 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1378,
      ADR1 => SEGMENT_DFIFO_N1767,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N15477
    );
  SEGMENT_DFIFO_BU593 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2156,
      ADR1 => SEGMENT_DFIFO_N2545,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N15479
    );
  SEGMENT_DFIFO_BU594 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N15477,
      IB => SEGMENT_DFIFO_N15479,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N15455
    );
  SEGMENT_DFIFO_BU595 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2934,
      ADR1 => SEGMENT_DFIFO_N3323,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N15561
    );
  SEGMENT_DFIFO_BU596 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3712,
      ADR1 => SEGMENT_DFIFO_N4101,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N15563
    );
  SEGMENT_DFIFO_BU597 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N15561,
      IB => SEGMENT_DFIFO_N15563,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N15539
    );
  SEGMENT_DFIFO_BU598 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N15455,
      IB => SEGMENT_DFIFO_N15539,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N15625
    );
  SEGMENT_DFIFO_BU599 : X_FF
    port map (
      I => SEGMENT_DFIFO_N15625,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(10)
    );
  SEGMENT_DFIFO_BU600 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1379,
      ADR1 => SEGMENT_DFIFO_N1768,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N15723
    );
  SEGMENT_DFIFO_BU601 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2157,
      ADR1 => SEGMENT_DFIFO_N2546,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N15725
    );
  SEGMENT_DFIFO_BU602 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N15723,
      IB => SEGMENT_DFIFO_N15725,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N15701
    );
  SEGMENT_DFIFO_BU603 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2935,
      ADR1 => SEGMENT_DFIFO_N3324,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N15807
    );
  SEGMENT_DFIFO_BU604 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3713,
      ADR1 => SEGMENT_DFIFO_N4102,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N15809
    );
  SEGMENT_DFIFO_BU605 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N15807,
      IB => SEGMENT_DFIFO_N15809,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N15785
    );
  SEGMENT_DFIFO_BU606 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N15701,
      IB => SEGMENT_DFIFO_N15785,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N15871
    );
  SEGMENT_DFIFO_BU607 : X_FF
    port map (
      I => SEGMENT_DFIFO_N15871,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(11)
    );
  SEGMENT_DFIFO_BU608 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1380,
      ADR1 => SEGMENT_DFIFO_N1769,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N15969
    );
  SEGMENT_DFIFO_BU609 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2158,
      ADR1 => SEGMENT_DFIFO_N2547,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N15971
    );
  SEGMENT_DFIFO_BU610 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N15969,
      IB => SEGMENT_DFIFO_N15971,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N15947
    );
  SEGMENT_DFIFO_BU611 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2936,
      ADR1 => SEGMENT_DFIFO_N3325,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N16053
    );
  SEGMENT_DFIFO_BU612 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3714,
      ADR1 => SEGMENT_DFIFO_N4103,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N16055
    );
  SEGMENT_DFIFO_BU613 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N16053,
      IB => SEGMENT_DFIFO_N16055,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N16031
    );
  SEGMENT_DFIFO_BU614 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N15947,
      IB => SEGMENT_DFIFO_N16031,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N16117
    );
  SEGMENT_DFIFO_BU615 : X_FF
    port map (
      I => SEGMENT_DFIFO_N16117,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(12)
    );
  SEGMENT_DFIFO_BU616 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1381,
      ADR1 => SEGMENT_DFIFO_N1770,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N16215
    );
  SEGMENT_DFIFO_BU617 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2159,
      ADR1 => SEGMENT_DFIFO_N2548,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N16217
    );
  SEGMENT_DFIFO_BU618 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N16215,
      IB => SEGMENT_DFIFO_N16217,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N16193
    );
  SEGMENT_DFIFO_BU619 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2937,
      ADR1 => SEGMENT_DFIFO_N3326,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N16299
    );
  SEGMENT_DFIFO_BU620 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3715,
      ADR1 => SEGMENT_DFIFO_N4104,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N16301
    );
  SEGMENT_DFIFO_BU621 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N16299,
      IB => SEGMENT_DFIFO_N16301,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N16277
    );
  SEGMENT_DFIFO_BU622 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N16193,
      IB => SEGMENT_DFIFO_N16277,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N16363
    );
  SEGMENT_DFIFO_BU623 : X_FF
    port map (
      I => SEGMENT_DFIFO_N16363,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(13)
    );
  SEGMENT_DFIFO_BU624 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1382,
      ADR1 => SEGMENT_DFIFO_N1771,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N16461
    );
  SEGMENT_DFIFO_BU625 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2160,
      ADR1 => SEGMENT_DFIFO_N2549,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N16463
    );
  SEGMENT_DFIFO_BU626 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N16461,
      IB => SEGMENT_DFIFO_N16463,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N16439
    );
  SEGMENT_DFIFO_BU627 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2938,
      ADR1 => SEGMENT_DFIFO_N3327,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N16545
    );
  SEGMENT_DFIFO_BU628 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3716,
      ADR1 => SEGMENT_DFIFO_N4105,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N16547
    );
  SEGMENT_DFIFO_BU629 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N16545,
      IB => SEGMENT_DFIFO_N16547,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N16523
    );
  SEGMENT_DFIFO_BU630 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N16439,
      IB => SEGMENT_DFIFO_N16523,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N16609
    );
  SEGMENT_DFIFO_BU631 : X_FF
    port map (
      I => SEGMENT_DFIFO_N16609,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(14)
    );
  SEGMENT_DFIFO_BU632 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1383,
      ADR1 => SEGMENT_DFIFO_N1772,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N16707
    );
  SEGMENT_DFIFO_BU633 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2161,
      ADR1 => SEGMENT_DFIFO_N2550,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N16709
    );
  SEGMENT_DFIFO_BU634 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N16707,
      IB => SEGMENT_DFIFO_N16709,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N16685
    );
  SEGMENT_DFIFO_BU635 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2939,
      ADR1 => SEGMENT_DFIFO_N3328,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N16791
    );
  SEGMENT_DFIFO_BU636 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3717,
      ADR1 => SEGMENT_DFIFO_N4106,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N16793
    );
  SEGMENT_DFIFO_BU637 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N16791,
      IB => SEGMENT_DFIFO_N16793,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N16769
    );
  SEGMENT_DFIFO_BU638 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N16685,
      IB => SEGMENT_DFIFO_N16769,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N16855
    );
  SEGMENT_DFIFO_BU639 : X_FF
    port map (
      I => SEGMENT_DFIFO_N16855,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(15)
    );
  SEGMENT_DFIFO_BU640 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1384,
      ADR1 => SEGMENT_DFIFO_N1773,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N16953
    );
  SEGMENT_DFIFO_BU641 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2162,
      ADR1 => SEGMENT_DFIFO_N2551,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N16955
    );
  SEGMENT_DFIFO_BU642 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N16953,
      IB => SEGMENT_DFIFO_N16955,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N16931
    );
  SEGMENT_DFIFO_BU643 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2940,
      ADR1 => SEGMENT_DFIFO_N3329,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N17037
    );
  SEGMENT_DFIFO_BU644 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3718,
      ADR1 => SEGMENT_DFIFO_N4107,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N17039
    );
  SEGMENT_DFIFO_BU645 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N17037,
      IB => SEGMENT_DFIFO_N17039,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N17015
    );
  SEGMENT_DFIFO_BU646 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N16931,
      IB => SEGMENT_DFIFO_N17015,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N17101
    );
  SEGMENT_DFIFO_BU647 : X_FF
    port map (
      I => SEGMENT_DFIFO_N17101,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(16)
    );
  SEGMENT_DFIFO_BU648 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1385,
      ADR1 => SEGMENT_DFIFO_N1774,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N17199
    );
  SEGMENT_DFIFO_BU649 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2163,
      ADR1 => SEGMENT_DFIFO_N2552,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N17201
    );
  SEGMENT_DFIFO_BU650 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N17199,
      IB => SEGMENT_DFIFO_N17201,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N17177
    );
  SEGMENT_DFIFO_BU651 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2941,
      ADR1 => SEGMENT_DFIFO_N3330,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N17283
    );
  SEGMENT_DFIFO_BU652 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3719,
      ADR1 => SEGMENT_DFIFO_N4108,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N17285
    );
  SEGMENT_DFIFO_BU653 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N17283,
      IB => SEGMENT_DFIFO_N17285,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N17261
    );
  SEGMENT_DFIFO_BU654 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N17177,
      IB => SEGMENT_DFIFO_N17261,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N17347
    );
  SEGMENT_DFIFO_BU655 : X_FF
    port map (
      I => SEGMENT_DFIFO_N17347,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(17)
    );
  SEGMENT_DFIFO_BU656 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1386,
      ADR1 => SEGMENT_DFIFO_N1775,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N17445
    );
  SEGMENT_DFIFO_BU657 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2164,
      ADR1 => SEGMENT_DFIFO_N2553,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N17447
    );
  SEGMENT_DFIFO_BU658 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N17445,
      IB => SEGMENT_DFIFO_N17447,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N17423
    );
  SEGMENT_DFIFO_BU659 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2942,
      ADR1 => SEGMENT_DFIFO_N3331,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N17529
    );
  SEGMENT_DFIFO_BU660 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3720,
      ADR1 => SEGMENT_DFIFO_N4109,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N17531
    );
  SEGMENT_DFIFO_BU661 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N17529,
      IB => SEGMENT_DFIFO_N17531,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N17507
    );
  SEGMENT_DFIFO_BU662 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N17423,
      IB => SEGMENT_DFIFO_N17507,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N17593
    );
  SEGMENT_DFIFO_BU663 : X_FF
    port map (
      I => SEGMENT_DFIFO_N17593,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(18)
    );
  SEGMENT_DFIFO_BU664 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1387,
      ADR1 => SEGMENT_DFIFO_N1776,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N17691
    );
  SEGMENT_DFIFO_BU665 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2165,
      ADR1 => SEGMENT_DFIFO_N2554,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N17693
    );
  SEGMENT_DFIFO_BU666 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N17691,
      IB => SEGMENT_DFIFO_N17693,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N17669
    );
  SEGMENT_DFIFO_BU667 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2943,
      ADR1 => SEGMENT_DFIFO_N3332,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N17775
    );
  SEGMENT_DFIFO_BU668 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3721,
      ADR1 => SEGMENT_DFIFO_N4110,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N17777
    );
  SEGMENT_DFIFO_BU669 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N17775,
      IB => SEGMENT_DFIFO_N17777,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N17753
    );
  SEGMENT_DFIFO_BU670 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N17669,
      IB => SEGMENT_DFIFO_N17753,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N17839
    );
  SEGMENT_DFIFO_BU671 : X_FF
    port map (
      I => SEGMENT_DFIFO_N17839,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(19)
    );
  SEGMENT_DFIFO_BU672 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1388,
      ADR1 => SEGMENT_DFIFO_N1777,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N17937
    );
  SEGMENT_DFIFO_BU673 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2166,
      ADR1 => SEGMENT_DFIFO_N2555,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N17939
    );
  SEGMENT_DFIFO_BU674 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N17937,
      IB => SEGMENT_DFIFO_N17939,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N17915
    );
  SEGMENT_DFIFO_BU675 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2944,
      ADR1 => SEGMENT_DFIFO_N3333,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N18021
    );
  SEGMENT_DFIFO_BU676 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3722,
      ADR1 => SEGMENT_DFIFO_N4111,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N18023
    );
  SEGMENT_DFIFO_BU677 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N18021,
      IB => SEGMENT_DFIFO_N18023,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N17999
    );
  SEGMENT_DFIFO_BU678 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N17915,
      IB => SEGMENT_DFIFO_N17999,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N18085
    );
  SEGMENT_DFIFO_BU679 : X_FF
    port map (
      I => SEGMENT_DFIFO_N18085,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(20)
    );
  SEGMENT_DFIFO_BU680 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1389,
      ADR1 => SEGMENT_DFIFO_N1778,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N18183
    );
  SEGMENT_DFIFO_BU681 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2167,
      ADR1 => SEGMENT_DFIFO_N2556,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N18185
    );
  SEGMENT_DFIFO_BU682 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N18183,
      IB => SEGMENT_DFIFO_N18185,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N18161
    );
  SEGMENT_DFIFO_BU683 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2945,
      ADR1 => SEGMENT_DFIFO_N3334,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N18267
    );
  SEGMENT_DFIFO_BU684 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3723,
      ADR1 => SEGMENT_DFIFO_N4112,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N18269
    );
  SEGMENT_DFIFO_BU685 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N18267,
      IB => SEGMENT_DFIFO_N18269,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N18245
    );
  SEGMENT_DFIFO_BU686 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N18161,
      IB => SEGMENT_DFIFO_N18245,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N18331
    );
  SEGMENT_DFIFO_BU687 : X_FF
    port map (
      I => SEGMENT_DFIFO_N18331,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(21)
    );
  SEGMENT_DFIFO_BU688 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1390,
      ADR1 => SEGMENT_DFIFO_N1779,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N18429
    );
  SEGMENT_DFIFO_BU689 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2168,
      ADR1 => SEGMENT_DFIFO_N2557,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N18431
    );
  SEGMENT_DFIFO_BU690 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N18429,
      IB => SEGMENT_DFIFO_N18431,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N18407
    );
  SEGMENT_DFIFO_BU691 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2946,
      ADR1 => SEGMENT_DFIFO_N3335,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N18513
    );
  SEGMENT_DFIFO_BU692 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3724,
      ADR1 => SEGMENT_DFIFO_N4113,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N18515
    );
  SEGMENT_DFIFO_BU693 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N18513,
      IB => SEGMENT_DFIFO_N18515,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N18491
    );
  SEGMENT_DFIFO_BU694 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N18407,
      IB => SEGMENT_DFIFO_N18491,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N18577
    );
  SEGMENT_DFIFO_BU695 : X_FF
    port map (
      I => SEGMENT_DFIFO_N18577,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(22)
    );
  SEGMENT_DFIFO_BU696 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1391,
      ADR1 => SEGMENT_DFIFO_N1780,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N18675
    );
  SEGMENT_DFIFO_BU697 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2169,
      ADR1 => SEGMENT_DFIFO_N2558,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N18677
    );
  SEGMENT_DFIFO_BU698 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N18675,
      IB => SEGMENT_DFIFO_N18677,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N18653
    );
  SEGMENT_DFIFO_BU699 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2947,
      ADR1 => SEGMENT_DFIFO_N3336,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N18759
    );
  SEGMENT_DFIFO_BU700 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3725,
      ADR1 => SEGMENT_DFIFO_N4114,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N18761
    );
  SEGMENT_DFIFO_BU701 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N18759,
      IB => SEGMENT_DFIFO_N18761,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N18737
    );
  SEGMENT_DFIFO_BU702 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N18653,
      IB => SEGMENT_DFIFO_N18737,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N18823
    );
  SEGMENT_DFIFO_BU703 : X_FF
    port map (
      I => SEGMENT_DFIFO_N18823,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(23)
    );
  SEGMENT_DFIFO_BU704 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1392,
      ADR1 => SEGMENT_DFIFO_N1781,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N18921
    );
  SEGMENT_DFIFO_BU705 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2170,
      ADR1 => SEGMENT_DFIFO_N2559,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N18923
    );
  SEGMENT_DFIFO_BU706 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N18921,
      IB => SEGMENT_DFIFO_N18923,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N18899
    );
  SEGMENT_DFIFO_BU707 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2948,
      ADR1 => SEGMENT_DFIFO_N3337,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N19005
    );
  SEGMENT_DFIFO_BU708 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3726,
      ADR1 => SEGMENT_DFIFO_N4115,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N19007
    );
  SEGMENT_DFIFO_BU709 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N19005,
      IB => SEGMENT_DFIFO_N19007,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N18983
    );
  SEGMENT_DFIFO_BU710 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N18899,
      IB => SEGMENT_DFIFO_N18983,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N19069
    );
  SEGMENT_DFIFO_BU711 : X_FF
    port map (
      I => SEGMENT_DFIFO_N19069,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(24)
    );
  SEGMENT_DFIFO_BU712 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1393,
      ADR1 => SEGMENT_DFIFO_N1782,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N19167
    );
  SEGMENT_DFIFO_BU713 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2171,
      ADR1 => SEGMENT_DFIFO_N2560,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N19169
    );
  SEGMENT_DFIFO_BU714 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N19167,
      IB => SEGMENT_DFIFO_N19169,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N19145
    );
  SEGMENT_DFIFO_BU715 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2949,
      ADR1 => SEGMENT_DFIFO_N3338,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N19251
    );
  SEGMENT_DFIFO_BU716 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3727,
      ADR1 => SEGMENT_DFIFO_N4116,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N19253
    );
  SEGMENT_DFIFO_BU717 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N19251,
      IB => SEGMENT_DFIFO_N19253,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N19229
    );
  SEGMENT_DFIFO_BU718 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N19145,
      IB => SEGMENT_DFIFO_N19229,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N19315
    );
  SEGMENT_DFIFO_BU719 : X_FF
    port map (
      I => SEGMENT_DFIFO_N19315,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(25)
    );
  SEGMENT_DFIFO_BU720 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1394,
      ADR1 => SEGMENT_DFIFO_N1783,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N19413
    );
  SEGMENT_DFIFO_BU721 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2172,
      ADR1 => SEGMENT_DFIFO_N2561,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N19415
    );
  SEGMENT_DFIFO_BU722 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N19413,
      IB => SEGMENT_DFIFO_N19415,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N19391
    );
  SEGMENT_DFIFO_BU723 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2950,
      ADR1 => SEGMENT_DFIFO_N3339,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N19497
    );
  SEGMENT_DFIFO_BU724 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3728,
      ADR1 => SEGMENT_DFIFO_N4117,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N19499
    );
  SEGMENT_DFIFO_BU725 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N19497,
      IB => SEGMENT_DFIFO_N19499,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N19475
    );
  SEGMENT_DFIFO_BU726 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N19391,
      IB => SEGMENT_DFIFO_N19475,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N19561
    );
  SEGMENT_DFIFO_BU727 : X_FF
    port map (
      I => SEGMENT_DFIFO_N19561,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(26)
    );
  SEGMENT_DFIFO_BU728 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1395,
      ADR1 => SEGMENT_DFIFO_N1784,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N19659
    );
  SEGMENT_DFIFO_BU729 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2173,
      ADR1 => SEGMENT_DFIFO_N2562,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N19661
    );
  SEGMENT_DFIFO_BU730 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N19659,
      IB => SEGMENT_DFIFO_N19661,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N19637
    );
  SEGMENT_DFIFO_BU731 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2951,
      ADR1 => SEGMENT_DFIFO_N3340,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N19743
    );
  SEGMENT_DFIFO_BU732 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3729,
      ADR1 => SEGMENT_DFIFO_N4118,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N19745
    );
  SEGMENT_DFIFO_BU733 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N19743,
      IB => SEGMENT_DFIFO_N19745,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N19721
    );
  SEGMENT_DFIFO_BU734 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N19637,
      IB => SEGMENT_DFIFO_N19721,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N19807
    );
  SEGMENT_DFIFO_BU735 : X_FF
    port map (
      I => SEGMENT_DFIFO_N19807,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(27)
    );
  SEGMENT_DFIFO_BU736 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1396,
      ADR1 => SEGMENT_DFIFO_N1785,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N19905
    );
  SEGMENT_DFIFO_BU737 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2174,
      ADR1 => SEGMENT_DFIFO_N2563,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N19907
    );
  SEGMENT_DFIFO_BU738 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N19905,
      IB => SEGMENT_DFIFO_N19907,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N19883
    );
  SEGMENT_DFIFO_BU739 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2952,
      ADR1 => SEGMENT_DFIFO_N3341,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N19989
    );
  SEGMENT_DFIFO_BU740 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3730,
      ADR1 => SEGMENT_DFIFO_N4119,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N19991
    );
  SEGMENT_DFIFO_BU741 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N19989,
      IB => SEGMENT_DFIFO_N19991,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N19967
    );
  SEGMENT_DFIFO_BU742 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N19883,
      IB => SEGMENT_DFIFO_N19967,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N20053
    );
  SEGMENT_DFIFO_BU743 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20053,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(28)
    );
  SEGMENT_DFIFO_BU744 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1397,
      ADR1 => SEGMENT_DFIFO_N1786,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N20151
    );
  SEGMENT_DFIFO_BU745 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2175,
      ADR1 => SEGMENT_DFIFO_N2564,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N20153
    );
  SEGMENT_DFIFO_BU746 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N20151,
      IB => SEGMENT_DFIFO_N20153,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N20129
    );
  SEGMENT_DFIFO_BU747 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2953,
      ADR1 => SEGMENT_DFIFO_N3342,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N20235
    );
  SEGMENT_DFIFO_BU748 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3731,
      ADR1 => SEGMENT_DFIFO_N4120,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N20237
    );
  SEGMENT_DFIFO_BU749 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N20235,
      IB => SEGMENT_DFIFO_N20237,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N20213
    );
  SEGMENT_DFIFO_BU750 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N20129,
      IB => SEGMENT_DFIFO_N20213,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N20299
    );
  SEGMENT_DFIFO_BU751 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20299,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(29)
    );
  SEGMENT_DFIFO_BU752 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1398,
      ADR1 => SEGMENT_DFIFO_N1787,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N20397
    );
  SEGMENT_DFIFO_BU753 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2176,
      ADR1 => SEGMENT_DFIFO_N2565,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N20399
    );
  SEGMENT_DFIFO_BU754 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N20397,
      IB => SEGMENT_DFIFO_N20399,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N20375
    );
  SEGMENT_DFIFO_BU755 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2954,
      ADR1 => SEGMENT_DFIFO_N3343,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N20481
    );
  SEGMENT_DFIFO_BU756 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3732,
      ADR1 => SEGMENT_DFIFO_N4121,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N20483
    );
  SEGMENT_DFIFO_BU757 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N20481,
      IB => SEGMENT_DFIFO_N20483,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N20459
    );
  SEGMENT_DFIFO_BU758 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N20375,
      IB => SEGMENT_DFIFO_N20459,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N20545
    );
  SEGMENT_DFIFO_BU759 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20545,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(30)
    );
  SEGMENT_DFIFO_BU760 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N1399,
      ADR1 => SEGMENT_DFIFO_N1788,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N20643
    );
  SEGMENT_DFIFO_BU761 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2177,
      ADR1 => SEGMENT_DFIFO_N2566,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N20645
    );
  SEGMENT_DFIFO_BU762 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N20643,
      IB => SEGMENT_DFIFO_N20645,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N20621
    );
  SEGMENT_DFIFO_BU763 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2955,
      ADR1 => SEGMENT_DFIFO_N3344,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N20727
    );
  SEGMENT_DFIFO_BU764 : X_LUT4
    generic map (
      INIT => X"caca"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N3733,
      ADR1 => SEGMENT_DFIFO_N4122,
      ADR2 => SEGMENT_DFIFO_N218,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N20729
    );
  SEGMENT_DFIFO_BU765 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N20727,
      IB => SEGMENT_DFIFO_N20729,
      SEL => SEGMENT_DFIFO_N217,
      O => SEGMENT_DFIFO_N20705
    );
  SEGMENT_DFIFO_BU766 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N20621,
      IB => SEGMENT_DFIFO_N20705,
      SEL => SEGMENT_DFIFO_N216,
      O => SEGMENT_DFIFO_N20791
    );
  SEGMENT_DFIFO_BU767 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20791,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N224,
      SET => GND,
      RST => GSR,
      O => SEGMENT_DFIFO_DOUT(31)
    );
  SEGMENT_DFIFO_BU768 : X_LUT4
    generic map (
      INIT => X"0100"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N208,
      ADR1 => SEGMENT_DFIFO_N209,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N226,
      O => SEGMENT_DFIFO_N912
    );
  SEGMENT_DFIFO_BU769 : X_LUT4
    generic map (
      INIT => X"1000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N208,
      ADR1 => SEGMENT_DFIFO_N209,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N226,
      O => SEGMENT_DFIFO_N913
    );
  SEGMENT_DFIFO_BU770 : X_LUT4
    generic map (
      INIT => X"0400"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N208,
      ADR1 => SEGMENT_DFIFO_N209,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N226,
      O => SEGMENT_DFIFO_N914
    );
  SEGMENT_DFIFO_BU771 : X_LUT4
    generic map (
      INIT => X"4000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N208,
      ADR1 => SEGMENT_DFIFO_N209,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N226,
      O => SEGMENT_DFIFO_N915
    );
  SEGMENT_DFIFO_BU772 : X_LUT4
    generic map (
      INIT => X"0200"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N208,
      ADR1 => SEGMENT_DFIFO_N209,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N226,
      O => SEGMENT_DFIFO_N916
    );
  SEGMENT_DFIFO_BU773 : X_LUT4
    generic map (
      INIT => X"2000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N208,
      ADR1 => SEGMENT_DFIFO_N209,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N226,
      O => SEGMENT_DFIFO_N917
    );
  SEGMENT_DFIFO_BU774 : X_LUT4
    generic map (
      INIT => X"0800"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N208,
      ADR1 => SEGMENT_DFIFO_N209,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N226,
      O => SEGMENT_DFIFO_N918
    );
  SEGMENT_DFIFO_BU775 : X_LUT4
    generic map (
      INIT => X"8000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N208,
      ADR1 => SEGMENT_DFIFO_N209,
      ADR2 => SEGMENT_DFIFO_N210,
      ADR3 => SEGMENT_DFIFO_N226,
      O => SEGMENT_DFIFO_N919
    );
  SEGMENT_DFIFO_BU776 : X_LUT4
    generic map (
      INIT => X"2222"
    )
    port map (
      ADR0 => SEGMENT_N_451_I,
      ADR1 => SEGMENT_DFIFO_EMPTY,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N20864
    );
  SEGMENT_DFIFO_BU777 : X_LUT4
    generic map (
      INIT => X"2222"
    )
    port map (
      ADR0 => SEGMENT_N_451_I,
      ADR1 => SEGMENT_DFIFO_EMPTY,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N224
    );
  SEGMENT_DFIFO_BU778 : X_LUT4
    generic map (
      INIT => X"5555"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N222,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N21283
    );
  SEGMENT_DFIFO_BU779 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N222,
      IB => SEGMENT_DFIFO_N2147483641,
      SEL => SEGMENT_DFIFO_N21283,
      O => SEGMENT_DFIFO_N21297
    );
  SEGMENT_DFIFO_BU780 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N21283,
      I1 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N21275
    );
  SEGMENT_DFIFO_BU781 : X_FF
    port map (
      I => SEGMENT_DFIFO_N21275,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU781_GSR_OR,
      O => SEGMENT_DFIFO_N222
    );
  SEGMENT_DFIFO_BU782 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N221,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N21313
    );
  SEGMENT_DFIFO_BU783 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N221,
      IB => SEGMENT_DFIFO_N21297,
      SEL => SEGMENT_DFIFO_N21313,
      O => SEGMENT_DFIFO_N21327
    );
  SEGMENT_DFIFO_BU784 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N21313,
      I1 => SEGMENT_DFIFO_N21297,
      O => SEGMENT_DFIFO_N21276
    );
  SEGMENT_DFIFO_BU785 : X_FF
    port map (
      I => SEGMENT_DFIFO_N21276,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU785_GSR_OR,
      O => SEGMENT_DFIFO_N221
    );
  SEGMENT_DFIFO_BU786 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N220,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N21343
    );
  SEGMENT_DFIFO_BU787 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N220,
      IB => SEGMENT_DFIFO_N21327,
      SEL => SEGMENT_DFIFO_N21343,
      O => SEGMENT_DFIFO_N21357
    );
  SEGMENT_DFIFO_BU788 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N21343,
      I1 => SEGMENT_DFIFO_N21327,
      O => SEGMENT_DFIFO_N21277
    );
  SEGMENT_DFIFO_BU789 : X_FF
    port map (
      I => SEGMENT_DFIFO_N21277,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU789_GSR_OR,
      O => SEGMENT_DFIFO_N220
    );
  SEGMENT_DFIFO_BU790 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N219,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N21373
    );
  SEGMENT_DFIFO_BU791 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N219,
      IB => SEGMENT_DFIFO_N21357,
      SEL => SEGMENT_DFIFO_N21373,
      O => SEGMENT_DFIFO_N21387
    );
  SEGMENT_DFIFO_BU792 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N21373,
      I1 => SEGMENT_DFIFO_N21357,
      O => SEGMENT_DFIFO_N21278
    );
  SEGMENT_DFIFO_BU793 : X_FF
    port map (
      I => SEGMENT_DFIFO_N21278,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU793_GSR_OR,
      O => SEGMENT_DFIFO_N219
    );
  SEGMENT_DFIFO_BU794 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N218,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N21403
    );
  SEGMENT_DFIFO_BU795 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N218,
      IB => SEGMENT_DFIFO_N21387,
      SEL => SEGMENT_DFIFO_N21403,
      O => SEGMENT_DFIFO_N21417
    );
  SEGMENT_DFIFO_BU796 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N21403,
      I1 => SEGMENT_DFIFO_N21387,
      O => SEGMENT_DFIFO_N21279
    );
  SEGMENT_DFIFO_BU797 : X_FF
    port map (
      I => SEGMENT_DFIFO_N21279,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU797_GSR_OR,
      O => SEGMENT_DFIFO_N218
    );
  SEGMENT_DFIFO_BU798 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N217,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N21433
    );
  SEGMENT_DFIFO_BU799 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N217,
      IB => SEGMENT_DFIFO_N21417,
      SEL => SEGMENT_DFIFO_N21433,
      O => SEGMENT_DFIFO_N21447
    );
  SEGMENT_DFIFO_BU800 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N21433,
      I1 => SEGMENT_DFIFO_N21417,
      O => SEGMENT_DFIFO_N21280
    );
  SEGMENT_DFIFO_BU801 : X_FF
    port map (
      I => SEGMENT_DFIFO_N21280,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU801_GSR_OR,
      O => SEGMENT_DFIFO_N217
    );
  SEGMENT_DFIFO_BU802 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N216,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N21463
    );
  SEGMENT_DFIFO_BU803 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N21463,
      I1 => SEGMENT_DFIFO_N21447,
      O => SEGMENT_DFIFO_N21281
    );
  SEGMENT_DFIFO_BU804 : X_FF
    port map (
      I => SEGMENT_DFIFO_N21281,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU804_GSR_OR,
      O => SEGMENT_DFIFO_N216
    );
  SEGMENT_DFIFO_BU805 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N222,
      ADR1 => SEGMENT_DFIFO_N221,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N21673
    );
  SEGMENT_DFIFO_BU806 : X_FF
    port map (
      I => SEGMENT_DFIFO_N21673,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU806_GSR_OR,
      O => SEGMENT_DFIFO_N20918
    );
  SEGMENT_DFIFO_BU807 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N221,
      ADR1 => SEGMENT_DFIFO_N220,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N21749
    );
  SEGMENT_DFIFO_BU808 : X_FF
    port map (
      I => SEGMENT_DFIFO_N21749,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU808_GSR_OR,
      O => SEGMENT_DFIFO_N20917
    );
  SEGMENT_DFIFO_BU809 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N220,
      ADR1 => SEGMENT_DFIFO_N219,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N21825
    );
  SEGMENT_DFIFO_BU810 : X_FF
    port map (
      I => SEGMENT_DFIFO_N21825,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU810_GSR_OR,
      O => SEGMENT_DFIFO_N20916
    );
  SEGMENT_DFIFO_BU811 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N219,
      ADR1 => SEGMENT_DFIFO_N218,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N21901
    );
  SEGMENT_DFIFO_BU812 : X_FF
    port map (
      I => SEGMENT_DFIFO_N21901,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU812_GSR_OR,
      O => SEGMENT_DFIFO_N20915
    );
  SEGMENT_DFIFO_BU813 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N218,
      ADR1 => SEGMENT_DFIFO_N217,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N21977
    );
  SEGMENT_DFIFO_BU814 : X_FF
    port map (
      I => SEGMENT_DFIFO_N21977,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU814_GSR_OR,
      O => SEGMENT_DFIFO_N20914
    );
  SEGMENT_DFIFO_BU815 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N217,
      ADR1 => SEGMENT_DFIFO_N216,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N22053
    );
  SEGMENT_DFIFO_BU816 : X_FF
    port map (
      I => SEGMENT_DFIFO_N22053,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU816_GSR_OR,
      O => SEGMENT_DFIFO_N20913
    );
  SEGMENT_DFIFO_BU817 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N216,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N22129
    );
  SEGMENT_DFIFO_BU818 : X_FF
    port map (
      I => SEGMENT_DFIFO_N22129,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => SEGMENT_DFIFO_BU818_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N20912
    );
  SEGMENT_DFIFO_BU819 : X_LUT4
    generic map (
      INIT => X"fffe"
    )
    port map (
      ADR0 => SEGMENT_N_451_I,
      ADR1 => SEGMENT_DFIFO_EMPTY,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N22216
    );
  SEGMENT_DFIFO_BU820 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N2147483641,
      IB => SEGMENT_DFIFO_N2147483644,
      SEL => SEGMENT_DFIFO_BU820_S,
      O => SEGMENT_DFIFO_BU820_O
    );
  SEGMENT_DFIFO_BU820_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_DFIFO_BU820_O,
      O => SEGMENT_DFIFO_BU820_LO
    );
  SEGMENT_DFIFO_BU821 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20982,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => SEGMENT_DFIFO_BU821_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N20998
    );
  SEGMENT_DFIFO_BU822 : X_LUT4
    generic map (
      INIT => X"ffff"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2147483641,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N22220
    );
  SEGMENT_DFIFO_BU823 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N2147483641,
      IB => SEGMENT_DFIFO_N2147483644,
      SEL => SEGMENT_DFIFO_N22220,
      O => SEGMENT_DFIFO_BU823_O
    );
  SEGMENT_DFIFO_BU823_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_DFIFO_BU823_O,
      O => SEGMENT_DFIFO_BU823_LO
    );
  SEGMENT_DFIFO_BU824 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20981,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => GND,
      RST => SEGMENT_DFIFO_BU824_GSR_OR,
      O => SEGMENT_DFIFO_N20997
    );
  SEGMENT_DFIFO_BU825 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N20918,
      ADR1 => SEGMENT_DFIFO_N20982,
      ADR2 => SEGMENT_DFIFO_N20998,
      ADR3 => SEGMENT_DFIFO_EMPTY,
      O => SEGMENT_DFIFO_N22205
    );
  SEGMENT_DFIFO_BU826 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N2147483641,
      IB => SEGMENT_DFIFO_N2147483644,
      SEL => SEGMENT_DFIFO_N22205,
      O => SEGMENT_DFIFO_N22213
    );
  SEGMENT_DFIFO_BU827 : X_FF
    port map (
      I => SEGMENT_DFIFO_N2147483641,
      CLK => SEGMENT_DFIFO_N2147483641,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3757_5
    );
  SEGMENT_DFIFO_BU828 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N20917,
      ADR1 => SEGMENT_DFIFO_N20981,
      ADR2 => SEGMENT_DFIFO_N20997,
      ADR3 => SEGMENT_DFIFO_EMPTY,
      O => SEGMENT_DFIFO_N22204
    );
  SEGMENT_DFIFO_BU829 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N2147483641,
      IB => SEGMENT_DFIFO_N22213,
      SEL => SEGMENT_DFIFO_N22204,
      O => SEGMENT_DFIFO_N22212
    );
  SEGMENT_DFIFO_BU830 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20980,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => GND,
      RST => SEGMENT_DFIFO_BU830_GSR_OR,
      O => SEGMENT_DFIFO_N20996
    );
  SEGMENT_DFIFO_BU831 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N20916,
      ADR1 => SEGMENT_DFIFO_N20980,
      ADR2 => SEGMENT_DFIFO_N20996,
      ADR3 => SEGMENT_DFIFO_EMPTY,
      O => SEGMENT_DFIFO_N22203
    );
  SEGMENT_DFIFO_BU832 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N2147483641,
      IB => SEGMENT_DFIFO_N22212,
      SEL => SEGMENT_DFIFO_N22203,
      O => SEGMENT_DFIFO_N22211
    );
  SEGMENT_DFIFO_BU833 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20979,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => GND,
      RST => SEGMENT_DFIFO_BU833_GSR_OR,
      O => SEGMENT_DFIFO_N20995
    );
  SEGMENT_DFIFO_BU834 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N20915,
      ADR1 => SEGMENT_DFIFO_N20979,
      ADR2 => SEGMENT_DFIFO_N20995,
      ADR3 => SEGMENT_DFIFO_EMPTY,
      O => SEGMENT_DFIFO_N22202
    );
  SEGMENT_DFIFO_BU835 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N2147483641,
      IB => SEGMENT_DFIFO_N22211,
      SEL => SEGMENT_DFIFO_N22202,
      O => SEGMENT_DFIFO_N22210
    );
  SEGMENT_DFIFO_BU836 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20978,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => GND,
      RST => SEGMENT_DFIFO_BU836_GSR_OR,
      O => SEGMENT_DFIFO_N20994
    );
  SEGMENT_DFIFO_BU837 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N20914,
      ADR1 => SEGMENT_DFIFO_N20978,
      ADR2 => SEGMENT_DFIFO_N20994,
      ADR3 => SEGMENT_DFIFO_EMPTY,
      O => SEGMENT_DFIFO_N22201
    );
  SEGMENT_DFIFO_BU838 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N2147483641,
      IB => SEGMENT_DFIFO_N22210,
      SEL => SEGMENT_DFIFO_N22201,
      O => SEGMENT_DFIFO_N22209
    );
  SEGMENT_DFIFO_BU839 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20977,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => GND,
      RST => SEGMENT_DFIFO_BU839_GSR_OR,
      O => SEGMENT_DFIFO_N20993
    );
  SEGMENT_DFIFO_BU840 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N20913,
      ADR1 => SEGMENT_DFIFO_N20977,
      ADR2 => SEGMENT_DFIFO_N20993,
      ADR3 => SEGMENT_DFIFO_EMPTY,
      O => SEGMENT_DFIFO_N22200
    );
  SEGMENT_DFIFO_BU841 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N2147483641,
      IB => SEGMENT_DFIFO_N22209,
      SEL => SEGMENT_DFIFO_N22200,
      O => SEGMENT_DFIFO_N22208
    );
  SEGMENT_DFIFO_BU842 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20976,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => SEGMENT_DFIFO_BU842_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N20992
    );
  SEGMENT_DFIFO_BU843 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N20912,
      ADR1 => SEGMENT_DFIFO_N20976,
      ADR2 => SEGMENT_DFIFO_N20992,
      ADR3 => SEGMENT_DFIFO_EMPTY,
      O => SEGMENT_DFIFO_N22199
    );
  SEGMENT_DFIFO_BU844 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N2147483641,
      IB => SEGMENT_DFIFO_N22208,
      SEL => SEGMENT_DFIFO_N22199,
      O => SEGMENT_DFIFO_BU844_O
    );
  SEGMENT_DFIFO_BU844_MUXCY_D_BUF : X_BUF
    port map (
      I => SEGMENT_DFIFO_BU844_O,
      O => SEGMENT_DFIFO_N22207
    );
  SEGMENT_DFIFO_BU845 : X_LUT4
    generic map (
      INIT => X"ffff"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2147483641,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => NGD2VHDL_X_3775_4
    );
  SEGMENT_DFIFO_BU846 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N2147483641,
      I1 => SEGMENT_DFIFO_N22207,
      O => SEGMENT_DFIFO_N22218
    );
  SEGMENT_DFIFO_BU847 : X_FF
    port map (
      I => SEGMENT_DFIFO_N22218,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N22216,
      SET => SEGMENT_DFIFO_BU847_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_EMPTY
    );
  SEGMENT_DFIFO_BU848 : X_FF
    port map (
      I => SEGMENT_DFIFO_N222,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => SEGMENT_DFIFO_BU848_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N20910
    );
  SEGMENT_DFIFO_BU849 : X_FF
    port map (
      I => SEGMENT_DFIFO_N221,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => SEGMENT_DFIFO_BU849_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N20909
    );
  SEGMENT_DFIFO_BU850 : X_FF
    port map (
      I => SEGMENT_DFIFO_N220,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => SEGMENT_DFIFO_BU850_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N20908
    );
  SEGMENT_DFIFO_BU851 : X_FF
    port map (
      I => SEGMENT_DFIFO_N219,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => SEGMENT_DFIFO_BU851_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N20907
    );
  SEGMENT_DFIFO_BU852 : X_FF
    port map (
      I => SEGMENT_DFIFO_N218,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => SEGMENT_DFIFO_BU852_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N20906
    );
  SEGMENT_DFIFO_BU853 : X_FF
    port map (
      I => SEGMENT_DFIFO_N217,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => SEGMENT_DFIFO_BU853_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N20905
    );
  SEGMENT_DFIFO_BU854 : X_FF
    port map (
      I => SEGMENT_DFIFO_N216,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => SEGMENT_DFIFO_BU854_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N20904
    );
  SEGMENT_DFIFO_BU855 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20982,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => GND,
      RST => SEGMENT_DFIFO_BU855_GSR_OR,
      O => SEGMENT_DFIFO_N21006
    );
  SEGMENT_DFIFO_BU856 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20981,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => GND,
      RST => SEGMENT_DFIFO_BU856_GSR_OR,
      O => SEGMENT_DFIFO_N21005
    );
  SEGMENT_DFIFO_BU857 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20980,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => GND,
      RST => SEGMENT_DFIFO_BU857_GSR_OR,
      O => SEGMENT_DFIFO_N21004
    );
  SEGMENT_DFIFO_BU858 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20979,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => GND,
      RST => SEGMENT_DFIFO_BU858_GSR_OR,
      O => SEGMENT_DFIFO_N21003
    );
  SEGMENT_DFIFO_BU859 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20978,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => GND,
      RST => SEGMENT_DFIFO_BU859_GSR_OR,
      O => SEGMENT_DFIFO_N21002
    );
  SEGMENT_DFIFO_BU860 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20977,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => GND,
      RST => SEGMENT_DFIFO_BU860_GSR_OR,
      O => SEGMENT_DFIFO_N21001
    );
  SEGMENT_DFIFO_BU861 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20976,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => SEGMENT_DFIFO_BU861_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N21000
    );
  SEGMENT_DFIFO_BU862 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N21001,
      ADR1 => SEGMENT_DFIFO_N21000,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N22723
    );
  SEGMENT_DFIFO_BU863 : X_LUT4
    generic map (
      INIT => X"9696"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N21002,
      ADR1 => SEGMENT_DFIFO_N21001,
      ADR2 => SEGMENT_DFIFO_N21000,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N22722
    );
  SEGMENT_DFIFO_BU864 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N21003,
      ADR1 => SEGMENT_DFIFO_N21002,
      ADR2 => SEGMENT_DFIFO_N21001,
      ADR3 => SEGMENT_DFIFO_N21000,
      O => SEGMENT_DFIFO_N22708
    );
  SEGMENT_DFIFO_BU865 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N21004,
      ADR1 => SEGMENT_DFIFO_N22708,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N22720
    );
  SEGMENT_DFIFO_BU866 : X_LUT4
    generic map (
      INIT => X"9696"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N21004,
      ADR1 => SEGMENT_DFIFO_N21005,
      ADR2 => SEGMENT_DFIFO_N22708,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N22719
    );
  SEGMENT_DFIFO_BU867 : X_LUT4
    generic map (
      INIT => X"6996"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N21004,
      ADR1 => SEGMENT_DFIFO_N21005,
      ADR2 => SEGMENT_DFIFO_N21006,
      ADR3 => SEGMENT_DFIFO_N22708,
      O => SEGMENT_DFIFO_N22718
    );
  SEGMENT_DFIFO_BU868 : X_FF
    port map (
      I => SEGMENT_DFIFO_N22718,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => SEGMENT_DFIFO_BU868_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N21014
    );
  SEGMENT_DFIFO_BU869 : X_FF
    port map (
      I => SEGMENT_DFIFO_N22719,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => SEGMENT_DFIFO_BU869_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N21013
    );
  SEGMENT_DFIFO_BU870 : X_FF
    port map (
      I => SEGMENT_DFIFO_N22720,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => SEGMENT_DFIFO_BU870_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N21012
    );
  SEGMENT_DFIFO_BU871 : X_FF
    port map (
      I => SEGMENT_DFIFO_N22708,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => SEGMENT_DFIFO_BU871_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N21011
    );
  SEGMENT_DFIFO_BU872 : X_FF
    port map (
      I => SEGMENT_DFIFO_N22722,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => SEGMENT_DFIFO_BU872_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N21010
    );
  SEGMENT_DFIFO_BU873 : X_FF
    port map (
      I => SEGMENT_DFIFO_N22723,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => SEGMENT_DFIFO_BU873_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N21009
    );
  SEGMENT_DFIFO_BU874 : X_FF
    port map (
      I => SEGMENT_DFIFO_N21000,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => SEGMENT_DFIFO_BU874_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N21008
    );
  SEGMENT_DFIFO_BU875 : X_LUT4
    generic map (
      INIT => X"9999"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N21014,
      ADR1 => SEGMENT_DFIFO_N20910,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N23669
    );
  SEGMENT_DFIFO_BU876 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N21014,
      IB => SEGMENT_DFIFO_N2147483644,
      SEL => SEGMENT_DFIFO_N23669,
      O => SEGMENT_DFIFO_N23685
    );
  SEGMENT_DFIFO_BU877 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N23669,
      I1 => SEGMENT_DFIFO_N2147483644,
      O => SEGMENT_DFIFO_N23661
    );
  SEGMENT_DFIFO_BU878 : X_FF
    port map (
      I => SEGMENT_DFIFO_N23661,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => GND,
      RST => SEGMENT_DFIFO_BU878_GSR_OR,
      O => SEGMENT_DFIFO_COUNT(0)
    );
  SEGMENT_DFIFO_BU879 : X_LUT4
    generic map (
      INIT => X"9999"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N21013,
      ADR1 => SEGMENT_DFIFO_N20909,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N23699
    );
  SEGMENT_DFIFO_BU880 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N21013,
      IB => SEGMENT_DFIFO_N23685,
      SEL => SEGMENT_DFIFO_N23699,
      O => SEGMENT_DFIFO_N23715
    );
  SEGMENT_DFIFO_BU881 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N23699,
      I1 => SEGMENT_DFIFO_N23685,
      O => SEGMENT_DFIFO_N23662
    );
  SEGMENT_DFIFO_BU882 : X_FF
    port map (
      I => SEGMENT_DFIFO_N23662,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => GND,
      RST => SEGMENT_DFIFO_BU882_GSR_OR,
      O => SEGMENT_DFIFO_COUNT(1)
    );
  SEGMENT_DFIFO_BU883 : X_LUT4
    generic map (
      INIT => X"9999"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N21012,
      ADR1 => SEGMENT_DFIFO_N20908,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N23729
    );
  SEGMENT_DFIFO_BU884 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N21012,
      IB => SEGMENT_DFIFO_N23715,
      SEL => SEGMENT_DFIFO_N23729,
      O => SEGMENT_DFIFO_N23745
    );
  SEGMENT_DFIFO_BU885 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N23729,
      I1 => SEGMENT_DFIFO_N23715,
      O => SEGMENT_DFIFO_N23663
    );
  SEGMENT_DFIFO_BU886 : X_FF
    port map (
      I => SEGMENT_DFIFO_N23663,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => GND,
      RST => SEGMENT_DFIFO_BU886_GSR_OR,
      O => SEGMENT_DFIFO_COUNT(2)
    );
  SEGMENT_DFIFO_BU887 : X_LUT4
    generic map (
      INIT => X"9999"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N21011,
      ADR1 => SEGMENT_DFIFO_N20907,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N23759
    );
  SEGMENT_DFIFO_BU888 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N21011,
      IB => SEGMENT_DFIFO_N23745,
      SEL => SEGMENT_DFIFO_N23759,
      O => SEGMENT_DFIFO_N23775
    );
  SEGMENT_DFIFO_BU889 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N23759,
      I1 => SEGMENT_DFIFO_N23745,
      O => SEGMENT_DFIFO_N23664
    );
  SEGMENT_DFIFO_BU890 : X_FF
    port map (
      I => SEGMENT_DFIFO_N23664,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => GND,
      RST => SEGMENT_DFIFO_BU890_GSR_OR,
      O => SEGMENT_DFIFO_COUNT(3)
    );
  SEGMENT_DFIFO_BU891 : X_LUT4
    generic map (
      INIT => X"9999"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N21010,
      ADR1 => SEGMENT_DFIFO_N20906,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N23789
    );
  SEGMENT_DFIFO_BU892 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N21010,
      IB => SEGMENT_DFIFO_N23775,
      SEL => SEGMENT_DFIFO_N23789,
      O => SEGMENT_DFIFO_N23805
    );
  SEGMENT_DFIFO_BU893 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N23789,
      I1 => SEGMENT_DFIFO_N23775,
      O => SEGMENT_DFIFO_N23665
    );
  SEGMENT_DFIFO_BU894 : X_FF
    port map (
      I => SEGMENT_DFIFO_N23665,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => GND,
      RST => SEGMENT_DFIFO_BU894_GSR_OR,
      O => SEGMENT_DFIFO_COUNT(4)
    );
  SEGMENT_DFIFO_BU895 : X_LUT4
    generic map (
      INIT => X"9999"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N21009,
      ADR1 => SEGMENT_DFIFO_N20905,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N23819
    );
  SEGMENT_DFIFO_BU896 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N21009,
      IB => SEGMENT_DFIFO_N23805,
      SEL => SEGMENT_DFIFO_N23819,
      O => SEGMENT_DFIFO_N23835
    );
  SEGMENT_DFIFO_BU897 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N23819,
      I1 => SEGMENT_DFIFO_N23805,
      O => SEGMENT_DFIFO_N23666
    );
  SEGMENT_DFIFO_BU898 : X_FF
    port map (
      I => SEGMENT_DFIFO_N23666,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => GND,
      RST => SEGMENT_DFIFO_BU898_GSR_OR,
      O => SEGMENT_DFIFO_COUNT(5)
    );
  SEGMENT_DFIFO_BU899 : X_LUT4
    generic map (
      INIT => X"9999"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N21008,
      ADR1 => SEGMENT_DFIFO_N20904,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N23849
    );
  SEGMENT_DFIFO_BU900 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N21008,
      IB => SEGMENT_DFIFO_N23835,
      SEL => SEGMENT_DFIFO_N23849,
      O => NGD2VHDL_X_3830_3
    );
  SEGMENT_DFIFO_BU901 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N23849,
      I1 => SEGMENT_DFIFO_N23835,
      O => SEGMENT_DFIFO_N23667
    );
  SEGMENT_DFIFO_BU902 : X_FF
    port map (
      I => SEGMENT_DFIFO_N23667,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N2147483644,
      SET => GND,
      RST => SEGMENT_DFIFO_BU902_GSR_OR,
      O => SEGMENT_DFIFO_COUNT(6)
    );
  SEGMENT_DFIFO_BU903 : X_LUT4
    generic map (
      INIT => X"9999"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2147483644,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => NGD2VHDL_X_3833_4
    );
  SEGMENT_DFIFO_BU904 : X_LUT4
    generic map (
      INIT => X"2222"
    )
    port map (
      ADR0 => SEGMENT_N_991_I,
      ADR1 => SEGMENT_DFIFO_FULL,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N20868
    );
  SEGMENT_DFIFO_BU905 : X_LUT4
    generic map (
      INIT => X"2222"
    )
    port map (
      ADR0 => SEGMENT_N_991_I,
      ADR1 => SEGMENT_DFIFO_FULL,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N226
    );
  SEGMENT_DFIFO_BU906 : X_LUT4
    generic map (
      INIT => X"5555"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N24091
    );
  SEGMENT_DFIFO_BU907 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N214,
      IB => SEGMENT_DFIFO_N2147483641,
      SEL => SEGMENT_DFIFO_N24091,
      O => SEGMENT_DFIFO_N24105
    );
  SEGMENT_DFIFO_BU908 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N24091,
      I1 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N24083
    );
  SEGMENT_DFIFO_BU909 : X_FF
    port map (
      I => SEGMENT_DFIFO_N24083,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => GND,
      RST => SEGMENT_DFIFO_BU909_GSR_OR,
      O => SEGMENT_DFIFO_N214
    );
  SEGMENT_DFIFO_BU910 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N213,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N24121
    );
  SEGMENT_DFIFO_BU911 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N213,
      IB => SEGMENT_DFIFO_N24105,
      SEL => SEGMENT_DFIFO_N24121,
      O => SEGMENT_DFIFO_N24135
    );
  SEGMENT_DFIFO_BU912 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N24121,
      I1 => SEGMENT_DFIFO_N24105,
      O => SEGMENT_DFIFO_N24084
    );
  SEGMENT_DFIFO_BU913 : X_FF
    port map (
      I => SEGMENT_DFIFO_N24084,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => GND,
      RST => SEGMENT_DFIFO_BU913_GSR_OR,
      O => SEGMENT_DFIFO_N213
    );
  SEGMENT_DFIFO_BU914 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N212,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N24151
    );
  SEGMENT_DFIFO_BU915 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N212,
      IB => SEGMENT_DFIFO_N24135,
      SEL => SEGMENT_DFIFO_N24151,
      O => SEGMENT_DFIFO_N24165
    );
  SEGMENT_DFIFO_BU916 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N24151,
      I1 => SEGMENT_DFIFO_N24135,
      O => SEGMENT_DFIFO_N24085
    );
  SEGMENT_DFIFO_BU917 : X_FF
    port map (
      I => SEGMENT_DFIFO_N24085,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => GND,
      RST => SEGMENT_DFIFO_BU917_GSR_OR,
      O => SEGMENT_DFIFO_N212
    );
  SEGMENT_DFIFO_BU918 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N211,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N24181
    );
  SEGMENT_DFIFO_BU919 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N211,
      IB => SEGMENT_DFIFO_N24165,
      SEL => SEGMENT_DFIFO_N24181,
      O => SEGMENT_DFIFO_N24195
    );
  SEGMENT_DFIFO_BU920 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N24181,
      I1 => SEGMENT_DFIFO_N24165,
      O => SEGMENT_DFIFO_N24086
    );
  SEGMENT_DFIFO_BU921 : X_FF
    port map (
      I => SEGMENT_DFIFO_N24086,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => GND,
      RST => SEGMENT_DFIFO_BU921_GSR_OR,
      O => SEGMENT_DFIFO_N211
    );
  SEGMENT_DFIFO_BU922 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N210,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N24211
    );
  SEGMENT_DFIFO_BU923 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N210,
      IB => SEGMENT_DFIFO_N24195,
      SEL => SEGMENT_DFIFO_N24211,
      O => SEGMENT_DFIFO_N24225
    );
  SEGMENT_DFIFO_BU924 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N24211,
      I1 => SEGMENT_DFIFO_N24195,
      O => SEGMENT_DFIFO_N24087
    );
  SEGMENT_DFIFO_BU925 : X_FF
    port map (
      I => SEGMENT_DFIFO_N24087,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => GND,
      RST => SEGMENT_DFIFO_BU925_GSR_OR,
      O => SEGMENT_DFIFO_N210
    );
  SEGMENT_DFIFO_BU926 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N209,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N24241
    );
  SEGMENT_DFIFO_BU927 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N209,
      IB => SEGMENT_DFIFO_N24225,
      SEL => SEGMENT_DFIFO_N24241,
      O => SEGMENT_DFIFO_N24255
    );
  SEGMENT_DFIFO_BU928 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N24241,
      I1 => SEGMENT_DFIFO_N24225,
      O => SEGMENT_DFIFO_N24088
    );
  SEGMENT_DFIFO_BU929 : X_FF
    port map (
      I => SEGMENT_DFIFO_N24088,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => GND,
      RST => SEGMENT_DFIFO_BU929_GSR_OR,
      O => SEGMENT_DFIFO_N209
    );
  SEGMENT_DFIFO_BU930 : X_LUT4
    generic map (
      INIT => X"aaaa"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N208,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N24271
    );
  SEGMENT_DFIFO_BU931 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N24271,
      I1 => SEGMENT_DFIFO_N24255,
      O => SEGMENT_DFIFO_N24089
    );
  SEGMENT_DFIFO_BU932 : X_FF
    port map (
      I => SEGMENT_DFIFO_N24089,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => GND,
      RST => SEGMENT_DFIFO_BU932_GSR_OR,
      O => SEGMENT_DFIFO_N208
    );
  SEGMENT_DFIFO_BU933 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N24481
    );
  SEGMENT_DFIFO_BU934 : X_FF
    port map (
      I => SEGMENT_DFIFO_N24481,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => GND,
      RST => SEGMENT_DFIFO_BU934_GSR_OR,
      O => SEGMENT_DFIFO_N20982
    );
  SEGMENT_DFIFO_BU935 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N213,
      ADR1 => SEGMENT_DFIFO_N212,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N24557
    );
  SEGMENT_DFIFO_BU936 : X_FF
    port map (
      I => SEGMENT_DFIFO_N24557,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => GND,
      RST => SEGMENT_DFIFO_BU936_GSR_OR,
      O => SEGMENT_DFIFO_N20981
    );
  SEGMENT_DFIFO_BU937 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N212,
      ADR1 => SEGMENT_DFIFO_N211,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N24633
    );
  SEGMENT_DFIFO_BU938 : X_FF
    port map (
      I => SEGMENT_DFIFO_N24633,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => GND,
      RST => SEGMENT_DFIFO_BU938_GSR_OR,
      O => SEGMENT_DFIFO_N20980
    );
  SEGMENT_DFIFO_BU939 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N211,
      ADR1 => SEGMENT_DFIFO_N210,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N24709
    );
  SEGMENT_DFIFO_BU940 : X_FF
    port map (
      I => SEGMENT_DFIFO_N24709,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => GND,
      RST => SEGMENT_DFIFO_BU940_GSR_OR,
      O => SEGMENT_DFIFO_N20979
    );
  SEGMENT_DFIFO_BU941 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N210,
      ADR1 => SEGMENT_DFIFO_N209,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N24785
    );
  SEGMENT_DFIFO_BU942 : X_FF
    port map (
      I => SEGMENT_DFIFO_N24785,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => GND,
      RST => SEGMENT_DFIFO_BU942_GSR_OR,
      O => SEGMENT_DFIFO_N20978
    );
  SEGMENT_DFIFO_BU943 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N209,
      ADR1 => SEGMENT_DFIFO_N208,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N24861
    );
  SEGMENT_DFIFO_BU944 : X_FF
    port map (
      I => SEGMENT_DFIFO_N24861,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => GND,
      RST => SEGMENT_DFIFO_BU944_GSR_OR,
      O => SEGMENT_DFIFO_N20977
    );
  SEGMENT_DFIFO_BU945 : X_LUT4
    generic map (
      INIT => X"6666"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N208,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N24937
    );
  SEGMENT_DFIFO_BU946 : X_FF
    port map (
      I => SEGMENT_DFIFO_N24937,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20868,
      SET => SEGMENT_DFIFO_BU946_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N20976
    );
  SEGMENT_DFIFO_BU947 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20918,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => SEGMENT_DFIFO_BU947_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N20934
    );
  SEGMENT_DFIFO_BU948 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20917,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU948_GSR_OR,
      O => SEGMENT_DFIFO_N20933
    );
  SEGMENT_DFIFO_BU949 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20916,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU949_GSR_OR,
      O => SEGMENT_DFIFO_N20932
    );
  SEGMENT_DFIFO_BU950 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20915,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU950_GSR_OR,
      O => SEGMENT_DFIFO_N20931
    );
  SEGMENT_DFIFO_BU951 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20914,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU951_GSR_OR,
      O => SEGMENT_DFIFO_N20930
    );
  SEGMENT_DFIFO_BU952 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20913,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU952_GSR_OR,
      O => SEGMENT_DFIFO_N20929
    );
  SEGMENT_DFIFO_BU953 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20912,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => SEGMENT_DFIFO_BU953_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N20928
    );
  SEGMENT_DFIFO_BU954 : X_LUT4
    generic map (
      INIT => X"fffe"
    )
    port map (
      ADR0 => SEGMENT_N_991_I,
      ADR1 => SEGMENT_DFIFO_FULL,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N25182
    );
  SEGMENT_DFIFO_BU955 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N2147483641,
      IB => SEGMENT_DFIFO_N2147483644,
      SEL => SEGMENT_DFIFO_BU955_S,
      O => SEGMENT_DFIFO_BU955_O
    );
  SEGMENT_DFIFO_BU955_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_DFIFO_BU955_O,
      O => SEGMENT_DFIFO_BU955_LO
    );
  SEGMENT_DFIFO_BU956 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20934,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => SEGMENT_DFIFO_BU956_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N20942
    );
  SEGMENT_DFIFO_BU957 : X_LUT4
    generic map (
      INIT => X"ffff"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2147483641,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => SEGMENT_DFIFO_N25186
    );
  SEGMENT_DFIFO_BU958 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N2147483641,
      IB => SEGMENT_DFIFO_N2147483644,
      SEL => SEGMENT_DFIFO_N25186,
      O => SEGMENT_DFIFO_BU958_O
    );
  SEGMENT_DFIFO_BU958_MUXCY_L_BUF : X_BUF
    port map (
      I => SEGMENT_DFIFO_BU958_O,
      O => SEGMENT_DFIFO_BU958_LO
    );
  SEGMENT_DFIFO_BU959 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20933,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => SEGMENT_DFIFO_BU959_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N20941
    );
  SEGMENT_DFIFO_BU960 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N20982,
      ADR1 => SEGMENT_DFIFO_N20934,
      ADR2 => SEGMENT_DFIFO_N20942,
      ADR3 => SEGMENT_DFIFO_FULL,
      O => SEGMENT_DFIFO_N25171
    );
  SEGMENT_DFIFO_BU961 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N2147483641,
      IB => SEGMENT_DFIFO_N2147483644,
      SEL => SEGMENT_DFIFO_N25171,
      O => SEGMENT_DFIFO_N25179
    );
  SEGMENT_DFIFO_BU962 : X_FF
    port map (
      I => SEGMENT_DFIFO_N2147483641,
      CLK => SEGMENT_DFIFO_N2147483641,
      CE => SEGMENT_DFIFO_N2147483641,
      SET => GND,
      RST => GSR,
      O => NGD2VHDL_X_3892_5
    );
  SEGMENT_DFIFO_BU963 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N20981,
      ADR1 => SEGMENT_DFIFO_N20933,
      ADR2 => SEGMENT_DFIFO_N20941,
      ADR3 => SEGMENT_DFIFO_FULL,
      O => SEGMENT_DFIFO_N25170
    );
  SEGMENT_DFIFO_BU964 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N2147483641,
      IB => SEGMENT_DFIFO_N25179,
      SEL => SEGMENT_DFIFO_N25170,
      O => SEGMENT_DFIFO_N25178
    );
  SEGMENT_DFIFO_BU965 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20932,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU965_GSR_OR,
      O => SEGMENT_DFIFO_N20940
    );
  SEGMENT_DFIFO_BU966 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N20980,
      ADR1 => SEGMENT_DFIFO_N20932,
      ADR2 => SEGMENT_DFIFO_N20940,
      ADR3 => SEGMENT_DFIFO_FULL,
      O => SEGMENT_DFIFO_N25169
    );
  SEGMENT_DFIFO_BU967 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N2147483641,
      IB => SEGMENT_DFIFO_N25178,
      SEL => SEGMENT_DFIFO_N25169,
      O => SEGMENT_DFIFO_N25177
    );
  SEGMENT_DFIFO_BU968 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20931,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU968_GSR_OR,
      O => SEGMENT_DFIFO_N20939
    );
  SEGMENT_DFIFO_BU969 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N20979,
      ADR1 => SEGMENT_DFIFO_N20931,
      ADR2 => SEGMENT_DFIFO_N20939,
      ADR3 => SEGMENT_DFIFO_FULL,
      O => SEGMENT_DFIFO_N25168
    );
  SEGMENT_DFIFO_BU970 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N2147483641,
      IB => SEGMENT_DFIFO_N25177,
      SEL => SEGMENT_DFIFO_N25168,
      O => SEGMENT_DFIFO_N25176
    );
  SEGMENT_DFIFO_BU971 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20930,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU971_GSR_OR,
      O => SEGMENT_DFIFO_N20938
    );
  SEGMENT_DFIFO_BU972 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N20978,
      ADR1 => SEGMENT_DFIFO_N20930,
      ADR2 => SEGMENT_DFIFO_N20938,
      ADR3 => SEGMENT_DFIFO_FULL,
      O => SEGMENT_DFIFO_N25167
    );
  SEGMENT_DFIFO_BU973 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N2147483641,
      IB => SEGMENT_DFIFO_N25176,
      SEL => SEGMENT_DFIFO_N25167,
      O => SEGMENT_DFIFO_N25175
    );
  SEGMENT_DFIFO_BU974 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20929,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => GND,
      RST => SEGMENT_DFIFO_BU974_GSR_OR,
      O => SEGMENT_DFIFO_N20937
    );
  SEGMENT_DFIFO_BU975 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N20977,
      ADR1 => SEGMENT_DFIFO_N20929,
      ADR2 => SEGMENT_DFIFO_N20937,
      ADR3 => SEGMENT_DFIFO_FULL,
      O => SEGMENT_DFIFO_N25166
    );
  SEGMENT_DFIFO_BU976 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N2147483641,
      IB => SEGMENT_DFIFO_N25175,
      SEL => SEGMENT_DFIFO_N25166,
      O => SEGMENT_DFIFO_N25174
    );
  SEGMENT_DFIFO_BU977 : X_FF
    port map (
      I => SEGMENT_DFIFO_N20928,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N20864,
      SET => SEGMENT_DFIFO_BU977_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_N20936
    );
  SEGMENT_DFIFO_BU978 : X_LUT4
    generic map (
      INIT => X"99a5"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N20976,
      ADR1 => SEGMENT_DFIFO_N20928,
      ADR2 => SEGMENT_DFIFO_N20936,
      ADR3 => SEGMENT_DFIFO_FULL,
      O => SEGMENT_DFIFO_N25165
    );
  SEGMENT_DFIFO_BU979 : X_MUX2
    port map (
      IA => SEGMENT_DFIFO_N2147483641,
      IB => SEGMENT_DFIFO_N25174,
      SEL => SEGMENT_DFIFO_N25165,
      O => SEGMENT_DFIFO_BU979_O
    );
  SEGMENT_DFIFO_BU979_MUXCY_D_BUF : X_BUF
    port map (
      I => SEGMENT_DFIFO_BU979_O,
      O => SEGMENT_DFIFO_N25173
    );
  SEGMENT_DFIFO_BU980 : X_LUT4
    generic map (
      INIT => X"ffff"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N2147483641,
      ADR1 => SEGMENT_DFIFO_N2147483641,
      ADR2 => SEGMENT_DFIFO_N2147483641,
      ADR3 => SEGMENT_DFIFO_N2147483641,
      O => NGD2VHDL_X_3910_4
    );
  SEGMENT_DFIFO_BU981 : X_XOR2
    port map (
      I0 => SEGMENT_DFIFO_N2147483641,
      I1 => SEGMENT_DFIFO_N25173,
      O => SEGMENT_DFIFO_N25184
    );
  SEGMENT_DFIFO_BU982 : X_FF
    port map (
      I => SEGMENT_DFIFO_N25184,
      CLK => CLK,
      CE => SEGMENT_DFIFO_N25182,
      SET => SEGMENT_DFIFO_BU982_GSR_OR,
      RST => GND,
      O => SEGMENT_DFIFO_FULL
    );
  SEGMENT_DFIFO_BU781_GSR_OR_487 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU781_GSR_OR
    );
  SEGMENT_DFIFO_BU785_GSR_OR_488 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU785_GSR_OR
    );
  SEGMENT_DFIFO_BU789_GSR_OR_489 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU789_GSR_OR
    );
  SEGMENT_DFIFO_BU793_GSR_OR_490 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU793_GSR_OR
    );
  SEGMENT_DFIFO_BU797_GSR_OR_491 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU797_GSR_OR
    );
  SEGMENT_DFIFO_BU801_GSR_OR_492 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU801_GSR_OR
    );
  SEGMENT_DFIFO_BU804_GSR_OR_493 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU804_GSR_OR
    );
  SEGMENT_DFIFO_BU806_GSR_OR_494 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU806_GSR_OR
    );
  SEGMENT_DFIFO_BU808_GSR_OR_495 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU808_GSR_OR
    );
  SEGMENT_DFIFO_BU810_GSR_OR_496 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU810_GSR_OR
    );
  SEGMENT_DFIFO_BU812_GSR_OR_497 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU812_GSR_OR
    );
  SEGMENT_DFIFO_BU814_GSR_OR_498 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU814_GSR_OR
    );
  SEGMENT_DFIFO_BU816_GSR_OR_499 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU816_GSR_OR
    );
  SEGMENT_DFIFO_BU818_GSR_OR_500 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU818_GSR_OR
    );
  SEGMENT_DFIFO_BU821_GSR_OR_501 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU821_GSR_OR
    );
  SEGMENT_DFIFO_BU824_GSR_OR_502 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU824_GSR_OR
    );
  SEGMENT_DFIFO_BU830_GSR_OR_503 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU830_GSR_OR
    );
  SEGMENT_DFIFO_BU833_GSR_OR_504 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU833_GSR_OR
    );
  SEGMENT_DFIFO_BU836_GSR_OR_505 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU836_GSR_OR
    );
  SEGMENT_DFIFO_BU839_GSR_OR_506 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU839_GSR_OR
    );
  SEGMENT_DFIFO_BU842_GSR_OR_507 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU842_GSR_OR
    );
  SEGMENT_DFIFO_BU847_GSR_OR_508 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU847_GSR_OR
    );
  SEGMENT_DFIFO_BU848_GSR_OR_509 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU848_GSR_OR
    );
  SEGMENT_DFIFO_BU849_GSR_OR_510 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU849_GSR_OR
    );
  SEGMENT_DFIFO_BU850_GSR_OR_511 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU850_GSR_OR
    );
  SEGMENT_DFIFO_BU851_GSR_OR_512 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU851_GSR_OR
    );
  SEGMENT_DFIFO_BU852_GSR_OR_513 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU852_GSR_OR
    );
  SEGMENT_DFIFO_BU853_GSR_OR_514 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU853_GSR_OR
    );
  SEGMENT_DFIFO_BU854_GSR_OR_515 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU854_GSR_OR
    );
  SEGMENT_DFIFO_BU855_GSR_OR_516 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU855_GSR_OR
    );
  SEGMENT_DFIFO_BU856_GSR_OR_517 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU856_GSR_OR
    );
  SEGMENT_DFIFO_BU857_GSR_OR_518 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU857_GSR_OR
    );
  SEGMENT_DFIFO_BU858_GSR_OR_519 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU858_GSR_OR
    );
  SEGMENT_DFIFO_BU859_GSR_OR_520 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU859_GSR_OR
    );
  SEGMENT_DFIFO_BU860_GSR_OR_521 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU860_GSR_OR
    );
  SEGMENT_DFIFO_BU861_GSR_OR_522 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU861_GSR_OR
    );
  SEGMENT_DFIFO_BU868_GSR_OR_523 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU868_GSR_OR
    );
  SEGMENT_DFIFO_BU869_GSR_OR_524 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU869_GSR_OR
    );
  SEGMENT_DFIFO_BU870_GSR_OR_525 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU870_GSR_OR
    );
  SEGMENT_DFIFO_BU871_GSR_OR_526 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU871_GSR_OR
    );
  SEGMENT_DFIFO_BU872_GSR_OR_527 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU872_GSR_OR
    );
  SEGMENT_DFIFO_BU873_GSR_OR_528 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU873_GSR_OR
    );
  SEGMENT_DFIFO_BU874_GSR_OR_529 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU874_GSR_OR
    );
  SEGMENT_DFIFO_BU878_GSR_OR_530 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU878_GSR_OR
    );
  SEGMENT_DFIFO_BU882_GSR_OR_531 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU882_GSR_OR
    );
  SEGMENT_DFIFO_BU886_GSR_OR_532 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU886_GSR_OR
    );
  SEGMENT_DFIFO_BU890_GSR_OR_533 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU890_GSR_OR
    );
  SEGMENT_DFIFO_BU894_GSR_OR_534 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU894_GSR_OR
    );
  SEGMENT_DFIFO_BU898_GSR_OR_535 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU898_GSR_OR
    );
  SEGMENT_DFIFO_BU902_GSR_OR_536 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU902_GSR_OR
    );
  SEGMENT_DFIFO_BU909_GSR_OR_537 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU909_GSR_OR
    );
  SEGMENT_DFIFO_BU913_GSR_OR_538 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU913_GSR_OR
    );
  SEGMENT_DFIFO_BU917_GSR_OR_539 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU917_GSR_OR
    );
  SEGMENT_DFIFO_BU921_GSR_OR_540 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU921_GSR_OR
    );
  SEGMENT_DFIFO_BU925_GSR_OR_541 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU925_GSR_OR
    );
  SEGMENT_DFIFO_BU929_GSR_OR_542 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU929_GSR_OR
    );
  SEGMENT_DFIFO_BU932_GSR_OR_543 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU932_GSR_OR
    );
  SEGMENT_DFIFO_BU934_GSR_OR_544 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU934_GSR_OR
    );
  SEGMENT_DFIFO_BU936_GSR_OR_545 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU936_GSR_OR
    );
  SEGMENT_DFIFO_BU938_GSR_OR_546 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU938_GSR_OR
    );
  SEGMENT_DFIFO_BU940_GSR_OR_547 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU940_GSR_OR
    );
  SEGMENT_DFIFO_BU942_GSR_OR_548 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU942_GSR_OR
    );
  SEGMENT_DFIFO_BU944_GSR_OR_549 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU944_GSR_OR
    );
  SEGMENT_DFIFO_BU946_GSR_OR_550 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU946_GSR_OR
    );
  SEGMENT_DFIFO_BU947_GSR_OR_551 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU947_GSR_OR
    );
  SEGMENT_DFIFO_BU948_GSR_OR_552 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU948_GSR_OR
    );
  SEGMENT_DFIFO_BU949_GSR_OR_553 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU949_GSR_OR
    );
  SEGMENT_DFIFO_BU950_GSR_OR_554 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU950_GSR_OR
    );
  SEGMENT_DFIFO_BU951_GSR_OR_555 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU951_GSR_OR
    );
  SEGMENT_DFIFO_BU952_GSR_OR_556 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU952_GSR_OR
    );
  SEGMENT_DFIFO_BU953_GSR_OR_557 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU953_GSR_OR
    );
  SEGMENT_DFIFO_BU956_GSR_OR_558 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU956_GSR_OR
    );
  SEGMENT_DFIFO_BU959_GSR_OR_559 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU959_GSR_OR
    );
  SEGMENT_DFIFO_BU965_GSR_OR_560 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU965_GSR_OR
    );
  SEGMENT_DFIFO_BU968_GSR_OR_561 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU968_GSR_OR
    );
  SEGMENT_DFIFO_BU971_GSR_OR_562 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU971_GSR_OR
    );
  SEGMENT_DFIFO_BU974_GSR_OR_563 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU974_GSR_OR
    );
  SEGMENT_DFIFO_BU977_GSR_OR_564 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU977_GSR_OR
    );
  SEGMENT_DFIFO_BU982_GSR_OR_565 : X_OR2
    port map (
      I0 => SEGMENT_FIFO_RESET,
      I1 => GSR,
      O => SEGMENT_DFIFO_BU982_GSR_OR
    );
  SEGMENT_DFIFO_BU0_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(0),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1335
    );
  SEGMENT_DFIFO_BU0_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(0),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1368
    );
  SEGMENT_DFIFO_BU1_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(1),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1336
    );
  SEGMENT_DFIFO_BU1_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(1),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1369
    );
  SEGMENT_DFIFO_BU2_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(2),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1337
    );
  SEGMENT_DFIFO_BU2_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(2),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1370
    );
  SEGMENT_DFIFO_BU3_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(3),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1338
    );
  SEGMENT_DFIFO_BU3_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(3),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1371
    );
  SEGMENT_DFIFO_BU4_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(4),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1339
    );
  SEGMENT_DFIFO_BU4_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(4),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1372
    );
  SEGMENT_DFIFO_BU5_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(5),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1340
    );
  SEGMENT_DFIFO_BU5_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(5),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1373
    );
  SEGMENT_DFIFO_BU6_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(6),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1341
    );
  SEGMENT_DFIFO_BU6_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(6),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1374
    );
  SEGMENT_DFIFO_BU7_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(7),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1342
    );
  SEGMENT_DFIFO_BU7_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(7),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1375
    );
  SEGMENT_DFIFO_BU8_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(8),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1343
    );
  SEGMENT_DFIFO_BU8_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(8),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1376
    );
  SEGMENT_DFIFO_BU9_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(9),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1344
    );
  SEGMENT_DFIFO_BU9_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(9),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1377
    );
  SEGMENT_DFIFO_BU10_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(10),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1345
    );
  SEGMENT_DFIFO_BU10_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(10),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1378
    );
  SEGMENT_DFIFO_BU11_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(11),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1346
    );
  SEGMENT_DFIFO_BU11_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(11),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1379
    );
  SEGMENT_DFIFO_BU12_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(12),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1347
    );
  SEGMENT_DFIFO_BU12_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(12),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1380
    );
  SEGMENT_DFIFO_BU13_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(13),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1348
    );
  SEGMENT_DFIFO_BU13_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(13),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1381
    );
  SEGMENT_DFIFO_BU14_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(14),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1349
    );
  SEGMENT_DFIFO_BU14_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(14),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1382
    );
  SEGMENT_DFIFO_BU15_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(15),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1350
    );
  SEGMENT_DFIFO_BU15_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(15),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1383
    );
  SEGMENT_DFIFO_BU16_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(16),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1351
    );
  SEGMENT_DFIFO_BU16_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(16),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1384
    );
  SEGMENT_DFIFO_BU17_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(17),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1352
    );
  SEGMENT_DFIFO_BU17_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(17),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1385
    );
  SEGMENT_DFIFO_BU18_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(18),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1353
    );
  SEGMENT_DFIFO_BU18_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(18),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1386
    );
  SEGMENT_DFIFO_BU19_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(19),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1354
    );
  SEGMENT_DFIFO_BU19_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(19),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1387
    );
  SEGMENT_DFIFO_BU20_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(20),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1355
    );
  SEGMENT_DFIFO_BU20_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(20),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1388
    );
  SEGMENT_DFIFO_BU21_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(21),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1356
    );
  SEGMENT_DFIFO_BU21_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(21),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1389
    );
  SEGMENT_DFIFO_BU22_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(22),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1357
    );
  SEGMENT_DFIFO_BU22_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(22),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1390
    );
  SEGMENT_DFIFO_BU23_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(23),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1358
    );
  SEGMENT_DFIFO_BU23_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(23),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1391
    );
  SEGMENT_DFIFO_BU24_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(24),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1359
    );
  SEGMENT_DFIFO_BU24_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(24),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1392
    );
  SEGMENT_DFIFO_BU25_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(25),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1360
    );
  SEGMENT_DFIFO_BU25_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(25),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1393
    );
  SEGMENT_DFIFO_BU26_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(26),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1361
    );
  SEGMENT_DFIFO_BU26_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(26),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1394
    );
  SEGMENT_DFIFO_BU27_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(27),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1362
    );
  SEGMENT_DFIFO_BU27_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(27),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1395
    );
  SEGMENT_DFIFO_BU28_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(28),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1363
    );
  SEGMENT_DFIFO_BU28_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(28),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1396
    );
  SEGMENT_DFIFO_BU29_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(29),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1364
    );
  SEGMENT_DFIFO_BU29_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(29),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1397
    );
  SEGMENT_DFIFO_BU30_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(30),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1365
    );
  SEGMENT_DFIFO_BU30_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(30),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1398
    );
  SEGMENT_DFIFO_BU31_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(31),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1366
    );
  SEGMENT_DFIFO_BU31_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(31),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N912,
      O => SEGMENT_DFIFO_N1399
    );
  SEGMENT_DFIFO_BU32_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(0),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1724
    );
  SEGMENT_DFIFO_BU32_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(0),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1757
    );
  SEGMENT_DFIFO_BU33_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(1),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1725
    );
  SEGMENT_DFIFO_BU33_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(1),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1758
    );
  SEGMENT_DFIFO_BU34_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(2),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1726
    );
  SEGMENT_DFIFO_BU34_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(2),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1759
    );
  SEGMENT_DFIFO_BU35_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(3),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1727
    );
  SEGMENT_DFIFO_BU35_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(3),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1760
    );
  SEGMENT_DFIFO_BU36_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(4),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1728
    );
  SEGMENT_DFIFO_BU36_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(4),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1761
    );
  SEGMENT_DFIFO_BU37_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(5),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1729
    );
  SEGMENT_DFIFO_BU37_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(5),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1762
    );
  SEGMENT_DFIFO_BU38_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(6),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1730
    );
  SEGMENT_DFIFO_BU38_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(6),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1763
    );
  SEGMENT_DFIFO_BU39_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(7),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1731
    );
  SEGMENT_DFIFO_BU39_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(7),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1764
    );
  SEGMENT_DFIFO_BU40_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(8),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1732
    );
  SEGMENT_DFIFO_BU40_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(8),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1765
    );
  SEGMENT_DFIFO_BU41_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(9),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1733
    );
  SEGMENT_DFIFO_BU41_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(9),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1766
    );
  SEGMENT_DFIFO_BU42_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(10),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1734
    );
  SEGMENT_DFIFO_BU42_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(10),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1767
    );
  SEGMENT_DFIFO_BU43_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(11),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1735
    );
  SEGMENT_DFIFO_BU43_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(11),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1768
    );
  SEGMENT_DFIFO_BU44_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(12),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1736
    );
  SEGMENT_DFIFO_BU44_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(12),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1769
    );
  SEGMENT_DFIFO_BU45_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(13),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1737
    );
  SEGMENT_DFIFO_BU45_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(13),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1770
    );
  SEGMENT_DFIFO_BU46_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(14),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1738
    );
  SEGMENT_DFIFO_BU46_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(14),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1771
    );
  SEGMENT_DFIFO_BU47_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(15),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1739
    );
  SEGMENT_DFIFO_BU47_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(15),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1772
    );
  SEGMENT_DFIFO_BU48_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(16),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1740
    );
  SEGMENT_DFIFO_BU48_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(16),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1773
    );
  SEGMENT_DFIFO_BU49_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(17),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1741
    );
  SEGMENT_DFIFO_BU49_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(17),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1774
    );
  SEGMENT_DFIFO_BU50_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(18),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1742
    );
  SEGMENT_DFIFO_BU50_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(18),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1775
    );
  SEGMENT_DFIFO_BU51_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(19),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1743
    );
  SEGMENT_DFIFO_BU51_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(19),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1776
    );
  SEGMENT_DFIFO_BU52_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(20),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1744
    );
  SEGMENT_DFIFO_BU52_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(20),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1777
    );
  SEGMENT_DFIFO_BU53_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(21),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1745
    );
  SEGMENT_DFIFO_BU53_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(21),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1778
    );
  SEGMENT_DFIFO_BU54_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(22),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1746
    );
  SEGMENT_DFIFO_BU54_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(22),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1779
    );
  SEGMENT_DFIFO_BU55_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(23),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1747
    );
  SEGMENT_DFIFO_BU55_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(23),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1780
    );
  SEGMENT_DFIFO_BU56_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(24),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1748
    );
  SEGMENT_DFIFO_BU56_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(24),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1781
    );
  SEGMENT_DFIFO_BU57_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(25),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1749
    );
  SEGMENT_DFIFO_BU57_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(25),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1782
    );
  SEGMENT_DFIFO_BU58_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(26),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1750
    );
  SEGMENT_DFIFO_BU58_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(26),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1783
    );
  SEGMENT_DFIFO_BU59_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(27),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1751
    );
  SEGMENT_DFIFO_BU59_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(27),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1784
    );
  SEGMENT_DFIFO_BU60_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(28),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1752
    );
  SEGMENT_DFIFO_BU60_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(28),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1785
    );
  SEGMENT_DFIFO_BU61_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(29),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1753
    );
  SEGMENT_DFIFO_BU61_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(29),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1786
    );
  SEGMENT_DFIFO_BU62_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(30),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1754
    );
  SEGMENT_DFIFO_BU62_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(30),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1787
    );
  SEGMENT_DFIFO_BU63_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(31),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1755
    );
  SEGMENT_DFIFO_BU63_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(31),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N913,
      O => SEGMENT_DFIFO_N1788
    );
  SEGMENT_DFIFO_BU64_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(0),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2113
    );
  SEGMENT_DFIFO_BU64_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(0),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2146
    );
  SEGMENT_DFIFO_BU65_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(1),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2114
    );
  SEGMENT_DFIFO_BU65_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(1),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2147
    );
  SEGMENT_DFIFO_BU66_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(2),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2115
    );
  SEGMENT_DFIFO_BU66_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(2),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2148
    );
  SEGMENT_DFIFO_BU67_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(3),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2116
    );
  SEGMENT_DFIFO_BU67_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(3),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2149
    );
  SEGMENT_DFIFO_BU68_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(4),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2117
    );
  SEGMENT_DFIFO_BU68_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(4),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2150
    );
  SEGMENT_DFIFO_BU69_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(5),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2118
    );
  SEGMENT_DFIFO_BU69_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(5),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2151
    );
  SEGMENT_DFIFO_BU70_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(6),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2119
    );
  SEGMENT_DFIFO_BU70_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(6),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2152
    );
  SEGMENT_DFIFO_BU71_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(7),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2120
    );
  SEGMENT_DFIFO_BU71_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(7),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2153
    );
  SEGMENT_DFIFO_BU72_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(8),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2121
    );
  SEGMENT_DFIFO_BU72_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(8),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2154
    );
  SEGMENT_DFIFO_BU73_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(9),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2122
    );
  SEGMENT_DFIFO_BU73_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(9),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2155
    );
  SEGMENT_DFIFO_BU74_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(10),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2123
    );
  SEGMENT_DFIFO_BU74_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(10),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2156
    );
  SEGMENT_DFIFO_BU75_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(11),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2124
    );
  SEGMENT_DFIFO_BU75_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(11),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2157
    );
  SEGMENT_DFIFO_BU76_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(12),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2125
    );
  SEGMENT_DFIFO_BU76_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(12),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2158
    );
  SEGMENT_DFIFO_BU77_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(13),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2126
    );
  SEGMENT_DFIFO_BU77_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(13),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2159
    );
  SEGMENT_DFIFO_BU78_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(14),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2127
    );
  SEGMENT_DFIFO_BU78_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(14),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2160
    );
  SEGMENT_DFIFO_BU79_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(15),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2128
    );
  SEGMENT_DFIFO_BU79_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(15),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2161
    );
  SEGMENT_DFIFO_BU80_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(16),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2129
    );
  SEGMENT_DFIFO_BU80_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(16),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2162
    );
  SEGMENT_DFIFO_BU81_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(17),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2130
    );
  SEGMENT_DFIFO_BU81_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(17),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2163
    );
  SEGMENT_DFIFO_BU82_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(18),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2131
    );
  SEGMENT_DFIFO_BU82_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(18),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2164
    );
  SEGMENT_DFIFO_BU83_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(19),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2132
    );
  SEGMENT_DFIFO_BU83_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(19),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2165
    );
  SEGMENT_DFIFO_BU84_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(20),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2133
    );
  SEGMENT_DFIFO_BU84_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(20),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2166
    );
  SEGMENT_DFIFO_BU85_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(21),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2134
    );
  SEGMENT_DFIFO_BU85_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(21),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2167
    );
  SEGMENT_DFIFO_BU86_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(22),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2135
    );
  SEGMENT_DFIFO_BU86_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(22),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2168
    );
  SEGMENT_DFIFO_BU87_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(23),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2136
    );
  SEGMENT_DFIFO_BU87_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(23),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2169
    );
  SEGMENT_DFIFO_BU88_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(24),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2137
    );
  SEGMENT_DFIFO_BU88_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(24),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2170
    );
  SEGMENT_DFIFO_BU89_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(25),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2138
    );
  SEGMENT_DFIFO_BU89_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(25),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2171
    );
  SEGMENT_DFIFO_BU90_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(26),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2139
    );
  SEGMENT_DFIFO_BU90_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(26),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2172
    );
  SEGMENT_DFIFO_BU91_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(27),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2140
    );
  SEGMENT_DFIFO_BU91_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(27),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2173
    );
  SEGMENT_DFIFO_BU92_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(28),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2141
    );
  SEGMENT_DFIFO_BU92_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(28),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2174
    );
  SEGMENT_DFIFO_BU93_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(29),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2142
    );
  SEGMENT_DFIFO_BU93_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(29),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2175
    );
  SEGMENT_DFIFO_BU94_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(30),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2143
    );
  SEGMENT_DFIFO_BU94_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(30),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2176
    );
  SEGMENT_DFIFO_BU95_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(31),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2144
    );
  SEGMENT_DFIFO_BU95_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(31),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N914,
      O => SEGMENT_DFIFO_N2177
    );
  SEGMENT_DFIFO_BU96_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(0),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2502
    );
  SEGMENT_DFIFO_BU96_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(0),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2535
    );
  SEGMENT_DFIFO_BU97_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(1),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2503
    );
  SEGMENT_DFIFO_BU97_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(1),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2536
    );
  SEGMENT_DFIFO_BU98_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(2),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2504
    );
  SEGMENT_DFIFO_BU98_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(2),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2537
    );
  SEGMENT_DFIFO_BU99_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(3),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2505
    );
  SEGMENT_DFIFO_BU99_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(3),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2538
    );
  SEGMENT_DFIFO_BU100_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(4),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2506
    );
  SEGMENT_DFIFO_BU100_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(4),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2539
    );
  SEGMENT_DFIFO_BU101_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(5),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2507
    );
  SEGMENT_DFIFO_BU101_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(5),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2540
    );
  SEGMENT_DFIFO_BU102_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(6),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2508
    );
  SEGMENT_DFIFO_BU102_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(6),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2541
    );
  SEGMENT_DFIFO_BU103_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(7),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2509
    );
  SEGMENT_DFIFO_BU103_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(7),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2542
    );
  SEGMENT_DFIFO_BU104_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(8),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2510
    );
  SEGMENT_DFIFO_BU104_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(8),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2543
    );
  SEGMENT_DFIFO_BU105_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(9),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2511
    );
  SEGMENT_DFIFO_BU105_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(9),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2544
    );
  SEGMENT_DFIFO_BU106_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(10),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2512
    );
  SEGMENT_DFIFO_BU106_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(10),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2545
    );
  SEGMENT_DFIFO_BU107_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(11),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2513
    );
  SEGMENT_DFIFO_BU107_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(11),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2546
    );
  SEGMENT_DFIFO_BU108_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(12),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2514
    );
  SEGMENT_DFIFO_BU108_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(12),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2547
    );
  SEGMENT_DFIFO_BU109_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(13),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2515
    );
  SEGMENT_DFIFO_BU109_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(13),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2548
    );
  SEGMENT_DFIFO_BU110_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(14),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2516
    );
  SEGMENT_DFIFO_BU110_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(14),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2549
    );
  SEGMENT_DFIFO_BU111_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(15),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2517
    );
  SEGMENT_DFIFO_BU111_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(15),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2550
    );
  SEGMENT_DFIFO_BU112_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(16),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2518
    );
  SEGMENT_DFIFO_BU112_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(16),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2551
    );
  SEGMENT_DFIFO_BU113_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(17),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2519
    );
  SEGMENT_DFIFO_BU113_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(17),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2552
    );
  SEGMENT_DFIFO_BU114_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(18),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2520
    );
  SEGMENT_DFIFO_BU114_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(18),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2553
    );
  SEGMENT_DFIFO_BU115_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(19),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2521
    );
  SEGMENT_DFIFO_BU115_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(19),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2554
    );
  SEGMENT_DFIFO_BU116_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(20),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2522
    );
  SEGMENT_DFIFO_BU116_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(20),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2555
    );
  SEGMENT_DFIFO_BU117_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(21),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2523
    );
  SEGMENT_DFIFO_BU117_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(21),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2556
    );
  SEGMENT_DFIFO_BU118_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(22),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2524
    );
  SEGMENT_DFIFO_BU118_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(22),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2557
    );
  SEGMENT_DFIFO_BU119_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(23),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2525
    );
  SEGMENT_DFIFO_BU119_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(23),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2558
    );
  SEGMENT_DFIFO_BU120_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(24),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2526
    );
  SEGMENT_DFIFO_BU120_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(24),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2559
    );
  SEGMENT_DFIFO_BU121_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(25),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2527
    );
  SEGMENT_DFIFO_BU121_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(25),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2560
    );
  SEGMENT_DFIFO_BU122_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(26),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2528
    );
  SEGMENT_DFIFO_BU122_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(26),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2561
    );
  SEGMENT_DFIFO_BU123_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(27),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2529
    );
  SEGMENT_DFIFO_BU123_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(27),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2562
    );
  SEGMENT_DFIFO_BU124_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(28),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2530
    );
  SEGMENT_DFIFO_BU124_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(28),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2563
    );
  SEGMENT_DFIFO_BU125_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(29),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2531
    );
  SEGMENT_DFIFO_BU125_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(29),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2564
    );
  SEGMENT_DFIFO_BU126_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(30),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2532
    );
  SEGMENT_DFIFO_BU126_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(30),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2565
    );
  SEGMENT_DFIFO_BU127_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(31),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2533
    );
  SEGMENT_DFIFO_BU127_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(31),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N915,
      O => SEGMENT_DFIFO_N2566
    );
  SEGMENT_DFIFO_BU128_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(0),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2891
    );
  SEGMENT_DFIFO_BU128_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(0),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2924
    );
  SEGMENT_DFIFO_BU129_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(1),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2892
    );
  SEGMENT_DFIFO_BU129_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(1),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2925
    );
  SEGMENT_DFIFO_BU130_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(2),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2893
    );
  SEGMENT_DFIFO_BU130_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(2),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2926
    );
  SEGMENT_DFIFO_BU131_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(3),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2894
    );
  SEGMENT_DFIFO_BU131_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(3),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2927
    );
  SEGMENT_DFIFO_BU132_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(4),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2895
    );
  SEGMENT_DFIFO_BU132_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(4),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2928
    );
  SEGMENT_DFIFO_BU133_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(5),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2896
    );
  SEGMENT_DFIFO_BU133_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(5),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2929
    );
  SEGMENT_DFIFO_BU134_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(6),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2897
    );
  SEGMENT_DFIFO_BU134_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(6),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2930
    );
  SEGMENT_DFIFO_BU135_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(7),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2898
    );
  SEGMENT_DFIFO_BU135_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(7),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2931
    );
  SEGMENT_DFIFO_BU136_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(8),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2899
    );
  SEGMENT_DFIFO_BU136_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(8),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2932
    );
  SEGMENT_DFIFO_BU137_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(9),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2900
    );
  SEGMENT_DFIFO_BU137_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(9),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2933
    );
  SEGMENT_DFIFO_BU138_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(10),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2901
    );
  SEGMENT_DFIFO_BU138_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(10),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2934
    );
  SEGMENT_DFIFO_BU139_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(11),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2902
    );
  SEGMENT_DFIFO_BU139_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(11),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2935
    );
  SEGMENT_DFIFO_BU140_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(12),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2903
    );
  SEGMENT_DFIFO_BU140_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(12),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2936
    );
  SEGMENT_DFIFO_BU141_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(13),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2904
    );
  SEGMENT_DFIFO_BU141_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(13),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2937
    );
  SEGMENT_DFIFO_BU142_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(14),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2905
    );
  SEGMENT_DFIFO_BU142_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(14),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2938
    );
  SEGMENT_DFIFO_BU143_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(15),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2906
    );
  SEGMENT_DFIFO_BU143_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(15),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2939
    );
  SEGMENT_DFIFO_BU144_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(16),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2907
    );
  SEGMENT_DFIFO_BU144_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(16),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2940
    );
  SEGMENT_DFIFO_BU145_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(17),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2908
    );
  SEGMENT_DFIFO_BU145_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(17),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2941
    );
  SEGMENT_DFIFO_BU146_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(18),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2909
    );
  SEGMENT_DFIFO_BU146_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(18),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2942
    );
  SEGMENT_DFIFO_BU147_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(19),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2910
    );
  SEGMENT_DFIFO_BU147_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(19),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2943
    );
  SEGMENT_DFIFO_BU148_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(20),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2911
    );
  SEGMENT_DFIFO_BU148_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(20),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2944
    );
  SEGMENT_DFIFO_BU149_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(21),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2912
    );
  SEGMENT_DFIFO_BU149_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(21),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2945
    );
  SEGMENT_DFIFO_BU150_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(22),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2913
    );
  SEGMENT_DFIFO_BU150_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(22),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2946
    );
  SEGMENT_DFIFO_BU151_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(23),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2914
    );
  SEGMENT_DFIFO_BU151_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(23),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2947
    );
  SEGMENT_DFIFO_BU152_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(24),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2915
    );
  SEGMENT_DFIFO_BU152_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(24),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2948
    );
  SEGMENT_DFIFO_BU153_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(25),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2916
    );
  SEGMENT_DFIFO_BU153_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(25),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2949
    );
  SEGMENT_DFIFO_BU154_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(26),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2917
    );
  SEGMENT_DFIFO_BU154_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(26),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2950
    );
  SEGMENT_DFIFO_BU155_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(27),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2918
    );
  SEGMENT_DFIFO_BU155_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(27),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2951
    );
  SEGMENT_DFIFO_BU156_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(28),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2919
    );
  SEGMENT_DFIFO_BU156_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(28),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2952
    );
  SEGMENT_DFIFO_BU157_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(29),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2920
    );
  SEGMENT_DFIFO_BU157_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(29),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2953
    );
  SEGMENT_DFIFO_BU158_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(30),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2921
    );
  SEGMENT_DFIFO_BU158_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(30),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2954
    );
  SEGMENT_DFIFO_BU159_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(31),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2922
    );
  SEGMENT_DFIFO_BU159_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(31),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N916,
      O => SEGMENT_DFIFO_N2955
    );
  SEGMENT_DFIFO_BU160_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(0),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3280
    );
  SEGMENT_DFIFO_BU160_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(0),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3313
    );
  SEGMENT_DFIFO_BU161_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(1),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3281
    );
  SEGMENT_DFIFO_BU161_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(1),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3314
    );
  SEGMENT_DFIFO_BU162_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(2),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3282
    );
  SEGMENT_DFIFO_BU162_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(2),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3315
    );
  SEGMENT_DFIFO_BU163_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(3),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3283
    );
  SEGMENT_DFIFO_BU163_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(3),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3316
    );
  SEGMENT_DFIFO_BU164_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(4),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3284
    );
  SEGMENT_DFIFO_BU164_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(4),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3317
    );
  SEGMENT_DFIFO_BU165_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(5),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3285
    );
  SEGMENT_DFIFO_BU165_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(5),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3318
    );
  SEGMENT_DFIFO_BU166_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(6),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3286
    );
  SEGMENT_DFIFO_BU166_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(6),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3319
    );
  SEGMENT_DFIFO_BU167_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(7),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3287
    );
  SEGMENT_DFIFO_BU167_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(7),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3320
    );
  SEGMENT_DFIFO_BU168_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(8),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3288
    );
  SEGMENT_DFIFO_BU168_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(8),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3321
    );
  SEGMENT_DFIFO_BU169_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(9),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3289
    );
  SEGMENT_DFIFO_BU169_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(9),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3322
    );
  SEGMENT_DFIFO_BU170_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(10),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3290
    );
  SEGMENT_DFIFO_BU170_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(10),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3323
    );
  SEGMENT_DFIFO_BU171_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(11),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3291
    );
  SEGMENT_DFIFO_BU171_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(11),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3324
    );
  SEGMENT_DFIFO_BU172_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(12),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3292
    );
  SEGMENT_DFIFO_BU172_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(12),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3325
    );
  SEGMENT_DFIFO_BU173_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(13),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3293
    );
  SEGMENT_DFIFO_BU173_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(13),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3326
    );
  SEGMENT_DFIFO_BU174_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(14),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3294
    );
  SEGMENT_DFIFO_BU174_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(14),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3327
    );
  SEGMENT_DFIFO_BU175_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(15),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3295
    );
  SEGMENT_DFIFO_BU175_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(15),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3328
    );
  SEGMENT_DFIFO_BU176_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(16),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3296
    );
  SEGMENT_DFIFO_BU176_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(16),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3329
    );
  SEGMENT_DFIFO_BU177_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(17),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3297
    );
  SEGMENT_DFIFO_BU177_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(17),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3330
    );
  SEGMENT_DFIFO_BU178_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(18),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3298
    );
  SEGMENT_DFIFO_BU178_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(18),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3331
    );
  SEGMENT_DFIFO_BU179_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(19),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3299
    );
  SEGMENT_DFIFO_BU179_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(19),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3332
    );
  SEGMENT_DFIFO_BU180_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(20),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3300
    );
  SEGMENT_DFIFO_BU180_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(20),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3333
    );
  SEGMENT_DFIFO_BU181_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(21),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3301
    );
  SEGMENT_DFIFO_BU181_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(21),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3334
    );
  SEGMENT_DFIFO_BU182_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(22),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3302
    );
  SEGMENT_DFIFO_BU182_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(22),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3335
    );
  SEGMENT_DFIFO_BU183_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(23),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3303
    );
  SEGMENT_DFIFO_BU183_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(23),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3336
    );
  SEGMENT_DFIFO_BU184_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(24),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3304
    );
  SEGMENT_DFIFO_BU184_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(24),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3337
    );
  SEGMENT_DFIFO_BU185_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(25),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3305
    );
  SEGMENT_DFIFO_BU185_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(25),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3338
    );
  SEGMENT_DFIFO_BU186_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(26),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3306
    );
  SEGMENT_DFIFO_BU186_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(26),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3339
    );
  SEGMENT_DFIFO_BU187_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(27),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3307
    );
  SEGMENT_DFIFO_BU187_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(27),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3340
    );
  SEGMENT_DFIFO_BU188_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(28),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3308
    );
  SEGMENT_DFIFO_BU188_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(28),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3341
    );
  SEGMENT_DFIFO_BU189_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(29),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3309
    );
  SEGMENT_DFIFO_BU189_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(29),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3342
    );
  SEGMENT_DFIFO_BU190_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(30),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3310
    );
  SEGMENT_DFIFO_BU190_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(30),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3343
    );
  SEGMENT_DFIFO_BU191_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(31),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3311
    );
  SEGMENT_DFIFO_BU191_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(31),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N917,
      O => SEGMENT_DFIFO_N3344
    );
  SEGMENT_DFIFO_BU192_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(0),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3669
    );
  SEGMENT_DFIFO_BU192_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(0),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3702
    );
  SEGMENT_DFIFO_BU193_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(1),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3670
    );
  SEGMENT_DFIFO_BU193_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(1),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3703
    );
  SEGMENT_DFIFO_BU194_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(2),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3671
    );
  SEGMENT_DFIFO_BU194_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(2),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3704
    );
  SEGMENT_DFIFO_BU195_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(3),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3672
    );
  SEGMENT_DFIFO_BU195_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(3),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3705
    );
  SEGMENT_DFIFO_BU196_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(4),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3673
    );
  SEGMENT_DFIFO_BU196_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(4),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3706
    );
  SEGMENT_DFIFO_BU197_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(5),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3674
    );
  SEGMENT_DFIFO_BU197_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(5),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3707
    );
  SEGMENT_DFIFO_BU198_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(6),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3675
    );
  SEGMENT_DFIFO_BU198_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(6),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3708
    );
  SEGMENT_DFIFO_BU199_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(7),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3676
    );
  SEGMENT_DFIFO_BU199_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(7),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3709
    );
  SEGMENT_DFIFO_BU200_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(8),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3677
    );
  SEGMENT_DFIFO_BU200_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(8),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3710
    );
  SEGMENT_DFIFO_BU201_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(9),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3678
    );
  SEGMENT_DFIFO_BU201_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(9),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3711
    );
  SEGMENT_DFIFO_BU202_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(10),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3679
    );
  SEGMENT_DFIFO_BU202_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(10),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3712
    );
  SEGMENT_DFIFO_BU203_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(11),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3680
    );
  SEGMENT_DFIFO_BU203_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(11),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3713
    );
  SEGMENT_DFIFO_BU204_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(12),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3681
    );
  SEGMENT_DFIFO_BU204_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(12),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3714
    );
  SEGMENT_DFIFO_BU205_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(13),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3682
    );
  SEGMENT_DFIFO_BU205_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(13),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3715
    );
  SEGMENT_DFIFO_BU206_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(14),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3683
    );
  SEGMENT_DFIFO_BU206_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(14),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3716
    );
  SEGMENT_DFIFO_BU207_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(15),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3684
    );
  SEGMENT_DFIFO_BU207_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(15),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3717
    );
  SEGMENT_DFIFO_BU208_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(16),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3685
    );
  SEGMENT_DFIFO_BU208_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(16),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3718
    );
  SEGMENT_DFIFO_BU209_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(17),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3686
    );
  SEGMENT_DFIFO_BU209_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(17),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3719
    );
  SEGMENT_DFIFO_BU210_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(18),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3687
    );
  SEGMENT_DFIFO_BU210_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(18),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3720
    );
  SEGMENT_DFIFO_BU211_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(19),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3688
    );
  SEGMENT_DFIFO_BU211_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(19),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3721
    );
  SEGMENT_DFIFO_BU212_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(20),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3689
    );
  SEGMENT_DFIFO_BU212_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(20),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3722
    );
  SEGMENT_DFIFO_BU213_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(21),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3690
    );
  SEGMENT_DFIFO_BU213_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(21),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3723
    );
  SEGMENT_DFIFO_BU214_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(22),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3691
    );
  SEGMENT_DFIFO_BU214_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(22),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3724
    );
  SEGMENT_DFIFO_BU215_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(23),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3692
    );
  SEGMENT_DFIFO_BU215_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(23),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3725
    );
  SEGMENT_DFIFO_BU216_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(24),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3693
    );
  SEGMENT_DFIFO_BU216_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(24),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3726
    );
  SEGMENT_DFIFO_BU217_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(25),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3694
    );
  SEGMENT_DFIFO_BU217_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(25),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3727
    );
  SEGMENT_DFIFO_BU218_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(26),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3695
    );
  SEGMENT_DFIFO_BU218_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(26),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3728
    );
  SEGMENT_DFIFO_BU219_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(27),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3696
    );
  SEGMENT_DFIFO_BU219_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(27),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3729
    );
  SEGMENT_DFIFO_BU220_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(28),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3697
    );
  SEGMENT_DFIFO_BU220_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(28),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3730
    );
  SEGMENT_DFIFO_BU221_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(29),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3698
    );
  SEGMENT_DFIFO_BU221_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(29),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3731
    );
  SEGMENT_DFIFO_BU222_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(30),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3699
    );
  SEGMENT_DFIFO_BU222_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(30),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3732
    );
  SEGMENT_DFIFO_BU223_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(31),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3700
    );
  SEGMENT_DFIFO_BU223_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(31),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N918,
      O => SEGMENT_DFIFO_N3733
    );
  SEGMENT_DFIFO_BU224_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(0),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4058
    );
  SEGMENT_DFIFO_BU224_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(0),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4091
    );
  SEGMENT_DFIFO_BU225_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(1),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4059
    );
  SEGMENT_DFIFO_BU225_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(1),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4092
    );
  SEGMENT_DFIFO_BU226_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(2),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4060
    );
  SEGMENT_DFIFO_BU226_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(2),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4093
    );
  SEGMENT_DFIFO_BU227_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(3),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4061
    );
  SEGMENT_DFIFO_BU227_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(3),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4094
    );
  SEGMENT_DFIFO_BU228_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(4),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4062
    );
  SEGMENT_DFIFO_BU228_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(4),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4095
    );
  SEGMENT_DFIFO_BU229_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(5),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4063
    );
  SEGMENT_DFIFO_BU229_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(5),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4096
    );
  SEGMENT_DFIFO_BU230_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(6),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4064
    );
  SEGMENT_DFIFO_BU230_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(6),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4097
    );
  SEGMENT_DFIFO_BU231_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(7),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4065
    );
  SEGMENT_DFIFO_BU231_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(7),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4098
    );
  SEGMENT_DFIFO_BU232_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(8),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4066
    );
  SEGMENT_DFIFO_BU232_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(8),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4099
    );
  SEGMENT_DFIFO_BU233_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(9),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4067
    );
  SEGMENT_DFIFO_BU233_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(9),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4100
    );
  SEGMENT_DFIFO_BU234_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(10),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4068
    );
  SEGMENT_DFIFO_BU234_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(10),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4101
    );
  SEGMENT_DFIFO_BU235_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(11),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4069
    );
  SEGMENT_DFIFO_BU235_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(11),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4102
    );
  SEGMENT_DFIFO_BU236_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(12),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4070
    );
  SEGMENT_DFIFO_BU236_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(12),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4103
    );
  SEGMENT_DFIFO_BU237_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(13),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4071
    );
  SEGMENT_DFIFO_BU237_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(13),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4104
    );
  SEGMENT_DFIFO_BU238_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(14),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4072
    );
  SEGMENT_DFIFO_BU238_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(14),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4105
    );
  SEGMENT_DFIFO_BU239_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(15),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4073
    );
  SEGMENT_DFIFO_BU239_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(15),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4106
    );
  SEGMENT_DFIFO_BU240_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(16),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4074
    );
  SEGMENT_DFIFO_BU240_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(16),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4107
    );
  SEGMENT_DFIFO_BU241_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(17),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4075
    );
  SEGMENT_DFIFO_BU241_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(17),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4108
    );
  SEGMENT_DFIFO_BU242_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(18),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4076
    );
  SEGMENT_DFIFO_BU242_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(18),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4109
    );
  SEGMENT_DFIFO_BU243_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(19),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4077
    );
  SEGMENT_DFIFO_BU243_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(19),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4110
    );
  SEGMENT_DFIFO_BU244_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(20),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4078
    );
  SEGMENT_DFIFO_BU244_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(20),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4111
    );
  SEGMENT_DFIFO_BU245_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(21),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4079
    );
  SEGMENT_DFIFO_BU245_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(21),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4112
    );
  SEGMENT_DFIFO_BU246_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(22),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4080
    );
  SEGMENT_DFIFO_BU246_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(22),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4113
    );
  SEGMENT_DFIFO_BU247_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(23),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4081
    );
  SEGMENT_DFIFO_BU247_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(23),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4114
    );
  SEGMENT_DFIFO_BU248_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(24),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4082
    );
  SEGMENT_DFIFO_BU248_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(24),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4115
    );
  SEGMENT_DFIFO_BU249_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(25),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4083
    );
  SEGMENT_DFIFO_BU249_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(25),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4116
    );
  SEGMENT_DFIFO_BU250_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(26),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4084
    );
  SEGMENT_DFIFO_BU250_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(26),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4117
    );
  SEGMENT_DFIFO_BU251_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(27),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4085
    );
  SEGMENT_DFIFO_BU251_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(27),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4118
    );
  SEGMENT_DFIFO_BU252_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(28),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4086
    );
  SEGMENT_DFIFO_BU252_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(28),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4119
    );
  SEGMENT_DFIFO_BU253_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(29),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4087
    );
  SEGMENT_DFIFO_BU253_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(29),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4120
    );
  SEGMENT_DFIFO_BU254_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(30),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4088
    );
  SEGMENT_DFIFO_BU254_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(30),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4121
    );
  SEGMENT_DFIFO_BU255_X_RAMS16 : X_RAMS16
    generic map (
      INIT => X"0000"
    )
    port map (
      ADR0 => SEGMENT_DFIFO_N214,
      ADR1 => SEGMENT_DFIFO_N213,
      ADR2 => SEGMENT_DFIFO_N212,
      ADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(31),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4089
    );
  SEGMENT_DFIFO_BU255_X_RAMD16 : X_RAMD16
    generic map (
      INIT => X"0000"
    )
    port map (
      RADR0 => SEGMENT_DFIFO_N222,
      RADR1 => SEGMENT_DFIFO_N221,
      RADR2 => SEGMENT_DFIFO_N220,
      RADR3 => SEGMENT_DFIFO_N219,
      WADR0 => SEGMENT_DFIFO_N214,
      WADR1 => SEGMENT_DFIFO_N213,
      WADR2 => SEGMENT_DFIFO_N212,
      WADR3 => SEGMENT_DFIFO_N211,
      I => SEGMENT_DATA_IN(31),
      CLK => CLK,
      WE => SEGMENT_DFIFO_N919,
      O => SEGMENT_DFIFO_N4122
    );
  VCC_566 : X_ONE
    port map (
      O => VCC
    );
  GND_567 : X_ZERO
    port map (
      O => GND
    );
  ROC_NGD2VHDL : ROC port map (O => GSR);
end STRUCTURE;

